/*!--------------------------------------------------------
 * Copyright (C) Microsoft Corporation. All rights reserved.
 *--------------------------------------------------------*/(function(){var Ce=["exports","require","vs/base/common/uri","vs/platform/instantiation/common/instantiation","vs/workbench/api/common/extHost.protocol","vs/base/common/event","vs/workbench/api/common/extHostTypes","vs/base/common/lifecycle","vs/workbench/api/common/extHostTypeConverters","vs/base/common/strings","vs/base/common/types","vs/workbench/api/common/extHostRpcService","vs/base/common/errors","vs/base/common/network","vs/platform/log/common/log","vs/base/common/async","vs/nls","vs/nls!vs/workbench/api/worker/extensionHostWorker","vs/base/common/arrays","vs/base/common/path","vs/base/common/cancellation","vs/base/common/platform","vs/base/common/resources","vs/base/common/buffer","vs/base/common/map","vs/workbench/services/extensions/common/extensions","vs/base/common/objects","vs/platform/extensions/common/extensions","vs/workbench/api/common/extHostInitDataService","vs/base/common/severity","vs/platform/registry/common/platform","vs/workbench/api/common/extHostWorkspace","vs/workbench/api/common/extHostConfiguration","vs/workbench/api/common/extHostExtensionService","vs/base/common/glob","vs/platform/files/common/files","vs/workbench/api/common/extHostFileSystemInfo","vs/workbench/api/common/extHostCommands","vs/base/common/extpath","vs/platform/contextkey/common/contextkey","vs/workbench/services/extensions/common/proxyIdentifier","vs/workbench/services/search/common/search","vs/base/common/uuid","vs/base/common/errorMessage","vs/base/common/assert","vs/platform/workspace/common/workspace","vs/workbench/api/common/extHostUriTransformerService","vs/workbench/contrib/testing/common/testId","vs/workbench/contrib/testing/common/testTypes","vs/editor/common/core/range","vs/workbench/api/common/extHostDocumentsAndEditors","vs/workbench/api/common/extHostEditorTabs","vs/workbench/api/common/extHostFileSystemConsumer","vs/workbench/api/common/extHostTerminalService","vs/workbench/api/common/extHostWebview","vs/base/common/decorators","vs/platform/instantiation/common/extensions","vs/platform/configuration/common/configuration","vs/platform/instantiation/common/serviceCollection","vs/base/common/process","vs/platform/theme/common/themeService","vs/workbench/api/common/cache","vs/workbench/api/common/extHostTunnelService","vs/workbench/common/webview","vs/workbench/contrib/notebook/common/notebookCommon","vs/workbench/contrib/testing/common/testItemCollection","vs/editor/common/languages","vs/workbench/api/common/extHostApiDeprecationService","vs/workbench/api/common/extHostLocalizationService","vs/workbench/api/common/extHostSecretState","vs/workbench/api/common/extHostStorage","vs/workbench/api/common/extHostStoragePaths","vs/base/common/performance","vs/base/common/collections","vs/base/common/idGenerator","vs/base/common/mime","vs/base/common/marshalling","vs/base/common/htmlContent","vs/base/common/labels","vs/editor/common/services/semanticTokensDto","vs/platform/instantiation/common/descriptors","vs/platform/extensionManagement/common/extensionManagement","vs/platform/markers/common/markers","vs/platform/opener/common/opener","vs/platform/jsonschemas/common/jsonContributionRegistry","vs/platform/configuration/common/configurationRegistry","vs/platform/remote/common/remoteAuthorityResolver","vs/platform/remote/common/remoteHosts","vs/workbench/api/common/extHostTelemetry","vs/workbench/common/editor","vs/workbench/api/common/extHostTestingPrivateApi","vs/workbench/services/editor/common/editorGroupsService","vs/workbench/services/extensions/common/extensionHostProtocol","vs/workbench/api/common/extHostDocumentData","vs/workbench/api/common/extHostNotebookEditor","vs/workbench/api/common/extHostTestItem","vs/workbench/api/common/extHostTextEditor","vs/workbench/api/common/extHostDecorations","vs/workbench/api/common/extHostTelemetryLogService","vs/workbench/api/common/extHostWindow","vs/workbench/api/common/extHostOutput","vs/workbench/services/search/common/searchExtTypes","vs/workbench/api/common/extHostTask","vs/workbench/api/common/extHostVariableResolverService","vs/workbench/api/common/extHostDebugService","vs/workbench/api/common/extHostSearch","vs/base/common/json","vs/base/common/marked/marked","vs/base/common/numbers","vs/base/common/stream","vs/editor/common/core/textModelDefaults","vs/editor/common/languages/languageConfiguration","vs/nls!vs/base/common/date","vs/base/common/date","vs/nls!vs/base/common/errorMessage","vs/base/common/filters","vs/base/common/iconLabels","vs/base/common/codicons","vs/base/common/comparers","vs/base/common/uriIpc","vs/editor/common/languageSelector","vs/nls!vs/editor/common/config/editorOptions","vs/editor/common/config/editorOptions","vs/editor/common/core/wordHelper","vs/nls!vs/platform/configuration/common/configurationRegistry","vs/nls!vs/platform/extensionManagement/common/extensionManagement","vs/nls!vs/platform/extensions/common/extensionValidator","vs/nls!vs/platform/files/common/files","vs/nls!vs/platform/markers/common/markers","vs/nls!vs/platform/workspace/common/workspace","vs/nls!vs/workbench/api/common/extHostDiagnostics","vs/nls!vs/workbench/api/common/extHostExtensionService","vs/nls!vs/workbench/api/common/extHostProgress","vs/nls!vs/workbench/api/common/extHostStatusBar","vs/nls!vs/workbench/api/common/extHostTerminalService","vs/nls!vs/workbench/api/common/extHostTreeViews","vs/nls!vs/workbench/api/common/extHostWorkspace","vs/nls!vs/workbench/common/editor","vs/nls!vs/workbench/contrib/debug/common/abstractDebugAdapter","vs/nls!vs/workbench/contrib/debug/common/debug","vs/nls!vs/workbench/contrib/tasks/common/taskDefinitionRegistry","vs/nls!vs/workbench/contrib/tasks/common/tasks","vs/nls!vs/workbench/services/configurationResolver/common/variableResolver","vs/nls!vs/workbench/services/extensions/common/extensionsRegistry","vs/nls!vs/workbench/services/search/common/queryBuilder","vs/platform/extensions/common/extensionValidator","vs/platform/instantiation/common/graph","vs/platform/environment/common/environment","vs/platform/instantiation/common/instantiationService","vs/platform/notification/common/notification","vs/platform/product/common/productService","vs/platform/progress/common/progress","vs/platform/configuration/common/configurationModels","vs/platform/extensionManagement/common/extensionManagementUtil","vs/platform/terminal/common/terminalDataBuffering","vs/platform/theme/common/theme","vs/platform/tunnel/common/tunnel","vs/platform/workspace/common/virtualWorkspace","vs/workbench/api/common/extHostMemento","vs/workbench/api/common/extHostNotebookDocuments","vs/workbench/api/common/extHostSecrets","vs/workbench/api/common/extHostWebviewMessaging","vs/workbench/api/common/extHostCodeInsets","vs/workbench/contrib/debug/common/abstractDebugAdapter","vs/workbench/contrib/debug/common/debug","vs/workbench/contrib/debug/common/debugUtils","vs/base/common/iterator","vs/workbench/contrib/notebook/common/notebookExecutionService","vs/workbench/contrib/terminal/common/environmentVariableShared","vs/workbench/services/configurationResolver/common/configurationResolver","vs/workbench/services/configurationResolver/common/variableResolver","vs/workbench/services/editor/common/editorService","vs/workbench/services/environment/common/environmentService","vs/workbench/services/extensions/common/extensionDescriptionRegistry","vs/workbench/api/common/extHostExtensionActivator","vs/workbench/api/common/extHostLogService","vs/workbench/api/common/extHostTheming","vs/base/common/functional","vs/workbench/api/common/extHostDocumentSaveParticipant","vs/workbench/api/common/extHostNotebookDocument","vs/workbench/api/common/extHostNotebookEditors","vs/workbench/api/common/extHostProgress","vs/workbench/services/extensions/common/extensionsApiProposals","vs/workbench/services/extensions/common/extensionsRegistry","vs/workbench/contrib/tasks/common/taskDefinitionRegistry","vs/workbench/contrib/tasks/common/tasks","vs/workbench/services/extensions/common/lazyPromise","vs/workbench/api/common/extHostAuthentication","vs/workbench/api/common/extHostBulkEdits","vs/workbench/api/common/extHostClipboard","vs/workbench/api/common/extHostApiCommands","vs/workbench/api/common/extHostComments","vs/workbench/api/common/extHostConsoleForwarder","vs/workbench/api/common/extHostDiagnostics","vs/workbench/api/common/extHostDialogs","vs/workbench/api/common/extHostDocumentContentProviders","vs/workbench/api/common/extHostDocuments","vs/base/common/lazy","vs/workbench/api/common/extHostFileSystem","vs/workbench/api/common/extHostFileSystemEventService","vs/workbench/api/common/extHostInteractive","vs/workbench/api/common/extHostLabelService","vs/workbench/api/common/extHostLanguageFeatures","vs/base/common/stopwatch","vs/workbench/api/common/extHostLanguages","vs/workbench/api/common/extHostLoggerService","vs/workbench/api/common/extHostMessageService","vs/workbench/api/common/extHostNotebook","vs/workbench/api/common/extHostNotebookKernels","vs/workbench/api/common/extHostNotebookRenderers","vs/workbench/api/common/extHostQuickOpen","vs/workbench/api/common/extHostSCM","vs/workbench/api/common/extHostStatusBar","vs/workbench/api/common/extHostTesting","vs/base/common/hash","vs/workbench/api/common/extHostTextEditors","vs/workbench/api/common/extHostTimeline","vs/workbench/api/common/extHostUriOpener","vs/workbench/api/common/extHostUrls","vs/workbench/api/common/extHostCustomEditors","vs/workbench/api/common/extHostWebviewPanels","vs/workbench/api/common/extHostWebviewView","vs/workbench/api/worker/extHostConsoleForwarder","vs/workbench/services/extensions/common/rpcProtocol","vs/workbench/services/extensions/worker/polyfillNestedWorker","vs/workbench/services/output/common/output","vs/workbench/services/remote/common/remoteAgentService","vs/workbench/services/path/common/pathService","vs/workbench/services/search/common/fileSearchManager","vs/workbench/services/search/common/queryBuilder","vs/workbench/services/extensions/common/workspaceContains","vs/workbench/api/common/extHostRequireInterceptor","vs/workbench/api/common/extensionHostMain","vs/workbench/services/search/common/textSearchManager","vs/workbench/api/common/extHost.common.services","vs/workbench/services/views/common/treeViewsService","vs/workbench/api/common/extHostTreeViews","vs/workbench/api/common/extHost.api.impl","vs/workbench/api/worker/extHostExtensionService","vs/workbench/api/worker/extHost.worker.services","vs/base/common/semver/semver","vs/editor/common/model/mirrorTextModel","vs/base/common/linkedList","vs/editor/common/core/position","vs/editor/common/languages/linkComputer","vs/editor/common/core/selection","vs/editor/common/model/textModelSearch","vs/editor/common/model","vs/workbench/api/worker/extensionHostWorker"],Ie=function(ie){for(var e=[],r=0,y=ie.length;r<y;r++)e[r]=Ce[ie[r]];return e};define(Ce[73],Ie([1,0]),function(ie,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.SetMap=e.diffMaps=e.diffSets=e.groupBy=void 0;function r(_,A){const b=Object.create(null);for(const P of _){const O=A(P);let E=b[O];E||(E=b[O]=[]),E.push(P)}return b}e.groupBy=r;function y(_,A){const b=[],P=[];for(const O of _)A.has(O)||b.push(O);for(const O of A)_.has(O)||P.push(O);return{removed:b,added:P}}e.diffSets=y;function S(_,A){const b=[],P=[];for(const[O,E]of _)A.has(O)||b.push(E);for(const[O,E]of A)_.has(O)||P.push(E);return{removed:b,added:P}}e.diffMaps=S;class M{constructor(){this.map=new Map}add(A,b){let P=this.map.get(A);P||(P=new Set,this.map.set(A,P)),P.add(b)}delete(A,b){const P=this.map.get(A);!P||(P.delete(b),P.size===0&&this.map.delete(A))}forEach(A,b){const P=this.map.get(A);!P||P.forEach(b)}}e.SetMap=M}),define(Ce[55],Ie([1,0]),function(ie,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.throttle=e.debounce=e.memoize=e.createDecorator=void 0;function r(_){return(A,b,P)=>{let O=null,E=null;if(typeof P.value=="function"?(O="value",E=P.value):typeof P.get=="function"&&(O="get",E=P.get),!E)throw new Error("not supported");P[O]=_(E,b)}}e.createDecorator=r;function y(_,A,b){let P=null,O=null;if(typeof b.value=="function"?(P="value",O=b.value,O.length!==0&&console.warn("Memoize should only be used in functions with zero parameters")):typeof b.get=="function"&&(P="get",O=b.get),!O)throw new Error("not supported");const E=`$memoize$${A}`;b[P]=function(...m){return this.hasOwnProperty(E)||Object.defineProperty(this,E,{configurable:!1,enumerable:!1,writable:!1,value:O.apply(this,m)}),this[E]}}e.memoize=y;function S(_,A,b){return r((P,O)=>{const E=`$debounce$${O}`,m=`$debounce$result$${O}`;return function(...k){this[m]||(this[m]=b?b():void 0),clearTimeout(this[E]),A&&(this[m]=A(this[m],...k),k=[this[m]]),this[E]=setTimeout(()=>{P.apply(this,k),this[m]=b?b():void 0},_)}})}e.debounce=S;function M(_,A,b){return r((P,O)=>{const E=`$throttle$timer$${O}`,m=`$throttle$result$${O}`,k=`$throttle$lastRun$${O}`,f=`$throttle$pending$${O}`;return function(...c){if(this[m]||(this[m]=b?b():void 0),(this[k]===null||this[k]===void 0)&&(this[k]=-Number.MAX_VALUE),A&&(this[m]=A(this[m],...c)),this[f])return;const d=this[k]+_;d<=Date.now()?(this[k]=Date.now(),P.apply(this,[this[m]]),this[m]=b?b():void 0):(this[f]=!0,this[E]=setTimeout(()=>{this[f]=!1,this[k]=Date.now(),P.apply(this,[this[m]]),this[m]=b?b():void 0},d-Date.now()))}})}e.throttle=M}),define(Ce[74],Ie([1,0]),function(ie,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.defaultGenerator=e.IdGenerator=void 0;class r{constructor(S){this._prefix=S,this._lastId=0}nextId(){return this._prefix+ ++this._lastId}}e.IdGenerator=r,e.defaultGenerator=new r("id#")}),define(Ce[106],Ie([1,0]),function(ie,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.getNodeType=e.stripComments=e.visit=e.findNodeAtOffset=e.contains=e.getNodeValue=e.getNodePath=e.findNodeAtLocation=e.parseTree=e.parse=e.getLocation=e.createScanner=e.ParseOptions=e.ParseErrorCode=e.SyntaxKind=e.ScanError=void 0;var r;(function(t){t[t.None=0]="None",t[t.UnexpectedEndOfComment=1]="UnexpectedEndOfComment",t[t.UnexpectedEndOfString=2]="UnexpectedEndOfString",t[t.UnexpectedEndOfNumber=3]="UnexpectedEndOfNumber",t[t.InvalidUnicode=4]="InvalidUnicode",t[t.InvalidEscapeCharacter=5]="InvalidEscapeCharacter",t[t.InvalidCharacter=6]="InvalidCharacter"})(r=e.ScanError||(e.ScanError={}));var y;(function(t){t[t.OpenBraceToken=1]="OpenBraceToken",t[t.CloseBraceToken=2]="CloseBraceToken",t[t.OpenBracketToken=3]="OpenBracketToken",t[t.CloseBracketToken=4]="CloseBracketToken",t[t.CommaToken=5]="CommaToken",t[t.ColonToken=6]="ColonToken",t[t.NullKeyword=7]="NullKeyword",t[t.TrueKeyword=8]="TrueKeyword",t[t.FalseKeyword=9]="FalseKeyword",t[t.StringLiteral=10]="StringLiteral",t[t.NumericLiteral=11]="NumericLiteral",t[t.LineCommentTrivia=12]="LineCommentTrivia",t[t.BlockCommentTrivia=13]="BlockCommentTrivia",t[t.LineBreakTrivia=14]="LineBreakTrivia",t[t.Trivia=15]="Trivia",t[t.Unknown=16]="Unknown",t[t.EOF=17]="EOF"})(y=e.SyntaxKind||(e.SyntaxKind={}));var S;(function(t){t[t.InvalidSymbol=1]="InvalidSymbol",t[t.InvalidNumberFormat=2]="InvalidNumberFormat",t[t.PropertyNameExpected=3]="PropertyNameExpected",t[t.ValueExpected=4]="ValueExpected",t[t.ColonExpected=5]="ColonExpected",t[t.CommaExpected=6]="CommaExpected",t[t.CloseBraceExpected=7]="CloseBraceExpected",t[t.CloseBracketExpected=8]="CloseBracketExpected",t[t.EndOfFileExpected=9]="EndOfFileExpected",t[t.InvalidCommentToken=10]="InvalidCommentToken",t[t.UnexpectedEndOfComment=11]="UnexpectedEndOfComment",t[t.UnexpectedEndOfString=12]="UnexpectedEndOfString",t[t.UnexpectedEndOfNumber=13]="UnexpectedEndOfNumber",t[t.InvalidUnicode=14]="InvalidUnicode",t[t.InvalidEscapeCharacter=15]="InvalidEscapeCharacter",t[t.InvalidCharacter=16]="InvalidCharacter"})(S=e.ParseErrorCode||(e.ParseErrorCode={}));var M;(function(t){t.DEFAULT={allowTrailingComma:!0}})(M=e.ParseOptions||(e.ParseOptions={}));function _(t,u=!1){let i=0;const n=t.length;let s="",a=0,o=16,v=0;function p(L){let R=0,K=0;for(;R<L;){const W=t.charCodeAt(i);if(W>=48&&W<=57)K=K*16+W-48;else if(W>=65&&W<=70)K=K*16+W-65+10;else if(W>=97&&W<=102)K=K*16+W-97+10;else break;i++,R++}return R<L&&(K=-1),K}function T(L){i=L,s="",a=0,o=16,v=0}function N(){const L=i;if(t.charCodeAt(i)===48)i++;else for(i++;i<t.length&&P(t.charCodeAt(i));)i++;if(i<t.length&&t.charCodeAt(i)===46)if(i++,i<t.length&&P(t.charCodeAt(i)))for(i++;i<t.length&&P(t.charCodeAt(i));)i++;else return v=3,t.substring(L,i);let R=i;if(i<t.length&&(t.charCodeAt(i)===69||t.charCodeAt(i)===101))if(i++,(i<t.length&&t.charCodeAt(i)===43||t.charCodeAt(i)===45)&&i++,i<t.length&&P(t.charCodeAt(i))){for(i++;i<t.length&&P(t.charCodeAt(i));)i++;R=i}else v=3;return t.substring(L,R)}function V(){let L="",R=i;for(;;){if(i>=n){L+=t.substring(R,i),v=2;break}const K=t.charCodeAt(i);if(K===34){L+=t.substring(R,i),i++;break}if(K===92){if(L+=t.substring(R,i),i++,i>=n){v=2;break}switch(t.charCodeAt(i++)){case 34:L+='"';break;case 92:L+="\\";break;case 47:L+="/";break;case 98:L+="\b";break;case 102:L+="\f";break;case 110:L+=`
`;break;case 114:L+="\r";break;case 116:L+="	";break;case 117:{const $=p(4);$>=0?L+=String.fromCharCode($):v=4;break}default:v=5}R=i;continue}if(K>=0&&K<=31)if(b(K)){L+=t.substring(R,i),v=2;break}else v=6;i++}return L}function B(){if(s="",v=0,a=i,i>=n)return a=n,o=17;let L=t.charCodeAt(i);if(A(L)){do i++,s+=String.fromCharCode(L),L=t.charCodeAt(i);while(A(L));return o=15}if(b(L))return i++,s+=String.fromCharCode(L),L===13&&t.charCodeAt(i)===10&&(i++,s+=`
`),o=14;switch(L){case 123:return i++,o=1;case 125:return i++,o=2;case 91:return i++,o=3;case 93:return i++,o=4;case 58:return i++,o=6;case 44:return i++,o=5;case 34:return i++,s=V(),o=10;case 47:{const R=i-1;if(t.charCodeAt(i+1)===47){for(i+=2;i<n&&!b(t.charCodeAt(i));)i++;return s=t.substring(R,i),o=12}if(t.charCodeAt(i+1)===42){i+=2;const K=n-1;let W=!1;for(;i<K;){if(t.charCodeAt(i)===42&&t.charCodeAt(i+1)===47){i+=2,W=!0;break}i++}return W||(i++,v=1),s=t.substring(R,i),o=13}return s+=String.fromCharCode(L),i++,o=16}case 45:if(s+=String.fromCharCode(L),i++,i===n||!P(t.charCodeAt(i)))return o=16;case 48:case 49:case 50:case 51:case 52:case 53:case 54:case 55:case 56:case 57:return s+=N(),o=11;default:for(;i<n&&D(L);)i++,L=t.charCodeAt(i);if(a!==i){switch(s=t.substring(a,i),s){case"true":return o=8;case"false":return o=9;case"null":return o=7}return o=16}return s+=String.fromCharCode(L),i++,o=16}}function D(L){if(A(L)||b(L))return!1;switch(L){case 125:case 93:case 123:case 91:case 34:case 58:case 44:case 47:return!1}return!0}function z(){let L;do L=B();while(L>=12&&L<=15);return L}return{setPosition:T,getPosition:()=>i,scan:u?z:B,getToken:()=>o,getTokenValue:()=>s,getTokenOffset:()=>a,getTokenLength:()=>i-a,getTokenError:()=>v}}e.createScanner=_;function A(t){return t===32||t===9||t===11||t===12||t===160||t===5760||t>=8192&&t<=8203||t===8239||t===8287||t===12288||t===65279}function b(t){return t===10||t===13||t===8232||t===8233}function P(t){return t>=48&&t<=57}var O;(function(t){t[t.nullCharacter=0]="nullCharacter",t[t.maxAsciiCharacter=127]="maxAsciiCharacter",t[t.lineFeed=10]="lineFeed",t[t.carriageReturn=13]="carriageReturn",t[t.lineSeparator=8232]="lineSeparator",t[t.paragraphSeparator=8233]="paragraphSeparator",t[t.nextLine=133]="nextLine",t[t.space=32]="space",t[t.nonBreakingSpace=160]="nonBreakingSpace",t[t.enQuad=8192]="enQuad",t[t.emQuad=8193]="emQuad",t[t.enSpace=8194]="enSpace",t[t.emSpace=8195]="emSpace",t[t.threePerEmSpace=8196]="threePerEmSpace",t[t.fourPerEmSpace=8197]="fourPerEmSpace",t[t.sixPerEmSpace=8198]="sixPerEmSpace",t[t.figureSpace=8199]="figureSpace",t[t.punctuationSpace=8200]="punctuationSpace",t[t.thinSpace=8201]="thinSpace",t[t.hairSpace=8202]="hairSpace",t[t.zeroWidthSpace=8203]="zeroWidthSpace",t[t.narrowNoBreakSpace=8239]="narrowNoBreakSpace",t[t.ideographicSpace=12288]="ideographicSpace",t[t.mathematicalSpace=8287]="mathematicalSpace",t[t.ogham=5760]="ogham",t[t._=95]="_",t[t.$=36]="$",t[t._0=48]="_0",t[t._1=49]="_1",t[t._2=50]="_2",t[t._3=51]="_3",t[t._4=52]="_4",t[t._5=53]="_5",t[t._6=54]="_6",t[t._7=55]="_7",t[t._8=56]="_8",t[t._9=57]="_9",t[t.a=97]="a",t[t.b=98]="b",t[t.c=99]="c",t[t.d=100]="d",t[t.e=101]="e",t[t.f=102]="f",t[t.g=103]="g",t[t.h=104]="h",t[t.i=105]="i",t[t.j=106]="j",t[t.k=107]="k",t[t.l=108]="l",t[t.m=109]="m",t[t.n=110]="n",t[t.o=111]="o",t[t.p=112]="p",t[t.q=113]="q",t[t.r=114]="r",t[t.s=115]="s",t[t.t=116]="t",t[t.u=117]="u",t[t.v=118]="v",t[t.w=119]="w",t[t.x=120]="x",t[t.y=121]="y",t[t.z=122]="z",t[t.A=65]="A",t[t.B=66]="B",t[t.C=67]="C",t[t.D=68]="D",t[t.E=69]="E",t[t.F=70]="F",t[t.G=71]="G",t[t.H=72]="H",t[t.I=73]="I",t[t.J=74]="J",t[t.K=75]="K",t[t.L=76]="L",t[t.M=77]="M",t[t.N=78]="N",t[t.O=79]="O",t[t.P=80]="P",t[t.Q=81]="Q",t[t.R=82]="R",t[t.S=83]="S",t[t.T=84]="T",t[t.U=85]="U",t[t.V=86]="V",t[t.W=87]="W",t[t.X=88]="X",t[t.Y=89]="Y",t[t.Z=90]="Z",t[t.ampersand=38]="ampersand",t[t.asterisk=42]="asterisk",t[t.at=64]="at",t[t.backslash=92]="backslash",t[t.bar=124]="bar",t[t.caret=94]="caret",t[t.closeBrace=125]="closeBrace",t[t.closeBracket=93]="closeBracket",t[t.closeParen=41]="closeParen",t[t.colon=58]="colon",t[t.comma=44]="comma",t[t.dot=46]="dot",t[t.doubleQuote=34]="doubleQuote",t[t.equals=61]="equals",t[t.exclamation=33]="exclamation",t[t.greaterThan=62]="greaterThan",t[t.lessThan=60]="lessThan",t[t.minus=45]="minus",t[t.openBrace=123]="openBrace",t[t.openBracket=91]="openBracket",t[t.openParen=40]="openParen",t[t.percent=37]="percent",t[t.plus=43]="plus",t[t.question=63]="question",t[t.semicolon=59]="semicolon",t[t.singleQuote=39]="singleQuote",t[t.slash=47]="slash",t[t.tilde=126]="tilde",t[t.backspace=8]="backspace",t[t.formFeed=12]="formFeed",t[t.byteOrderMark=65279]="byteOrderMark",t[t.tab=9]="tab",t[t.verticalTab=11]="verticalTab"})(O||(O={}));function E(t,u){const i=[],n=new Object;let s;const a={value:{},offset:0,length:0,type:"object",parent:void 0};let o=!1;function v(p,T,N,V){a.value=p,a.offset=T,a.length=N,a.type=V,a.colonOffset=void 0,s=a}try{C(t,{onObjectBegin:(p,T)=>{if(u<=p)throw n;s=void 0,o=u>p,i.push("")},onObjectProperty:(p,T,N)=>{if(u<T||(v(p,T,N,"property"),i[i.length-1]=p,u<=T+N))throw n},onObjectEnd:(p,T)=>{if(u<=p)throw n;s=void 0,i.pop()},onArrayBegin:(p,T)=>{if(u<=p)throw n;s=void 0,i.push(0)},onArrayEnd:(p,T)=>{if(u<=p)throw n;s=void 0,i.pop()},onLiteralValue:(p,T,N)=>{if(u<T||(v(p,T,N,w(p)),u<=T+N))throw n},onSeparator:(p,T,N)=>{if(u<=T)throw n;if(p===":"&&s&&s.type==="property")s.colonOffset=T,o=!1,s=void 0;else if(p===","){const V=i[i.length-1];typeof V=="number"?i[i.length-1]=V+1:(o=!0,i[i.length-1]=""),s=void 0}}})}catch(p){if(p!==n)throw p}return{path:i,previousNode:s,isAtPropertyKey:o,matches:p=>{let T=0;for(let N=0;T<p.length&&N<i.length;N++)if(p[T]===i[N]||p[T]==="*")T++;else if(p[T]!=="**")return!1;return T===p.length}}}e.getLocation=E;function m(t,u=[],i=M.DEFAULT){let n=null,s=[];const a=[];function o(p){Array.isArray(s)?s.push(p):n!==null&&(s[n]=p)}return C(t,{onObjectBegin:()=>{const p={};o(p),a.push(s),s=p,n=null},onObjectProperty:p=>{n=p},onObjectEnd:()=>{s=a.pop()},onArrayBegin:()=>{const p=[];o(p),a.push(s),s=p,n=null},onArrayEnd:()=>{s=a.pop()},onLiteralValue:o,onError:(p,T,N)=>{u.push({error:p,offset:T,length:N})}},i),s[0]}e.parse=m;function k(t,u=[],i=M.DEFAULT){let n={type:"array",offset:-1,length:-1,children:[],parent:void 0};function s(p){n.type==="property"&&(n.length=p-n.offset,n=n.parent)}function a(p){return n.children.push(p),p}C(t,{onObjectBegin:p=>{n=a({type:"object",offset:p,length:-1,parent:n,children:[]})},onObjectProperty:(p,T,N)=>{n=a({type:"property",offset:T,length:-1,parent:n,children:[]}),n.children.push({type:"string",value:p,offset:T,length:N,parent:n})},onObjectEnd:(p,T)=>{n.length=p+T-n.offset,n=n.parent,s(p+T)},onArrayBegin:(p,T)=>{n=a({type:"array",offset:p,length:-1,parent:n,children:[]})},onArrayEnd:(p,T)=>{n.length=p+T-n.offset,n=n.parent,s(p+T)},onLiteralValue:(p,T,N)=>{a({type:w(p),offset:T,length:N,parent:n,value:p}),s(T+N)},onSeparator:(p,T,N)=>{n.type==="property"&&(p===":"?n.colonOffset=T:p===","&&s(T))},onError:(p,T,N)=>{u.push({error:p,offset:T,length:N})}},i);const v=n.children[0];return v&&delete v.parent,v}e.parseTree=k;function f(t,u){if(!t)return;let i=t;for(const n of u)if(typeof n=="string"){if(i.type!=="object"||!Array.isArray(i.children))return;let s=!1;for(const a of i.children)if(Array.isArray(a.children)&&a.children[0].value===n){i=a.children[1],s=!0;break}if(!s)return}else{const s=n;if(i.type!=="array"||s<0||!Array.isArray(i.children)||s>=i.children.length)return;i=i.children[s]}return i}e.findNodeAtLocation=f;function c(t){if(!t.parent||!t.parent.children)return[];const u=c(t.parent);if(t.parent.type==="property"){const i=t.parent.children[0].value;u.push(i)}else if(t.parent.type==="array"){const i=t.parent.children.indexOf(t);i!==-1&&u.push(i)}return u}e.getNodePath=c;function d(t){switch(t.type){case"array":return t.children.map(d);case"object":{const u=Object.create(null);for(const i of t.children){const n=i.children[1];n&&(u[i.children[0].value]=d(n))}return u}case"null":case"string":case"number":case"boolean":return t.value;default:return}}e.getNodeValue=d;function h(t,u,i=!1){return u>=t.offset&&u<t.offset+t.length||i&&u===t.offset+t.length}e.contains=h;function g(t,u,i=!1){if(h(t,u,i)){const n=t.children;if(Array.isArray(n))for(let s=0;s<n.length&&n[s].offset<=u;s++){const a=g(n[s],u,i);if(a)return a}return t}}e.findNodeAtOffset=g;function C(t,u,i=M.DEFAULT){const n=_(t,!1);function s(ce){return ce?()=>ce(n.getTokenOffset(),n.getTokenLength()):()=>!0}function a(ce){return ce?me=>ce(me,n.getTokenOffset(),n.getTokenLength()):()=>!0}const o=s(u.onObjectBegin),v=a(u.onObjectProperty),p=s(u.onObjectEnd),T=s(u.onArrayBegin),N=s(u.onArrayEnd),V=a(u.onLiteralValue),B=a(u.onSeparator),D=s(u.onComment),z=a(u.onError),L=i&&i.disallowComments,R=i&&i.allowTrailingComma;function K(){for(;;){const ce=n.scan();switch(n.getTokenError()){case 4:W(14);break;case 5:W(15);break;case 3:W(13);break;case 1:L||W(11);break;case 2:W(12);break;case 6:W(16);break}switch(ce){case 12:case 13:L?W(10):D();break;case 16:W(1);break;case 15:case 14:break;default:return ce}}}function W(ce,me=[],ee=[]){if(z(ce),me.length+ee.length>0){let be=n.getToken();for(;be!==17;){if(me.indexOf(be)!==-1){K();break}else if(ee.indexOf(be)!==-1)break;be=K()}}}function $(ce){const me=n.getTokenValue();return ce?V(me):v(me),K(),!0}function G(){switch(n.getToken()){case 11:{let ce=0;try{ce=JSON.parse(n.getTokenValue()),typeof ce!="number"&&(W(2),ce=0)}catch{W(2)}V(ce);break}case 7:V(null);break;case 8:V(!0);break;case 9:V(!1);break;default:return!1}return K(),!0}function ne(){return n.getToken()!==10?(W(3,[],[2,5]),!1):($(!1),n.getToken()===6?(B(":"),K(),Ee()||W(4,[],[2,5])):W(5,[],[2,5]),!0)}function ge(){o(),K();let ce=!1;for(;n.getToken()!==2&&n.getToken()!==17;){if(n.getToken()===5){if(ce||W(4,[],[]),B(","),K(),n.getToken()===2&&R)break}else ce&&W(6,[],[]);ne()||W(4,[],[2,5]),ce=!0}return p(),n.getToken()!==2?W(7,[2],[]):K(),!0}function oe(){T(),K();let ce=!1;for(;n.getToken()!==4&&n.getToken()!==17;){if(n.getToken()===5){if(ce||W(4,[],[]),B(","),K(),n.getToken()===4&&R)break}else ce&&W(6,[],[]);Ee()||W(4,[],[4,5]),ce=!0}return N(),n.getToken()!==4?W(8,[4],[]):K(),!0}function Ee(){switch(n.getToken()){case 3:return oe();case 1:return ge();case 10:return $(!0);default:return G()}}return K(),n.getToken()===17?i.allowEmptyContent?!0:(W(4,[],[]),!1):Ee()?(n.getToken()!==17&&W(9,[],[]),!0):(W(4,[],[]),!1)}e.visit=C;function l(t,u){const i=_(t),n=[];let s,a=0,o;do switch(o=i.getPosition(),s=i.scan(),s){case 12:case 13:case 17:a!==o&&n.push(t.substring(a,o)),u!==void 0&&n.push(i.getTokenValue().replace(/[^\r\n]/g,u)),a=i.getPosition();break}while(s!==17);return n.join("")}e.stripComments=l;function w(t){switch(typeof t){case"boolean":return"boolean";case"number":return"number";case"string":return"string";case"object":{if(t){if(Array.isArray(t))return"array"}else return"null";return"object"}default:return"null"}}e.getNodeType=w}),function(ie,e){typeof exports=="object"&&typeof module<"u"?e(exports):typeof define=="function"&&define.amd?define(Ce[107],Ie([0]),e):(ie=typeof globalThis<"u"?globalThis:ie||self,e(ie.marked={}))}(this,function(ie){"use strict";function e(ke,ye){for(var De=0;De<ye.length;De++){var ae=ye[De];ae.enumerable=ae.enumerable||!1,ae.configurable=!0,"value"in ae&&(ae.writable=!0),Object.defineProperty(ke,ae.key,ae)}}function r(ke,ye,De){return ye&&e(ke.prototype,ye),De&&e(ke,De),Object.defineProperty(ke,"prototype",{writable:!1}),ke}function y(ke,ye){if(!!ke){if(typeof ke=="string")return S(ke,ye);var De=Object.prototype.toString.call(ke).slice(8,-1);if(De==="Object"&&ke.constructor&&(De=ke.constructor.name),De==="Map"||De==="Set")return Array.from(ke);if(De==="Arguments"||/^(?:Ui|I)nt(?:8|16|32)(?:Clamped)?Array$/.test(De))return S(ke,ye)}}function S(ke,ye){(ye==null||ye>ke.length)&&(ye=ke.length);for(var De=0,ae=new Array(ye);De<ye;De++)ae[De]=ke[De];return ae}function M(ke,ye){var De=typeof Symbol<"u"&&ke[Symbol.iterator]||ke["@@iterator"];if(De)return(De=De.call(ke)).next.bind(De);if(Array.isArray(ke)||(De=y(ke))||ye&&ke&&typeof ke.length=="number"){De&&(ke=De);var ae=0;return function(){return ae>=ke.length?{done:!0}:{done:!1,value:ke[ae++]}}}throw new TypeError(`Invalid attempt to iterate non-iterable instance.
In order to be iterable, non-array objects must have a [Symbol.iterator]() method.`)}function _(){return{async:!1,baseUrl:null,breaks:!1,extensions:null,gfm:!0,headerIds:!0,headerPrefix:"",highlight:null,langPrefix:"language-",mangle:!0,pedantic:!1,renderer:null,sanitize:!1,sanitizer:null,silent:!1,smartLists:!1,smartypants:!1,tokenizer:null,walkTokens:null,xhtml:!1}}ie.defaults=_();function A(ke){ie.defaults=ke}var b=/[&<>"']/,P=/[&<>"']/g,O=/[<>"']|&(?!#?\w+;)/,E=/[<>"']|&(?!#?\w+;)/g,m={"&":"&amp;","<":"&lt;",">":"&gt;",'"':"&quot;","'":"&#39;"},k=function(ye){return m[ye]};function f(ke,ye){if(ye){if(b.test(ke))return ke.replace(P,k)}else if(O.test(ke))return ke.replace(E,k);return ke}var c=/&(#(?:\d+)|(?:#x[0-9A-Fa-f]+)|(?:\w+));?/ig;function d(ke){return ke.replace(c,function(ye,De){return De=De.toLowerCase(),De==="colon"?":":De.charAt(0)==="#"?De.charAt(1)==="x"?String.fromCharCode(parseInt(De.substring(2),16)):String.fromCharCode(+De.substring(1)):""})}var h=/(^|[^\[])\^/g;function g(ke,ye){ke=typeof ke=="string"?ke:ke.source,ye=ye||"";var De={replace:function(ue,Z){return Z=Z.source||Z,Z=Z.replace(h,"$1"),ke=ke.replace(ue,Z),De},getRegex:function(){return new RegExp(ke,ye)}};return De}var C=/[^\w:]/g,l=/^$|^[a-z][a-z0-9+.-]*:|^[?#]/i;function w(ke,ye,De){if(ke){var ae;try{ae=decodeURIComponent(d(De)).replace(C,"").toLowerCase()}catch{return null}if(ae.indexOf("javascript:")===0||ae.indexOf("vbscript:")===0||ae.indexOf("data:")===0)return null}ye&&!l.test(De)&&(De=s(ye,De));try{De=encodeURI(De).replace(/%25/g,"%")}catch{return null}return De}var t={},u=/^[^:]+:\/*[^/]*$/,i=/^([^:]+:)[\s\S]*$/,n=/^([^:]+:\/*[^/]*)[\s\S]*$/;function s(ke,ye){t[" "+ke]||(u.test(ke)?t[" "+ke]=ke+"/":t[" "+ke]=p(ke,"/",!0)),ke=t[" "+ke];var De=ke.indexOf(":")===-1;return ye.substring(0,2)==="//"?De?ye:ke.replace(i,"$1")+ye:ye.charAt(0)==="/"?De?ye:ke.replace(n,"$1")+ye:ke+ye}var a={exec:function(){}};function o(ke){for(var ye=1,De,ae;ye<arguments.length;ye++){De=arguments[ye];for(ae in De)Object.prototype.hasOwnProperty.call(De,ae)&&(ke[ae]=De[ae])}return ke}function v(ke,ye){var De=ke.replace(/\|/g,function(Z,J,I){for(var U=!1,H=J;--H>=0&&I[H]==="\\";)U=!U;return U?"|":" |"}),ae=De.split(/ \|/),ue=0;if(ae[0].trim()||ae.shift(),ae.length>0&&!ae[ae.length-1].trim()&&ae.pop(),ae.length>ye)ae.splice(ye);else for(;ae.length<ye;)ae.push("");for(;ue<ae.length;ue++)ae[ue]=ae[ue].trim().replace(/\\\|/g,"|");return ae}function p(ke,ye,De){var ae=ke.length;if(ae===0)return"";for(var ue=0;ue<ae;){var Z=ke.charAt(ae-ue-1);if(Z===ye&&!De)ue++;else if(Z!==ye&&De)ue++;else break}return ke.slice(0,ae-ue)}function T(ke,ye){if(ke.indexOf(ye[1])===-1)return-1;for(var De=ke.length,ae=0,ue=0;ue<De;ue++)if(ke[ue]==="\\")ue++;else if(ke[ue]===ye[0])ae++;else if(ke[ue]===ye[1]&&(ae--,ae<0))return ue;return-1}function N(ke){ke&&ke.sanitize&&!ke.silent&&console.warn("marked(): sanitize and sanitizer parameters are deprecated since version 0.7.0, should not be used and will be removed in the future. Read more here: https://marked.js.org/#/USING_ADVANCED.md#options")}function V(ke,ye){if(ye<1)return"";for(var De="";ye>1;)ye&1&&(De+=ke),ye>>=1,ke+=ke;return De+ke}function B(ke,ye,De,ae){var ue=ye.href,Z=ye.title?f(ye.title):null,J=ke[1].replace(/\\([\[\]])/g,"$1");if(ke[0].charAt(0)!=="!"){ae.state.inLink=!0;var I={type:"link",raw:De,href:ue,title:Z,text:J,tokens:ae.inlineTokens(J)};return ae.state.inLink=!1,I}return{type:"image",raw:De,href:ue,title:Z,text:f(J)}}function D(ke,ye){var De=ke.match(/^(\s+)(?:```)/);if(De===null)return ye;var ae=De[1];return ye.split(`
`).map(function(ue){var Z=ue.match(/^\s+/);if(Z===null)return ue;var J=Z[0];return J.length>=ae.length?ue.slice(ae.length):ue}).join(`
`)}var z=function(){function ke(De){this.options=De||ie.defaults}var ye=ke.prototype;return ye.space=function(ae){var ue=this.rules.block.newline.exec(ae);if(ue&&ue[0].length>0)return{type:"space",raw:ue[0]}},ye.code=function(ae){var ue=this.rules.block.code.exec(ae);if(ue){var Z=ue[0].replace(/^ {1,4}/gm,"");return{type:"code",raw:ue[0],codeBlockStyle:"indented",text:this.options.pedantic?Z:p(Z,`
`)}}},ye.fences=function(ae){var ue=this.rules.block.fences.exec(ae);if(ue){var Z=ue[0],J=D(Z,ue[3]||"");return{type:"code",raw:Z,lang:ue[2]?ue[2].trim():ue[2],text:J}}},ye.heading=function(ae){var ue=this.rules.block.heading.exec(ae);if(ue){var Z=ue[2].trim();if(/#$/.test(Z)){var J=p(Z,"#");(this.options.pedantic||!J||/ $/.test(J))&&(Z=J.trim())}return{type:"heading",raw:ue[0],depth:ue[1].length,text:Z,tokens:this.lexer.inline(Z)}}},ye.hr=function(ae){var ue=this.rules.block.hr.exec(ae);if(ue)return{type:"hr",raw:ue[0]}},ye.blockquote=function(ae){var ue=this.rules.block.blockquote.exec(ae);if(ue){var Z=ue[0].replace(/^ *>[ \t]?/gm,"");return{type:"blockquote",raw:ue[0],tokens:this.lexer.blockTokens(Z,[]),text:Z}}},ye.list=function(ae){var ue=this.rules.block.list.exec(ae);if(ue){var Z,J,I,U,H,j,se,le,Y,ve,pe,Me,xe=ue[1].trim(),Ye=xe.length>1,Ge={type:"list",raw:"",ordered:Ye,start:Ye?+xe.slice(0,-1):"",loose:!1,items:[]};xe=Ye?"\\d{1,9}\\"+xe.slice(-1):"\\"+xe,this.options.pedantic&&(xe=Ye?xe:"[*+-]");for(var Te=new RegExp("^( {0,3}"+xe+")((?:[	 ][^\\n]*)?(?:\\n|$))");ae&&(Me=!1,!(!(ue=Te.exec(ae))||this.rules.block.hr.test(ae)));){if(Z=ue[0],ae=ae.substring(Z.length),le=ue[2].split(`
`,1)[0],Y=ae.split(`
`,1)[0],this.options.pedantic?(U=2,pe=le.trimLeft()):(U=ue[2].search(/[^ ]/),U=U>4?1:U,pe=le.slice(U),U+=ue[1].length),j=!1,!le&&/^ *$/.test(Y)&&(Z+=Y+`
`,ae=ae.substring(Y.length+1),Me=!0),!Me)for(var rt=new RegExp("^ {0,"+Math.min(3,U-1)+"}(?:[*+-]|\\d{1,9}[.)])((?: [^\\n]*)?(?:\\n|$))"),X=new RegExp("^ {0,"+Math.min(3,U-1)+"}((?:- *){3,}|(?:_ *){3,}|(?:\\* *){3,})(?:\\n+|$)"),Q=new RegExp("^ {0,"+Math.min(3,U-1)+"}(?:```|~~~)"),he=new RegExp("^ {0,"+Math.min(3,U-1)+"}#");ae&&(ve=ae.split(`
`,1)[0],le=ve,this.options.pedantic&&(le=le.replace(/^ {1,4}(?=( {4})*[^ ])/g,"  ")),!(Q.test(le)||he.test(le)||rt.test(le)||X.test(ae)));){if(le.search(/[^ ]/)>=U||!le.trim())pe+=`
`+le.slice(U);else if(!j)pe+=`
`+le;else break;!j&&!le.trim()&&(j=!0),Z+=ve+`
`,ae=ae.substring(ve.length+1)}Ge.loose||(se?Ge.loose=!0:/\n *\n *$/.test(Z)&&(se=!0)),this.options.gfm&&(J=/^\[[ xX]\] /.exec(pe),J&&(I=J[0]!=="[ ] ",pe=pe.replace(/^\[[ xX]\] +/,""))),Ge.items.push({type:"list_item",raw:Z,task:!!J,checked:I,loose:!1,text:pe}),Ge.raw+=Z}Ge.items[Ge.items.length-1].raw=Z.trimRight(),Ge.items[Ge.items.length-1].text=pe.trimRight(),Ge.raw=Ge.raw.trimRight();var Ue=Ge.items.length;for(H=0;H<Ue;H++){this.lexer.state.top=!1,Ge.items[H].tokens=this.lexer.blockTokens(Ge.items[H].text,[]);var je=Ge.items[H].tokens.filter(function(Ke){return Ke.type==="space"}),Ze=je.every(function(Ke){for(var Ve=Ke.raw.split(""),it=0,st=M(Ve),dt;!(dt=st()).done;){var yt=dt.value;if(yt===`
`&&(it+=1),it>1)return!0}return!1});!Ge.loose&&je.length&&Ze&&(Ge.loose=!0,Ge.items[H].loose=!0)}return Ge}},ye.html=function(ae){var ue=this.rules.block.html.exec(ae);if(ue){var Z={type:"html",raw:ue[0],pre:!this.options.sanitizer&&(ue[1]==="pre"||ue[1]==="script"||ue[1]==="style"),text:ue[0]};if(this.options.sanitize){var J=this.options.sanitizer?this.options.sanitizer(ue[0]):f(ue[0]);Z.type="paragraph",Z.text=J,Z.tokens=this.lexer.inline(J)}return Z}},ye.def=function(ae){var ue=this.rules.block.def.exec(ae);if(ue){ue[3]&&(ue[3]=ue[3].substring(1,ue[3].length-1));var Z=ue[1].toLowerCase().replace(/\s+/g," ");return{type:"def",tag:Z,raw:ue[0],href:ue[2],title:ue[3]}}},ye.table=function(ae){var ue=this.rules.block.table.exec(ae);if(ue){var Z={type:"table",header:v(ue[1]).map(function(se){return{text:se}}),align:ue[2].replace(/^ *|\| *$/g,"").split(/ *\| */),rows:ue[3]&&ue[3].trim()?ue[3].replace(/\n[ \t]*$/,"").split(`
`):[]};if(Z.header.length===Z.align.length){Z.raw=ue[0];var J=Z.align.length,I,U,H,j;for(I=0;I<J;I++)/^ *-+: *$/.test(Z.align[I])?Z.align[I]="right":/^ *:-+: *$/.test(Z.align[I])?Z.align[I]="center":/^ *:-+ *$/.test(Z.align[I])?Z.align[I]="left":Z.align[I]=null;for(J=Z.rows.length,I=0;I<J;I++)Z.rows[I]=v(Z.rows[I],Z.header.length).map(function(se){return{text:se}});for(J=Z.header.length,U=0;U<J;U++)Z.header[U].tokens=this.lexer.inline(Z.header[U].text);for(J=Z.rows.length,U=0;U<J;U++)for(j=Z.rows[U],H=0;H<j.length;H++)j[H].tokens=this.lexer.inline(j[H].text);return Z}}},ye.lheading=function(ae){var ue=this.rules.block.lheading.exec(ae);if(ue)return{type:"heading",raw:ue[0],depth:ue[2].charAt(0)==="="?1:2,text:ue[1],tokens:this.lexer.inline(ue[1])}},ye.paragraph=function(ae){var ue=this.rules.block.paragraph.exec(ae);if(ue){var Z=ue[1].charAt(ue[1].length-1)===`
`?ue[1].slice(0,-1):ue[1];return{type:"paragraph",raw:ue[0],text:Z,tokens:this.lexer.inline(Z)}}},ye.text=function(ae){var ue=this.rules.block.text.exec(ae);if(ue)return{type:"text",raw:ue[0],text:ue[0],tokens:this.lexer.inline(ue[0])}},ye.escape=function(ae){var ue=this.rules.inline.escape.exec(ae);if(ue)return{type:"escape",raw:ue[0],text:f(ue[1])}},ye.tag=function(ae){var ue=this.rules.inline.tag.exec(ae);if(ue)return!this.lexer.state.inLink&&/^<a /i.test(ue[0])?this.lexer.state.inLink=!0:this.lexer.state.inLink&&/^<\/a>/i.test(ue[0])&&(this.lexer.state.inLink=!1),!this.lexer.state.inRawBlock&&/^<(pre|code|kbd|script)(\s|>)/i.test(ue[0])?this.lexer.state.inRawBlock=!0:this.lexer.state.inRawBlock&&/^<\/(pre|code|kbd|script)(\s|>)/i.test(ue[0])&&(this.lexer.state.inRawBlock=!1),{type:this.options.sanitize?"text":"html",raw:ue[0],inLink:this.lexer.state.inLink,inRawBlock:this.lexer.state.inRawBlock,text:this.options.sanitize?this.options.sanitizer?this.options.sanitizer(ue[0]):f(ue[0]):ue[0]}},ye.link=function(ae){var ue=this.rules.inline.link.exec(ae);if(ue){var Z=ue[2].trim();if(!this.options.pedantic&&/^</.test(Z)){if(!/>$/.test(Z))return;var J=p(Z.slice(0,-1),"\\");if((Z.length-J.length)%2===0)return}else{var I=T(ue[2],"()");if(I>-1){var U=ue[0].indexOf("!")===0?5:4,H=U+ue[1].length+I;ue[2]=ue[2].substring(0,I),ue[0]=ue[0].substring(0,H).trim(),ue[3]=""}}var j=ue[2],se="";if(this.options.pedantic){var le=/^([^'"]*[^\s])\s+(['"])(.*)\2/.exec(j);le&&(j=le[1],se=le[3])}else se=ue[3]?ue[3].slice(1,-1):"";return j=j.trim(),/^</.test(j)&&(this.options.pedantic&&!/>$/.test(Z)?j=j.slice(1):j=j.slice(1,-1)),B(ue,{href:j&&j.replace(this.rules.inline._escapes,"$1"),title:se&&se.replace(this.rules.inline._escapes,"$1")},ue[0],this.lexer)}},ye.reflink=function(ae,ue){var Z;if((Z=this.rules.inline.reflink.exec(ae))||(Z=this.rules.inline.nolink.exec(ae))){var J=(Z[2]||Z[1]).replace(/\s+/g," ");if(J=ue[J.toLowerCase()],!J||!J.href){var I=Z[0].charAt(0);return{type:"text",raw:I,text:I}}return B(Z,J,Z[0],this.lexer)}},ye.emStrong=function(ae,ue,Z){Z===void 0&&(Z="");var J=this.rules.inline.emStrong.lDelim.exec(ae);if(!!J&&!(J[3]&&Z.match(/(?:[0-9A-Za-z\xAA\xB2\xB3\xB5\xB9\xBA\xBC-\xBE\xC0-\xD6\xD8-\xF6\xF8-\u02C1\u02C6-\u02D1\u02E0-\u02E4\u02EC\u02EE\u0370-\u0374\u0376\u0377\u037A-\u037D\u037F\u0386\u0388-\u038A\u038C\u038E-\u03A1\u03A3-\u03F5\u03F7-\u0481\u048A-\u052F\u0531-\u0556\u0559\u0560-\u0588\u05D0-\u05EA\u05EF-\u05F2\u0620-\u064A\u0660-\u0669\u066E\u066F\u0671-\u06D3\u06D5\u06E5\u06E6\u06EE-\u06FC\u06FF\u0710\u0712-\u072F\u074D-\u07A5\u07B1\u07C0-\u07EA\u07F4\u07F5\u07FA\u0800-\u0815\u081A\u0824\u0828\u0840-\u0858\u0860-\u086A\u0870-\u0887\u0889-\u088E\u08A0-\u08C9\u0904-\u0939\u093D\u0950\u0958-\u0961\u0966-\u096F\u0971-\u0980\u0985-\u098C\u098F\u0990\u0993-\u09A8\u09AA-\u09B0\u09B2\u09B6-\u09B9\u09BD\u09CE\u09DC\u09DD\u09DF-\u09E1\u09E6-\u09F1\u09F4-\u09F9\u09FC\u0A05-\u0A0A\u0A0F\u0A10\u0A13-\u0A28\u0A2A-\u0A30\u0A32\u0A33\u0A35\u0A36\u0A38\u0A39\u0A59-\u0A5C\u0A5E\u0A66-\u0A6F\u0A72-\u0A74\u0A85-\u0A8D\u0A8F-\u0A91\u0A93-\u0AA8\u0AAA-\u0AB0\u0AB2\u0AB3\u0AB5-\u0AB9\u0ABD\u0AD0\u0AE0\u0AE1\u0AE6-\u0AEF\u0AF9\u0B05-\u0B0C\u0B0F\u0B10\u0B13-\u0B28\u0B2A-\u0B30\u0B32\u0B33\u0B35-\u0B39\u0B3D\u0B5C\u0B5D\u0B5F-\u0B61\u0B66-\u0B6F\u0B71-\u0B77\u0B83\u0B85-\u0B8A\u0B8E-\u0B90\u0B92-\u0B95\u0B99\u0B9A\u0B9C\u0B9E\u0B9F\u0BA3\u0BA4\u0BA8-\u0BAA\u0BAE-\u0BB9\u0BD0\u0BE6-\u0BF2\u0C05-\u0C0C\u0C0E-\u0C10\u0C12-\u0C28\u0C2A-\u0C39\u0C3D\u0C58-\u0C5A\u0C5D\u0C60\u0C61\u0C66-\u0C6F\u0C78-\u0C7E\u0C80\u0C85-\u0C8C\u0C8E-\u0C90\u0C92-\u0CA8\u0CAA-\u0CB3\u0CB5-\u0CB9\u0CBD\u0CDD\u0CDE\u0CE0\u0CE1\u0CE6-\u0CEF\u0CF1\u0CF2\u0D04-\u0D0C\u0D0E-\u0D10\u0D12-\u0D3A\u0D3D\u0D4E\u0D54-\u0D56\u0D58-\u0D61\u0D66-\u0D78\u0D7A-\u0D7F\u0D85-\u0D96\u0D9A-\u0DB1\u0DB3-\u0DBB\u0DBD\u0DC0-\u0DC6\u0DE6-\u0DEF\u0E01-\u0E30\u0E32\u0E33\u0E40-\u0E46\u0E50-\u0E59\u0E81\u0E82\u0E84\u0E86-\u0E8A\u0E8C-\u0EA3\u0EA5\u0EA7-\u0EB0\u0EB2\u0EB3\u0EBD\u0EC0-\u0EC4\u0EC6\u0ED0-\u0ED9\u0EDC-\u0EDF\u0F00\u0F20-\u0F33\u0F40-\u0F47\u0F49-\u0F6C\u0F88-\u0F8C\u1000-\u102A\u103F-\u1049\u1050-\u1055\u105A-\u105D\u1061\u1065\u1066\u106E-\u1070\u1075-\u1081\u108E\u1090-\u1099\u10A0-\u10C5\u10C7\u10CD\u10D0-\u10FA\u10FC-\u1248\u124A-\u124D\u1250-\u1256\u1258\u125A-\u125D\u1260-\u1288\u128A-\u128D\u1290-\u12B0\u12B2-\u12B5\u12B8-\u12BE\u12C0\u12C2-\u12C5\u12C8-\u12D6\u12D8-\u1310\u1312-\u1315\u1318-\u135A\u1369-\u137C\u1380-\u138F\u13A0-\u13F5\u13F8-\u13FD\u1401-\u166C\u166F-\u167F\u1681-\u169A\u16A0-\u16EA\u16EE-\u16F8\u1700-\u1711\u171F-\u1731\u1740-\u1751\u1760-\u176C\u176E-\u1770\u1780-\u17B3\u17D7\u17DC\u17E0-\u17E9\u17F0-\u17F9\u1810-\u1819\u1820-\u1878\u1880-\u1884\u1887-\u18A8\u18AA\u18B0-\u18F5\u1900-\u191E\u1946-\u196D\u1970-\u1974\u1980-\u19AB\u19B0-\u19C9\u19D0-\u19DA\u1A00-\u1A16\u1A20-\u1A54\u1A80-\u1A89\u1A90-\u1A99\u1AA7\u1B05-\u1B33\u1B45-\u1B4C\u1B50-\u1B59\u1B83-\u1BA0\u1BAE-\u1BE5\u1C00-\u1C23\u1C40-\u1C49\u1C4D-\u1C7D\u1C80-\u1C88\u1C90-\u1CBA\u1CBD-\u1CBF\u1CE9-\u1CEC\u1CEE-\u1CF3\u1CF5\u1CF6\u1CFA\u1D00-\u1DBF\u1E00-\u1F15\u1F18-\u1F1D\u1F20-\u1F45\u1F48-\u1F4D\u1F50-\u1F57\u1F59\u1F5B\u1F5D\u1F5F-\u1F7D\u1F80-\u1FB4\u1FB6-\u1FBC\u1FBE\u1FC2-\u1FC4\u1FC6-\u1FCC\u1FD0-\u1FD3\u1FD6-\u1FDB\u1FE0-\u1FEC\u1FF2-\u1FF4\u1FF6-\u1FFC\u2070\u2071\u2074-\u2079\u207F-\u2089\u2090-\u209C\u2102\u2107\u210A-\u2113\u2115\u2119-\u211D\u2124\u2126\u2128\u212A-\u212D\u212F-\u2139\u213C-\u213F\u2145-\u2149\u214E\u2150-\u2189\u2460-\u249B\u24EA-\u24FF\u2776-\u2793\u2C00-\u2CE4\u2CEB-\u2CEE\u2CF2\u2CF3\u2CFD\u2D00-\u2D25\u2D27\u2D2D\u2D30-\u2D67\u2D6F\u2D80-\u2D96\u2DA0-\u2DA6\u2DA8-\u2DAE\u2DB0-\u2DB6\u2DB8-\u2DBE\u2DC0-\u2DC6\u2DC8-\u2DCE\u2DD0-\u2DD6\u2DD8-\u2DDE\u2E2F\u3005-\u3007\u3021-\u3029\u3031-\u3035\u3038-\u303C\u3041-\u3096\u309D-\u309F\u30A1-\u30FA\u30FC-\u30FF\u3105-\u312F\u3131-\u318E\u3192-\u3195\u31A0-\u31BF\u31F0-\u31FF\u3220-\u3229\u3248-\u324F\u3251-\u325F\u3280-\u3289\u32B1-\u32BF\u3400-\u4DBF\u4E00-\uA48C\uA4D0-\uA4FD\uA500-\uA60C\uA610-\uA62B\uA640-\uA66E\uA67F-\uA69D\uA6A0-\uA6EF\uA717-\uA71F\uA722-\uA788\uA78B-\uA7CA\uA7D0\uA7D1\uA7D3\uA7D5-\uA7D9\uA7F2-\uA801\uA803-\uA805\uA807-\uA80A\uA80C-\uA822\uA830-\uA835\uA840-\uA873\uA882-\uA8B3\uA8D0-\uA8D9\uA8F2-\uA8F7\uA8FB\uA8FD\uA8FE\uA900-\uA925\uA930-\uA946\uA960-\uA97C\uA984-\uA9B2\uA9CF-\uA9D9\uA9E0-\uA9E4\uA9E6-\uA9FE\uAA00-\uAA28\uAA40-\uAA42\uAA44-\uAA4B\uAA50-\uAA59\uAA60-\uAA76\uAA7A\uAA7E-\uAAAF\uAAB1\uAAB5\uAAB6\uAAB9-\uAABD\uAAC0\uAAC2\uAADB-\uAADD\uAAE0-\uAAEA\uAAF2-\uAAF4\uAB01-\uAB06\uAB09-\uAB0E\uAB11-\uAB16\uAB20-\uAB26\uAB28-\uAB2E\uAB30-\uAB5A\uAB5C-\uAB69\uAB70-\uABE2\uABF0-\uABF9\uAC00-\uD7A3\uD7B0-\uD7C6\uD7CB-\uD7FB\uF900-\uFA6D\uFA70-\uFAD9\uFB00-\uFB06\uFB13-\uFB17\uFB1D\uFB1F-\uFB28\uFB2A-\uFB36\uFB38-\uFB3C\uFB3E\uFB40\uFB41\uFB43\uFB44\uFB46-\uFBB1\uFBD3-\uFD3D\uFD50-\uFD8F\uFD92-\uFDC7\uFDF0-\uFDFB\uFE70-\uFE74\uFE76-\uFEFC\uFF10-\uFF19\uFF21-\uFF3A\uFF41-\uFF5A\uFF66-\uFFBE\uFFC2-\uFFC7\uFFCA-\uFFCF\uFFD2-\uFFD7\uFFDA-\uFFDC]|\uD800[\uDC00-\uDC0B\uDC0D-\uDC26\uDC28-\uDC3A\uDC3C\uDC3D\uDC3F-\uDC4D\uDC50-\uDC5D\uDC80-\uDCFA\uDD07-\uDD33\uDD40-\uDD78\uDD8A\uDD8B\uDE80-\uDE9C\uDEA0-\uDED0\uDEE1-\uDEFB\uDF00-\uDF23\uDF2D-\uDF4A\uDF50-\uDF75\uDF80-\uDF9D\uDFA0-\uDFC3\uDFC8-\uDFCF\uDFD1-\uDFD5]|\uD801[\uDC00-\uDC9D\uDCA0-\uDCA9\uDCB0-\uDCD3\uDCD8-\uDCFB\uDD00-\uDD27\uDD30-\uDD63\uDD70-\uDD7A\uDD7C-\uDD8A\uDD8C-\uDD92\uDD94\uDD95\uDD97-\uDDA1\uDDA3-\uDDB1\uDDB3-\uDDB9\uDDBB\uDDBC\uDE00-\uDF36\uDF40-\uDF55\uDF60-\uDF67\uDF80-\uDF85\uDF87-\uDFB0\uDFB2-\uDFBA]|\uD802[\uDC00-\uDC05\uDC08\uDC0A-\uDC35\uDC37\uDC38\uDC3C\uDC3F-\uDC55\uDC58-\uDC76\uDC79-\uDC9E\uDCA7-\uDCAF\uDCE0-\uDCF2\uDCF4\uDCF5\uDCFB-\uDD1B\uDD20-\uDD39\uDD80-\uDDB7\uDDBC-\uDDCF\uDDD2-\uDE00\uDE10-\uDE13\uDE15-\uDE17\uDE19-\uDE35\uDE40-\uDE48\uDE60-\uDE7E\uDE80-\uDE9F\uDEC0-\uDEC7\uDEC9-\uDEE4\uDEEB-\uDEEF\uDF00-\uDF35\uDF40-\uDF55\uDF58-\uDF72\uDF78-\uDF91\uDFA9-\uDFAF]|\uD803[\uDC00-\uDC48\uDC80-\uDCB2\uDCC0-\uDCF2\uDCFA-\uDD23\uDD30-\uDD39\uDE60-\uDE7E\uDE80-\uDEA9\uDEB0\uDEB1\uDF00-\uDF27\uDF30-\uDF45\uDF51-\uDF54\uDF70-\uDF81\uDFB0-\uDFCB\uDFE0-\uDFF6]|\uD804[\uDC03-\uDC37\uDC52-\uDC6F\uDC71\uDC72\uDC75\uDC83-\uDCAF\uDCD0-\uDCE8\uDCF0-\uDCF9\uDD03-\uDD26\uDD36-\uDD3F\uDD44\uDD47\uDD50-\uDD72\uDD76\uDD83-\uDDB2\uDDC1-\uDDC4\uDDD0-\uDDDA\uDDDC\uDDE1-\uDDF4\uDE00-\uDE11\uDE13-\uDE2B\uDE80-\uDE86\uDE88\uDE8A-\uDE8D\uDE8F-\uDE9D\uDE9F-\uDEA8\uDEB0-\uDEDE\uDEF0-\uDEF9\uDF05-\uDF0C\uDF0F\uDF10\uDF13-\uDF28\uDF2A-\uDF30\uDF32\uDF33\uDF35-\uDF39\uDF3D\uDF50\uDF5D-\uDF61]|\uD805[\uDC00-\uDC34\uDC47-\uDC4A\uDC50-\uDC59\uDC5F-\uDC61\uDC80-\uDCAF\uDCC4\uDCC5\uDCC7\uDCD0-\uDCD9\uDD80-\uDDAE\uDDD8-\uDDDB\uDE00-\uDE2F\uDE44\uDE50-\uDE59\uDE80-\uDEAA\uDEB8\uDEC0-\uDEC9\uDF00-\uDF1A\uDF30-\uDF3B\uDF40-\uDF46]|\uD806[\uDC00-\uDC2B\uDCA0-\uDCF2\uDCFF-\uDD06\uDD09\uDD0C-\uDD13\uDD15\uDD16\uDD18-\uDD2F\uDD3F\uDD41\uDD50-\uDD59\uDDA0-\uDDA7\uDDAA-\uDDD0\uDDE1\uDDE3\uDE00\uDE0B-\uDE32\uDE3A\uDE50\uDE5C-\uDE89\uDE9D\uDEB0-\uDEF8]|\uD807[\uDC00-\uDC08\uDC0A-\uDC2E\uDC40\uDC50-\uDC6C\uDC72-\uDC8F\uDD00-\uDD06\uDD08\uDD09\uDD0B-\uDD30\uDD46\uDD50-\uDD59\uDD60-\uDD65\uDD67\uDD68\uDD6A-\uDD89\uDD98\uDDA0-\uDDA9\uDEE0-\uDEF2\uDFB0\uDFC0-\uDFD4]|\uD808[\uDC00-\uDF99]|\uD809[\uDC00-\uDC6E\uDC80-\uDD43]|\uD80B[\uDF90-\uDFF0]|[\uD80C\uD81C-\uD820\uD822\uD840-\uD868\uD86A-\uD86C\uD86F-\uD872\uD874-\uD879\uD880-\uD883][\uDC00-\uDFFF]|\uD80D[\uDC00-\uDC2E]|\uD811[\uDC00-\uDE46]|\uD81A[\uDC00-\uDE38\uDE40-\uDE5E\uDE60-\uDE69\uDE70-\uDEBE\uDEC0-\uDEC9\uDED0-\uDEED\uDF00-\uDF2F\uDF40-\uDF43\uDF50-\uDF59\uDF5B-\uDF61\uDF63-\uDF77\uDF7D-\uDF8F]|\uD81B[\uDE40-\uDE96\uDF00-\uDF4A\uDF50\uDF93-\uDF9F\uDFE0\uDFE1\uDFE3]|\uD821[\uDC00-\uDFF7]|\uD823[\uDC00-\uDCD5\uDD00-\uDD08]|\uD82B[\uDFF0-\uDFF3\uDFF5-\uDFFB\uDFFD\uDFFE]|\uD82C[\uDC00-\uDD22\uDD50-\uDD52\uDD64-\uDD67\uDD70-\uDEFB]|\uD82F[\uDC00-\uDC6A\uDC70-\uDC7C\uDC80-\uDC88\uDC90-\uDC99]|\uD834[\uDEE0-\uDEF3\uDF60-\uDF78]|\uD835[\uDC00-\uDC54\uDC56-\uDC9C\uDC9E\uDC9F\uDCA2\uDCA5\uDCA6\uDCA9-\uDCAC\uDCAE-\uDCB9\uDCBB\uDCBD-\uDCC3\uDCC5-\uDD05\uDD07-\uDD0A\uDD0D-\uDD14\uDD16-\uDD1C\uDD1E-\uDD39\uDD3B-\uDD3E\uDD40-\uDD44\uDD46\uDD4A-\uDD50\uDD52-\uDEA5\uDEA8-\uDEC0\uDEC2-\uDEDA\uDEDC-\uDEFA\uDEFC-\uDF14\uDF16-\uDF34\uDF36-\uDF4E\uDF50-\uDF6E\uDF70-\uDF88\uDF8A-\uDFA8\uDFAA-\uDFC2\uDFC4-\uDFCB\uDFCE-\uDFFF]|\uD837[\uDF00-\uDF1E]|\uD838[\uDD00-\uDD2C\uDD37-\uDD3D\uDD40-\uDD49\uDD4E\uDE90-\uDEAD\uDEC0-\uDEEB\uDEF0-\uDEF9]|\uD839[\uDFE0-\uDFE6\uDFE8-\uDFEB\uDFED\uDFEE\uDFF0-\uDFFE]|\uD83A[\uDC00-\uDCC4\uDCC7-\uDCCF\uDD00-\uDD43\uDD4B\uDD50-\uDD59]|\uD83B[\uDC71-\uDCAB\uDCAD-\uDCAF\uDCB1-\uDCB4\uDD01-\uDD2D\uDD2F-\uDD3D\uDE00-\uDE03\uDE05-\uDE1F\uDE21\uDE22\uDE24\uDE27\uDE29-\uDE32\uDE34-\uDE37\uDE39\uDE3B\uDE42\uDE47\uDE49\uDE4B\uDE4D-\uDE4F\uDE51\uDE52\uDE54\uDE57\uDE59\uDE5B\uDE5D\uDE5F\uDE61\uDE62\uDE64\uDE67-\uDE6A\uDE6C-\uDE72\uDE74-\uDE77\uDE79-\uDE7C\uDE7E\uDE80-\uDE89\uDE8B-\uDE9B\uDEA1-\uDEA3\uDEA5-\uDEA9\uDEAB-\uDEBB]|\uD83C[\uDD00-\uDD0C]|\uD83E[\uDFF0-\uDFF9]|\uD869[\uDC00-\uDEDF\uDF00-\uDFFF]|\uD86D[\uDC00-\uDF38\uDF40-\uDFFF]|\uD86E[\uDC00-\uDC1D\uDC20-\uDFFF]|\uD873[\uDC00-\uDEA1\uDEB0-\uDFFF]|\uD87A[\uDC00-\uDFE0]|\uD87E[\uDC00-\uDE1D]|\uD884[\uDC00-\uDF4A])/))){var I=J[1]||J[2]||"";if(!I||I&&(Z===""||this.rules.inline.punctuation.exec(Z))){var U=J[0].length-1,H,j,se=U,le=0,Y=J[0][0]==="*"?this.rules.inline.emStrong.rDelimAst:this.rules.inline.emStrong.rDelimUnd;for(Y.lastIndex=0,ue=ue.slice(-1*ae.length+U);(J=Y.exec(ue))!=null;)if(H=J[1]||J[2]||J[3]||J[4]||J[5]||J[6],!!H){if(j=H.length,J[3]||J[4]){se+=j;continue}else if((J[5]||J[6])&&U%3&&!((U+j)%3)){le+=j;continue}if(se-=j,!(se>0)){if(j=Math.min(j,j+se+le),Math.min(U,j)%2){var ve=ae.slice(1,U+J.index+j);return{type:"em",raw:ae.slice(0,U+J.index+j+1),text:ve,tokens:this.lexer.inlineTokens(ve)}}var pe=ae.slice(2,U+J.index+j-1);return{type:"strong",raw:ae.slice(0,U+J.index+j+1),text:pe,tokens:this.lexer.inlineTokens(pe)}}}}}},ye.codespan=function(ae){var ue=this.rules.inline.code.exec(ae);if(ue){var Z=ue[2].replace(/\n/g," "),J=/[^ ]/.test(Z),I=/^ /.test(Z)&&/ $/.test(Z);return J&&I&&(Z=Z.substring(1,Z.length-1)),Z=f(Z,!0),{type:"codespan",raw:ue[0],text:Z}}},ye.br=function(ae){var ue=this.rules.inline.br.exec(ae);if(ue)return{type:"br",raw:ue[0]}},ye.del=function(ae){var ue=this.rules.inline.del.exec(ae);if(ue)return{type:"del",raw:ue[0],text:ue[2],tokens:this.lexer.inlineTokens(ue[2])}},ye.autolink=function(ae,ue){var Z=this.rules.inline.autolink.exec(ae);if(Z){var J,I;return Z[2]==="@"?(J=f(this.options.mangle?ue(Z[1]):Z[1]),I="mailto:"+J):(J=f(Z[1]),I=J),{type:"link",raw:Z[0],text:J,href:I,tokens:[{type:"text",raw:J,text:J}]}}},ye.url=function(ae,ue){var Z;if(Z=this.rules.inline.url.exec(ae)){var J,I;if(Z[2]==="@")J=f(this.options.mangle?ue(Z[0]):Z[0]),I="mailto:"+J;else{var U;do U=Z[0],Z[0]=this.rules.inline._backpedal.exec(Z[0])[0];while(U!==Z[0]);J=f(Z[0]),Z[1]==="www."?I="http://"+J:I=J}return{type:"link",raw:Z[0],text:J,href:I,tokens:[{type:"text",raw:J,text:J}]}}},ye.inlineText=function(ae,ue){var Z=this.rules.inline.text.exec(ae);if(Z){var J;return this.lexer.state.inRawBlock?J=this.options.sanitize?this.options.sanitizer?this.options.sanitizer(Z[0]):f(Z[0]):Z[0]:J=f(this.options.smartypants?ue(Z[0]):Z[0]),{type:"text",raw:Z[0],text:J}}},ke}(),L={newline:/^(?: *(?:\n|$))+/,code:/^( {4}[^\n]+(?:\n(?: *(?:\n|$))*)?)+/,fences:/^ {0,3}(`{3,}(?=[^`\n]*\n)|~{3,})([^\n]*)\n(?:|([\s\S]*?)\n)(?: {0,3}\1[~`]* *(?=\n|$)|$)/,hr:/^ {0,3}((?:-[\t ]*){3,}|(?:_[ \t]*){3,}|(?:\*[ \t]*){3,})(?:\n+|$)/,heading:/^ {0,3}(#{1,6})(?=\s|$)(.*)(?:\n+|$)/,blockquote:/^( {0,3}> ?(paragraph|[^\n]*)(?:\n|$))+/,list:/^( {0,3}bull)([ \t][^\n]+?)?(?:\n|$)/,html:"^ {0,3}(?:<(script|pre|style|textarea)[\\s>][\\s\\S]*?(?:</\\1>[^\\n]*\\n+|$)|comment[^\\n]*(\\n+|$)|<\\?[\\s\\S]*?(?:\\?>\\n*|$)|<![A-Z][\\s\\S]*?(?:>\\n*|$)|<!\\[CDATA\\[[\\s\\S]*?(?:\\]\\]>\\n*|$)|</?(tag)(?: +|\\n|/?>)[\\s\\S]*?(?:(?:\\n *)+\\n|$)|<(?!script|pre|style|textarea)([a-z][\\w-]*)(?:attribute)*? */?>(?=[ \\t]*(?:\\n|$))[\\s\\S]*?(?:(?:\\n *)+\\n|$)|</(?!script|pre|style|textarea)[a-z][\\w-]*\\s*>(?=[ \\t]*(?:\\n|$))[\\s\\S]*?(?:(?:\\n *)+\\n|$))",def:/^ {0,3}\[(label)\]: *(?:\n *)?<?([^\s>]+)>?(?:(?: +(?:\n *)?| *\n *)(title))? *(?:\n+|$)/,table:a,lheading:/^([^\n]+)\n {0,3}(=+|-+) *(?:\n+|$)/,_paragraph:/^([^\n]+(?:\n(?!hr|heading|lheading|blockquote|fences|list|html|table| +\n)[^\n]+)*)/,text:/^[^\n]+/};L._label=/(?!\s*\])(?:\\.|[^\[\]\\])+/,L._title=/(?:"(?:\\"?|[^"\\])*"|'[^'\n]*(?:\n[^'\n]+)*\n?'|\([^()]*\))/,L.def=g(L.def).replace("label",L._label).replace("title",L._title).getRegex(),L.bullet=/(?:[*+-]|\d{1,9}[.)])/,L.listItemStart=g(/^( *)(bull) */).replace("bull",L.bullet).getRegex(),L.list=g(L.list).replace(/bull/g,L.bullet).replace("hr","\\n+(?=\\1?(?:(?:- *){3,}|(?:_ *){3,}|(?:\\* *){3,})(?:\\n+|$))").replace("def","\\n+(?="+L.def.source+")").getRegex(),L._tag="address|article|aside|base|basefont|blockquote|body|caption|center|col|colgroup|dd|details|dialog|dir|div|dl|dt|fieldset|figcaption|figure|footer|form|frame|frameset|h[1-6]|head|header|hr|html|iframe|legend|li|link|main|menu|menuitem|meta|nav|noframes|ol|optgroup|option|p|param|section|source|summary|table|tbody|td|tfoot|th|thead|title|tr|track|ul",L._comment=/<!--(?!-?>)[\s\S]*?(?:-->|$)/,L.html=g(L.html,"i").replace("comment",L._comment).replace("tag",L._tag).replace("attribute",/ +[a-zA-Z:_][\w.:-]*(?: *= *"[^"\n]*"| *= *'[^'\n]*'| *= *[^\s"'=<>`]+)?/).getRegex(),L.paragraph=g(L._paragraph).replace("hr",L.hr).replace("heading"," {0,3}#{1,6} ").replace("|lheading","").replace("|table","").replace("blockquote"," {0,3}>").replace("fences"," {0,3}(?:`{3,}(?=[^`\\n]*\\n)|~{3,})[^\\n]*\\n").replace("list"," {0,3}(?:[*+-]|1[.)]) ").replace("html","</?(?:tag)(?: +|\\n|/?>)|<(?:script|pre|style|textarea|!--)").replace("tag",L._tag).getRegex(),L.blockquote=g(L.blockquote).replace("paragraph",L.paragraph).getRegex(),L.normal=o({},L),L.gfm=o({},L.normal,{table:"^ *([^\\n ].*\\|.*)\\n {0,3}(?:\\| *)?(:?-+:? *(?:\\| *:?-+:? *)*)(?:\\| *)?(?:\\n((?:(?! *\\n|hr|heading|blockquote|code|fences|list|html).*(?:\\n|$))*)\\n*|$)"}),L.gfm.table=g(L.gfm.table).replace("hr",L.hr).replace("heading"," {0,3}#{1,6} ").replace("blockquote"," {0,3}>").replace("code"," {4}[^\\n]").replace("fences"," {0,3}(?:`{3,}(?=[^`\\n]*\\n)|~{3,})[^\\n]*\\n").replace("list"," {0,3}(?:[*+-]|1[.)]) ").replace("html","</?(?:tag)(?: +|\\n|/?>)|<(?:script|pre|style|textarea|!--)").replace("tag",L._tag).getRegex(),L.gfm.paragraph=g(L._paragraph).replace("hr",L.hr).replace("heading"," {0,3}#{1,6} ").replace("|lheading","").replace("table",L.gfm.table).replace("blockquote"," {0,3}>").replace("fences"," {0,3}(?:`{3,}(?=[^`\\n]*\\n)|~{3,})[^\\n]*\\n").replace("list"," {0,3}(?:[*+-]|1[.)]) ").replace("html","</?(?:tag)(?: +|\\n|/?>)|<(?:script|pre|style|textarea|!--)").replace("tag",L._tag).getRegex(),L.pedantic=o({},L.normal,{html:g(`^ *(?:comment *(?:\\n|\\s*$)|<(tag)[\\s\\S]+?</\\1> *(?:\\n{2,}|\\s*$)|<tag(?:"[^"]*"|'[^']*'|\\s[^'"/>\\s]*)*?/?> *(?:\\n{2,}|\\s*$))`).replace("comment",L._comment).replace(/tag/g,"(?!(?:a|em|strong|small|s|cite|q|dfn|abbr|data|time|code|var|samp|kbd|sub|sup|i|b|u|mark|ruby|rt|rp|bdi|bdo|span|br|wbr|ins|del|img)\\b)\\w+(?!:|[^\\w\\s@]*@)\\b").getRegex(),def:/^ *\[([^\]]+)\]: *<?([^\s>]+)>?(?: +(["(][^\n]+[")]))? *(?:\n+|$)/,heading:/^(#{1,6})(.*)(?:\n+|$)/,fences:a,paragraph:g(L.normal._paragraph).replace("hr",L.hr).replace("heading",` *#{1,6} *[^
]`).replace("lheading",L.lheading).replace("blockquote"," {0,3}>").replace("|fences","").replace("|list","").replace("|html","").getRegex()});var R={escape:/^\\([!"#$%&'()*+,\-./:;<=>?@\[\]\\^_`{|}~])/,autolink:/^<(scheme:[^\s\x00-\x1f<>]*|email)>/,url:a,tag:"^comment|^</[a-zA-Z][\\w:-]*\\s*>|^<[a-zA-Z][\\w-]*(?:attribute)*?\\s*/?>|^<\\?[\\s\\S]*?\\?>|^<![a-zA-Z]+\\s[\\s\\S]*?>|^<!\\[CDATA\\[[\\s\\S]*?\\]\\]>",link:/^!?\[(label)\]\(\s*(href)(?:\s+(title))?\s*\)/,reflink:/^!?\[(label)\]\[(ref)\]/,nolink:/^!?\[(ref)\](?:\[\])?/,reflinkSearch:"reflink|nolink(?!\\()",emStrong:{lDelim:/^(?:\*+(?:([punct_])|[^\s*]))|^_+(?:([punct*])|([^\s_]))/,rDelimAst:/^[^_*]*?\_\_[^_*]*?\*[^_*]*?(?=\_\_)|[^*]+(?=[^*])|[punct_](\*+)(?=[\s]|$)|[^punct*_\s](\*+)(?=[punct_\s]|$)|[punct_\s](\*+)(?=[^punct*_\s])|[\s](\*+)(?=[punct_])|[punct_](\*+)(?=[punct_])|[^punct*_\s](\*+)(?=[^punct*_\s])/,rDelimUnd:/^[^_*]*?\*\*[^_*]*?\_[^_*]*?(?=\*\*)|[^_]+(?=[^_])|[punct*](\_+)(?=[\s]|$)|[^punct*_\s](\_+)(?=[punct*\s]|$)|[punct*\s](\_+)(?=[^punct*_\s])|[\s](\_+)(?=[punct*])|[punct*](\_+)(?=[punct*])/},code:/^(`+)([^`]|[^`][\s\S]*?[^`])\1(?!`)/,br:/^( {2,}|\\)\n(?!\s*$)/,del:a,text:/^(`+|[^`])(?:(?= {2,}\n)|[\s\S]*?(?:(?=[\\<!\[`*_]|\b_|$)|[^ ](?= {2,}\n)))/,punctuation:/^([\spunctuation])/};R._punctuation="!\"#$%&'()+\\-.,/:;<=>?@\\[\\]`^{|}~",R.punctuation=g(R.punctuation).replace(/punctuation/g,R._punctuation).getRegex(),R.blockSkip=/\[[^\]]*?\]\([^\)]*?\)|`[^`]*?`|<[^>]*?>/g,R.escapedEmSt=/\\\*|\\_/g,R._comment=g(L._comment).replace("(?:-->|$)","-->").getRegex(),R.emStrong.lDelim=g(R.emStrong.lDelim).replace(/punct/g,R._punctuation).getRegex(),R.emStrong.rDelimAst=g(R.emStrong.rDelimAst,"g").replace(/punct/g,R._punctuation).getRegex(),R.emStrong.rDelimUnd=g(R.emStrong.rDelimUnd,"g").replace(/punct/g,R._punctuation).getRegex(),R._escapes=/\\([!"#$%&'()*+,\-./:;<=>?@\[\]\\^_`{|}~])/g,R._scheme=/[a-zA-Z][a-zA-Z0-9+.-]{1,31}/,R._email=/[a-zA-Z0-9.!#$%&'*+/=?^_`{|}~-]+(@)[a-zA-Z0-9](?:[a-zA-Z0-9-]{0,61}[a-zA-Z0-9])?(?:\.[a-zA-Z0-9](?:[a-zA-Z0-9-]{0,61}[a-zA-Z0-9])?)+(?![-_])/,R.autolink=g(R.autolink).replace("scheme",R._scheme).replace("email",R._email).getRegex(),R._attribute=/\s+[a-zA-Z:_][\w.:-]*(?:\s*=\s*"[^"]*"|\s*=\s*'[^']*'|\s*=\s*[^\s"'=<>`]+)?/,R.tag=g(R.tag).replace("comment",R._comment).replace("attribute",R._attribute).getRegex(),R._label=/(?:\[(?:\\.|[^\[\]\\])*\]|\\.|`[^`]*`|[^\[\]\\`])*?/,R._href=/<(?:\\.|[^\n<>\\])+>|[^\s\x00-\x1f]*/,R._title=/"(?:\\"?|[^"\\])*"|'(?:\\'?|[^'\\])*'|\((?:\\\)?|[^)\\])*\)/,R.link=g(R.link).replace("label",R._label).replace("href",R._href).replace("title",R._title).getRegex(),R.reflink=g(R.reflink).replace("label",R._label).replace("ref",L._label).getRegex(),R.nolink=g(R.nolink).replace("ref",L._label).getRegex(),R.reflinkSearch=g(R.reflinkSearch,"g").replace("reflink",R.reflink).replace("nolink",R.nolink).getRegex(),R.normal=o({},R),R.pedantic=o({},R.normal,{strong:{start:/^__|\*\*/,middle:/^__(?=\S)([\s\S]*?\S)__(?!_)|^\*\*(?=\S)([\s\S]*?\S)\*\*(?!\*)/,endAst:/\*\*(?!\*)/g,endUnd:/__(?!_)/g},em:{start:/^_|\*/,middle:/^()\*(?=\S)([\s\S]*?\S)\*(?!\*)|^_(?=\S)([\s\S]*?\S)_(?!_)/,endAst:/\*(?!\*)/g,endUnd:/_(?!_)/g},link:g(/^!?\[(label)\]\((.*?)\)/).replace("label",R._label).getRegex(),reflink:g(/^!?\[(label)\]\s*\[([^\]]*)\]/).replace("label",R._label).getRegex()}),R.gfm=o({},R.normal,{escape:g(R.escape).replace("])","~|])").getRegex(),_extended_email:/[A-Za-z0-9._+-]+(@)[a-zA-Z0-9-_]+(?:\.[a-zA-Z0-9-_]*[a-zA-Z0-9])+(?![-_])/,url:/^((?:ftp|https?):\/\/|www\.)(?:[a-zA-Z0-9\-]+\.?)+[^\s<]*|^email/,_backpedal:/(?:[^?!.,:;*_~()&]+|\([^)]*\)|&(?![a-zA-Z0-9]+;$)|[?!.,:;*_~)]+(?!$))+/,del:/^(~~?)(?=[^\s~])([\s\S]*?[^\s~])\1(?=[^~]|$)/,text:/^([`~]+|[^`~])(?:(?= {2,}\n)|(?=[a-zA-Z0-9.!#$%&'*+\/=?_`{\|}~-]+@)|[\s\S]*?(?:(?=[\\<!\[`*~_]|\b_|https?:\/\/|ftp:\/\/|www\.|$)|[^ ](?= {2,}\n)|[^a-zA-Z0-9.!#$%&'*+\/=?_`{\|}~-](?=[a-zA-Z0-9.!#$%&'*+\/=?_`{\|}~-]+@)))/}),R.gfm.url=g(R.gfm.url,"i").replace("email",R.gfm._extended_email).getRegex(),R.breaks=o({},R.gfm,{br:g(R.br).replace("{2,}","*").getRegex(),text:g(R.gfm.text).replace("\\b_","\\b_| {2,}\\n").replace(/\{2,\}/g,"*").getRegex()});function K(ke){return ke.replace(/---/g,"\u2014").replace(/--/g,"\u2013").replace(/(^|[-\u2014/(\[{"\s])'/g,"$1\u2018").replace(/'/g,"\u2019").replace(/(^|[-\u2014/(\[{\u2018\s])"/g,"$1\u201C").replace(/"/g,"\u201D").replace(/\.{3}/g,"\u2026")}function W(ke){var ye="",De,ae,ue=ke.length;for(De=0;De<ue;De++)ae=ke.charCodeAt(De),Math.random()>.5&&(ae="x"+ae.toString(16)),ye+="&#"+ae+";";return ye}var $=function(){function ke(De){this.tokens=[],this.tokens.links=Object.create(null),this.options=De||ie.defaults,this.options.tokenizer=this.options.tokenizer||new z,this.tokenizer=this.options.tokenizer,this.tokenizer.options=this.options,this.tokenizer.lexer=this,this.inlineQueue=[],this.state={inLink:!1,inRawBlock:!1,top:!0};var ae={block:L.normal,inline:R.normal};this.options.pedantic?(ae.block=L.pedantic,ae.inline=R.pedantic):this.options.gfm&&(ae.block=L.gfm,this.options.breaks?ae.inline=R.breaks:ae.inline=R.gfm),this.tokenizer.rules=ae}ke.lex=function(ae,ue){var Z=new ke(ue);return Z.lex(ae)},ke.lexInline=function(ae,ue){var Z=new ke(ue);return Z.inlineTokens(ae)};var ye=ke.prototype;return ye.lex=function(ae){ae=ae.replace(/\r\n|\r/g,`
`),this.blockTokens(ae,this.tokens);for(var ue;ue=this.inlineQueue.shift();)this.inlineTokens(ue.src,ue.tokens);return this.tokens},ye.blockTokens=function(ae,ue){var Z=this;ue===void 0&&(ue=[]),this.options.pedantic?ae=ae.replace(/\t/g,"    ").replace(/^ +$/gm,""):ae=ae.replace(/^( *)(\t+)/gm,function(se,le,Y){return le+"    ".repeat(Y.length)});for(var J,I,U,H;ae;)if(!(this.options.extensions&&this.options.extensions.block&&this.options.extensions.block.some(function(se){return(J=se.call({lexer:Z},ae,ue))?(ae=ae.substring(J.raw.length),ue.push(J),!0):!1}))){if(J=this.tokenizer.space(ae)){ae=ae.substring(J.raw.length),J.raw.length===1&&ue.length>0?ue[ue.length-1].raw+=`
`:ue.push(J);continue}if(J=this.tokenizer.code(ae)){ae=ae.substring(J.raw.length),I=ue[ue.length-1],I&&(I.type==="paragraph"||I.type==="text")?(I.raw+=`
`+J.raw,I.text+=`
`+J.text,this.inlineQueue[this.inlineQueue.length-1].src=I.text):ue.push(J);continue}if(J=this.tokenizer.fences(ae)){ae=ae.substring(J.raw.length),ue.push(J);continue}if(J=this.tokenizer.heading(ae)){ae=ae.substring(J.raw.length),ue.push(J);continue}if(J=this.tokenizer.hr(ae)){ae=ae.substring(J.raw.length),ue.push(J);continue}if(J=this.tokenizer.blockquote(ae)){ae=ae.substring(J.raw.length),ue.push(J);continue}if(J=this.tokenizer.list(ae)){ae=ae.substring(J.raw.length),ue.push(J);continue}if(J=this.tokenizer.html(ae)){ae=ae.substring(J.raw.length),ue.push(J);continue}if(J=this.tokenizer.def(ae)){ae=ae.substring(J.raw.length),I=ue[ue.length-1],I&&(I.type==="paragraph"||I.type==="text")?(I.raw+=`
`+J.raw,I.text+=`
`+J.raw,this.inlineQueue[this.inlineQueue.length-1].src=I.text):this.tokens.links[J.tag]||(this.tokens.links[J.tag]={href:J.href,title:J.title});continue}if(J=this.tokenizer.table(ae)){ae=ae.substring(J.raw.length),ue.push(J);continue}if(J=this.tokenizer.lheading(ae)){ae=ae.substring(J.raw.length),ue.push(J);continue}if(U=ae,this.options.extensions&&this.options.extensions.startBlock&&function(){var se=1/0,le=ae.slice(1),Y=void 0;Z.options.extensions.startBlock.forEach(function(ve){Y=ve.call({lexer:this},le),typeof Y=="number"&&Y>=0&&(se=Math.min(se,Y))}),se<1/0&&se>=0&&(U=ae.substring(0,se+1))}(),this.state.top&&(J=this.tokenizer.paragraph(U))){I=ue[ue.length-1],H&&I.type==="paragraph"?(I.raw+=`
`+J.raw,I.text+=`
`+J.text,this.inlineQueue.pop(),this.inlineQueue[this.inlineQueue.length-1].src=I.text):ue.push(J),H=U.length!==ae.length,ae=ae.substring(J.raw.length);continue}if(J=this.tokenizer.text(ae)){ae=ae.substring(J.raw.length),I=ue[ue.length-1],I&&I.type==="text"?(I.raw+=`
`+J.raw,I.text+=`
`+J.text,this.inlineQueue.pop(),this.inlineQueue[this.inlineQueue.length-1].src=I.text):ue.push(J);continue}if(ae){var j="Infinite loop on byte: "+ae.charCodeAt(0);if(this.options.silent){console.error(j);break}else throw new Error(j)}}return this.state.top=!0,ue},ye.inline=function(ae,ue){return ue===void 0&&(ue=[]),this.inlineQueue.push({src:ae,tokens:ue}),ue},ye.inlineTokens=function(ae,ue){var Z=this;ue===void 0&&(ue=[]);var J,I,U,H=ae,j,se,le;if(this.tokens.links){var Y=Object.keys(this.tokens.links);if(Y.length>0)for(;(j=this.tokenizer.rules.inline.reflinkSearch.exec(H))!=null;)Y.includes(j[0].slice(j[0].lastIndexOf("[")+1,-1))&&(H=H.slice(0,j.index)+"["+V("a",j[0].length-2)+"]"+H.slice(this.tokenizer.rules.inline.reflinkSearch.lastIndex))}for(;(j=this.tokenizer.rules.inline.blockSkip.exec(H))!=null;)H=H.slice(0,j.index)+"["+V("a",j[0].length-2)+"]"+H.slice(this.tokenizer.rules.inline.blockSkip.lastIndex);for(;(j=this.tokenizer.rules.inline.escapedEmSt.exec(H))!=null;)H=H.slice(0,j.index)+"++"+H.slice(this.tokenizer.rules.inline.escapedEmSt.lastIndex);for(;ae;)if(se||(le=""),se=!1,!(this.options.extensions&&this.options.extensions.inline&&this.options.extensions.inline.some(function(pe){return(J=pe.call({lexer:Z},ae,ue))?(ae=ae.substring(J.raw.length),ue.push(J),!0):!1}))){if(J=this.tokenizer.escape(ae)){ae=ae.substring(J.raw.length),ue.push(J);continue}if(J=this.tokenizer.tag(ae)){ae=ae.substring(J.raw.length),I=ue[ue.length-1],I&&J.type==="text"&&I.type==="text"?(I.raw+=J.raw,I.text+=J.text):ue.push(J);continue}if(J=this.tokenizer.link(ae)){ae=ae.substring(J.raw.length),ue.push(J);continue}if(J=this.tokenizer.reflink(ae,this.tokens.links)){ae=ae.substring(J.raw.length),I=ue[ue.length-1],I&&J.type==="text"&&I.type==="text"?(I.raw+=J.raw,I.text+=J.text):ue.push(J);continue}if(J=this.tokenizer.emStrong(ae,H,le)){ae=ae.substring(J.raw.length),ue.push(J);continue}if(J=this.tokenizer.codespan(ae)){ae=ae.substring(J.raw.length),ue.push(J);continue}if(J=this.tokenizer.br(ae)){ae=ae.substring(J.raw.length),ue.push(J);continue}if(J=this.tokenizer.del(ae)){ae=ae.substring(J.raw.length),ue.push(J);continue}if(J=this.tokenizer.autolink(ae,W)){ae=ae.substring(J.raw.length),ue.push(J);continue}if(!this.state.inLink&&(J=this.tokenizer.url(ae,W))){ae=ae.substring(J.raw.length),ue.push(J);continue}if(U=ae,this.options.extensions&&this.options.extensions.startInline&&function(){var pe=1/0,Me=ae.slice(1),xe=void 0;Z.options.extensions.startInline.forEach(function(Ye){xe=Ye.call({lexer:this},Me),typeof xe=="number"&&xe>=0&&(pe=Math.min(pe,xe))}),pe<1/0&&pe>=0&&(U=ae.substring(0,pe+1))}(),J=this.tokenizer.inlineText(U,K)){ae=ae.substring(J.raw.length),J.raw.slice(-1)!=="_"&&(le=J.raw.slice(-1)),se=!0,I=ue[ue.length-1],I&&I.type==="text"?(I.raw+=J.raw,I.text+=J.text):ue.push(J);continue}if(ae){var ve="Infinite loop on byte: "+ae.charCodeAt(0);if(this.options.silent){console.error(ve);break}else throw new Error(ve)}}return ue},r(ke,null,[{key:"rules",get:function(){return{block:L,inline:R}}}]),ke}(),G=function(){function ke(De){this.options=De||ie.defaults}var ye=ke.prototype;return ye.code=function(ae,ue,Z){var J=(ue||"").match(/\S*/)[0];if(this.options.highlight){var I=this.options.highlight(ae,J);I!=null&&I!==ae&&(Z=!0,ae=I)}return ae=ae.replace(/\n$/,"")+`
`,J?'<pre><code class="'+this.options.langPrefix+f(J,!0)+'">'+(Z?ae:f(ae,!0))+`</code></pre>
`:"<pre><code>"+(Z?ae:f(ae,!0))+`</code></pre>
`},ye.blockquote=function(ae){return`<blockquote>
`+ae+`</blockquote>
`},ye.html=function(ae){return ae},ye.heading=function(ae,ue,Z,J){if(this.options.headerIds){var I=this.options.headerPrefix+J.slug(Z);return"<h"+ue+' id="'+I+'">'+ae+"</h"+ue+`>
`}return"<h"+ue+">"+ae+"</h"+ue+`>
`},ye.hr=function(){return this.options.xhtml?`<hr/>
`:`<hr>
`},ye.list=function(ae,ue,Z){var J=ue?"ol":"ul",I=ue&&Z!==1?' start="'+Z+'"':"";return"<"+J+I+`>
`+ae+"</"+J+`>
`},ye.listitem=function(ae){return"<li>"+ae+`</li>
`},ye.checkbox=function(ae){return"<input "+(ae?'checked="" ':"")+'disabled="" type="checkbox"'+(this.options.xhtml?" /":"")+"> "},ye.paragraph=function(ae){return"<p>"+ae+`</p>
`},ye.table=function(ae,ue){return ue&&(ue="<tbody>"+ue+"</tbody>"),`<table>
<thead>
`+ae+`</thead>
`+ue+`</table>
`},ye.tablerow=function(ae){return`<tr>
`+ae+`</tr>
`},ye.tablecell=function(ae,ue){var Z=ue.header?"th":"td",J=ue.align?"<"+Z+' align="'+ue.align+'">':"<"+Z+">";return J+ae+("</"+Z+`>
`)},ye.strong=function(ae){return"<strong>"+ae+"</strong>"},ye.em=function(ae){return"<em>"+ae+"</em>"},ye.codespan=function(ae){return"<code>"+ae+"</code>"},ye.br=function(){return this.options.xhtml?"<br/>":"<br>"},ye.del=function(ae){return"<del>"+ae+"</del>"},ye.link=function(ae,ue,Z){if(ae=w(this.options.sanitize,this.options.baseUrl,ae),ae===null)return Z;var J='<a href="'+f(ae)+'"';return ue&&(J+=' title="'+ue+'"'),J+=">"+Z+"</a>",J},ye.image=function(ae,ue,Z){if(ae=w(this.options.sanitize,this.options.baseUrl,ae),ae===null)return Z;var J='<img src="'+ae+'" alt="'+Z+'"';return ue&&(J+=' title="'+ue+'"'),J+=this.options.xhtml?"/>":">",J},ye.text=function(ae){return ae},ke}(),ne=function(){function ke(){}var ye=ke.prototype;return ye.strong=function(ae){return ae},ye.em=function(ae){return ae},ye.codespan=function(ae){return ae},ye.del=function(ae){return ae},ye.html=function(ae){return ae},ye.text=function(ae){return ae},ye.link=function(ae,ue,Z){return""+Z},ye.image=function(ae,ue,Z){return""+Z},ye.br=function(){return""},ke}(),ge=function(){function ke(){this.seen={}}var ye=ke.prototype;return ye.serialize=function(ae){return ae.toLowerCase().trim().replace(/<[!\/a-z].*?>/ig,"").replace(/[\u2000-\u206F\u2E00-\u2E7F\\'!"#$%&()*+,./:;<=>?@[\]^`{|}~]/g,"").replace(/\s/g,"-")},ye.getNextSafeSlug=function(ae,ue){var Z=ae,J=0;if(this.seen.hasOwnProperty(Z)){J=this.seen[ae];do J++,Z=ae+"-"+J;while(this.seen.hasOwnProperty(Z))}return ue||(this.seen[ae]=J,this.seen[Z]=0),Z},ye.slug=function(ae,ue){ue===void 0&&(ue={});var Z=this.serialize(ae);return this.getNextSafeSlug(Z,ue.dryrun)},ke}(),oe=function(){function ke(De){this.options=De||ie.defaults,this.options.renderer=this.options.renderer||new G,this.renderer=this.options.renderer,this.renderer.options=this.options,this.textRenderer=new ne,this.slugger=new ge}ke.parse=function(ae,ue){var Z=new ke(ue);return Z.parse(ae)},ke.parseInline=function(ae,ue){var Z=new ke(ue);return Z.parseInline(ae)};var ye=ke.prototype;return ye.parse=function(ae,ue){ue===void 0&&(ue=!0);var Z="",J,I,U,H,j,se,le,Y,ve,pe,Me,xe,Ye,Ge,Te,rt,X,Q,he,Ue=ae.length;for(J=0;J<Ue;J++){if(pe=ae[J],this.options.extensions&&this.options.extensions.renderers&&this.options.extensions.renderers[pe.type]&&(he=this.options.extensions.renderers[pe.type].call({parser:this},pe),he!==!1||!["space","hr","heading","code","table","blockquote","list","html","paragraph","text"].includes(pe.type))){Z+=he||"";continue}switch(pe.type){case"space":continue;case"hr":{Z+=this.renderer.hr();continue}case"heading":{Z+=this.renderer.heading(this.parseInline(pe.tokens),pe.depth,d(this.parseInline(pe.tokens,this.textRenderer)),this.slugger);continue}case"code":{Z+=this.renderer.code(pe.text,pe.lang,pe.escaped);continue}case"table":{for(Y="",le="",H=pe.header.length,I=0;I<H;I++)le+=this.renderer.tablecell(this.parseInline(pe.header[I].tokens),{header:!0,align:pe.align[I]});for(Y+=this.renderer.tablerow(le),ve="",H=pe.rows.length,I=0;I<H;I++){for(se=pe.rows[I],le="",j=se.length,U=0;U<j;U++)le+=this.renderer.tablecell(this.parseInline(se[U].tokens),{header:!1,align:pe.align[U]});ve+=this.renderer.tablerow(le)}Z+=this.renderer.table(Y,ve);continue}case"blockquote":{ve=this.parse(pe.tokens),Z+=this.renderer.blockquote(ve);continue}case"list":{for(Me=pe.ordered,xe=pe.start,Ye=pe.loose,H=pe.items.length,ve="",I=0;I<H;I++)Te=pe.items[I],rt=Te.checked,X=Te.task,Ge="",Te.task&&(Q=this.renderer.checkbox(rt),Ye?Te.tokens.length>0&&Te.tokens[0].type==="paragraph"?(Te.tokens[0].text=Q+" "+Te.tokens[0].text,Te.tokens[0].tokens&&Te.tokens[0].tokens.length>0&&Te.tokens[0].tokens[0].type==="text"&&(Te.tokens[0].tokens[0].text=Q+" "+Te.tokens[0].tokens[0].text)):Te.tokens.unshift({type:"text",text:Q}):Ge+=Q),Ge+=this.parse(Te.tokens,Ye),ve+=this.renderer.listitem(Ge,X,rt);Z+=this.renderer.list(ve,Me,xe);continue}case"html":{Z+=this.renderer.html(pe.text);continue}case"paragraph":{Z+=this.renderer.paragraph(this.parseInline(pe.tokens));continue}case"text":{for(ve=pe.tokens?this.parseInline(pe.tokens):pe.text;J+1<Ue&&ae[J+1].type==="text";)pe=ae[++J],ve+=`
`+(pe.tokens?this.parseInline(pe.tokens):pe.text);Z+=ue?this.renderer.paragraph(ve):ve;continue}default:{var je='Token with "'+pe.type+'" type was not found.';if(this.options.silent){console.error(je);return}else throw new Error(je)}}}return Z},ye.parseInline=function(ae,ue){ue=ue||this.renderer;var Z="",J,I,U,H=ae.length;for(J=0;J<H;J++){if(I=ae[J],this.options.extensions&&this.options.extensions.renderers&&this.options.extensions.renderers[I.type]&&(U=this.options.extensions.renderers[I.type].call({parser:this},I),U!==!1||!["escape","html","link","image","strong","em","codespan","br","del","text"].includes(I.type))){Z+=U||"";continue}switch(I.type){case"escape":{Z+=ue.text(I.text);break}case"html":{Z+=ue.html(I.text);break}case"link":{Z+=ue.link(I.href,I.title,this.parseInline(I.tokens,ue));break}case"image":{Z+=ue.image(I.href,I.title,I.text);break}case"strong":{Z+=ue.strong(this.parseInline(I.tokens,ue));break}case"em":{Z+=ue.em(this.parseInline(I.tokens,ue));break}case"codespan":{Z+=ue.codespan(I.text);break}case"br":{Z+=ue.br();break}case"del":{Z+=ue.del(this.parseInline(I.tokens,ue));break}case"text":{Z+=ue.text(I.text);break}default:{var j='Token with "'+I.type+'" type was not found.';if(this.options.silent){console.error(j);return}else throw new Error(j)}}}return Z},ke}();function Ee(ke,ye,De){if(typeof ke>"u"||ke===null)throw new Error("marked(): input parameter is undefined or null");if(typeof ke!="string")throw new Error("marked(): input parameter is of type "+Object.prototype.toString.call(ke)+", string expected");if(typeof ye=="function"&&(De=ye,ye=null),ye=o({},Ee.defaults,ye||{}),N(ye),De){var ae=ye.highlight,ue;try{ue=$.lex(ke,ye)}catch(H){return De(H)}var Z=function(j){var se;if(!j)try{ye.walkTokens&&Ee.walkTokens(ue,ye.walkTokens),se=oe.parse(ue,ye)}catch(le){j=le}return ye.highlight=ae,j?De(j):De(null,se)};if(!ae||ae.length<3||(delete ye.highlight,!ue.length))return Z();var J=0;Ee.walkTokens(ue,function(H){H.type==="code"&&(J++,setTimeout(function(){ae(H.text,H.lang,function(j,se){if(j)return Z(j);se!=null&&se!==H.text&&(H.text=se,H.escaped=!0),J--,J===0&&Z()})},0))}),J===0&&Z();return}function I(H){if(H.message+=`
Please report this to https://github.com/markedjs/marked.`,ye.silent)return"<p>An error occurred:</p><pre>"+f(H.message+"",!0)+"</pre>";throw H}try{var U=$.lex(ke,ye);if(ye.walkTokens){if(ye.async)return Promise.all(Ee.walkTokens(U,ye.walkTokens)).then(function(){return oe.parse(U,ye)}).catch(I);Ee.walkTokens(U,ye.walkTokens)}return oe.parse(U,ye)}catch(H){I(H)}}Ee.options=Ee.setOptions=function(ke){return o(Ee.defaults,ke),A(Ee.defaults),Ee},Ee.getDefaults=_,Ee.defaults=ie.defaults,Ee.use=function(){for(var ke=arguments.length,ye=new Array(ke),De=0;De<ke;De++)ye[De]=arguments[De];var ae=o.apply(void 0,[{}].concat(ye)),ue=Ee.defaults.extensions||{renderers:{},childTokens:{}},Z;ye.forEach(function(J){if(J.extensions&&(Z=!0,J.extensions.forEach(function(U){if(!U.name)throw new Error("extension name required");if(U.renderer){var H=ue.renderers?ue.renderers[U.name]:null;H?ue.renderers[U.name]=function(){for(var j=arguments.length,se=new Array(j),le=0;le<j;le++)se[le]=arguments[le];var Y=U.renderer.apply(this,se);return Y===!1&&(Y=H.apply(this,se)),Y}:ue.renderers[U.name]=U.renderer}if(U.tokenizer){if(!U.level||U.level!=="block"&&U.level!=="inline")throw new Error("extension level must be 'block' or 'inline'");ue[U.level]?ue[U.level].unshift(U.tokenizer):ue[U.level]=[U.tokenizer],U.start&&(U.level==="block"?ue.startBlock?ue.startBlock.push(U.start):ue.startBlock=[U.start]:U.level==="inline"&&(ue.startInline?ue.startInline.push(U.start):ue.startInline=[U.start]))}U.childTokens&&(ue.childTokens[U.name]=U.childTokens)})),J.renderer&&function(){var U=Ee.defaults.renderer||new G,H=function(le){var Y=U[le];U[le]=function(){for(var ve=arguments.length,pe=new Array(ve),Me=0;Me<ve;Me++)pe[Me]=arguments[Me];var xe=J.renderer[le].apply(U,pe);return xe===!1&&(xe=Y.apply(U,pe)),xe}};for(var j in J.renderer)H(j);ae.renderer=U}(),J.tokenizer&&function(){var U=Ee.defaults.tokenizer||new z,H=function(le){var Y=U[le];U[le]=function(){for(var ve=arguments.length,pe=new Array(ve),Me=0;Me<ve;Me++)pe[Me]=arguments[Me];var xe=J.tokenizer[le].apply(U,pe);return xe===!1&&(xe=Y.apply(U,pe)),xe}};for(var j in J.tokenizer)H(j);ae.tokenizer=U}(),J.walkTokens){var I=Ee.defaults.walkTokens;ae.walkTokens=function(U){var H=[];return H.push(J.walkTokens.call(this,U)),I&&(H=H.concat(I.call(this,U))),H}}Z&&(ae.extensions=ue),Ee.setOptions(ae)})},Ee.walkTokens=function(ke,ye){for(var De=[],ae=function(){var I=Z.value;switch(De=De.concat(ye.call(Ee,I)),I.type){case"table":{for(var U=M(I.header),H;!(H=U()).done;){var j=H.value;De=De.concat(Ee.walkTokens(j.tokens,ye))}for(var se=M(I.rows),le;!(le=se()).done;)for(var Y=le.value,ve=M(Y),pe;!(pe=ve()).done;){var Me=pe.value;De=De.concat(Ee.walkTokens(Me.tokens,ye))}break}case"list":{De=De.concat(Ee.walkTokens(I.items,ye));break}default:Ee.defaults.extensions&&Ee.defaults.extensions.childTokens&&Ee.defaults.extensions.childTokens[I.type]?Ee.defaults.extensions.childTokens[I.type].forEach(function(xe){De=De.concat(Ee.walkTokens(I[xe],ye))}):I.tokens&&(De=De.concat(Ee.walkTokens(I.tokens,ye)))}},ue=M(ke),Z;!(Z=ue()).done;)ae();return De},Ee.parseInline=function(ke,ye){if(typeof ke>"u"||ke===null)throw new Error("marked.parseInline(): input parameter is undefined or null");if(typeof ke!="string")throw new Error("marked.parseInline(): input parameter is of type "+Object.prototype.toString.call(ke)+", string expected");ye=o({},Ee.defaults,ye||{}),N(ye);try{var De=$.lexInline(ke,ye);return ye.walkTokens&&Ee.walkTokens(De,ye.walkTokens),oe.parseInline(De,ye)}catch(ae){if(ae.message+=`
Please report this to https://github.com/markedjs/marked.`,ye.silent)return"<p>An error occurred:</p><pre>"+f(ae.message+"",!0)+"</pre>";throw ae}},Ee.Parser=oe,Ee.parser=oe.parse,Ee.Renderer=G,Ee.TextRenderer=ne,Ee.Lexer=$,Ee.lexer=$.lex,Ee.Tokenizer=z,Ee.Slugger=ge,Ee.parse=Ee;var ce=Ee.options,me=Ee.setOptions,ee=Ee.use,be=Ee.walkTokens,_e=Ee.parseInline,Fe=Ee,Be=oe.parse,Xe=$.lex;ie.Lexer=$,ie.Parser=oe,ie.Renderer=G,ie.Slugger=ge,ie.TextRenderer=ne,ie.Tokenizer=z,ie.getDefaults=_,ie.lexer=Xe,ie.marked=Ee,ie.options=ce,ie.parse=Fe,ie.parseInline=_e,ie.parser=Be,ie.setOptions=me,ie.use=ee,ie.walkTokens=be,Object.defineProperty(ie,"__esModule",{value:!0})}),define(Ce[108],Ie([1,0]),function(ie,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.SlidingWindowAverage=e.MovingAverage=e.Counter=e.rot=e.clamp=void 0;function r(A,b,P){return Math.min(Math.max(A,b),P)}e.clamp=r;function y(A,b){return(b+A%b)%b}e.rot=y;class S{constructor(){this._next=0}getNext(){return this._next++}}e.Counter=S;class M{constructor(){this._n=1,this._val=0}update(b){return this._val=this._val+(b-this._val)/this._n,this._n+=1,this._val}get value(){return this._val}}e.MovingAverage=M;class _{constructor(b){this._n=0,this._val=0,this._values=[],this._index=0,this._sum=0,this._values=new Array(b),this._values.fill(0,0,b)}update(b){const P=this._values[this._index];return this._values[this._index]=b,this._index=(this._index+1)%this._values.length,this._sum-=P,this._sum+=b,this._n<this._values.length&&(this._n+=1),this._val=this._sum/this._n,this._val}get value(){return this._val}}e.SlidingWindowAverage=_}),function(){function ie(S){const M=[];typeof S=="number"&&M.push("code/timeOrigin",S);function _(b){M.push(b,Date.now())}function A(){const b=[];for(let P=0;P<M.length;P+=2)b.push({name:M[P],startTime:M[P+1]});return b}return{mark:_,getMarks:A}}function e(){if(typeof performance=="object"&&typeof performance.mark=="function"&&!performance.nodeTiming)return typeof performance.timeOrigin!="number"&&!performance.timing?ie():{mark(S){performance.mark(S)},getMarks(){let S=performance.timeOrigin;typeof S!="number"&&(S=performance.timing.navigationStart||performance.timing.redirectStart||performance.timing.fetchStart);const M=[{name:"code/timeOrigin",startTime:Math.round(S)}];for(const _ of performance.getEntriesByType("mark"))M.push({name:_.name,startTime:Math.round(S+_.startTime)});return M}};if(typeof process=="object"){const S=Math.round((require.nodeRequire||require)("perf_hooks").performance.timeOrigin);return ie(S)}else return console.trace("perf-util loaded in UNKNOWN environment"),ie()}function r(S){return S.MonacoPerformanceMarks||(S.MonacoPerformanceMarks=e()),S.MonacoPerformanceMarks}var y;typeof global=="object"?y=global:typeof self=="object"?y=self:y={},typeof define=="function"?define("vs/base/common/performance",[],function(){return r(y)}):typeof module=="object"&&typeof module.exports=="object"?module.exports=r(y):(console.trace("perf-util defined in UNKNOWN context (neither requirejs or commonjs)"),y.perf=r(y))}(),function(ie,e){if(typeof exports=="object"&&typeof module=="object")module.exports=e();else if(typeof define=="function"&&define.amd)define("vs/base/common/semver/semver",[],e);else{var r=e();for(var y in r)(typeof exports=="object"?exports:ie)[y]=r[y]}}(typeof self<"u"?self:this,function(){return function(ie){var e={};function r(y){if(e[y])return e[y].exports;var S=e[y]={i:y,l:!1,exports:{}};return ie[y].call(S.exports,S,S.exports,r),S.l=!0,S.exports}return r.m=ie,r.c=e,r.d=function(y,S,M){r.o(y,S)||Object.defineProperty(y,S,{enumerable:!0,get:M})},r.r=function(y){typeof Symbol<"u"&&Symbol.toStringTag&&Object.defineProperty(y,Symbol.toStringTag,{value:"Module"}),Object.defineProperty(y,"__esModule",{value:!0})},r.t=function(y,S){if(1&S&&(y=r(y)),8&S||4&S&&typeof y=="object"&&y&&y.__esModule)return y;var M=Object.create(null);if(r.r(M),Object.defineProperty(M,"default",{enumerable:!0,value:y}),2&S&&typeof y!="string")for(var _ in y)r.d(M,_,function(A){return y[A]}.bind(null,_));return M},r.n=function(y){var S=y&&y.__esModule?function(){return y.default}:function(){return y};return r.d(S,"a",S),S},r.o=function(y,S){return Object.prototype.hasOwnProperty.call(y,S)},r.p="",r(r.s=0)}([function(ie,e,r){(function(y){var S;e=ie.exports=ee,S=typeof y=="object"&&y.env&&y.env.NODE_DEBUG&&/\bsemver\b/i.test(y.env.NODE_DEBUG)?function(){var Y=Array.prototype.slice.call(arguments,0);Y.unshift("SEMVER"),console.log.apply(console,Y)}:function(){},e.SEMVER_SPEC_VERSION="2.0.0";var M=256,_=Number.MAX_SAFE_INTEGER||9007199254740991,A=e.re=[],b=e.src=[],P=0,O=P++;b[O]="0|[1-9]\\d*";var E=P++;b[E]="[0-9]+";var m=P++;b[m]="\\d*[a-zA-Z-][a-zA-Z0-9-]*";var k=P++;b[k]="("+b[O]+")\\.("+b[O]+")\\.("+b[O]+")";var f=P++;b[f]="("+b[E]+")\\.("+b[E]+")\\.("+b[E]+")";var c=P++;b[c]="(?:"+b[O]+"|"+b[m]+")";var d=P++;b[d]="(?:"+b[E]+"|"+b[m]+")";var h=P++;b[h]="(?:-("+b[c]+"(?:\\."+b[c]+")*))";var g=P++;b[g]="(?:-?("+b[d]+"(?:\\."+b[d]+")*))";var C=P++;b[C]="[0-9A-Za-z-]+";var l=P++;b[l]="(?:\\+("+b[C]+"(?:\\."+b[C]+")*))";var w=P++,t="v?"+b[k]+b[h]+"?"+b[l]+"?";b[w]="^"+t+"$";var u="[v=\\s]*"+b[f]+b[g]+"?"+b[l]+"?",i=P++;b[i]="^"+u+"$";var n=P++;b[n]="((?:<|>)?=?)";var s=P++;b[s]=b[E]+"|x|X|\\*";var a=P++;b[a]=b[O]+"|x|X|\\*";var o=P++;b[o]="[v=\\s]*("+b[a]+")(?:\\.("+b[a]+")(?:\\.("+b[a]+")(?:"+b[h]+")?"+b[l]+"?)?)?";var v=P++;b[v]="[v=\\s]*("+b[s]+")(?:\\.("+b[s]+")(?:\\.("+b[s]+")(?:"+b[g]+")?"+b[l]+"?)?)?";var p=P++;b[p]="^"+b[n]+"\\s*"+b[o]+"$";var T=P++;b[T]="^"+b[n]+"\\s*"+b[v]+"$";var N=P++;b[N]="(?:^|[^\\d])(\\d{1,16})(?:\\.(\\d{1,16}))?(?:\\.(\\d{1,16}))?(?:$|[^\\d])";var V=P++;b[V]="(?:~>?)";var B=P++;b[B]="(\\s*)"+b[V]+"\\s+",A[B]=new RegExp(b[B],"g");var D=P++;b[D]="^"+b[V]+b[o]+"$";var z=P++;b[z]="^"+b[V]+b[v]+"$";var L=P++;b[L]="(?:\\^)";var R=P++;b[R]="(\\s*)"+b[L]+"\\s+",A[R]=new RegExp(b[R],"g");var K=P++;b[K]="^"+b[L]+b[o]+"$";var W=P++;b[W]="^"+b[L]+b[v]+"$";var $=P++;b[$]="^"+b[n]+"\\s*("+u+")$|^$";var G=P++;b[G]="^"+b[n]+"\\s*("+t+")$|^$";var ne=P++;b[ne]="(\\s*)"+b[n]+"\\s*("+u+"|"+b[o]+")",A[ne]=new RegExp(b[ne],"g");var ge=P++;b[ge]="^\\s*("+b[o]+")\\s+-\\s+("+b[o]+")\\s*$";var oe=P++;b[oe]="^\\s*("+b[v]+")\\s+-\\s+("+b[v]+")\\s*$";var Ee=P++;b[Ee]="(<|>)?=?\\s*\\*";for(var ce=0;ce<35;ce++)S(ce,b[ce]),A[ce]||(A[ce]=new RegExp(b[ce]));function me(Y,ve){if(Y instanceof ee)return Y;if(typeof Y!="string"||Y.length>M||!(ve?A[i]:A[w]).test(Y))return null;try{return new ee(Y,ve)}catch{return null}}function ee(Y,ve){if(Y instanceof ee){if(Y.loose===ve)return Y;Y=Y.version}else if(typeof Y!="string")throw new TypeError("Invalid Version: "+Y);if(Y.length>M)throw new TypeError("version is longer than "+M+" characters");if(!(this instanceof ee))return new ee(Y,ve);S("SemVer",Y,ve),this.loose=ve;var pe=Y.trim().match(ve?A[i]:A[w]);if(!pe)throw new TypeError("Invalid Version: "+Y);if(this.raw=Y,this.major=+pe[1],this.minor=+pe[2],this.patch=+pe[3],this.major>_||this.major<0)throw new TypeError("Invalid major version");if(this.minor>_||this.minor<0)throw new TypeError("Invalid minor version");if(this.patch>_||this.patch<0)throw new TypeError("Invalid patch version");pe[4]?this.prerelease=pe[4].split(".").map(function(Me){if(/^[0-9]+$/.test(Me)){var xe=+Me;if(xe>=0&&xe<_)return xe}return Me}):this.prerelease=[],this.build=pe[5]?pe[5].split("."):[],this.format()}e.parse=me,e.valid=function(Y,ve){var pe=me(Y,ve);return pe?pe.version:null},e.clean=function(Y,ve){var pe=me(Y.trim().replace(/^[=v]+/,""),ve);return pe?pe.version:null},e.SemVer=ee,ee.prototype.format=function(){return this.version=this.major+"."+this.minor+"."+this.patch,this.prerelease.length&&(this.version+="-"+this.prerelease.join(".")),this.version},ee.prototype.toString=function(){return this.version},ee.prototype.compare=function(Y){return S("SemVer.compare",this.version,this.loose,Y),Y instanceof ee||(Y=new ee(Y,this.loose)),this.compareMain(Y)||this.comparePre(Y)},ee.prototype.compareMain=function(Y){return Y instanceof ee||(Y=new ee(Y,this.loose)),_e(this.major,Y.major)||_e(this.minor,Y.minor)||_e(this.patch,Y.patch)},ee.prototype.comparePre=function(Y){if(Y instanceof ee||(Y=new ee(Y,this.loose)),this.prerelease.length&&!Y.prerelease.length)return-1;if(!this.prerelease.length&&Y.prerelease.length)return 1;if(!this.prerelease.length&&!Y.prerelease.length)return 0;var ve=0;do{var pe=this.prerelease[ve],Me=Y.prerelease[ve];if(S("prerelease compare",ve,pe,Me),pe===void 0&&Me===void 0)return 0;if(Me===void 0)return 1;if(pe===void 0)return-1;if(pe!==Me)return _e(pe,Me)}while(++ve)},ee.prototype.inc=function(Y,ve){switch(Y){case"premajor":this.prerelease.length=0,this.patch=0,this.minor=0,this.major++,this.inc("pre",ve);break;case"preminor":this.prerelease.length=0,this.patch=0,this.minor++,this.inc("pre",ve);break;case"prepatch":this.prerelease.length=0,this.inc("patch",ve),this.inc("pre",ve);break;case"prerelease":this.prerelease.length===0&&this.inc("patch",ve),this.inc("pre",ve);break;case"major":this.minor===0&&this.patch===0&&this.prerelease.length!==0||this.major++,this.minor=0,this.patch=0,this.prerelease=[];break;case"minor":this.patch===0&&this.prerelease.length!==0||this.minor++,this.patch=0,this.prerelease=[];break;case"patch":this.prerelease.length===0&&this.patch++,this.prerelease=[];break;case"pre":if(this.prerelease.length===0)this.prerelease=[0];else{for(var pe=this.prerelease.length;--pe>=0;)typeof this.prerelease[pe]=="number"&&(this.prerelease[pe]++,pe=-2);pe===-1&&this.prerelease.push(0)}ve&&(this.prerelease[0]===ve?isNaN(this.prerelease[1])&&(this.prerelease=[ve,0]):this.prerelease=[ve,0]);break;default:throw new Error("invalid increment argument: "+Y)}return this.format(),this.raw=this.version,this},e.inc=function(Y,ve,pe,Me){typeof pe=="string"&&(Me=pe,pe=void 0);try{return new ee(Y,pe).inc(ve,Me).version}catch{return null}},e.diff=function(Y,ve){if(ke(Y,ve))return null;var pe=me(Y),Me=me(ve);if(pe.prerelease.length||Me.prerelease.length){for(var xe in pe)if((xe==="major"||xe==="minor"||xe==="patch")&&pe[xe]!==Me[xe])return"pre"+xe;return"prerelease"}for(var xe in pe)if((xe==="major"||xe==="minor"||xe==="patch")&&pe[xe]!==Me[xe])return xe},e.compareIdentifiers=_e;var be=/^[0-9]+$/;function _e(Y,ve){var pe=be.test(Y),Me=be.test(ve);return pe&&Me&&(Y=+Y,ve=+ve),pe&&!Me?-1:Me&&!pe?1:Y<ve?-1:Y>ve?1:0}function Fe(Y,ve,pe){return new ee(Y,pe).compare(new ee(ve,pe))}function Be(Y,ve,pe){return Fe(Y,ve,pe)>0}function Xe(Y,ve,pe){return Fe(Y,ve,pe)<0}function ke(Y,ve,pe){return Fe(Y,ve,pe)===0}function ye(Y,ve,pe){return Fe(Y,ve,pe)!==0}function De(Y,ve,pe){return Fe(Y,ve,pe)>=0}function ae(Y,ve,pe){return Fe(Y,ve,pe)<=0}function ue(Y,ve,pe,Me){var xe;switch(ve){case"===":typeof Y=="object"&&(Y=Y.version),typeof pe=="object"&&(pe=pe.version),xe=Y===pe;break;case"!==":typeof Y=="object"&&(Y=Y.version),typeof pe=="object"&&(pe=pe.version),xe=Y!==pe;break;case"":case"=":case"==":xe=ke(Y,pe,Me);break;case"!=":xe=ye(Y,pe,Me);break;case">":xe=Be(Y,pe,Me);break;case">=":xe=De(Y,pe,Me);break;case"<":xe=Xe(Y,pe,Me);break;case"<=":xe=ae(Y,pe,Me);break;default:throw new TypeError("Invalid operator: "+ve)}return xe}function Z(Y,ve){if(Y instanceof Z){if(Y.loose===ve)return Y;Y=Y.value}if(!(this instanceof Z))return new Z(Y,ve);S("comparator",Y,ve),this.loose=ve,this.parse(Y),this.semver===J?this.value="":this.value=this.operator+this.semver.version,S("comp",this)}e.rcompareIdentifiers=function(Y,ve){return _e(ve,Y)},e.major=function(Y,ve){return new ee(Y,ve).major},e.minor=function(Y,ve){return new ee(Y,ve).minor},e.patch=function(Y,ve){return new ee(Y,ve).patch},e.compare=Fe,e.compareLoose=function(Y,ve){return Fe(Y,ve,!0)},e.rcompare=function(Y,ve,pe){return Fe(ve,Y,pe)},e.sort=function(Y,ve){return Y.sort(function(pe,Me){return e.compare(pe,Me,ve)})},e.rsort=function(Y,ve){return Y.sort(function(pe,Me){return e.rcompare(pe,Me,ve)})},e.gt=Be,e.lt=Xe,e.eq=ke,e.neq=ye,e.gte=De,e.lte=ae,e.cmp=ue,e.Comparator=Z;var J={};function I(Y,ve){if(Y instanceof I)return Y.loose===ve?Y:new I(Y.raw,ve);if(Y instanceof Z)return new I(Y.value,ve);if(!(this instanceof I))return new I(Y,ve);if(this.loose=ve,this.raw=Y,this.set=Y.split(/\s*\|\|\s*/).map(function(pe){return this.parseRange(pe.trim())},this).filter(function(pe){return pe.length}),!this.set.length)throw new TypeError("Invalid SemVer Range: "+Y);this.format()}function U(Y){return!Y||Y.toLowerCase()==="x"||Y==="*"}function H(Y,ve,pe,Me,xe,Ye,Ge,Te,rt,X,Q,he,Ue){return((ve=U(pe)?"":U(Me)?">="+pe+".0.0":U(xe)?">="+pe+"."+Me+".0":">="+ve)+" "+(Te=U(rt)?"":U(X)?"<"+(+rt+1)+".0.0":U(Q)?"<"+rt+"."+(+X+1)+".0":he?"<="+rt+"."+X+"."+Q+"-"+he:"<="+Te)).trim()}function j(Y,ve){for(var pe=0;pe<Y.length;pe++)if(!Y[pe].test(ve))return!1;if(ve.prerelease.length){for(pe=0;pe<Y.length;pe++)if(S(Y[pe].semver),Y[pe].semver!==J&&Y[pe].semver.prerelease.length>0){var Me=Y[pe].semver;if(Me.major===ve.major&&Me.minor===ve.minor&&Me.patch===ve.patch)return!0}return!1}return!0}function se(Y,ve,pe){try{ve=new I(ve,pe)}catch{return!1}return ve.test(Y)}function le(Y,ve,pe,Me){var xe,Ye,Ge,Te,rt;switch(Y=new ee(Y,Me),ve=new I(ve,Me),pe){case">":xe=Be,Ye=ae,Ge=Xe,Te=">",rt=">=";break;case"<":xe=Xe,Ye=De,Ge=Be,Te="<",rt="<=";break;default:throw new TypeError('Must provide a hilo val of "<" or ">"')}if(se(Y,ve,Me))return!1;for(var X=0;X<ve.set.length;++X){var Q=ve.set[X],he=null,Ue=null;if(Q.forEach(function(je){je.semver===J&&(je=new Z(">=0.0.0")),he=he||je,Ue=Ue||je,xe(je.semver,he.semver,Me)?he=je:Ge(je.semver,Ue.semver,Me)&&(Ue=je)}),he.operator===Te||he.operator===rt||(!Ue.operator||Ue.operator===Te)&&Ye(Y,Ue.semver)||Ue.operator===rt&&Ge(Y,Ue.semver))return!1}return!0}Z.prototype.parse=function(Y){var ve=this.loose?A[$]:A[G],pe=Y.match(ve);if(!pe)throw new TypeError("Invalid comparator: "+Y);this.operator=pe[1],this.operator==="="&&(this.operator=""),pe[2]?this.semver=new ee(pe[2],this.loose):this.semver=J},Z.prototype.toString=function(){return this.value},Z.prototype.test=function(Y){return S("Comparator.test",Y,this.loose),this.semver===J||(typeof Y=="string"&&(Y=new ee(Y,this.loose)),ue(Y,this.operator,this.semver,this.loose))},Z.prototype.intersects=function(Y,ve){if(!(Y instanceof Z))throw new TypeError("a Comparator is required");var pe;if(this.operator==="")return pe=new I(Y.value,ve),se(this.value,pe,ve);if(Y.operator==="")return pe=new I(this.value,ve),se(Y.semver,pe,ve);var Me=!(this.operator!==">="&&this.operator!==">"||Y.operator!==">="&&Y.operator!==">"),xe=!(this.operator!=="<="&&this.operator!=="<"||Y.operator!=="<="&&Y.operator!=="<"),Ye=this.semver.version===Y.semver.version,Ge=!(this.operator!==">="&&this.operator!=="<="||Y.operator!==">="&&Y.operator!=="<="),Te=ue(this.semver,"<",Y.semver,ve)&&(this.operator===">="||this.operator===">")&&(Y.operator==="<="||Y.operator==="<"),rt=ue(this.semver,">",Y.semver,ve)&&(this.operator==="<="||this.operator==="<")&&(Y.operator===">="||Y.operator===">");return Me||xe||Ye&&Ge||Te||rt},e.Range=I,I.prototype.format=function(){return this.range=this.set.map(function(Y){return Y.join(" ").trim()}).join("||").trim(),this.range},I.prototype.toString=function(){return this.range},I.prototype.parseRange=function(Y){var ve=this.loose;Y=Y.trim(),S("range",Y,ve);var pe=ve?A[oe]:A[ge];Y=Y.replace(pe,H),S("hyphen replace",Y),Y=Y.replace(A[ne],"$1$2$3"),S("comparator trim",Y,A[ne]),Y=(Y=(Y=Y.replace(A[B],"$1~")).replace(A[R],"$1^")).split(/\s+/).join(" ");var Me=ve?A[$]:A[G],xe=Y.split(" ").map(function(Ye){return function(Ge,Te){return S("comp",Ge),Ge=function(rt,X){return rt.trim().split(/\s+/).map(function(Q){return function(he,Ue){S("caret",he,Ue);var je=Ue?A[W]:A[K];return he.replace(je,function(Ze,Ke,Ve,it,st){var dt;return S("caret",he,Ze,Ke,Ve,it,st),U(Ke)?dt="":U(Ve)?dt=">="+Ke+".0.0 <"+(+Ke+1)+".0.0":U(it)?dt=Ke==="0"?">="+Ke+"."+Ve+".0 <"+Ke+"."+(+Ve+1)+".0":">="+Ke+"."+Ve+".0 <"+(+Ke+1)+".0.0":st?(S("replaceCaret pr",st),st.charAt(0)!=="-"&&(st="-"+st),dt=Ke==="0"?Ve==="0"?">="+Ke+"."+Ve+"."+it+st+" <"+Ke+"."+Ve+"."+(+it+1):">="+Ke+"."+Ve+"."+it+st+" <"+Ke+"."+(+Ve+1)+".0":">="+Ke+"."+Ve+"."+it+st+" <"+(+Ke+1)+".0.0"):(S("no pr"),dt=Ke==="0"?Ve==="0"?">="+Ke+"."+Ve+"."+it+" <"+Ke+"."+Ve+"."+(+it+1):">="+Ke+"."+Ve+"."+it+" <"+Ke+"."+(+Ve+1)+".0":">="+Ke+"."+Ve+"."+it+" <"+(+Ke+1)+".0.0"),S("caret return",dt),dt})}(Q,X)}).join(" ")}(Ge,Te),S("caret",Ge),Ge=function(rt,X){return rt.trim().split(/\s+/).map(function(Q){return function(he,Ue){var je=Ue?A[z]:A[D];return he.replace(je,function(Ze,Ke,Ve,it,st){var dt;return S("tilde",he,Ze,Ke,Ve,it,st),U(Ke)?dt="":U(Ve)?dt=">="+Ke+".0.0 <"+(+Ke+1)+".0.0":U(it)?dt=">="+Ke+"."+Ve+".0 <"+Ke+"."+(+Ve+1)+".0":st?(S("replaceTilde pr",st),st.charAt(0)!=="-"&&(st="-"+st),dt=">="+Ke+"."+Ve+"."+it+st+" <"+Ke+"."+(+Ve+1)+".0"):dt=">="+Ke+"."+Ve+"."+it+" <"+Ke+"."+(+Ve+1)+".0",S("tilde return",dt),dt})}(Q,X)}).join(" ")}(Ge,Te),S("tildes",Ge),Ge=function(rt,X){return S("replaceXRanges",rt,X),rt.split(/\s+/).map(function(Q){return function(he,Ue){he=he.trim();var je=Ue?A[T]:A[p];return he.replace(je,function(Ze,Ke,Ve,it,st,dt){S("xRange",he,Ze,Ke,Ve,it,st,dt);var yt=U(Ve),et=yt||U(it),ut=et||U(st);return Ke==="="&&ut&&(Ke=""),yt?Ze=Ke===">"||Ke==="<"?"<0.0.0":"*":Ke&&ut?(et&&(it=0),ut&&(st=0),Ke===">"?(Ke=">=",et?(Ve=+Ve+1,it=0,st=0):ut&&(it=+it+1,st=0)):Ke==="<="&&(Ke="<",et?Ve=+Ve+1:it=+it+1),Ze=Ke+Ve+"."+it+"."+st):et?Ze=">="+Ve+".0.0 <"+(+Ve+1)+".0.0":ut&&(Ze=">="+Ve+"."+it+".0 <"+Ve+"."+(+it+1)+".0"),S("xRange return",Ze),Ze})}(Q,X)}).join(" ")}(Ge,Te),S("xrange",Ge),Ge=function(rt,X){return S("replaceStars",rt,X),rt.trim().replace(A[Ee],"")}(Ge,Te),S("stars",Ge),Ge}(Ye,ve)}).join(" ").split(/\s+/);return this.loose&&(xe=xe.filter(function(Ye){return!!Ye.match(Me)})),xe=xe.map(function(Ye){return new Z(Ye,ve)})},I.prototype.intersects=function(Y,ve){if(!(Y instanceof I))throw new TypeError("a Range is required");return this.set.some(function(pe){return pe.every(function(Me){return Y.set.some(function(xe){return xe.every(function(Ye){return Me.intersects(Ye,ve)})})})})},e.toComparators=function(Y,ve){return new I(Y,ve).set.map(function(pe){return pe.map(function(Me){return Me.value}).join(" ").trim().split(" ")})},I.prototype.test=function(Y){if(!Y)return!1;typeof Y=="string"&&(Y=new ee(Y,this.loose));for(var ve=0;ve<this.set.length;ve++)if(j(this.set[ve],Y))return!0;return!1},e.satisfies=se,e.maxSatisfying=function(Y,ve,pe){var Me=null,xe=null;try{var Ye=new I(ve,pe)}catch{return null}return Y.forEach(function(Ge){Ye.test(Ge)&&(Me&&xe.compare(Ge)!==-1||(xe=new ee(Me=Ge,pe)))}),Me},e.minSatisfying=function(Y,ve,pe){var Me=null,xe=null;try{var Ye=new I(ve,pe)}catch{return null}return Y.forEach(function(Ge){Ye.test(Ge)&&(Me&&xe.compare(Ge)!==1||(xe=new ee(Me=Ge,pe)))}),Me},e.validRange=function(Y,ve){try{return new I(Y,ve).range||"*"}catch{return null}},e.ltr=function(Y,ve,pe){return le(Y,ve,"<",pe)},e.gtr=function(Y,ve,pe){return le(Y,ve,">",pe)},e.outside=le,e.prerelease=function(Y,ve){var pe=me(Y,ve);return pe&&pe.prerelease.length?pe.prerelease:null},e.intersects=function(Y,ve,pe){return Y=new I(Y,pe),ve=new I(ve,pe),Y.intersects(ve)},e.coerce=function(Y){if(Y instanceof ee)return Y;if(typeof Y!="string")return null;var ve=Y.match(A[N]);return ve==null?null:me((ve[1]||"0")+"."+(ve[2]||"0")+"."+(ve[3]||"0"))}}).call(this,r(1))},function(ie,e){var r,y,S=ie.exports={};function M(){throw new Error("setTimeout has not been defined")}function _(){throw new Error("clearTimeout has not been defined")}function A(d){if(r===setTimeout)return setTimeout(d,0);if((r===M||!r)&&setTimeout)return r=setTimeout,setTimeout(d,0);try{return r(d,0)}catch{try{return r.call(null,d,0)}catch{return r.call(this,d,0)}}}(function(){try{r=typeof setTimeout=="function"?setTimeout:M}catch{r=M}try{y=typeof clearTimeout=="function"?clearTimeout:_}catch{y=_}})();var b,P=[],O=!1,E=-1;function m(){O&&b&&(O=!1,b.length?P=b.concat(P):E=-1,P.length&&k())}function k(){if(!O){var d=A(m);O=!0;for(var h=P.length;h;){for(b=P,P=[];++E<h;)b&&b[E].run();E=-1,h=P.length}b=null,O=!1,function(g){if(y===clearTimeout)return clearTimeout(g);if((y===_||!y)&&clearTimeout)return y=clearTimeout,clearTimeout(g);try{y(g)}catch{try{return y.call(null,g)}catch{return y.call(this,g)}}}(d)}}function f(d,h){this.fun=d,this.array=h}function c(){}S.nextTick=function(d){var h=new Array(arguments.length-1);if(arguments.length>1)for(var g=1;g<arguments.length;g++)h[g-1]=arguments[g];P.push(new f(d,h)),P.length!==1||O||A(k)},f.prototype.run=function(){this.fun.apply(null,this.array)},S.title="browser",S.browser=!0,S.env={},S.argv=[],S.version="",S.versions={},S.on=c,S.addListener=c,S.once=c,S.off=c,S.removeListener=c,S.removeAllListeners=c,S.emit=c,S.prependListener=c,S.prependOnceListener=c,S.listeners=function(d){return[]},S.binding=function(d){throw new Error("process.binding is not supported")},S.cwd=function(){return"/"},S.chdir=function(d){throw new Error("process.chdir is not supported")},S.umask=function(){return 0}}])}),define(Ce[109],Ie([1,0,12,7]),function(ie,e,r,y){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.prefixedStream=e.prefixedReadable=e.transform=e.toReadable=e.emptyStream=e.toStream=e.peekStream=e.listenStream=e.consumeStream=e.peekReadable=e.consumeReadable=e.newWriteableStream=e.isReadableBufferedStream=e.isReadableStream=e.isReadable=void 0;function S(l){const w=l;return w?typeof w.read=="function":!1}e.isReadable=S;function M(l){const w=l;return w?[w.on,w.pause,w.resume,w.destroy].every(t=>typeof t=="function"):!1}e.isReadableStream=M;function _(l){const w=l;return w?M(w.stream)&&Array.isArray(w.buffer)&&typeof w.ended=="boolean":!1}e.isReadableBufferedStream=_;function A(l,w){return new b(l,w)}e.newWriteableStream=A;class b{constructor(w,t){this.reducer=w,this.options=t,this.state={flowing:!1,ended:!1,destroyed:!1},this.buffer={data:[],error:[]},this.listeners={data:[],error:[],end:[]},this.pendingWritePromises=[]}pause(){this.state.destroyed||(this.state.flowing=!1)}resume(){this.state.destroyed||this.state.flowing||(this.state.flowing=!0,this.flowData(),this.flowErrors(),this.flowEnd())}write(w){if(!this.state.destroyed){if(this.state.flowing)this.emitData(w);else if(this.buffer.data.push(w),typeof this.options?.highWaterMark=="number"&&this.buffer.data.length>this.options.highWaterMark)return new Promise(t=>this.pendingWritePromises.push(t))}}error(w){this.state.destroyed||(this.state.flowing?this.emitError(w):this.buffer.error.push(w))}end(w){this.state.destroyed||(typeof w<"u"&&this.write(w),this.state.flowing?(this.emitEnd(),this.destroy()):this.state.ended=!0)}emitData(w){this.listeners.data.slice(0).forEach(t=>t(w))}emitError(w){this.listeners.error.length===0?(0,r.onUnexpectedError)(w):this.listeners.error.slice(0).forEach(t=>t(w))}emitEnd(){this.listeners.end.slice(0).forEach(w=>w())}on(w,t){if(!this.state.destroyed)switch(w){case"data":this.listeners.data.push(t),this.resume();break;case"end":this.listeners.end.push(t),this.state.flowing&&this.flowEnd()&&this.destroy();break;case"error":this.listeners.error.push(t),this.state.flowing&&this.flowErrors();break}}removeListener(w,t){if(this.state.destroyed)return;let u;switch(w){case"data":u=this.listeners.data;break;case"end":u=this.listeners.end;break;case"error":u=this.listeners.error;break}if(u){const i=u.indexOf(t);i>=0&&u.splice(i,1)}}flowData(){if(this.buffer.data.length>0){const w=this.reducer(this.buffer.data);this.emitData(w),this.buffer.data.length=0;const t=[...this.pendingWritePromises];this.pendingWritePromises.length=0,t.forEach(u=>u())}}flowErrors(){if(this.listeners.error.length>0){for(const w of this.buffer.error)this.emitError(w);this.buffer.error.length=0}}flowEnd(){return this.state.ended?(this.emitEnd(),this.listeners.end.length>0):!1}destroy(){this.state.destroyed||(this.state.destroyed=!0,this.state.ended=!0,this.buffer.data.length=0,this.buffer.error.length=0,this.listeners.data.length=0,this.listeners.error.length=0,this.listeners.end.length=0,this.pendingWritePromises.length=0)}}function P(l,w){const t=[];let u;for(;(u=l.read())!==null;)t.push(u);return w(t)}e.consumeReadable=P;function O(l,w,t){const u=[];let i;for(;(i=l.read())!==null&&u.length<t;)u.push(i);return i===null&&u.length>0?w(u):{read:()=>{if(u.length>0)return u.shift();if(typeof i<"u"){const n=i;return i=void 0,n}return l.read()}}}e.peekReadable=O;function E(l,w){return new Promise((t,u)=>{const i=[];m(l,{onData:n=>{w&&i.push(n)},onError:n=>{w?u(n):t(void 0)},onEnd:()=>{t(w?w(i):void 0)}})})}e.consumeStream=E;function m(l,w){let t=!1;return l.on("error",u=>{t||w.onError(u)}),l.on("end",()=>{t||w.onEnd()}),l.on("data",u=>{t||w.onData(u)}),(0,y.toDisposable)(()=>t=!0)}e.listenStream=m;function k(l,w){return new Promise((t,u)=>{const i=new y.DisposableStore,n=[],s=v=>{if(n.push(v),n.length>w)return i.dispose(),l.pause(),t({stream:l,buffer:n,ended:!1})},a=v=>u(v),o=()=>t({stream:l,buffer:n,ended:!0});i.add((0,y.toDisposable)(()=>l.removeListener("error",a))),l.on("error",a),i.add((0,y.toDisposable)(()=>l.removeListener("end",o))),l.on("end",o),i.add((0,y.toDisposable)(()=>l.removeListener("data",s))),l.on("data",s)})}e.peekStream=k;function f(l,w){const t=A(w);return t.end(l),t}e.toStream=f;function c(){const l=A(()=>{throw new Error("not supported")});return l.end(),l}e.emptyStream=c;function d(l){let w=!1;return{read:()=>w?null:(w=!0,l)}}e.toReadable=d;function h(l,w,t){const u=A(t);return m(l,{onData:i=>u.write(w.data(i)),onError:i=>u.error(w.error?w.error(i):i),onEnd:()=>u.end()}),u}e.transform=h;function g(l,w,t){let u=!1;return{read:()=>{const i=w.read();return u?i:(u=!0,i!==null?t([l,i]):l)}}}e.prefixedReadable=g;function C(l,w,t){let u=!1;const i=A(t);return m(w,{onData:n=>u?i.write(n):(u=!0,i.write(t([l,n]))),onError:n=>i.error(n),onEnd:()=>{u||(u=!0,i.write(l)),i.end()}}),i}e.prefixedStream=C}),define(Ce[23],Ie([1,0,109]),function(ie,e,r){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.encodeBase64=e.decodeBase64=e.prefixedBufferStream=e.prefixedBufferReadable=e.newWriteableBufferStream=e.streamToBufferReadableStream=e.bufferToStream=e.bufferedStreamToBuffer=e.streamToBuffer=e.bufferToReadable=e.readableToBuffer=e.writeUInt8=e.readUInt8=e.writeUInt32LE=e.readUInt32LE=e.writeUInt32BE=e.readUInt32BE=e.writeUInt16LE=e.readUInt16LE=e.VSBuffer=void 0;const y=typeof Buffer<"u";let S,M;class _{static alloc(v){return y?new _(Buffer.allocUnsafe(v)):new _(new Uint8Array(v))}static wrap(v){return y&&!Buffer.isBuffer(v)&&(v=Buffer.from(v.buffer,v.byteOffset,v.byteLength)),new _(v)}static fromString(v,p){return!(p?.dontUseNodeBuffer||!1)&&y?new _(Buffer.from(v)):(S||(S=new TextEncoder),new _(S.encode(v)))}static fromByteArray(v){const p=_.alloc(v.length);for(let T=0,N=v.length;T<N;T++)p.buffer[T]=v[T];return p}static concat(v,p){if(typeof p>"u"){p=0;for(let V=0,B=v.length;V<B;V++)p+=v[V].byteLength}const T=_.alloc(p);let N=0;for(let V=0,B=v.length;V<B;V++){const D=v[V];T.set(D,N),N+=D.byteLength}return T}constructor(v){this.buffer=v,this.byteLength=this.buffer.byteLength}clone(){const v=_.alloc(this.byteLength);return v.set(this),v}toString(){return y?this.buffer.toString():(M||(M=new TextDecoder),M.decode(this.buffer))}slice(v,p){return new _(this.buffer.subarray(v,p))}set(v,p){if(v instanceof _)this.buffer.set(v.buffer,p);else if(v instanceof Uint8Array)this.buffer.set(v,p);else if(v instanceof ArrayBuffer)this.buffer.set(new Uint8Array(v),p);else if(ArrayBuffer.isView(v))this.buffer.set(new Uint8Array(v.buffer,v.byteOffset,v.byteLength),p);else throw new Error("Unknown argument 'array'")}readUInt32BE(v){return P(this.buffer,v)}writeUInt32BE(v,p){O(this.buffer,v,p)}readUInt32LE(v){return E(this.buffer,v)}writeUInt32LE(v,p){m(this.buffer,v,p)}readUInt8(v){return k(this.buffer,v)}writeUInt8(v,p){f(this.buffer,v,p)}}e.VSBuffer=_;function A(o,v){return o[v+0]<<0>>>0|o[v+1]<<8>>>0}e.readUInt16LE=A;function b(o,v,p){o[p+0]=v&255,v=v>>>8,o[p+1]=v&255}e.writeUInt16LE=b;function P(o,v){return o[v]*2**24+o[v+1]*2**16+o[v+2]*2**8+o[v+3]}e.readUInt32BE=P;function O(o,v,p){o[p+3]=v,v=v>>>8,o[p+2]=v,v=v>>>8,o[p+1]=v,v=v>>>8,o[p]=v}e.writeUInt32BE=O;function E(o,v){return o[v+0]<<0>>>0|o[v+1]<<8>>>0|o[v+2]<<16>>>0|o[v+3]<<24>>>0}e.readUInt32LE=E;function m(o,v,p){o[p+0]=v&255,v=v>>>8,o[p+1]=v&255,v=v>>>8,o[p+2]=v&255,v=v>>>8,o[p+3]=v&255}e.writeUInt32LE=m;function k(o,v){return o[v]}e.readUInt8=k;function f(o,v,p){o[p]=v}e.writeUInt8=f;function c(o){return r.consumeReadable(o,v=>_.concat(v))}e.readableToBuffer=c;function d(o){return r.toReadable(o)}e.bufferToReadable=d;function h(o){return r.consumeStream(o,v=>_.concat(v))}e.streamToBuffer=h;async function g(o){return o.ended?_.concat(o.buffer):_.concat([...o.buffer,await h(o.stream)])}e.bufferedStreamToBuffer=g;function C(o){return r.toStream(o,v=>_.concat(v))}e.bufferToStream=C;function l(o){return r.transform(o,{data:v=>typeof v=="string"?_.fromString(v):_.wrap(v)},v=>_.concat(v))}e.streamToBufferReadableStream=l;function w(o){return r.newWriteableStream(v=>_.concat(v),o)}e.newWriteableBufferStream=w;function t(o,v){return r.prefixedReadable(o,v,p=>_.concat(p))}e.prefixedBufferReadable=t;function u(o,v){return r.prefixedStream(o,v,p=>_.concat(p))}e.prefixedBufferStream=u;function i(o){let v=0,p=0,T=0;const N=new Uint8Array(Math.floor(o.length/4*3)),V=D=>{switch(p){case 3:N[T++]=v|D,p=0;break;case 2:N[T++]=v|D>>>2,v=D<<6,p=3;break;case 1:N[T++]=v|D>>>4,v=D<<4,p=2;break;default:v=D<<2,p=1}};for(let D=0;D<o.length;D++){const z=o.charCodeAt(D);if(z>=65&&z<=90)V(z-65);else if(z>=97&&z<=122)V(z-97+26);else if(z>=48&&z<=57)V(z-48+52);else if(z===43||z===45)V(62);else if(z===47||z===95)V(63);else{if(z===61)break;throw new SyntaxError(`Unexpected base64 character ${o[D]}`)}}const B=T;for(;p>0;)V(0);return _.wrap(N).slice(0,B)}e.decodeBase64=i;const n="ABCDEFGHIJKLMNOPQRSTUVWXYZabcdefghijklmnopqrstuvwxyz0123456789+/",s="ABCDEFGHIJKLMNOPQRSTUVWXYZabcdefghijklmnopqrstuvwxyz0123456789-_";function a({buffer:o},v=!0,p=!1){const T=p?s:n;let N="";const V=o.byteLength%3;let B=0;for(;B<o.byteLength-V;B+=3){const D=o[B+0],z=o[B+1],L=o[B+2];N+=T[D>>>2],N+=T[(D<<4|z>>>4)&63],N+=T[(z<<2|L>>>6)&63],N+=T[L&63]}if(V===1){const D=o[B+0];N+=T[D>>>2],N+=T[D<<4&63],v&&(N+="==")}else if(V===2){const D=o[B+0],z=o[B+1];N+=T[D>>>2],N+=T[(D<<4|z>>>4)&63],N+=T[z<<2&63],v&&(N+="=")}return N}e.encodeBase64=a}),define(Ce[42],Ie([1,0]),function(ie,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.generateUuid=e.isUUID=void 0;const r=/^[0-9a-f]{8}-[0-9a-f]{4}-[0-9a-f]{4}-[0-9a-f]{4}-[0-9a-f]{12}$/i;function y(S){return r.test(S)}e.isUUID=y,e.generateUuid=function(){if(typeof crypto=="object"&&typeof crypto.randomUUID=="function")return crypto.randomUUID.bind(crypto);let S;typeof crypto=="object"&&typeof crypto.getRandomValues=="function"?S=crypto.getRandomValues.bind(crypto):S=function(A){for(let b=0;b<A.length;b++)A[b]=Math.floor(Math.random()*256);return A};const M=new Uint8Array(16),_=[];for(let A=0;A<256;A++)_.push(A.toString(16).padStart(2,"0"));return function(){S(M),M[6]=M[6]&15|64,M[8]=M[8]&63|128;let b=0,P="";return P+=_[M[b++]],P+=_[M[b++]],P+=_[M[b++]],P+=_[M[b++]],P+="-",P+=_[M[b++]],P+=_[M[b++]],P+="-",P+=_[M[b++]],P+=_[M[b++]],P+="-",P+=_[M[b++]],P+=_[M[b++]],P+="-",P+=_[M[b++]],P+=_[M[b++]],P+=_[M[b++]],P+=_[M[b++]],P+=_[M[b++]],P+=_[M[b++]],P}}()}),define(Ce[110],Ie([1,0]),function(ie,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.EDITOR_MODEL_DEFAULTS=void 0,e.EDITOR_MODEL_DEFAULTS={tabSize:4,indentSize:4,insertSpaces:!0,detectIndentation:!0,trimAutoWhitespace:!0,largeFileOptimizations:!0,bracketPairColorizationOptions:{enabled:!0,independentColorPoolPerBracketType:!1}}}),define(Ce[111],Ie([1,0]),function(ie,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.AutoClosingPairs=e.StandardAutoClosingPairConditional=e.IndentAction=void 0;var r;(function(_){_[_.None=0]="None",_[_.Indent=1]="Indent",_[_.IndentOutdent=2]="IndentOutdent",_[_.Outdent=3]="Outdent"})(r=e.IndentAction||(e.IndentAction={}));class y{constructor(A){if(this._neutralCharacter=null,this._neutralCharacterSearched=!1,this.open=A.open,this.close=A.close,this._inString=!0,this._inComment=!0,this._inRegEx=!0,Array.isArray(A.notIn))for(let b=0,P=A.notIn.length;b<P;b++)switch(A.notIn[b]){case"string":this._inString=!1;break;case"comment":this._inComment=!1;break;case"regex":this._inRegEx=!1;break}}isOK(A){switch(A){case 0:return!0;case 1:return this._inComment;case 2:return this._inString;case 3:return this._inRegEx}}shouldAutoClose(A,b){if(A.getTokenCount()===0)return!0;const P=A.findTokenIndexAtOffset(b-2),O=A.getStandardTokenType(P);return this.isOK(O)}_findNeutralCharacterInRange(A,b){for(let P=A;P<=b;P++){const O=String.fromCharCode(P);if(!this.open.includes(O)&&!this.close.includes(O))return O}return null}findNeutralCharacter(){return this._neutralCharacterSearched||(this._neutralCharacterSearched=!0,this._neutralCharacter||(this._neutralCharacter=this._findNeutralCharacterInRange(48,57)),this._neutralCharacter||(this._neutralCharacter=this._findNeutralCharacterInRange(97,122)),this._neutralCharacter||(this._neutralCharacter=this._findNeutralCharacterInRange(65,90))),this._neutralCharacter}}e.StandardAutoClosingPairConditional=y;class S{constructor(A){this.autoClosingPairsOpenByStart=new Map,this.autoClosingPairsOpenByEnd=new Map,this.autoClosingPairsCloseByStart=new Map,this.autoClosingPairsCloseByEnd=new Map,this.autoClosingPairsCloseSingleChar=new Map;for(const b of A)M(this.autoClosingPairsOpenByStart,b.open.charAt(0),b),M(this.autoClosingPairsOpenByEnd,b.open.charAt(b.open.length-1),b),M(this.autoClosingPairsCloseByStart,b.close.charAt(0),b),M(this.autoClosingPairsCloseByEnd,b.close.charAt(b.close.length-1),b),b.close.length===1&&b.open.length===1&&M(this.autoClosingPairsCloseSingleChar,b.close,b)}}e.AutoClosingPairs=S;function M(_,A,b){_.has(A)?_.get(A).push(b):_.set(A,[b])}}),define(Ce[112],Ie([16,17]),function(ie,e){return ie.create("vs/base/common/date",e)}),define(Ce[113],Ie([1,0,112]),function(ie,e,r){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.toLocalISOString=e.fromNow=void 0;const y=60,S=y*60,M=S*24,_=M*7,A=M*30,b=M*365;function P(E,m,k){typeof E!="number"&&(E=E.getTime());const f=Math.round((new Date().getTime()-E)/1e3);if(f<-30)return(0,r.localize)(0,null,P(new Date().getTime()+f*1e3,!1));if(f<30)return(0,r.localize)(1,null);let c;return f<y?(c=f,m?c===1?k?(0,r.localize)(2,null,c):(0,r.localize)(3,null,c):k?(0,r.localize)(4,null,c):(0,r.localize)(5,null,c):c===1?k?(0,r.localize)(6,null,c):(0,r.localize)(7,null,c):k?(0,r.localize)(8,null,c):(0,r.localize)(9,null,c)):f<S?(c=Math.floor(f/y),m?c===1?k?(0,r.localize)(10,null,c):(0,r.localize)(11,null,c):k?(0,r.localize)(12,null,c):(0,r.localize)(13,null,c):c===1?k?(0,r.localize)(14,null,c):(0,r.localize)(15,null,c):k?(0,r.localize)(16,null,c):(0,r.localize)(17,null,c)):f<M?(c=Math.floor(f/S),m?c===1?k?(0,r.localize)(18,null,c):(0,r.localize)(19,null,c):k?(0,r.localize)(20,null,c):(0,r.localize)(21,null,c):c===1?k?(0,r.localize)(22,null,c):(0,r.localize)(23,null,c):k?(0,r.localize)(24,null,c):(0,r.localize)(25,null,c)):f<_?(c=Math.floor(f/M),m?c===1?(0,r.localize)(26,null,c):(0,r.localize)(27,null,c):c===1?(0,r.localize)(28,null,c):(0,r.localize)(29,null,c)):f<A?(c=Math.floor(f/_),m?c===1?k?(0,r.localize)(30,null,c):(0,r.localize)(31,null,c):k?(0,r.localize)(32,null,c):(0,r.localize)(33,null,c):c===1?k?(0,r.localize)(34,null,c):(0,r.localize)(35,null,c):k?(0,r.localize)(36,null,c):(0,r.localize)(37,null,c)):f<b?(c=Math.floor(f/A),m?c===1?k?(0,r.localize)(38,null,c):(0,r.localize)(39,null,c):k?(0,r.localize)(40,null,c):(0,r.localize)(41,null,c):c===1?k?(0,r.localize)(42,null,c):(0,r.localize)(43,null,c):k?(0,r.localize)(44,null,c):(0,r.localize)(45,null,c)):(c=Math.floor(f/b),m?c===1?k?(0,r.localize)(46,null,c):(0,r.localize)(47,null,c):k?(0,r.localize)(48,null,c):(0,r.localize)(49,null,c):c===1?k?(0,r.localize)(50,null,c):(0,r.localize)(51,null,c):k?(0,r.localize)(52,null,c):(0,r.localize)(53,null,c))}e.fromNow=P;function O(E){return E.getFullYear()+"-"+String(E.getMonth()+1).padStart(2,"0")+"-"+String(E.getDate()).padStart(2,"0")+"T"+String(E.getHours()).padStart(2,"0")+":"+String(E.getMinutes()).padStart(2,"0")+":"+String(E.getSeconds()).padStart(2,"0")+"."+(E.getMilliseconds()/1e3).toFixed(3).slice(2,5)+"Z"}e.toLocalISOString=O}),define(Ce[114],Ie([16,17]),function(ie,e){return ie.create("vs/base/common/errorMessage",e)}),define(Ce[43],Ie([1,0,18,10,114]),function(ie,e,r,y,S){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.createErrorWithActions=e.isErrorWithActions=e.toErrorMessage=void 0;function M(E,m){return m&&(E.stack||E.stacktrace)?S.localize(0,null,A(E),_(E.stack)||_(E.stacktrace)):A(E)}function _(E){return Array.isArray(E)?E.join(`
`):E}function A(E){return typeof E.code=="string"&&typeof E.errno=="number"&&typeof E.syscall=="string"?S.localize(1,null,E.message):E.message||S.localize(2,null)}function b(E=null,m=!1){if(!E)return S.localize(3,null);if(Array.isArray(E)){const k=r.coalesce(E),f=b(k[0],m);return k.length>1?S.localize(4,null,f,k.length):f}if(y.isString(E))return E;if(E.detail){const k=E.detail;if(k.error)return M(k.error,m);if(k.exception)return M(k.exception,m)}return E.stack?M(E,m):E.message?E.message:S.localize(5,null)}e.toErrorMessage=b;function P(E){const m=E;return m instanceof Error&&Array.isArray(m.actions)}e.isErrorWithActions=P;function O(E,m){let k;return typeof E=="string"?k=new Error(E):k=E,k.actions=m,k}e.createErrorWithActions=O}),define(Ce[75],Ie([1,0,19]),function(ie,e,r){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.normalizeMimeType=e.getExtensionForMimeType=e.getMediaMime=e.getMediaOrTextMime=e.Mimes=void 0,e.Mimes=Object.freeze({text:"text/plain",binary:"application/octet-stream",unknown:"application/unknown",markdown:"text/markdown",latex:"text/latex",uriList:"text/uri-list"});const y={".css":"text/css",".csv":"text/csv",".htm":"text/html",".html":"text/html",".ics":"text/calendar",".js":"text/javascript",".mjs":"text/javascript",".txt":"text/plain",".xml":"text/xml"},S={".aac":"audio/x-aac",".avi":"video/x-msvideo",".bmp":"image/bmp",".flv":"video/x-flv",".gif":"image/gif",".ico":"image/x-icon",".jpe":"image/jpg",".jpeg":"image/jpg",".jpg":"image/jpg",".m1v":"video/mpeg",".m2a":"audio/mpeg",".m2v":"video/mpeg",".m3a":"audio/mpeg",".mid":"audio/midi",".midi":"audio/midi",".mk3d":"video/x-matroska",".mks":"video/x-matroska",".mkv":"video/x-matroska",".mov":"video/quicktime",".movie":"video/x-sgi-movie",".mp2":"audio/mpeg",".mp2a":"audio/mpeg",".mp3":"audio/mpeg",".mp4":"video/mp4",".mp4a":"audio/mp4",".mp4v":"video/mp4",".mpe":"video/mpeg",".mpeg":"video/mpeg",".mpg":"video/mpeg",".mpg4":"video/mp4",".mpga":"audio/mpeg",".oga":"audio/ogg",".ogg":"audio/ogg",".opus":"audio/opus",".ogv":"video/ogg",".png":"image/png",".psd":"image/vnd.adobe.photoshop",".qt":"video/quicktime",".spx":"audio/ogg",".svg":"image/svg+xml",".tga":"image/x-tga",".tif":"image/tiff",".tiff":"image/tiff",".wav":"audio/x-wav",".webm":"video/webm",".webp":"image/webp",".wma":"audio/x-ms-wma",".wmv":"video/x-ms-wmv",".woff":"application/font-woff"};function M(O){const E=(0,r.extname)(O),m=y[E.toLowerCase()];return m!==void 0?m:_(O)}e.getMediaOrTextMime=M;function _(O){const E=(0,r.extname)(O);return S[E.toLowerCase()]}e.getMediaMime=_;function A(O){for(const E in S)if(S[E]===O)return E}e.getExtensionForMimeType=A;const b=/^(.+)\/(.+?)(;.+)?$/;function P(O,E){const m=b.exec(O);return m?`${m[1].toLowerCase()}/${m[2].toLowerCase()}${m[3]??""}`:E?void 0:O}e.normalizeMimeType=P}),define(Ce[38],Ie([1,0,19,21,9,10]),function(ie,e,r,y,S,M){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.randomPath=e.parseLineAndColumnAware=e.indexOfPath=e.getDriveLetter=e.hasDriveLetter=e.isRootOrDriveLetter=e.sanitizeFilePath=e.isWindowsDriveLetter=e.isEqualOrParent=e.isEqual=e.isValidBasename=e.isUNC=e.getRoot=e.toPosixPath=e.toSlashes=e.isPathSeparator=void 0;function _(s){return s===47||s===92}e.isPathSeparator=_;function A(s){return s.replace(/[\\/]/g,r.posix.sep)}e.toSlashes=A;function b(s){return s.indexOf("/")===-1&&(s=A(s)),/^[a-zA-Z]:(\/|$)/.test(s)&&(s="/"+s),s}e.toPosixPath=b;function P(s,a=r.posix.sep){if(!s)return"";const o=s.length,v=s.charCodeAt(0);if(_(v)){if(_(s.charCodeAt(1))&&!_(s.charCodeAt(2))){let T=3;const N=T;for(;T<o&&!_(s.charCodeAt(T));T++);if(N!==T&&!_(s.charCodeAt(T+1))){for(T+=1;T<o;T++)if(_(s.charCodeAt(T)))return s.slice(0,T+1).replace(/[\\/]/g,a)}}return a}else if(h(v)&&s.charCodeAt(1)===58)return _(s.charCodeAt(2))?s.slice(0,2)+a:s.slice(0,2);let p=s.indexOf("://");if(p!==-1){for(p+=3;p<o;p++)if(_(s.charCodeAt(p)))return s.slice(0,p+1)}return""}e.getRoot=P;function O(s){if(!y.isWindows||!s||s.length<5)return!1;let a=s.charCodeAt(0);if(a!==92||(a=s.charCodeAt(1),a!==92))return!1;let o=2;const v=o;for(;o<s.length&&(a=s.charCodeAt(o),a!==92);o++);return!(v===o||(a=s.charCodeAt(o+1),isNaN(a)||a===92))}e.isUNC=O;const E=/[\\/:\*\?"<>\|]/g,m=/[\\/]/g,k=/^(con|prn|aux|clock\$|nul|lpt[0-9]|com[0-9])(\.(.*?))?$/i;function f(s,a=y.isWindows){const o=a?E:m;return!(!s||s.length===0||/^\s+$/.test(s)||(o.lastIndex=0,o.test(s))||a&&k.test(s)||s==="."||s===".."||a&&s[s.length-1]==="."||a&&s.length!==s.trim().length||s.length>255)}e.isValidBasename=f;function c(s,a,o){const v=s===a;return!o||v?v:!s||!a?!1:(0,S.equalsIgnoreCase)(s,a)}e.isEqual=c;function d(s,a,o,v=r.sep){if(s===a)return!0;if(!s||!a||a.length>s.length)return!1;if(o){if(!(0,S.startsWithIgnoreCase)(s,a))return!1;if(a.length===s.length)return!0;let T=a.length;return a.charAt(a.length-1)===v&&T--,s.charAt(T)===v}return a.charAt(a.length-1)!==v&&(a+=v),s.indexOf(a)===0}e.isEqualOrParent=d;function h(s){return s>=65&&s<=90||s>=97&&s<=122}e.isWindowsDriveLetter=h;function g(s,a){return y.isWindows&&s.endsWith(":")&&(s+=r.sep),(0,r.isAbsolute)(s)||(s=(0,r.join)(a,s)),s=(0,r.normalize)(s),y.isWindows?(s=(0,S.rtrim)(s,r.sep),s.endsWith(":")&&(s+=r.sep)):(s=(0,S.rtrim)(s,r.sep),s||(s=r.sep)),s}e.sanitizeFilePath=g;function C(s){const a=(0,r.normalize)(s);return y.isWindows?s.length>3?!1:l(a)&&(s.length===2||a.charCodeAt(2)===92):a===r.posix.sep}e.isRootOrDriveLetter=C;function l(s,a=y.isWindows){return a?h(s.charCodeAt(0))&&s.charCodeAt(1)===58:!1}e.hasDriveLetter=l;function w(s){return l(s)?s[0]:void 0}e.getDriveLetter=w;function t(s,a,o){return a.length>s.length?-1:s===a?0:(o&&(s=s.toLowerCase(),a=a.toLowerCase()),s.indexOf(a))}e.indexOfPath=t;function u(s){const a=s.split(":");let o,v,p;for(const T of a){const N=Number(T);(0,M.isNumber)(N)?v===void 0?v=N:p===void 0&&(p=N):o=o?[o,T].join(":"):T}if(!o)throw new Error("Format for `--goto` should be: `FILE:LINE(:COLUMN)`");return{path:o,line:v!==void 0?v:void 0,column:p!==void 0?p:v!==void 0?1:void 0}}e.parseLineAndColumnAware=u;const i="ABCDEFGHIJKLMNOPQRSTUVWXYZabcdefghijklmnopqrstuvwxyz0123456789";function n(s,a,o=8){let v="";for(let T=0;T<o;T++)v+=i.charAt(Math.floor(Math.random()*i.length));let p;return a?p=`${a}-${v}`:p=v,s?(0,r.join)(s,p):p}e.randomPath=n}),define(Ce[24],Ie([1,0,18,9]),function(ie,e,r,y){"use strict";var S,M,_;Object.defineProperty(e,"__esModule",{value:!0}),e.LRUCache=e.LinkedMap=e.Touch=e.ResourceSet=e.ResourceMap=e.TernarySearchTree=e.UriIterator=e.PathIterator=e.ConfigKeysIterator=e.StringIterator=e.setToString=e.mapToString=e.getOrSet=void 0;function A(i,n,s){let a=i.get(n);return a===void 0&&(a=s,i.set(n,a)),a}e.getOrSet=A;function b(i){const n=[];return i.forEach((s,a)=>{n.push(`${a} => ${s}`)}),`Map(${i.size}) {${n.join(", ")}}`}e.mapToString=b;function P(i){const n=[];return i.forEach(s=>{n.push(s)}),`Set(${i.size}) {${n.join(", ")}}`}e.setToString=P;class O{constructor(){this._value="",this._pos=0}reset(n){return this._value=n,this._pos=0,this}next(){return this._pos+=1,this}hasNext(){return this._pos<this._value.length-1}cmp(n){const s=n.charCodeAt(0),a=this._value.charCodeAt(this._pos);return s-a}value(){return this._value[this._pos]}}e.StringIterator=O;class E{constructor(n=!0){this._caseSensitive=n}reset(n){return this._value=n,this._from=0,this._to=0,this.next()}hasNext(){return this._to<this._value.length}next(){this._from=this._to;let n=!0;for(;this._to<this._value.length;this._to++)if(this._value.charCodeAt(this._to)===46)if(n)this._from++;else break;else n=!1;return this}cmp(n){return this._caseSensitive?(0,y.compareSubstring)(n,this._value,0,n.length,this._from,this._to):(0,y.compareSubstringIgnoreCase)(n,this._value,0,n.length,this._from,this._to)}value(){return this._value.substring(this._from,this._to)}}e.ConfigKeysIterator=E;class m{constructor(n=!0,s=!0){this._splitOnBackslash=n,this._caseSensitive=s}reset(n){this._from=0,this._to=0,this._value=n,this._valueLen=n.length;for(let s=n.length-1;s>=0;s--,this._valueLen--){const a=this._value.charCodeAt(s);if(!(a===47||this._splitOnBackslash&&a===92))break}return this.next()}hasNext(){return this._to<this._valueLen}next(){this._from=this._to;let n=!0;for(;this._to<this._valueLen;this._to++){const s=this._value.charCodeAt(this._to);if(s===47||this._splitOnBackslash&&s===92)if(n)this._from++;else break;else n=!1}return this}cmp(n){return this._caseSensitive?(0,y.compareSubstring)(n,this._value,0,n.length,this._from,this._to):(0,y.compareSubstringIgnoreCase)(n,this._value,0,n.length,this._from,this._to)}value(){return this._value.substring(this._from,this._to)}}e.PathIterator=m;var k;(function(i){i[i.Scheme=1]="Scheme",i[i.Authority=2]="Authority",i[i.Path=3]="Path",i[i.Query=4]="Query",i[i.Fragment=5]="Fragment"})(k||(k={}));class f{constructor(n,s){this._ignorePathCasing=n,this._ignoreQueryAndFragment=s,this._states=[],this._stateIdx=0}reset(n){return this._value=n,this._states=[],this._value.scheme&&this._states.push(1),this._value.authority&&this._states.push(2),this._value.path&&(this._pathIterator=new m(!1,!this._ignorePathCasing(n)),this._pathIterator.reset(n.path),this._pathIterator.value()&&this._states.push(3)),this._ignoreQueryAndFragment(n)||(this._value.query&&this._states.push(4),this._value.fragment&&this._states.push(5)),this._stateIdx=0,this}next(){return this._states[this._stateIdx]===3&&this._pathIterator.hasNext()?this._pathIterator.next():this._stateIdx+=1,this}hasNext(){return this._states[this._stateIdx]===3&&this._pathIterator.hasNext()||this._stateIdx<this._states.length-1}cmp(n){if(this._states[this._stateIdx]===1)return(0,y.compareIgnoreCase)(n,this._value.scheme);if(this._states[this._stateIdx]===2)return(0,y.compareIgnoreCase)(n,this._value.authority);if(this._states[this._stateIdx]===3)return this._pathIterator.cmp(n);if(this._states[this._stateIdx]===4)return(0,y.compare)(n,this._value.query);if(this._states[this._stateIdx]===5)return(0,y.compare)(n,this._value.fragment);throw new Error}value(){if(this._states[this._stateIdx]===1)return this._value.scheme;if(this._states[this._stateIdx]===2)return this._value.authority;if(this._states[this._stateIdx]===3)return this._pathIterator.value();if(this._states[this._stateIdx]===4)return this._value.query;if(this._states[this._stateIdx]===5)return this._value.fragment;throw new Error}}e.UriIterator=f;class c{constructor(){this.height=1}isEmpty(){return!this.left&&!this.mid&&!this.right&&!this.value}rotateLeft(){const n=this.right;return this.right=n.left,n.left=this,this.updateHeight(),n.updateHeight(),n}rotateRight(){const n=this.left;return this.left=n.right,n.right=this,this.updateHeight(),n.updateHeight(),n}updateHeight(){this.height=1+Math.max(this.heightLeft,this.heightRight)}balanceFactor(){return this.heightRight-this.heightLeft}get heightLeft(){return this.left?.height??0}get heightRight(){return this.right?.height??0}}var d;(function(i){i[i.Left=-1]="Left",i[i.Mid=0]="Mid",i[i.Right=1]="Right"})(d||(d={}));class h{static forUris(n=()=>!1,s=()=>!1){return new h(new f(n,s))}static forPaths(n=!1){return new h(new m(void 0,!n))}static forStrings(){return new h(new O)}static forConfigKeys(){return new h(new E)}constructor(n){this._iter=n}clear(){this._root=void 0}fill(n,s){if(s){const a=s.slice(0);(0,r.shuffle)(a);for(const o of a)this.set(o,n)}else{const a=n.slice(0);(0,r.shuffle)(a);for(const o of a)this.set(o[0],o[1])}}set(n,s){const a=this._iter.reset(n);let o;this._root||(this._root=new c,this._root.segment=a.value());const v=[];for(o=this._root;;){const T=a.cmp(o.segment);if(T>0)o.left||(o.left=new c,o.left.segment=a.value()),v.push([-1,o]),o=o.left;else if(T<0)o.right||(o.right=new c,o.right.segment=a.value()),v.push([1,o]),o=o.right;else if(a.hasNext())a.next(),o.mid||(o.mid=new c,o.mid.segment=a.value()),v.push([0,o]),o=o.mid;else break}const p=o.value;o.value=s,o.key=n;for(let T=v.length-1;T>=0;T--){const N=v[T][1];N.updateHeight();const V=N.balanceFactor();if(V<-1||V>1){const B=v[T][0],D=v[T+1][0];if(B===1&&D===1)v[T][1]=N.rotateLeft();else if(B===-1&&D===-1)v[T][1]=N.rotateRight();else if(B===1&&D===-1)N.right=v[T+1][1]=v[T+1][1].rotateRight(),v[T][1]=N.rotateLeft();else if(B===-1&&D===1)N.left=v[T+1][1]=v[T+1][1].rotateLeft(),v[T][1]=N.rotateRight();else throw new Error;if(T>0)switch(v[T-1][0]){case-1:v[T-1][1].left=v[T][1];break;case 1:v[T-1][1].right=v[T][1];break;case 0:v[T-1][1].mid=v[T][1];break}else this._root=v[0][1]}}return p}get(n){return this._getNode(n)?.value}_getNode(n){const s=this._iter.reset(n);let a=this._root;for(;a;){const o=s.cmp(a.segment);if(o>0)a=a.left;else if(o<0)a=a.right;else if(s.hasNext())s.next(),a=a.mid;else break}return a}has(n){const s=this._getNode(n);return!(s?.value===void 0&&s?.mid===void 0)}delete(n){return this._delete(n,!1)}deleteSuperstr(n){return this._delete(n,!0)}_delete(n,s){const a=this._iter.reset(n),o=[];let v=this._root;for(;v;){const p=a.cmp(v.segment);if(p>0)o.push([-1,v]),v=v.left;else if(p<0)o.push([1,v]),v=v.right;else if(a.hasNext())a.next(),o.push([0,v]),v=v.mid;else break}if(!!v){if(s?(v.left=void 0,v.mid=void 0,v.right=void 0,v.height=1):(v.key=void 0,v.value=void 0),!v.mid&&!v.value)if(v.left&&v.right){const p=this._min(v.right),{key:T,value:N,segment:V}=p;this._delete(p.key,!1),v.key=T,v.value=N,v.segment=V}else{const p=v.left??v.right;if(o.length>0){const[T,N]=o[o.length-1];switch(T){case-1:N.left=p;break;case 0:N.mid=p;break;case 1:N.right=p;break}}else this._root=p}for(let p=o.length-1;p>=0;p--){const T=o[p][1];T.updateHeight();const N=T.balanceFactor();if(N>1?(T.right.balanceFactor()>=0||(T.right=T.right.rotateRight()),o[p][1]=T.rotateLeft()):N<-1&&(T.left.balanceFactor()<=0||(T.left=T.left.rotateLeft()),o[p][1]=T.rotateRight()),p>0)switch(o[p-1][0]){case-1:o[p-1][1].left=o[p][1];break;case 1:o[p-1][1].right=o[p][1];break;case 0:o[p-1][1].mid=o[p][1];break}else this._root=o[0][1]}}}_min(n){for(;n.left;)n=n.left;return n}findSubstr(n){const s=this._iter.reset(n);let a=this._root,o;for(;a;){const v=s.cmp(a.segment);if(v>0)a=a.left;else if(v<0)a=a.right;else if(s.hasNext())s.next(),o=a.value||o,a=a.mid;else break}return a&&a.value||o}findSuperstr(n){const s=this._iter.reset(n);let a=this._root;for(;a;){const o=s.cmp(a.segment);if(o>0)a=a.left;else if(o<0)a=a.right;else if(s.hasNext())s.next(),a=a.mid;else return a.mid?this._entries(a.mid):void 0}}forEach(n){for(const[s,a]of this)n(a,s)}*[Symbol.iterator](){yield*this._entries(this._root)}_entries(n){const s=[];return this._dfsEntries(n,s),s[Symbol.iterator]()}_dfsEntries(n,s){!n||(n.left&&this._dfsEntries(n.left,s),n.value&&s.push([n.key,n.value]),n.mid&&this._dfsEntries(n.mid,s),n.right&&this._dfsEntries(n.right,s))}_isBalanced(){const n=s=>{if(!s)return!0;const a=s.balanceFactor();return a<-1||a>1?!1:n(s.left)&&n(s.right)};return n(this._root)}}e.TernarySearchTree=h;class g{constructor(n,s){this.uri=n,this.value=s}}class C{constructor(n,s){this[S]="ResourceMap",n instanceof C?(this.map=new Map(n.map),this.toKey=s??C.defaultToKey):(this.map=new Map,this.toKey=n??C.defaultToKey)}set(n,s){return this.map.set(this.toKey(n),new g(n,s)),this}get(n){return this.map.get(this.toKey(n))?.value}has(n){return this.map.has(this.toKey(n))}get size(){return this.map.size}clear(){this.map.clear()}delete(n){return this.map.delete(this.toKey(n))}forEach(n,s){typeof s<"u"&&(n=n.bind(s));for(const[a,o]of this.map)n(o.value,o.uri,this)}*values(){for(const n of this.map.values())yield n.value}*keys(){for(const n of this.map.values())yield n.uri}*entries(){for(const n of this.map.values())yield[n.uri,n.value]}*[(S=Symbol.toStringTag,Symbol.iterator)](){for(const[,n]of this.map)yield[n.uri,n.value]}}e.ResourceMap=C,C.defaultToKey=i=>i.toString();class l{constructor(n,s){this[M]="ResourceSet",!n||typeof n=="function"?this._map=new C(n):(this._map=new C(s),n.forEach(this.add,this))}get size(){return this._map.size}add(n){return this._map.set(n,n),this}clear(){this._map.clear()}delete(n){return this._map.delete(n)}forEach(n,s){this._map.forEach((a,o)=>n.call(s,o,o,this))}has(n){return this._map.has(n)}entries(){return this._map.entries()}keys(){return this._map.keys()}values(){return this._map.keys()}[(M=Symbol.toStringTag,Symbol.iterator)](){return this.keys()}}e.ResourceSet=l;var w;(function(i){i[i.None=0]="None",i[i.AsOld=1]="AsOld",i[i.AsNew=2]="AsNew"})(w=e.Touch||(e.Touch={}));class t{constructor(){this[_]="LinkedMap",this._map=new Map,this._head=void 0,this._tail=void 0,this._size=0,this._state=0}clear(){this._map.clear(),this._head=void 0,this._tail=void 0,this._size=0,this._state++}isEmpty(){return!this._head&&!this._tail}get size(){return this._size}get first(){return this._head?.value}get last(){return this._tail?.value}has(n){return this._map.has(n)}get(n,s=0){const a=this._map.get(n);if(!!a)return s!==0&&this.touch(a,s),a.value}set(n,s,a=0){let o=this._map.get(n);if(o)o.value=s,a!==0&&this.touch(o,a);else{switch(o={key:n,value:s,next:void 0,previous:void 0},a){case 0:this.addItemLast(o);break;case 1:this.addItemFirst(o);break;case 2:this.addItemLast(o);break;default:this.addItemLast(o);break}this._map.set(n,o),this._size++}return this}delete(n){return!!this.remove(n)}remove(n){const s=this._map.get(n);if(!!s)return this._map.delete(n),this.removeItem(s),this._size--,s.value}shift(){if(!this._head&&!this._tail)return;if(!this._head||!this._tail)throw new Error("Invalid list");const n=this._head;return this._map.delete(n.key),this.removeItem(n),this._size--,n.value}forEach(n,s){const a=this._state;let o=this._head;for(;o;){if(s?n.bind(s)(o.value,o.key,this):n(o.value,o.key,this),this._state!==a)throw new Error("LinkedMap got modified during iteration.");o=o.next}}keys(){const n=this,s=this._state;let a=this._head;const o={[Symbol.iterator](){return o},next(){if(n._state!==s)throw new Error("LinkedMap got modified during iteration.");if(a){const v={value:a.key,done:!1};return a=a.next,v}else return{value:void 0,done:!0}}};return o}values(){const n=this,s=this._state;let a=this._head;const o={[Symbol.iterator](){return o},next(){if(n._state!==s)throw new Error("LinkedMap got modified during iteration.");if(a){const v={value:a.value,done:!1};return a=a.next,v}else return{value:void 0,done:!0}}};return o}entries(){const n=this,s=this._state;let a=this._head;const o={[Symbol.iterator](){return o},next(){if(n._state!==s)throw new Error("LinkedMap got modified during iteration.");if(a){const v={value:[a.key,a.value],done:!1};return a=a.next,v}else return{value:void 0,done:!0}}};return o}[(_=Symbol.toStringTag,Symbol.iterator)](){return this.entries()}trimOld(n){if(n>=this.size)return;if(n===0){this.clear();return}let s=this._head,a=this.size;for(;s&&a>n;)this._map.delete(s.key),s=s.next,a--;this._head=s,this._size=a,s&&(s.previous=void 0),this._state++}addItemFirst(n){if(!this._head&&!this._tail)this._tail=n;else if(this._head)n.next=this._head,this._head.previous=n;else throw new Error("Invalid list");this._head=n,this._state++}addItemLast(n){if(!this._head&&!this._tail)this._head=n;else if(this._tail)n.previous=this._tail,this._tail.next=n;else throw new Error("Invalid list");this._tail=n,this._state++}removeItem(n){if(n===this._head&&n===this._tail)this._head=void 0,this._tail=void 0;else if(n===this._head){if(!n.next)throw new Error("Invalid list");n.next.previous=void 0,this._head=n.next}else if(n===this._tail){if(!n.previous)throw new Error("Invalid list");n.previous.next=void 0,this._tail=n.previous}else{const s=n.next,a=n.previous;if(!s||!a)throw new Error("Invalid list");s.previous=a,a.next=s}n.next=void 0,n.previous=void 0,this._state++}touch(n,s){if(!this._head||!this._tail)throw new Error("Invalid list");if(!(s!==1&&s!==2)){if(s===1){if(n===this._head)return;const a=n.next,o=n.previous;n===this._tail?(o.next=void 0,this._tail=o):(a.previous=o,o.next=a),n.previous=void 0,n.next=this._head,this._head.previous=n,this._head=n,this._state++}else if(s===2){if(n===this._tail)return;const a=n.next,o=n.previous;n===this._head?(a.previous=void 0,this._head=a):(a.previous=o,o.next=a),n.next=void 0,n.previous=this._tail,this._tail.next=n,this._tail=n,this._state++}}}toJSON(){const n=[];return this.forEach((s,a)=>{n.push([a,s])}),n}fromJSON(n){this.clear();for(const[s,a]of n)this.set(s,a)}}e.LinkedMap=t;class u extends t{constructor(n,s=1){super(),this._limit=n,this._ratio=Math.min(Math.max(0,s),1)}get limit(){return this._limit}set limit(n){this._limit=n,this.checkTrim()}get ratio(){return this._ratio}set ratio(n){this._ratio=Math.min(Math.max(0,n),1),this.checkTrim()}get(n,s=2){return super.get(n,s)}peek(n){return super.get(n,0)}set(n,s){return super.set(n,s,2),this.checkTrim(),this}checkTrim(){this.size>this._limit&&this.trimOld(Math.round(this._limit*this._ratio))}}e.LRUCache=u}),define(Ce[115],Ie([1,0,24,9]),function(ie,e,r,y){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.fuzzyScoreGraceful=e.fuzzyScoreGracefulAggressive=e.fuzzyScore=e.FuzzyScoreOptions=e.FuzzyScore=e.isPatternInWord=e.createMatches=e.anyScore=e.matchesFuzzy2=e.matchesFuzzy=e.matchesWords=e.matchesCamelCase=e.isUpper=e.matchesSubString=e.matchesContiguousSubString=e.matchesPrefix=e.matchesStrictPrefix=e.or=void 0;function S(...Z){return function(J,I){for(let U=0,H=Z.length;U<H;U++){const j=Z[U](J,I);if(j)return j}return null}}e.or=S,e.matchesStrictPrefix=M.bind(void 0,!1),e.matchesPrefix=M.bind(void 0,!0);function M(Z,J,I){if(!I||I.length<J.length)return null;let U;return Z?U=y.startsWithIgnoreCase(I,J):U=I.indexOf(J)===0,U?J.length>0?[{start:0,end:J.length}]:[]:null}function _(Z,J){const I=J.toLowerCase().indexOf(Z.toLowerCase());return I===-1?null:[{start:I,end:I+Z.length}]}e.matchesContiguousSubString=_;function A(Z,J){return b(Z.toLowerCase(),J.toLowerCase(),0,0)}e.matchesSubString=A;function b(Z,J,I,U){if(I===Z.length)return[];if(U===J.length)return null;if(Z[I]===J[U]){let H=null;return(H=b(Z,J,I+1,U+1))?h({start:U,end:U+1},H):null}return b(Z,J,I,U+1)}function P(Z){return 97<=Z&&Z<=122}function O(Z){return 65<=Z&&Z<=90}e.isUpper=O;function E(Z){return 48<=Z&&Z<=57}function m(Z){return Z===32||Z===9||Z===10||Z===13}const k=new Set;"()[]{}<>`'\"-/;:,.?!".split("").forEach(Z=>k.add(Z.charCodeAt(0)));function f(Z){return m(Z)||k.has(Z)}function c(Z,J){return Z===J||f(Z)&&f(J)}function d(Z){return P(Z)||O(Z)||E(Z)}function h(Z,J){return J.length===0?J=[Z]:Z.end===J[0].start?J[0].start=Z.start:J.unshift(Z),J}function g(Z,J){for(let I=J;I<Z.length;I++){const U=Z.charCodeAt(I);if(O(U)||E(U)||I>0&&!d(Z.charCodeAt(I-1)))return I}return Z.length}function C(Z,J,I,U){if(I===Z.length)return[];if(U===J.length)return null;if(Z[I]!==J[U].toLowerCase())return null;{let H=null,j=U+1;for(H=C(Z,J,I+1,U+1);!H&&(j=g(J,j))<J.length;)H=C(Z,J,I+1,j),j++;return H===null?null:h({start:U,end:U+1},H)}}function l(Z){let J=0,I=0,U=0,H=0,j=0;for(let pe=0;pe<Z.length;pe++)j=Z.charCodeAt(pe),O(j)&&J++,P(j)&&I++,d(j)&&U++,E(j)&&H++;const se=J/Z.length,le=I/Z.length,Y=U/Z.length,ve=H/Z.length;return{upperPercent:se,lowerPercent:le,alphaPercent:Y,numericPercent:ve}}function w(Z){const{upperPercent:J,lowerPercent:I}=Z;return I===0&&J>.6}function t(Z){const{upperPercent:J,lowerPercent:I,alphaPercent:U,numericPercent:H}=Z;return I>.2&&J<.8&&U>.6&&H<.2}function u(Z){let J=0,I=0,U=0,H=0;for(let j=0;j<Z.length;j++)U=Z.charCodeAt(j),O(U)&&J++,P(U)&&I++,m(U)&&H++;return(J===0||I===0)&&H===0?Z.length<=30:J<=5}function i(Z,J){if(!J||(J=J.trim(),J.length===0)||!u(Z)||J.length>60)return null;const I=l(J);if(!t(I)){if(!w(I))return null;J=J.toLowerCase()}let U=null,H=0;for(Z=Z.toLowerCase();H<J.length&&(U=C(Z,J,0,H))===null;)H=g(J,H+1);return U}e.matchesCamelCase=i;function n(Z,J,I=!1){if(!J||J.length===0)return null;let U=null,H=0;for(Z=Z.toLowerCase(),J=J.toLowerCase();H<J.length&&(U=s(Z,J,0,H,I))===null;)H=a(J,H+1);return U}e.matchesWords=n;function s(Z,J,I,U,H){if(I===Z.length)return[];if(U===J.length)return null;if(c(Z.charCodeAt(I),J.charCodeAt(U))){let j=null,se=U+1;if(j=s(Z,J,I+1,U+1,H),!H)for(;!j&&(se=a(J,se))<J.length;)j=s(Z,J,I+1,se,H),se++;return j?Z.charCodeAt(I)!==J.charCodeAt(U)?j:h({start:U,end:U+1},j):null}else return null}function a(Z,J){for(let I=J;I<Z.length;I++)if(f(Z.charCodeAt(I))||I>0&&f(Z.charCodeAt(I-1)))return I;return Z.length}const o=S(e.matchesPrefix,i,_),v=S(e.matchesPrefix,i,A),p=new r.LRUCache(1e4);function T(Z,J,I=!1){if(typeof Z!="string"||typeof J!="string")return null;let U=p.get(Z);U||(U=new RegExp(y.convertSimple2RegExpPattern(Z),"i"),p.set(Z,U));const H=U.exec(J);return H?[{start:H.index,end:H.index+H[0].length}]:I?v(Z,J):o(Z,J)}e.matchesFuzzy=T;function N(Z,J){const I=Be(Z,Z.toLowerCase(),0,J,J.toLowerCase(),0,{firstMatchCanBeWeak:!0,boostFullMatch:!0});return I?B(I):null}e.matchesFuzzy2=N;function V(Z,J,I,U,H,j){const se=Math.min(13,Z.length);for(;I<se;I++){const le=Be(Z,J,I,U,H,j,{firstMatchCanBeWeak:!1,boostFullMatch:!0});if(le)return le}return[0,j]}e.anyScore=V;function B(Z){if(typeof Z>"u")return[];const J=[],I=Z[1];for(let U=Z.length-1;U>1;U--){const H=Z[U]+I,j=J[J.length-1];j&&j.end===H?j.end=H+1:J.push({start:H,end:H+1})}return J}e.createMatches=B;const D=128;function z(){const Z=[],J=[];for(let I=0;I<=D;I++)J[I]=0;for(let I=0;I<=D;I++)Z.push(J.slice(0));return Z}function L(Z){const J=[];for(let I=0;I<=Z;I++)J[I]=0;return J}const R=L(2*D),K=L(2*D),W=z(),$=z(),G=z(),ne=!1;function ge(Z,J,I,U,H){function j(le,Y,ve=" "){for(;le.length<Y;)le=ve+le;return le}let se=` |   |${U.split("").map(le=>j(le,3)).join("|")}
`;for(let le=0;le<=I;le++)le===0?se+=" |":se+=`${J[le-1]}|`,se+=Z[le].slice(0,H+1).map(Y=>j(Y.toString(),3)).join("|")+`
`;return se}function oe(Z,J,I,U){Z=Z.substr(J),I=I.substr(U),console.log(ge($,Z,Z.length,I,I.length)),console.log(ge(G,Z,Z.length,I,I.length)),console.log(ge(W,Z,Z.length,I,I.length))}function Ee(Z,J){if(J<0||J>=Z.length)return!1;const I=Z.codePointAt(J);switch(I){case 95:case 45:case 46:case 32:case 47:case 92:case 39:case 34:case 58:case 36:case 60:case 62:case 40:case 41:case 91:case 93:case 123:case 125:return!0;case void 0:return!1;default:return!!y.isEmojiImprecise(I)}}function ce(Z,J){if(J<0||J>=Z.length)return!1;switch(Z.charCodeAt(J)){case 32:case 9:return!0;default:return!1}}function me(Z,J,I){return J[Z]!==I[Z]}function ee(Z,J,I,U,H,j,se=!1){for(;J<I&&H<j;)Z[J]===U[H]&&(se&&(R[J]=H),J+=1),H+=1;return J===I}e.isPatternInWord=ee;var be;(function(Z){Z[Z.Diag=1]="Diag",Z[Z.Left=2]="Left",Z[Z.LeftLeft=3]="LeftLeft"})(be||(be={}));var _e;(function(Z){Z.Default=[-100,0];function J(I){return!I||I.length===2&&I[0]===-100&&I[1]===0}Z.isDefault=J})(_e=e.FuzzyScore||(e.FuzzyScore={}));class Fe{constructor(J,I){this.firstMatchCanBeWeak=J,this.boostFullMatch=I}}e.FuzzyScoreOptions=Fe,Fe.default={boostFullMatch:!0,firstMatchCanBeWeak:!1};function Be(Z,J,I,U,H,j,se=Fe.default){const le=Z.length>D?D:Z.length,Y=U.length>D?D:U.length;if(I>=le||j>=Y||le-I>Y-j||!ee(J,I,le,H,j,Y,!0))return;Xe(le,Y,I,j,J,H);let ve=1,pe=1,Me=I,xe=j;const Ye=[!1];for(ve=1,Me=I;Me<le;ve++,Me++){const Q=R[Me],he=K[Me],Ue=Me+1<le?K[Me+1]:Y;for(pe=Q-j+1,xe=Q;xe<Ue;pe++,xe++){let je=Number.MIN_SAFE_INTEGER,Ze=!1;xe<=he&&(je=ke(Z,J,Me,I,U,H,xe,Y,j,W[ve-1][pe-1]===0,Ye));let Ke=0;je!==Number.MAX_SAFE_INTEGER&&(Ze=!0,Ke=je+$[ve-1][pe-1]);const Ve=xe>Q,it=Ve?$[ve][pe-1]+(W[ve][pe-1]>0?-5:0):0,st=xe>Q+1&&W[ve][pe-1]>0,dt=st?$[ve][pe-2]+(W[ve][pe-2]>0?-5:0):0;if(st&&(!Ve||dt>=it)&&(!Ze||dt>=Ke))$[ve][pe]=dt,G[ve][pe]=3,W[ve][pe]=0;else if(Ve&&(!Ze||it>=Ke))$[ve][pe]=it,G[ve][pe]=2,W[ve][pe]=0;else if(Ze)$[ve][pe]=Ke,G[ve][pe]=1,W[ve][pe]=W[ve-1][pe-1]+1;else throw new Error("not possible")}}if(ne&&oe(Z,I,U,j),!Ye[0]&&!se.firstMatchCanBeWeak)return;ve--,pe--;const Ge=[$[ve][pe],j];let Te=0,rt=0;for(;ve>=1;){let Q=pe;do{const he=G[ve][Q];if(he===3)Q=Q-2;else if(he===2)Q=Q-1;else break}while(Q>=1);Te>1&&J[I+ve-1]===H[j+pe-1]&&!me(Q+j-1,U,H)&&Te+1>W[ve][Q]&&(Q=pe),Q===pe?Te++:Te=1,rt||(rt=Q),ve--,pe=Q-1,Ge.push(pe)}Y===le&&se.boostFullMatch&&(Ge[0]+=2);const X=rt-le;return Ge[0]-=X,Ge}e.fuzzyScore=Be;function Xe(Z,J,I,U,H,j){let se=Z-1,le=J-1;for(;se>=I&&le>=U;)H[se]===j[le]&&(K[se]=le,se--),le--}function ke(Z,J,I,U,H,j,se,le,Y,ve,pe){if(J[I]!==j[se])return Number.MIN_SAFE_INTEGER;let Me=1,xe=!1;return se===I-U?Me=Z[I]===H[se]?7:5:me(se,H,j)&&(se===0||!me(se-1,H,j))?(Me=Z[I]===H[se]?7:5,xe=!0):Ee(j,se)&&(se===0||!Ee(j,se-1))?Me=5:(Ee(j,se-1)||ce(j,se-1))&&(Me=5,xe=!0),Me>1&&I===U&&(pe[0]=!0),xe||(xe=me(se,H,j)||Ee(j,se-1)||ce(j,se-1)),I===U?se>Y&&(Me-=xe?3:5):ve?Me+=xe?2:0:Me+=xe?0:1,se+1===le&&(Me-=xe?3:5),Me}function ye(Z,J,I,U,H,j,se){return ae(Z,J,I,U,H,j,!0,se)}e.fuzzyScoreGracefulAggressive=ye;function De(Z,J,I,U,H,j,se){return ae(Z,J,I,U,H,j,!1,se)}e.fuzzyScoreGraceful=De;function ae(Z,J,I,U,H,j,se,le){let Y=Be(Z,J,I,U,H,j,le);if(Y&&!se)return Y;if(Z.length>=3){const ve=Math.min(7,Z.length-1);for(let pe=I+1;pe<ve;pe++){const Me=ue(Z,pe);if(Me){const xe=Be(Me,Me.toLowerCase(),I,U,H,j,le);xe&&(xe[0]-=3,(!Y||xe[0]>Y[0])&&(Y=xe))}}}return Y}function ue(Z,J){if(J+1>=Z.length)return;const I=Z[J],U=Z[J+1];if(I!==U)return Z.slice(0,J)+U+I+Z.slice(J+2)}}),define(Ce[116],Ie([1,0,117,115,9]),function(ie,e,r,y,S){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.matchesFuzzyIconAware=e.parseLabelWithIcons=e.stripIcons=e.markdownEscapeEscapedIcons=e.escapeIcons=e.iconStartMarker=void 0,e.iconStartMarker="$(";const M=new RegExp(`\\$\\(${r.CSSIcon.iconNameExpression}(?:${r.CSSIcon.iconModifierExpression})?\\)`,"g"),_=new RegExp(r.CSSIcon.iconNameCharacter),A=new RegExp(`(\\\\)?${M.source}`,"g");function b(d){return d.replace(A,(h,g)=>g?h:`\\${h}`)}e.escapeIcons=b;const P=new RegExp(`\\\\${M.source}`,"g");function O(d){return d.replace(P,h=>`\\${h}`)}e.markdownEscapeEscapedIcons=O;const E=new RegExp(`(\\s)?(\\\\)?${M.source}(\\s)?`,"g");function m(d){return d.indexOf(e.iconStartMarker)===-1?d:d.replace(E,(h,g,C,l)=>C?h:g||l||"")}e.stripIcons=m;function k(d){const h=d.indexOf(e.iconStartMarker);return h===-1?{text:d}:f(d,h)}e.parseLabelWithIcons=k;function f(d,h){const g=[];let C="";function l(o){if(o){C+=o;for(const v of o)g.push(u)}}let w=-1,t="",u=0,i,n,s=h;const a=d.length;for(l(d.substr(0,h));s<a;)i=d[s],n=d[s+1],i===e.iconStartMarker[0]&&n===e.iconStartMarker[1]?(w=s,l(t),t=e.iconStartMarker,s++):i===")"&&w!==-1?(u+=s-w+1,w=-1,t=""):w!==-1?_.test(i)?t+=i:(l(t),w=-1,t=""):l(i),s++;return l(t),{text:C,iconOffsets:g}}function c(d,h,g=!1){const{text:C,iconOffsets:l}=h;if(!l||l.length===0)return(0,y.matchesFuzzy)(d,C,g);const w=(0,S.ltrim)(C," "),t=C.length-w.length,u=(0,y.matchesFuzzy)(d,w,g);if(u)for(const i of u){const n=l[i.start+t]+t;i.start+=n,i.end+=n}return u}e.matchesFuzzyIconAware=c}),define(Ce[29],Ie([1,0,9]),function(ie,e,r){"use strict";Object.defineProperty(e,"__esModule",{value:!0});var y;(function(S){S[S.Ignore=0]="Ignore",S[S.Info=1]="Info",S[S.Warning=2]="Warning",S[S.Error=3]="Error"})(y||(y={})),function(S){const M="error",_="warning",A="warn",b="info",P="ignore";function O(m){return m?r.equalsIgnoreCase(M,m)?S.Error:r.equalsIgnoreCase(_,m)||r.equalsIgnoreCase(A,m)?S.Warning:r.equalsIgnoreCase(b,m)?S.Info:S.Ignore:S.Ignore}S.fromValue=O;function E(m){switch(m){case S.Error:return M;case S.Warning:return _;case S.Info:return b;default:return P}}S.toString=E}(y||(y={})),e.default=y}),define(Ce[76],Ie([1,0,23,9,2]),function(ie,e,r,y,S){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.revive=e.parse=e.stringify=void 0;function M(P){return JSON.stringify(P,A)}e.stringify=M;function _(P){let O=JSON.parse(P);return O=b(O),O}e.parse=_;function A(P,O){return O instanceof RegExp?{$mid:2,source:O.source,flags:(0,y.regExpFlags)(O)}:O}function b(P,O=0){if(!P||O>200)return P;if(typeof P=="object"){switch(P.$mid){case 1:return S.URI.revive(P);case 2:return new RegExp(P.source,P.flags);case 14:return new Date(P.source)}if(P instanceof r.VSBuffer||P instanceof Uint8Array)return P;if(Array.isArray(P))for(let E=0;E<P.length;++E)P[E]=b(P[E],O+1);else for(const E in P)Object.hasOwnProperty.call(P,E)&&(P[E]=b(P[E],O+1))}return P}e.revive=b}),define(Ce[13],Ie([1,0,21,2]),function(ie,e,r,y){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.COI=e.FileAccess=e.RemoteAuthorities=e.connectionTokenQueryName=e.connectionTokenCookieName=e.Schemas=void 0;var S;(function(b){b.inMemory="inmemory",b.vscode="vscode",b.internal="private",b.walkThrough="walkThrough",b.walkThroughSnippet="walkThroughSnippet",b.http="http",b.https="https",b.file="file",b.mailto="mailto",b.untitled="untitled",b.data="data",b.command="command",b.vscodeRemote="vscode-remote",b.vscodeRemoteResource="vscode-remote-resource",b.vscodeUserData="vscode-userdata",b.vscodeCustomEditor="vscode-custom-editor",b.vscodeNotebook="vscode-notebook",b.vscodeNotebookCell="vscode-notebook-cell",b.vscodeNotebookCellMetadata="vscode-notebook-cell-metadata",b.vscodeNotebookCellOutput="vscode-notebook-cell-output",b.vscodeInteractive="vscode-interactive",b.vscodeInteractiveInput="vscode-interactive-input",b.vscodeSettings="vscode-settings",b.vscodeWorkspaceTrust="vscode-workspace-trust",b.vscodeTerminal="vscode-terminal",b.webviewPanel="webview-panel",b.vscodeWebview="vscode-webview",b.extension="extension",b.vscodeFileResource="vscode-file",b.tmp="tmp",b.vsls="vsls",b.vscodeSourceControl="vscode-scm"})(S=e.Schemas||(e.Schemas={})),e.connectionTokenCookieName="vscode-tkn",e.connectionTokenQueryName="tkn";class M{constructor(){this._hosts=Object.create(null),this._ports=Object.create(null),this._connectionTokens=Object.create(null),this._preferredWebSchema="http",this._delegate=null,this._remoteResourcesPath=`/${S.vscodeRemoteResource}`}setPreferredWebSchema(P){this._preferredWebSchema=P}setDelegate(P){this._delegate=P}setServerRootPath(P){this._remoteResourcesPath=`${P}/${S.vscodeRemoteResource}`}set(P,O,E){this._hosts[P]=O,this._ports[P]=E}setConnectionToken(P,O){this._connectionTokens[P]=O}getPreferredWebSchema(){return this._preferredWebSchema}rewrite(P){if(this._delegate)return this._delegate(P);const O=P.authority;let E=this._hosts[O];E&&E.indexOf(":")!==-1&&(E=`[${E}]`);const m=this._ports[O],k=this._connectionTokens[O];let f=`path=${encodeURIComponent(P.path)}`;return typeof k=="string"&&(f+=`&${e.connectionTokenQueryName}=${encodeURIComponent(k)}`),y.URI.from({scheme:r.isWeb?this._preferredWebSchema:S.vscodeRemoteResource,authority:`${E}:${m}`,path:this._remoteResourcesPath,query:f})}}e.RemoteAuthorities=new M;class _{asBrowserUri(P,O){const E=this.toUri(P,O);return E.scheme===S.vscodeRemote?e.RemoteAuthorities.rewrite(E):E.scheme===S.file&&(r.isNative||r.isWebWorker&&r.globals.origin===`${S.vscodeFileResource}://${_.FALLBACK_AUTHORITY}`)?E.with({scheme:S.vscodeFileResource,authority:E.authority||_.FALLBACK_AUTHORITY,query:null,fragment:null}):E}asFileUri(P,O){const E=this.toUri(P,O);return E.scheme===S.vscodeFileResource?E.with({scheme:S.file,authority:E.authority!==_.FALLBACK_AUTHORITY?E.authority:null,query:null,fragment:null}):E}toUri(P,O){return y.URI.isUri(P)?P:y.URI.parse(O.toUrl(P))}}_.FALLBACK_AUTHORITY="vscode-app",e.FileAccess=new _;var A;(function(b){const P=new Map([["1",{"Cross-Origin-Opener-Policy":"same-origin"}],["2",{"Cross-Origin-Embedder-Policy":"require-corp"}],["3",{"Cross-Origin-Opener-Policy":"same-origin","Cross-Origin-Embedder-Policy":"require-corp"}]]);b.CoopAndCoep=Object.freeze(P.get("3"));const O="vscode-coi";function E(k){let f;typeof k=="string"?f=new URL(k).searchParams:k instanceof URL?f=k.searchParams:y.URI.isUri(k)&&(f=new URL(k.toString(!0)).searchParams);const c=f?.get(O);if(!!c)return P.get(c)}b.getHeadersFromQuery=E;function m(k,f,c){if(!globalThis.crossOriginIsolated)return;const d=f&&c?"3":c?"2":"1";k instanceof URLSearchParams?k.set(O,d):k[O]=d}b.addSearchParam=m})(A=e.COI||(e.COI={}))}),define(Ce[22],Ie([1,0,38,13,19,21,9,2]),function(ie,e,r,y,S,M,_,A){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.toLocalResource=e.DataUri=e.distinctParents=e.addTrailingPathSeparator=e.removeTrailingPathSeparator=e.hasTrailingPathSeparator=e.isEqualAuthority=e.isAbsolutePath=e.resolvePath=e.relativePath=e.normalizePath=e.joinPath=e.dirname=e.extname=e.basename=e.basenameOrAuthority=e.getComparisonKey=e.isEqualOrParent=e.isEqual=e.extUriIgnorePathCase=e.extUriBiasedIgnorePathCase=e.extUri=e.ExtUri=e.originalFSPath=void 0;function b(k){return(0,A.uriToFsPath)(k,!0)}e.originalFSPath=b;class P{constructor(f){this._ignorePathCasing=f}compare(f,c,d=!1){return f===c?0:(0,_.compare)(this.getComparisonKey(f,d),this.getComparisonKey(c,d))}isEqual(f,c,d=!1){return f===c?!0:!f||!c?!1:this.getComparisonKey(f,d)===this.getComparisonKey(c,d)}getComparisonKey(f,c=!1){return f.with({path:this._ignorePathCasing(f)?f.path.toLowerCase():void 0,fragment:c?null:void 0}).toString()}ignorePathCasing(f){return this._ignorePathCasing(f)}isEqualOrParent(f,c,d=!1){if(f.scheme===c.scheme){if(f.scheme===y.Schemas.file)return r.isEqualOrParent(b(f),b(c),this._ignorePathCasing(f))&&f.query===c.query&&(d||f.fragment===c.fragment);if((0,e.isEqualAuthority)(f.authority,c.authority))return r.isEqualOrParent(f.path,c.path,this._ignorePathCasing(f),"/")&&f.query===c.query&&(d||f.fragment===c.fragment)}return!1}joinPath(f,...c){return A.URI.joinPath(f,...c)}basenameOrAuthority(f){return(0,e.basename)(f)||f.authority}basename(f){return S.posix.basename(f.path)}extname(f){return S.posix.extname(f.path)}dirname(f){if(f.path.length===0)return f;let c;return f.scheme===y.Schemas.file?c=A.URI.file(S.dirname(b(f))).path:(c=S.posix.dirname(f.path),f.authority&&c.length&&c.charCodeAt(0)!==47&&(console.error(`dirname("${f.toString})) resulted in a relative path`),c="/")),f.with({path:c})}normalizePath(f){if(!f.path.length)return f;let c;return f.scheme===y.Schemas.file?c=A.URI.file(S.normalize(b(f))).path:c=S.posix.normalize(f.path),f.with({path:c})}relativePath(f,c){if(f.scheme!==c.scheme||!(0,e.isEqualAuthority)(f.authority,c.authority))return;if(f.scheme===y.Schemas.file){const g=S.relative(b(f),b(c));return M.isWindows?r.toSlashes(g):g}let d=f.path||"/";const h=c.path||"/";if(this._ignorePathCasing(f)){let g=0;for(const C=Math.min(d.length,h.length);g<C&&!(d.charCodeAt(g)!==h.charCodeAt(g)&&d.charAt(g).toLowerCase()!==h.charAt(g).toLowerCase());g++);d=h.substr(0,g)+d.substr(g)}return S.posix.relative(d,h)}resolvePath(f,c){if(f.scheme===y.Schemas.file){const d=A.URI.file(S.resolve(b(f),c));return f.with({authority:d.authority,path:d.path})}return c=r.toPosixPath(c),f.with({path:S.posix.resolve(f.path,c)})}isAbsolutePath(f){return!!f.path&&f.path[0]==="/"}isEqualAuthority(f,c){return f===c||f!==void 0&&c!==void 0&&(0,_.equalsIgnoreCase)(f,c)}hasTrailingPathSeparator(f,c=S.sep){if(f.scheme===y.Schemas.file){const d=b(f);return d.length>r.getRoot(d).length&&d[d.length-1]===c}else{const d=f.path;return d.length>1&&d.charCodeAt(d.length-1)===47&&!/^[a-zA-Z]:(\/$|\\$)/.test(f.fsPath)}}removeTrailingPathSeparator(f,c=S.sep){return(0,e.hasTrailingPathSeparator)(f,c)?f.with({path:f.path.substr(0,f.path.length-1)}):f}addTrailingPathSeparator(f,c=S.sep){let d=!1;if(f.scheme===y.Schemas.file){const h=b(f);d=h!==void 0&&h.length===r.getRoot(h).length&&h[h.length-1]===c}else{c="/";const h=f.path;d=h.length===1&&h.charCodeAt(h.length-1)===47}return!d&&!(0,e.hasTrailingPathSeparator)(f,c)?f.with({path:f.path+"/"}):f}}e.ExtUri=P,e.extUri=new P(()=>!1),e.extUriBiasedIgnorePathCase=new P(k=>k.scheme===y.Schemas.file?!M.isLinux:!0),e.extUriIgnorePathCase=new P(k=>!0),e.isEqual=e.extUri.isEqual.bind(e.extUri),e.isEqualOrParent=e.extUri.isEqualOrParent.bind(e.extUri),e.getComparisonKey=e.extUri.getComparisonKey.bind(e.extUri),e.basenameOrAuthority=e.extUri.basenameOrAuthority.bind(e.extUri),e.basename=e.extUri.basename.bind(e.extUri),e.extname=e.extUri.extname.bind(e.extUri),e.dirname=e.extUri.dirname.bind(e.extUri),e.joinPath=e.extUri.joinPath.bind(e.extUri),e.normalizePath=e.extUri.normalizePath.bind(e.extUri),e.relativePath=e.extUri.relativePath.bind(e.extUri),e.resolvePath=e.extUri.resolvePath.bind(e.extUri),e.isAbsolutePath=e.extUri.isAbsolutePath.bind(e.extUri),e.isEqualAuthority=e.extUri.isEqualAuthority.bind(e.extUri),e.hasTrailingPathSeparator=e.extUri.hasTrailingPathSeparator.bind(e.extUri),e.removeTrailingPathSeparator=e.extUri.removeTrailingPathSeparator.bind(e.extUri),e.addTrailingPathSeparator=e.extUri.addTrailingPathSeparator.bind(e.extUri);function O(k,f){const c=[];for(let d=0;d<k.length;d++){const h=f(k[d]);k.some((g,C)=>C===d?!1:(0,e.isEqualOrParent)(h,f(g)))||c.push(k[d])}return c}e.distinctParents=O;var E;(function(k){k.META_DATA_LABEL="label",k.META_DATA_DESCRIPTION="description",k.META_DATA_SIZE="size",k.META_DATA_MIME="mime";function f(c){const d=new Map;c.path.substring(c.path.indexOf(";")+1,c.path.lastIndexOf(";")).split(";").forEach(C=>{const[l,w]=C.split(":");l&&w&&d.set(l,w)});const g=c.path.substring(0,c.path.indexOf(";"));return g&&d.set(k.META_DATA_MIME,g),d}k.parseMetaData=f})(E=e.DataUri||(e.DataUri={}));function m(k,f,c){if(f){let d=k.path;return d&&d[0]!==S.posix.sep&&(d=S.posix.sep+d),k.with({scheme:c,authority:f,path:d})}return k.with({scheme:c})}e.toLocalResource=m}),define(Ce[15],Ie([1,0,20,12,5,7,22,21]),function(ie,e,r,y,S,M,_,A){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.createCancelableAsyncIterable=e.CancelableAsyncIterableObject=e.AsyncIterableObject=e.Promises=e.DeferredPromise=e.IntervalCounter=e.TaskSequentializer=e.retry=e.IdleValue=e.runWhenIdle=e.ThrottledWorker=e.RunOnceWorker=e.ProcessTimeRunOnceScheduler=e.RunOnceScheduler=e.IntervalTimer=e.TimeoutTimer=e.ResourceQueue=e.Queue=e.Limiter=e.firstParallel=e.first=e.sequence=e.disposableTimeout=e.timeout=e.AutoOpenBarrier=e.Barrier=e.ThrottledDelayer=e.Delayer=e.MicrotaskDelay=e.SequencerByKey=e.Sequencer=e.Throttler=e.asPromise=e.raceTimeout=e.raceCancellablePromises=e.raceCancellationError=e.raceCancellation=e.createCancelablePromise=e.isThenable=void 0;function b(me){return!!me&&typeof me.then=="function"}e.isThenable=b;function P(me){const ee=new r.CancellationTokenSource,be=me(ee.token),_e=new Promise((Fe,Be)=>{const Xe=ee.token.onCancellationRequested(()=>{Xe.dispose(),ee.dispose(),Be(new y.CancellationError)});Promise.resolve(be).then(ke=>{Xe.dispose(),ee.dispose(),Fe(ke)},ke=>{Xe.dispose(),ee.dispose(),Be(ke)})});return new class{cancel(){ee.cancel()}then(Fe,Be){return _e.then(Fe,Be)}catch(Fe){return this.then(void 0,Fe)}finally(Fe){return _e.finally(Fe)}}}e.createCancelablePromise=P;function O(me,ee,be){return new Promise((_e,Fe)=>{const Be=ee.onCancellationRequested(()=>{Be.dispose(),_e(be)});me.then(_e,Fe).finally(()=>Be.dispose())})}e.raceCancellation=O;function E(me,ee){return new Promise((be,_e)=>{const Fe=ee.onCancellationRequested(()=>{Fe.dispose(),_e(new y.CancellationError)});me.then(be,_e).finally(()=>Fe.dispose())})}e.raceCancellationError=E;async function m(me){let ee=-1;const be=me.map((Fe,Be)=>Fe.then(Xe=>(ee=Be,Xe))),_e=await Promise.race(be);return me.forEach((Fe,Be)=>{Be!==ee&&Fe.cancel()}),_e}e.raceCancellablePromises=m;function k(me,ee,be){let _e;const Fe=setTimeout(()=>{_e?.(void 0),be?.()},ee);return Promise.race([me.finally(()=>clearTimeout(Fe)),new Promise(Be=>_e=Be)])}e.raceTimeout=k;function f(me){return new Promise((ee,be)=>{const _e=me();b(_e)?_e.then(ee,be):ee(_e)})}e.asPromise=f;class c{constructor(){this.activePromise=null,this.queuedPromise=null,this.queuedPromiseFactory=null}queue(ee){if(this.activePromise){if(this.queuedPromiseFactory=ee,!this.queuedPromise){const be=()=>{this.queuedPromise=null;const _e=this.queue(this.queuedPromiseFactory);return this.queuedPromiseFactory=null,_e};this.queuedPromise=new Promise(_e=>{this.activePromise.then(be,be).then(_e)})}return new Promise((be,_e)=>{this.queuedPromise.then(be,_e)})}return this.activePromise=ee(),new Promise((be,_e)=>{this.activePromise.then(Fe=>{this.activePromise=null,be(Fe)},Fe=>{this.activePromise=null,_e(Fe)})})}}e.Throttler=c;class d{constructor(){this.current=Promise.resolve(null)}queue(ee){return this.current=this.current.then(()=>ee(),()=>ee())}}e.Sequencer=d;class h{constructor(){this.promiseMap=new Map}queue(ee,be){const Fe=(this.promiseMap.get(ee)??Promise.resolve()).catch(()=>{}).then(be).finally(()=>{this.promiseMap.get(ee)===Fe&&this.promiseMap.delete(ee)});return this.promiseMap.set(ee,Fe),Fe}}e.SequencerByKey=h;const g=(me,ee)=>{let be=!0;const _e=setTimeout(()=>{be=!1,ee()},me);return{isTriggered:()=>be,dispose:()=>{clearTimeout(_e),be=!1}}},C=me=>{let ee=!0;return queueMicrotask(()=>{ee&&(ee=!1,me())}),{isTriggered:()=>ee,dispose:()=>{ee=!1}}};e.MicrotaskDelay=Symbol("MicrotaskDelay");class l{constructor(ee){this.defaultDelay=ee,this.deferred=null,this.completionPromise=null,this.doResolve=null,this.doReject=null,this.task=null}trigger(ee,be=this.defaultDelay){this.task=ee,this.cancelTimeout(),this.completionPromise||(this.completionPromise=new Promise((Fe,Be)=>{this.doResolve=Fe,this.doReject=Be}).then(()=>{if(this.completionPromise=null,this.doResolve=null,this.task){const Fe=this.task;return this.task=null,Fe()}}));const _e=()=>{this.deferred=null,this.doResolve?.(null)};return this.deferred=be===e.MicrotaskDelay?C(_e):g(be,_e),this.completionPromise}isTriggered(){return!!this.deferred?.isTriggered()}cancel(){this.cancelTimeout(),this.completionPromise&&(this.doReject?.(new y.CancellationError),this.completionPromise=null)}cancelTimeout(){this.deferred?.dispose(),this.deferred=null}dispose(){this.cancel()}}e.Delayer=l;class w{constructor(ee){this.delayer=new l(ee),this.throttler=new c}trigger(ee,be){return this.delayer.trigger(()=>this.throttler.queue(ee),be)}isTriggered(){return this.delayer.isTriggered()}cancel(){this.delayer.cancel()}dispose(){this.delayer.dispose()}}e.ThrottledDelayer=w;class t{constructor(){this._isOpen=!1,this._promise=new Promise((ee,be)=>{this._completePromise=ee})}isOpen(){return this._isOpen}open(){this._isOpen=!0,this._completePromise(!0)}wait(){return this._promise}}e.Barrier=t;class u extends t{constructor(ee){super(),this._timeout=setTimeout(()=>this.open(),ee)}open(){clearTimeout(this._timeout),super.open()}}e.AutoOpenBarrier=u;function i(me,ee){return ee?new Promise((be,_e)=>{const Fe=setTimeout(()=>{Be.dispose(),be()},me),Be=ee.onCancellationRequested(()=>{clearTimeout(Fe),Be.dispose(),_e(new y.CancellationError)})}):P(be=>i(me,be))}e.timeout=i;function n(me,ee=0){const be=setTimeout(me,ee);return(0,M.toDisposable)(()=>clearTimeout(be))}e.disposableTimeout=n;function s(me){const ee=[];let be=0;const _e=me.length;function Fe(){return be<_e?me[be++]():null}function Be(Xe){Xe!=null&&ee.push(Xe);const ke=Fe();return ke?ke.then(Be):Promise.resolve(ee)}return Promise.resolve(null).then(Be)}e.sequence=s;function a(me,ee=_e=>!!_e,be=null){let _e=0;const Fe=me.length,Be=()=>{if(_e>=Fe)return Promise.resolve(be);const Xe=me[_e++];return Promise.resolve(Xe()).then(ye=>ee(ye)?Promise.resolve(ye):Be())};return Be()}e.first=a;function o(me,ee=_e=>!!_e,be=null){if(me.length===0)return Promise.resolve(be);let _e=me.length;const Fe=()=>{_e=-1;for(const Be of me)Be.cancel?.()};return new Promise((Be,Xe)=>{for(const ke of me)ke.then(ye=>{--_e>=0&&ee(ye)?(Fe(),Be(ye)):_e===0&&Be(be)}).catch(ye=>{--_e>=0&&(Fe(),Xe(ye))})})}e.firstParallel=o;class v{constructor(ee){this._size=0,this.maxDegreeOfParalellism=ee,this.outstandingPromises=[],this.runningPromises=0,this._onDrained=new S.Emitter}get onDrained(){return this._onDrained.event}get size(){return this._size}queue(ee){return this._size++,new Promise((be,_e)=>{this.outstandingPromises.push({factory:ee,c:be,e:_e}),this.consume()})}consume(){for(;this.outstandingPromises.length&&this.runningPromises<this.maxDegreeOfParalellism;){const ee=this.outstandingPromises.shift();this.runningPromises++;const be=ee.factory();be.then(ee.c,ee.e),be.then(()=>this.consumed(),()=>this.consumed())}}consumed(){this._size--,this.runningPromises--,this.outstandingPromises.length>0?this.consume():this._onDrained.fire()}dispose(){this._onDrained.dispose()}}e.Limiter=v;class p extends v{constructor(){super(1)}}e.Queue=p;class T{constructor(){this.queues=new Map,this.drainers=new Set}async whenDrained(){if(this.isDrained())return;const ee=new G;return this.drainers.add(ee),ee.p}isDrained(){for(const[,ee]of this.queues)if(ee.size>0)return!1;return!0}queueFor(ee,be=_.extUri){const _e=be.getComparisonKey(ee);let Fe=this.queues.get(_e);return Fe||(Fe=new p,S.Event.once(Fe.onDrained)(()=>{Fe?.dispose(),this.queues.delete(_e),this.onDidQueueDrain()}),this.queues.set(_e,Fe)),Fe}onDidQueueDrain(){!this.isDrained()||this.releaseDrainers()}releaseDrainers(){for(const ee of this.drainers)ee.complete();this.drainers.clear()}dispose(){for(const[,ee]of this.queues)ee.dispose();this.queues.clear(),this.releaseDrainers()}}e.ResourceQueue=T;class N{constructor(ee,be){this._token=-1,typeof ee=="function"&&typeof be=="number"&&this.setIfNotSet(ee,be)}dispose(){this.cancel()}cancel(){this._token!==-1&&(clearTimeout(this._token),this._token=-1)}cancelAndSet(ee,be){this.cancel(),this._token=setTimeout(()=>{this._token=-1,ee()},be)}setIfNotSet(ee,be){this._token===-1&&(this._token=setTimeout(()=>{this._token=-1,ee()},be))}}e.TimeoutTimer=N;class V{constructor(){this._token=-1}dispose(){this.cancel()}cancel(){this._token!==-1&&(clearInterval(this._token),this._token=-1)}cancelAndSet(ee,be){this.cancel(),this._token=setInterval(()=>{ee()},be)}}e.IntervalTimer=V;class B{constructor(ee,be){this.timeoutToken=-1,this.runner=ee,this.timeout=be,this.timeoutHandler=this.onTimeout.bind(this)}dispose(){this.cancel(),this.runner=null}cancel(){this.isScheduled()&&(clearTimeout(this.timeoutToken),this.timeoutToken=-1)}schedule(ee=this.timeout){this.cancel(),this.timeoutToken=setTimeout(this.timeoutHandler,ee)}get delay(){return this.timeout}set delay(ee){this.timeout=ee}isScheduled(){return this.timeoutToken!==-1}onTimeout(){this.timeoutToken=-1,this.runner&&this.doRun()}doRun(){this.runner?.()}}e.RunOnceScheduler=B;class D{constructor(ee,be){be%1e3!==0&&console.warn(`ProcessTimeRunOnceScheduler resolution is 1s, ${be}ms is not a multiple of 1000ms.`),this.runner=ee,this.timeout=be,this.counter=0,this.intervalToken=-1,this.intervalHandler=this.onInterval.bind(this)}dispose(){this.cancel(),this.runner=null}cancel(){this.isScheduled()&&(clearInterval(this.intervalToken),this.intervalToken=-1)}schedule(ee=this.timeout){ee%1e3!==0&&console.warn(`ProcessTimeRunOnceScheduler resolution is 1s, ${ee}ms is not a multiple of 1000ms.`),this.cancel(),this.counter=Math.ceil(ee/1e3),this.intervalToken=setInterval(this.intervalHandler,1e3)}isScheduled(){return this.intervalToken!==-1}onInterval(){this.counter--,!(this.counter>0)&&(clearInterval(this.intervalToken),this.intervalToken=-1,this.runner?.())}}e.ProcessTimeRunOnceScheduler=D;class z extends B{constructor(ee,be){super(ee,be),this.units=[]}work(ee){this.units.push(ee),this.isScheduled()||this.schedule()}doRun(){const ee=this.units;this.units=[],this.runner?.(ee)}dispose(){this.units=[],super.dispose()}}e.RunOnceWorker=z;class L extends M.Disposable{constructor(ee,be){super(),this.options=ee,this.handler=be,this.pendingWork=[],this.throttler=this._register(new M.MutableDisposable),this.disposed=!1}get pending(){return this.pendingWork.length}work(ee){if(this.disposed)return!1;if(typeof this.options.maxBufferedWork=="number"){if(this.throttler.value){if(this.pending+ee.length>this.options.maxBufferedWork)return!1}else if(this.pending+ee.length-this.options.maxWorkChunkSize>this.options.maxBufferedWork)return!1}return this.pendingWork.push(...ee),this.throttler.value||this.doWork(),!0}doWork(){this.handler(this.pendingWork.splice(0,this.options.maxWorkChunkSize)),this.pendingWork.length>0&&(this.throttler.value=new B(()=>{this.throttler.clear(),this.doWork()},this.options.throttleDelay),this.throttler.value.schedule())}dispose(){super.dispose(),this.disposed=!0}}e.ThrottledWorker=L,function(){typeof requestIdleCallback!="function"||typeof cancelIdleCallback!="function"?e.runWhenIdle=me=>{(0,A.setTimeout0)(()=>{if(ee)return;const be=Date.now()+15;me(Object.freeze({didTimeout:!0,timeRemaining(){return Math.max(0,be-Date.now())}}))});let ee=!1;return{dispose(){ee||(ee=!0)}}}:e.runWhenIdle=(me,ee)=>{const be=requestIdleCallback(me,typeof ee=="number"?{timeout:ee}:void 0);let _e=!1;return{dispose(){_e||(_e=!0,cancelIdleCallback(be))}}}}();class R{constructor(ee){this._didRun=!1,this._executor=()=>{try{this._value=ee()}catch(be){this._error=be}finally{this._didRun=!0}},this._handle=(0,e.runWhenIdle)(()=>this._executor())}dispose(){this._handle.dispose()}get value(){if(this._didRun||(this._handle.dispose(),this._executor()),this._error)throw this._error;return this._value}get isInitialized(){return this._didRun}}e.IdleValue=R;async function K(me,ee,be){let _e;for(let Fe=0;Fe<be;Fe++)try{return await me()}catch(Be){_e=Be,await i(ee)}throw _e}e.retry=K;class W{hasPending(ee){return this._pending?typeof ee=="number"?this._pending.taskId===ee:!!this._pending:!1}get pending(){return this._pending?.promise}cancelPending(){this._pending?.cancel()}setPending(ee,be,_e){return this._pending={taskId:ee,cancel:()=>_e?.(),promise:be},be.then(()=>this.donePending(ee),()=>this.donePending(ee)),be}donePending(ee){this._pending&&ee===this._pending.taskId&&(this._pending=void 0,this.triggerNext())}triggerNext(){if(this._next){const ee=this._next;this._next=void 0,ee.run().then(ee.promiseResolve,ee.promiseReject)}}setNext(ee){if(this._next)this._next.run=ee;else{let be,_e;const Fe=new Promise((Be,Xe)=>{be=Be,_e=Xe});this._next={run:ee,promise:Fe,promiseResolve:be,promiseReject:_e}}return this._next.promise}hasNext(){return!!this._next}async join(){return this._next?.promise??this._pending?.promise}}e.TaskSequentializer=W;class ${constructor(ee,be=()=>Date.now()){this.interval=ee,this.nowFn=be,this.lastIncrementTime=0,this.value=0}increment(){const ee=this.nowFn();return ee-this.lastIncrementTime>this.interval&&(this.lastIncrementTime=ee,this.value=0),this.value++,this.value}}e.IntervalCounter=$;class G{get isRejected(){return this.rejected}get isResolved(){return this.resolved}get isSettled(){return this.rejected||this.resolved}constructor(){this.rejected=!1,this.resolved=!1,this.p=new Promise((ee,be)=>{this.completeCallback=ee,this.errorCallback=be})}complete(ee){return new Promise(be=>{this.completeCallback(ee),this.resolved=!0,be()})}error(ee){return new Promise(be=>{this.errorCallback(ee),this.rejected=!0,be()})}cancel(){new Promise(ee=>{this.errorCallback(new y.CancellationError),this.rejected=!0,ee()})}}e.DeferredPromise=G;var ne;(function(me){async function ee(_e){let Fe;const Be=await Promise.all(_e.map(Xe=>Xe.then(ke=>ke,ke=>{Fe||(Fe=ke)})));if(typeof Fe<"u")throw Fe;return Be}me.settled=ee;function be(_e){return new Promise(async(Fe,Be)=>{try{await _e(Fe,Be)}catch(Xe){Be(Xe)}})}me.withAsyncBody=be})(ne=e.Promises||(e.Promises={}));var ge;(function(me){me[me.Initial=0]="Initial",me[me.DoneOK=1]="DoneOK",me[me.DoneError=2]="DoneError"})(ge||(ge={}));class oe{static fromArray(ee){return new oe(be=>{be.emitMany(ee)})}static fromPromise(ee){return new oe(async be=>{be.emitMany(await ee)})}static fromPromises(ee){return new oe(async be=>{await Promise.all(ee.map(async _e=>be.emitOne(await _e)))})}static merge(ee){return new oe(async be=>{await Promise.all(ee.map(async _e=>{for await(const Fe of _e)be.emitOne(Fe)}))})}constructor(ee){this._state=0,this._results=[],this._error=null,this._onStateChanged=new S.Emitter,queueMicrotask(async()=>{const be={emitOne:_e=>this.emitOne(_e),emitMany:_e=>this.emitMany(_e),reject:_e=>this.reject(_e)};try{await Promise.resolve(ee(be)),this.resolve()}catch(_e){this.reject(_e)}finally{be.emitOne=void 0,be.emitMany=void 0,be.reject=void 0}})}[Symbol.asyncIterator](){let ee=0;return{next:async()=>{do{if(this._state===2)throw this._error;if(ee<this._results.length)return{done:!1,value:this._results[ee++]};if(this._state===1)return{done:!0,value:void 0};await S.Event.toPromise(this._onStateChanged.event)}while(!0)}}}static map(ee,be){return new oe(async _e=>{for await(const Fe of ee)_e.emitOne(be(Fe))})}map(ee){return oe.map(this,ee)}static filter(ee,be){return new oe(async _e=>{for await(const Fe of ee)be(Fe)&&_e.emitOne(Fe)})}filter(ee){return oe.filter(this,ee)}static coalesce(ee){return oe.filter(ee,be=>!!be)}coalesce(){return oe.coalesce(this)}static async toPromise(ee){const be=[];for await(const _e of ee)be.push(_e);return be}toPromise(){return oe.toPromise(this)}emitOne(ee){this._state===0&&(this._results.push(ee),this._onStateChanged.fire())}emitMany(ee){this._state===0&&(this._results=this._results.concat(ee),this._onStateChanged.fire())}resolve(){this._state===0&&(this._state=1,this._onStateChanged.fire())}reject(ee){this._state===0&&(this._state=2,this._error=ee,this._onStateChanged.fire())}}e.AsyncIterableObject=oe,oe.EMPTY=oe.fromArray([]);class Ee extends oe{constructor(ee,be){super(be),this._source=ee}cancel(){this._source.cancel()}}e.CancelableAsyncIterableObject=Ee;function ce(me){const ee=new r.CancellationTokenSource,be=me(ee.token);return new Ee(ee,async _e=>{const Fe=ee.token.onCancellationRequested(()=>{Fe.dispose(),ee.dispose(),_e.reject(new y.CancellationError)});try{for await(const Be of be){if(ee.token.isCancellationRequested)return;_e.emitOne(Be)}Fe.dispose(),ee.dispose()}catch(Be){Fe.dispose(),ee.dispose(),_e.reject(Be)}})}e.createCancelableAsyncIterable=ce}),define(Ce[118],Ie([1,0,15,19]),function(ie,e,r,y){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.compareByPrefix=e.compareAnything=e.comparePaths=e.compareFileExtensionsUnicode=e.compareFileExtensionsLower=e.compareFileExtensionsUpper=e.compareFileExtensionsDefault=e.compareFileExtensions=e.noIntlCompareFileNames=e.compareFileNamesUnicode=e.compareFileNamesLower=e.compareFileNamesUpper=e.compareFileNamesDefault=e.compareFileNames=void 0;const S=new r.IdleValue(()=>{const p=new Intl.Collator(void 0,{numeric:!0,sensitivity:"base"});return{collator:p,collatorIsNumeric:p.resolvedOptions().numeric}}),M=new r.IdleValue(()=>({collator:new Intl.Collator(void 0,{numeric:!0})})),_=new r.IdleValue(()=>({collator:new Intl.Collator(void 0,{numeric:!0,sensitivity:"accent"})}));function A(p,T,N=!1){const V=p||"",B=T||"",D=S.value.collator.compare(V,B);return S.value.collatorIsNumeric&&D===0&&V!==B?V<B?-1:1:D}e.compareFileNames=A;function b(p,T){const N=M.value.collator;return p=p||"",T=T||"",w(N,p,T)}e.compareFileNamesDefault=b;function P(p,T){const N=M.value.collator;return p=p||"",T=T||"",n(p,T)||w(N,p,T)}e.compareFileNamesUpper=P;function O(p,T){const N=M.value.collator;return p=p||"",T=T||"",i(p,T)||w(N,p,T)}e.compareFileNamesLower=O;function E(p,T){return p=p||"",T=T||"",p===T?0:p<T?-1:1}e.compareFileNamesUnicode=E;function m(p,T,N=!1){N||(p=p&&p.toLowerCase(),T=T&&T.toLowerCase());const[V,B]=C(p),[D,z]=C(T);return V!==D?V<D?-1:1:B===z?0:B<z?-1:1}e.noIntlCompareFileNames=m;function k(p,T){const[N,V]=C(p),[B,D]=C(T);let z=S.value.collator.compare(V,D);if(z===0){if(S.value.collatorIsNumeric&&V!==D)return V<D?-1:1;if(z=S.value.collator.compare(N,B),S.value.collatorIsNumeric&&z===0&&N!==B)return N<B?-1:1}return z}e.compareFileExtensions=k;function f(p,T){p=p||"",T=T||"";const N=l(p),V=l(T),B=M.value.collator,D=_.value.collator;return w(D,N,V)||w(B,p,T)}e.compareFileExtensionsDefault=f;function c(p,T){p=p||"",T=T||"";const N=l(p),V=l(T),B=M.value.collator,D=_.value.collator;return w(D,N,V)||n(p,T)||w(B,p,T)}e.compareFileExtensionsUpper=c;function d(p,T){p=p||"",T=T||"";const N=l(p),V=l(T),B=M.value.collator,D=_.value.collator;return w(D,N,V)||i(p,T)||w(B,p,T)}e.compareFileExtensionsLower=d;function h(p,T){p=p||"",T=T||"";const N=l(p).toLowerCase(),V=l(T).toLowerCase();return N!==V?N<V?-1:1:p!==T?p<T?-1:1:0}e.compareFileExtensionsUnicode=h;const g=/^(.*?)(\.([^.]*))?$/;function C(p,T=!1){const N=p?g.exec(p):[];let V=[N&&N[1]||"",N&&N[3]||""];return T&&(!V[0]&&V[1]||V[0]&&V[0].charAt(0)===".")&&(V=[V[0]+"."+V[1],""]),V}function l(p){const T=p?g.exec(p):[];return T&&T[1]&&T[1].charAt(0)!=="."&&T[3]||""}function w(p,T,N){const V=p.compare(T,N);return V!==0?V:T.length!==N.length?T.length<N.length?-1:1:0}function t(p){const T=p.charAt(0);return T.toLocaleUpperCase()!==T}function u(p){const T=p.charAt(0);return T.toLocaleLowerCase()!==T}function i(p,T){return t(p)&&u(T)?-1:u(p)&&t(T)?1:0}function n(p,T){return u(p)&&t(T)?-1:t(p)&&u(T)?1:0}function s(p,T,N=!1){return N||(p=p&&p.toLowerCase(),T=T&&T.toLowerCase()),p===T?0:p<T?-1:1}function a(p,T,N=!1){const V=p.split(y.sep),B=T.split(y.sep),D=V.length-1,z=B.length-1;let L,R;for(let K=0;;K++){if(L=D===K,R=z===K,L&&R)return A(V[K],B[K],N);if(L)return-1;if(R)return 1;const W=s(V[K],B[K],N);if(W!==0)return W}}e.comparePaths=a;function o(p,T,N){const V=p.toLowerCase(),B=T.toLowerCase(),D=v(p,T,N);if(D)return D;const z=V.endsWith(N),L=B.endsWith(N);if(z!==L)return z?-1:1;const R=A(V,B);return R!==0?R:V.localeCompare(B)}e.compareAnything=o;function v(p,T,N){const V=p.toLowerCase(),B=T.toLowerCase(),D=V.startsWith(N),z=B.startsWith(N);if(D!==z)return D?-1:1;if(D&&z){if(V.length<B.length)return-1;if(V.length>B.length)return 1}return 0}e.compareByPrefix=v}),define(Ce[34],Ie([1,0,18,15,38,24,19,21,9]),function(ie,e,r,y,S,M,_,A,b){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.patternsEquals=e.getPathTerms=e.getBasenameTerms=e.isRelativePattern=e.parse=e.match=e.splitGlobAware=e.GLOB_SPLIT=e.GLOBSTAR=e.getEmptyExpression=void 0;function P(){return Object.create(null)}e.getEmptyExpression=P,e.GLOBSTAR="**",e.GLOB_SPLIT="/";const O="[/\\\\]",E="[^/\\\\]",m=/\//g;function k(G,ne){switch(G){case 0:return"";case 1:return`${E}*?`;default:return`(?:${O}|${E}+${O}${ne?`|${O}${E}+`:""})*?`}}function f(G,ne){if(!G)return[];const ge=[];let oe=!1,Ee=!1,ce="";for(const me of G){switch(me){case ne:if(!oe&&!Ee){ge.push(ce),ce="";continue}break;case"{":oe=!0;break;case"}":oe=!1;break;case"[":Ee=!0;break;case"]":Ee=!1;break}ce+=me}return ce&&ge.push(ce),ge}e.splitGlobAware=f;function c(G){if(!G)return"";let ne="";const ge=f(G,e.GLOB_SPLIT);if(ge.every(oe=>oe===e.GLOBSTAR))ne=".*";else{let oe=!1;ge.forEach((Ee,ce)=>{if(Ee===e.GLOBSTAR){if(oe)return;ne+=k(2,ce===ge.length-1)}else{let me=!1,ee="",be=!1,_e="";for(const Fe of Ee){if(Fe!=="}"&&me){ee+=Fe;continue}if(be&&(Fe!=="]"||!_e)){let Be;Fe==="-"?Be=Fe:(Fe==="^"||Fe==="!")&&!_e?Be="^":Fe===e.GLOB_SPLIT?Be="":Be=(0,b.escapeRegExpCharacters)(Fe),_e+=Be;continue}switch(Fe){case"{":me=!0;continue;case"[":be=!0;continue;case"}":{ne+=`(?:${f(ee,",").map(ke=>c(ke)).join("|")})`,me=!1,ee="";break}case"]":{ne+="["+_e+"]",be=!1,_e="";break}case"?":ne+=E;continue;case"*":ne+=k(1);continue;default:ne+=(0,b.escapeRegExpCharacters)(Fe)}}ce<ge.length-1&&(ge[ce+1]!==e.GLOBSTAR||ce+2<ge.length)&&(ne+=O)}oe=Ee===e.GLOBSTAR})}return ne}const d=/^\*\*\/\*\.[\w\.-]+$/,h=/^\*\*\/([\w\.-]+)\/?$/,g=/^{\*\*\/\*?[\w\.-]+\/?(,\*\*\/\*?[\w\.-]+\/?)*}$/,C=/^{\*\*\/\*?[\w\.-]+(\/(\*\*)?)?(,\*\*\/\*?[\w\.-]+(\/(\*\*)?)?)*}$/,l=/^\*\*((\/[\w\.-]+)+)\/?$/,w=/^([\w\.-]+(\/[\w\.-]+)*)\/?$/,t=new M.LRUCache(1e4),u=function(){return!1},i=function(){return null};function n(G,ne){if(!G)return i;let ge;typeof G!="string"?ge=G.pattern:ge=G,ge=ge.trim();const oe=`${ge}_${!!ne.trimForExclusions}`;let Ee=t.get(oe);if(Ee)return s(Ee,G);let ce;return d.test(ge)?Ee=o(ge.substr(4),ge):(ce=h.exec(a(ge,ne)))?Ee=v(ce[1],ge):(ne.trimForExclusions?C:g).test(ge)?Ee=p(ge,ne):(ce=l.exec(a(ge,ne)))?Ee=T(ce[1].substr(1),ge,!0):(ce=w.exec(a(ge,ne)))?Ee=T(ce[1],ge,!1):Ee=N(ge),t.set(oe,Ee),s(Ee,G)}function s(G,ne){if(typeof ne=="string")return G;const ge=function(oe,Ee){return(0,S.isEqualOrParent)(oe,ne.base,!A.isLinux)?G(oe.substr(ne.base.length+1),Ee):null};return ge.allBasenames=G.allBasenames,ge.allPaths=G.allPaths,ge.basenames=G.basenames,ge.patterns=G.patterns,ge}function a(G,ne){return ne.trimForExclusions&&G.endsWith("/**")?G.substr(0,G.length-2):G}function o(G,ne){return function(ge,oe){return typeof ge=="string"&&ge.endsWith(G)?ne:null}}function v(G,ne){const ge=`/${G}`,oe=`\\${G}`,Ee=function(me,ee){return typeof me!="string"?null:ee?ee===G?ne:null:me===G||me.endsWith(ge)||me.endsWith(oe)?ne:null},ce=[G];return Ee.basenames=ce,Ee.patterns=[ne],Ee.allBasenames=ce,Ee}function p(G,ne){const ge=W(G.slice(1,-1).split(",").map(ee=>n(ee,ne)).filter(ee=>ee!==i),G),oe=ge.length;if(!oe)return i;if(oe===1)return ge[0];const Ee=function(ee,be){for(let _e=0,Fe=ge.length;_e<Fe;_e++)if(ge[_e](ee,be))return G;return null},ce=ge.find(ee=>!!ee.allBasenames);ce&&(Ee.allBasenames=ce.allBasenames);const me=ge.reduce((ee,be)=>be.allPaths?ee.concat(be.allPaths):ee,[]);return me.length&&(Ee.allPaths=me),Ee}function T(G,ne,ge){const oe=_.sep===_.posix.sep,Ee=oe?G:G.replace(m,_.sep),ce=_.sep+Ee,me=_.posix.sep+G;let ee;return ge?ee=function(be,_e){return typeof be=="string"&&(be===Ee||be.endsWith(ce)||!oe&&(be===G||be.endsWith(me)))?ne:null}:ee=function(be,_e){return typeof be=="string"&&(be===Ee||!oe&&be===G)?ne:null},ee.allPaths=[(ge?"*/":"./")+G],ee}function N(G){try{const ne=new RegExp(`^${c(G)}$`);return function(ge){return ne.lastIndex=0,typeof ge=="string"&&ne.test(ge)?G:null}}catch{return i}}function V(G,ne,ge){return!G||typeof ne!="string"?!1:B(G)(ne,void 0,ge)}e.match=V;function B(G,ne={}){if(!G)return u;if(typeof G=="string"||D(G)){const ge=n(G,ne);if(ge===i)return u;const oe=function(Ee,ce){return!!ge(Ee,ce)};return ge.allBasenames&&(oe.allBasenames=ge.allBasenames),ge.allPaths&&(oe.allPaths=ge.allPaths),oe}return R(G,ne)}e.parse=B;function D(G){const ne=G;return ne?typeof ne.base=="string"&&typeof ne.pattern=="string":!1}e.isRelativePattern=D;function z(G){return G.allBasenames||[]}e.getBasenameTerms=z;function L(G){return G.allPaths||[]}e.getPathTerms=L;function R(G,ne){const ge=W(Object.getOwnPropertyNames(G).map(ee=>K(ee,G[ee],ne)).filter(ee=>ee!==i)),oe=ge.length;if(!oe)return i;if(!ge.some(ee=>!!ee.requiresSiblings)){if(oe===1)return ge[0];const ee=function(Fe,Be){let Xe;for(let ke=0,ye=ge.length;ke<ye;ke++){const De=ge[ke](Fe,Be);if(typeof De=="string")return De;(0,y.isThenable)(De)&&(Xe||(Xe=[]),Xe.push(De))}return Xe?(async()=>{for(const ke of Xe){const ye=await ke;if(typeof ye=="string")return ye}return null})():null},be=ge.find(Fe=>!!Fe.allBasenames);be&&(ee.allBasenames=be.allBasenames);const _e=ge.reduce((Fe,Be)=>Be.allPaths?Fe.concat(Be.allPaths):Fe,[]);return _e.length&&(ee.allPaths=_e),ee}const Ee=function(ee,be,_e){let Fe,Be;for(let Xe=0,ke=ge.length;Xe<ke;Xe++){const ye=ge[Xe];ye.requiresSiblings&&_e&&(be||(be=(0,_.basename)(ee)),Fe||(Fe=be.substr(0,be.length-(0,_.extname)(ee).length)));const De=ye(ee,be,Fe,_e);if(typeof De=="string")return De;(0,y.isThenable)(De)&&(Be||(Be=[]),Be.push(De))}return Be?(async()=>{for(const Xe of Be){const ke=await Xe;if(typeof ke=="string")return ke}return null})():null},ce=ge.find(ee=>!!ee.allBasenames);ce&&(Ee.allBasenames=ce.allBasenames);const me=ge.reduce((ee,be)=>be.allPaths?ee.concat(be.allPaths):ee,[]);return me.length&&(Ee.allPaths=me),Ee}function K(G,ne,ge){if(ne===!1)return i;const oe=n(G,ge);if(oe===i)return i;if(typeof ne=="boolean")return oe;if(ne){const Ee=ne.when;if(typeof Ee=="string"){const ce=(me,ee,be,_e)=>{if(!_e||!oe(me,ee))return null;const Fe=Ee.replace("$(basename)",be),Be=_e(Fe);return(0,y.isThenable)(Be)?Be.then(Xe=>Xe?G:null):Be?G:null};return ce.requiresSiblings=!0,ce}}return oe}function W(G,ne){const ge=G.filter(ee=>!!ee.basenames);if(ge.length<2)return G;const oe=ge.reduce((ee,be)=>{const _e=be.basenames;return _e?ee.concat(_e):ee},[]);let Ee;if(ne){Ee=[];for(let ee=0,be=oe.length;ee<be;ee++)Ee.push(ne)}else Ee=ge.reduce((ee,be)=>{const _e=be.patterns;return _e?ee.concat(_e):ee},[]);const ce=function(ee,be){if(typeof ee!="string")return null;if(!be){let Fe;for(Fe=ee.length;Fe>0;Fe--){const Be=ee.charCodeAt(Fe-1);if(Be===47||Be===92)break}be=ee.substr(Fe)}const _e=oe.indexOf(be);return _e!==-1?Ee[_e]:null};ce.basenames=oe,ce.patterns=Ee,ce.allBasenames=oe;const me=G.filter(ee=>!ee.basenames);return me.push(ce),me}function $(G,ne){return(0,r.equals)(G,ne,(ge,oe)=>typeof ge=="string"&&typeof oe=="string"?ge===oe:typeof ge!="string"&&typeof oe!="string"?ge.base===oe.base&&ge.pattern===oe.pattern:!1)}e.patternsEquals=$}),define(Ce[77],Ie([1,0,12,116,22,9,2]),function(ie,e,r,y,S,M,_){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.parseHrefAndDimensions=e.removeMarkdownEscapes=e.escapeDoubleQuotes=e.escapeMarkdownSyntaxTokens=e.markdownStringEqual=e.isMarkdownString=e.isEmptyMarkdownString=e.MarkdownString=e.MarkdownStringTextNewlineStyle=void 0;var A;(function(d){d[d.Paragraph=0]="Paragraph",d[d.Break=1]="Break"})(A=e.MarkdownStringTextNewlineStyle||(e.MarkdownStringTextNewlineStyle={}));class b{constructor(h="",g=!1){if(this.value=h,typeof this.value!="string")throw(0,r.illegalArgument)("value");typeof g=="boolean"?(this.isTrusted=g,this.supportThemeIcons=!1,this.supportHtml=!1):(this.isTrusted=g.isTrusted??void 0,this.supportThemeIcons=g.supportThemeIcons??!1,this.supportHtml=g.supportHtml??!1)}appendText(h,g=0){return this.value+=m(this.supportThemeIcons?(0,y.escapeIcons)(h):h).replace(/([ \t]+)/g,(C,l)=>"&nbsp;".repeat(l.length)).replace(/\>/gm,"\\>").replace(/\n/g,g===1?`\\
`:`

`),this}appendMarkdown(h){return this.value+=h,this}appendCodeblock(h,g){return this.value+="\n```",this.value+=h,this.value+=`
`,this.value+=g,this.value+="\n```\n",this}appendLink(h,g,C){return this.value+="[",this.value+=this._escape(g,"]"),this.value+="](",this.value+=this._escape(String(h),")"),C&&(this.value+=` "${this._escape(this._escape(C,'"'),")")}"`),this.value+=")",this}_escape(h,g){const C=new RegExp((0,M.escapeRegExpCharacters)(g),"g");return h.replace(C,(l,w)=>h.charAt(w-1)!=="\\"?`\\${l}`:l)}}e.MarkdownString=b;function P(d){return O(d)?!d.value:Array.isArray(d)?d.every(P):!0}e.isEmptyMarkdownString=P;function O(d){return d instanceof b?!0:d&&typeof d=="object"?typeof d.value=="string"&&(typeof d.isTrusted=="boolean"||d.isTrusted===void 0)&&(typeof d.supportThemeIcons=="boolean"||d.supportThemeIcons===void 0):!1}e.isMarkdownString=O;function E(d,h){return d===h?!0:!d||!h?!1:d.value===h.value&&d.isTrusted===h.isTrusted&&d.supportThemeIcons===h.supportThemeIcons&&d.supportHtml===h.supportHtml&&(d.baseUri===h.baseUri||!!d.baseUri&&!!h.baseUri&&(0,S.isEqual)(_.URI.from(d.baseUri),_.URI.from(h.baseUri)))}e.markdownStringEqual=E;function m(d){return d.replace(/[\\`*_{}[\]()#+\-!]/g,"\\$&")}e.escapeMarkdownSyntaxTokens=m;function k(d){return d.replace(/"/g,"&quot;")}e.escapeDoubleQuotes=k;function f(d){return d&&d.replace(/\\([\\`*_{}[\]()#+\-.!])/g,"$1")}e.removeMarkdownEscapes=f;function c(d){const h=[],g=d.split("|").map(l=>l.trim());d=g[0];const C=g[1];if(C){const l=/height=(\d+)/.exec(C),w=/width=(\d+)/.exec(C),t=l?l[1]:"",u=w?w[1]:"",i=isFinite(parseInt(u)),n=isFinite(parseInt(t));i&&h.push(`width="${u}"`),n&&h.push(`height="${t}"`)}return{href:d,dimensions:h}}e.parseHrefAndDimensions=c}),define(Ce[78],Ie([1,0,18,38,19,21,22,9]),function(ie,e,r,y,S,M,_,A){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.splitName=e.unmnemonicLabel=e.mnemonicButtonLabel=e.mnemonicMenuLabel=e.template=e.shorten=e.untildify=e.tildify=e.normalizeDriveLetter=e.getPathLabel=void 0;function b(i,n){const{os:s,tildify:a,relative:o}=n;if(o){const T=P(i,o,s);if(typeof T=="string")return T}let v=i.fsPath;if(s===1&&!M.isWindows?v=v.replace(/\//g,"\\"):s!==1&&M.isWindows&&(v=v.replace(/\\/g,"/")),s!==1&&a?.userHome){const T=a.userHome.fsPath;let N;i.scheme!==a.userHome.scheme&&i.path.startsWith(S.posix.sep)?N=a.userHome.with({path:i.path}).fsPath:N=i.fsPath,v=m(N,T,s)}return(s===1?S.win32:S.posix).normalize(O(v,s===1))}e.getPathLabel=b;function P(i,n,s){const a=s===1?S.win32:S.posix,o=s===3?_.extUri:_.extUriIgnorePathCase,v=n.getWorkspace(),p=(0,r.firstOrDefault)(v.folders);if(!p)return;i.scheme!==p.uri.scheme&&i.path.startsWith(S.posix.sep)&&(i=p.uri.with({path:i.path}));const T=n.getWorkspaceFolder(i);if(!T)return;let N;if(o.isEqual(T.uri,i)?N="":N=o.relativePath(T.uri,i)??"",N&&(N=a.normalize(N)),v.folders.length>1&&!n.noPrefix){const V=T.name?T.name:o.basenameOrAuthority(T.uri);N=N?`${V} \u2022 ${N}`:V}return N}function O(i,n=M.isWindows){return(0,y.hasDriveLetter)(i,n)?i.charAt(0).toUpperCase()+i.slice(1):i}e.normalizeDriveLetter=O;let E=Object.create(null);function m(i,n,s=M.OS){if(s===1||!i||!n)return i;let a=E.original===n?E.normalized:void 0;a||(a=n,M.isWindows&&(a=(0,y.toSlashes)(a)),a=`${(0,A.rtrim)(a,S.posix.sep)}${S.posix.sep}`,E={original:n,normalized:a});let o=i;return M.isWindows&&(o=(0,y.toSlashes)(o)),(s===3?o.startsWith(a):(0,A.startsWithIgnoreCase)(o,a))?`~/${o.substr(a.length)}`:i}e.tildify=m;function k(i,n){return i.replace(/^~($|\/|\\)/,`${n}$1`)}e.untildify=k;const f="\u2026",c="\\\\",d="~";function h(i,n=S.sep){const s=new Array(i.length);let a=!1;for(let o=0;o<i.length;o++){const v=i[o];if(v===""){s[o]=`.${n}`;continue}if(!v){s[o]=v;continue}a=!0;let p="",T=v;T.indexOf(c)===0?(p=T.substr(0,T.indexOf(c)+c.length),T=T.substr(T.indexOf(c)+c.length)):T.indexOf(n)===0?(p=T.substr(0,T.indexOf(n)+n.length),T=T.substr(T.indexOf(n)+n.length)):T.indexOf(d)===0&&(p=T.substr(0,T.indexOf(d)+d.length),T=T.substr(T.indexOf(d)+d.length));const N=T.split(n);for(let V=1;a&&V<=N.length;V++)for(let B=N.length-V;a&&B>=0;B--){a=!1;let D=N.slice(B,B+V).join(n);for(let z=0;!a&&z<i.length;z++)if(z!==o&&i[z]&&i[z].indexOf(D)>-1){const L=B+V===N.length,R=B>0&&i[z].indexOf(n)>-1?n+D:D,K=i[z].endsWith(R);a=!L||K}if(!a){let z="";(N[0].endsWith(":")||p!=="")&&(B===1&&(B=0,V++,D=N[0]+n+D),B>0&&(z=N[0]+n),z=p+z),B>0&&(z=z+f+n),z=z+D,B+V<N.length&&(z=z+n+f),s[o]=z}}a&&(s[o]=v)}return s}e.shorten=h;var g;(function(i){i[i.TEXT=0]="TEXT",i[i.VARIABLE=1]="VARIABLE",i[i.SEPARATOR=2]="SEPARATOR"})(g||(g={}));function C(i,n=Object.create(null)){const s=[];let a=!1,o="";for(const v of i)if(v==="$"||a&&v==="{")o&&s.push({value:o,type:g.TEXT}),o="",a=!0;else if(v==="}"&&a){const p=n[o];if(typeof p=="string")p.length&&s.push({value:p,type:g.VARIABLE});else if(p){const T=s[s.length-1];(!T||T.type!==g.SEPARATOR)&&s.push({value:p.label,type:g.SEPARATOR})}o="",a=!1}else o+=v;return o&&!a&&s.push({value:o,type:g.TEXT}),s.filter((v,p)=>{if(v.type===g.SEPARATOR){const T=s[p-1],N=s[p+1];return[T,N].every(V=>V&&(V.type===g.VARIABLE||V.type===g.TEXT)&&V.value.length>0)}return!0}).map(v=>v.value).join("")}e.template=C;function l(i,n){return M.isMacintosh||n?i.replace(/\(&&\w\)|&&/g,"").replace(/&/g,M.isMacintosh?"&":"&&"):i.replace(/&&|&/g,s=>s==="&"?"&&":"&")}e.mnemonicMenuLabel=l;function w(i,n){return M.isMacintosh||n?i.replace(/\(&&\w\)|&&/g,""):M.isWindows?i.replace(/&&|&/g,s=>s==="&"?"&&":"&"):i.replace(/&&/g,"_")}e.mnemonicButtonLabel=w;function t(i){return i.replace(/&/g,"&&")}e.unmnemonicLabel=t;function u(i){const n=i.indexOf("/")!==-1?S.posix:S.win32,s=n.basename(i),a=n.dirname(i);return s.length?{name:s,parentPath:a}:{name:a,parentPath:""}}e.splitName=u}),define(Ce[119],Ie([1,0,2]),function(ie,e,r){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.transformAndReviveIncomingURIs=e.transformIncomingURIs=e.transformOutgoingURIs=e.DefaultURITransformer=e.URITransformer=void 0;function y(O){return O.toJSON()}class S{constructor(E){this._uriTransformer=E}transformIncoming(E){const m=this._uriTransformer.transformIncoming(E);return m===E?E:y(r.URI.from(m))}transformOutgoing(E){const m=this._uriTransformer.transformOutgoing(E);return m===E?E:y(r.URI.from(m))}transformOutgoingURI(E){const m=this._uriTransformer.transformOutgoing(E);return m===E?E:r.URI.from(m)}transformOutgoingScheme(E){return this._uriTransformer.transformOutgoingScheme(E)}}e.URITransformer=S,e.DefaultURITransformer=new class{transformIncoming(O){return O}transformOutgoing(O){return O}transformOutgoingURI(O){return O}transformOutgoingScheme(O){return O}};function M(O,E,m){if(!O||m>200)return null;if(typeof O=="object"){if(O instanceof r.URI)return E.transformOutgoing(O);for(const k in O)if(Object.hasOwnProperty.call(O,k)){const f=M(O[k],E,m+1);f!==null&&(O[k]=f)}}return null}function _(O,E){const m=M(O,E,0);return m===null?O:m}e.transformOutgoingURIs=_;function A(O,E,m,k){if(!O||k>200)return null;if(typeof O=="object"){if(O.$mid===1)return m?r.URI.revive(E.transformIncoming(O)):E.transformIncoming(O);for(const f in O)if(Object.hasOwnProperty.call(O,f)){const c=A(O[f],E,m,k+1);c!==null&&(O[f]=c)}}return null}function b(O,E){const m=A(O,E,!1,0);return m===null?O:m}e.transformIncomingURIs=b;function P(O,E){const m=A(O,E,!0,0);return m===null?O:m}e.transformAndReviveIncomingURIs=P}),define(Ce[120],Ie([1,0,34,19]),function(ie,e,r,y){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.score=void 0;function S(M,_,A,b,P,O){if(Array.isArray(M)){let E=0;for(const m of M){const k=S(m,_,A,b,P,O);if(k===10)return k;k>E&&(E=k)}return E}else{if(typeof M=="string")return b?M==="*"?5:M===A?10:0:0;if(M){const{language:E,pattern:m,scheme:k,hasAccessToAllModels:f,notebookType:c}=M;if(!b&&!f)return 0;c&&P&&(_=P);let d=0;if(k)if(k===_.scheme)d=10;else if(k==="*")d=5;else return 0;if(E)if(E===A)d=10;else if(E==="*")d=Math.max(d,5);else return 0;if(c)if(c===O)d=10;else if(c==="*"&&O!==void 0)d=Math.max(d,5);else return 0;if(m){let h;if(typeof m=="string"?h=m:h={...m,base:(0,y.normalize)(m.base)},h===_.fsPath||(0,r.match)(h,_.fsPath))d=10;else return 0}return d}else return 0}}e.score=S}),define(Ce[79],Ie([1,0,23,21]),function(ie,e,r,y){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.decodeSemanticTokensDto=e.encodeSemanticTokensDto=void 0;var S;(function(E){E[E.Full=1]="Full",E[E.Delta=2]="Delta"})(S||(S={}));function M(E){for(let m=0,k=E.length;m<k;m+=4){const f=E[m+0],c=E[m+1],d=E[m+2],h=E[m+3];E[m+0]=h,E[m+1]=d,E[m+2]=c,E[m+3]=f}}function _(E){const m=new Uint8Array(E.buffer,E.byteOffset,E.length*4);return y.isLittleEndian()||M(m),r.VSBuffer.wrap(m)}function A(E){const m=E.buffer;if(y.isLittleEndian()||M(m),m.byteOffset%4===0)return new Uint32Array(m.buffer,m.byteOffset,m.length/4);{const k=new Uint8Array(m.byteLength);return k.set(m),new Uint32Array(k.buffer,k.byteOffset,k.length/4)}}function b(E){const m=new Uint32Array(P(E));let k=0;if(m[k++]=E.id,E.type==="full")m[k++]=1,m[k++]=E.data.length,m.set(E.data,k),k+=E.data.length;else{m[k++]=2,m[k++]=E.deltas.length;for(const f of E.deltas)m[k++]=f.start,m[k++]=f.deleteCount,f.data?(m[k++]=f.data.length,m.set(f.data,k),k+=f.data.length):m[k++]=0}return _(m)}e.encodeSemanticTokensDto=b;function P(E){let m=0;if(m+=1+1,E.type==="full")m+=1+E.data.length;else{m+=1,m+=(1+1+1)*E.deltas.length;for(const k of E.deltas)k.data&&(m+=k.data.length)}return m}function O(E){const m=A(E);let k=0;const f=m[k++];if(m[k++]===1){const g=m[k++],C=m.subarray(k,k+g);return k+=g,{id:f,type:"full",data:C}}const d=m[k++],h=[];for(let g=0;g<d;g++){const C=m[k++],l=m[k++],w=m[k++];let t;w>0&&(t=m.subarray(k,k+w),k+=w),h[g]={start:C,deleteCount:l,data:t}}return{id:f,type:"delta",deltas:h}}e.decodeSemanticTokensDto=O}),define(Ce[121],Ie([16,17]),function(ie,e){return ie.create("vs/editor/common/config/editorOptions",e)}),define(Ce[122],Ie([1,0,121,21,123,18,26,110]),function(ie,e,r,y,S,M,_,A){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.EditorOptions=e.EditorOption=e.editorOptionsRegistry=e.EDITOR_FONT_DEFAULTS=e.WrappingIndent=e.unicodeHighlightConfigKeys=e.inUntrustedWorkspace=e.filterValidationDecorations=e.RenderLineNumbersType=e.EditorLayoutInfoComputer=e.RenderMinimap=e.EditorFontLigatures=e.cursorStyleToString=e.TextEditorCursorStyle=e.TextEditorCursorBlinkingStyle=e.stringSet=e.clampedInt=e.boolean=e.ApplyUpdateResult=e.ComputeOptionsMemory=e.ConfigurationChangedEvent=e.MINIMAP_GUTTER_WIDTH=e.EditorAutoIndentStrategy=void 0;var b;(function(X){X[X.None=0]="None",X[X.Keep=1]="Keep",X[X.Brackets=2]="Brackets",X[X.Advanced=3]="Advanced",X[X.Full=4]="Full"})(b=e.EditorAutoIndentStrategy||(e.EditorAutoIndentStrategy={})),e.MINIMAP_GUTTER_WIDTH=8;class P{constructor(Q){this._values=Q}hasChanged(Q){return this._values[Q]}}e.ConfigurationChangedEvent=P;class O{constructor(){this.stableMinimapLayoutInput=null,this.stableFitMaxMinimapScale=0,this.stableFitRemainingWidth=0}}e.ComputeOptionsMemory=O;class E{constructor(Q,he,Ue,je){this.id=Q,this.name=he,this.defaultValue=Ue,this.schema=je}applyUpdate(Q,he){return k(Q,he)}compute(Q,he,Ue){return Ue}}class m{constructor(Q,he){this.newValue=Q,this.didChange=he}}e.ApplyUpdateResult=m;function k(X,Q){if(typeof X!="object"||typeof Q!="object"||!X||!Q)return new m(Q,X!==Q);if(Array.isArray(X)||Array.isArray(Q)){const Ue=Array.isArray(X)&&Array.isArray(Q)&&M.equals(X,Q);return new m(Q,!Ue)}let he=!1;for(const Ue in Q)if(Q.hasOwnProperty(Ue)){const je=k(X[Ue],Q[Ue]);je.didChange&&(X[Ue]=je.newValue,he=!0)}return new m(X,he)}class f{constructor(Q){this.schema=void 0,this.id=Q,this.name="_never_",this.defaultValue=void 0}applyUpdate(Q,he){return k(Q,he)}validate(Q){return this.defaultValue}}class c{constructor(Q,he,Ue,je){this.id=Q,this.name=he,this.defaultValue=Ue,this.schema=je}applyUpdate(Q,he){return k(Q,he)}validate(Q){return typeof Q>"u"?this.defaultValue:Q}compute(Q,he,Ue){return Ue}}function d(X,Q){return typeof X>"u"?Q:X==="false"?!1:Boolean(X)}e.boolean=d;class h extends c{constructor(Q,he,Ue,je=void 0){typeof je<"u"&&(je.type="boolean",je.default=Ue),super(Q,he,Ue,je)}validate(Q){return d(Q,this.defaultValue)}}function g(X,Q,he,Ue){if(typeof X>"u")return Q;let je=parseInt(X,10);return isNaN(je)?Q:(je=Math.max(he,je),je=Math.min(Ue,je),je|0)}e.clampedInt=g;class C extends c{static clampedInt(Q,he,Ue,je){return g(Q,he,Ue,je)}constructor(Q,he,Ue,je,Ze,Ke=void 0){typeof Ke<"u"&&(Ke.type="integer",Ke.default=Ue,Ke.minimum=je,Ke.maximum=Ze),super(Q,he,Ue,Ke),this.minimum=je,this.maximum=Ze}validate(Q){return C.clampedInt(Q,this.defaultValue,this.minimum,this.maximum)}}class l extends c{static clamp(Q,he,Ue){return Q<he?he:Q>Ue?Ue:Q}static float(Q,he){if(typeof Q=="number")return Q;if(typeof Q>"u")return he;const Ue=parseFloat(Q);return isNaN(Ue)?he:Ue}constructor(Q,he,Ue,je,Ze){typeof Ze<"u"&&(Ze.type="number",Ze.default=Ue),super(Q,he,Ue,Ze),this.validationFn=je}validate(Q){return this.validationFn(l.float(Q,this.defaultValue))}}class w extends c{static string(Q,he){return typeof Q!="string"?he:Q}constructor(Q,he,Ue,je=void 0){typeof je<"u"&&(je.type="string",je.default=Ue),super(Q,he,Ue,je)}validate(Q){return w.string(Q,this.defaultValue)}}function t(X,Q,he){return typeof X!="string"||he.indexOf(X)===-1?Q:X}e.stringSet=t;class u extends c{constructor(Q,he,Ue,je,Ze=void 0){typeof Ze<"u"&&(Ze.type="string",Ze.enum=je,Ze.default=Ue),super(Q,he,Ue,Ze),this._allowedValues=je}validate(Q){return t(Q,this.defaultValue,this._allowedValues)}}class i extends E{constructor(Q,he,Ue,je,Ze,Ke,Ve=void 0){typeof Ve<"u"&&(Ve.type="string",Ve.enum=Ze,Ve.default=je),super(Q,he,Ue,Ve),this._allowedValues=Ze,this._convert=Ke}validate(Q){return typeof Q!="string"?this.defaultValue:this._allowedValues.indexOf(Q)===-1?this.defaultValue:this._convert(Q)}}function n(X){switch(X){case"none":return 0;case"keep":return 1;case"brackets":return 2;case"advanced":return 3;case"full":return 4}}class s extends E{constructor(){super(2,"accessibilitySupport",0,{type:"string",enum:["auto","on","off"],enumDescriptions:[r.localize(0,null),r.localize(1,null),r.localize(2,null)],default:"auto",description:r.localize(3,null)})}validate(Q){switch(Q){case"auto":return 0;case"off":return 1;case"on":return 2}return this.defaultValue}compute(Q,he,Ue){return Ue===0?Q.accessibilitySupport:Ue}}class a extends E{constructor(){const Q={insertSpace:!0,ignoreEmptyLines:!0};super(19,"comments",Q,{"editor.comments.insertSpace":{type:"boolean",default:Q.insertSpace,description:r.localize(4,null)},"editor.comments.ignoreEmptyLines":{type:"boolean",default:Q.ignoreEmptyLines,description:r.localize(5,null)}})}validate(Q){if(!Q||typeof Q!="object")return this.defaultValue;const he=Q;return{insertSpace:d(he.insertSpace,this.defaultValue.insertSpace),ignoreEmptyLines:d(he.ignoreEmptyLines,this.defaultValue.ignoreEmptyLines)}}}var o;(function(X){X[X.Hidden=0]="Hidden",X[X.Blink=1]="Blink",X[X.Smooth=2]="Smooth",X[X.Phase=3]="Phase",X[X.Expand=4]="Expand",X[X.Solid=5]="Solid"})(o=e.TextEditorCursorBlinkingStyle||(e.TextEditorCursorBlinkingStyle={}));function v(X){switch(X){case"blink":return 1;case"smooth":return 2;case"phase":return 3;case"expand":return 4;case"solid":return 5}}var p;(function(X){X[X.Line=1]="Line",X[X.Block=2]="Block",X[X.Underline=3]="Underline",X[X.LineThin=4]="LineThin",X[X.BlockOutline=5]="BlockOutline",X[X.UnderlineThin=6]="UnderlineThin"})(p=e.TextEditorCursorStyle||(e.TextEditorCursorStyle={}));function T(X){switch(X){case p.Line:return"line";case p.Block:return"block";case p.Underline:return"underline";case p.LineThin:return"line-thin";case p.BlockOutline:return"block-outline";case p.UnderlineThin:return"underline-thin"}}e.cursorStyleToString=T;function N(X){switch(X){case"line":return p.Line;case"block":return p.Block;case"underline":return p.Underline;case"line-thin":return p.LineThin;case"block-outline":return p.BlockOutline;case"underline-thin":return p.UnderlineThin}}class V extends f{constructor(){super(130)}compute(Q,he,Ue){const je=["monaco-editor"];return he.get(34)&&je.push(he.get(34)),Q.extraEditorClassName&&je.push(Q.extraEditorClassName),he.get(67)==="default"?je.push("mouse-default"):he.get(67)==="copy"&&je.push("mouse-copy"),he.get(101)&&je.push("showUnused"),he.get(128)&&je.push("showDeprecated"),je.join(" ")}}class B extends h{constructor(){super(33,"emptySelectionClipboard",!0,{description:r.localize(6,null)})}compute(Q,he,Ue){return Ue&&Q.emptySelectionClipboard}}class D extends E{constructor(){const Q={cursorMoveOnType:!0,seedSearchStringFromSelection:"always",autoFindInSelection:"never",globalFindClipboard:!1,addExtraSpaceOnTop:!0,loop:!0};super(36,"find",Q,{"editor.find.cursorMoveOnType":{type:"boolean",default:Q.cursorMoveOnType,description:r.localize(7,null)},"editor.find.seedSearchStringFromSelection":{type:"string",enum:["never","always","selection"],default:Q.seedSearchStringFromSelection,enumDescriptions:[r.localize(8,null),r.localize(9,null),r.localize(10,null)],description:r.localize(11,null)},"editor.find.autoFindInSelection":{type:"string",enum:["never","always","multiline"],default:Q.autoFindInSelection,enumDescriptions:[r.localize(12,null),r.localize(13,null),r.localize(14,null)],description:r.localize(15,null)},"editor.find.globalFindClipboard":{type:"boolean",default:Q.globalFindClipboard,description:r.localize(16,null),included:y.isMacintosh},"editor.find.addExtraSpaceOnTop":{type:"boolean",default:Q.addExtraSpaceOnTop,description:r.localize(17,null)},"editor.find.loop":{type:"boolean",default:Q.loop,description:r.localize(18,null)}})}validate(Q){if(!Q||typeof Q!="object")return this.defaultValue;const he=Q;return{cursorMoveOnType:d(he.cursorMoveOnType,this.defaultValue.cursorMoveOnType),seedSearchStringFromSelection:typeof Q.seedSearchStringFromSelection=="boolean"?Q.seedSearchStringFromSelection?"always":"never":t(he.seedSearchStringFromSelection,this.defaultValue.seedSearchStringFromSelection,["never","always","selection"]),autoFindInSelection:typeof Q.autoFindInSelection=="boolean"?Q.autoFindInSelection?"always":"never":t(he.autoFindInSelection,this.defaultValue.autoFindInSelection,["never","always","multiline"]),globalFindClipboard:d(he.globalFindClipboard,this.defaultValue.globalFindClipboard),addExtraSpaceOnTop:d(he.addExtraSpaceOnTop,this.defaultValue.addExtraSpaceOnTop),loop:d(he.loop,this.defaultValue.loop)}}}class z extends E{constructor(){super(46,"fontLigatures",z.OFF,{anyOf:[{type:"boolean",description:r.localize(19,null)},{type:"string",description:r.localize(20,null)}],description:r.localize(21,null),default:!1})}validate(Q){return typeof Q>"u"?this.defaultValue:typeof Q=="string"?Q==="false"?z.OFF:Q==="true"?z.ON:Q:Boolean(Q)?z.ON:z.OFF}}e.EditorFontLigatures=z,z.OFF='"liga" off, "calt" off',z.ON='"liga" on, "calt" on';class L extends f{constructor(){super(45)}compute(Q,he,Ue){return Q.fontInfo}}class R extends c{constructor(){super(47,"fontSize",e.EDITOR_FONT_DEFAULTS.fontSize,{type:"number",minimum:6,maximum:100,default:e.EDITOR_FONT_DEFAULTS.fontSize,description:r.localize(22,null)})}validate(Q){const he=l.float(Q,this.defaultValue);return he===0?e.EDITOR_FONT_DEFAULTS.fontSize:l.clamp(he,6,100)}compute(Q,he,Ue){return Q.fontInfo.fontSize}}class K extends E{constructor(){super(48,"fontWeight",e.EDITOR_FONT_DEFAULTS.fontWeight,{anyOf:[{type:"number",minimum:K.MINIMUM_VALUE,maximum:K.MAXIMUM_VALUE,errorMessage:r.localize(23,null)},{type:"string",pattern:"^(normal|bold|1000|[1-9][0-9]{0,2})$"},{enum:K.SUGGESTION_VALUES}],default:e.EDITOR_FONT_DEFAULTS.fontWeight,description:r.localize(24,null)})}validate(Q){return Q==="normal"||Q==="bold"?Q:String(C.clampedInt(Q,e.EDITOR_FONT_DEFAULTS.fontWeight,K.MINIMUM_VALUE,K.MAXIMUM_VALUE))}}K.SUGGESTION_VALUES=["normal","bold","100","200","300","400","500","600","700","800","900"],K.MINIMUM_VALUE=1,K.MAXIMUM_VALUE=1e3;class W extends E{constructor(){const Q={multiple:"peek",multipleDefinitions:"peek",multipleTypeDefinitions:"peek",multipleDeclarations:"peek",multipleImplementations:"peek",multipleReferences:"peek",alternativeDefinitionCommand:"editor.action.goToReferences",alternativeTypeDefinitionCommand:"editor.action.goToReferences",alternativeDeclarationCommand:"editor.action.goToReferences",alternativeImplementationCommand:"",alternativeReferenceCommand:""},he={type:"string",enum:["peek","gotoAndPeek","goto"],default:Q.multiple,enumDescriptions:[r.localize(25,null),r.localize(26,null),r.localize(27,null)]},Ue=["","editor.action.referenceSearch.trigger","editor.action.goToReferences","editor.action.peekImplementation","editor.action.goToImplementation","editor.action.peekTypeDefinition","editor.action.goToTypeDefinition","editor.action.peekDeclaration","editor.action.revealDeclaration","editor.action.peekDefinition","editor.action.revealDefinitionAside","editor.action.revealDefinition"];super(52,"gotoLocation",Q,{"editor.gotoLocation.multiple":{deprecationMessage:r.localize(28,null)},"editor.gotoLocation.multipleDefinitions":{description:r.localize(29,null),...he},"editor.gotoLocation.multipleTypeDefinitions":{description:r.localize(30,null),...he},"editor.gotoLocation.multipleDeclarations":{description:r.localize(31,null),...he},"editor.gotoLocation.multipleImplementations":{description:r.localize(32,null),...he},"editor.gotoLocation.multipleReferences":{description:r.localize(33,null),...he},"editor.gotoLocation.alternativeDefinitionCommand":{type:"string",default:Q.alternativeDefinitionCommand,enum:Ue,description:r.localize(34,null)},"editor.gotoLocation.alternativeTypeDefinitionCommand":{type:"string",default:Q.alternativeTypeDefinitionCommand,enum:Ue,description:r.localize(35,null)},"editor.gotoLocation.alternativeDeclarationCommand":{type:"string",default:Q.alternativeDeclarationCommand,enum:Ue,description:r.localize(36,null)},"editor.gotoLocation.alternativeImplementationCommand":{type:"string",default:Q.alternativeImplementationCommand,enum:Ue,description:r.localize(37,null)},"editor.gotoLocation.alternativeReferenceCommand":{type:"string",default:Q.alternativeReferenceCommand,enum:Ue,description:r.localize(38,null)}})}validate(Q){if(!Q||typeof Q!="object")return this.defaultValue;const he=Q;return{multiple:t(he.multiple,this.defaultValue.multiple,["peek","gotoAndPeek","goto"]),multipleDefinitions:he.multipleDefinitions??t(he.multipleDefinitions,"peek",["peek","gotoAndPeek","goto"]),multipleTypeDefinitions:he.multipleTypeDefinitions??t(he.multipleTypeDefinitions,"peek",["peek","gotoAndPeek","goto"]),multipleDeclarations:he.multipleDeclarations??t(he.multipleDeclarations,"peek",["peek","gotoAndPeek","goto"]),multipleImplementations:he.multipleImplementations??t(he.multipleImplementations,"peek",["peek","gotoAndPeek","goto"]),multipleReferences:he.multipleReferences??t(he.multipleReferences,"peek",["peek","gotoAndPeek","goto"]),alternativeDefinitionCommand:w.string(he.alternativeDefinitionCommand,this.defaultValue.alternativeDefinitionCommand),alternativeTypeDefinitionCommand:w.string(he.alternativeTypeDefinitionCommand,this.defaultValue.alternativeTypeDefinitionCommand),alternativeDeclarationCommand:w.string(he.alternativeDeclarationCommand,this.defaultValue.alternativeDeclarationCommand),alternativeImplementationCommand:w.string(he.alternativeImplementationCommand,this.defaultValue.alternativeImplementationCommand),alternativeReferenceCommand:w.string(he.alternativeReferenceCommand,this.defaultValue.alternativeReferenceCommand)}}}class $ extends E{constructor(){const Q={enabled:!0,delay:300,sticky:!0,above:!0};super(54,"hover",Q,{"editor.hover.enabled":{type:"boolean",default:Q.enabled,description:r.localize(39,null)},"editor.hover.delay":{type:"number",default:Q.delay,minimum:0,maximum:1e4,description:r.localize(40,null)},"editor.hover.sticky":{type:"boolean",default:Q.sticky,description:r.localize(41,null)},"editor.hover.above":{type:"boolean",default:Q.above,description:r.localize(42,null)}})}validate(Q){if(!Q||typeof Q!="object")return this.defaultValue;const he=Q;return{enabled:d(he.enabled,this.defaultValue.enabled),delay:C.clampedInt(he.delay,this.defaultValue.delay,0,1e4),sticky:d(he.sticky,this.defaultValue.sticky),above:d(he.above,this.defaultValue.above)}}}var G;(function(X){X[X.None=0]="None",X[X.Text=1]="Text",X[X.Blocks=2]="Blocks"})(G=e.RenderMinimap||(e.RenderMinimap={}));class ne extends f{constructor(){super(133)}compute(Q,he,Ue){return ne.computeLayout(he,{memory:Q.memory,outerWidth:Q.outerWidth,outerHeight:Q.outerHeight,isDominatedByLongLines:Q.isDominatedByLongLines,lineHeight:Q.fontInfo.lineHeight,viewLineCount:Q.viewLineCount,lineNumbersDigitCount:Q.lineNumbersDigitCount,typicalHalfwidthCharacterWidth:Q.fontInfo.typicalHalfwidthCharacterWidth,maxDigitWidth:Q.fontInfo.maxDigitWidth,pixelRatio:Q.pixelRatio})}static computeContainedMinimapLineCount(Q){const he=Q.height/Q.lineHeight,Ue=Q.scrollBeyondLastLine?he-1:0,je=(Q.viewLineCount+Ue)/(Q.pixelRatio*Q.height),Ze=Math.floor(Q.viewLineCount/je);return{typicalViewportLineCount:he,extraLinesBeyondLastLine:Ue,desiredRatio:je,minimapLineCount:Ze}}static _computeMinimapLayout(Q,he){const Ue=Q.outerWidth,je=Q.outerHeight,Ze=Q.pixelRatio;if(!Q.minimap.enabled)return{renderMinimap:0,minimapLeft:0,minimapWidth:0,minimapHeightIsEditorHeight:!1,minimapIsSampling:!1,minimapScale:1,minimapLineHeight:1,minimapCanvasInnerWidth:0,minimapCanvasInnerHeight:Math.floor(Ze*je),minimapCanvasOuterWidth:0,minimapCanvasOuterHeight:je};const Ke=he.stableMinimapLayoutInput,Ve=Ke&&Q.outerHeight===Ke.outerHeight&&Q.lineHeight===Ke.lineHeight&&Q.typicalHalfwidthCharacterWidth===Ke.typicalHalfwidthCharacterWidth&&Q.pixelRatio===Ke.pixelRatio&&Q.scrollBeyondLastLine===Ke.scrollBeyondLastLine&&Q.minimap.enabled===Ke.minimap.enabled&&Q.minimap.side===Ke.minimap.side&&Q.minimap.size===Ke.minimap.size&&Q.minimap.showSlider===Ke.minimap.showSlider&&Q.minimap.renderCharacters===Ke.minimap.renderCharacters&&Q.minimap.maxColumn===Ke.minimap.maxColumn&&Q.minimap.scale===Ke.minimap.scale&&Q.verticalScrollbarWidth===Ke.verticalScrollbarWidth&&Q.isViewportWrapping===Ke.isViewportWrapping,it=Q.lineHeight,st=Q.typicalHalfwidthCharacterWidth,dt=Q.scrollBeyondLastLine,yt=Q.minimap.renderCharacters;let et=Ze>=2?Math.round(Q.minimap.scale*2):Q.minimap.scale;const ut=Q.minimap.maxColumn,Ot=Q.minimap.size,Vt=Q.minimap.side,At=Q.verticalScrollbarWidth,ft=Q.viewLineCount,It=Q.remainingWidth,Lt=Q.isViewportWrapping,xt=yt?2:3;let qe=Math.floor(Ze*je);const Ft=qe/Ze;let kt=!1,Nt=!1,gt=xt*et,Se=et/Ze,Pe=1;if(Ot==="fill"||Ot==="fit"){const{typicalViewportLineCount:tt,extraLinesBeyondLastLine:ct,desiredRatio:mt,minimapLineCount:Dt}=ne.computeContainedMinimapLineCount({viewLineCount:ft,scrollBeyondLastLine:dt,height:je,lineHeight:it,pixelRatio:Ze});if(ft/Dt>1)kt=!0,Nt=!0,et=1,gt=1,Se=et/Ze;else{let wt=!1,Tt=et+1;if(Ot==="fit"){const bt=Math.ceil((ft+ct)*gt);Lt&&Ve&&It<=he.stableFitRemainingWidth?(wt=!0,Tt=he.stableFitMaxMinimapScale):wt=bt>qe}if(Ot==="fill"||wt){kt=!0;const bt=et;gt=Math.min(it*Ze,Math.max(1,Math.floor(1/mt))),Lt&&Ve&&It<=he.stableFitRemainingWidth&&(Tt=he.stableFitMaxMinimapScale),et=Math.min(Tt,Math.max(1,Math.floor(gt/xt))),et>bt&&(Pe=Math.min(2,et/bt)),Se=et/Ze/Pe,qe=Math.ceil(Math.max(tt,ft+ct)*gt),Lt?(he.stableMinimapLayoutInput=Q,he.stableFitRemainingWidth=It,he.stableFitMaxMinimapScale=et):(he.stableMinimapLayoutInput=null,he.stableFitRemainingWidth=0)}}}const fe=Math.floor(ut*Se),q=Math.min(fe,Math.max(0,Math.floor((It-At-2)*Se/(st+Se)))+e.MINIMAP_GUTTER_WIDTH);let Ae=Math.floor(Ze*q);const Le=Ae/Ze;Ae=Math.floor(Ae*Pe);const nt=yt?1:2,We=Vt==="left"?0:Ue-q-At;return{renderMinimap:nt,minimapLeft:We,minimapWidth:q,minimapHeightIsEditorHeight:kt,minimapIsSampling:Nt,minimapScale:et,minimapLineHeight:gt,minimapCanvasInnerWidth:Ae,minimapCanvasInnerHeight:qe,minimapCanvasOuterWidth:Le,minimapCanvasOuterHeight:Ft}}static computeLayout(Q,he){const Ue=he.outerWidth|0,je=he.outerHeight|0,Ze=he.lineHeight|0,Ke=he.lineNumbersDigitCount|0,Ve=he.typicalHalfwidthCharacterWidth,it=he.maxDigitWidth,st=he.pixelRatio,dt=he.viewLineCount,yt=Q.get(125),et=yt==="inherit"?Q.get(124):yt,ut=et==="inherit"?Q.get(120):et,Ot=Q.get(123),Vt=Q.get(2),At=he.isDominatedByLongLines,ft=Q.get(51),It=Q.get(61).renderType!==0,Lt=Q.get(62),xt=Q.get(95),qe=Q.get(66),Ft=Q.get(93),kt=Ft.verticalScrollbarSize,Nt=Ft.verticalHasArrows,gt=Ft.arrowSize,Se=Ft.horizontalScrollbarSize,Pe=Q.get(59),fe=Q.get(38),q=Q.get(100)!=="never";let Ae;if(typeof Pe=="string"&&/^\d+(\.\d+)?ch$/.test(Pe)){const vt=parseFloat(Pe.substr(0,Pe.length-2));Ae=C.clampedInt(vt*Ve,0,0,1e3)}else Ae=C.clampedInt(Pe,0,0,1e3);fe&&q&&(Ae+=16);let Le=0;if(It){const vt=Math.max(Ke,Lt);Le=Math.round(vt*it)}let nt=0;ft&&(nt=Ze);let We=0,tt=We+nt,ct=tt+Le,mt=ct+Ae;const Dt=Ue-nt-Le-Ae;let Et=!1,wt=!1,Tt=-1;Vt!==2&&(et==="inherit"&&At?(Et=!0,wt=!0):ut==="on"||ut==="bounded"?wt=!0:ut==="wordWrapColumn"&&(Tt=Ot));const bt=ne._computeMinimapLayout({outerWidth:Ue,outerHeight:je,lineHeight:Ze,typicalHalfwidthCharacterWidth:Ve,pixelRatio:st,scrollBeyondLastLine:xt,minimap:qe,verticalScrollbarWidth:kt,viewLineCount:dt,remainingWidth:Dt,isViewportWrapping:wt},he.memory||new O);bt.renderMinimap!==0&&bt.minimapLeft===0&&(We+=bt.minimapWidth,tt+=bt.minimapWidth,ct+=bt.minimapWidth,mt+=bt.minimapWidth);const Ct=Dt-bt.minimapWidth,Yt=Math.max(1,Math.floor((Ct-kt-2)/Ve)),qt=Nt?gt:0;return wt&&(Tt=Math.max(1,Yt),ut==="bounded"&&(Tt=Math.min(Tt,Ot))),{width:Ue,height:je,glyphMarginLeft:We,glyphMarginWidth:nt,lineNumbersLeft:tt,lineNumbersWidth:Le,decorationsLeft:ct,decorationsWidth:Ae,contentLeft:mt,contentWidth:Ct,minimap:bt,viewportColumn:Yt,isWordWrapMinified:Et,isViewportWrapping:wt,wrappingColumn:Tt,verticalScrollbarWidth:kt,horizontalScrollbarHeight:Se,overviewRuler:{top:qt,width:kt,height:je-2*qt,right:0}}}}e.EditorLayoutInfoComputer=ne;class ge extends E{constructor(){const Q={enabled:!0};super(58,"lightbulb",Q,{"editor.lightbulb.enabled":{type:"boolean",default:Q.enabled,description:r.localize(43,null)}})}validate(Q){return!Q||typeof Q!="object"?this.defaultValue:{enabled:d(Q.enabled,this.defaultValue.enabled)}}}class oe extends E{constructor(){const Q={enabled:!1,maxLineCount:5};super(105,"stickyScroll",Q,{"editor.stickyScroll.enabled":{type:"boolean",default:Q.enabled,description:r.localize(44,null)},"editor.stickyScroll.maxLineCount":{type:"number",default:Q.maxLineCount,minimum:1,maximum:10,description:r.localize(45,null)}})}validate(Q){if(!Q||typeof Q!="object")return this.defaultValue;const he=Q;return{enabled:d(he.enabled,this.defaultValue.enabled),maxLineCount:C.clampedInt(he.maxLineCount,this.defaultValue.maxLineCount,1,10)}}}class Ee extends E{constructor(){const Q={enabled:"on",fontSize:0,fontFamily:"",padding:!1};super(129,"inlayHints",Q,{"editor.inlayHints.enabled":{type:"string",default:Q.enabled,description:r.localize(46,null),enum:["on","onUnlessPressed","offUnlessPressed","off"],markdownEnumDescriptions:[r.localize(47,null),r.localize(48,null,y.isMacintosh?"Ctrl+Option":"Ctrl+Alt"),r.localize(49,null,y.isMacintosh?"Ctrl+Option":"Ctrl+Alt"),r.localize(50,null)]},"editor.inlayHints.fontSize":{type:"number",default:Q.fontSize,markdownDescription:r.localize(51,null,"`#editor.fontSize#`","`5`")},"editor.inlayHints.fontFamily":{type:"string",default:Q.fontFamily,markdownDescription:r.localize(52,null,"`#editor.fontFamily#`")},"editor.inlayHints.padding":{type:"boolean",default:Q.padding,description:r.localize(53,null)}})}validate(Q){if(!Q||typeof Q!="object")return this.defaultValue;const he=Q;return typeof he.enabled=="boolean"&&(he.enabled=he.enabled?"on":"off"),{enabled:t(he.enabled,this.defaultValue.enabled,["on","off","offUnlessPressed","onUnlessPressed"]),fontSize:C.clampedInt(he.fontSize,this.defaultValue.fontSize,0,100),fontFamily:w.string(he.fontFamily,this.defaultValue.fontFamily),padding:d(he.padding,this.defaultValue.padding)}}}class ce extends l{constructor(){super(60,"lineHeight",e.EDITOR_FONT_DEFAULTS.lineHeight,Q=>l.clamp(Q,0,150),{markdownDescription:r.localize(54,null)})}compute(Q,he,Ue){return Q.fontInfo.lineHeight}}class me extends E{constructor(){const Q={enabled:!0,size:"proportional",side:"right",showSlider:"mouseover",autohide:!1,renderCharacters:!0,maxColumn:120,scale:1};super(66,"minimap",Q,{"editor.minimap.enabled":{type:"boolean",default:Q.enabled,description:r.localize(55,null)},"editor.minimap.autohide":{type:"boolean",default:Q.autohide,description:r.localize(56,null)},"editor.minimap.size":{type:"string",enum:["proportional","fill","fit"],enumDescriptions:[r.localize(57,null),r.localize(58,null),r.localize(59,null)],default:Q.size,description:r.localize(60,null)},"editor.minimap.side":{type:"string",enum:["left","right"],default:Q.side,description:r.localize(61,null)},"editor.minimap.showSlider":{type:"string",enum:["always","mouseover"],default:Q.showSlider,description:r.localize(62,null)},"editor.minimap.scale":{type:"number",default:Q.scale,minimum:1,maximum:3,enum:[1,2,3],description:r.localize(63,null)},"editor.minimap.renderCharacters":{type:"boolean",default:Q.renderCharacters,description:r.localize(64,null)},"editor.minimap.maxColumn":{type:"number",default:Q.maxColumn,description:r.localize(65,null)}})}validate(Q){if(!Q||typeof Q!="object")return this.defaultValue;const he=Q;return{enabled:d(he.enabled,this.defaultValue.enabled),autohide:d(he.autohide,this.defaultValue.autohide),size:t(he.size,this.defaultValue.size,["proportional","fill","fit"]),side:t(he.side,this.defaultValue.side,["right","left"]),showSlider:t(he.showSlider,this.defaultValue.showSlider,["always","mouseover"]),renderCharacters:d(he.renderCharacters,this.defaultValue.renderCharacters),scale:C.clampedInt(he.scale,1,1,3),maxColumn:C.clampedInt(he.maxColumn,this.defaultValue.maxColumn,1,1e4)}}}function ee(X){return X==="ctrlCmd"?y.isMacintosh?"metaKey":"ctrlKey":"altKey"}class be extends E{constructor(){super(76,"padding",{top:0,bottom:0},{"editor.padding.top":{type:"number",default:0,minimum:0,maximum:1e3,description:r.localize(66,null)},"editor.padding.bottom":{type:"number",default:0,minimum:0,maximum:1e3,description:r.localize(67,null)}})}validate(Q){if(!Q||typeof Q!="object")return this.defaultValue;const he=Q;return{top:C.clampedInt(he.top,0,0,1e3),bottom:C.clampedInt(he.bottom,0,0,1e3)}}}class _e extends E{constructor(){const Q={enabled:!0,cycle:!1};super(77,"parameterHints",Q,{"editor.parameterHints.enabled":{type:"boolean",default:Q.enabled,description:r.localize(68,null)},"editor.parameterHints.cycle":{type:"boolean",default:Q.cycle,description:r.localize(69,null)}})}validate(Q){if(!Q||typeof Q!="object")return this.defaultValue;const he=Q;return{enabled:d(he.enabled,this.defaultValue.enabled),cycle:d(he.cycle,this.defaultValue.cycle)}}}class Fe extends f{constructor(){super(131)}compute(Q,he,Ue){return Q.pixelRatio}}class Be extends E{constructor(){const Q={other:"on",comments:"off",strings:"off"},he=[{type:"boolean"},{type:"string",enum:["on","inline","off"],enumDescriptions:[r.localize(70,null),r.localize(71,null),r.localize(72,null)]}];super(80,"quickSuggestions",Q,{type:"object",additionalProperties:!1,properties:{strings:{anyOf:he,default:Q.strings,description:r.localize(73,null)},comments:{anyOf:he,default:Q.comments,description:r.localize(74,null)},other:{anyOf:he,default:Q.other,description:r.localize(75,null)}},default:Q,markdownDescription:r.localize(76,null,"#editor.suggestOnTriggerCharacters#")}),this.defaultValue=Q}validate(Q){if(typeof Q=="boolean"){const st=Q?"on":"off";return{comments:st,strings:st,other:st}}if(!Q||typeof Q!="object")return this.defaultValue;const{other:he,comments:Ue,strings:je}=Q,Ze=["on","inline","off"];let Ke,Ve,it;return typeof he=="boolean"?Ke=he?"on":"off":Ke=t(he,this.defaultValue.other,Ze),typeof Ue=="boolean"?Ve=Ue?"on":"off":Ve=t(Ue,this.defaultValue.comments,Ze),typeof je=="boolean"?it=je?"on":"off":it=t(je,this.defaultValue.strings,Ze),{other:Ke,comments:Ve,strings:it}}}var Xe;(function(X){X[X.Off=0]="Off",X[X.On=1]="On",X[X.Relative=2]="Relative",X[X.Interval=3]="Interval",X[X.Custom=4]="Custom"})(Xe=e.RenderLineNumbersType||(e.RenderLineNumbersType={}));class ke extends E{constructor(){super(61,"lineNumbers",{renderType:1,renderFn:null},{type:"string",enum:["off","on","relative","interval"],enumDescriptions:[r.localize(77,null),r.localize(78,null),r.localize(79,null),r.localize(80,null)],default:"on",description:r.localize(81,null)})}validate(Q){let he=this.defaultValue.renderType,Ue=this.defaultValue.renderFn;return typeof Q<"u"&&(typeof Q=="function"?(he=4,Ue=Q):Q==="interval"?he=3:Q==="relative"?he=2:Q==="on"?he=1:he=0),{renderType:he,renderFn:Ue}}}function ye(X){const Q=X.get(88);return Q==="editable"?X.get(82):Q!=="on"}e.filterValidationDecorations=ye;class De extends E{constructor(){const Q=[],he={type:"number",description:r.localize(82,null)};super(92,"rulers",Q,{type:"array",items:{anyOf:[he,{type:["object"],properties:{column:he,color:{type:"string",description:r.localize(83,null),format:"color-hex"}}}]},default:Q,description:r.localize(84,null)})}validate(Q){if(Array.isArray(Q)){const he=[];for(const Ue of Q)if(typeof Ue=="number")he.push({column:C.clampedInt(Ue,0,0,1e4),color:null});else if(Ue&&typeof Ue=="object"){const je=Ue;he.push({column:C.clampedInt(je.column,0,0,1e4),color:je.color})}return he.sort((Ue,je)=>Ue.column-je.column),he}return this.defaultValue}}function ae(X,Q){if(typeof X!="string")return Q;switch(X){case"hidden":return 2;case"visible":return 3;default:return 1}}class ue extends E{constructor(){const Q={vertical:1,horizontal:1,arrowSize:11,useShadows:!0,verticalHasArrows:!1,horizontalHasArrows:!1,horizontalScrollbarSize:12,horizontalSliderSize:12,verticalScrollbarSize:14,verticalSliderSize:14,handleMouseWheel:!0,alwaysConsumeMouseWheel:!0,scrollByPage:!1};super(93,"scrollbar",Q,{"editor.scrollbar.vertical":{type:"string",enum:["auto","visible","hidden"],enumDescriptions:[r.localize(85,null),r.localize(86,null),r.localize(87,null)],default:"auto",description:r.localize(88,null)},"editor.scrollbar.horizontal":{type:"string",enum:["auto","visible","hidden"],enumDescriptions:[r.localize(89,null),r.localize(90,null),r.localize(91,null)],default:"auto",description:r.localize(92,null)},"editor.scrollbar.verticalScrollbarSize":{type:"number",default:Q.verticalScrollbarSize,description:r.localize(93,null)},"editor.scrollbar.horizontalScrollbarSize":{type:"number",default:Q.horizontalScrollbarSize,description:r.localize(94,null)},"editor.scrollbar.scrollByPage":{type:"boolean",default:Q.scrollByPage,description:r.localize(95,null)}})}validate(Q){if(!Q||typeof Q!="object")return this.defaultValue;const he=Q,Ue=C.clampedInt(he.horizontalScrollbarSize,this.defaultValue.horizontalScrollbarSize,0,1e3),je=C.clampedInt(he.verticalScrollbarSize,this.defaultValue.verticalScrollbarSize,0,1e3);return{arrowSize:C.clampedInt(he.arrowSize,this.defaultValue.arrowSize,0,1e3),vertical:ae(he.vertical,this.defaultValue.vertical),horizontal:ae(he.horizontal,this.defaultValue.horizontal),useShadows:d(he.useShadows,this.defaultValue.useShadows),verticalHasArrows:d(he.verticalHasArrows,this.defaultValue.verticalHasArrows),horizontalHasArrows:d(he.horizontalHasArrows,this.defaultValue.horizontalHasArrows),handleMouseWheel:d(he.handleMouseWheel,this.defaultValue.handleMouseWheel),alwaysConsumeMouseWheel:d(he.alwaysConsumeMouseWheel,this.defaultValue.alwaysConsumeMouseWheel),horizontalScrollbarSize:Ue,horizontalSliderSize:C.clampedInt(he.horizontalSliderSize,Ue,0,1e3),verticalScrollbarSize:je,verticalSliderSize:C.clampedInt(he.verticalSliderSize,je,0,1e3),scrollByPage:d(he.scrollByPage,this.defaultValue.scrollByPage)}}}e.inUntrustedWorkspace="inUntrustedWorkspace",e.unicodeHighlightConfigKeys={allowedCharacters:"editor.unicodeHighlight.allowedCharacters",invisibleCharacters:"editor.unicodeHighlight.invisibleCharacters",nonBasicASCII:"editor.unicodeHighlight.nonBasicASCII",ambiguousCharacters:"editor.unicodeHighlight.ambiguousCharacters",includeComments:"editor.unicodeHighlight.includeComments",includeStrings:"editor.unicodeHighlight.includeStrings",allowedLocales:"editor.unicodeHighlight.allowedLocales"};class Z extends E{constructor(){const Q={nonBasicASCII:e.inUntrustedWorkspace,invisibleCharacters:!0,ambiguousCharacters:!0,includeComments:e.inUntrustedWorkspace,includeStrings:!0,allowedCharacters:{},allowedLocales:{_os:!0,_vscode:!0}};super(115,"unicodeHighlight",Q,{[e.unicodeHighlightConfigKeys.nonBasicASCII]:{restricted:!0,type:["boolean","string"],enum:[!0,!1,e.inUntrustedWorkspace],default:Q.nonBasicASCII,description:r.localize(96,null)},[e.unicodeHighlightConfigKeys.invisibleCharacters]:{restricted:!0,type:"boolean",default:Q.invisibleCharacters,description:r.localize(97,null)},[e.unicodeHighlightConfigKeys.ambiguousCharacters]:{restricted:!0,type:"boolean",default:Q.ambiguousCharacters,description:r.localize(98,null)},[e.unicodeHighlightConfigKeys.includeComments]:{restricted:!0,type:["boolean","string"],enum:[!0,!1,e.inUntrustedWorkspace],default:Q.includeComments,description:r.localize(99,null)},[e.unicodeHighlightConfigKeys.includeStrings]:{restricted:!0,type:["boolean","string"],enum:[!0,!1,e.inUntrustedWorkspace],default:Q.includeStrings,description:r.localize(100,null)},[e.unicodeHighlightConfigKeys.allowedCharacters]:{restricted:!0,type:"object",default:Q.allowedCharacters,description:r.localize(101,null),additionalProperties:{type:"boolean"}},[e.unicodeHighlightConfigKeys.allowedLocales]:{restricted:!0,type:"object",additionalProperties:{type:"boolean"},default:Q.allowedLocales,description:r.localize(102,null)}})}applyUpdate(Q,he){let Ue=!1;he.allowedCharacters&&Q&&(_.equals(Q.allowedCharacters,he.allowedCharacters)||(Q={...Q,allowedCharacters:he.allowedCharacters},Ue=!0)),he.allowedLocales&&Q&&(_.equals(Q.allowedLocales,he.allowedLocales)||(Q={...Q,allowedLocales:he.allowedLocales},Ue=!0));const je=super.applyUpdate(Q,he);return Ue?new m(je.newValue,!0):je}validate(Q){if(!Q||typeof Q!="object")return this.defaultValue;const he=Q;return{nonBasicASCII:H(he.nonBasicASCII,e.inUntrustedWorkspace,[!0,!1,e.inUntrustedWorkspace]),invisibleCharacters:d(he.invisibleCharacters,this.defaultValue.invisibleCharacters),ambiguousCharacters:d(he.ambiguousCharacters,this.defaultValue.ambiguousCharacters),includeComments:H(he.includeComments,e.inUntrustedWorkspace,[!0,!1,e.inUntrustedWorkspace]),includeStrings:H(he.includeStrings,e.inUntrustedWorkspace,[!0,!1,e.inUntrustedWorkspace]),allowedCharacters:this.validateBooleanMap(Q.allowedCharacters,this.defaultValue.allowedCharacters),allowedLocales:this.validateBooleanMap(Q.allowedLocales,this.defaultValue.allowedLocales)}}validateBooleanMap(Q,he){if(typeof Q!="object"||!Q)return he;const Ue={};for(const[je,Ze]of Object.entries(Q))Ze===!0&&(Ue[je]=!0);return Ue}}class J extends E{constructor(){const Q={enabled:!0,mode:"subwordSmart"};super(56,"inlineSuggest",Q,{"editor.inlineSuggest.enabled":{type:"boolean",default:Q.enabled,description:r.localize(103,null)}})}validate(Q){if(!Q||typeof Q!="object")return this.defaultValue;const he=Q;return{enabled:d(he.enabled,this.defaultValue.enabled),mode:t(he.mode,this.defaultValue.mode,["prefix","subword","subwordSmart"])}}}class I extends E{constructor(){const Q={enabled:A.EDITOR_MODEL_DEFAULTS.bracketPairColorizationOptions.enabled,independentColorPoolPerBracketType:A.EDITOR_MODEL_DEFAULTS.bracketPairColorizationOptions.independentColorPoolPerBracketType};super(12,"bracketPairColorization",Q,{"editor.bracketPairColorization.enabled":{type:"boolean",default:Q.enabled,markdownDescription:r.localize(104,null,"`#workbench.colorCustomizations#`")},"editor.bracketPairColorization.independentColorPoolPerBracketType":{type:"boolean",default:Q.independentColorPoolPerBracketType,description:r.localize(105,null)}})}validate(Q){if(!Q||typeof Q!="object")return this.defaultValue;const he=Q;return{enabled:d(he.enabled,this.defaultValue.enabled),independentColorPoolPerBracketType:d(he.independentColorPoolPerBracketType,this.defaultValue.independentColorPoolPerBracketType)}}}class U extends E{constructor(){const Q={bracketPairs:!1,bracketPairsHorizontal:"active",highlightActiveBracketPair:!0,indentation:!0,highlightActiveIndentation:!0};super(13,"guides",Q,{"editor.guides.bracketPairs":{type:["boolean","string"],enum:[!0,"active",!1],enumDescriptions:[r.localize(106,null),r.localize(107,null),r.localize(108,null)],default:Q.bracketPairs,description:r.localize(109,null)},"editor.guides.bracketPairsHorizontal":{type:["boolean","string"],enum:[!0,"active",!1],enumDescriptions:[r.localize(110,null),r.localize(111,null),r.localize(112,null)],default:Q.bracketPairsHorizontal,description:r.localize(113,null)},"editor.guides.highlightActiveBracketPair":{type:"boolean",default:Q.highlightActiveBracketPair,description:r.localize(114,null)},"editor.guides.indentation":{type:"boolean",default:Q.indentation,description:r.localize(115,null)},"editor.guides.highlightActiveIndentation":{type:["boolean","string"],enum:[!0,"always",!1],enumDescriptions:[r.localize(116,null),r.localize(117,null),r.localize(118,null)],default:Q.highlightActiveIndentation,description:r.localize(119,null)}})}validate(Q){if(!Q||typeof Q!="object")return this.defaultValue;const he=Q;return{bracketPairs:H(he.bracketPairs,this.defaultValue.bracketPairs,[!0,!1,"active"]),bracketPairsHorizontal:H(he.bracketPairsHorizontal,this.defaultValue.bracketPairsHorizontal,[!0,!1,"active"]),highlightActiveBracketPair:d(he.highlightActiveBracketPair,this.defaultValue.highlightActiveBracketPair),indentation:d(he.indentation,this.defaultValue.indentation),highlightActiveIndentation:H(he.highlightActiveIndentation,this.defaultValue.highlightActiveIndentation,[!0,!1,"always"])}}}function H(X,Q,he){const Ue=he.indexOf(X);return Ue===-1?Q:he[Ue]}class j extends E{constructor(){const Q={insertMode:"insert",filterGraceful:!0,snippetsPreventQuickSuggestions:!0,localityBonus:!1,shareSuggestSelections:!1,showIcons:!0,showStatusBar:!1,preview:!1,previewMode:"subwordSmart",showInlineDetails:!0,showMethods:!0,showFunctions:!0,showConstructors:!0,showDeprecated:!0,matchOnWordStartOnly:!0,showFields:!0,showVariables:!0,showClasses:!0,showStructs:!0,showInterfaces:!0,showModules:!0,showProperties:!0,showEvents:!0,showOperators:!0,showUnits:!0,showValues:!0,showConstants:!0,showEnums:!0,showEnumMembers:!0,showKeywords:!0,showWords:!0,showColors:!0,showFiles:!0,showReferences:!0,showFolders:!0,showTypeParameters:!0,showSnippets:!0,showUsers:!0,showIssues:!0};super(108,"suggest",Q,{"editor.suggest.insertMode":{type:"string",enum:["insert","replace"],enumDescriptions:[r.localize(120,null),r.localize(121,null)],default:Q.insertMode,description:r.localize(122,null)},"editor.suggest.filterGraceful":{type:"boolean",default:Q.filterGraceful,description:r.localize(123,null)},"editor.suggest.localityBonus":{type:"boolean",default:Q.localityBonus,description:r.localize(124,null)},"editor.suggest.shareSuggestSelections":{type:"boolean",default:Q.shareSuggestSelections,markdownDescription:r.localize(125,null)},"editor.suggest.snippetsPreventQuickSuggestions":{type:"boolean",default:Q.snippetsPreventQuickSuggestions,description:r.localize(126,null)},"editor.suggest.showIcons":{type:"boolean",default:Q.showIcons,description:r.localize(127,null)},"editor.suggest.showStatusBar":{type:"boolean",default:Q.showStatusBar,description:r.localize(128,null)},"editor.suggest.preview":{type:"boolean",default:Q.preview,description:r.localize(129,null)},"editor.suggest.showInlineDetails":{type:"boolean",default:Q.showInlineDetails,description:r.localize(130,null)},"editor.suggest.maxVisibleSuggestions":{type:"number",deprecationMessage:r.localize(131,null)},"editor.suggest.filteredTypes":{type:"object",deprecationMessage:r.localize(132,null)},"editor.suggest.showMethods":{type:"boolean",default:!0,markdownDescription:r.localize(133,null)},"editor.suggest.showFunctions":{type:"boolean",default:!0,markdownDescription:r.localize(134,null)},"editor.suggest.showConstructors":{type:"boolean",default:!0,markdownDescription:r.localize(135,null)},"editor.suggest.showDeprecated":{type:"boolean",default:!0,markdownDescription:r.localize(136,null)},"editor.suggest.matchOnWordStartOnly":{type:"boolean",default:!0,markdownDescription:r.localize(137,null)},"editor.suggest.showFields":{type:"boolean",default:!0,markdownDescription:r.localize(138,null)},"editor.suggest.showVariables":{type:"boolean",default:!0,markdownDescription:r.localize(139,null)},"editor.suggest.showClasses":{type:"boolean",default:!0,markdownDescription:r.localize(140,null)},"editor.suggest.showStructs":{type:"boolean",default:!0,markdownDescription:r.localize(141,null)},"editor.suggest.showInterfaces":{type:"boolean",default:!0,markdownDescription:r.localize(142,null)},"editor.suggest.showModules":{type:"boolean",default:!0,markdownDescription:r.localize(143,null)},"editor.suggest.showProperties":{type:"boolean",default:!0,markdownDescription:r.localize(144,null)},"editor.suggest.showEvents":{type:"boolean",default:!0,markdownDescription:r.localize(145,null)},"editor.suggest.showOperators":{type:"boolean",default:!0,markdownDescription:r.localize(146,null)},"editor.suggest.showUnits":{type:"boolean",default:!0,markdownDescription:r.localize(147,null)},"editor.suggest.showValues":{type:"boolean",default:!0,markdownDescription:r.localize(148,null)},"editor.suggest.showConstants":{type:"boolean",default:!0,markdownDescription:r.localize(149,null)},"editor.suggest.showEnums":{type:"boolean",default:!0,markdownDescription:r.localize(150,null)},"editor.suggest.showEnumMembers":{type:"boolean",default:!0,markdownDescription:r.localize(151,null)},"editor.suggest.showKeywords":{type:"boolean",default:!0,markdownDescription:r.localize(152,null)},"editor.suggest.showWords":{type:"boolean",default:!0,markdownDescription:r.localize(153,null)},"editor.suggest.showColors":{type:"boolean",default:!0,markdownDescription:r.localize(154,null)},"editor.suggest.showFiles":{type:"boolean",default:!0,markdownDescription:r.localize(155,null)},"editor.suggest.showReferences":{type:"boolean",default:!0,markdownDescription:r.localize(156,null)},"editor.suggest.showCustomcolors":{type:"boolean",default:!0,markdownDescription:r.localize(157,null)},"editor.suggest.showFolders":{type:"boolean",default:!0,markdownDescription:r.localize(158,null)},"editor.suggest.showTypeParameters":{type:"boolean",default:!0,markdownDescription:r.localize(159,null)},"editor.suggest.showSnippets":{type:"boolean",default:!0,markdownDescription:r.localize(160,null)},"editor.suggest.showUsers":{type:"boolean",default:!0,markdownDescription:r.localize(161,null)},"editor.suggest.showIssues":{type:"boolean",default:!0,markdownDescription:r.localize(162,null)}})}validate(Q){if(!Q||typeof Q!="object")return this.defaultValue;const he=Q;return{insertMode:t(he.insertMode,this.defaultValue.insertMode,["insert","replace"]),filterGraceful:d(he.filterGraceful,this.defaultValue.filterGraceful),snippetsPreventQuickSuggestions:d(he.snippetsPreventQuickSuggestions,this.defaultValue.filterGraceful),localityBonus:d(he.localityBonus,this.defaultValue.localityBonus),shareSuggestSelections:d(he.shareSuggestSelections,this.defaultValue.shareSuggestSelections),showIcons:d(he.showIcons,this.defaultValue.showIcons),showStatusBar:d(he.showStatusBar,this.defaultValue.showStatusBar),preview:d(he.preview,this.defaultValue.preview),previewMode:t(he.previewMode,this.defaultValue.previewMode,["prefix","subword","subwordSmart"]),showInlineDetails:d(he.showInlineDetails,this.defaultValue.showInlineDetails),showMethods:d(he.showMethods,this.defaultValue.showMethods),showFunctions:d(he.showFunctions,this.defaultValue.showFunctions),showConstructors:d(he.showConstructors,this.defaultValue.showConstructors),showDeprecated:d(he.showDeprecated,this.defaultValue.showDeprecated),matchOnWordStartOnly:d(he.matchOnWordStartOnly,this.defaultValue.matchOnWordStartOnly),showFields:d(he.showFields,this.defaultValue.showFields),showVariables:d(he.showVariables,this.defaultValue.showVariables),showClasses:d(he.showClasses,this.defaultValue.showClasses),showStructs:d(he.showStructs,this.defaultValue.showStructs),showInterfaces:d(he.showInterfaces,this.defaultValue.showInterfaces),showModules:d(he.showModules,this.defaultValue.showModules),showProperties:d(he.showProperties,this.defaultValue.showProperties),showEvents:d(he.showEvents,this.defaultValue.showEvents),showOperators:d(he.showOperators,this.defaultValue.showOperators),showUnits:d(he.showUnits,this.defaultValue.showUnits),showValues:d(he.showValues,this.defaultValue.showValues),showConstants:d(he.showConstants,this.defaultValue.showConstants),showEnums:d(he.showEnums,this.defaultValue.showEnums),showEnumMembers:d(he.showEnumMembers,this.defaultValue.showEnumMembers),showKeywords:d(he.showKeywords,this.defaultValue.showKeywords),showWords:d(he.showWords,this.defaultValue.showWords),showColors:d(he.showColors,this.defaultValue.showColors),showFiles:d(he.showFiles,this.defaultValue.showFiles),showReferences:d(he.showReferences,this.defaultValue.showReferences),showFolders:d(he.showFolders,this.defaultValue.showFolders),showTypeParameters:d(he.showTypeParameters,this.defaultValue.showTypeParameters),showSnippets:d(he.showSnippets,this.defaultValue.showSnippets),showUsers:d(he.showUsers,this.defaultValue.showUsers),showIssues:d(he.showIssues,this.defaultValue.showIssues)}}}class se extends E{constructor(){super(103,"smartSelect",{selectLeadingAndTrailingWhitespace:!0},{"editor.smartSelect.selectLeadingAndTrailingWhitespace":{description:r.localize(163,null),default:!0,type:"boolean"}})}validate(Q){return!Q||typeof Q!="object"?this.defaultValue:{selectLeadingAndTrailingWhitespace:d(Q.selectLeadingAndTrailingWhitespace,this.defaultValue.selectLeadingAndTrailingWhitespace)}}}class le extends f{constructor(){super(132)}compute(Q,he,Ue){return he.get(82)?!0:Q.tabFocusMode}}var Y;(function(X){X[X.None=0]="None",X[X.Same=1]="Same",X[X.Indent=2]="Indent",X[X.DeepIndent=3]="DeepIndent"})(Y=e.WrappingIndent||(e.WrappingIndent={}));function ve(X){switch(X){case"none":return 0;case"same":return 1;case"indent":return 2;case"deepIndent":return 3}}class pe extends f{constructor(){super(134)}compute(Q,he,Ue){const je=he.get(133);return{isDominatedByLongLines:Q.isDominatedByLongLines,isWordWrapMinified:je.isWordWrapMinified,isViewportWrapping:je.isViewportWrapping,wrappingColumn:je.wrappingColumn}}}class Me extends E{constructor(){const Q={enabled:!0};super(32,"dropIntoEditor",Q,{"editor.dropIntoEditor.enabled":{type:"boolean",default:Q.enabled,markdownDescription:r.localize(164,null)}})}validate(Q){return!Q||typeof Q!="object"?this.defaultValue:{enabled:d(Q.enabled,this.defaultValue.enabled)}}}const xe="Consolas, 'Courier New', monospace",Ye="Menlo, Monaco, 'Courier New', monospace",Ge="'Droid Sans Mono', 'monospace', monospace";e.EDITOR_FONT_DEFAULTS={fontFamily:y.isMacintosh?Ye:y.isLinux?Ge:xe,fontWeight:"normal",fontSize:y.isMacintosh?12:14,lineHeight:0,letterSpacing:0},e.editorOptionsRegistry=[];function Te(X){return e.editorOptionsRegistry[X.id]=X,X}var rt;(function(X){X[X.acceptSuggestionOnCommitCharacter=0]="acceptSuggestionOnCommitCharacter",X[X.acceptSuggestionOnEnter=1]="acceptSuggestionOnEnter",X[X.accessibilitySupport=2]="accessibilitySupport",X[X.accessibilityPageSize=3]="accessibilityPageSize",X[X.ariaLabel=4]="ariaLabel",X[X.autoClosingBrackets=5]="autoClosingBrackets",X[X.autoClosingDelete=6]="autoClosingDelete",X[X.autoClosingOvertype=7]="autoClosingOvertype",X[X.autoClosingQuotes=8]="autoClosingQuotes",X[X.autoIndent=9]="autoIndent",X[X.automaticLayout=10]="automaticLayout",X[X.autoSurround=11]="autoSurround",X[X.bracketPairColorization=12]="bracketPairColorization",X[X.guides=13]="guides",X[X.codeLens=14]="codeLens",X[X.codeLensFontFamily=15]="codeLensFontFamily",X[X.codeLensFontSize=16]="codeLensFontSize",X[X.colorDecorators=17]="colorDecorators",X[X.columnSelection=18]="columnSelection",X[X.comments=19]="comments",X[X.contextmenu=20]="contextmenu",X[X.copyWithSyntaxHighlighting=21]="copyWithSyntaxHighlighting",X[X.cursorBlinking=22]="cursorBlinking",X[X.cursorSmoothCaretAnimation=23]="cursorSmoothCaretAnimation",X[X.cursorStyle=24]="cursorStyle",X[X.cursorSurroundingLines=25]="cursorSurroundingLines",X[X.cursorSurroundingLinesStyle=26]="cursorSurroundingLinesStyle",X[X.cursorWidth=27]="cursorWidth",X[X.disableLayerHinting=28]="disableLayerHinting",X[X.disableMonospaceOptimizations=29]="disableMonospaceOptimizations",X[X.domReadOnly=30]="domReadOnly",X[X.dragAndDrop=31]="dragAndDrop",X[X.dropIntoEditor=32]="dropIntoEditor",X[X.emptySelectionClipboard=33]="emptySelectionClipboard",X[X.extraEditorClassName=34]="extraEditorClassName",X[X.fastScrollSensitivity=35]="fastScrollSensitivity",X[X.find=36]="find",X[X.fixedOverflowWidgets=37]="fixedOverflowWidgets",X[X.folding=38]="folding",X[X.foldingStrategy=39]="foldingStrategy",X[X.foldingHighlight=40]="foldingHighlight",X[X.foldingImportsByDefault=41]="foldingImportsByDefault",X[X.foldingMaximumRegions=42]="foldingMaximumRegions",X[X.unfoldOnClickAfterEndOfLine=43]="unfoldOnClickAfterEndOfLine",X[X.fontFamily=44]="fontFamily",X[X.fontInfo=45]="fontInfo",X[X.fontLigatures=46]="fontLigatures",X[X.fontSize=47]="fontSize",X[X.fontWeight=48]="fontWeight",X[X.formatOnPaste=49]="formatOnPaste",X[X.formatOnType=50]="formatOnType",X[X.glyphMargin=51]="glyphMargin",X[X.gotoLocation=52]="gotoLocation",X[X.hideCursorInOverviewRuler=53]="hideCursorInOverviewRuler",X[X.hover=54]="hover",X[X.inDiffEditor=55]="inDiffEditor",X[X.inlineSuggest=56]="inlineSuggest",X[X.letterSpacing=57]="letterSpacing",X[X.lightbulb=58]="lightbulb",X[X.lineDecorationsWidth=59]="lineDecorationsWidth",X[X.lineHeight=60]="lineHeight",X[X.lineNumbers=61]="lineNumbers",X[X.lineNumbersMinChars=62]="lineNumbersMinChars",X[X.linkedEditing=63]="linkedEditing",X[X.links=64]="links",X[X.matchBrackets=65]="matchBrackets",X[X.minimap=66]="minimap",X[X.mouseStyle=67]="mouseStyle",X[X.mouseWheelScrollSensitivity=68]="mouseWheelScrollSensitivity",X[X.mouseWheelZoom=69]="mouseWheelZoom",X[X.multiCursorMergeOverlapping=70]="multiCursorMergeOverlapping",X[X.multiCursorModifier=71]="multiCursorModifier",X[X.multiCursorPaste=72]="multiCursorPaste",X[X.occurrencesHighlight=73]="occurrencesHighlight",X[X.overviewRulerBorder=74]="overviewRulerBorder",X[X.overviewRulerLanes=75]="overviewRulerLanes",X[X.padding=76]="padding",X[X.parameterHints=77]="parameterHints",X[X.peekWidgetDefaultFocus=78]="peekWidgetDefaultFocus",X[X.definitionLinkOpensInPeek=79]="definitionLinkOpensInPeek",X[X.quickSuggestions=80]="quickSuggestions",X[X.quickSuggestionsDelay=81]="quickSuggestionsDelay",X[X.readOnly=82]="readOnly",X[X.renameOnType=83]="renameOnType",X[X.renderControlCharacters=84]="renderControlCharacters",X[X.renderFinalNewline=85]="renderFinalNewline",X[X.renderLineHighlight=86]="renderLineHighlight",X[X.renderLineHighlightOnlyWhenFocus=87]="renderLineHighlightOnlyWhenFocus",X[X.renderValidationDecorations=88]="renderValidationDecorations",X[X.renderWhitespace=89]="renderWhitespace",X[X.revealHorizontalRightPadding=90]="revealHorizontalRightPadding",X[X.roundedSelection=91]="roundedSelection",X[X.rulers=92]="rulers",X[X.scrollbar=93]="scrollbar",X[X.scrollBeyondLastColumn=94]="scrollBeyondLastColumn",X[X.scrollBeyondLastLine=95]="scrollBeyondLastLine",X[X.scrollPredominantAxis=96]="scrollPredominantAxis",X[X.selectionClipboard=97]="selectionClipboard",X[X.selectionHighlight=98]="selectionHighlight",X[X.selectOnLineNumbers=99]="selectOnLineNumbers",X[X.showFoldingControls=100]="showFoldingControls",X[X.showUnused=101]="showUnused",X[X.snippetSuggestions=102]="snippetSuggestions",X[X.smartSelect=103]="smartSelect",X[X.smoothScrolling=104]="smoothScrolling",X[X.stickyScroll=105]="stickyScroll",X[X.stickyTabStops=106]="stickyTabStops",X[X.stopRenderingLineAfter=107]="stopRenderingLineAfter",X[X.suggest=108]="suggest",X[X.suggestFontSize=109]="suggestFontSize",X[X.suggestLineHeight=110]="suggestLineHeight",X[X.suggestOnTriggerCharacters=111]="suggestOnTriggerCharacters",X[X.suggestSelection=112]="suggestSelection",X[X.tabCompletion=113]="tabCompletion",X[X.tabIndex=114]="tabIndex",X[X.unicodeHighlighting=115]="unicodeHighlighting",X[X.unusualLineTerminators=116]="unusualLineTerminators",X[X.useShadowDOM=117]="useShadowDOM",X[X.useTabStops=118]="useTabStops",X[X.wordSeparators=119]="wordSeparators",X[X.wordWrap=120]="wordWrap",X[X.wordWrapBreakAfterCharacters=121]="wordWrapBreakAfterCharacters",X[X.wordWrapBreakBeforeCharacters=122]="wordWrapBreakBeforeCharacters",X[X.wordWrapColumn=123]="wordWrapColumn",X[X.wordWrapOverride1=124]="wordWrapOverride1",X[X.wordWrapOverride2=125]="wordWrapOverride2",X[X.wrappingIndent=126]="wrappingIndent",X[X.wrappingStrategy=127]="wrappingStrategy",X[X.showDeprecated=128]="showDeprecated",X[X.inlayHints=129]="inlayHints",X[X.editorClassName=130]="editorClassName",X[X.pixelRatio=131]="pixelRatio",X[X.tabFocusMode=132]="tabFocusMode",X[X.layoutInfo=133]="layoutInfo",X[X.wrappingInfo=134]="wrappingInfo"})(rt=e.EditorOption||(e.EditorOption={})),e.EditorOptions={acceptSuggestionOnCommitCharacter:Te(new h(0,"acceptSuggestionOnCommitCharacter",!0,{markdownDescription:r.localize(165,null)})),acceptSuggestionOnEnter:Te(new u(1,"acceptSuggestionOnEnter","on",["on","smart","off"],{markdownEnumDescriptions:["",r.localize(166,null),""],markdownDescription:r.localize(167,null)})),accessibilitySupport:Te(new s),accessibilityPageSize:Te(new C(3,"accessibilityPageSize",10,1,1073741824,{description:r.localize(168,null)})),ariaLabel:Te(new w(4,"ariaLabel",r.localize(169,null))),autoClosingBrackets:Te(new u(5,"autoClosingBrackets","languageDefined",["always","languageDefined","beforeWhitespace","never"],{enumDescriptions:["",r.localize(170,null),r.localize(171,null),""],description:r.localize(172,null)})),autoClosingDelete:Te(new u(6,"autoClosingDelete","auto",["always","auto","never"],{enumDescriptions:["",r.localize(173,null),""],description:r.localize(174,null)})),autoClosingOvertype:Te(new u(7,"autoClosingOvertype","auto",["always","auto","never"],{enumDescriptions:["",r.localize(175,null),""],description:r.localize(176,null)})),autoClosingQuotes:Te(new u(8,"autoClosingQuotes","languageDefined",["always","languageDefined","beforeWhitespace","never"],{enumDescriptions:["",r.localize(177,null),r.localize(178,null),""],description:r.localize(179,null)})),autoIndent:Te(new i(9,"autoIndent",4,"full",["none","keep","brackets","advanced","full"],n,{enumDescriptions:[r.localize(180,null),r.localize(181,null),r.localize(182,null),r.localize(183,null),r.localize(184,null)],description:r.localize(185,null)})),automaticLayout:Te(new h(10,"automaticLayout",!1)),autoSurround:Te(new u(11,"autoSurround","languageDefined",["languageDefined","quotes","brackets","never"],{enumDescriptions:[r.localize(186,null),r.localize(187,null),r.localize(188,null),""],description:r.localize(189,null)})),bracketPairColorization:Te(new I),bracketPairGuides:Te(new U),stickyTabStops:Te(new h(106,"stickyTabStops",!1,{description:r.localize(190,null)})),codeLens:Te(new h(14,"codeLens",!0,{description:r.localize(191,null)})),codeLensFontFamily:Te(new w(15,"codeLensFontFamily","",{description:r.localize(192,null)})),codeLensFontSize:Te(new C(16,"codeLensFontSize",0,0,100,{type:"number",default:0,minimum:0,maximum:100,markdownDescription:r.localize(193,null)})),colorDecorators:Te(new h(17,"colorDecorators",!0,{description:r.localize(194,null)})),columnSelection:Te(new h(18,"columnSelection",!1,{description:r.localize(195,null)})),comments:Te(new a),contextmenu:Te(new h(20,"contextmenu",!0)),copyWithSyntaxHighlighting:Te(new h(21,"copyWithSyntaxHighlighting",!0,{description:r.localize(196,null)})),cursorBlinking:Te(new i(22,"cursorBlinking",1,"blink",["blink","smooth","phase","expand","solid"],v,{description:r.localize(197,null)})),cursorSmoothCaretAnimation:Te(new h(23,"cursorSmoothCaretAnimation",!1,{description:r.localize(198,null)})),cursorStyle:Te(new i(24,"cursorStyle",p.Line,"line",["line","block","underline","line-thin","block-outline","underline-thin"],N,{description:r.localize(199,null)})),cursorSurroundingLines:Te(new C(25,"cursorSurroundingLines",0,0,1073741824,{description:r.localize(200,null)})),cursorSurroundingLinesStyle:Te(new u(26,"cursorSurroundingLinesStyle","default",["default","all"],{enumDescriptions:[r.localize(201,null),r.localize(202,null)],description:r.localize(203,null)})),cursorWidth:Te(new C(27,"cursorWidth",0,0,1073741824,{markdownDescription:r.localize(204,null)})),disableLayerHinting:Te(new h(28,"disableLayerHinting",!1)),disableMonospaceOptimizations:Te(new h(29,"disableMonospaceOptimizations",!1)),domReadOnly:Te(new h(30,"domReadOnly",!1)),dragAndDrop:Te(new h(31,"dragAndDrop",!0,{description:r.localize(205,null)})),emptySelectionClipboard:Te(new B),dropIntoEditor:Te(new Me),stickyScroll:Te(new oe),extraEditorClassName:Te(new w(34,"extraEditorClassName","")),fastScrollSensitivity:Te(new l(35,"fastScrollSensitivity",5,X=>X<=0?5:X,{markdownDescription:r.localize(206,null)})),find:Te(new D),fixedOverflowWidgets:Te(new h(37,"fixedOverflowWidgets",!1)),folding:Te(new h(38,"folding",!0,{description:r.localize(207,null)})),foldingStrategy:Te(new u(39,"foldingStrategy","auto",["auto","indentation"],{enumDescriptions:[r.localize(208,null),r.localize(209,null)],description:r.localize(210,null)})),foldingHighlight:Te(new h(40,"foldingHighlight",!0,{description:r.localize(211,null)})),foldingImportsByDefault:Te(new h(41,"foldingImportsByDefault",!1,{description:r.localize(212,null)})),foldingMaximumRegions:Te(new C(42,"foldingMaximumRegions",5e3,10,65e3,{description:r.localize(213,null)})),unfoldOnClickAfterEndOfLine:Te(new h(43,"unfoldOnClickAfterEndOfLine",!1,{description:r.localize(214,null)})),fontFamily:Te(new w(44,"fontFamily",e.EDITOR_FONT_DEFAULTS.fontFamily,{description:r.localize(215,null)})),fontInfo:Te(new L),fontLigatures2:Te(new z),fontSize:Te(new R),fontWeight:Te(new K),formatOnPaste:Te(new h(49,"formatOnPaste",!1,{description:r.localize(216,null)})),formatOnType:Te(new h(50,"formatOnType",!1,{description:r.localize(217,null)})),glyphMargin:Te(new h(51,"glyphMargin",!0,{description:r.localize(218,null)})),gotoLocation:Te(new W),hideCursorInOverviewRuler:Te(new h(53,"hideCursorInOverviewRuler",!1,{description:r.localize(219,null)})),hover:Te(new $),inDiffEditor:Te(new h(55,"inDiffEditor",!1)),letterSpacing:Te(new l(57,"letterSpacing",e.EDITOR_FONT_DEFAULTS.letterSpacing,X=>l.clamp(X,-5,20),{description:r.localize(220,null)})),lightbulb:Te(new ge),lineDecorationsWidth:Te(new c(59,"lineDecorationsWidth",10)),lineHeight:Te(new ce),lineNumbers:Te(new ke),lineNumbersMinChars:Te(new C(62,"lineNumbersMinChars",5,1,300)),linkedEditing:Te(new h(63,"linkedEditing",!1,{description:r.localize(221,null)})),links:Te(new h(64,"links",!0,{description:r.localize(222,null)})),matchBrackets:Te(new u(65,"matchBrackets","always",["always","near","never"],{description:r.localize(223,null)})),minimap:Te(new me),mouseStyle:Te(new u(67,"mouseStyle","text",["text","default","copy"])),mouseWheelScrollSensitivity:Te(new l(68,"mouseWheelScrollSensitivity",1,X=>X===0?1:X,{markdownDescription:r.localize(224,null)})),mouseWheelZoom:Te(new h(69,"mouseWheelZoom",!1,{markdownDescription:r.localize(225,null)})),multiCursorMergeOverlapping:Te(new h(70,"multiCursorMergeOverlapping",!0,{description:r.localize(226,null)})),multiCursorModifier:Te(new i(71,"multiCursorModifier","altKey","alt",["ctrlCmd","alt"],ee,{markdownEnumDescriptions:[r.localize(227,null),r.localize(228,null)],markdownDescription:r.localize(229,null)})),multiCursorPaste:Te(new u(72,"multiCursorPaste","spread",["spread","full"],{markdownEnumDescriptions:[r.localize(230,null),r.localize(231,null)],markdownDescription:r.localize(232,null)})),occurrencesHighlight:Te(new h(73,"occurrencesHighlight",!0,{description:r.localize(233,null)})),overviewRulerBorder:Te(new h(74,"overviewRulerBorder",!0,{description:r.localize(234,null)})),overviewRulerLanes:Te(new C(75,"overviewRulerLanes",3,0,3)),padding:Te(new be),parameterHints:Te(new _e),peekWidgetDefaultFocus:Te(new u(78,"peekWidgetDefaultFocus","tree",["tree","editor"],{enumDescriptions:[r.localize(235,null),r.localize(236,null)],description:r.localize(237,null)})),definitionLinkOpensInPeek:Te(new h(79,"definitionLinkOpensInPeek",!1,{description:r.localize(238,null)})),quickSuggestions:Te(new Be),quickSuggestionsDelay:Te(new C(81,"quickSuggestionsDelay",10,0,1073741824,{description:r.localize(239,null)})),readOnly:Te(new h(82,"readOnly",!1)),renameOnType:Te(new h(83,"renameOnType",!1,{description:r.localize(240,null),markdownDeprecationMessage:r.localize(241,null)})),renderControlCharacters:Te(new h(84,"renderControlCharacters",!0,{description:r.localize(242,null),restricted:!0})),renderFinalNewline:Te(new h(85,"renderFinalNewline",!0,{description:r.localize(243,null)})),renderLineHighlight:Te(new u(86,"renderLineHighlight","line",["none","gutter","line","all"],{enumDescriptions:["","","",r.localize(244,null)],description:r.localize(245,null)})),renderLineHighlightOnlyWhenFocus:Te(new h(87,"renderLineHighlightOnlyWhenFocus",!1,{description:r.localize(246,null)})),renderValidationDecorations:Te(new u(88,"renderValidationDecorations","editable",["editable","on","off"])),renderWhitespace:Te(new u(89,"renderWhitespace","selection",["none","boundary","selection","trailing","all"],{enumDescriptions:["",r.localize(247,null),r.localize(248,null),r.localize(249,null),""],description:r.localize(250,null)})),revealHorizontalRightPadding:Te(new C(90,"revealHorizontalRightPadding",15,0,1e3)),roundedSelection:Te(new h(91,"roundedSelection",!0,{description:r.localize(251,null)})),rulers:Te(new De),scrollbar:Te(new ue),scrollBeyondLastColumn:Te(new C(94,"scrollBeyondLastColumn",4,0,1073741824,{description:r.localize(252,null)})),scrollBeyondLastLine:Te(new h(95,"scrollBeyondLastLine",!0,{description:r.localize(253,null)})),scrollPredominantAxis:Te(new h(96,"scrollPredominantAxis",!0,{description:r.localize(254,null)})),selectionClipboard:Te(new h(97,"selectionClipboard",!0,{description:r.localize(255,null),included:y.isLinux})),selectionHighlight:Te(new h(98,"selectionHighlight",!0,{description:r.localize(256,null)})),selectOnLineNumbers:Te(new h(99,"selectOnLineNumbers",!0)),showFoldingControls:Te(new u(100,"showFoldingControls","mouseover",["always","never","mouseover"],{enumDescriptions:[r.localize(257,null),r.localize(258,null),r.localize(259,null)],description:r.localize(260,null)})),showUnused:Te(new h(101,"showUnused",!0,{description:r.localize(261,null)})),showDeprecated:Te(new h(128,"showDeprecated",!0,{description:r.localize(262,null)})),inlayHints:Te(new Ee),snippetSuggestions:Te(new u(102,"snippetSuggestions","inline",["top","bottom","inline","none"],{enumDescriptions:[r.localize(263,null),r.localize(264,null),r.localize(265,null),r.localize(266,null)],description:r.localize(267,null)})),smartSelect:Te(new se),smoothScrolling:Te(new h(104,"smoothScrolling",!1,{description:r.localize(268,null)})),stopRenderingLineAfter:Te(new C(107,"stopRenderingLineAfter",1e4,-1,1073741824)),suggest:Te(new j),inlineSuggest:Te(new J),suggestFontSize:Te(new C(109,"suggestFontSize",0,0,1e3,{markdownDescription:r.localize(269,null,"`0`","`#editor.fontSize#`")})),suggestLineHeight:Te(new C(110,"suggestLineHeight",0,0,1e3,{markdownDescription:r.localize(270,null,"`0`","`#editor.lineHeight#`")})),suggestOnTriggerCharacters:Te(new h(111,"suggestOnTriggerCharacters",!0,{description:r.localize(271,null)})),suggestSelection:Te(new u(112,"suggestSelection","first",["first","recentlyUsed","recentlyUsedByPrefix"],{markdownEnumDescriptions:[r.localize(272,null),r.localize(273,null),r.localize(274,null)],description:r.localize(275,null)})),tabCompletion:Te(new u(113,"tabCompletion","off",["on","off","onlySnippets"],{enumDescriptions:[r.localize(276,null),r.localize(277,null),r.localize(278,null)],description:r.localize(279,null)})),tabIndex:Te(new C(114,"tabIndex",0,-1,1073741824)),unicodeHighlight:Te(new Z),unusualLineTerminators:Te(new u(116,"unusualLineTerminators","prompt",["auto","off","prompt"],{enumDescriptions:[r.localize(280,null),r.localize(281,null),r.localize(282,null)],description:r.localize(283,null)})),useShadowDOM:Te(new h(117,"useShadowDOM",!0)),useTabStops:Te(new h(118,"useTabStops",!0,{description:r.localize(284,null)})),wordSeparators:Te(new w(119,"wordSeparators",S.USUAL_WORD_SEPARATORS,{description:r.localize(285,null)})),wordWrap:Te(new u(120,"wordWrap","off",["off","on","wordWrapColumn","bounded"],{markdownEnumDescriptions:[r.localize(286,null),r.localize(287,null),r.localize(288,null),r.localize(289,null)],description:r.localize(290,null)})),wordWrapBreakAfterCharacters:Te(new w(121,"wordWrapBreakAfterCharacters"," 	})]?|/&.,;\xA2\xB0\u2032\u2033\u2030\u2103\u3001\u3002\uFF61\uFF64\uFFE0\uFF0C\uFF0E\uFF1A\uFF1B\uFF1F\uFF01\uFF05\u30FB\uFF65\u309D\u309E\u30FD\u30FE\u30FC\u30A1\u30A3\u30A5\u30A7\u30A9\u30C3\u30E3\u30E5\u30E7\u30EE\u30F5\u30F6\u3041\u3043\u3045\u3047\u3049\u3063\u3083\u3085\u3087\u308E\u3095\u3096\u31F0\u31F1\u31F2\u31F3\u31F4\u31F5\u31F6\u31F7\u31F8\u31F9\u31FA\u31FB\u31FC\u31FD\u31FE\u31FF\u3005\u303B\uFF67\uFF68\uFF69\uFF6A\uFF6B\uFF6C\uFF6D\uFF6E\uFF6F\uFF70\u201D\u3009\u300B\u300D\u300F\u3011\u3015\uFF09\uFF3D\uFF5D\uFF63")),wordWrapBreakBeforeCharacters:Te(new w(122,"wordWrapBreakBeforeCharacters","([{\u2018\u201C\u3008\u300A\u300C\u300E\u3010\u3014\uFF08\uFF3B\uFF5B\uFF62\xA3\xA5\uFF04\uFFE1\uFFE5+\uFF0B")),wordWrapColumn:Te(new C(123,"wordWrapColumn",80,1,1073741824,{markdownDescription:r.localize(291,null)})),wordWrapOverride1:Te(new u(124,"wordWrapOverride1","inherit",["off","on","inherit"])),wordWrapOverride2:Te(new u(125,"wordWrapOverride2","inherit",["off","on","inherit"])),wrappingIndent:Te(new i(126,"wrappingIndent",1,"same",["none","same","indent","deepIndent"],ve,{enumDescriptions:[r.localize(292,null),r.localize(293,null),r.localize(294,null),r.localize(295,null)],description:r.localize(296,null)})),wrappingStrategy:Te(new u(127,"wrappingStrategy","simple",["simple","advanced"],{enumDescriptions:[r.localize(297,null),r.localize(298,null)],description:r.localize(299,null)})),editorClassName:Te(new V),pixelRatio:Te(new Fe),tabFocusMode:Te(new le),layoutInfo:Te(new ne),wrappingInfo:Te(new pe)}}),define(Ce[124],Ie([16,17]),function(ie,e){return ie.create("vs/platform/configuration/common/configurationRegistry",e)}),define(Ce[125],Ie([16,17]),function(ie,e){return ie.create("vs/platform/extensionManagement/common/extensionManagement",e)}),define(Ce[126],Ie([16,17]),function(ie,e){return ie.create("vs/platform/extensions/common/extensionValidator",e)}),define(Ce[127],Ie([16,17]),function(ie,e){return ie.create("vs/platform/files/common/files",e)}),define(Ce[128],Ie([16,17]),function(ie,e){return ie.create("vs/platform/markers/common/markers",e)}),define(Ce[129],Ie([16,17]),function(ie,e){return ie.create("vs/platform/workspace/common/workspace",e)}),define(Ce[130],Ie([16,17]),function(ie,e){return ie.create("vs/workbench/api/common/extHostDiagnostics",e)}),define(Ce[131],Ie([16,17]),function(ie,e){return ie.create("vs/workbench/api/common/extHostExtensionService",e)}),define(Ce[132],Ie([16,17]),function(ie,e){return ie.create("vs/workbench/api/common/extHostProgress",e)}),define(Ce[133],Ie([16,17]),function(ie,e){return ie.create("vs/workbench/api/common/extHostStatusBar",e)}),define(Ce[134],Ie([16,17]),function(ie,e){return ie.create("vs/workbench/api/common/extHostTerminalService",e)}),define(Ce[135],Ie([16,17]),function(ie,e){return ie.create("vs/workbench/api/common/extHostTreeViews",e)}),define(Ce[136],Ie([16,17]),function(ie,e){return ie.create("vs/workbench/api/common/extHostWorkspace",e)}),define(Ce[137],Ie([16,17]),function(ie,e){return ie.create("vs/workbench/common/editor",e)}),define(Ce[138],Ie([16,17]),function(ie,e){return ie.create("vs/workbench/contrib/debug/common/abstractDebugAdapter",e)}),define(Ce[139],Ie([16,17]),function(ie,e){return ie.create("vs/workbench/contrib/debug/common/debug",e)}),define(Ce[140],Ie([16,17]),function(ie,e){return ie.create("vs/workbench/contrib/tasks/common/taskDefinitionRegistry",e)}),define(Ce[141],Ie([16,17]),function(ie,e){return ie.create("vs/workbench/contrib/tasks/common/tasks",e)}),define(Ce[142],Ie([16,17]),function(ie,e){return ie.create("vs/workbench/services/configurationResolver/common/variableResolver",e)}),define(Ce[143],Ie([16,17]),function(ie,e){return ie.create("vs/workbench/services/extensions/common/extensionsRegistry",e)}),define(Ce[144],Ie([16,17]),function(ie,e){return ie.create("vs/workbench/services/search/common/queryBuilder",e)}),define(Ce[145],Ie([1,0,22,29,126,240]),function(ie,e,r,y,S,M){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.isEngineValid=e.isValidExtensionVersion=e.validateExtensionManifest=e.isValidVersion=e.normalizeVersion=e.parseVersion=e.isValidVersionStr=void 0;const _=/^(\^|>=)?((\d+)|x)\.((\d+)|x)\.((\d+)|x)(\-.*)?$/,A=/^-(\d{4})(\d{2})(\d{2})$/;function b(h){return h=h.trim(),h==="*"||_.test(h)}e.isValidVersionStr=b;function P(h){if(!b(h))return null;if(h=h.trim(),h==="*")return{hasCaret:!1,hasGreaterEquals:!1,majorBase:0,majorMustEqual:!1,minorBase:0,minorMustEqual:!1,patchBase:0,patchMustEqual:!1,preRelease:null};const g=h.match(_);return g?{hasCaret:g[1]==="^",hasGreaterEquals:g[1]===">=",majorBase:g[2]==="x"?0:parseInt(g[2],10),majorMustEqual:g[2]!=="x",minorBase:g[4]==="x"?0:parseInt(g[4],10),minorMustEqual:g[4]!=="x",patchBase:g[6]==="x"?0:parseInt(g[6],10),patchMustEqual:g[6]!=="x",preRelease:g[8]||null}:null}e.parseVersion=P;function O(h){if(!h)return null;const g=h.majorBase,C=h.majorMustEqual,l=h.minorBase;let w=h.minorMustEqual;const t=h.patchBase;let u=h.patchMustEqual;h.hasCaret&&(g===0||(w=!1),u=!1);let i=0;if(h.preRelease){const n=A.exec(h.preRelease);if(n){const[,s,a,o]=n;i=Date.UTC(Number(s),Number(a)-1,Number(o))}}return{majorBase:g,majorMustEqual:C,minorBase:l,minorMustEqual:w,patchBase:t,patchMustEqual:u,isMinimum:h.hasGreaterEquals,notBefore:i}}e.normalizeVersion=O;function E(h,g,C){let l;typeof h=="string"?l=O(P(h)):l=h;let w;g instanceof Date?w=g.getTime():typeof g=="string"&&(w=new Date(g).getTime());let t;if(typeof C=="string"?t=O(P(C)):t=C,!l||!t)return!1;const u=l.majorBase,i=l.minorBase,n=l.patchBase;let s=t.majorBase,a=t.minorBase,o=t.patchBase;const v=t.notBefore;let p=t.majorMustEqual,T=t.minorMustEqual,N=t.patchMustEqual;return t.isMinimum?u>s?!0:u<s?!1:i>a?!0:i<a||w&&w<v?!1:n>=o:(u===1&&s===0&&(!p||!T||!N)&&(s=1,a=0,o=0,p=!0,T=!1,N=!1),u<s?!1:u>s?!p:i<a?!1:i>a?!T:n<o?!1:n>o?!N:!(w&&w<v))}e.isValidVersion=E;function m(h,g,C,l,w){const t=[];if(typeof l.publisher<"u"&&typeof l.publisher!="string")return t.push([y.default.Error,S.localize(0,null)]),t;if(typeof l.name!="string")return t.push([y.default.Error,S.localize(1,null,"name")]),t;if(typeof l.version!="string")return t.push([y.default.Error,S.localize(2,null,"version")]),t;if(!l.engines)return t.push([y.default.Error,S.localize(3,null,"engines")]),t;if(typeof l.engines.vscode!="string")return t.push([y.default.Error,S.localize(4,null,"engines.vscode")]),t;if(typeof l.extensionDependencies<"u"&&!d(l.extensionDependencies))return t.push([y.default.Error,S.localize(5,null,"extensionDependencies")]),t;if(typeof l.activationEvents<"u"){if(!d(l.activationEvents))return t.push([y.default.Error,S.localize(6,null,"activationEvents")]),t;if(typeof l.main>"u"&&typeof l.browser>"u")return t.push([y.default.Error,S.localize(7,null,"activationEvents","main")]),t}if(typeof l.extensionKind<"u"&&typeof l.main>"u"&&t.push([y.default.Warning,S.localize(8,null,"extensionKind")]),typeof l.main<"u"){if(typeof l.main!="string")return t.push([y.default.Error,S.localize(9,null,"main")]),t;{const n=(0,r.joinPath)(C,l.main);(0,r.isEqualOrParent)(n,C)||t.push([y.default.Warning,S.localize(10,null,n.path,C.path)])}if(typeof l.activationEvents>"u")return t.push([y.default.Error,S.localize(11,null,"activationEvents","main")]),t}if(typeof l.browser<"u"){if(typeof l.browser!="string")return t.push([y.default.Error,S.localize(12,null,"browser")]),t;{const n=(0,r.joinPath)(C,l.browser);(0,r.isEqualOrParent)(n,C)||t.push([y.default.Warning,S.localize(13,null,n.path,C.path)])}if(typeof l.activationEvents>"u")return t.push([y.default.Error,S.localize(14,null,"activationEvents","browser")]),t}if(!M.valid(l.version))return t.push([y.default.Error,S.localize(15,null)]),t;const u=[];if(!k(h,g,l,w,u))for(const n of u)t.push([y.default.Error,n]);return t}e.validateExtensionManifest=m;function k(h,g,C,l,w){return l||typeof C.main>"u"&&typeof C.browser>"u"?!0:c(h,g,C.engines.vscode,w)}e.isValidExtensionVersion=k;function f(h,g,C){return h==="*"||c(g,C,h)}e.isEngineValid=f;function c(h,g,C,l=[]){const w=O(P(C));if(!w)return l.push(S.localize(16,null,C)),!1;if(w.majorBase===0){if(!w.majorMustEqual||!w.minorMustEqual)return l.push(S.localize(17,null,C)),!1}else if(!w.majorMustEqual)return l.push(S.localize(18,null,C)),!1;return E(h,g,w)?!0:(l.push(S.localize(19,null,h,C)),!1)}function d(h){if(!Array.isArray(h))return!1;for(let g=0,C=h.length;g<C;g++)if(typeof h[g]!="string")return!1;return!0}}),define(Ce[80],Ie([1,0]),function(ie,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.SyncDescriptor=void 0;class r{constructor(S,M=[],_=!1){this.ctor=S,this.staticArguments=M,this.supportsDelayedInstantiation=_}}e.SyncDescriptor=r}),define(Ce[56],Ie([1,0,80]),function(ie,e,r){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.getSingletonServiceDescriptors=e.registerSingleton=e.InstantiationType=void 0;const y=[];var S;(function(A){A[A.Eager=0]="Eager",A[A.Delayed=1]="Delayed"})(S=e.InstantiationType||(e.InstantiationType={}));function M(A,b,P){b instanceof r.SyncDescriptor||(b=new r.SyncDescriptor(b,[],Boolean(P))),y.push([A,b])}e.registerSingleton=M;function _(){return y}e.getSingletonServiceDescriptors=_}),define(Ce[146],Ie([1,0]),function(ie,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.Graph=e.Node=void 0;class r{constructor(M,_){this.key=M,this.data=_,this.incoming=new Map,this.outgoing=new Map}}e.Node=r;class y{constructor(M){this._hashFn=M,this._nodes=new Map}roots(){const M=[];for(const _ of this._nodes.values())_.outgoing.size===0&&M.push(_);return M}insertEdge(M,_){const A=this.lookupOrInsertNode(M),b=this.lookupOrInsertNode(_);A.outgoing.set(b.key,b),b.incoming.set(A.key,A)}removeNode(M){const _=this._hashFn(M);this._nodes.delete(_);for(const A of this._nodes.values())A.outgoing.delete(_),A.incoming.delete(_)}lookupOrInsertNode(M){const _=this._hashFn(M);let A=this._nodes.get(_);return A||(A=new r(_,M),this._nodes.set(_,A)),A}lookup(M){return this._nodes.get(this._hashFn(M))}isEmpty(){return this._nodes.size===0}toString(){const M=[];for(const[_,A]of this._nodes)M.push(`${_}
	(-> incoming)[${[...A.incoming.keys()].join(", ")}]
	(outgoing ->)[${[...A.outgoing.keys()].join(",")}]
`);return M.join(`
`)}findCycleSlow(){for(const[M,_]of this._nodes){const A=new Set([M]),b=this._findCycle(_,A);if(b)return b}}_findCycle(M,_){for(const[A,b]of M.outgoing){if(_.has(A))return[..._,A].join(" -> ");_.add(A);const P=this._findCycle(b,_);if(P)return P;_.delete(A)}}}e.Graph=y}),define(Ce[3],Ie([1,0]),function(ie,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.refineServiceDecorator=e.createDecorator=e.IInstantiationService=e._util=void 0;var r;(function(_){_.serviceIds=new Map,_.DI_TARGET="$di$target",_.DI_DEPENDENCIES="$di$dependencies";function A(b){return b[_.DI_DEPENDENCIES]||[]}_.getServiceDependencies=A})(r=e._util||(e._util={})),e.IInstantiationService=S("instantiationService");function y(_,A,b){A[r.DI_TARGET]===A?A[r.DI_DEPENDENCIES].push({id:_,index:b}):(A[r.DI_DEPENDENCIES]=[{id:_,index:b}],A[r.DI_TARGET]=A)}function S(_){if(r.serviceIds.has(_))return r.serviceIds.get(_);const A=function(b,P,O){if(arguments.length!==3)throw new Error("@IServiceName-decorator can only be used to decorate a parameter");y(A,b,O)};return A.toString=()=>_,r.serviceIds.set(_,A),A}e.createDecorator=S;function M(_){return _}e.refineServiceDecorator=M}),define(Ce[57],Ie([1,0,10,2,3]),function(ie,e,r,y,S){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.getLanguageTagSettingPlainKey=e.getMigratedSettingValue=e.merge=e.getConfigurationValue=e.removeFromValueTree=e.addToValueTree=e.toValuesTree=e.ConfigurationTargetToString=e.ConfigurationTarget=e.isConfigurationUpdateOverrides=e.isConfigurationOverrides=e.IConfigurationService=void 0,e.IConfigurationService=(0,S.createDecorator)("configurationService");function M(h){return h&&typeof h=="object"&&(!h.overrideIdentifier||typeof h.overrideIdentifier=="string")&&(!h.resource||h.resource instanceof y.URI)}e.isConfigurationOverrides=M;function _(h){return h&&typeof h=="object"&&(!h.overrideIdentifiers||Array.isArray(h.overrideIdentifiers))&&!h.overrideIdentifier&&(!h.resource||h.resource instanceof y.URI)}e.isConfigurationUpdateOverrides=_;var A;(function(h){h[h.APPLICATION=1]="APPLICATION",h[h.USER=2]="USER",h[h.USER_LOCAL=3]="USER_LOCAL",h[h.USER_REMOTE=4]="USER_REMOTE",h[h.WORKSPACE=5]="WORKSPACE",h[h.WORKSPACE_FOLDER=6]="WORKSPACE_FOLDER",h[h.DEFAULT=7]="DEFAULT",h[h.MEMORY=8]="MEMORY"})(A=e.ConfigurationTarget||(e.ConfigurationTarget={}));function b(h){switch(h){case 1:return"APPLICATION";case 2:return"USER";case 3:return"USER_LOCAL";case 4:return"USER_REMOTE";case 5:return"WORKSPACE";case 6:return"WORKSPACE_FOLDER";case 7:return"DEFAULT";case 8:return"MEMORY"}}e.ConfigurationTargetToString=b;function P(h,g){const C=Object.create(null);for(const l in h)O(C,l,h[l],g);return C}e.toValuesTree=P;function O(h,g,C,l){const w=g.split("."),t=w.pop();let u=h;for(let i=0;i<w.length;i++){const n=w[i];let s=u[n];switch(typeof s){case"undefined":s=u[n]=Object.create(null);break;case"object":break;default:l(`Ignoring ${g} as ${w.slice(0,i+1).join(".")} is ${JSON.stringify(s)}`);return}u=s}if(typeof u=="object"&&u!==null)try{u[t]=C}catch{l(`Ignoring ${g} as ${w.join(".")} is ${JSON.stringify(u)}`)}else l(`Ignoring ${g} as ${w.join(".")} is ${JSON.stringify(u)}`)}e.addToValueTree=O;function E(h,g){const C=g.split(".");m(h,C)}e.removeFromValueTree=E;function m(h,g){const C=g.shift();if(g.length===0){delete h[C];return}if(Object.keys(h).indexOf(C)!==-1){const l=h[C];typeof l=="object"&&!Array.isArray(l)&&(m(l,g),Object.keys(l).length===0&&delete h[C])}}function k(h,g,C){function l(u,i){let n=u;for(const s of i){if(typeof n!="object"||n===null)return;n=n[s]}return n}const w=g.split("."),t=l(h,w);return typeof t>"u"?C:t}e.getConfigurationValue=k;function f(h,g,C){Object.keys(g).forEach(l=>{l!=="__proto__"&&(l in h?r.isObject(h[l])&&r.isObject(g[l])?f(h[l],g[l],C):C&&(h[l]=g[l]):h[l]=g[l])})}e.merge=f;function c(h,g,C){const l=h.inspect(g),w=h.inspect(C);return typeof l.userValue<"u"||typeof l.workspaceValue<"u"||typeof l.workspaceFolderValue<"u"?l.value:typeof w.userValue<"u"||typeof w.workspaceValue<"u"||typeof w.workspaceFolderValue<"u"?w.value:l.defaultValue}e.getMigratedSettingValue=c;function d(h){return h.replace(/[\[\]]/g,"")}e.getLanguageTagSettingPlainKey=d}),define(Ce[39],Ie([1,0,21,9,3]),function(ie,e,r,y,S){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.implies=e.SET_CONTEXT_COMMAND_ID=e.IContextKeyService=e.RawContextKey=e.ContextKeyNotRegexExpr=e.ContextKeyRegexExpr=e.ContextKeySmallerEqualsExpr=e.ContextKeySmallerExpr=e.ContextKeyGreaterEqualsExpr=e.ContextKeyGreaterExpr=e.ContextKeyNotExpr=e.ContextKeyNotEqualsExpr=e.ContextKeyNotInExpr=e.ContextKeyInExpr=e.ContextKeyEqualsExpr=e.ContextKeyDefinedExpr=e.ContextKeyTrueExpr=e.ContextKeyFalseExpr=e.expressionsAreEqualWithConstantSubstitution=e.ContextKeyExpr=e.ContextKeyExprType=void 0;const M=new Map;M.set("false",!1),M.set("true",!0),M.set("isMac",r.isMacintosh),M.set("isLinux",r.isLinux),M.set("isWindows",r.isWindows),M.set("isWeb",r.isWeb),M.set("isMacNative",r.isMacintosh&&!r.isWeb),M.set("isEdge",r.isEdge),M.set("isFirefox",r.isFirefox),M.set("isChrome",r.isChrome),M.set("isSafari",r.isSafari);const _=Object.prototype.hasOwnProperty;var A;(function(B){B[B.False=0]="False",B[B.True=1]="True",B[B.Defined=2]="Defined",B[B.Not=3]="Not",B[B.Equals=4]="Equals",B[B.NotEquals=5]="NotEquals",B[B.And=6]="And",B[B.Regex=7]="Regex",B[B.NotRegex=8]="NotRegex",B[B.Or=9]="Or",B[B.In=10]="In",B[B.NotIn=11]="NotIn",B[B.Greater=12]="Greater",B[B.GreaterEquals=13]="GreaterEquals",B[B.Smaller=14]="Smaller",B[B.SmallerEquals=15]="SmallerEquals"})(A=e.ContextKeyExprType||(e.ContextKeyExprType={}));class b{static false(){return E.INSTANCE}static true(){return m.INSTANCE}static has(D){return k.create(D)}static equals(D,z){return f.create(D,z)}static notEquals(D,z){return h.create(D,z)}static regex(D,z){return i.create(D,z)}static in(D,z){return c.create(D,z)}static notIn(D,z){return d.create(D,z)}static not(D){return g.create(D)}static and(...D){return a.create(D,null)}static or(...D){return o.create(D,null,!0)}static greater(D,z){return l.create(D,z)}static greaterEquals(D,z){return w.create(D,z)}static smaller(D,z){return t.create(D,z)}static smallerEquals(D,z){return u.create(D,z)}static deserialize(D,z=!1){if(!!D)return this._deserializeOrExpression(D,z)}static _deserializeOrExpression(D,z){const L=D.split("||");return o.create(L.map(R=>this._deserializeAndExpression(R,z)),null,!0)}static _deserializeAndExpression(D,z){const L=D.split("&&");return a.create(L.map(R=>this._deserializeOne(R,z)),null)}static _deserializeOne(D,z){if(D=D.trim(),D.indexOf("!=")>=0){const L=D.split("!=");return h.create(L[0].trim(),this._deserializeValue(L[1],z))}if(D.indexOf("==")>=0){const L=D.split("==");return f.create(L[0].trim(),this._deserializeValue(L[1],z))}if(D.indexOf("=~")>=0){const L=D.split("=~");return i.create(L[0].trim(),this._deserializeRegexValue(L[1],z))}if(D.indexOf(" not in ")>=0){const L=D.split(" not in ");return d.create(L[0].trim(),L[1].trim())}if(D.indexOf(" in ")>=0){const L=D.split(" in ");return c.create(L[0].trim(),L[1].trim())}if(/^[^<=>]+>=[^<=>]+$/.test(D)){const L=D.split(">=");return w.create(L[0].trim(),L[1].trim())}if(/^[^<=>]+>[^<=>]+$/.test(D)){const L=D.split(">");return l.create(L[0].trim(),L[1].trim())}if(/^[^<=>]+<=[^<=>]+$/.test(D)){const L=D.split("<=");return u.create(L[0].trim(),L[1].trim())}if(/^[^<=>]+<[^<=>]+$/.test(D)){const L=D.split("<");return t.create(L[0].trim(),L[1].trim())}return/^\!\s*/.test(D)?g.create(D.substr(1).trim()):k.create(D)}static _deserializeValue(D,z){if(D=D.trim(),D==="true")return!0;if(D==="false")return!1;const L=/^'([^']*)'$/.exec(D);return L?L[1].trim():D}static _deserializeRegexValue(D,z){if((0,y.isFalsyOrWhitespace)(D)){if(z)throw new Error("missing regexp-value for =~-expression");return console.warn("missing regexp-value for =~-expression"),null}const L=D.indexOf("/"),R=D.lastIndexOf("/");if(L===R||L<0){if(z)throw new Error(`bad regexp-value '${D}', missing /-enclosure`);return console.warn(`bad regexp-value '${D}', missing /-enclosure`),null}const K=D.slice(L+1,R),W=D[R+1]==="i"?"i":"";try{return new RegExp(K,W)}catch($){if(z)throw new Error(`bad regexp-value '${D}', parse error: ${$}`);return console.warn(`bad regexp-value '${D}', parse error: ${$}`),null}}}e.ContextKeyExpr=b;function P(B,D){const z=B?B.substituteConstants():void 0,L=D?D.substituteConstants():void 0;return!z&&!L?!0:!z||!L?!1:z.equals(L)}e.expressionsAreEqualWithConstantSubstitution=P;function O(B,D){return B.cmp(D)}class E{constructor(){this.type=0}cmp(D){return this.type-D.type}equals(D){return D.type===this.type}substituteConstants(){return this}evaluate(D){return!1}serialize(){return"false"}keys(){return[]}map(D){return this}negate(){return m.INSTANCE}}e.ContextKeyFalseExpr=E,E.INSTANCE=new E;class m{constructor(){this.type=1}cmp(D){return this.type-D.type}equals(D){return D.type===this.type}substituteConstants(){return this}evaluate(D){return!0}serialize(){return"true"}keys(){return[]}map(D){return this}negate(){return E.INSTANCE}}e.ContextKeyTrueExpr=m,m.INSTANCE=new m;class k{static create(D,z=null){const L=M.get(D);return typeof L=="boolean"?L?m.INSTANCE:E.INSTANCE:new k(D,z)}constructor(D,z){this.key=D,this.negated=z,this.type=2}cmp(D){return D.type!==this.type?this.type-D.type:p(this.key,D.key)}equals(D){return D.type===this.type?this.key===D.key:!1}substituteConstants(){const D=M.get(this.key);return typeof D=="boolean"?D?m.INSTANCE:E.INSTANCE:this}evaluate(D){return!!D.getValue(this.key)}serialize(){return this.key}keys(){return[this.key]}map(D){return D.mapDefined(this.key)}negate(){return this.negated||(this.negated=g.create(this.key,this)),this.negated}}e.ContextKeyDefinedExpr=k;class f{static create(D,z,L=null){if(typeof z=="boolean")return z?k.create(D,L):g.create(D,L);const R=M.get(D);return typeof R=="boolean"?z===(R?"true":"false")?m.INSTANCE:E.INSTANCE:new f(D,z,L)}constructor(D,z,L){this.key=D,this.value=z,this.negated=L,this.type=4}cmp(D){return D.type!==this.type?this.type-D.type:T(this.key,this.value,D.key,D.value)}equals(D){return D.type===this.type?this.key===D.key&&this.value===D.value:!1}substituteConstants(){const D=M.get(this.key);if(typeof D=="boolean"){const z=D?"true":"false";return this.value===z?m.INSTANCE:E.INSTANCE}return this}evaluate(D){return D.getValue(this.key)==this.value}serialize(){return`${this.key} == '${this.value}'`}keys(){return[this.key]}map(D){return D.mapEquals(this.key,this.value)}negate(){return this.negated||(this.negated=h.create(this.key,this.value,this)),this.negated}}e.ContextKeyEqualsExpr=f;class c{static create(D,z){return new c(D,z)}constructor(D,z){this.key=D,this.valueKey=z,this.type=10,this.negated=null}cmp(D){return D.type!==this.type?this.type-D.type:T(this.key,this.valueKey,D.key,D.valueKey)}equals(D){return D.type===this.type?this.key===D.key&&this.valueKey===D.valueKey:!1}substituteConstants(){return this}evaluate(D){const z=D.getValue(this.valueKey),L=D.getValue(this.key);return Array.isArray(z)?z.includes(L):typeof L=="string"&&typeof z=="object"&&z!==null?_.call(z,L):!1}serialize(){return`${this.key} in '${this.valueKey}'`}keys(){return[this.key,this.valueKey]}map(D){return D.mapIn(this.key,this.valueKey)}negate(){return this.negated||(this.negated=d.create(this.key,this.valueKey)),this.negated}}e.ContextKeyInExpr=c;class d{static create(D,z){return new d(D,z)}constructor(D,z){this.key=D,this.valueKey=z,this.type=11,this._negated=c.create(D,z)}cmp(D){return D.type!==this.type?this.type-D.type:this._negated.cmp(D._negated)}equals(D){return D.type===this.type?this._negated.equals(D._negated):!1}substituteConstants(){return this}evaluate(D){return!this._negated.evaluate(D)}serialize(){return`${this.key} not in '${this.valueKey}'`}keys(){return this._negated.keys()}map(D){return D.mapNotIn(this.key,this.valueKey)}negate(){return this._negated}}e.ContextKeyNotInExpr=d;class h{static create(D,z,L=null){if(typeof z=="boolean")return z?g.create(D,L):k.create(D,L);const R=M.get(D);return typeof R=="boolean"?z===(R?"true":"false")?E.INSTANCE:m.INSTANCE:new h(D,z,L)}constructor(D,z,L){this.key=D,this.value=z,this.negated=L,this.type=5}cmp(D){return D.type!==this.type?this.type-D.type:T(this.key,this.value,D.key,D.value)}equals(D){return D.type===this.type?this.key===D.key&&this.value===D.value:!1}substituteConstants(){const D=M.get(this.key);if(typeof D=="boolean"){const z=D?"true":"false";return this.value===z?E.INSTANCE:m.INSTANCE}return this}evaluate(D){return D.getValue(this.key)!=this.value}serialize(){return`${this.key} != '${this.value}'`}keys(){return[this.key]}map(D){return D.mapNotEquals(this.key,this.value)}negate(){return this.negated||(this.negated=f.create(this.key,this.value,this)),this.negated}}e.ContextKeyNotEqualsExpr=h;class g{static create(D,z=null){const L=M.get(D);return typeof L=="boolean"?L?E.INSTANCE:m.INSTANCE:new g(D,z)}constructor(D,z){this.key=D,this.negated=z,this.type=3}cmp(D){return D.type!==this.type?this.type-D.type:p(this.key,D.key)}equals(D){return D.type===this.type?this.key===D.key:!1}substituteConstants(){const D=M.get(this.key);return typeof D=="boolean"?D?E.INSTANCE:m.INSTANCE:this}evaluate(D){return!D.getValue(this.key)}serialize(){return`!${this.key}`}keys(){return[this.key]}map(D){return D.mapNot(this.key)}negate(){return this.negated||(this.negated=k.create(this.key,this)),this.negated}}e.ContextKeyNotExpr=g;function C(B,D){if(typeof B=="string"){const z=parseFloat(B);isNaN(z)||(B=z)}return typeof B=="string"||typeof B=="number"?D(B):E.INSTANCE}class l{static create(D,z,L=null){return C(z,R=>new l(D,R,L))}constructor(D,z,L){this.key=D,this.value=z,this.negated=L,this.type=12}cmp(D){return D.type!==this.type?this.type-D.type:T(this.key,this.value,D.key,D.value)}equals(D){return D.type===this.type?this.key===D.key&&this.value===D.value:!1}substituteConstants(){return this}evaluate(D){return typeof this.value=="string"?!1:parseFloat(D.getValue(this.key))>this.value}serialize(){return`${this.key} > ${this.value}`}keys(){return[this.key]}map(D){return D.mapGreater(this.key,this.value)}negate(){return this.negated||(this.negated=u.create(this.key,this.value,this)),this.negated}}e.ContextKeyGreaterExpr=l;class w{static create(D,z,L=null){return C(z,R=>new w(D,R,L))}constructor(D,z,L){this.key=D,this.value=z,this.negated=L,this.type=13}cmp(D){return D.type!==this.type?this.type-D.type:T(this.key,this.value,D.key,D.value)}equals(D){return D.type===this.type?this.key===D.key&&this.value===D.value:!1}substituteConstants(){return this}evaluate(D){return typeof this.value=="string"?!1:parseFloat(D.getValue(this.key))>=this.value}serialize(){return`${this.key} >= ${this.value}`}keys(){return[this.key]}map(D){return D.mapGreaterEquals(this.key,this.value)}negate(){return this.negated||(this.negated=t.create(this.key,this.value,this)),this.negated}}e.ContextKeyGreaterEqualsExpr=w;class t{static create(D,z,L=null){return C(z,R=>new t(D,R,L))}constructor(D,z,L){this.key=D,this.value=z,this.negated=L,this.type=14}cmp(D){return D.type!==this.type?this.type-D.type:T(this.key,this.value,D.key,D.value)}equals(D){return D.type===this.type?this.key===D.key&&this.value===D.value:!1}substituteConstants(){return this}evaluate(D){return typeof this.value=="string"?!1:parseFloat(D.getValue(this.key))<this.value}serialize(){return`${this.key} < ${this.value}`}keys(){return[this.key]}map(D){return D.mapSmaller(this.key,this.value)}negate(){return this.negated||(this.negated=w.create(this.key,this.value,this)),this.negated}}e.ContextKeySmallerExpr=t;class u{static create(D,z,L=null){return C(z,R=>new u(D,R,L))}constructor(D,z,L){this.key=D,this.value=z,this.negated=L,this.type=15}cmp(D){return D.type!==this.type?this.type-D.type:T(this.key,this.value,D.key,D.value)}equals(D){return D.type===this.type?this.key===D.key&&this.value===D.value:!1}substituteConstants(){return this}evaluate(D){return typeof this.value=="string"?!1:parseFloat(D.getValue(this.key))<=this.value}serialize(){return`${this.key} <= ${this.value}`}keys(){return[this.key]}map(D){return D.mapSmallerEquals(this.key,this.value)}negate(){return this.negated||(this.negated=l.create(this.key,this.value,this)),this.negated}}e.ContextKeySmallerEqualsExpr=u;class i{static create(D,z){return new i(D,z)}constructor(D,z){this.key=D,this.regexp=z,this.type=7,this.negated=null}cmp(D){if(D.type!==this.type)return this.type-D.type;if(this.key<D.key)return-1;if(this.key>D.key)return 1;const z=this.regexp?this.regexp.source:"",L=D.regexp?D.regexp.source:"";return z<L?-1:z>L?1:0}equals(D){if(D.type===this.type){const z=this.regexp?this.regexp.source:"",L=D.regexp?D.regexp.source:"";return this.key===D.key&&z===L}return!1}substituteConstants(){return this}evaluate(D){const z=D.getValue(this.key);return this.regexp?this.regexp.test(z):!1}serialize(){const D=this.regexp?`/${this.regexp.source}/${this.regexp.ignoreCase?"i":""}`:"/invalid/";return`${this.key} =~ ${D}`}keys(){return[this.key]}map(D){return D.mapRegex(this.key,this.regexp)}negate(){return this.negated||(this.negated=n.create(this)),this.negated}}e.ContextKeyRegexExpr=i;class n{static create(D){return new n(D)}constructor(D){this._actual=D,this.type=8}cmp(D){return D.type!==this.type?this.type-D.type:this._actual.cmp(D._actual)}equals(D){return D.type===this.type?this._actual.equals(D._actual):!1}substituteConstants(){return this}evaluate(D){return!this._actual.evaluate(D)}serialize(){throw new Error("Method not implemented.")}keys(){return this._actual.keys()}map(D){return new n(this._actual.map(D))}negate(){return this._actual}}e.ContextKeyNotRegexExpr=n;function s(B){let D=null;for(let z=0,L=B.length;z<L;z++){const R=B[z].substituteConstants();if(B[z]!==R&&D===null){D=[];for(let K=0;K<z;K++)D[K]=B[K]}D!==null&&(D[z]=R)}return D===null?B:D}class a{static create(D,z){return a._normalizeArr(D,z)}constructor(D,z){this.expr=D,this.negated=z,this.type=6}cmp(D){if(D.type!==this.type)return this.type-D.type;if(this.expr.length<D.expr.length)return-1;if(this.expr.length>D.expr.length)return 1;for(let z=0,L=this.expr.length;z<L;z++){const R=O(this.expr[z],D.expr[z]);if(R!==0)return R}return 0}equals(D){if(D.type===this.type){if(this.expr.length!==D.expr.length)return!1;for(let z=0,L=this.expr.length;z<L;z++)if(!this.expr[z].equals(D.expr[z]))return!1;return!0}return!1}substituteConstants(){const D=s(this.expr);return D===this.expr?this:a.create(D,this.negated)}evaluate(D){for(let z=0,L=this.expr.length;z<L;z++)if(!this.expr[z].evaluate(D))return!1;return!0}static _normalizeArr(D,z){const L=[];let R=!1;for(const K of D)if(!!K){if(K.type===1){R=!0;continue}if(K.type===0)return E.INSTANCE;if(K.type===6){L.push(...K.expr);continue}L.push(K)}if(L.length===0&&R)return m.INSTANCE;if(L.length!==0){if(L.length===1)return L[0];L.sort(O);for(let K=1;K<L.length;K++)L[K-1].equals(L[K])&&(L.splice(K,1),K--);if(L.length===1)return L[0];for(;L.length>1;){const K=L[L.length-1];if(K.type!==9)break;L.pop();const W=L.pop(),$=L.length===0,G=o.create(K.expr.map(ne=>a.create([ne,W],null)),null,$);G&&(L.push(G),L.sort(O))}return L.length===1?L[0]:new a(L,z)}}serialize(){return this.expr.map(D=>D.serialize()).join(" && ")}keys(){const D=[];for(const z of this.expr)D.push(...z.keys());return D}map(D){return new a(this.expr.map(z=>z.map(D)),null)}negate(){if(!this.negated){const D=[];for(const z of this.expr)D.push(z.negate());this.negated=o.create(D,this,!0)}return this.negated}}class o{static create(D,z,L){return o._normalizeArr(D,z,L)}constructor(D,z){this.expr=D,this.negated=z,this.type=9}cmp(D){if(D.type!==this.type)return this.type-D.type;if(this.expr.length<D.expr.length)return-1;if(this.expr.length>D.expr.length)return 1;for(let z=0,L=this.expr.length;z<L;z++){const R=O(this.expr[z],D.expr[z]);if(R!==0)return R}return 0}equals(D){if(D.type===this.type){if(this.expr.length!==D.expr.length)return!1;for(let z=0,L=this.expr.length;z<L;z++)if(!this.expr[z].equals(D.expr[z]))return!1;return!0}return!1}substituteConstants(){const D=s(this.expr);return D===this.expr?this:o.create(D,this.negated,!1)}evaluate(D){for(let z=0,L=this.expr.length;z<L;z++)if(this.expr[z].evaluate(D))return!0;return!1}static _normalizeArr(D,z,L){let R=[],K=!1;if(D){for(let W=0,$=D.length;W<$;W++){const G=D[W];if(!!G){if(G.type===0){K=!0;continue}if(G.type===1)return m.INSTANCE;if(G.type===9){R=R.concat(G.expr);continue}R.push(G)}}if(R.length===0&&K)return E.INSTANCE;R.sort(O)}if(R.length!==0){if(R.length===1)return R[0];for(let W=1;W<R.length;W++)R[W-1].equals(R[W])&&(R.splice(W,1),W--);if(R.length===1)return R[0];if(L){for(let W=0;W<R.length;W++)for(let $=W+1;$<R.length;$++)N(R[W],R[$])&&(R.splice($,1),$--);if(R.length===1)return R[0]}return new o(R,z)}}serialize(){return this.expr.map(D=>D.serialize()).join(" || ")}keys(){const D=[];for(const z of this.expr)D.push(...z.keys());return D}map(D){return new o(this.expr.map(z=>z.map(D)),null)}negate(){if(!this.negated){const D=[];for(const z of this.expr)D.push(z.negate());for(;D.length>1;){const z=D.shift(),L=D.shift(),R=[];for(const W of V(z))for(const $ of V(L))R.push(a.create([W,$],null));const K=D.length===0;D.unshift(o.create(R,null,K))}this.negated=D[0]}return this.negated}}class v extends k{static all(){return v._info.values()}constructor(D,z,L){super(D,null),this._defaultValue=z,typeof L=="object"?v._info.push({...L,key:D}):L!==!0&&v._info.push({key:D,description:L,type:z!=null?typeof z:void 0})}bindTo(D){return D.createKey(this.key,this._defaultValue)}getValue(D){return D.getContextKeyValue(this.key)}toNegated(){return this.negate()}isEqualTo(D){return f.create(this.key,D)}notEqualsTo(D){return h.create(this.key,D)}}e.RawContextKey=v,v._info=[],e.IContextKeyService=(0,S.createDecorator)("contextKeyService"),e.SET_CONTEXT_COMMAND_ID="setContext";function p(B,D){return B<D?-1:B>D?1:0}function T(B,D,z,L){return B<z?-1:B>z?1:D<L?-1:D>L?1:0}function N(B,D){if(D.type===6&&B.type!==9&&B.type!==6){for(const R of D.expr)if(B.equals(R))return!0}const z=B.negate(),L=V(z).concat(V(D));L.sort(O);for(let R=0;R<L.length;R++){const W=L[R].negate();for(let $=R+1;$<L.length;$++){const G=L[$];if(W.equals(G))return!0}}return!1}e.implies=N;function V(B){return B.type===9?B.expr:[B]}}),define(Ce[147],Ie([1,0,3]),function(ie,e,r){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.INativeEnvironmentService=e.IEnvironmentService=void 0,e.IEnvironmentService=(0,r.createDecorator)("environmentService"),e.INativeEnvironmentService=(0,r.refineServiceDecorator)(e.IEnvironmentService)}),define(Ce[81],Ie([1,0,125,3]),function(ie,e,r,y){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.PreferencesLocalizedLabel=e.PreferencesLabel=e.ExtensionsChannelId=e.ExtensionsLocalizedLabel=e.ExtensionsLabel=e.IExtensionTipsService=e.IGlobalExtensionEnablementService=e.ENABLED_EXTENSIONS_STORAGE_PATH=e.DISABLED_EXTENSIONS_STORAGE_PATH=e.IExtensionManagementService=e.ExtensionManagementError=e.ExtensionManagementErrorCode=e.IExtensionGalleryService=e.InstallOperation=e.StatisticType=e.SortOrder=e.SortBy=e.isIExtensionIdentifier=e.getFallbackTargetPlarforms=e.isTargetPlatformCompatible=e.isNotWebExtensionInWebTargetPlatform=e.getTargetPlatform=e.toTargetPlatform=e.TargetPlatformToString=e.WEB_EXTENSION_TAG=e.EXTENSION_IDENTIFIER_REGEX=e.EXTENSION_IDENTIFIER_PATTERN=void 0,e.EXTENSION_IDENTIFIER_PATTERN="^([a-z0-9A-Z][a-z0-9-A-Z]*)\\.([a-z0-9A-Z][a-z0-9-A-Z]*)$",e.EXTENSION_IDENTIFIER_REGEX=new RegExp(e.EXTENSION_IDENTIFIER_PATTERN),e.WEB_EXTENSION_TAG="__web_extension";function S(h){switch(h){case"win32-x64":return"Windows 64 bit";case"win32-ia32":return"Windows 32 bit";case"win32-arm64":return"Windows ARM";case"linux-x64":return"Linux 64 bit";case"linux-arm64":return"Linux ARM 64";case"linux-armhf":return"Linux ARM";case"alpine-x64":return"Alpine Linux 64 bit";case"alpine-arm64":return"Alpine ARM 64";case"darwin-x64":return"Mac";case"darwin-arm64":return"Mac Silicon";case"web":return"Web";case"universal":return"universal";case"unknown":return"unknown";case"undefined":return"undefined"}}e.TargetPlatformToString=S;function M(h){switch(h){case"win32-x64":return"win32-x64";case"win32-ia32":return"win32-ia32";case"win32-arm64":return"win32-arm64";case"linux-x64":return"linux-x64";case"linux-arm64":return"linux-arm64";case"linux-armhf":return"linux-armhf";case"alpine-x64":return"alpine-x64";case"alpine-arm64":return"alpine-arm64";case"darwin-x64":return"darwin-x64";case"darwin-arm64":return"darwin-arm64";case"web":return"web";case"universal":return"universal";default:return"unknown"}}e.toTargetPlatform=M;function _(h,g){switch(h){case 3:return g==="x64"?"win32-x64":g==="ia32"?"win32-ia32":g==="arm64"?"win32-arm64":"unknown";case 2:return g==="x64"?"linux-x64":g==="arm64"?"linux-arm64":g==="arm"?"linux-armhf":"unknown";case"alpine":return g==="x64"?"alpine-x64":g==="arm64"?"alpine-arm64":"unknown";case 1:return g==="x64"?"darwin-x64":g==="arm64"?"darwin-arm64":"unknown";case 0:return"web"}}e.getTargetPlatform=_;function A(h,g){return g==="web"&&!h.includes("web")}e.isNotWebExtensionInWebTargetPlatform=A;function b(h,g,C){return A(g,C)?!1:h==="undefined"||h==="universal"?!0:h==="unknown"?!1:h===C?!0:P(C).includes(h)}e.isTargetPlatformCompatible=b;function P(h){switch(h){case"win32-x64":return["win32-ia32"];case"win32-arm64":return["win32-ia32"]}return[]}e.getFallbackTargetPlarforms=P;function O(h){return h&&typeof h=="object"&&typeof h.id=="string"&&(!h.uuid||typeof h.uuid=="string")}e.isIExtensionIdentifier=O;var E;(function(h){h[h.NoneOrRelevance=0]="NoneOrRelevance",h[h.LastUpdatedDate=1]="LastUpdatedDate",h[h.Title=2]="Title",h[h.PublisherName=3]="PublisherName",h[h.InstallCount=4]="InstallCount",h[h.PublishedDate=10]="PublishedDate",h[h.AverageRating=6]="AverageRating",h[h.WeightedRating=12]="WeightedRating"})(E=e.SortBy||(e.SortBy={}));var m;(function(h){h[h.Default=0]="Default",h[h.Ascending=1]="Ascending",h[h.Descending=2]="Descending"})(m=e.SortOrder||(e.SortOrder={}));var k;(function(h){h.Install="install",h.Uninstall="uninstall"})(k=e.StatisticType||(e.StatisticType={}));var f;(function(h){h[h.None=1]="None",h[h.Install=2]="Install",h[h.Update=3]="Update",h[h.Migrate=4]="Migrate"})(f=e.InstallOperation||(e.InstallOperation={})),e.IExtensionGalleryService=(0,y.createDecorator)("extensionGalleryService");var c;(function(h){h.Unsupported="Unsupported",h.Deprecated="Deprecated",h.Malicious="Malicious",h.Incompatible="Incompatible",h.IncompatiblePreRelease="IncompatiblePreRelease",h.IncompatibleTargetPlatform="IncompatibleTargetPlatform",h.ReleaseVersionNotFound="ReleaseVersionNotFound",h.Invalid="Invalid",h.Download="Download",h.Extract="Extract",h.Delete="Delete",h.Rename="Rename",h.CorruptZip="CorruptZip",h.IncompleteZip="IncompleteZip",h.Internal="Internal"})(c=e.ExtensionManagementErrorCode||(e.ExtensionManagementErrorCode={}));class d extends Error{constructor(g,C){super(g),this.code=C,this.name=C}}e.ExtensionManagementError=d,e.IExtensionManagementService=(0,y.createDecorator)("extensionManagementService"),e.DISABLED_EXTENSIONS_STORAGE_PATH="extensionsIdentifiers/disabled",e.ENABLED_EXTENSIONS_STORAGE_PATH="extensionsIdentifiers/enabled",e.IGlobalExtensionEnablementService=(0,y.createDecorator)("IGlobalExtensionEnablementService"),e.IExtensionTipsService=(0,y.createDecorator)("IExtensionTipsService"),e.ExtensionsLabel=(0,r.localize)(0,null),e.ExtensionsLocalizedLabel={value:e.ExtensionsLabel,original:"Extensions"},e.ExtensionsChannelId="extensions",e.PreferencesLabel=(0,r.localize)(1,null),e.PreferencesLocalizedLabel={value:e.PreferencesLabel,original:"Preferences"}}),define(Ce[35],Ie([1,0,24,19,9,10,2,127,3]),function(ie,e,r,y,S,M,_,A,b){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.getPlatformLimits=e.Arch=e.ByteSize=e.FALLBACK_MAX_MEMORY_SIZE_MB=e.MIN_MAX_MEMORY_SIZE_MB=e.whenProviderRegistered=e.etag=e.ETAG_DISABLED=e.FileKind=e.FILES_EXCLUDE_CONFIG=e.FILES_ASSOCIATIONS_CONFIG=e.HotExitConfiguration=e.AutoSaveConfiguration=e.FileOperationResult=e.NotModifiedSinceFileOperationError=e.FileOperationError=e.isParent=e.FileChangesEvent=e.FileChangeType=e.FileOperationEvent=e.FileOperation=e.toFileOperationResult=e.toFileSystemProviderErrorCode=e.markAsFileSystemProviderError=e.ensureFileSystemProviderError=e.createFileSystemProviderError=e.FileSystemProviderError=e.FileSystemProviderErrorCode=e.hasFileAtomicReadCapability=e.hasFileReadStreamCapability=e.hasOpenReadWriteCloseCapability=e.hasFileCloneCapability=e.hasFileFolderCopyCapability=e.hasReadWriteCapability=e.FileSystemProviderCapabilities=e.FilePermission=e.FileType=e.isFileOpenForWriteOptions=e.IFileService=void 0,e.IFileService=(0,b.createDecorator)("fileService");function P(W){return W.create===!0}e.isFileOpenForWriteOptions=P;var O;(function(W){W[W.Unknown=0]="Unknown",W[W.File=1]="File",W[W.Directory=2]="Directory",W[W.SymbolicLink=64]="SymbolicLink"})(O=e.FileType||(e.FileType={}));var E;(function(W){W[W.Readonly=1]="Readonly"})(E=e.FilePermission||(e.FilePermission={}));var m;(function(W){W[W.FileReadWrite=2]="FileReadWrite",W[W.FileOpenReadWriteClose=4]="FileOpenReadWriteClose",W[W.FileReadStream=16]="FileReadStream",W[W.FileFolderCopy=8]="FileFolderCopy",W[W.PathCaseSensitive=1024]="PathCaseSensitive",W[W.Readonly=2048]="Readonly",W[W.Trash=4096]="Trash",W[W.FileWriteUnlock=8192]="FileWriteUnlock",W[W.FileAtomicRead=16384]="FileAtomicRead",W[W.FileClone=32768]="FileClone"})(m=e.FileSystemProviderCapabilities||(e.FileSystemProviderCapabilities={}));function k(W){return!!(W.capabilities&2)}e.hasReadWriteCapability=k;function f(W){return!!(W.capabilities&8)}e.hasFileFolderCopyCapability=f;function c(W){return!!(W.capabilities&32768)}e.hasFileCloneCapability=c;function d(W){return!!(W.capabilities&4)}e.hasOpenReadWriteCloseCapability=d;function h(W){return!!(W.capabilities&16)}e.hasFileReadStreamCapability=h;function g(W){return k(W)?!!(W.capabilities&16384):!1}e.hasFileAtomicReadCapability=g;var C;(function(W){W.FileExists="EntryExists",W.FileNotFound="EntryNotFound",W.FileNotADirectory="EntryNotADirectory",W.FileIsADirectory="EntryIsADirectory",W.FileExceedsMemoryLimit="EntryExceedsMemoryLimit",W.FileTooLarge="EntryTooLarge",W.FileWriteLocked="EntryWriteLocked",W.NoPermissions="NoPermissions",W.Unavailable="Unavailable",W.Unknown="Unknown"})(C=e.FileSystemProviderErrorCode||(e.FileSystemProviderErrorCode={}));class l extends Error{constructor($,G){super($),this.code=G}}e.FileSystemProviderError=l;function w(W,$){const G=new l(W.toString(),$);return u(G,$),G}e.createFileSystemProviderError=w;function t(W){return W||w((0,A.localize)(0,null),C.Unknown)}e.ensureFileSystemProviderError=t;function u(W,$){return W.name=$?`${$} (FileSystemError)`:"FileSystemError",W}e.markAsFileSystemProviderError=u;function i(W){if(!W)return C.Unknown;if(W instanceof l)return W.code;const $=/^(.+) \(FileSystemError\)$/.exec(W.name);if(!$)return C.Unknown;switch($[1]){case C.FileExists:return C.FileExists;case C.FileIsADirectory:return C.FileIsADirectory;case C.FileNotADirectory:return C.FileNotADirectory;case C.FileNotFound:return C.FileNotFound;case C.FileExceedsMemoryLimit:return C.FileExceedsMemoryLimit;case C.FileTooLarge:return C.FileTooLarge;case C.FileWriteLocked:return C.FileWriteLocked;case C.NoPermissions:return C.NoPermissions;case C.Unavailable:return C.Unavailable}return C.Unknown}e.toFileSystemProviderErrorCode=i;function n(W){if(W instanceof T)return W.fileOperationResult;switch(i(W)){case C.FileNotFound:return 1;case C.FileIsADirectory:return 0;case C.FileNotADirectory:return 10;case C.FileWriteLocked:return 5;case C.NoPermissions:return 6;case C.FileExists:return 4;case C.FileExceedsMemoryLimit:return 9;case C.FileTooLarge:return 7;default:return 11}}e.toFileOperationResult=n;var s;(function(W){W[W.CREATE=0]="CREATE",W[W.DELETE=1]="DELETE",W[W.MOVE=2]="MOVE",W[W.COPY=3]="COPY",W[W.WRITE=4]="WRITE"})(s=e.FileOperation||(e.FileOperation={}));class a{constructor($,G,ne){this.resource=$,this.operation=G,this.target=ne}isOperation($){return this.operation===$}}e.FileOperationEvent=a;var o;(function(W){W[W.UPDATED=0]="UPDATED",W[W.ADDED=1]="ADDED",W[W.DELETED=2]="DELETED"})(o=e.FileChangeType||(e.FileChangeType={}));class v{constructor($,G){this.added=void 0,this.updated=void 0,this.deleted=void 0,this.rawChanges=[],this.rawAdded=[],this.rawUpdated=[],this.rawDeleted=[],this.rawChanges=$;const ne=new Map;for(const ge of $){const oe=ne.get(ge.type);switch(oe?oe.push([ge.resource,ge]):ne.set(ge.type,[[ge.resource,ge]]),ge.type){case 1:this.rawAdded.push(ge.resource);break;case 0:this.rawUpdated.push(ge.resource);break;case 2:this.rawDeleted.push(ge.resource);break}}for(const[ge,oe]of ne)switch(ge){case 1:this.added=r.TernarySearchTree.forUris(()=>G),this.added.fill(oe);break;case 0:this.updated=r.TernarySearchTree.forUris(()=>G),this.updated.fill(oe);break;case 2:this.deleted=r.TernarySearchTree.forUris(()=>G),this.deleted.fill(oe);break}}contains($,...G){return this.doContains($,{includeChildren:!1},...G)}affects($,...G){return this.doContains($,{includeChildren:!0},...G)}doContains($,G,...ne){if(!$)return!1;const ge=ne.length>0;return!!((!ge||ne.includes(1))&&(this.added?.get($)||G.includeChildren&&this.added?.findSuperstr($))||(!ge||ne.includes(0))&&(this.updated?.get($)||G.includeChildren&&this.updated?.findSuperstr($))||(!ge||ne.includes(2))&&(this.deleted?.findSubstr($)||G.includeChildren&&this.deleted?.findSuperstr($)))}gotAdded(){return!!this.added}gotDeleted(){return!!this.deleted}gotUpdated(){return!!this.updated}}e.FileChangesEvent=v;function p(W,$,G){return!W||!$||W===$||$.length>W.length?!1:($.charAt($.length-1)!==y.sep&&($+=y.sep),G?(0,S.startsWithIgnoreCase)(W,$):W.indexOf($)===0)}e.isParent=p;class T extends Error{constructor($,G,ne){super($),this.fileOperationResult=G,this.options=ne}}e.FileOperationError=T;class N extends T{constructor($,G,ne){super($,2,ne),this.stat=G}}e.NotModifiedSinceFileOperationError=N;var V;(function(W){W[W.FILE_IS_DIRECTORY=0]="FILE_IS_DIRECTORY",W[W.FILE_NOT_FOUND=1]="FILE_NOT_FOUND",W[W.FILE_NOT_MODIFIED_SINCE=2]="FILE_NOT_MODIFIED_SINCE",W[W.FILE_MODIFIED_SINCE=3]="FILE_MODIFIED_SINCE",W[W.FILE_MOVE_CONFLICT=4]="FILE_MOVE_CONFLICT",W[W.FILE_WRITE_LOCKED=5]="FILE_WRITE_LOCKED",W[W.FILE_PERMISSION_DENIED=6]="FILE_PERMISSION_DENIED",W[W.FILE_TOO_LARGE=7]="FILE_TOO_LARGE",W[W.FILE_INVALID_PATH=8]="FILE_INVALID_PATH",W[W.FILE_EXCEEDS_MEMORY_LIMIT=9]="FILE_EXCEEDS_MEMORY_LIMIT",W[W.FILE_NOT_DIRECTORY=10]="FILE_NOT_DIRECTORY",W[W.FILE_OTHER_ERROR=11]="FILE_OTHER_ERROR"})(V=e.FileOperationResult||(e.FileOperationResult={})),e.AutoSaveConfiguration={OFF:"off",AFTER_DELAY:"afterDelay",ON_FOCUS_CHANGE:"onFocusChange",ON_WINDOW_CHANGE:"onWindowChange"},e.HotExitConfiguration={OFF:"off",ON_EXIT:"onExit",ON_EXIT_AND_WINDOW_CLOSE:"onExitAndWindowClose"},e.FILES_ASSOCIATIONS_CONFIG="files.associations",e.FILES_EXCLUDE_CONFIG="files.exclude";var B;(function(W){W[W.FILE=0]="FILE",W[W.FOLDER=1]="FOLDER",W[W.ROOT_FOLDER=2]="ROOT_FOLDER"})(B=e.FileKind||(e.FileKind={})),e.ETAG_DISABLED="";function D(W){if(!(typeof W.size!="number"||typeof W.mtime!="number"))return W.mtime.toString(29)+W.size.toString(31)}e.etag=D;async function z(W,$){if(!$.hasProvider(_.URI.from({scheme:W.scheme})))return new Promise(G=>{const ne=$.onDidChangeFileSystemProviderRegistrations(ge=>{ge.scheme===W.scheme&&ge.added&&(ne.dispose(),G())})})}e.whenProviderRegistered=z,e.MIN_MAX_MEMORY_SIZE_MB=2048,e.FALLBACK_MAX_MEMORY_SIZE_MB=4096;class L{static formatSize($){return(0,M.isNumber)($)||($=0),$<L.KB?(0,A.localize)(1,null,$.toFixed(0)):$<L.MB?(0,A.localize)(2,null,($/L.KB).toFixed(2)):$<L.GB?(0,A.localize)(3,null,($/L.MB).toFixed(2)):$<L.TB?(0,A.localize)(4,null,($/L.GB).toFixed(2)):(0,A.localize)(5,null,($/L.TB).toFixed(2))}}e.ByteSize=L,L.KB=1024,L.MB=L.KB*L.KB,L.GB=L.MB*L.KB,L.TB=L.GB*L.KB;var R;(function(W){W[W.IA32=0]="IA32",W[W.OTHER=1]="OTHER"})(R=e.Arch||(e.Arch={}));function K(W){return{maxFileSize:W===0?300*L.MB:16*L.GB,maxHeapSize:W===0?700*L.MB:2*700*L.MB}}e.getPlatformLimits=K}),define(Ce[58],Ie([1,0]),function(ie,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ServiceCollection=void 0;class r{constructor(...S){this._entries=new Map;for(const[M,_]of S)this.set(M,_)}set(S,M){const _=this._entries.get(S);return this._entries.set(S,M),_}has(S){return this._entries.has(S)}get(S){return this._entries.get(S)}}e.ServiceCollection=r}),define(Ce[148],Ie([1,0,15,12,80,146,3,58]),function(ie,e,r,y,S,M,_,A){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.Trace=e.InstantiationService=void 0;const b=!1;class P extends Error{constructor(f){super("cyclic dependency between services"),this.message=f.findCycleSlow()??`UNABLE to detect cycle, dumping graph: 
${f.toString()}`}}class O{constructor(f=new A.ServiceCollection,c=!1,d,h=b){this._services=f,this._strict=c,this._parent=d,this._enableTracing=h,this._activeInstantiations=new Set,this._services.set(_.IInstantiationService,this),this._globalGraph=h?d?._globalGraph??new M.Graph(g=>g):void 0}createChild(f){return new O(f,this._strict,this,this._enableTracing)}invokeFunction(f,...c){const d=m.traceInvocation(this._enableTracing,f);let h=!1;try{return f({get:C=>{if(h)throw(0,y.illegalState)("service accessor is only valid during the invocation of its target method");const l=this._getOrCreateServiceInstance(C,d);if(!l)throw new Error(`[invokeFunction] unknown service '${C}'`);return l}},...c)}finally{h=!0,d.stop()}}createInstance(f,...c){let d,h;return f instanceof S.SyncDescriptor?(d=m.traceCreation(this._enableTracing,f.ctor),h=this._createInstance(f.ctor,f.staticArguments.concat(c),d)):(d=m.traceCreation(this._enableTracing,f),h=this._createInstance(f,c,d)),d.stop(),h}_createInstance(f,c=[],d){const h=_._util.getServiceDependencies(f).sort((l,w)=>l.index-w.index),g=[];for(const l of h){const w=this._getOrCreateServiceInstance(l.id,d);w||this._throwIfStrict(`[createInstance] ${f.name} depends on UNKNOWN service ${l.id}.`,!1),g.push(w)}const C=h.length>0?h[0].index:c.length;if(c.length!==C){console.trace(`[createInstance] First service dependency of ${f.name} at position ${C+1} conflicts with ${c.length} static arguments`);const l=C-c.length;l>0?c=c.concat(new Array(l)):c=c.slice(0,C)}return new f(...c,...g)}_setServiceInstance(f,c){if(this._services.get(f)instanceof S.SyncDescriptor)this._services.set(f,c);else if(this._parent)this._parent._setServiceInstance(f,c);else throw new Error("illegalState - setting UNKNOWN service instance")}_getServiceInstanceOrDescriptor(f){const c=this._services.get(f);return!c&&this._parent?this._parent._getServiceInstanceOrDescriptor(f):c}_getOrCreateServiceInstance(f,c){this._globalGraph&&this._globalGraphImplicitDependency&&this._globalGraph.insertEdge(this._globalGraphImplicitDependency,String(f));const d=this._getServiceInstanceOrDescriptor(f);return d instanceof S.SyncDescriptor?this._safeCreateAndCacheServiceInstance(f,d,c.branch(f,!0)):(c.branch(f,!1),d)}_safeCreateAndCacheServiceInstance(f,c,d){if(this._activeInstantiations.has(f))throw new Error(`illegal state - RECURSIVELY instantiating service '${f}'`);this._activeInstantiations.add(f);try{return this._createAndCacheServiceInstance(f,c,d)}finally{this._activeInstantiations.delete(f)}}_createAndCacheServiceInstance(f,c,d){const h=new M.Graph(l=>l.id.toString());let g=0;const C=[{id:f,desc:c,_trace:d}];for(;C.length;){const l=C.pop();if(h.lookupOrInsertNode(l),g++>1e3)throw new P(h);for(const w of _._util.getServiceDependencies(l.desc.ctor)){const t=this._getServiceInstanceOrDescriptor(w.id);if(t||this._throwIfStrict(`[createInstance] ${f} depends on ${w.id} which is NOT registered.`,!0),this._globalGraph?.insertEdge(String(l.id),String(w.id)),t instanceof S.SyncDescriptor){const u={id:w.id,desc:t,_trace:l._trace.branch(w.id,!0)};h.insertEdge(l,u),C.push(u)}}}for(;;){const l=h.roots();if(l.length===0){if(!h.isEmpty())throw new P(h);break}for(const{data:w}of l){if(this._getServiceInstanceOrDescriptor(w.id)instanceof S.SyncDescriptor){const u=this._createServiceInstanceWithOwner(w.id,w.desc.ctor,w.desc.staticArguments,w.desc.supportsDelayedInstantiation,w._trace);this._setServiceInstance(w.id,u)}h.removeNode(w)}}return this._getServiceInstanceOrDescriptor(f)}_createServiceInstanceWithOwner(f,c,d=[],h,g){if(this._services.get(f)instanceof S.SyncDescriptor)return this._createServiceInstance(f,c,d,h,g);if(this._parent)return this._parent._createServiceInstanceWithOwner(f,c,d,h,g);throw new Error(`illegalState - creating UNKNOWN service instance ${c.name}`)}_createServiceInstance(f,c,d=[],h,g){if(h){const C=new O(void 0,this._strict,this,this._enableTracing);C._globalGraphImplicitDependency=String(f);const l=new r.IdleValue(()=>C._createInstance(c,d,g));return new Proxy(Object.create(null),{get(w,t){if(t in w)return w[t];const u=l.value;let i=u[t];return typeof i!="function"||(i=i.bind(u),w[t]=i),i},set(w,t,u){return l.value[t]=u,!0}})}else return this._createInstance(c,d,g)}_throwIfStrict(f,c){if(c&&console.warn(f),this._strict)throw new Error(f)}}e.InstantiationService=O;var E;(function(k){k[k.Creation=0]="Creation",k[k.Invocation=1]="Invocation",k[k.Branch=2]="Branch"})(E||(E={}));class m{static traceInvocation(f,c){return f?new m(1,c.name||new Error().stack.split(`
`).slice(3,4).join(`
`)):m._None}static traceCreation(f,c){return f?new m(0,c.name):m._None}constructor(f,c){this.type=f,this.name=c,this._start=Date.now(),this._dep=[]}branch(f,c){const d=new m(2,f.toString());return this._dep.push([f,c,d]),d}stop(){const f=Date.now()-this._start;m._totals+=f;let c=!1;function d(g,C){const l=[],w=new Array(g+1).join("	");for(const[t,u,i]of C._dep)if(u&&i){c=!0,l.push(`${w}CREATES -> ${t}`);const n=d(g+1,i);n&&l.push(n)}else l.push(`${w}uses -> ${t}`);return l.join(`
`)}const h=[`${this.type===0?"CREATE":"CALL"} ${this.name}`,`${d(1,this)}`,`DONE, took ${f.toFixed(2)}ms (grand total ${m._totals.toFixed(2)}ms)`];(f>2||c)&&m.all.add(h.join(`
`))}}e.Trace=m,m.all=new Set,m._None=new class extends m{constructor(){super(-1,null)}stop(){}branch(){return this}},m._totals=0}),define(Ce[14],Ie([1,0,43,5,7,21,3]),function(ie,e,r,y,S,M,_){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.LogLevelToString=e.parseLogLevel=e.getLogLevel=e.NullLogService=e.AbstractLoggerService=e.LogService=e.MultiplexLogService=e.AdapterLogger=e.ConsoleLogger=e.ConsoleMainLogger=e.AbstractMessageLogger=e.AbstractLogger=e.format=e.log=e.DEFAULT_LOG_LEVEL=e.LogLevel=e.ILoggerService=e.ILogService=void 0,e.ILogService=(0,_.createDecorator)("logService"),e.ILoggerService=(0,_.createDecorator)("loggerService");function A(){return new Date().toISOString()}var b;(function(u){u[u.Trace=0]="Trace",u[u.Debug=1]="Debug",u[u.Info=2]="Info",u[u.Warning=3]="Warning",u[u.Error=4]="Error",u[u.Critical=5]="Critical",u[u.Off=6]="Off"})(b=e.LogLevel||(e.LogLevel={})),e.DEFAULT_LOG_LEVEL=b.Info;function P(u,i,n){switch(i){case b.Trace:u.trace(n);break;case b.Debug:u.debug(n);break;case b.Info:u.info(n);break;case b.Warning:u.warn(n);break;case b.Error:u.error(n);break;case b.Critical:u.critical(n);break;default:throw new Error("Invalid log level")}}e.log=P;function O(u){let i="";for(let n=0;n<u.length;n++){let s=u[n];if(typeof s=="object")try{s=JSON.stringify(s)}catch{}i+=(n>0?" ":"")+s}return i}e.format=O;class E extends S.Disposable{constructor(){super(...arguments),this.level=e.DEFAULT_LOG_LEVEL,this._onDidChangeLogLevel=this._register(new y.Emitter),this.onDidChangeLogLevel=this._onDidChangeLogLevel.event}setLevel(i){this.level!==i&&(this.level=i,this._onDidChangeLogLevel.fire(this.level))}getLevel(){return this.level}}e.AbstractLogger=E;class m extends E{constructor(i){super(),this.logAlways=i}checkLogLevel(i){return this.logAlways||this.getLevel()<=i}trace(i,...n){this.checkLogLevel(b.Trace)&&this.log(b.Trace,O([i,...n]))}debug(i,...n){this.checkLogLevel(b.Debug)&&this.log(b.Debug,O([i,...n]))}info(i,...n){this.checkLogLevel(b.Info)&&this.log(b.Info,O([i,...n]))}warn(i,...n){this.checkLogLevel(b.Warning)&&this.log(b.Warning,O([i,...n]))}error(i,...n){if(this.checkLogLevel(b.Error))if(i instanceof Error){const s=Array.prototype.slice.call(arguments);s[0]=i.stack,this.log(b.Error,O(s))}else this.log(b.Error,O([i,...n]))}critical(i,...n){this.checkLogLevel(b.Critical)&&this.log(b.Critical,O([i,...n]))}flush(){}}e.AbstractMessageLogger=m;class k extends E{constructor(i=e.DEFAULT_LOG_LEVEL){super(),this.setLevel(i),this.useColors=!M.isWindows}trace(i,...n){this.getLevel()<=b.Trace&&(this.useColors?console.log(`\x1B[90m[main ${A()}]\x1B[0m`,i,...n):console.log(`[main ${A()}]`,i,...n))}debug(i,...n){this.getLevel()<=b.Debug&&(this.useColors?console.log(`\x1B[90m[main ${A()}]\x1B[0m`,i,...n):console.log(`[main ${A()}]`,i,...n))}info(i,...n){this.getLevel()<=b.Info&&(this.useColors?console.log(`\x1B[90m[main ${A()}]\x1B[0m`,i,...n):console.log(`[main ${A()}]`,i,...n))}warn(i,...n){this.getLevel()<=b.Warning&&(this.useColors?console.warn(`\x1B[93m[main ${A()}]\x1B[0m`,i,...n):console.warn(`[main ${A()}]`,i,...n))}error(i,...n){this.getLevel()<=b.Error&&(this.useColors?console.error(`\x1B[91m[main ${A()}]\x1B[0m`,i,...n):console.error(`[main ${A()}]`,i,...n))}critical(i,...n){this.getLevel()<=b.Critical&&(this.useColors?console.error(`\x1B[90m[main ${A()}]\x1B[0m`,i,...n):console.error(`[main ${A()}]`,i,...n))}dispose(){}flush(){}}e.ConsoleMainLogger=k;class f extends E{constructor(i=e.DEFAULT_LOG_LEVEL){super(),this.setLevel(i)}trace(i,...n){this.getLevel()<=b.Trace&&console.log("%cTRACE","color: #888",i,...n)}debug(i,...n){this.getLevel()<=b.Debug&&console.log("%cDEBUG","background: #eee; color: #888",i,...n)}info(i,...n){this.getLevel()<=b.Info&&console.log("%c INFO","color: #33f",i,...n)}warn(i,...n){this.getLevel()<=b.Warning&&console.log("%c WARN","color: #993",i,...n)}error(i,...n){this.getLevel()<=b.Error&&console.log("%c  ERR","color: #f33",i,...n)}critical(i,...n){this.getLevel()<=b.Critical&&console.log("%cCRITI","background: #f33; color: white",i,...n)}dispose(){}flush(){}}e.ConsoleLogger=f;class c extends E{constructor(i,n=e.DEFAULT_LOG_LEVEL){super(),this.adapter=i,this.setLevel(n)}trace(i,...n){this.getLevel()<=b.Trace&&this.adapter.log(b.Trace,[this.extractMessage(i),...n])}debug(i,...n){this.getLevel()<=b.Debug&&this.adapter.log(b.Debug,[this.extractMessage(i),...n])}info(i,...n){this.getLevel()<=b.Info&&this.adapter.log(b.Info,[this.extractMessage(i),...n])}warn(i,...n){this.getLevel()<=b.Warning&&this.adapter.log(b.Warning,[this.extractMessage(i),...n])}error(i,...n){this.getLevel()<=b.Error&&this.adapter.log(b.Error,[this.extractMessage(i),...n])}critical(i,...n){this.getLevel()<=b.Critical&&this.adapter.log(b.Critical,[this.extractMessage(i),...n])}extractMessage(i){return typeof i=="string"?i:(0,r.toErrorMessage)(i,this.getLevel()<=b.Trace)}dispose(){}flush(){}}e.AdapterLogger=c;class d extends E{constructor(i){super(),this.logServices=i,i.length&&this.setLevel(i[0].getLevel())}setLevel(i){for(const n of this.logServices)n.setLevel(i);super.setLevel(i)}trace(i,...n){for(const s of this.logServices)s.trace(i,...n)}debug(i,...n){for(const s of this.logServices)s.debug(i,...n)}info(i,...n){for(const s of this.logServices)s.info(i,...n)}warn(i,...n){for(const s of this.logServices)s.warn(i,...n)}error(i,...n){for(const s of this.logServices)s.error(i,...n)}critical(i,...n){for(const s of this.logServices)s.critical(i,...n)}flush(){for(const i of this.logServices)i.flush()}dispose(){for(const i of this.logServices)i.dispose()}}e.MultiplexLogService=d;class h extends S.Disposable{constructor(i){super(),this.logger=i,this._register(i)}get onDidChangeLogLevel(){return this.logger.onDidChangeLogLevel}setLevel(i){this.logger.setLevel(i)}getLevel(){return this.logger.getLevel()}trace(i,...n){this.logger.trace(i,...n)}debug(i,...n){this.logger.debug(i,...n)}info(i,...n){this.logger.info(i,...n)}warn(i,...n){this.logger.warn(i,...n)}error(i,...n){this.logger.error(i,...n)}critical(i,...n){this.logger.critical(i,...n)}flush(){this.logger.flush()}}e.LogService=h;class g extends S.Disposable{constructor(i,n){super(),this.logLevel=i,this.loggers=new Map,this.logLevelChangeableLoggers=[],this._register(n(s=>{this.logLevel=s,this.logLevelChangeableLoggers.forEach(a=>a.setLevel(s))}))}getLogger(i){return this.loggers.get(i.toString())}createLogger(i,n){let s=this.loggers.get(i.toString());return s||(s=this.doCreateLogger(i,n?.always?b.Trace:this.logLevel,n),this.loggers.set(i.toString(),s),n?.always||this.logLevelChangeableLoggers.push(s)),s}dispose(){this.logLevelChangeableLoggers.splice(0,this.logLevelChangeableLoggers.length),this.loggers.forEach(i=>i.dispose()),this.loggers.clear(),super.dispose()}}e.AbstractLoggerService=g;class C{constructor(){this.onDidChangeLogLevel=new y.Emitter().event}setLevel(i){}getLevel(){return b.Info}trace(i,...n){}debug(i,...n){}info(i,...n){}warn(i,...n){}error(i,...n){}critical(i,...n){}dispose(){}flush(){}}e.NullLogService=C;function l(u){if(u.verbose)return b.Trace;if(typeof u.logLevel=="string"){const i=w(u.logLevel.toLowerCase());if(i!==void 0)return i}return e.DEFAULT_LOG_LEVEL}e.getLogLevel=l;function w(u){switch(u){case"trace":return b.Trace;case"debug":return b.Debug;case"info":return b.Info;case"warn":return b.Warning;case"error":return b.Error;case"critical":return b.Critical;case"off":return b.Off}}e.parseLogLevel=w;function t(u){switch(u){case b.Trace:return"trace";case b.Debug:return"debug";case b.Info:return"info";case b.Warning:return"warn";case b.Error:return"error";case b.Critical:return"critical";case b.Off:return"off"}}e.LogLevelToString=t}),define(Ce[82],Ie([1,0,29,128,3]),function(ie,e,r,y,S){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.IMarkerService=e.IMarkerData=e.MarkerSeverity=e.MarkerTag=void 0;var M;(function(b){b[b.Unnecessary=1]="Unnecessary",b[b.Deprecated=2]="Deprecated"})(M=e.MarkerTag||(e.MarkerTag={}));var _;(function(b){b[b.Hint=1]="Hint",b[b.Info=2]="Info",b[b.Warning=4]="Warning",b[b.Error=8]="Error"})(_=e.MarkerSeverity||(e.MarkerSeverity={})),function(b){function P(f,c){return c-f}b.compare=P;const O=Object.create(null);O[b.Error]=(0,y.localize)(0,null),O[b.Warning]=(0,y.localize)(1,null),O[b.Info]=(0,y.localize)(2,null);function E(f){return O[f]||""}b.toString=E;function m(f){switch(f){case r.default.Error:return b.Error;case r.default.Warning:return b.Warning;case r.default.Info:return b.Info;case r.default.Ignore:return b.Hint}}b.fromSeverity=m;function k(f){switch(f){case b.Error:return r.default.Error;case b.Warning:return r.default.Warning;case b.Info:return r.default.Info;case b.Hint:return r.default.Ignore}}b.toSeverity=k}(_=e.MarkerSeverity||(e.MarkerSeverity={}));var A;(function(b){const P="";function O(m){return E(m,!0)}b.makeKey=O;function E(m,k){const f=[P];return m.source?f.push(m.source.replace("\xA6","\\\xA6")):f.push(P),m.code?typeof m.code=="string"?f.push(m.code.replace("\xA6","\\\xA6")):f.push(m.code.value.replace("\xA6","\\\xA6")):f.push(P),m.severity!==void 0&&m.severity!==null?f.push(_.toString(m.severity)):f.push(P),m.message&&k?f.push(m.message.replace("\xA6","\\\xA6")):f.push(P),m.startLineNumber!==void 0&&m.startLineNumber!==null?f.push(m.startLineNumber.toString()):f.push(P),m.startColumn!==void 0&&m.startColumn!==null?f.push(m.startColumn.toString()):f.push(P),m.endLineNumber!==void 0&&m.endLineNumber!==null?f.push(m.endLineNumber.toString()):f.push(P),m.endColumn!==void 0&&m.endColumn!==null?f.push(m.endColumn.toString()):f.push(P),f.push(P),f.join("\xA6")}b.makeKeyOptionalMessage=E})(A=e.IMarkerData||(e.IMarkerData={})),e.IMarkerService=(0,S.createDecorator)("markerService")}),define(Ce[149],Ie([1,0,5,29,3]),function(ie,e,r,y,S){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.NoOpProgress=e.NoOpNotification=e.NotificationsFilter=e.NeverShowAgainScope=e.INotificationService=e.Severity=void 0,e.Severity=y.default,e.INotificationService=(0,S.createDecorator)("notificationService");var M;(function(P){P[P.WORKSPACE=0]="WORKSPACE",P[P.PROFILE=1]="PROFILE",P[P.APPLICATION=2]="APPLICATION"})(M=e.NeverShowAgainScope||(e.NeverShowAgainScope={}));var _;(function(P){P[P.OFF=0]="OFF",P[P.SILENT=1]="SILENT",P[P.ERROR=2]="ERROR"})(_=e.NotificationsFilter||(e.NotificationsFilter={}));class A{constructor(){this.progress=new b,this.onDidClose=r.Event.None,this.onDidChangeVisibility=r.Event.None}updateSeverity(O){}updateMessage(O){}updateActions(O){}close(){}}e.NoOpNotification=A;class b{infinite(){}done(){}total(O){}worked(O){}}e.NoOpProgress=b}),define(Ce[83],Ie([1,0,7,9,2,3]),function(ie,e,r,y,S,M){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.extractSelection=e.withSelection=e.matchesSomeScheme=e.matchesScheme=e.NullOpenerService=e.IOpenerService=void 0,e.IOpenerService=(0,M.createDecorator)("openerService"),e.NullOpenerService=Object.freeze({_serviceBrand:void 0,registerOpener(){return r.Disposable.None},registerValidator(){return r.Disposable.None},registerExternalUriResolver(){return r.Disposable.None},setDefaultExternalOpener(){},registerExternalOpener(){return r.Disposable.None},async open(){return!1},async resolveExternalUri(O){return{resolved:O,dispose(){}}}});function _(O,E){return S.URI.isUri(O)?(0,y.equalsIgnoreCase)(O.scheme,E):(0,y.startsWithIgnoreCase)(O,E+":")}e.matchesScheme=_;function A(O,...E){return E.some(m=>_(O,m))}e.matchesSomeScheme=A;function b(O,E){return O.with({fragment:`${E.startLineNumber},${E.startColumn}${E.endLineNumber?`-${E.endLineNumber}${E.endColumn?`,${E.endColumn}`:""}`:""}`})}e.withSelection=b;function P(O){let E;const m=/^L?(\d+)(?:,(\d+))?(-L?(\d+)(?:,(\d+))?)?/.exec(O.fragment);return m&&(E={startLineNumber:parseInt(m[1]),startColumn:m[2]?parseInt(m[2]):1,endLineNumber:m[4]?parseInt(m[4]):void 0,endColumn:m[4]?m[5]?parseInt(m[5]):1:void 0},O=O.with({fragment:""})),{selection:E,uri:O}}e.extractSelection=P}),define(Ce[150],Ie([1,0,3]),function(ie,e,r){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.productSchemaId=e.IProductService=void 0,e.IProductService=(0,r.createDecorator)("productService"),e.productSchemaId="vscode://schemas/vscode-product"});var ze=this&&this.__decorate||function(ie,e,r,y){var S=arguments.length,M=S<3?e:y===null?y=Object.getOwnPropertyDescriptor(e,r):y,_;if(typeof Reflect=="object"&&typeof Reflect.decorate=="function")M=Reflect.decorate(ie,e,r,y);else for(var A=ie.length-1;A>=0;A--)(_=ie[A])&&(M=(S<3?_(M):S>3?_(e,r,M):_(e,r))||M);return S>3&&M&&Object.defineProperty(e,r,M),M},$e=this&&this.__param||function(ie,e){return function(r,y){e(r,y,ie)}};define(Ce[151],Ie([1,0,15,20,7,3]),function(ie,e,r,y,S,M){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.IEditorProgressService=e.LongRunningOperation=e.UnmanagedProgress=e.Progress=e.emptyProgressRunner=e.ProgressLocation=e.IProgressService=void 0,e.IProgressService=(0,M.createDecorator)("progressService");var _;(function(O){O[O.Explorer=1]="Explorer",O[O.Scm=3]="Scm",O[O.Extensions=5]="Extensions",O[O.Window=10]="Window",O[O.Notification=15]="Notification",O[O.Dialog=20]="Dialog"})(_=e.ProgressLocation||(e.ProgressLocation={})),e.emptyProgressRunner=Object.freeze({total(){},worked(){},done(){}});class A{get value(){return this._value}constructor(E){this.callback=E}report(E){this._value=E,this.callback(this._value)}}e.Progress=A,A.None=Object.freeze({report(){}});let b=class extends S.Disposable{constructor(E,m){super(),this.deferred=new r.DeferredPromise,m.withProgress(E,k=>(this.reporter=k,this.lastStep&&k.report(this.lastStep),this.deferred.p)),this._register((0,S.toDisposable)(()=>this.deferred.complete()))}report(E){this.reporter?this.reporter.report(E):this.lastStep=E}};b=ze([$e(1,e.IProgressService)],b),e.UnmanagedProgress=b;class P extends S.Disposable{constructor(E){super(),this.progressIndicator=E,this.currentOperationId=0,this.currentOperationDisposables=this._register(new S.DisposableStore)}start(E){this.stop();const m=++this.currentOperationId,k=new y.CancellationTokenSource;return this.currentProgressTimeout=setTimeout(()=>{m===this.currentOperationId&&(this.currentProgressRunner=this.progressIndicator.show(!0))},E),this.currentOperationDisposables.add((0,S.toDisposable)(()=>clearTimeout(this.currentProgressTimeout))),this.currentOperationDisposables.add((0,S.toDisposable)(()=>k.cancel())),this.currentOperationDisposables.add((0,S.toDisposable)(()=>this.currentProgressRunner?this.currentProgressRunner.done():void 0)),{id:m,token:k.token,stop:()=>this.doStop(m),isCurrent:()=>this.currentOperationId===m}}stop(){this.doStop(this.currentOperationId)}doStop(E){this.currentOperationId===E&&this.currentOperationDisposables.clear()}}e.LongRunningOperation=P,e.IEditorProgressService=(0,M.createDecorator)("editorProgressService")}),define(Ce[30],Ie([1,0,44,10]),function(ie,e,r,y){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.Registry=void 0;class S{constructor(){this.data=new Map}add(_,A){r.ok(y.isString(_)),r.ok(y.isObject(A)),r.ok(!this.data.has(_),"There is already an extension with this id"),this.data.set(_,A)}knows(_){return this.data.has(_)}as(_){return this.data.get(_)||null}}e.Registry=new S}),define(Ce[84],Ie([1,0,5,30]),function(ie,e,r,y){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.Extensions=void 0,e.Extensions={JSONContribution:"base.contributions.json"};function S(A){return A.length>0&&A.charAt(A.length-1)==="#"?A.substring(0,A.length-1):A}class M{constructor(){this._onDidChangeSchema=new r.Emitter,this.onDidChangeSchema=this._onDidChangeSchema.event,this.schemasById={}}registerSchema(b,P){this.schemasById[S(b)]=P,this._onDidChangeSchema.fire(b)}notifySchemaChanged(b){this._onDidChangeSchema.fire(b)}getSchemaContributions(){return{schemas:this.schemasById}}}const _=new M;y.Registry.add(e.Extensions.JSONContribution,_)}),define(Ce[85],Ie([1,0,18,5,10,124,57,84,30]),function(ie,e,r,y,S,M,_,A,b){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.getScopes=e.validateProperty=e.getDefaultValue=e.keyFromOverrideIdentifiers=e.overrideIdentifiersFromKey=e.OVERRIDE_PROPERTY_REGEX=e.OVERRIDE_PROPERTY_PATTERN=e.configurationDefaultsSchemaId=e.resourceLanguageSettingsSchemaId=e.resourceSettings=e.windowSettings=e.machineOverridableSettings=e.machineSettings=e.applicationSettings=e.allSettings=e.ConfigurationScope=e.Extensions=e.EditPresentationTypes=void 0;var P;(function(w){w.Multiline="multilineText",w.Singleline="singlelineText"})(P=e.EditPresentationTypes||(e.EditPresentationTypes={})),e.Extensions={Configuration:"base.contributions.configuration"};var O;(function(w){w[w.APPLICATION=1]="APPLICATION",w[w.MACHINE=2]="MACHINE",w[w.WINDOW=3]="WINDOW",w[w.RESOURCE=4]="RESOURCE",w[w.LANGUAGE_OVERRIDABLE=5]="LANGUAGE_OVERRIDABLE",w[w.MACHINE_OVERRIDABLE=6]="MACHINE_OVERRIDABLE"})(O=e.ConfigurationScope||(e.ConfigurationScope={})),e.allSettings={properties:{},patternProperties:{}},e.applicationSettings={properties:{},patternProperties:{}},e.machineSettings={properties:{},patternProperties:{}},e.machineOverridableSettings={properties:{},patternProperties:{}},e.windowSettings={properties:{},patternProperties:{}},e.resourceSettings={properties:{},patternProperties:{}},e.resourceLanguageSettingsSchemaId="vscode://schemas/settings/resourceLanguage",e.configurationDefaultsSchemaId="vscode://schemas/settings/configurationDefaults";const E=b.Registry.as(A.Extensions.JSONContribution);class m{constructor(){this.overrideIdentifiers=new Set,this._onDidSchemaChange=new y.Emitter,this.onDidSchemaChange=this._onDidSchemaChange.event,this._onDidUpdateConfiguration=new y.Emitter,this.onDidUpdateConfiguration=this._onDidUpdateConfiguration.event,this.configurationDefaultsOverrides=new Map,this.defaultLanguageConfigurationOverridesNode={id:"defaultOverrides",title:M.localize(0,null),properties:{}},this.configurationContributors=[this.defaultLanguageConfigurationOverridesNode],this.resourceLanguageSettingsSchema={properties:{},patternProperties:{},additionalProperties:!1,errorMessage:"Unknown editor configuration setting",allowTrailingCommas:!0,allowComments:!0},this.configurationProperties={},this.policyConfigurations=new Map,this.excludedConfigurationProperties={},E.registerSchema(e.resourceLanguageSettingsSchemaId,this.resourceLanguageSettingsSchema),this.registerOverridePropertyPatternKey()}registerConfiguration(t,u=!0){this.registerConfigurations([t],u)}registerConfigurations(t,u=!0){const i=this.doRegisterConfigurations(t,u);E.registerSchema(e.resourceLanguageSettingsSchemaId,this.resourceLanguageSettingsSchema),this._onDidSchemaChange.fire(),this._onDidUpdateConfiguration.fire({properties:i})}deregisterConfigurations(t){const u=this.doDeregisterConfigurations(t);E.registerSchema(e.resourceLanguageSettingsSchemaId,this.resourceLanguageSettingsSchema),this._onDidSchemaChange.fire(),this._onDidUpdateConfiguration.fire({properties:u})}updateConfigurations({add:t,remove:u}){const i=[];i.push(...this.doDeregisterConfigurations(u)),i.push(...this.doRegisterConfigurations(t,!1)),E.registerSchema(e.resourceLanguageSettingsSchemaId,this.resourceLanguageSettingsSchema),this._onDidSchemaChange.fire(),this._onDidUpdateConfiguration.fire({properties:(0,r.distinct)(i)})}registerDefaultConfigurations(t){const u=[],i=[];for(const{overrides:n,source:s}of t)for(const a in n)if(u.push(a),e.OVERRIDE_PROPERTY_REGEX.test(a)){const o=this.configurationDefaultsOverrides.get(a),v=o?.valuesSources??new Map;if(s)for(const V of Object.keys(n[a]))v.set(V,s);const p={...o?.value||{},...n[a]};this.configurationDefaultsOverrides.set(a,{source:s,value:p,valuesSources:v});const T=(0,_.getLanguageTagSettingPlainKey)(a),N={type:"object",default:p,description:M.localize(1,null,T),$ref:e.resourceLanguageSettingsSchemaId,defaultDefaultValue:p,source:S.isString(s)?void 0:s,defaultValueSource:s};i.push(...c(a)),this.configurationProperties[a]=N,this.defaultLanguageConfigurationOverridesNode.properties[a]=N}else{this.configurationDefaultsOverrides.set(a,{value:n[a],source:s});const o=this.configurationProperties[a];o&&(this.updatePropertyDefaultValue(a,o),this.updateSchema(a,o))}this.registerOverrideIdentifiers(i),this._onDidSchemaChange.fire(),this._onDidUpdateConfiguration.fire({properties:u,defaultsOverrides:!0})}deregisterDefaultConfigurations(t){const u=[];for(const{overrides:i,source:n}of t)for(const s in i){const a=this.configurationDefaultsOverrides.get(s),o=S.isString(n)?n:n?.id,v=S.isString(a?.source)?a?.source:a?.source?.id;if(o===v)if(u.push(s),this.configurationDefaultsOverrides.delete(s),e.OVERRIDE_PROPERTY_REGEX.test(s))delete this.configurationProperties[s],delete this.defaultLanguageConfigurationOverridesNode.properties[s];else{const p=this.configurationProperties[s];p&&(this.updatePropertyDefaultValue(s,p),this.updateSchema(s,p))}}this.updateOverridePropertyPatternKey(),this._onDidSchemaChange.fire(),this._onDidUpdateConfiguration.fire({properties:u,defaultsOverrides:!0})}notifyConfigurationSchemaUpdated(...t){this._onDidSchemaChange.fire()}registerOverrideIdentifiers(t){for(const u of t)this.overrideIdentifiers.add(u);this.updateOverridePropertyPatternKey()}doRegisterConfigurations(t,u){const i=[];return t.forEach(n=>{i.push(...this.validateAndRegisterProperties(n,u,n.extensionInfo,n.restrictedProperties)),this.configurationContributors.push(n),this.registerJSONConfiguration(n)}),i}doDeregisterConfigurations(t){const u=[],i=n=>{if(n.properties)for(const s in n.properties){u.push(s);const a=this.configurationProperties[s];a?.policy?.name&&this.policyConfigurations.delete(a.policy.name),delete this.configurationProperties[s],this.removeFromSchema(s,n.properties[s])}n.allOf?.forEach(s=>i(s))};for(const n of t){i(n);const s=this.configurationContributors.indexOf(n);s!==-1&&this.configurationContributors.splice(s,1)}return u}validateAndRegisterProperties(t,u=!0,i,n,s=3){s=S.isUndefinedOrNull(t.scope)?s:t.scope;const a=[],o=t.properties;if(o)for(const p in o){const T=o[p];if(u&&C(p,T)){delete o[p];continue}if(T.source=i,T.defaultDefaultValue=o[p].default,this.updatePropertyDefaultValue(p,T),e.OVERRIDE_PROPERTY_REGEX.test(p)?T.scope=void 0:(T.scope=S.isUndefinedOrNull(T.scope)?s:T.scope,T.restricted=S.isUndefinedOrNull(T.restricted)?!!n?.includes(p):T.restricted),o[p].hasOwnProperty("included")&&!o[p].included){this.excludedConfigurationProperties[p]=o[p],delete o[p];continue}else this.configurationProperties[p]=o[p],o[p].policy?.name&&this.policyConfigurations.set(o[p].policy.name,p);!o[p].deprecationMessage&&o[p].markdownDeprecationMessage&&(o[p].deprecationMessage=o[p].markdownDeprecationMessage),a.push(p)}const v=t.allOf;if(v)for(const p of v)a.push(...this.validateAndRegisterProperties(p,u,i,n,s));return a}getConfigurations(){return this.configurationContributors}getConfigurationProperties(){return this.configurationProperties}getPolicyConfigurations(){return this.policyConfigurations}getExcludedConfigurationProperties(){return this.excludedConfigurationProperties}getConfigurationDefaultsOverrides(){return this.configurationDefaultsOverrides}registerJSONConfiguration(t){const u=i=>{const n=i.properties;if(n)for(const a in n)this.updateSchema(a,n[a]);i.allOf?.forEach(u)};u(t)}updateSchema(t,u){switch(e.allSettings.properties[t]=u,u.scope){case 1:e.applicationSettings.properties[t]=u;break;case 2:e.machineSettings.properties[t]=u;break;case 6:e.machineOverridableSettings.properties[t]=u;break;case 3:e.windowSettings.properties[t]=u;break;case 4:e.resourceSettings.properties[t]=u;break;case 5:e.resourceSettings.properties[t]=u,this.resourceLanguageSettingsSchema.properties[t]=u;break}}removeFromSchema(t,u){switch(delete e.allSettings.properties[t],u.scope){case 1:delete e.applicationSettings.properties[t];break;case 2:delete e.machineSettings.properties[t];break;case 6:delete e.machineOverridableSettings.properties[t];break;case 3:delete e.windowSettings.properties[t];break;case 4:case 5:delete e.resourceSettings.properties[t],delete this.resourceLanguageSettingsSchema.properties[t];break}}updateOverridePropertyPatternKey(){for(const t of this.overrideIdentifiers.values()){const u=`[${t}]`,i={type:"object",description:M.localize(2,null),errorMessage:M.localize(3,null),$ref:e.resourceLanguageSettingsSchemaId};this.updatePropertyDefaultValue(u,i),e.allSettings.properties[u]=i,e.applicationSettings.properties[u]=i,e.machineSettings.properties[u]=i,e.machineOverridableSettings.properties[u]=i,e.windowSettings.properties[u]=i,e.resourceSettings.properties[u]=i}this._onDidSchemaChange.fire()}registerOverridePropertyPatternKey(){const t={type:"object",description:M.localize(4,null),errorMessage:M.localize(5,null),$ref:e.resourceLanguageSettingsSchemaId};e.allSettings.patternProperties[e.OVERRIDE_PROPERTY_PATTERN]=t,e.applicationSettings.patternProperties[e.OVERRIDE_PROPERTY_PATTERN]=t,e.machineSettings.patternProperties[e.OVERRIDE_PROPERTY_PATTERN]=t,e.machineOverridableSettings.patternProperties[e.OVERRIDE_PROPERTY_PATTERN]=t,e.windowSettings.patternProperties[e.OVERRIDE_PROPERTY_PATTERN]=t,e.resourceSettings.patternProperties[e.OVERRIDE_PROPERTY_PATTERN]=t,this._onDidSchemaChange.fire()}updatePropertyDefaultValue(t,u){const i=this.configurationDefaultsOverrides.get(t);let n=i?.value,s=i?.source;S.isUndefined(n)&&(n=u.defaultDefaultValue,s=void 0),S.isUndefined(n)&&(n=h(u.type)),u.default=n,u.defaultValueSource=s}}const k="\\[([^\\]]+)\\]",f=new RegExp(k,"g");e.OVERRIDE_PROPERTY_PATTERN=`^(${k})+$`,e.OVERRIDE_PROPERTY_REGEX=new RegExp(e.OVERRIDE_PROPERTY_PATTERN);function c(w){const t=[];if(e.OVERRIDE_PROPERTY_REGEX.test(w)){let u=f.exec(w);for(;u?.length;){const i=u[1].trim();i&&t.push(i),u=f.exec(w)}}return(0,r.distinct)(t)}e.overrideIdentifiersFromKey=c;function d(w){return w.reduce((t,u)=>`${t}[${u}]`,"")}e.keyFromOverrideIdentifiers=d;function h(w){switch(Array.isArray(w)?w[0]:w){case"boolean":return!1;case"integer":case"number":return 0;case"string":return"";case"array":return[];case"object":return{};default:return null}}e.getDefaultValue=h;const g=new m;b.Registry.add(e.Extensions.Configuration,g);function C(w,t){return w.trim()?e.OVERRIDE_PROPERTY_REGEX.test(w)?M.localize(7,null,w):g.getConfigurationProperties()[w]!==void 0?M.localize(8,null,w):t.policy?.name&&g.getPolicyConfigurations().get(t.policy?.name)!==void 0?M.localize(9,null,w,t.policy?.name,g.getPolicyConfigurations().get(t.policy?.name)):null:M.localize(6,null)}e.validateProperty=C;function l(){const w=[],t=g.getConfigurationProperties();for(const u of Object.keys(t))w.push([u,t[u].scope]);return w.push(["launch",4]),w.push(["task",4]),w}e.getScopes=l}),define(Ce[152],Ie([1,0,18,5,106,7,24,26,10,2,57,85,30]),function(ie,e,r,y,S,M,_,A,b,P,O,E,m){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ConfigurationChangeEvent=e.mergeChanges=e.Configuration=e.UserSettings=e.ConfigurationModelParser=e.ConfigurationModel=void 0;class k{constructor(t={},u=[],i=[],n){this._contents=t,this._keys=u,this._overrides=i,this.raw=n,this.frozen=!1,this.overrideConfigurations=new Map}get rawConfiguration(){if(!this._rawConfiguration)if(this.raw?.length){const t=this.raw.map(u=>{if(u instanceof k)return u;const i=new f("");return i.parseRaw(u),i.configurationModel});this._rawConfiguration=t.reduce((u,i)=>i===u?i:u.merge(i),t[0])}else this._rawConfiguration=this;return this._rawConfiguration}get contents(){return this.checkAndFreeze(this._contents)}get overrides(){return this.checkAndFreeze(this._overrides)}get keys(){return this.checkAndFreeze(this._keys)}isEmpty(){return this._keys.length===0&&Object.keys(this._contents).length===0&&this._overrides.length===0}isFrozen(){return this.frozen}getValue(t){return t?(0,O.getConfigurationValue)(this.contents,t):this.contents}inspect(t,u){const i=this.rawConfiguration.getValue(t),n=u?this.rawConfiguration.getOverrideValue(t,u):void 0,s=u?this.rawConfiguration.override(u).getValue(t):i;return{value:i,override:n,merged:s}}getOverrideValue(t,u){const i=this.getContentsForOverrideIdentifer(u);return i?t?(0,O.getConfigurationValue)(i,t):i:void 0}getKeysForOverrideIdentifier(t){const u=[];for(const i of this.overrides)i.identifiers.includes(t)&&u.push(...i.keys);return r.distinct(u)}getAllOverrideIdentifiers(){const t=[];for(const u of this.overrides)t.push(...u.identifiers);return r.distinct(t)}override(t){let u=this.overrideConfigurations.get(t);return u||(u=this.createOverrideConfigurationModel(t),this.overrideConfigurations.set(t,u)),u}merge(...t){const u=A.deepClone(this.contents),i=A.deepClone(this.overrides),n=[...this.keys],s=this.raw?.length?[...this.raw]:[this];for(const a of t)if(s.push(...a.raw?.length?a.raw:[a]),!a.isEmpty()){this.mergeContents(u,a.contents);for(const o of a.overrides){const[v]=i.filter(p=>r.equals(p.identifiers,o.identifiers));v?(this.mergeContents(v.contents,o.contents),v.keys.push(...o.keys),v.keys=r.distinct(v.keys)):i.push(A.deepClone(o))}for(const o of a.keys)n.indexOf(o)===-1&&n.push(o)}return new k(u,n,i,s.every(a=>a instanceof k)?void 0:s)}freeze(){return this.frozen=!0,this}clone(){return new k(A.deepClone(this.contents),[...this.keys],A.deepClone(this.overrides))}createOverrideConfigurationModel(t){const u=this.getContentsForOverrideIdentifer(t);if(!u||typeof u!="object"||!Object.keys(u).length)return this;const i={};for(const n of r.distinct([...Object.keys(this.contents),...Object.keys(u)])){let s=this.contents[n];const a=u[n];a&&(typeof s=="object"&&typeof a=="object"?(s=A.deepClone(s),this.mergeContents(s,a)):s=a),i[n]=s}return new k(i,this.keys,this.overrides)}mergeContents(t,u){for(const i of Object.keys(u)){if(i in t&&b.isObject(t[i])&&b.isObject(u[i])){this.mergeContents(t[i],u[i]);continue}t[i]=A.deepClone(u[i])}}checkAndFreeze(t){return this.frozen&&!Object.isFrozen(t)?A.deepFreeze(t):t}getContentsForOverrideIdentifer(t){let u=null,i=null;const n=s=>{s&&(i?this.mergeContents(i,s):i=A.deepClone(s))};for(const s of this.overrides)r.equals(s.identifiers,[t])?u=s.contents:s.identifiers.includes(t)&&n(s.contents);return n(u),i}toJSON(){return{contents:this.contents,overrides:this.overrides,keys:this.keys}}setValue(t,u){this.addKey(t),(0,O.addToValueTree)(this.contents,t,u,i=>{throw new Error(i)})}removeValue(t){this.removeKey(t)&&(0,O.removeFromValueTree)(this.contents,t)}addKey(t){let u=this.keys.length;for(let i=0;i<u;i++)t.indexOf(this.keys[i])===0&&(u=i);this.keys.splice(u,1,t)}removeKey(t){const u=this.keys.indexOf(t);return u!==-1?(this.keys.splice(u,1),!0):!1}}e.ConfigurationModel=k;class f{constructor(t){this._name=t,this._raw=null,this._configurationModel=null,this._restrictedConfigurations=[],this._parseErrors=[]}get configurationModel(){return this._configurationModel||new k}get restrictedConfigurations(){return this._restrictedConfigurations}get errors(){return this._parseErrors}parse(t,u){if(!b.isUndefinedOrNull(t)){const i=this.doParseContent(t);this.parseRaw(i,u)}}reparse(t){this._raw&&this.parseRaw(this._raw,t)}parseRaw(t,u){this._raw=t;const{contents:i,keys:n,overrides:s,restricted:a,hasExcludedProperties:o}=this.doParseRaw(t,u);this._configurationModel=new k(i,n,s,o?[t]:void 0),this._restrictedConfigurations=a||[]}doParseContent(t){let u={},i=null,n=[];const s=[],a=[];function o(p){Array.isArray(n)?n.push(p):i!==null&&(n[i]=p)}const v={onObjectBegin:()=>{const p={};o(p),s.push(n),n=p,i=null},onObjectProperty:p=>{i=p},onObjectEnd:()=>{n=s.pop()},onArrayBegin:()=>{const p=[];o(p),s.push(n),n=p,i=null},onArrayEnd:()=>{n=s.pop()},onLiteralValue:o,onError:(p,T,N)=>{a.push({error:p,offset:T,length:N})}};if(t)try{S.visit(t,v),u=n[0]||{}}catch(p){console.error(`Error while parsing settings file ${this._name}: ${p}`),this._parseErrors=[p]}return u}doParseRaw(t,u){const i=m.Registry.as(E.Extensions.Configuration).getConfigurationProperties(),n=this.filter(t,i,!0,u);t=n.raw;const s=(0,O.toValuesTree)(t,v=>console.error(`Conflict in settings file ${this._name}: ${v}`)),a=Object.keys(t),o=this.toOverrides(t,v=>console.error(`Conflict in settings file ${this._name}: ${v}`));return{contents:s,keys:a,overrides:o,restricted:n.restricted,hasExcludedProperties:n.hasExcludedProperties}}filter(t,u,i,n){let s=!1;if(!n?.scopes&&!n?.skipRestricted)return{raw:t,restricted:[],hasExcludedProperties:s};const a={},o=[];for(const v in t)if(E.OVERRIDE_PROPERTY_REGEX.test(v)&&i){const p=this.filter(t[v],u,!1,n);a[v]=p.raw,s=s||p.hasExcludedProperties,o.push(...p.restricted)}else{const p=u[v],T=p?typeof p.scope<"u"?p.scope:3:void 0;p?.restricted&&o.push(v),(T===void 0||n.scopes===void 0||n.scopes.includes(T))&&!(n.skipRestricted&&p?.restricted)?a[v]=t[v]:s=!0}return{raw:a,restricted:o,hasExcludedProperties:s}}toOverrides(t,u){const i=[];for(const n of Object.keys(t))if(E.OVERRIDE_PROPERTY_REGEX.test(n)){const s={};for(const a in t[n])s[a]=t[n][a];i.push({identifiers:(0,E.overrideIdentifiersFromKey)(n),keys:Object.keys(s),contents:(0,O.toValuesTree)(s,u)})}return i}}e.ConfigurationModelParser=f;class c extends M.Disposable{constructor(t,u,i,n){super(),this.userSettingsResource=t,this.scopes=u,this.fileService=n,this._onDidChange=this._register(new y.Emitter),this.onDidChange=this._onDidChange.event,this.parser=new f(this.userSettingsResource.toString()),this.parseOptions={scopes:this.scopes},this._register(this.fileService.watch(i.dirname(this.userSettingsResource))),this._register(this.fileService.watch(this.userSettingsResource)),this._register(y.Event.any(y.Event.filter(this.fileService.onDidFilesChange,s=>s.contains(this.userSettingsResource)),y.Event.filter(this.fileService.onDidRunOperation,s=>(s.isOperation(0)||s.isOperation(3)||s.isOperation(1)||s.isOperation(4))&&i.isEqual(s.resource,t)))(()=>this._onDidChange.fire()))}async loadConfiguration(){try{const t=await this.fileService.readFile(this.userSettingsResource);return this.parser.parse(t.value.toString()||"{}",this.parseOptions),this.parser.configurationModel}catch{return new k}}reparse(){return this.parser.reparse(this.parseOptions),this.parser.configurationModel}getRestrictedSettings(){return this.parser.restrictedConfigurations}}e.UserSettings=c;class d{constructor(t,u,i,n,s=new k,a=new k,o=new _.ResourceMap,v=new k,p=new _.ResourceMap,T=!0){this._defaultConfiguration=t,this._policyConfiguration=u,this._applicationConfiguration=i,this._localUserConfiguration=n,this._remoteUserConfiguration=s,this._workspaceConfiguration=a,this._folderConfigurations=o,this._memoryConfiguration=v,this._memoryConfigurationByResource=p,this._freeze=T,this._workspaceConsolidatedConfiguration=null,this._foldersConsolidatedConfigurations=new _.ResourceMap,this._userConfiguration=null}getValue(t,u,i){return this.getConsolidatedConfigurationModel(t,u,i).getValue(t)}updateValue(t,u,i={}){let n;i.resource?(n=this._memoryConfigurationByResource.get(i.resource),n||(n=new k,this._memoryConfigurationByResource.set(i.resource,n))):n=this._memoryConfiguration,u===void 0?n.removeValue(t):n.setValue(t,u),i.resource||(this._workspaceConsolidatedConfiguration=null)}inspect(t,u,i){const n=this.getConsolidatedConfigurationModel(t,u,i),s=this.getFolderConfigurationModelForResource(u.resource,i),a=u.resource?this._memoryConfigurationByResource.get(u.resource)||this._memoryConfiguration:this._memoryConfiguration,o=this._defaultConfiguration.inspect(t,u.overrideIdentifier),v=this._policyConfiguration.isEmpty()?void 0:this._policyConfiguration.freeze().inspect(t),p=this.applicationConfiguration.isEmpty()?void 0:this.applicationConfiguration.freeze().inspect(t),T=this.userConfiguration.freeze().inspect(t,u.overrideIdentifier),N=this.localUserConfiguration.freeze().inspect(t,u.overrideIdentifier),V=this.remoteUserConfiguration.freeze().inspect(t,u.overrideIdentifier),B=i?this._workspaceConfiguration.freeze().inspect(t,u.overrideIdentifier):void 0,D=s?s.freeze().inspect(t,u.overrideIdentifier):void 0,z=a.inspect(t,u.overrideIdentifier),L=n.getValue(t),R=r.distinct(n.overrides.map(K=>K.identifiers).flat()).filter(K=>n.getOverrideValue(t,K)!==void 0);return{defaultValue:o?o.merged:void 0,policyValue:v?v.merged:void 0,applicationValue:p?p.merged:void 0,userValue:T?T.merged:void 0,userLocalValue:N?N.merged:void 0,userRemoteValue:V?V.merged:void 0,workspaceValue:B?B.merged:void 0,workspaceFolderValue:D?D.merged:void 0,memoryValue:z?z.merged:void 0,value:L,default:o.value!==void 0||o.override!==void 0?{value:o.value,override:o.override}:void 0,policy:v?.value!==void 0?{value:v.value}:void 0,application:p?.value!==void 0||p?.override!==void 0?{value:p.value,override:p.override}:void 0,user:T.value!==void 0||T.override!==void 0?{value:T.value,override:T.override}:void 0,userLocal:N.value!==void 0||N.override!==void 0?{value:N.value,override:N.override}:void 0,userRemote:V.value!==void 0||V.override!==void 0?{value:V.value,override:V.override}:void 0,workspace:B?.value!==void 0||B?.override!==void 0?{value:B.value,override:B.override}:void 0,workspaceFolder:D?.value!==void 0||D?.override!==void 0?{value:D.value,override:D.override}:void 0,memory:z.value!==void 0||z.override!==void 0?{value:z.value,override:z.override}:void 0,overrideIdentifiers:R.length?R:void 0}}keys(t){const u=this.getFolderConfigurationModelForResource(void 0,t);return{default:this._defaultConfiguration.freeze().keys,user:this.userConfiguration.freeze().keys,workspace:this._workspaceConfiguration.freeze().keys,workspaceFolder:u?u.freeze().keys:[]}}updateDefaultConfiguration(t){this._defaultConfiguration=t,this._workspaceConsolidatedConfiguration=null,this._foldersConsolidatedConfigurations.clear()}updatePolicyConfiguration(t){this._policyConfiguration=t}updateApplicationConfiguration(t){this._applicationConfiguration=t,this._workspaceConsolidatedConfiguration=null,this._foldersConsolidatedConfigurations.clear()}updateLocalUserConfiguration(t){this._localUserConfiguration=t,this._userConfiguration=null,this._workspaceConsolidatedConfiguration=null,this._foldersConsolidatedConfigurations.clear()}updateRemoteUserConfiguration(t){this._remoteUserConfiguration=t,this._userConfiguration=null,this._workspaceConsolidatedConfiguration=null,this._foldersConsolidatedConfigurations.clear()}updateWorkspaceConfiguration(t){this._workspaceConfiguration=t,this._workspaceConsolidatedConfiguration=null,this._foldersConsolidatedConfigurations.clear()}updateFolderConfiguration(t,u){this._folderConfigurations.set(t,u),this._foldersConsolidatedConfigurations.delete(t)}deleteFolderConfiguration(t){this.folderConfigurations.delete(t),this._foldersConsolidatedConfigurations.delete(t)}compareAndUpdateDefaultConfiguration(t,u){const i=[];if(!u){const{added:n,updated:s,removed:a}=C(this._defaultConfiguration,t);u=[...n,...s,...a]}for(const n of u)for(const s of(0,E.overrideIdentifiersFromKey)(n)){const a=this._defaultConfiguration.getKeysForOverrideIdentifier(s),o=t.getKeysForOverrideIdentifier(s),v=[...o.filter(p=>a.indexOf(p)===-1),...a.filter(p=>o.indexOf(p)===-1),...a.filter(p=>!A.equals(this._defaultConfiguration.override(s).getValue(p),t.override(s).getValue(p)))];i.push([s,v])}return this.updateDefaultConfiguration(t),{keys:u,overrides:i}}compareAndUpdatePolicyConfiguration(t){const{added:u,updated:i,removed:n}=C(this._policyConfiguration,t),s=[...u,...i,...n];return s.length&&this.updatePolicyConfiguration(t),{keys:s,overrides:[]}}compareAndUpdateApplicationConfiguration(t){const{added:u,updated:i,removed:n,overrides:s}=C(this.applicationConfiguration,t),a=[...u,...i,...n];return a.length&&this.updateApplicationConfiguration(t),{keys:a,overrides:s}}compareAndUpdateLocalUserConfiguration(t){const{added:u,updated:i,removed:n,overrides:s}=C(this.localUserConfiguration,t),a=[...u,...i,...n];return a.length&&this.updateLocalUserConfiguration(t),{keys:a,overrides:s}}compareAndUpdateRemoteUserConfiguration(t){const{added:u,updated:i,removed:n,overrides:s}=C(this.remoteUserConfiguration,t),a=[...u,...i,...n];return a.length&&this.updateRemoteUserConfiguration(t),{keys:a,overrides:s}}compareAndUpdateWorkspaceConfiguration(t){const{added:u,updated:i,removed:n,overrides:s}=C(this.workspaceConfiguration,t),a=[...u,...i,...n];return a.length&&this.updateWorkspaceConfiguration(t),{keys:a,overrides:s}}compareAndUpdateFolderConfiguration(t,u){const i=this.folderConfigurations.get(t),{added:n,updated:s,removed:a,overrides:o}=C(i,u),v=[...n,...s,...a];return(v.length||!i)&&this.updateFolderConfiguration(t,u),{keys:v,overrides:o}}compareAndDeleteFolderConfiguration(t){const u=this.folderConfigurations.get(t);if(!u)throw new Error("Unknown folder");this.deleteFolderConfiguration(t);const{added:i,updated:n,removed:s,overrides:a}=C(u,void 0);return{keys:[...i,...n,...s],overrides:a}}get defaults(){return this._defaultConfiguration}get applicationConfiguration(){return this._applicationConfiguration}get userConfiguration(){return this._userConfiguration||(this._userConfiguration=this._remoteUserConfiguration.isEmpty()?this._localUserConfiguration:this._localUserConfiguration.merge(this._remoteUserConfiguration),this._freeze&&this._userConfiguration.freeze()),this._userConfiguration}get localUserConfiguration(){return this._localUserConfiguration}get remoteUserConfiguration(){return this._remoteUserConfiguration}get workspaceConfiguration(){return this._workspaceConfiguration}get folderConfigurations(){return this._folderConfigurations}getConsolidatedConfigurationModel(t,u,i){let n=this.getConsolidatedConfigurationModelForResource(u,i);return u.overrideIdentifier&&(n=n.override(u.overrideIdentifier)),!this._policyConfiguration.isEmpty()&&this._policyConfiguration.getValue(t)!==void 0&&(n=n.merge(this._policyConfiguration)),n}getConsolidatedConfigurationModelForResource({resource:t},u){let i=this.getWorkspaceConsolidatedConfiguration();if(u&&t){const n=u.getFolder(t);n&&(i=this.getFolderConsolidatedConfiguration(n.uri)||i);const s=this._memoryConfigurationByResource.get(t);s&&(i=i.merge(s))}return i}getWorkspaceConsolidatedConfiguration(){return this._workspaceConsolidatedConfiguration||(this._workspaceConsolidatedConfiguration=this._defaultConfiguration.merge(this.applicationConfiguration,this.userConfiguration,this._workspaceConfiguration,this._memoryConfiguration),this._freeze&&(this._workspaceConfiguration=this._workspaceConfiguration.freeze())),this._workspaceConsolidatedConfiguration}getFolderConsolidatedConfiguration(t){let u=this._foldersConsolidatedConfigurations.get(t);if(!u){const i=this.getWorkspaceConsolidatedConfiguration(),n=this._folderConfigurations.get(t);n?(u=i.merge(n),this._freeze&&(u=u.freeze()),this._foldersConsolidatedConfigurations.set(t,u)):u=i}return u}getFolderConfigurationModelForResource(t,u){if(u&&t){const i=u.getFolder(t);if(i)return this._folderConfigurations.get(i.uri)}}toData(){return{defaults:{contents:this._defaultConfiguration.contents,overrides:this._defaultConfiguration.overrides,keys:this._defaultConfiguration.keys},policy:{contents:this._policyConfiguration.contents,overrides:this._policyConfiguration.overrides,keys:this._policyConfiguration.keys},application:{contents:this.applicationConfiguration.contents,overrides:this.applicationConfiguration.overrides,keys:this.applicationConfiguration.keys},user:{contents:this.userConfiguration.contents,overrides:this.userConfiguration.overrides,keys:this.userConfiguration.keys},workspace:{contents:this._workspaceConfiguration.contents,overrides:this._workspaceConfiguration.overrides,keys:this._workspaceConfiguration.keys},folders:[...this._folderConfigurations.keys()].reduce((t,u)=>{const{contents:i,overrides:n,keys:s}=this._folderConfigurations.get(u);return t.push([u,{contents:i,overrides:n,keys:s}]),t},[])}}allKeys(){const t=new Set;return this._defaultConfiguration.freeze().keys.forEach(u=>t.add(u)),this.userConfiguration.freeze().keys.forEach(u=>t.add(u)),this._workspaceConfiguration.freeze().keys.forEach(u=>t.add(u)),this._folderConfigurations.forEach(u=>u.freeze().keys.forEach(i=>t.add(i))),[...t.values()]}allOverrideIdentifiers(){const t=new Set;return this._defaultConfiguration.freeze().getAllOverrideIdentifiers().forEach(u=>t.add(u)),this.userConfiguration.freeze().getAllOverrideIdentifiers().forEach(u=>t.add(u)),this._workspaceConfiguration.freeze().getAllOverrideIdentifiers().forEach(u=>t.add(u)),this._folderConfigurations.forEach(u=>u.freeze().getAllOverrideIdentifiers().forEach(i=>t.add(i))),[...t.values()]}getAllKeysForOverrideIdentifier(t){const u=new Set;return this._defaultConfiguration.getKeysForOverrideIdentifier(t).forEach(i=>u.add(i)),this.userConfiguration.getKeysForOverrideIdentifier(t).forEach(i=>u.add(i)),this._workspaceConfiguration.getKeysForOverrideIdentifier(t).forEach(i=>u.add(i)),this._folderConfigurations.forEach(i=>i.getKeysForOverrideIdentifier(t).forEach(n=>u.add(n))),[...u.values()]}static parse(t){const u=this.parseConfigurationModel(t.defaults),i=this.parseConfigurationModel(t.policy),n=this.parseConfigurationModel(t.application),s=this.parseConfigurationModel(t.user),a=this.parseConfigurationModel(t.workspace),o=t.folders.reduce((v,p)=>(v.set(P.URI.revive(p[0]),this.parseConfigurationModel(p[1])),v),new _.ResourceMap);return new d(u,i,n,s,new k,a,o,new k,new _.ResourceMap,!1)}static parseConfigurationModel(t){return new k(t.contents,t.keys,t.overrides).freeze()}}e.Configuration=d;function h(...w){if(w.length===0)return{keys:[],overrides:[]};if(w.length===1)return w[0];const t=new Set,u=new Map;for(const n of w)n.keys.forEach(s=>t.add(s)),n.overrides.forEach(([s,a])=>{const o=(0,_.getOrSet)(u,s,new Set);a.forEach(v=>o.add(v))});const i=[];return u.forEach((n,s)=>i.push([s,[...n.values()]])),{keys:[...t.values()],overrides:i}}e.mergeChanges=h;class g{constructor(t,u,i,n){this.change=t,this.previous=u,this.currentConfiguraiton=i,this.currentWorkspace=n,this._previousConfiguration=void 0;const s=new Set;t.keys.forEach(o=>s.add(o)),t.overrides.forEach(([,o])=>o.forEach(v=>s.add(v))),this.affectedKeys=[...s.values()];const a=new k;this.affectedKeys.forEach(o=>a.setValue(o,{})),this.affectedKeysTree=a.contents}get previousConfiguration(){return!this._previousConfiguration&&this.previous&&(this._previousConfiguration=d.parse(this.previous.data)),this._previousConfiguration}affectsConfiguration(t,u){if(this.doesAffectedKeysTreeContains(this.affectedKeysTree,t)){if(u){const i=this.previousConfiguration?this.previousConfiguration.getValue(t,u,this.previous?.workspace):void 0,n=this.currentConfiguraiton.getValue(t,u,this.currentWorkspace);return!A.equals(i,n)}return!0}return!1}doesAffectedKeysTreeContains(t,u){let i=(0,O.toValuesTree)({[u]:!0},()=>{}),n;for(;typeof i=="object"&&(n=Object.keys(i)[0]);){if(t=t[n],!t)return!1;i=i[n]}return!0}}e.ConfigurationChangeEvent=g;function C(w,t){const{added:u,removed:i,updated:n}=l(t,w),s=[],a=w?.getAllOverrideIdentifiers()||[],o=t?.getAllOverrideIdentifiers()||[];if(t){const v=o.filter(p=>!a.includes(p));for(const p of v)s.push([p,t.getKeysForOverrideIdentifier(p)])}if(w){const v=a.filter(p=>!o.includes(p));for(const p of v)s.push([p,w.getKeysForOverrideIdentifier(p)])}if(t&&w){for(const v of a)if(o.includes(v)){const p=l({contents:w.getOverrideValue(void 0,v)||{},keys:w.getKeysForOverrideIdentifier(v)},{contents:t.getOverrideValue(void 0,v)||{},keys:t.getKeysForOverrideIdentifier(v)});s.push([v,[...p.added,...p.removed,...p.updated]])}}return{added:u,removed:i,updated:n,overrides:s}}function l(w,t){const u=w?t?w.keys.filter(s=>t.keys.indexOf(s)===-1):[...w.keys]:[],i=t?w?t.keys.filter(s=>w.keys.indexOf(s)===-1):[...t.keys]:[],n=[];if(w&&t){for(const s of t.keys)if(w.keys.indexOf(s)!==-1){const a=(0,O.getConfigurationValue)(t.contents,s),o=(0,O.getConfigurationValue)(w.contents,s);A.equals(a,o)||n.push(s)}}return{added:u,removed:i,updated:n}}}),define(Ce[86],Ie([1,0,12,3]),function(ie,e,r,y){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.RemoteAuthorityResolverError=e.RemoteAuthorityResolverErrorCode=e.IRemoteAuthorityResolverService=void 0,e.IRemoteAuthorityResolverService=(0,y.createDecorator)("remoteAuthorityResolverService");var S;(function(_){_.Unknown="Unknown",_.NotAvailable="NotAvailable",_.TemporarilyNotAvailable="TemporarilyNotAvailable",_.NoResolverFound="NoResolverFound"})(S=e.RemoteAuthorityResolverErrorCode||(e.RemoteAuthorityResolverErrorCode={}));class M extends r.ErrorNoTelemetry{static isTemporarilyNotAvailable(A){return A instanceof M&&A._code===S.TemporarilyNotAvailable}static isNoResolverFound(A){return A instanceof M&&A._code===S.NoResolverFound}static isHandled(A){return A instanceof M&&A.isHandled}constructor(A,b=S.Unknown,P){super(A),this._message=A,this._code=b,this._detail=P,this.isHandled=b===S.NotAvailable&&P===!0,typeof Object.setPrototypeOf=="function"&&Object.setPrototypeOf(this,M.prototype)}}e.RemoteAuthorityResolverError=M}),define(Ce[87],Ie([1,0,13]),function(ie,e,r){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.parseAuthorityWithOptionalPort=e.parseAuthorityWithPort=e.getRemoteServerRootPath=e.getRemoteName=e.getRemoteAuthority=void 0;function y(P){return P.scheme===r.Schemas.vscodeRemote?P.authority:void 0}e.getRemoteAuthority=y;function S(P){if(!P)return;const O=P.indexOf("+");return O<0?P:P.substr(0,O)}e.getRemoteName=S;function M(P){return`/${P.quality??"oss"}-${P.commit??"dev"}`}e.getRemoteServerRootPath=M;function _(P){const{host:O,port:E}=b(P);if(typeof E>"u")throw new Error("Remote authority doesn't contain a port!");return{host:O,port:E}}e.parseAuthorityWithPort=_;function A(P,O){let{host:E,port:m}=b(P);return typeof m>"u"&&(m=O),{host:E,port:m}}e.parseAuthorityWithOptionalPort=A;function b(P){const O=P.match(/^(\[[0-9a-z:]+\]):(\d+)$/);if(O)return{host:O[1],port:parseInt(O[2],10)};const E=P.match(/^(\[[0-9a-z:]+\])$/);if(E)return{host:E[1],port:void 0};const m=P.match(/(.*):(\d+)$/);return m?{host:m[1],port:parseInt(m[2],10)}:{host:P,port:void 0}}}),define(Ce[27],Ie([1,0,9,3,87]),function(ie,e,r,y,S){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.IBuiltinExtensionsScannerService=e.isResolverExtension=e.isAuthenticationProviderExtension=e.isLanguagePackExtension=e.isApplicationScopedExtension=e.ExtensionIdentifier=e.TargetPlatform=e.ExtensionType=e.EXTENSION_CATEGORIES=e.isIExtensionIdentifier=e.getWorkspaceSupportTypeMessage=e.ALL_EXTENSION_KINDS=e.UNDEFINED_PUBLISHER=e.BUILTIN_MANIFEST_CACHE_FILE=e.USER_MANIFEST_CACHE_FILE=e.MANIFEST_CACHE_FOLDER=void 0,e.MANIFEST_CACHE_FOLDER="CachedExtensions",e.USER_MANIFEST_CACHE_FILE="user",e.BUILTIN_MANIFEST_CACHE_FILE="builtin",e.UNDEFINED_PUBLISHER="undefined_publisher",e.ALL_EXTENSION_KINDS=["ui","workspace","web"];function M(f){if(typeof f=="object"&&f!==null&&f.supported!==!0)return f.description}e.getWorkspaceSupportTypeMessage=M;function _(f){return f&&typeof f=="object"&&typeof f.id=="string"&&(!f.uuid||typeof f.uuid=="string")}e.isIExtensionIdentifier=_,e.EXTENSION_CATEGORIES=["Azure","Data Science","Debuggers","Extension Packs","Education","Formatters","Keymaps","Language Packs","Linters","Machine Learning","Notebooks","Programming Languages","SCM Providers","Snippets","Testing","Themes","Visualization","Other"];var A;(function(f){f[f.System=0]="System",f[f.User=1]="User"})(A=e.ExtensionType||(e.ExtensionType={}));var b;(function(f){f.WIN32_X64="win32-x64",f.WIN32_IA32="win32-ia32",f.WIN32_ARM64="win32-arm64",f.LINUX_X64="linux-x64",f.LINUX_ARM64="linux-arm64",f.LINUX_ARMHF="linux-armhf",f.ALPINE_X64="alpine-x64",f.ALPINE_ARM64="alpine-arm64",f.DARWIN_X64="darwin-x64",f.DARWIN_ARM64="darwin-arm64",f.WEB="web",f.UNIVERSAL="universal",f.UNKNOWN="unknown",f.UNDEFINED="undefined"})(b=e.TargetPlatform||(e.TargetPlatform={}));class P{constructor(c){this.value=c,this._lower=c.toLowerCase()}static equals(c,d){if(typeof c>"u"||c===null)return typeof d>"u"||d===null;if(typeof d>"u"||d===null)return!1;if(typeof c=="string"||typeof d=="string"){const h=typeof c=="string"?c:c.value,g=typeof d=="string"?d:d.value;return r.equalsIgnoreCase(h,g)}return c._lower===d._lower}static toKey(c){return typeof c=="string"?c.toLowerCase():c._lower}}e.ExtensionIdentifier=P;function O(f){return E(f)}e.isApplicationScopedExtension=O;function E(f){return f.contributes&&f.contributes.localizations?f.contributes.localizations.length>0:!1}e.isLanguagePackExtension=E;function m(f){return f.contributes&&f.contributes.authentication?f.contributes.authentication.length>0:!1}e.isAuthenticationProviderExtension=m;function k(f,c){if(c){const d=`onResolveRemoteAuthority:${(0,S.getRemoteName)(c)}`;return f.activationEvents?.indexOf(d)!==-1}return!1}e.isResolverExtension=k,e.IBuiltinExtensionsScannerService=(0,y.createDecorator)("IBuiltinExtensionsScannerService")}),define(Ce[153],Ie([1,0,9,81,27,21,2,12,59]),function(ie,e,r,y,S,M,_,A,b){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.computeTargetPlatform=e.isAlpineLinux=e.getExtensionDependencies=e.BetterMergeId=e.getGalleryExtensionTelemetryData=e.getLocalExtensionTelemetryData=e.groupByExtension=e.getGalleryExtensionId=e.adoptToGalleryExtensionId=e.getExtensionId=e.getIdAndVersion=e.ExtensionKey=e.areSameExtensions=void 0;function P(u,i){return u.uuid&&i.uuid?u.uuid===i.uuid:u.id===i.id?!0:(0,r.compareIgnoreCase)(u.id,i.id)===0}e.areSameExtensions=P;const O=/^([^.]+\..+)-(\d+\.\d+\.\d+)(-(.+))?$/;class E{static create(i){const n=i.manifest?i.manifest.version:i.version,s=i.manifest?i.targetPlatform:i.properties.targetPlatform;return new E(i.identifier,n,s)}static parse(i){const n=O.exec(i);return n&&n[1]&&n[2]?new E({id:n[1]},n[2],n[4]||void 0):null}constructor(i,n,s="undefined"){this.version=n,this.targetPlatform=s,this.id=i.id}toString(){return`${this.id}-${this.version}${this.targetPlatform!=="undefined"?`-${this.targetPlatform}`:""}`}equals(i){return i instanceof E?P(this,i)&&this.version===i.version&&this.targetPlatform===i.targetPlatform:!1}}e.ExtensionKey=E;const m=/^([^.]+\..+)@((prerelease)|(\d+\.\d+\.\d+(-.*)?))$/;function k(u){const i=m.exec(u);return i&&i[1]?[c(i[1]),i[2]]:[c(u),void 0]}e.getIdAndVersion=k;function f(u,i){return`${u}.${i}`}e.getExtensionId=f;function c(u){return u.toLocaleLowerCase()}e.adoptToGalleryExtensionId=c;function d(u,i){return c(f(u,i))}e.getGalleryExtensionId=d;function h(u,i){const n=[],s=a=>{for(const o of n)if(o.some(v=>P(i(v),i(a))))return o;return null};for(const a of u){const o=s(a);o?o.push(a):n.push([a])}return n}e.groupByExtension=h;function g(u){return{id:u.identifier.id,name:u.manifest.name,galleryId:null,publisherId:u.publisherId,publisherName:u.manifest.publisher,publisherDisplayName:u.publisherDisplayName,dependencies:u.manifest.extensionDependencies&&u.manifest.extensionDependencies.length>0}}e.getLocalExtensionTelemetryData=g;function C(u){return{id:u.identifier.id,name:u.name,galleryId:u.identifier.uuid,publisherId:u.publisherId,publisherName:u.publisher,publisherDisplayName:u.publisherDisplayName,isPreReleaseVersion:u.properties.isPreReleaseVersion,dependencies:!!(u.properties.dependencies&&u.properties.dependencies.length>0),...u.telemetryData}}e.getGalleryExtensionTelemetryData=C,e.BetterMergeId=new S.ExtensionIdentifier("pprice.better-merge");function l(u,i){const n=[],s=i.manifest.extensionDependencies?.slice(0)??[];for(;s.length;){const a=s.shift();if(a&&n.every(o=>!P(o.identifier,{id:a}))){const o=u.filter(v=>P(v.identifier,{id:a}));o.length===1&&(n.push(o[0]),s.push(...o[0].manifest.extensionDependencies?.slice(0)??[]))}}return n}e.getExtensionDependencies=l;async function w(u,i){if(!M.isLinux)return!1;let n;try{n=(await u.readFile(_.URI.file("/etc/os-release"))).value.toString()}catch{try{n=(await u.readFile(_.URI.file("/usr/lib/os-release"))).value.toString()}catch(a){i.debug("Error while getting the os-release file.",(0,A.getErrorMessage)(a))}}return!!n&&(n.match(/^ID=([^\u001b\r\n]*)/m)||[])[1]==="alpine"}e.isAlpineLinux=w;async function t(u,i){const n=await w(u,i),s=(0,y.getTargetPlatform)(n?"alpine":M.platform,b.arch);return i.debug("ComputeTargetPlatform:",s),s}e.computeTargetPlatform=t}),define(Ce[154],Ie([1,0]),function(ie,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.TerminalDataBufferer=void 0;class r{constructor(S){this._callback=S,this._terminalBufferMap=new Map}dispose(){for(const S of this._terminalBufferMap.values())S.dispose()}startBuffering(S,M,_=5){const A=M(b=>{const P=typeof b=="string"?b:b.data;let O=this._terminalBufferMap.get(S);if(O){O.data.push(P);return}const E=setTimeout(()=>this.flushBuffer(S),_);O={data:[P],timeoutId:E,dispose:()=>{clearTimeout(E),this.flushBuffer(S),A.dispose()}},this._terminalBufferMap.set(S,O)});return A}stopBuffering(S){this._terminalBufferMap.get(S)?.dispose()}flushBuffer(S){const M=this._terminalBufferMap.get(S);M&&(this._terminalBufferMap.delete(S),this._callback(S,M.data.join("")))}}e.TerminalDataBufferer=r}),define(Ce[155],Ie([1,0]),function(ie,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.isDark=e.isHighContrast=e.ColorScheme=void 0;var r;(function(M){M.DARK="dark",M.LIGHT="light",M.HIGH_CONTRAST_DARK="hcDark",M.HIGH_CONTRAST_LIGHT="hcLight"})(r=e.ColorScheme||(e.ColorScheme={}));function y(M){return M===r.HIGH_CONTRAST_DARK||M===r.HIGH_CONTRAST_LIGHT}e.isHighContrast=y;function S(M){return M===r.DARK||M===r.HIGH_CONTRAST_DARK}e.isDark=S}),define(Ce[60],Ie([1,0,117,5,7,3,30,155]),function(ie,e,r,y,S,M,_,A){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.Themable=e.registerThemingParticipant=e.Extensions=e.getThemeTypeSelector=e.FolderThemeIcon=e.FileThemeIcon=e.ThemeIcon=e.themeColorFromId=e.ThemeColor=e.IThemeService=void 0,e.IThemeService=(0,M.createDecorator)("themeService");var b;(function(d){function h(g){return g&&typeof g=="object"&&typeof g.id=="string"}d.isThemeColor=h})(b=e.ThemeColor||(e.ThemeColor={}));function P(d){return{id:d}}e.themeColorFromId=P;var O;(function(d){function h(n){return n&&typeof n=="object"&&typeof n.id=="string"&&(typeof n.color>"u"||b.isThemeColor(n.color))}d.isThemeIcon=h;const g=new RegExp(`^\\$\\((${r.CSSIcon.iconNameExpression}(?:${r.CSSIcon.iconModifierExpression})?)\\)$`);function C(n){const s=g.exec(n);if(!s)return;const[,a]=s;return{id:a}}d.fromString=C;function l(n){return{id:n}}d.fromId=l;function w(n,s){let a=n.id;const o=a.lastIndexOf("~");return o!==-1&&(a=a.substring(0,o)),s&&(a=`${a}~${s}`),{id:a}}d.modify=w;function t(n){const s=n.id.lastIndexOf("~");if(s!==-1)return n.id.substring(s+1)}d.getModifier=t;function u(n,s){return n.id===s.id&&n.color?.id===s.color?.id}d.isEqual=u;function i(n,s){return{id:n.id,color:s?P(s):void 0}}d.asThemeIcon=i,d.asClassNameArray=r.CSSIcon.asClassNameArray,d.asClassName=r.CSSIcon.asClassName,d.asCSSSelector=r.CSSIcon.asCSSSelector})(O=e.ThemeIcon||(e.ThemeIcon={})),e.FileThemeIcon=r.Codicon.file,e.FolderThemeIcon=r.Codicon.folder;function E(d){switch(d){case A.ColorScheme.DARK:return"vs-dark";case A.ColorScheme.HIGH_CONTRAST_DARK:return"hc-black";case A.ColorScheme.HIGH_CONTRAST_LIGHT:return"hc-light";default:return"vs"}}e.getThemeTypeSelector=E,e.Extensions={ThemingContribution:"base.contributions.theming"};class m{constructor(){this.themingParticipants=[],this.themingParticipants=[],this.onThemingParticipantAddedEmitter=new y.Emitter}onColorThemeChange(h){return this.themingParticipants.push(h),this.onThemingParticipantAddedEmitter.fire(h),(0,S.toDisposable)(()=>{const g=this.themingParticipants.indexOf(h);this.themingParticipants.splice(g,1)})}get onThemingParticipantAdded(){return this.onThemingParticipantAddedEmitter.event}getThemingParticipants(){return this.themingParticipants}}const k=new m;_.Registry.add(e.Extensions.ThemingContribution,k);function f(d){return k.onColorThemeChange(d)}e.registerThemingParticipant=f;class c extends S.Disposable{constructor(h){super(),this.themeService=h,this.theme=h.getColorTheme(),this._register(this.themeService.onDidColorThemeChange(g=>this.onThemeChange(g)))}onThemeChange(h){this.theme=h,this.updateStyles()}updateStyles(){}getColor(h,g){let C=this.theme.getColor(h);return C&&g&&(C=g(C,this.theme)),C?C.toString():null}}e.Themable=c}),define(Ce[156],Ie([1,0,5,21,3,14]),function(ie,e,r,y,S,M){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.AbstractTunnelService=e.DisposableTunnel=e.isPortPrivileged=e.isAllInterfaces=e.ALL_INTERFACES_ADDRESSES=e.isLocalhost=e.LOCALHOST_ADDRESSES=e.extractLocalHostUriMetaDataForPortMapping=e.ProvidedOnAutoForward=e.TunnelPrivacyId=e.TunnelProtocol=e.ISharedTunnelsService=e.ITunnelService=void 0,e.ITunnelService=(0,S.createDecorator)("tunnelService"),e.ISharedTunnelsService=(0,S.createDecorator)("sharedTunnelsService");var _;(function(c){c.Http="http",c.Https="https"})(_=e.TunnelProtocol||(e.TunnelProtocol={}));var A;(function(c){c.ConstantPrivate="constantPrivate",c.Private="private",c.Public="public"})(A=e.TunnelPrivacyId||(e.TunnelPrivacyId={}));var b;(function(c){c[c.Notify=1]="Notify",c[c.OpenBrowser=2]="OpenBrowser",c[c.OpenPreview=3]="OpenPreview",c[c.Silent=4]="Silent",c[c.Ignore=5]="Ignore",c[c.OpenBrowserOnce=6]="OpenBrowserOnce"})(b=e.ProvidedOnAutoForward||(e.ProvidedOnAutoForward={}));function P(c){if(c.scheme!=="http"&&c.scheme!=="https")return;const d=/^(localhost|127\.0\.0\.1|0\.0\.0\.0):(\d+)$/.exec(c.authority);if(!!d)return{address:d[1],port:+d[2]}}e.extractLocalHostUriMetaDataForPortMapping=P,e.LOCALHOST_ADDRESSES=["localhost","127.0.0.1","0:0:0:0:0:0:0:1","::1"];function O(c){return e.LOCALHOST_ADDRESSES.indexOf(c)>=0}e.isLocalhost=O,e.ALL_INTERFACES_ADDRESSES=["0.0.0.0","0:0:0:0:0:0:0:0","::"];function E(c){return e.ALL_INTERFACES_ADDRESSES.indexOf(c)>=0}e.isAllInterfaces=E;function m(c,d){return d?d!==1&&c<1024:!y.isWindows&&c<1024}e.isPortPrivileged=m;class k{constructor(d,h,g){this.remoteAddress=d,this.localAddress=h,this._dispose=g,this._onDispose=new r.Emitter,this.onDidDispose=this._onDispose.event}dispose(){return this._onDispose.fire(),this._dispose()}}e.DisposableTunnel=k;let f=class{constructor(d){this.logService=d,this._onTunnelOpened=new r.Emitter,this.onTunnelOpened=this._onTunnelOpened.event,this._onTunnelClosed=new r.Emitter,this.onTunnelClosed=this._onTunnelClosed.event,this._onAddedTunnelProvider=new r.Emitter,this.onAddedTunnelProvider=this._onAddedTunnelProvider.event,this._tunnels=new Map,this._canElevate=!1,this._privacyOptions=[],this._factoryInProgress=new Set}get hasTunnelProvider(){return!!this._tunnelProvider}setTunnelProvider(d){return this._tunnelProvider=d,d?(this._onAddedTunnelProvider.fire(),{dispose:()=>{this._tunnelProvider=void 0,this._canElevate=!1,this._privacyOptions=[]}}):(this._canElevate=!1,this._privacyOptions=[],this._onAddedTunnelProvider.fire(),{dispose:()=>{}})}setTunnelFeatures(d){this._canElevate=d.elevation,this._privacyOptions=d.privacyOptions}get canElevate(){return this._canElevate}get canChangePrivacy(){return this._privacyOptions.length>0}get privacyOptions(){return this._privacyOptions}get tunnels(){return this.getTunnels()}async getTunnels(){const d=[],h=Array.from(this._tunnels.values());for(const g of h){const C=Array.from(g.values());for(const l of C){const w=await l.value;w&&d.push(w)}}return d}async dispose(){for(const d of this._tunnels.values()){for(const{value:h}of d.values())await h.then(g=>g?.dispose());d.clear()}this._tunnels.clear()}openTunnel(d,h,g,C,l=!1,w,t){if(this.logService.trace(`ForwardedPorts: (TunnelService) openTunnel request for ${h}:${g} on local port ${C}.`),!d)return;if(h||(h="localhost"),this._tunnelProvider&&this._factoryInProgress.has(g)){this.logService.debug("ForwardedPorts: (TunnelService) Another call to create a tunnel with the same address has occurred before the last one completed. This call will be ignored.");return}const u=this.retainOrCreateTunnel(d,h,g,C,l,w,t);return u?u.then(i=>{if(!i){this.logService.trace("ForwardedPorts: (TunnelService) New tunnel is undefined."),this.removeEmptyTunnelFromMap(h,g);return}this.logService.trace("ForwardedPorts: (TunnelService) New tunnel established.");const n=this.makeTunnel(i);return(i.tunnelRemoteHost!==h||i.tunnelRemotePort!==g)&&this.logService.warn("ForwardedPorts: (TunnelService) Created tunnel does not match requirements of requested tunnel. Host or port mismatch."),this._onTunnelOpened.fire(n),n}):(this.logService.trace("ForwardedPorts: (TunnelService) Tunnel was not created."),u)}makeTunnel(d){return{tunnelRemotePort:d.tunnelRemotePort,tunnelRemoteHost:d.tunnelRemoteHost,tunnelLocalPort:d.tunnelLocalPort,localAddress:d.localAddress,privacy:d.privacy,protocol:d.protocol,dispose:async()=>{this.logService.trace(`ForwardedPorts: (TunnelService) dispose request for ${d.tunnelRemoteHost}:${d.tunnelRemotePort} `);const h=this._tunnels.get(d.tunnelRemoteHost);if(h){const g=h.get(d.tunnelRemotePort);g&&(g.refcount--,await this.tryDisposeTunnel(d.tunnelRemoteHost,d.tunnelRemotePort,g))}}}}async tryDisposeTunnel(d,h,g){if(g.refcount<=0){this.logService.trace(`ForwardedPorts: (TunnelService) Tunnel is being disposed ${d}:${h}.`);const C=g.value.then(async l=>{l&&(await l.dispose(!0),this._onTunnelClosed.fire({host:l.tunnelRemoteHost,port:l.tunnelRemotePort}))});return this._tunnels.has(d)&&this._tunnels.get(d).delete(h),C}}async closeTunnel(d,h){this.logService.trace(`ForwardedPorts: (TunnelService) close request for ${d}:${h} `);const g=this._tunnels.get(d);if(g&&g.has(h)){const C=g.get(h);C.refcount=0,await this.tryDisposeTunnel(d,h,C)}}addTunnelToMap(d,h,g){this._tunnels.has(d)||this._tunnels.set(d,new Map),this._tunnels.get(d).set(h,{refcount:1,value:g})}async removeEmptyTunnelFromMap(d,h){const g=this._tunnels.get(d);g&&(await g.get(h)||g.delete(h),g.size===0&&this._tunnels.delete(d))}getTunnelFromMap(d,h){const g=[d];O(d)?(g.push(...e.LOCALHOST_ADDRESSES),g.push(...e.ALL_INTERFACES_ADDRESSES)):E(d)&&g.push(...e.ALL_INTERFACES_ADDRESSES);const C=g.map(l=>this._tunnels.get(l));for(const l of C){const w=l?.get(h);if(w)return w}}canTunnel(d){return!!P(d)}createWithProvider(d,h,g,C,l,w,t){this.logService.trace(`ForwardedPorts: (TunnelService) Creating tunnel with provider ${h}:${g} on local port ${C}.`);const u=g;this._factoryInProgress.add(u);const n={elevationRequired:l?m(C===void 0?g:C):!1},s={remoteAddress:{host:h,port:g},localAddressPort:C,privacy:w,public:w?w!==A.Private:void 0,protocol:t},a=d.forwardPort(s,n);return a?(this.addTunnelToMap(h,g,a),a.finally(()=>{this.logService.trace("ForwardedPorts: (TunnelService) Tunnel created by provider."),this._factoryInProgress.delete(u)})):this._factoryInProgress.delete(u),a}};f=ze([$e(0,M.ILogService)],f),e.AbstractTunnelService=f}),define(Ce[157],Ie([1,0,13]),function(ie,e,r){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.isVirtualWorkspace=e.getVirtualWorkspaceAuthority=e.getVirtualWorkspaceScheme=e.getVirtualWorkspaceLocation=e.isVirtualResource=void 0;function y(b){return b.scheme!==r.Schemas.file&&b.scheme!==r.Schemas.vscodeRemote}e.isVirtualResource=y;function S(b){if(b.folders.length)return b.folders.every(P=>y(P.uri))?b.folders[0].uri:void 0;if(b.configuration&&y(b.configuration))return b.configuration}e.getVirtualWorkspaceLocation=S;function M(b){return S(b)?.scheme}e.getVirtualWorkspaceScheme=M;function _(b){return S(b)?.authority}e.getVirtualWorkspaceAuthority=_;function A(b){return S(b)!==void 0}e.isVirtualWorkspace=A}),define(Ce[45],Ie([1,0,129,19,24,22,2,3,13]),function(ie,e,r,y,S,M,_,A,b){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.hasWorkspaceFileExtension=e.isSavedWorkspace=e.isTemporaryWorkspace=e.isUntitledWorkspace=e.UNTITLED_WORKSPACE_NAME=e.WORKSPACE_FILTER=e.WORKSPACE_SUFFIX=e.WORKSPACE_EXTENSION=e.toWorkspaceFolder=e.WorkspaceFolder=e.Workspace=e.isWorkspaceFolder=e.isWorkspace=e.WorkbenchState=e.reviveIdentifier=e.isWorkspaceIdentifier=e.toWorkspaceIdentifier=e.EXTENSION_DEVELOPMENT_EMPTY_WINDOW_WORKSPACE=e.isSingleFolderWorkspaceIdentifier=e.IWorkspaceContextService=void 0,e.IWorkspaceContextService=(0,A.createDecorator)("contextService");function P(u){const i=u;return typeof i?.id=="string"&&_.URI.isUri(i.uri)}e.isSingleFolderWorkspaceIdentifier=P,e.EXTENSION_DEVELOPMENT_EMPTY_WINDOW_WORKSPACE={id:"ext-dev"};function O(u,i){if(typeof u=="string"||typeof u>"u")return typeof u=="string"?{id:(0,y.basename)(u)}:i?e.EXTENSION_DEVELOPMENT_EMPTY_WINDOW_WORKSPACE:void 0;const n=u;if(n.configuration)return{id:n.id,configPath:n.configuration};if(n.folders.length===1)return{id:n.id,uri:n.folders[0].uri}}e.toWorkspaceIdentifier=O;function E(u){const i=u;return typeof i?.id=="string"&&_.URI.isUri(i.configPath)}e.isWorkspaceIdentifier=E;function m(u){const i=u;if(i?.uri)return{id:i.id,uri:_.URI.revive(i.uri)};const n=u;if(n?.configPath)return{id:n.id,configPath:_.URI.revive(n.configPath)};if(u?.id)return{id:u.id}}e.reviveIdentifier=m;var k;(function(u){u[u.EMPTY=1]="EMPTY",u[u.FOLDER=2]="FOLDER",u[u.WORKSPACE=3]="WORKSPACE"})(k=e.WorkbenchState||(e.WorkbenchState={}));function f(u){const i=u;return!!(i&&typeof i=="object"&&typeof i.id=="string"&&Array.isArray(i.folders))}e.isWorkspace=f;function c(u){const i=u;return!!(i&&typeof i=="object"&&_.URI.isUri(i.uri)&&typeof i.name=="string"&&typeof i.toResource=="function")}e.isWorkspaceFolder=c;class d{constructor(i,n,s,a,o){this._id=i,this._transient=s,this._configuration=a,this._ignorePathCasing=o,this._foldersMap=S.TernarySearchTree.forUris(this._ignorePathCasing,()=>!0),this.folders=n}update(i){this._id=i.id,this._configuration=i.configuration,this._transient=i.transient,this._ignorePathCasing=i._ignorePathCasing,this.folders=i.folders}get folders(){return this._folders}set folders(i){this._folders=i,this.updateFoldersMap()}get id(){return this._id}get transient(){return this._transient}get configuration(){return this._configuration}set configuration(i){this._configuration=i}getFolder(i){return i&&this._foldersMap.findSubstr(i)||null}updateFoldersMap(){this._foldersMap=S.TernarySearchTree.forUris(this._ignorePathCasing,()=>!0);for(const i of this.folders)this._foldersMap.set(i.uri,i)}toJSON(){return{id:this.id,folders:this.folders,transient:this.transient,configuration:this.configuration}}}e.Workspace=d;class h{constructor(i,n){this.raw=n,this.uri=i.uri,this.index=i.index,this.name=i.name}toResource(i){return(0,M.joinPath)(this.uri,i)}toJSON(){return{uri:this.uri,name:this.name,index:this.index}}}e.WorkspaceFolder=h;function g(u){return new h({uri:u,index:0,name:(0,M.basenameOrAuthority)(u)},{uri:u.toString()})}e.toWorkspaceFolder=g,e.WORKSPACE_EXTENSION="code-workspace",e.WORKSPACE_SUFFIX=`.${e.WORKSPACE_EXTENSION}`,e.WORKSPACE_FILTER=[{name:(0,r.localize)(0,null),extensions:[e.WORKSPACE_EXTENSION]}],e.UNTITLED_WORKSPACE_NAME="workspace.json";function C(u,i){return M.extUriBiasedIgnorePathCase.isEqualOrParent(u,i.untitledWorkspacesHome)}e.isUntitledWorkspace=C;function l(u){let i;return _.URI.isUri(u)?i=u:i=u.configuration,i?.scheme===b.Schemas.tmp}e.isTemporaryWorkspace=l;function w(u,i){return!C(u,i)&&!l(u)}e.isSavedWorkspace=w;function t(u){return(typeof u=="string"?(0,y.extname)(u):(0,M.extname)(u))===e.WORKSPACE_SUFFIX}e.hasWorkspaceFileExtension=t}),define(Ce[61],Ie([1,0]),function(ie,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.Cache=void 0;class r{constructor(S){this.id=S,this._data=new Map,this._idPool=1}add(S){const M=this._idPool++;return this._data.set(M,S),this.logDebugInfo(),M}get(S,M){return this._data.has(S)?this._data.get(S)[M]:void 0}delete(S){this._data.delete(S),this.logDebugInfo()}logDebugInfo(){!r.enableDebugLogging||console.log(`${this.id} cache size - ${this._data.size}`)}}e.Cache=r,r.enableDebugLogging=!1}),define(Ce[36],Ie([1,0,13,22,3]),function(ie,e,r,y,S){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.IExtHostFileSystemInfo=e.ExtHostFileSystemInfo=void 0;class M{constructor(){this._systemSchemes=new Set(Object.keys(r.Schemas)),this._providerInfo=new Map,this.extUri=new y.ExtUri(A=>{const b=this._providerInfo.get(A.scheme);return!(b===void 0||b&1024)})}$acceptProviderInfos(A,b){b===null?this._providerInfo.delete(A.scheme):this._providerInfo.set(A.scheme,b)}isFreeScheme(A){return!this._providerInfo.has(A)&&!this._systemSchemes.has(A)}getCapabilities(A){return this._providerInfo.get(A)}}e.ExtHostFileSystemInfo=M,e.IExtHostFileSystemInfo=(0,S.createDecorator)("IExtHostFileSystemInfo")}),define(Ce[28],Ie([1,0,3]),function(ie,e,r){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.IExtHostInitDataService=void 0,e.IExtHostInitDataService=(0,r.createDecorator)("IExtHostInitDataService")}),define(Ce[158],Ie([1,0,15]),function(ie,e,r){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtensionGlobalMemento=e.ExtensionMemento=void 0;class y{constructor(_,A,b){this._deferredPromises=new Map,this._id=_,this._shared=A,this._storage=b,this._init=this._storage.initializeExtensionStorage(this._shared,this._id,Object.create(null)).then(P=>(this._value=P,this)),this._storageListener=this._storage.onDidChangeStorage(P=>{P.shared===this._shared&&P.key===this._id&&(this._value=P.value)}),this._scheduler=new r.RunOnceScheduler(()=>{const P=this._deferredPromises;this._deferredPromises=new Map,(async()=>{try{await this._storage.setValue(this._shared,this._id,this._value);for(const O of P.values())O.complete()}catch(O){for(const E of P.values())E.error(O)}})()},0)}keys(){return Object.entries(this._value??{}).filter(([,_])=>_!==void 0).map(([_])=>_)}get whenReady(){return this._init}get(_,A){let b=this._value[_];return typeof b>"u"&&(b=A),b}update(_,A){this._value[_]=A;const b=this._deferredPromises.get(_);if(b!==void 0)return b.p;const P=new r.DeferredPromise;return this._deferredPromises.set(_,P),this._scheduler.isScheduled()||this._scheduler.schedule(),P.p}dispose(){this._storageListener.dispose()}}e.ExtensionMemento=y;class S extends y{setKeysForSync(_){this._storage.registerExtensionStorageKeysToSync({id:this._id,version:this._extension.version},_)}constructor(_,A){super(_.identifier.value,!0,A),this._extension=_}}e.ExtensionGlobalMemento=S}),define(Ce[159],Ie([1,0,5,2]),function(ie,e,r,y){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtHostNotebookDocuments=void 0;class S{constructor(_){this._notebooksAndEditors=_,this._onDidSaveNotebookDocument=new r.Emitter,this.onDidSaveNotebookDocument=this._onDidSaveNotebookDocument.event,this._onDidChangeNotebookDocument=new r.Emitter,this.onDidChangeNotebookDocument=this._onDidChangeNotebookDocument.event}$acceptModelChanged(_,A,b,P){const E=this._notebooksAndEditors.getNotebookDocument(y.URI.revive(_)).acceptModelChanged(A.value,b,P);this._onDidChangeNotebookDocument.fire(E)}$acceptDirtyStateChanged(_,A){this._notebooksAndEditors.getNotebookDocument(y.URI.revive(_)).acceptDirty(A)}$acceptModelSaved(_){const A=this._notebooksAndEditors.getNotebookDocument(y.URI.revive(_));this._onDidSaveNotebookDocument.fire(A.apiNotebook)}}e.ExtHostNotebookDocuments=S}),define(Ce[11],Ie([1,0,3]),function(ie,e,r){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtHostRpcService=e.IExtHostRpcService=void 0,e.IExtHostRpcService=(0,r.createDecorator)("IExtHostRpcService");class y{constructor(M){this.getProxy=M.getProxy.bind(M),this.set=M.set.bind(M),this.dispose=M.dispose.bind(M),this.assertRegistered=M.assertRegistered.bind(M),this.drain=M.drain.bind(M)}}e.ExtHostRpcService=y});var Je=this&&this.__classPrivateFieldSet||function(ie,e,r,y,S){if(y==="m")throw new TypeError("Private method is not writable");if(y==="a"&&!S)throw new TypeError("Private accessor was defined without a setter");if(typeof e=="function"?ie!==e||!S:!e.has(ie))throw new TypeError("Cannot write private member to an object whose class did not declare it");return y==="a"?S.call(ie,r):S?S.value=r:e.set(ie,r),r},Oe=this&&this.__classPrivateFieldGet||function(ie,e,r,y){if(r==="a"&&!y)throw new TypeError("Private accessor was defined without a getter");if(typeof e=="function"?ie!==e||!y:!e.has(ie))throw new TypeError("Cannot read private member from an object whose class did not declare it");return r==="m"?y:r==="a"?y.call(ie):y?y.value:e.get(ie)};define(Ce[160],Ie([1,0,27,5]),function(ie,e,r,y){"use strict";var S;Object.defineProperty(e,"__esModule",{value:!0}),e.ExtensionSecrets=void 0;class M{constructor(A,b){S.set(this,void 0),this._onDidChange=new y.Emitter,this.onDidChange=this._onDidChange.event,this._id=r.ExtensionIdentifier.toKey(A.identifier),Je(this,S,b,"f"),Oe(this,S,"f").onDidChangePassword(P=>{P.extensionId===this._id&&this._onDidChange.fire({key:P.key})})}get(A){return Oe(this,S,"f").get(this._id,A)}store(A,b){return Oe(this,S,"f").store(this._id,A,b)}delete(A){return Oe(this,S,"f").delete(this._id,A)}}e.ExtensionSecrets=M,S=new WeakMap}),define(Ce[88],Ie([1,0,3,5]),function(ie,e,r,y){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.IExtHostTelemetry=e.ExtHostTelemetry=void 0;class S{constructor(){this._onDidChangeTelemetryEnabled=new y.Emitter,this.onDidChangeTelemetryEnabled=this._onDidChangeTelemetryEnabled.event,this._onDidChangeTelemetryConfiguration=new y.Emitter,this.onDidChangeTelemetryConfiguration=this._onDidChangeTelemetryConfiguration.event,this._productConfig={usage:!0,error:!0},this._level=0}getTelemetryConfiguration(){return this._level===3}getTelemetryDetails(){return{isCrashEnabled:this._level>=1,isErrorsEnabled:this._productConfig.error?this._level>=2:!1,isUsageEnabled:this._productConfig.usage?this._level>=3:!1}}$initializeTelemetryLevel(_,A){this._level=_,this._productConfig=A||{usage:!0,error:!0}}$onDidChangeTelemetryLevel(_){this._oldTelemetryEnablement=this.getTelemetryConfiguration(),this._level=_,this._oldTelemetryEnablement!==this.getTelemetryConfiguration()&&this._onDidChangeTelemetryEnabled.fire(this.getTelemetryConfiguration()),this._onDidChangeTelemetryConfiguration.fire(this.getTelemetryDetails())}}e.ExtHostTelemetry=S,e.IExtHostTelemetry=(0,r.createDecorator)("IExtHostTelemetry")}),define(Ce[62],Ie([1,0,3,156,5,11]),function(ie,e,r,y,S,M){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtHostTunnelService=e.IExtHostTunnelService=e.TunnelDtoConverter=void 0;var _;(function(b){function P(E){return{remoteAddress:E.remoteAddress,localAddress:E.localAddress,public:!!E.public,privacy:E.privacy??(E.public?y.TunnelPrivacyId.Public:y.TunnelPrivacyId.Private),protocol:E.protocol}}b.fromApiTunnel=P;function O(E){return{remoteAddress:{host:E.tunnelRemoteHost,port:E.tunnelRemotePort},localAddress:E.localAddress,public:E.privacy!==y.TunnelPrivacyId.ConstantPrivate&&E.privacy!==y.TunnelPrivacyId.ConstantPrivate,privacy:E.privacy,protocol:E.protocol}}b.fromServiceTunnel=O})(_=e.TunnelDtoConverter||(e.TunnelDtoConverter={})),e.IExtHostTunnelService=(0,r.createDecorator)("IExtHostTunnelService");let A=class{constructor(P){this.onDidChangeTunnels=new S.Emitter().event}async $applyCandidateFilter(P){return P}async openTunnel(P,O){}async getTunnels(){return[]}async setTunnelFactory(P){return{dispose:()=>{}}}registerPortsAttributesProvider(P,O){return{dispose:()=>{}}}async $providePortAttributes(P,O,E,m,k){return[]}async $forwardPort(P,O){}async $closeTunnel(P){}async $onDidTunnelsChange(){}async $registerCandidateFinder(){}};A=ze([$e(0,M.IExtHostRpcService)],A),e.ExtHostTunnelService=A}),define(Ce[46],Ie([1,0,3]),function(ie,e,r){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.URITransformerService=e.IURITransformerService=void 0,e.IURITransformerService=(0,r.createDecorator)("IURITransformerService");class y{constructor(M){M?(this.transformIncoming=M.transformIncoming.bind(M),this.transformOutgoing=M.transformOutgoing.bind(M),this.transformOutgoingURI=M.transformOutgoingURI.bind(M),this.transformOutgoingScheme=M.transformOutgoingScheme.bind(M)):(this.transformIncoming=_=>_,this.transformOutgoing=_=>_,this.transformOutgoingURI=_=>_,this.transformOutgoingScheme=_=>_)}}e.URITransformerService=y}),define(Ce[161],Ie([1,0,23]),function(ie,e,r){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.deserializeWebviewMessage=e.serializeWebviewMessage=void 0;class y{constructor(){this.buffers=[]}add(b){let P=this.buffers.indexOf(b);return P<0&&(P=this.buffers.length,this.buffers.push(b)),P}}function S(A,b){if(b.serializeBuffersForPostMessage){const P=new y,O=(k,f)=>{if(f instanceof ArrayBuffer){const c=P.add(f);return{$$vscode_array_buffer_reference$$:!0,index:c}}else if(ArrayBuffer.isView(f)){const c=M(f);if(c){const d=P.add(f.buffer);return{$$vscode_array_buffer_reference$$:!0,index:d,view:{type:c,byteLength:f.byteLength,byteOffset:f.byteOffset}}}}return f},E=JSON.stringify(A,O),m=P.buffers.map(k=>{const f=new Uint8Array(k);return r.VSBuffer.wrap(f)});return{message:E,buffers:m}}else return{message:JSON.stringify(A),buffers:[]}}e.serializeWebviewMessage=S;function M(A){switch(A.constructor.name){case"Int8Array":return 1;case"Uint8Array":return 2;case"Uint8ClampedArray":return 3;case"Int16Array":return 4;case"Uint16Array":return 5;case"Int32Array":return 6;case"Uint32Array":return 7;case"Float32Array":return 8;case"Float64Array":return 9;case"BigInt64Array":return 10;case"BigUint64Array":return 11}}function _(A,b){const P=b.map(m=>{const k=new ArrayBuffer(m.byteLength);return new Uint8Array(k).set(m.buffer),k}),O=b.length?(m,k)=>{if(k&&typeof k=="object"&&k.$$vscode_array_buffer_reference$$){const f=k,{index:c}=f,d=P[c];if(f.view)switch(f.view.type){case 1:return new Int8Array(d,f.view.byteOffset,f.view.byteLength/Int8Array.BYTES_PER_ELEMENT);case 2:return new Uint8Array(d,f.view.byteOffset,f.view.byteLength/Uint8Array.BYTES_PER_ELEMENT);case 3:return new Uint8ClampedArray(d,f.view.byteOffset,f.view.byteLength/Uint8ClampedArray.BYTES_PER_ELEMENT);case 4:return new Int16Array(d,f.view.byteOffset,f.view.byteLength/Int16Array.BYTES_PER_ELEMENT);case 5:return new Uint16Array(d,f.view.byteOffset,f.view.byteLength/Uint16Array.BYTES_PER_ELEMENT);case 6:return new Int32Array(d,f.view.byteOffset,f.view.byteLength/Int32Array.BYTES_PER_ELEMENT);case 7:return new Uint32Array(d,f.view.byteOffset,f.view.byteLength/Uint32Array.BYTES_PER_ELEMENT);case 8:return new Float32Array(d,f.view.byteOffset,f.view.byteLength/Float32Array.BYTES_PER_ELEMENT);case 9:return new Float64Array(d,f.view.byteOffset,f.view.byteLength/Float64Array.BYTES_PER_ELEMENT);case 10:return new BigInt64Array(d,f.view.byteOffset,f.view.byteLength/BigInt64Array.BYTES_PER_ELEMENT);case 11:return new BigUint64Array(d,f.view.byteOffset,f.view.byteLength/BigUint64Array.BYTES_PER_ELEMENT);default:throw new Error("Unknown array buffer view type")}return d}return k}:void 0;return{message:JSON.parse(A,O),arrayBuffers:P}}e.deserializeWebviewMessage=_}),define(Ce[89],Ie([1,0,137,10,2,7,3,30,35,13]),function(ie,e,r,y,S,M,_,A,b,P){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.isTextEditorViewState=e.EditorsOrder=e.pathsToEditors=e.CloseDirection=e.EditorResourceAccessor=e.SideBySideEditor=e.GroupModelChangeKind=e.EditorCloseContext=e.isEditorIdentifier=e.isEditorInputWithOptionsAndGroup=e.isEditorInputWithOptions=e.isDiffEditorInput=e.isSideBySideEditorInput=e.isEditorInput=e.AbstractEditorInput=e.EditorInputCapabilities=e.SaveSourceRegistry=e.SaveReason=e.Verbosity=e.isResourceMergeEditorInput=e.isUntitledWithAssociatedResource=e.isUntitledResourceEditorInput=e.isResourceSideBySideEditorInput=e.isResourceDiffEditorInput=e.isResourceEditorInput=e.findViewStateForEditor=e.isEditorPaneWithSelection=e.EditorPaneSelectionCompareResult=e.EditorPaneSelectionChangeReason=e.BINARY_DIFF_EDITOR_ID=e.TEXT_DIFF_EDITOR_ID=e.SIDE_BY_SIDE_EDITOR_ID=e.DEFAULT_EDITOR_ASSOCIATION=e.EditorExtensions=void 0,e.EditorExtensions={EditorPane:"workbench.contributions.editors",EditorFactory:"workbench.contributions.editor.inputFactories"},e.DEFAULT_EDITOR_ASSOCIATION={id:"default",displayName:(0,r.localize)(0,null),providerDisplayName:(0,r.localize)(1,null)},e.SIDE_BY_SIDE_EDITOR_ID="workbench.editor.sidebysideEditor",e.TEXT_DIFF_EDITOR_ID="workbench.editors.textDiffEditor",e.BINARY_DIFF_EDITOR_ID="workbench.editors.binaryResourceDiffEditor";var O;(function(G){G[G.PROGRAMMATIC=1]="PROGRAMMATIC",G[G.USER=2]="USER",G[G.EDIT=3]="EDIT",G[G.NAVIGATION=4]="NAVIGATION",G[G.JUMP=5]="JUMP"})(O=e.EditorPaneSelectionChangeReason||(e.EditorPaneSelectionChangeReason={}));var E;(function(G){G[G.IDENTICAL=1]="IDENTICAL",G[G.SIMILAR=2]="SIMILAR",G[G.DIFFERENT=3]="DIFFERENT"})(E=e.EditorPaneSelectionCompareResult||(e.EditorPaneSelectionCompareResult={}));function m(G){const ne=G;return!!ne&&typeof ne.getSelection=="function"&&!!ne.onDidChangeSelection}e.isEditorPaneWithSelection=m;function k(G,ne,ge){for(const oe of ge.visibleEditorPanes)if(oe.group.id===ne&&G.matches(oe.input))return oe.getViewState()}e.findViewStateForEditor=k;function f(G){if(s(G))return!1;const ne=G;return S.URI.isUri(ne?.resource)}e.isResourceEditorInput=f;function c(G){if(s(G))return!1;const ne=G;return ne?.original!==void 0&&ne.modified!==void 0}e.isResourceDiffEditorInput=c;function d(G){if(s(G)||c(G))return!1;const ne=G;return ne?.primary!==void 0&&ne.secondary!==void 0}e.isResourceSideBySideEditorInput=d;function h(G){if(s(G))return!1;const ne=G;return ne?ne.resource===void 0||ne.resource.scheme===P.Schemas.untitled||ne.forceUntitled===!0:!1}e.isUntitledResourceEditorInput=h;const g=/Untitled-\d+/;function C(G){return G.scheme===P.Schemas.untitled&&G.path.length>1&&!g.test(G.path)}e.isUntitledWithAssociatedResource=C;function l(G){if(s(G))return!1;const ne=G;return S.URI.isUri(ne?.base?.resource)&&S.URI.isUri(ne?.input1?.resource)&&S.URI.isUri(ne?.input2?.resource)&&S.URI.isUri(ne?.result?.resource)}e.isResourceMergeEditorInput=l;var w;(function(G){G[G.SHORT=0]="SHORT",G[G.MEDIUM=1]="MEDIUM",G[G.LONG=2]="LONG"})(w=e.Verbosity||(e.Verbosity={}));var t;(function(G){G[G.EXPLICIT=1]="EXPLICIT",G[G.AUTO=2]="AUTO",G[G.FOCUS_CHANGE=3]="FOCUS_CHANGE",G[G.WINDOW_CHANGE=4]="WINDOW_CHANGE"})(t=e.SaveReason||(e.SaveReason={}));class u{constructor(){this.mapIdToSaveSource=new Map}registerSource(ne,ge){let oe=this.mapIdToSaveSource.get(ne);return oe||(oe={source:ne,label:ge},this.mapIdToSaveSource.set(ne,oe)),oe.source}getSourceLabel(ne){return this.mapIdToSaveSource.get(ne)?.label??ne}}e.SaveSourceRegistry=new u;var i;(function(G){G[G.None=0]="None",G[G.Readonly=2]="Readonly",G[G.Untitled=4]="Untitled",G[G.Singleton=8]="Singleton",G[G.RequiresTrust=16]="RequiresTrust",G[G.CanSplitInGroup=32]="CanSplitInGroup",G[G.ForceDescription=64]="ForceDescription",G[G.CanDropIntoEditor=128]="CanDropIntoEditor",G[G.MultipleEditors=256]="MultipleEditors"})(i=e.EditorInputCapabilities||(e.EditorInputCapabilities={}));class n extends M.Disposable{}e.AbstractEditorInput=n;function s(G){return G instanceof n}e.isEditorInput=s;function a(G){const ne=G;return S.URI.isUri(ne?.preferredResource)}function o(G){const ne=G;return s(ne?.primary)&&s(ne?.secondary)}e.isSideBySideEditorInput=o;function v(G){const ne=G;return s(ne?.modified)&&s(ne?.original)}e.isDiffEditorInput=v;function p(G){return s(G?.editor)}e.isEditorInputWithOptions=p;function T(G){const ne=G;return p(G)&&ne?.group!==void 0}e.isEditorInputWithOptionsAndGroup=T;function N(G){const ne=G;return typeof ne?.groupId=="number"&&s(ne.editor)}e.isEditorIdentifier=N;var V;(function(G){G[G.UNKNOWN=0]="UNKNOWN",G[G.REPLACE=1]="REPLACE",G[G.MOVE=2]="MOVE",G[G.UNPIN=3]="UNPIN"})(V=e.EditorCloseContext||(e.EditorCloseContext={}));var B;(function(G){G[G.GROUP_ACTIVE=0]="GROUP_ACTIVE",G[G.GROUP_INDEX=1]="GROUP_INDEX",G[G.GROUP_LOCKED=2]="GROUP_LOCKED",G[G.EDITOR_OPEN=3]="EDITOR_OPEN",G[G.EDITOR_CLOSE=4]="EDITOR_CLOSE",G[G.EDITOR_MOVE=5]="EDITOR_MOVE",G[G.EDITOR_ACTIVE=6]="EDITOR_ACTIVE",G[G.EDITOR_LABEL=7]="EDITOR_LABEL",G[G.EDITOR_CAPABILITIES=8]="EDITOR_CAPABILITIES",G[G.EDITOR_PIN=9]="EDITOR_PIN",G[G.EDITOR_STICKY=10]="EDITOR_STICKY",G[G.EDITOR_DIRTY=11]="EDITOR_DIRTY",G[G.EDITOR_WILL_DISPOSE=12]="EDITOR_WILL_DISPOSE"})(B=e.GroupModelChangeKind||(e.GroupModelChangeKind={}));var D;(function(G){G[G.PRIMARY=1]="PRIMARY",G[G.SECONDARY=2]="SECONDARY",G[G.BOTH=3]="BOTH",G[G.ANY=4]="ANY"})(D=e.SideBySideEditor||(e.SideBySideEditor={}));class z{getOriginalUri(ne,ge){if(!ne)return;if(l(ne))return e.EditorResourceAccessor.getOriginalUri(ne.result,ge);if(ge?.supportSideBySide){const{primary:Ee,secondary:ce}=this.getSideEditors(ne);if(Ee&&ce){if(ge?.supportSideBySide===D.BOTH)return{primary:this.getOriginalUri(Ee,{filterByScheme:ge.filterByScheme}),secondary:this.getOriginalUri(ce,{filterByScheme:ge.filterByScheme})};if(ge?.supportSideBySide===D.ANY)return this.getOriginalUri(Ee,{filterByScheme:ge.filterByScheme})??this.getOriginalUri(ce,{filterByScheme:ge.filterByScheme});ne=ge.supportSideBySide===D.PRIMARY?Ee:ce}}if(c(ne)||d(ne)||l(ne))return;const oe=a(ne)?ne.preferredResource:ne.resource;return!oe||!ge||!ge.filterByScheme?oe:this.filterUri(oe,ge.filterByScheme)}getSideEditors(ne){return o(ne)||d(ne)?{primary:ne.primary,secondary:ne.secondary}:v(ne)||c(ne)?{primary:ne.modified,secondary:ne.original}:{primary:void 0,secondary:void 0}}getCanonicalUri(ne,ge){if(!ne)return;if(l(ne))return e.EditorResourceAccessor.getCanonicalUri(ne.result,ge);if(ge?.supportSideBySide){const{primary:Ee,secondary:ce}=this.getSideEditors(ne);if(Ee&&ce){if(ge?.supportSideBySide===D.BOTH)return{primary:this.getCanonicalUri(Ee,{filterByScheme:ge.filterByScheme}),secondary:this.getCanonicalUri(ce,{filterByScheme:ge.filterByScheme})};if(ge?.supportSideBySide===D.ANY)return this.getCanonicalUri(Ee,{filterByScheme:ge.filterByScheme})??this.getCanonicalUri(ce,{filterByScheme:ge.filterByScheme});ne=ge.supportSideBySide===D.PRIMARY?Ee:ce}}if(c(ne)||d(ne)||l(ne))return;const oe=ne.resource;return!oe||!ge||!ge.filterByScheme?oe:this.filterUri(oe,ge.filterByScheme)}filterUri(ne,ge){if(Array.isArray(ge)){if(ge.some(oe=>ne.scheme===oe))return ne}else if(ge===ne.scheme)return ne}}e.EditorResourceAccessor=new z;var L;(function(G){G[G.LEFT=0]="LEFT",G[G.RIGHT=1]="RIGHT"})(L=e.CloseDirection||(e.CloseDirection={}));class R{constructor(){this.editorSerializerConstructors=new Map,this.editorSerializerInstances=new Map}start(ne){const ge=this.instantiationService=ne.get(_.IInstantiationService);for(const[oe,Ee]of this.editorSerializerConstructors)this.createEditorSerializer(oe,Ee,ge);this.editorSerializerConstructors.clear()}createEditorSerializer(ne,ge,oe){const Ee=oe.createInstance(ge);this.editorSerializerInstances.set(ne,Ee)}registerFileEditorFactory(ne){if(this.fileEditorFactory)throw new Error("Can only register one file editor factory.");this.fileEditorFactory=ne}getFileEditorFactory(){return(0,y.assertIsDefined)(this.fileEditorFactory)}registerEditorSerializer(ne,ge){if(this.editorSerializerConstructors.has(ne)||this.editorSerializerInstances.has(ne))throw new Error(`A editor serializer with type ID '${ne}' was already registered.`);return this.instantiationService?this.createEditorSerializer(ne,ge,this.instantiationService):this.editorSerializerConstructors.set(ne,ge),(0,M.toDisposable)(()=>{this.editorSerializerConstructors.delete(ne),this.editorSerializerInstances.delete(ne)})}getEditorSerializer(ne){return this.editorSerializerInstances.get(typeof ne=="string"?ne:ne.typeId)}}A.Registry.add(e.EditorExtensions.EditorFactory,new R);async function K(G,ne){return!G||!G.length?[]:await Promise.all(G.map(async ge=>{const oe=S.URI.revive(ge.fileUri);if(!oe||!await ne.canHandleResource(oe))return;let ce=ge.exists,me=ge.type;if(typeof ce!="boolean"||typeof me!="number")try{me=(await ne.stat(oe)).isDirectory?b.FileType.Directory:b.FileType.Unknown,ce=!0}catch{ce=!1}if(!ce&&ge.openOnlyIfExists||me===b.FileType.Directory)return;const ee={...ge.options,pinned:!0};return ce?{resource:oe,options:ee}:{resource:oe,options:ee,forceUntitled:!0}}))}e.pathsToEditors=K;var W;(function(G){G[G.MOST_RECENTLY_ACTIVE=0]="MOST_RECENTLY_ACTIVE",G[G.SEQUENTIAL=1]="SEQUENTIAL"})(W=e.EditorsOrder||(e.EditorsOrder={}));function $(G){const ne=G;if(!ne)return!1;const ge=ne;if(ge.modified)return $(ge.modified);const oe=ne;return!!(oe.contributionsState&&oe.viewState&&Array.isArray(oe.cursorState))}e.isTextEditorViewState=$}),define(Ce[63],Ie([1,0,13,2]),function(ie,e,r,y){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.decodeAuthority=e.asWebviewUri=e.webviewGenericCspSource=e.webviewRootResourceAuthority=e.webviewResourceBaseHost=void 0,e.webviewResourceBaseHost="vscode-cdn.net",e.webviewRootResourceAuthority=`vscode-resource.${e.webviewResourceBaseHost}`,e.webviewGenericCspSource=`'self' https://*.${e.webviewResourceBaseHost}`;function S(A,b){return A.scheme===r.Schemas.http||A.scheme===r.Schemas.https?A:(b&&b.authority&&b.isRemote&&A.scheme===r.Schemas.file&&(A=y.URI.from({scheme:r.Schemas.vscodeRemote,authority:b.authority,path:A.path})),y.URI.from({scheme:r.Schemas.https,authority:`${A.scheme}+${M(A.authority)}.${e.webviewRootResourceAuthority}`,path:A.path,fragment:A.fragment,query:A.query}))}e.asWebviewUri=S;function M(A){return A.replace(/./g,b=>{const P=b.charCodeAt(0);return P>=97&&P<=122||P>=65&&P<=90||P>=48&&P<=57?b:"-"+P.toString(16).padStart(4,"0")})}function _(A){return A.replace(/-([0-9a-f]{4})/g,(b,P)=>String.fromCharCode(parseInt(P,16)))}e.decodeAuthority=_}),define(Ce[162],Ie([1,0,5,7,63]),function(ie,e,r,y,S){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtHostEditorInsets=void 0;class M{constructor(A,b,P){this._proxy=A,this._editors=b,this._remoteInfo=P,this._handlePool=0,this._disposables=new y.DisposableStore,this._insets=new Map,this._disposables.add(b.onDidChangeVisibleTextEditors(()=>{const O=b.getVisibleTextEditors();for(const E of this._insets.values())O.indexOf(E.editor)<0&&E.inset.dispose()}))}dispose(){this._insets.forEach(A=>A.inset.dispose()),this._disposables.dispose()}createWebviewEditorInset(A,b,P,O,E){let m;for(const C of this._editors.getVisibleTextEditors(!0))if(C.value===A){m=C;break}if(!m)throw new Error("not a visible editor");const k=this,f=this._handlePool++,c=new r.Emitter,d=new r.Emitter,h=new class{constructor(){this._html="",this._options=Object.create(null)}asWebviewUri(C){return(0,S.asWebviewUri)(C,k._remoteInfo)}get cspSource(){return S.webviewGenericCspSource}set options(C){this._options=C,k._proxy.$setOptions(f,C)}get options(){return this._options}set html(C){this._html=C,k._proxy.$setHtml(f,C)}get html(){return this._html}get onDidReceiveMessage(){return c.event}postMessage(C){return k._proxy.$postMessage(f,C)}},g=new class{constructor(){this.editor=A,this.line=b,this.height=P,this.webview=h,this.onDidDispose=d.event}dispose(){k._insets.has(f)&&(k._insets.delete(f),k._proxy.$disposeEditorInset(f),d.fire(),d.dispose(),c.dispose())}};return this._proxy.$createEditorInset(f,m.id,m.value.document.uri,b+1,P,O||{},E.identifier,E.extensionLocation),this._insets.set(f,{editor:A,inset:g,onDidReceiveMessage:c}),g}$onDidDispose(A){const b=this._insets.get(A);b&&b.inset.dispose()}$onDidReceiveMessage(A,b){this._insets.get(A)?.onDidReceiveMessage.fire(b)}}e.ExtHostEditorInsets=M}),define(Ce[163],Ie([1,0,5,15,138]),function(ie,e,r,y,S){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.AbstractDebugAdapter=void 0;class M{constructor(){this.pendingRequests=new Map,this.queue=[],this._onError=new r.Emitter,this._onExit=new r.Emitter,this.sequence=1}get onError(){return this._onError.event}get onExit(){return this._onExit.event}onMessage(A){this.messageCallback&&this._onError.fire(new Error("attempt to set more than one 'Message' callback")),this.messageCallback=A}onEvent(A){this.eventCallback&&this._onError.fire(new Error("attempt to set more than one 'Event' callback")),this.eventCallback=A}onRequest(A){this.requestCallback&&this._onError.fire(new Error("attempt to set more than one 'Request' callback")),this.requestCallback=A}sendResponse(A){A.seq>0?this._onError.fire(new Error(`attempt to send more than one response for command ${A.command}`)):this.internalSend("response",A)}sendRequest(A,b,P,O){const E={command:A};if(b&&Object.keys(b).length>0&&(E.arguments=b),this.internalSend("request",E),typeof O=="number"){const m=setTimeout(()=>{clearTimeout(m);const k=this.pendingRequests.get(E.seq);if(k){this.pendingRequests.delete(E.seq);const f={type:"response",seq:0,request_seq:E.seq,success:!1,command:A,message:(0,S.localize)(0,null,O,A)};k(f)}},O)}return P&&this.pendingRequests.set(E.seq,P),E.seq}acceptMessage(A){this.messageCallback?this.messageCallback(A):(this.queue.push(A),this.queue.length===1&&this.processQueue())}needsTaskBoundaryBetween(A,b){return A.type!=="event"||b.type!=="event"}async processQueue(){let A;for(;this.queue.length;){if((!A||this.needsTaskBoundaryBetween(this.queue[0],A))&&await(0,y.timeout)(0),A=this.queue.shift(),!A)return;switch(A.type){case"event":this.eventCallback?.(A);break;case"request":this.requestCallback?.(A);break;case"response":{const b=A,P=this.pendingRequests.get(b.request_seq);P&&(this.pendingRequests.delete(b.request_seq),P(b));break}}}}internalSend(A,b){b.type=A,b.seq=this.sequence++,this.sendMessage(b)}async cancelPendingRequests(){if(this.pendingRequests.size===0)return Promise.resolve();const A=new Map;this.pendingRequests.forEach((b,P)=>A.set(P,b)),await(0,y.timeout)(500),A.forEach((b,P)=>{b({type:"response",seq:0,request_seq:P,success:!1,command:"canceled",message:"canceled"}),this.pendingRequests.delete(P)})}getPendingRequestIds(){return Array.from(this.pendingRequests.keys())}dispose(){this.queue=[]}}e.AbstractDebugAdapter=M}),define(Ce[164],Ie([1,0,139,39,3]),function(ie,e,r,y,S){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.BreakpointWidgetContext=e.IDebugService=e.DebuggerString=e.DebugConfigurationProviderTriggerKind=e.DEBUG_MEMORY_SCHEME=e.MemoryRangeType=e.getStateLabel=e.State=e.INTERNAL_CONSOLE_OPTIONS_SCHEMA=e.DEBUG_SCHEME=e.BREAKPOINT_EDITOR_CONTRIBUTION_ID=e.EDITOR_CONTRIBUTION_ID=e.debuggerDisabledMessage=e.CONTEXT_FOCUSED_STACK_FRAME_HAS_INSTRUCTION_POINTER_REFERENCE=e.CONTEXT_LANGUAGE_SUPPORTS_DISASSEMBLE_REQUEST=e.CONTEXT_DISASSEMBLY_VIEW_FOCUS=e.CONTEXT_DISASSEMBLE_REQUEST_SUPPORTED=e.CONTEXT_MULTI_SESSION_DEBUG=e.CONTEXT_MULTI_SESSION_REPL=e.CONTEXT_EXCEPTION_WIDGET_VISIBLE=e.CONTEXT_VARIABLE_IS_READONLY=e.CONTEXT_VARIABLE_EVALUATE_NAME_PRESENT=e.CONTEXT_SUSPEND_DEBUGGEE_SUPPORTED=e.CONTEXT_TERMINATE_DEBUGGEE_SUPPORTED=e.CONTEXT_BREAK_WHEN_VALUE_IS_READ_SUPPORTED=e.CONTEXT_BREAK_WHEN_VALUE_IS_ACCESSED_SUPPORTED=e.CONTEXT_BREAK_WHEN_VALUE_CHANGES_SUPPORTED=e.CONTEXT_SET_EXPRESSION_SUPPORTED=e.CONTEXT_SET_VARIABLE_SUPPORTED=e.CONTEXT_DEBUG_PROTOCOL_VARIABLE_MENU_CONTEXT=e.CONTEXT_DEBUG_EXTENSION_AVAILABLE=e.CONTEXT_DEBUGGERS_AVAILABLE=e.CONTEXT_BREAKPOINTS_EXIST=e.CONTEXT_STEP_INTO_TARGETS_SUPPORTED=e.CONTEXT_JUMP_TO_CURSOR_SUPPORTED=e.CONTEXT_STACK_FRAME_SUPPORTS_RESTART=e.CONTEXT_RESTART_FRAME_SUPPORTED=e.CONTEXT_STEP_BACK_SUPPORTED=e.CONTEXT_FOCUSED_SESSION_IS_ATTACH=e.CONTEXT_LOADED_SCRIPTS_ITEM_TYPE=e.CONTEXT_LOADED_SCRIPTS_SUPPORTED=e.CONTEXT_BREAKPOINT_SUPPORTS_CONDITION=e.CONTEXT_BREAKPOINT_ACCESS_TYPE=e.CONTEXT_BREAKPOINT_ITEM_TYPE=e.CONTEXT_CAN_VIEW_MEMORY=e.CONTEXT_WATCH_ITEM_TYPE=e.CONTEXT_CALLSTACK_SESSION_HAS_ONE_THREAD=e.CONTEXT_CALLSTACK_ITEM_STOPPED=e.CONTEXT_CALLSTACK_SESSION_IS_ATTACH=e.CONTEXT_CALLSTACK_ITEM_TYPE=e.CONTEXT_BREAKPOINT_INPUT_FOCUSED=e.CONTEXT_EXPRESSION_SELECTED=e.CONTEXT_VARIABLES_FOCUSED=e.CONTEXT_WATCH_EXPRESSIONS_EXIST=e.CONTEXT_WATCH_EXPRESSIONS_FOCUSED=e.CONTEXT_BREAKPOINTS_FOCUSED=e.CONTEXT_IN_BREAKPOINT_WIDGET=e.CONTEXT_BREAKPOINT_WIDGET_VISIBLE=e.CONTEXT_IN_DEBUG_REPL=e.CONTEXT_IN_DEBUG_MODE=e.CONTEXT_DEBUG_UX=e.CONTEXT_DEBUG_UX_KEY=e.CONTEXT_DEBUG_STATE=e.CONTEXT_DEBUG_CONFIGURATION_TYPE=e.CONTEXT_DEBUG_TYPE=e.DEBUG_SERVICE_ID=e.REPL_VIEW_ID=e.DEBUG_PANEL_ID=e.DISASSEMBLY_VIEW_ID=e.BREAKPOINTS_VIEW_ID=e.LOADED_SCRIPTS_VIEW_ID=e.CALLSTACK_VIEW_ID=e.WATCH_VIEW_ID=e.VARIABLES_VIEW_ID=e.VIEWLET_ID=void 0,e.VIEWLET_ID="workbench.view.debug",e.VARIABLES_VIEW_ID="workbench.debug.variablesView",e.WATCH_VIEW_ID="workbench.debug.watchExpressionsView",e.CALLSTACK_VIEW_ID="workbench.debug.callStackView",e.LOADED_SCRIPTS_VIEW_ID="workbench.debug.loadedScriptsView",e.BREAKPOINTS_VIEW_ID="workbench.debug.breakPointsView",e.DISASSEMBLY_VIEW_ID="workbench.debug.disassemblyView",e.DEBUG_PANEL_ID="workbench.panel.repl",e.REPL_VIEW_ID="workbench.panel.repl.view",e.DEBUG_SERVICE_ID="debugService",e.CONTEXT_DEBUG_TYPE=new y.RawContextKey("debugType",void 0,{type:"string",description:r.localize(0,null)}),e.CONTEXT_DEBUG_CONFIGURATION_TYPE=new y.RawContextKey("debugConfigurationType",void 0,{type:"string",description:r.localize(1,null)}),e.CONTEXT_DEBUG_STATE=new y.RawContextKey("debugState","inactive",{type:"string",description:r.localize(2,null)}),e.CONTEXT_DEBUG_UX_KEY="debugUx",e.CONTEXT_DEBUG_UX=new y.RawContextKey(e.CONTEXT_DEBUG_UX_KEY,"default",{type:"string",description:r.localize(3,null)}),e.CONTEXT_IN_DEBUG_MODE=new y.RawContextKey("inDebugMode",!1,{type:"boolean",description:r.localize(4,null)}),e.CONTEXT_IN_DEBUG_REPL=new y.RawContextKey("inDebugRepl",!1,{type:"boolean",description:r.localize(5,null)}),e.CONTEXT_BREAKPOINT_WIDGET_VISIBLE=new y.RawContextKey("breakpointWidgetVisible",!1,{type:"boolean",description:r.localize(6,null)}),e.CONTEXT_IN_BREAKPOINT_WIDGET=new y.RawContextKey("inBreakpointWidget",!1,{type:"boolean",description:r.localize(7,null)}),e.CONTEXT_BREAKPOINTS_FOCUSED=new y.RawContextKey("breakpointsFocused",!0,{type:"boolean",description:r.localize(8,null)}),e.CONTEXT_WATCH_EXPRESSIONS_FOCUSED=new y.RawContextKey("watchExpressionsFocused",!0,{type:"boolean",description:r.localize(9,null)}),e.CONTEXT_WATCH_EXPRESSIONS_EXIST=new y.RawContextKey("watchExpressionsExist",!1,{type:"boolean",description:r.localize(10,null)}),e.CONTEXT_VARIABLES_FOCUSED=new y.RawContextKey("variablesFocused",!0,{type:"boolean",description:r.localize(11,null)}),e.CONTEXT_EXPRESSION_SELECTED=new y.RawContextKey("expressionSelected",!1,{type:"boolean",description:r.localize(12,null)}),e.CONTEXT_BREAKPOINT_INPUT_FOCUSED=new y.RawContextKey("breakpointInputFocused",!1,{type:"boolean",description:r.localize(13,null)}),e.CONTEXT_CALLSTACK_ITEM_TYPE=new y.RawContextKey("callStackItemType",void 0,{type:"string",description:r.localize(14,null)}),e.CONTEXT_CALLSTACK_SESSION_IS_ATTACH=new y.RawContextKey("callStackSessionIsAttach",!1,{type:"boolean",description:r.localize(15,null)}),e.CONTEXT_CALLSTACK_ITEM_STOPPED=new y.RawContextKey("callStackItemStopped",!1,{type:"boolean",description:r.localize(16,null)}),e.CONTEXT_CALLSTACK_SESSION_HAS_ONE_THREAD=new y.RawContextKey("callStackSessionHasOneThread",!1,{type:"boolean",description:r.localize(17,null)}),e.CONTEXT_WATCH_ITEM_TYPE=new y.RawContextKey("watchItemType",void 0,{type:"string",description:r.localize(18,null)}),e.CONTEXT_CAN_VIEW_MEMORY=new y.RawContextKey("canViewMemory",void 0,{type:"boolean",description:r.localize(19,null)}),e.CONTEXT_BREAKPOINT_ITEM_TYPE=new y.RawContextKey("breakpointItemType",void 0,{type:"string",description:r.localize(20,null)}),e.CONTEXT_BREAKPOINT_ACCESS_TYPE=new y.RawContextKey("breakpointAccessType",void 0,{type:"string",description:r.localize(21,null)}),e.CONTEXT_BREAKPOINT_SUPPORTS_CONDITION=new y.RawContextKey("breakpointSupportsCondition",!1,{type:"boolean",description:r.localize(22,null)}),e.CONTEXT_LOADED_SCRIPTS_SUPPORTED=new y.RawContextKey("loadedScriptsSupported",!1,{type:"boolean",description:r.localize(23,null)}),e.CONTEXT_LOADED_SCRIPTS_ITEM_TYPE=new y.RawContextKey("loadedScriptsItemType",void 0,{type:"string",description:r.localize(24,null)}),e.CONTEXT_FOCUSED_SESSION_IS_ATTACH=new y.RawContextKey("focusedSessionIsAttach",!1,{type:"boolean",description:r.localize(25,null)}),e.CONTEXT_STEP_BACK_SUPPORTED=new y.RawContextKey("stepBackSupported",!1,{type:"boolean",description:r.localize(26,null)}),e.CONTEXT_RESTART_FRAME_SUPPORTED=new y.RawContextKey("restartFrameSupported",!1,{type:"boolean",description:r.localize(27,null)}),e.CONTEXT_STACK_FRAME_SUPPORTS_RESTART=new y.RawContextKey("stackFrameSupportsRestart",!1,{type:"boolean",description:r.localize(28,null)}),e.CONTEXT_JUMP_TO_CURSOR_SUPPORTED=new y.RawContextKey("jumpToCursorSupported",!1,{type:"boolean",description:r.localize(29,null)}),e.CONTEXT_STEP_INTO_TARGETS_SUPPORTED=new y.RawContextKey("stepIntoTargetsSupported",!1,{type:"boolean",description:r.localize(30,null)}),e.CONTEXT_BREAKPOINTS_EXIST=new y.RawContextKey("breakpointsExist",!1,{type:"boolean",description:r.localize(31,null)}),e.CONTEXT_DEBUGGERS_AVAILABLE=new y.RawContextKey("debuggersAvailable",!1,{type:"boolean",description:r.localize(32,null)}),e.CONTEXT_DEBUG_EXTENSION_AVAILABLE=new y.RawContextKey("debugExtensionAvailable",!1,{type:"boolean",description:r.localize(33,null)}),e.CONTEXT_DEBUG_PROTOCOL_VARIABLE_MENU_CONTEXT=new y.RawContextKey("debugProtocolVariableMenuContext",void 0,{type:"string",description:r.localize(34,null)}),e.CONTEXT_SET_VARIABLE_SUPPORTED=new y.RawContextKey("debugSetVariableSupported",!1,{type:"boolean",description:r.localize(35,null)}),e.CONTEXT_SET_EXPRESSION_SUPPORTED=new y.RawContextKey("debugSetExpressionSupported",!1,{type:"boolean",description:r.localize(36,null)}),e.CONTEXT_BREAK_WHEN_VALUE_CHANGES_SUPPORTED=new y.RawContextKey("breakWhenValueChangesSupported",!1,{type:"boolean",description:r.localize(37,null)}),e.CONTEXT_BREAK_WHEN_VALUE_IS_ACCESSED_SUPPORTED=new y.RawContextKey("breakWhenValueIsAccessedSupported",!1,{type:"boolean",description:r.localize(38,null)}),e.CONTEXT_BREAK_WHEN_VALUE_IS_READ_SUPPORTED=new y.RawContextKey("breakWhenValueIsReadSupported",!1,{type:"boolean",description:r.localize(39,null)}),e.CONTEXT_TERMINATE_DEBUGGEE_SUPPORTED=new y.RawContextKey("terminateDebuggeeSupported",!1,{type:"boolean",description:r.localize(40,null)}),e.CONTEXT_SUSPEND_DEBUGGEE_SUPPORTED=new y.RawContextKey("suspendDebuggeeSupported",!1,{type:"boolean",description:r.localize(41,null)}),e.CONTEXT_VARIABLE_EVALUATE_NAME_PRESENT=new y.RawContextKey("variableEvaluateNamePresent",!1,{type:"boolean",description:r.localize(42,null)}),e.CONTEXT_VARIABLE_IS_READONLY=new y.RawContextKey("variableIsReadonly",!1,{type:"boolean",description:r.localize(43,null)}),e.CONTEXT_EXCEPTION_WIDGET_VISIBLE=new y.RawContextKey("exceptionWidgetVisible",!1,{type:"boolean",description:r.localize(44,null)}),e.CONTEXT_MULTI_SESSION_REPL=new y.RawContextKey("multiSessionRepl",!1,{type:"boolean",description:r.localize(45,null)}),e.CONTEXT_MULTI_SESSION_DEBUG=new y.RawContextKey("multiSessionDebug",!1,{type:"boolean",description:r.localize(46,null)}),e.CONTEXT_DISASSEMBLE_REQUEST_SUPPORTED=new y.RawContextKey("disassembleRequestSupported",!1,{type:"boolean",description:r.localize(47,null)}),e.CONTEXT_DISASSEMBLY_VIEW_FOCUS=new y.RawContextKey("disassemblyViewFocus",!1,{type:"boolean",description:r.localize(48,null)}),e.CONTEXT_LANGUAGE_SUPPORTS_DISASSEMBLE_REQUEST=new y.RawContextKey("languageSupportsDisassembleRequest",!1,{type:"boolean",description:r.localize(49,null)}),e.CONTEXT_FOCUSED_STACK_FRAME_HAS_INSTRUCTION_POINTER_REFERENCE=new y.RawContextKey("focusedStackFrameHasInstructionReference",!1,{type:"boolean",description:r.localize(50,null)});const M=m=>r.localize(51,null,m);e.debuggerDisabledMessage=M,e.EDITOR_CONTRIBUTION_ID="editor.contrib.debug",e.BREAKPOINT_EDITOR_CONTRIBUTION_ID="editor.contrib.breakpoint",e.DEBUG_SCHEME="debug",e.INTERNAL_CONSOLE_OPTIONS_SCHEMA={enum:["neverOpen","openOnSessionStart","openOnFirstSessionStart"],default:"openOnFirstSessionStart",description:r.localize(52,null)};var _;(function(m){m[m.Inactive=0]="Inactive",m[m.Initializing=1]="Initializing",m[m.Stopped=2]="Stopped",m[m.Running=3]="Running"})(_=e.State||(e.State={}));function A(m){switch(m){case 1:return"initializing";case 2:return"stopped";case 3:return"running";default:return"inactive"}}e.getStateLabel=A;var b;(function(m){m[m.Valid=0]="Valid",m[m.Unreadable=1]="Unreadable",m[m.Error=2]="Error"})(b=e.MemoryRangeType||(e.MemoryRangeType={})),e.DEBUG_MEMORY_SCHEME="vscode-debug-memory";var P;(function(m){m[m.Initial=1]="Initial",m[m.Dynamic=2]="Dynamic"})(P=e.DebugConfigurationProviderTriggerKind||(e.DebugConfigurationProviderTriggerKind={}));var O;(function(m){m.UnverifiedBreakpoints="unverifiedBreakpoints"})(O=e.DebuggerString||(e.DebuggerString={})),e.IDebugService=(0,S.createDecorator)(e.DEBUG_SERVICE_ID);var E;(function(m){m[m.CONDITION=0]="CONDITION",m[m.HIT_COUNT=1]="HIT_COUNT",m[m.LOG_MESSAGE=2]="LOG_MESSAGE"})(E=e.BreakpointWidgetContext||(e.BreakpointWidgetContext={}))}),define(Ce[165],Ie([1,0,9,2,19,26,13]),function(ie,e,r,y,S,M,_){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.saveAllBeforeDebugStart=e.getVisibleAndSorted=e.convertToVSCPaths=e.convertToDAPaths=e.isUri=e.getExactExpressionStartAndEnd=e.isDebuggerMainContribution=e.getExtensionHostDebugSession=e.isSessionAttach=e.filterExceptionsFromTelemetry=e.formatPII=void 0;const A=/{([^}]+)}/g;function b(i,n,s){return i.replace(A,function(a,o){return n&&o.length>0&&o[0]!=="_"?a:s&&s.hasOwnProperty(o)?s[o]:a})}e.formatPII=b;function P(i){const n={};for(const s of Object.keys(i))s.startsWith("!")||(n[s]=i[s]);return n}e.filterExceptionsFromTelemetry=P;function O(i){return i.configuration.request==="attach"&&!E(i)&&(!i.parentSession||O(i.parentSession))}e.isSessionAttach=O;function E(i){let n=i.configuration.type;if(!!n)return n==="vslsShare"&&(n=i.configuration.adapterProxy.configuration.type),(0,r.equalsIgnoreCase)(n,"extensionhost")||(0,r.equalsIgnoreCase)(n,"pwa-extensionhost")?i:i.parentSession?E(i.parentSession):void 0}e.getExtensionHostDebugSession=E;function m(i){return i.type&&(i.label||i.program||i.runtime)}e.isDebuggerMainContribution=m;function k(i,n,s){let a,o=0;const v=/([^()\[\]{}<>\s+\-/%~#^;=|,`!]|\->)+/g;let p=null;for(;p=v.exec(i);){const T=p.index+1,N=T+p[0].length;if(T<=n&&N>=s){a=p[0],o=T;break}}if(a){const T=/\w+/g;let N=null;for(;(N=T.exec(a))&&!(N.index+1+o+N[0].length>=s););N&&(a=a.substring(0,T.lastIndex))}return a?{start:o,end:o+a.length-1}:{start:0,end:0}}e.getExactExpressionStartAndEnd=k;const f=/^[a-zA-Z][a-zA-Z0-9\+\-\.]+:/;function c(i){return!!(i&&i.match(f))}e.isUri=c;function d(i){if(typeof i.path=="string"&&!(typeof i.sourceReference=="number"&&i.sourceReference>0)){if(c(i.path))return y.URI.parse(i.path);if((0,S.isAbsolute)(i.path))return y.URI.file(i.path)}return i.path}function h(i){if(typeof i.path=="object"){const n=y.URI.revive(i.path);if(n)return n.scheme===_.Schemas.file?n.fsPath:n.toString()}return i.path}function g(i,n){const s=n?d:h,a=(0,M.deepClone)(i);return l(a,(o,v)=>{o&&v&&(v.path=s(v))}),a}e.convertToDAPaths=g;function C(i,n){const s=n?d:h,a=(0,M.deepClone)(i);return l(a,(o,v)=>{!o&&v&&(v.path=s(v))}),a}e.convertToVSCPaths=C;function l(i,n){switch(i.type){case"event":{const s=i;switch(s.event){case"output":n(!1,s.body.source);break;case"loadedSource":n(!1,s.body.source);break;case"breakpoint":n(!1,s.body.breakpoint.source);break;default:break}break}case"request":{const s=i;switch(s.command){case"setBreakpoints":n(!0,s.arguments.source);break;case"breakpointLocations":n(!0,s.arguments.source);break;case"source":n(!0,s.arguments.source);break;case"gotoTargets":n(!0,s.arguments.source);break;case"launchVSCode":s.arguments.args.forEach(a=>n(!1,a));break;default:break}break}case"response":{const s=i;if(s.success&&s.body)switch(s.command){case"stackTrace":s.body.stackFrames.forEach(a=>n(!1,a.source));break;case"loadedSources":s.body.sources.forEach(a=>n(!1,a));break;case"scopes":s.body.scopes.forEach(a=>n(!1,a.source));break;case"setFunctionBreakpoints":s.body.breakpoints.forEach(a=>n(!1,a.source));break;case"setBreakpoints":s.body.breakpoints.forEach(a=>n(!1,a.source));break;case"disassemble":s.body?.instructions.forEach(o=>n(!1,o.location));break;default:break}break}}}function w(i){return i.filter(n=>!n.presentation?.hidden).sort((n,s)=>n.presentation?s.presentation?n.presentation.group?s.presentation.group?n.presentation.group!==s.presentation.group?n.presentation.group.localeCompare(s.presentation.group):t(n.presentation.order,s.presentation.order):-1:s.presentation.group?1:t(n.presentation.order,s.presentation.order):-1:s.presentation?1:0)}e.getVisibleAndSorted=w;function t(i,n){return typeof i!="number"?typeof n!="number"?0:1:typeof n!="number"?-1:i-n}async function u(i,n){const s=i.getValue("debug.saveBeforeStart",{overrideIdentifier:n.activeTextEditorLanguageId});if(s!=="none"&&(await n.saveAll(),s==="allEditorsInActiveGroup")){const a=n.activeEditorPane;a&&a.input.resource?.scheme===_.Schemas.untitled&&await n.save({editor:a.input,groupId:a.group.id})}await i.reloadConfiguration()}e.saveAllBeforeDebugStart=u}),define(Ce[64],Ie([1,0,23,34,166,75,13,19,21,39]),function(ie,e,r,y,S,M,_,A,b,P){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.isTextStreamMime=e.NotebookWorkingCopyTypeIdentifier=e.CellStatusbarAlignment=e.NotebookSetting=e.notebookDocumentFilterMatch=e.isDocumentExcludePattern=e.NotebookEditorPriority=e.NOTEBOOK_EDITOR_CURSOR_BOUNDARY=e.diff=e.MimeTypeDisplayOrder=e.CellUri=e.CellEditType=e.SelectionStateType=e.NotebookCellsChangeType=e.RendererMessagingSpec=e.NotebookRendererMatch=e.NotebookCellExecutionState=e.NotebookRunState=e.RENDERER_NOT_AVAILABLE=e.RENDERER_EQUIVALENT_EXTENSIONS=e.ACCESSIBLE_NOTEBOOK_DISPLAY_ORDER=e.NOTEBOOK_DISPLAY_ORDER=e.CellKind=e.NOTEBOOK_DIFF_EDITOR_ID=e.NOTEBOOK_EDITOR_ID=void 0,e.NOTEBOOK_EDITOR_ID="workbench.editor.notebook",e.NOTEBOOK_DIFF_EDITOR_ID="workbench.editor.notebookTextDiffEditor";var O;(function(o){o[o.Markup=1]="Markup",o[o.Code=2]="Code"})(O=e.CellKind||(e.CellKind={})),e.NOTEBOOK_DISPLAY_ORDER=["application/json","application/javascript","text/html","image/svg+xml",M.Mimes.latex,M.Mimes.markdown,"image/png","image/jpeg",M.Mimes.text],e.ACCESSIBLE_NOTEBOOK_DISPLAY_ORDER=[M.Mimes.latex,M.Mimes.markdown,"application/json",M.Mimes.text,"text/html","image/svg+xml","image/png","image/jpeg"],e.RENDERER_EQUIVALENT_EXTENSIONS=new Map([["ms-toolsai.jupyter",new Set(["jupyter-notebook","interactive"])],["ms-toolsai.jupyter-renderers",new Set(["jupyter-notebook","interactive"])]]),e.RENDERER_NOT_AVAILABLE="_notAvailable";var E;(function(o){o[o.Running=1]="Running",o[o.Idle=2]="Idle"})(E=e.NotebookRunState||(e.NotebookRunState={}));var m;(function(o){o[o.Unconfirmed=1]="Unconfirmed",o[o.Pending=2]="Pending",o[o.Executing=3]="Executing"})(m=e.NotebookCellExecutionState||(e.NotebookCellExecutionState={}));var k;(function(o){o[o.WithHardKernelDependency=0]="WithHardKernelDependency",o[o.WithOptionalKernelDependency=1]="WithOptionalKernelDependency",o[o.Pure=2]="Pure",o[o.Never=3]="Never"})(k=e.NotebookRendererMatch||(e.NotebookRendererMatch={}));var f;(function(o){o.Always="always",o.Never="never",o.Optional="optional"})(f=e.RendererMessagingSpec||(e.RendererMessagingSpec={}));var c;(function(o){o[o.ModelChange=1]="ModelChange",o[o.Move=2]="Move",o[o.ChangeCellLanguage=5]="ChangeCellLanguage",o[o.Initialize=6]="Initialize",o[o.ChangeCellMetadata=7]="ChangeCellMetadata",o[o.Output=8]="Output",o[o.OutputItem=9]="OutputItem",o[o.ChangeCellContent=10]="ChangeCellContent",o[o.ChangeDocumentMetadata=11]="ChangeDocumentMetadata",o[o.ChangeCellInternalMetadata=12]="ChangeCellInternalMetadata",o[o.ChangeCellMime=13]="ChangeCellMime",o[o.Unknown=100]="Unknown"})(c=e.NotebookCellsChangeType||(e.NotebookCellsChangeType={}));var d;(function(o){o[o.Handle=0]="Handle",o[o.Index=1]="Index"})(d=e.SelectionStateType||(e.SelectionStateType={}));var h;(function(o){o[o.Replace=1]="Replace",o[o.Output=2]="Output",o[o.Metadata=3]="Metadata",o[o.CellLanguage=4]="CellLanguage",o[o.DocumentMetadata=5]="DocumentMetadata",o[o.Move=6]="Move",o[o.OutputItems=7]="OutputItems",o[o.PartialMetadata=8]="PartialMetadata",o[o.PartialInternalMetadata=9]="PartialInternalMetadata"})(h=e.CellEditType||(e.CellEditType={}));var g;(function(o){o.scheme=_.Schemas.vscodeNotebookCell;const v=["W","X","Y","Z","a","b","c","d","e","f"],p=new RegExp(`^[${v.join("")}]+`),T=7;function N(R,K){const W=K.toString(T),G=`${W.length<v.length?v[W.length-1]:"z"}${W}s${(0,r.encodeBase64)(r.VSBuffer.fromString(R.scheme),!0,!0)}`;return R.with({scheme:o.scheme,fragment:G})}o.generate=N;function V(R){if(R.scheme!==o.scheme)return;const K=R.fragment.indexOf("s");if(K<0)return;const W=parseInt(R.fragment.substring(0,K).replace(p,""),T),$=(0,r.decodeBase64)(R.fragment.substring(K+1)).toString();if(!isNaN(W))return{handle:W,notebook:R.with({scheme:$,fragment:null})}}o.parse=V;function B(R,K){return R.with({scheme:_.Schemas.vscodeNotebookCellOutput,fragment:`op${K??""},${R.scheme!==_.Schemas.file?R.scheme:""}`})}o.generateCellOutputUri=B;function D(R){if(R.scheme!==_.Schemas.vscodeNotebookCellOutput)return;const K=/^op([0-9a-f]{8}-[0-9a-f]{4}-[0-9a-f]{4}-[0-9a-f]{4}-[0-9a-f]{12})?\,(.*)$/i.exec(R.fragment);if(!K)return;const W=K[1]&&K[1]!==""?K[1]:void 0,$=K[2];return{outputId:W,notebook:R.with({scheme:$||_.Schemas.file,fragment:null})}}o.parseCellOutputUri=D;function z(R,K,W){return o.generate(R,K).with({scheme:W})}o.generateCellPropertyUri=z;function L(R,K){if(R.scheme===K)return o.parse(R.with({scheme:o.scheme}))}o.parseCellPropertyUri=L})(g=e.CellUri||(e.CellUri={}));const C=o=>b.isWindows?o.replace(/\//g,"\\"):o;class l{constructor(v=[],p=e.NOTEBOOK_DISPLAY_ORDER){this.defaultOrder=p,this.order=[...new Set(v)].map(T=>({pattern:T,matches:y.parse(C(T))}))}sort(v){const p=new Map(S.Iterable.map(v,N=>[N,C(N)]));let T=[];for(const{matches:N}of this.order)for(const[V,B]of p)if(N(B)){T.push(V),p.delete(V);break}return p.size&&(T=T.concat([...p.keys()].sort((N,V)=>this.defaultOrder.indexOf(N)-this.defaultOrder.indexOf(V)))),T}prioritize(v,p){const T=this.findIndex(v);if(T===-1){this.order.unshift({pattern:v,matches:y.parse(C(v))});return}const N=new Set(p.map(B=>this.findIndex(B,T)));N.delete(-1);const V=Array.from(N).sort();this.order.splice(T+1,0,...V.map(B=>this.order[B]));for(let B=V.length-1;B>=0;B--)this.order.splice(V[B],1)}toArray(){return this.order.map(v=>v.pattern)}findIndex(v,p=this.order.length){const T=C(v);for(let N=0;N<p;N++)if(this.order[N].matches(T))return N;return-1}}e.MimeTypeDisplayOrder=l;function w(o,v,p,T=(N,V)=>N===V){const N=[];function V(z,L,R){if(L===0&&R.length===0)return;const K=N[N.length-1];K&&K.start+K.deleteCount===z?(K.deleteCount+=L,K.toInsert.push(...R)):N.push({start:z,deleteCount:L,toInsert:R})}let B=0,D=0;for(;;){if(B===o.length){V(B,0,v.slice(D));break}if(D===v.length){V(B,o.length-B,[]);break}const z=o[B],L=v[D];if(T(z,L)){B+=1,D+=1;continue}p(L)?(V(B,1,[]),B+=1):(V(B,0,[L]),D+=1)}return N}e.diff=w,e.NOTEBOOK_EDITOR_CURSOR_BOUNDARY=new P.RawContextKey("notebookEditorCursorAtBoundary","none");var t;(function(o){o.default="default",o.option="option"})(t=e.NotebookEditorPriority||(e.NotebookEditorPriority={}));function u(o){const v=o;return!!((typeof v.include=="string"||y.isRelativePattern(v.include))&&(typeof v.exclude=="string"||y.isRelativePattern(v.exclude)))}e.isDocumentExcludePattern=u;function i(o,v,p){if(Array.isArray(o.viewType)&&o.viewType.indexOf(v)>=0||o.viewType===v)return!0;if(o.filenamePattern){const T=u(o.filenamePattern)?o.filenamePattern.include:o.filenamePattern,N=u(o.filenamePattern)?o.filenamePattern.exclude:void 0;if(y.match(T,(0,A.basename)(p.fsPath).toLowerCase()))return!(N&&y.match(N,(0,A.basename)(p.fsPath).toLowerCase()))}return!1}e.notebookDocumentFilterMatch=i,e.NotebookSetting={displayOrder:"notebook.displayOrder",cellToolbarLocation:"notebook.cellToolbarLocation",cellToolbarVisibility:"notebook.cellToolbarVisibility",showCellStatusBar:"notebook.showCellStatusBar",textDiffEditorPreview:"notebook.diff.enablePreview",experimentalInsertToolbarAlignment:"notebook.experimental.insertToolbarAlignment",compactView:"notebook.compactView",focusIndicator:"notebook.cellFocusIndicator",insertToolbarLocation:"notebook.insertToolbarLocation",globalToolbar:"notebook.globalToolbar",undoRedoPerCell:"notebook.undoRedoPerCell",consolidatedOutputButton:"notebook.consolidatedOutputButton",showFoldingControls:"notebook.showFoldingControls",dragAndDropEnabled:"notebook.dragAndDropEnabled",cellEditorOptionsCustomizations:"notebook.editorOptionsCustomizations",consolidatedRunButton:"notebook.consolidatedRunButton",openGettingStarted:"notebook.experimental.openGettingStarted",textOutputLineLimit:"notebook.output.textLineLimit",globalToolbarShowLabel:"notebook.globalToolbarShowLabel",markupFontSize:"notebook.markup.fontSize",interactiveWindowCollapseCodeCells:"interactiveWindow.collapseCellInputCode",outputLineHeight:"notebook.outputLineHeight",outputFontSize:"notebook.outputFontSize",outputFontFamily:"notebook.outputFontFamily"};var n;(function(o){o[o.Left=1]="Left",o[o.Right=2]="Right"})(n=e.CellStatusbarAlignment||(e.CellStatusbarAlignment={}));class s{static create(v){return`${s._prefix}${v}`}static parse(v){if(v.startsWith(s._prefix))return v.substring(s._prefix.length)}}e.NotebookWorkingCopyTypeIdentifier=s,s._prefix="notebook/";function a(o){return["application/vnd.code.notebook.stdout","application/x.notebook.stdout","application/x.notebook.stream","application/vnd.code.notebook.stderr","application/x.notebook.stderr"].includes(o)}e.isTextStreamMime=a}),define(Ce[167],Ie([1,0,3]),function(ie,e,r){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.INotebookExecutionService=e.CellExecutionUpdateType=void 0;var y;(function(S){S[S.Output=1]="Output",S[S.OutputItems=2]="OutputItems",S[S.ExecutionState=3]="ExecutionState"})(y=e.CellExecutionUpdateType||(e.CellExecutionUpdateType={})),e.INotebookExecutionService=(0,r.createDecorator)("INotebookExecutionService")}),define(Ce[168],Ie([1,0]),function(ie,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.deserializeEnvironmentVariableCollections=e.serializeEnvironmentVariableCollections=e.deserializeEnvironmentVariableCollection=e.serializeEnvironmentVariableCollection=void 0;function r(_){return[..._.entries()]}e.serializeEnvironmentVariableCollection=r;function y(_){return new Map(_)}e.deserializeEnvironmentVariableCollection=y;function S(_){return Array.from(_.entries()).map(A=>[A[0],r(A[1].map)])}e.serializeEnvironmentVariableCollections=S;function M(_){return new Map(_.map(A=>[A[0],{map:y(A[1])}]))}e.deserializeEnvironmentVariableCollections=M}),define(Ce[47],Ie([1,0]),function(ie,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.TestId=e.TestPosition=e.TestIdPathParts=void 0;var r;(function(M){M.Delimiter="\0"})(r=e.TestIdPathParts||(e.TestIdPathParts={}));var y;(function(M){M[M.IsSame=0]="IsSame",M[M.Disconnected=1]="Disconnected",M[M.IsChild=2]="IsChild",M[M.IsParent=3]="IsParent"})(y=e.TestPosition||(e.TestPosition={}));class S{static fromExtHostTestItem(_,A,b=_.parent){if(_.id===A)return new S([A]);const P=[_.id];for(let O=b;O&&O.id!==A;O=O.parent)P.push(O.id);return P.push(A),new S(P.reverse())}static isRoot(_){return!_.includes("\0")}static root(_){const A=_.indexOf("\0");return A===-1?_:_.slice(0,A)}static fromString(_){return new S(_.split("\0"))}static join(_,A){return new S([..._.path,A])}static joinToString(_,A){return _.toString()+"\0"+A}static compare(_,A){return _===A?0:A.startsWith(_+"\0")?2:_.startsWith(A+"\0")?3:1}constructor(_,A=_.length){if(this.path=_,this.viewEnd=A,_.length===0||A<1)throw new Error("cannot create test with empty path")}get parentId(){return this.viewEnd>1?new S(this.path,this.viewEnd-1):this}get localId(){return this.path[this.viewEnd-1]}get controllerId(){return this.path[0]}get isRoot(){return this.viewEnd===1}*idsFromRoot(){for(let _=1;_<=this.viewEnd;_++)yield new S(this.path,_)}compare(_){if(typeof _=="string")return S.compare(this.toString(),_);for(let A=0;A<_.viewEnd&&A<this.viewEnd;A++)if(_.path[A]!==this.path[A])return 1;return _.viewEnd>this.viewEnd?2:_.viewEnd<this.viewEnd?3:0}toJSON(){return this.toString()}toString(){if(!this.stringifed){this.stringifed=this.path[0];for(let _=1;_<this.viewEnd;_++)this.stringifed+="\0",this.stringifed+=this.path[_]}return this.stringifed}}e.TestId=S}),define(Ce[48],Ie([1,0,2,49]),function(ie,e,r,y){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.AbstractIncrementalTestCollection=e.IncrementalChangeCollector=e.TestsDiffOp=e.TestDiffOpType=e.DetailType=e.TestResultItem=e.applyTestItemUpdate=e.ITestItemUpdate=e.InternalTestItem=e.TestItemExpandState=e.ITestItem=e.denamespaceTestTag=e.namespaceTestTag=e.ITestTaskState=e.ITestMessage=e.ITestOutputMessage=e.ITestErrorMessage=e.TestMessageType=e.IRichLocation=e.testRunProfileBitsetList=e.TestRunProfileBitset=e.TestResultState=void 0;var S;(function(s){s[s.Unset=0]="Unset",s[s.Queued=1]="Queued",s[s.Running=2]="Running",s[s.Passed=3]="Passed",s[s.Failed=4]="Failed",s[s.Skipped=5]="Skipped",s[s.Errored=6]="Errored"})(S=e.TestResultState||(e.TestResultState={}));var M;(function(s){s[s.Run=2]="Run",s[s.Debug=4]="Debug",s[s.Coverage=8]="Coverage",s[s.HasNonDefaultProfile=16]="HasNonDefaultProfile",s[s.HasConfigurable=32]="HasConfigurable"})(M=e.TestRunProfileBitset||(e.TestRunProfileBitset={})),e.testRunProfileBitsetList=[2,4,8,16];var _;(function(s){s.serialize=a=>({range:a.range.toJSON(),uri:a.uri.toJSON()}),s.deserialize=a=>({range:y.Range.lift(a.range),uri:r.URI.revive(a.uri)})})(_=e.IRichLocation||(e.IRichLocation={}));var A;(function(s){s[s.Error=0]="Error",s[s.Output=1]="Output"})(A=e.TestMessageType||(e.TestMessageType={}));var b;(function(s){s.serialize=a=>({message:a.message,type:0,expected:a.expected,actual:a.actual,location:a.location&&_.serialize(a.location)}),s.deserialize=a=>({message:a.message,type:0,expected:a.expected,actual:a.actual,location:a.location&&_.deserialize(a.location)})})(b=e.ITestErrorMessage||(e.ITestErrorMessage={}));var P;(function(s){s.serialize=a=>({message:a.message,type:1,offset:a.offset,length:a.length,location:a.location&&_.serialize(a.location)}),s.deserialize=a=>({message:a.message,type:1,offset:a.offset,length:a.length,location:a.location&&_.deserialize(a.location)})})(P=e.ITestOutputMessage||(e.ITestOutputMessage={}));var O;(function(s){s.serialize=a=>a.type===0?b.serialize(a):P.serialize(a),s.deserialize=a=>a.type===0?b.deserialize(a):P.deserialize(a)})(O=e.ITestMessage||(e.ITestMessage={}));var E;(function(s){s.serializeWithoutMessages=a=>({state:a.state,duration:a.duration,messages:[]}),s.serialize=a=>({state:a.state,duration:a.duration,messages:a.messages.map(O.serialize)}),s.deserialize=a=>({state:a.state,duration:a.duration,messages:a.messages.map(O.deserialize)})})(E=e.ITestTaskState||(e.ITestTaskState={}));const m="\0",k=(s,a)=>s+m+a;e.namespaceTestTag=k;const f=s=>{const a=s.indexOf(m);return{ctrlId:s.slice(0,a),tagId:s.slice(a+1)}};e.denamespaceTestTag=f;var c;(function(s){s.serialize=a=>({extId:a.extId,label:a.label,tags:a.tags,busy:a.busy,children:void 0,uri:a.uri?.toJSON(),range:a.range?.toJSON()||null,description:a.description,error:a.error,sortText:a.sortText}),s.deserialize=a=>({extId:a.extId,label:a.label,tags:a.tags,busy:a.busy,children:void 0,uri:a.uri?r.URI.revive(a.uri):void 0,range:a.range?y.Range.lift(a.range):null,description:a.description,error:a.error,sortText:a.sortText})})(c=e.ITestItem||(e.ITestItem={}));var d;(function(s){s[s.NotExpandable=0]="NotExpandable",s[s.Expandable=1]="Expandable",s[s.BusyExpanding=2]="BusyExpanding",s[s.Expanded=3]="Expanded"})(d=e.TestItemExpandState||(e.TestItemExpandState={}));var h;(function(s){s.serialize=a=>({controllerId:a.controllerId,expand:a.expand,parent:a.parent,item:c.serialize(a.item)}),s.deserialize=a=>({controllerId:a.controllerId,expand:a.expand,parent:a.parent,item:c.deserialize(a.item)})})(h=e.InternalTestItem||(e.InternalTestItem={}));var g;(function(s){s.serialize=a=>{let o;return a.item&&(o={},a.item.label!==void 0&&(o.label=a.item.label),a.item.tags!==void 0&&(o.tags=a.item.tags),a.item.busy!==void 0&&(o.busy=a.item.busy),a.item.uri!==void 0&&(o.uri=a.item.uri?.toJSON()),a.item.range!==void 0&&(o.range=a.item.range?.toJSON()),a.item.description!==void 0&&(o.description=a.item.description),a.item.error!==void 0&&(o.error=a.item.error),a.item.sortText!==void 0&&(o.sortText=a.item.sortText)),{extId:a.extId,expand:a.expand,item:o}},s.deserialize=a=>{let o;return a.item&&(o={},a.item.label!==void 0&&(o.label=a.item.label),a.item.tags!==void 0&&(o.tags=a.item.tags),a.item.busy!==void 0&&(o.busy=a.item.busy),a.item.range!==void 0&&(o.range=a.item.range?y.Range.lift(a.item.range):null),a.item.description!==void 0&&(o.description=a.item.description),a.item.error!==void 0&&(o.error=a.item.error),a.item.sortText!==void 0&&(o.sortText=a.item.sortText)),{extId:a.extId,expand:a.expand,item:o}}})(g=e.ITestItemUpdate||(e.ITestItemUpdate={}));const C=(s,a)=>{a.expand!==void 0&&(s.expand=a.expand),a.item!==void 0&&(s.item=s.item?Object.assign(s.item,a.item):a.item)};e.applyTestItemUpdate=C;var l;(function(s){s.serializeWithoutMessages=a=>({...h.serialize(a),ownComputedState:a.ownComputedState,computedState:a.computedState,tasks:a.tasks.map(E.serializeWithoutMessages),retired:a.retired}),s.serialize=a=>({...h.serialize(a),ownComputedState:a.ownComputedState,computedState:a.computedState,tasks:a.tasks.map(E.serialize),retired:a.retired})})(l=e.TestResultItem||(e.TestResultItem={}));var w;(function(s){s[s.Function=0]="Function",s[s.Statement=1]="Statement"})(w=e.DetailType||(e.DetailType={}));var t;(function(s){s[s.Add=0]="Add",s[s.Update=1]="Update",s[s.DocumentSynced=2]="DocumentSynced",s[s.Remove=3]="Remove",s[s.IncrementPendingExtHosts=4]="IncrementPendingExtHosts",s[s.Retire=5]="Retire",s[s.AddTag=6]="AddTag",s[s.RemoveTag=7]="RemoveTag"})(t=e.TestDiffOpType||(e.TestDiffOpType={}));var u;(function(s){s.deserialize=a=>a.op===0?{op:a.op,item:h.deserialize(a.item)}:a.op===1?{op:a.op,item:g.deserialize(a.item)}:a.op===2?{op:a.op,uri:r.URI.revive(a.uri),docv:a.docv}:a,s.serialize=a=>a.op===0?{op:a.op,item:h.serialize(a.item)}:a.op===1?{op:a.op,item:g.serialize(a.item)}:a})(u=e.TestsDiffOp||(e.TestsDiffOp={}));class i{add(a){}update(a){}remove(a,o){}complete(){}}e.IncrementalChangeCollector=i;class n{constructor(){this._tags=new Map,this.items=new Map,this.roots=new Set,this.busyControllerCount=0,this.pendingRootCount=0,this.tags=this._tags}apply(a){const o=this.createChangeCollector();for(const v of a)switch(v.op){case 0:{const p=h.deserialize(v.item);if(p.parent){if(this.items.has(p.parent)){const T=this.items.get(p.parent);T.children.add(p.item.extId);const N=this.createItem(p,T);this.items.set(p.item.extId,N),o.add(N)}}else{const T=this.createItem(p);this.roots.add(T),this.items.set(p.item.extId,T),o.add(T)}p.expand===2&&this.busyControllerCount++;break}case 1:{const p=g.deserialize(v.item),T=this.items.get(p.extId);if(!T)break;p.expand!==void 0&&(T.expand===2&&this.busyControllerCount--,p.expand===2&&this.busyControllerCount++),(0,e.applyTestItemUpdate)(T,p),o.update(T);break}case 3:{const p=this.items.get(v.itemId);if(!p)break;p.parent?this.items.get(p.parent).children.delete(p.item.extId):this.roots.delete(p);const T=[[v.itemId]];for(;T.length;)for(const N of T.pop()){const V=this.items.get(N);V&&(T.push(V.children),this.items.delete(N),o.remove(V,V!==p),V.expand===2&&this.busyControllerCount--)}break}case 5:this.retireTest(v.itemId);break;case 4:this.updatePendingRoots(v.amount);break;case 6:this._tags.set(v.tag.id,v.tag);break;case 7:this._tags.delete(v.id);break}o.complete()}retireTest(a){}updatePendingRoots(a){this.pendingRootCount+=a}createChangeCollector(){return new i}}e.AbstractIncrementalTestCollection=n}),define(Ce[65],Ie([1,0,15,5,7,44,48,47]),function(ie,e,r,y,S,M,_,A){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.createTestItemChildren=e.MixedTestItemController=e.InvalidTestItemError=e.DuplicateTestItemError=e.TestItemCollection=e.TestItemEventOp=void 0;var b;(function(h){h[h.Upsert=0]="Upsert",h[h.SetTags=1]="SetTags",h[h.UpdateCanResolveChildren=2]="UpdateCanResolveChildren",h[h.RemoveChild=3]="RemoveChild",h[h.SetProp=4]="SetProp",h[h.Bulk=5]="Bulk",h[h.DocumentSynced=6]="DocumentSynced"})(b=e.TestItemEventOp||(e.TestItemEventOp={}));const P=(h,g)=>h===g,O={range:(h,g)=>h===g?!0:!h||!g?!1:h.equalsRange(g),busy:P,label:P,description:P,error:P,tags:(h,g)=>!(h.length!==g.length||h.some(C=>!g.includes(C)))},E=(h,g)=>{let C;for(const[l,w]of Object.entries(O))w(h[l],g[l])||(C?C[l]=g[l]:C={[l]:g[l]});return C};class m extends S.Disposable{get root(){return this.options.root}constructor(g){super(),this.options=g,this.debounceSendDiff=this._register(new r.RunOnceScheduler(()=>this.flushDiff(),200)),this.diffOpEmitter=this._register(new y.Emitter),this.tree=new Map,this.tags=new Map,this.diff=[],this.onDidGenerateDiff=this.diffOpEmitter.event,this.root.canResolveChildren=!0,this.upsertItem(this.root,void 0)}set resolveHandler(g){this._resolveHandler=g;for(const C of this.tree.values())this.updateExpandability(C)}collectDiff(){const g=this.diff;return this.diff=[],g}pushDiff(g){switch(g.op){case 2:{for(const C of this.diff)if(C.op===2&&C.uri===g.uri){C.docv=g.docv;return}break}case 1:{const C=this.diff[this.diff.length-1];if(C){if(C.op===1&&C.item.extId===g.item.extId){(0,_.applyTestItemUpdate)(C.item,g.item);return}if(C.op===0&&C.item.item.extId===g.item.extId){(0,_.applyTestItemUpdate)(C.item,g.item);return}}break}}this.diff.push(g),this.debounceSendDiff.isScheduled()||this.debounceSendDiff.schedule()}expand(g,C){const l=this.tree.get(g);if(!!l){if((l.expandLevels===void 0||C>l.expandLevels)&&(l.expandLevels=C),l.expand===1){const w=this.resolveChildren(l);return w.isOpen()?this.expandChildren(l,C-1):w.wait().then(()=>this.expandChildren(l,C-1))}else if(l.expand===3)return l.resolveBarrier?.isOpen()===!1?l.resolveBarrier.wait().then(()=>this.expandChildren(l,C-1)):this.expandChildren(l,C-1)}}dispose(){for(const g of this.tree.values())this.options.getApiFor(g.actual).listener=void 0;this.tree.clear(),this.diff=[],super.dispose()}onTestItemEvent(g,C){switch(C.op){case 3:this.removeItem(A.TestId.joinToString(g.fullId,C.id));break;case 0:this.upsertItem(C.item,g);break;case 5:for(const l of C.ops)this.onTestItemEvent(g,l);break;case 1:this.diffTagRefs(C.new,C.old,g.fullId.toString());break;case 2:this.updateExpandability(g);break;case 4:this.pushDiff({op:1,item:{extId:g.fullId.toString(),item:C.update}});break;case 6:this.documentSynced(g.actual.uri);break;default:(0,M.assertNever)(C)}}documentSynced(g){g&&this.pushDiff({op:2,uri:g,docv:this.options.getDocumentVersion(g)})}upsertItem(g,C){const l=A.TestId.fromExtHostTestItem(g,this.root.id,C?.actual),w=this.options.getApiFor(g);w.parent&&w.parent!==C?.actual&&this.options.getChildren(w.parent).delete(g.id);let t=this.tree.get(l.toString());if(!t){t={fullId:l,actual:g,parent:C?l.parentId:null,expandLevels:C?.expandLevels?C.expandLevels-1:void 0,expand:0},g.tags.forEach(this.incrementTagRefs,this),this.tree.set(t.fullId.toString(),t),this.setItemParent(g,C),this.pushDiff({op:0,item:{parent:t.parent&&t.parent.toString(),controllerId:this.options.controllerId,expand:t.expand,item:this.options.toITestItem(g)}}),this.connectItemAndChildren(g,t,C);return}if(t.actual===g){this.connectItem(g,t,C);return}const u=this.options.getChildren(t.actual),i=t.actual,n=E(this.options.toITestItem(i),this.options.toITestItem(g));this.options.getApiFor(i).listener=void 0,t.actual=g,t.expand=0,n&&(n.hasOwnProperty("tags")&&(this.diffTagRefs(g.tags,i.tags,l.toString()),delete n.tags),this.onTestItemEvent(t,{op:4,update:n})),this.connectItemAndChildren(g,t,C);for(const[s,a]of u)this.options.getChildren(g).get(a.id)||this.removeItem(A.TestId.joinToString(l,a.id));this.documentSynced(t.actual.uri)}diffTagRefs(g,C,l){const w=new Set(C.map(t=>t.id));for(const t of g)w.delete(t.id)||this.incrementTagRefs(t);this.pushDiff({op:1,item:{extId:l,item:{tags:g.map(t=>(0,_.namespaceTestTag)(this.options.controllerId,t.id))}}}),w.forEach(this.decrementTagRefs,this)}incrementTagRefs(g){const C=this.tags.get(g.id);C?C.refCount++:(this.tags.set(g.id,{refCount:1}),this.pushDiff({op:6,tag:{id:(0,_.namespaceTestTag)(this.options.controllerId,g.id)}}))}decrementTagRefs(g){const C=this.tags.get(g);C&&!--C.refCount&&(this.tags.delete(g),this.pushDiff({op:7,id:(0,_.namespaceTestTag)(this.options.controllerId,g)}))}setItemParent(g,C){this.options.getApiFor(g).parent=C&&C.actual!==this.root?C.actual:void 0}connectItem(g,C,l){this.setItemParent(g,l);const w=this.options.getApiFor(g);w.parent=l?.actual,w.listener=t=>this.onTestItemEvent(C,t),this.updateExpandability(C)}connectItemAndChildren(g,C,l){this.connectItem(g,C,l);for(const[w,t]of this.options.getChildren(g))this.upsertItem(t,C)}updateExpandability(g){let C;this._resolveHandler?g.resolveBarrier?C=g.resolveBarrier.isOpen()?3:2:C=g.actual.canResolveChildren?1:0:C=0,C!==g.expand&&(g.expand=C,this.pushDiff({op:1,item:{extId:g.fullId.toString(),expand:C}}),C===1&&g.expandLevels!==void 0&&this.resolveChildren(g))}expandChildren(g,C){if(C<0)return;const l=[];for(const[w,t]of this.options.getChildren(g.actual)){const u=this.expand(A.TestId.joinToString(g.fullId,t.id),C);(0,r.isThenable)(u)&&l.push(u)}if(l.length)return Promise.all(l).then(()=>{})}resolveChildren(g){if(g.resolveBarrier)return g.resolveBarrier;if(!this._resolveHandler){const t=new r.Barrier;return t.open(),t}g.expand=2,this.pushExpandStateUpdate(g);const C=g.resolveBarrier=new r.Barrier,l=t=>{console.error(`Unhandled error in resolveHandler of test controller "${this.options.controllerId}"`,t)};let w;try{w=this._resolveHandler(g.actual===this.root?void 0:g.actual)}catch(t){l(t)}return(0,r.isThenable)(w)?w.catch(l).then(()=>{C.open(),this.updateExpandability(g)}):(C.open(),this.updateExpandability(g)),g.resolveBarrier}pushExpandStateUpdate(g){this.pushDiff({op:1,item:{extId:g.fullId.toString(),expand:g.expand}})}removeItem(g){const C=this.tree.get(g);if(!C)throw new Error("attempting to remove non-existent child");this.pushDiff({op:3,itemId:g});const l=[C];for(;l.length;){const w=l.pop();if(!!w){this.options.getApiFor(w.actual).listener=void 0;for(const t of w.actual.tags)this.decrementTagRefs(t.id);this.tree.delete(w.fullId.toString());for(const[t,u]of this.options.getChildren(w.actual))l.push(this.tree.get(A.TestId.joinToString(w.fullId,u.id)))}}}flushDiff(){const g=this.collectDiff();g.length&&this.diffOpEmitter.fire(g)}}e.TestItemCollection=m;class k extends Error{constructor(g){super(`Attempted to insert a duplicate test item ID ${g}`)}}e.DuplicateTestItemError=k;class f extends Error{constructor(g){super(`TestItem with ID "${g}" is invalid. Make sure to create it from the createTestItem method.`)}}e.InvalidTestItemError=f;class c extends Error{constructor(g,C,l){super(`TestItem with ID "${g}" is from controller "${C}" and cannot be added as a child of an item from controller "${l}".`)}}e.MixedTestItemController=c;const d=(h,g,C)=>{let l=new Map;return{get size(){return l.size},forEach(w,t){for(const u of l.values())w.call(t,u,this)},[Symbol.iterator](){return l.entries()},replace(w){const t=new Map,u=new Set(l.keys()),i={op:5,ops:[]};for(const n of w){if(!(n instanceof C))throw new f(n.id);const s=g(n).controllerId;if(s!==h.controllerId)throw new c(n.id,s,h.controllerId);if(t.has(n.id))throw new k(n.id);t.set(n.id,n),u.delete(n.id),i.ops.push({op:0,item:n})}for(const n of u.keys())i.ops.push({op:3,id:n});h.listener?.(i),l=t},add(w){if(!(w instanceof C))throw new f(w.id);l.set(w.id,w),h.listener?.({op:0,item:w})},delete(w){l.delete(w)&&h.listener?.({op:3,id:w})},get(w){return l.get(w)},toJSON(){return Array.from(l.values())}}};e.createTestItemChildren=d}),define(Ce[90],Ie([1,0,65]),function(ie,e,r){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.getPrivateApiFor=e.createPrivateApiFor=void 0;const y=new WeakMap,S=(_,A)=>{const b={controllerId:A};return y.set(_,b),b};e.createPrivateApiFor=S;const M=_=>{const A=y.get(_);if(!A)throw new r.InvalidTestItemError(_?.id||"<unknown>");return A};e.getPrivateApiFor=M}),define(Ce[169],Ie([1,0,3]),function(ie,e,r){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.VariableError=e.VariableKind=e.IConfigurationResolverService=void 0,e.IConfigurationResolverService=(0,r.createDecorator)("configurationResolverService");var y;(function(M){M.Unknown="unknown",M.Env="env",M.Config="config",M.Command="command",M.Input="input",M.ExtensionInstallFolder="extensionInstallFolder",M.WorkspaceFolder="workspaceFolder",M.Cwd="cwd",M.WorkspaceFolderBasename="workspaceFolderBasename",M.UserHome="userHome",M.LineNumber="lineNumber",M.SelectedText="selectedText",M.File="file",M.FileWorkspaceFolder="fileWorkspaceFolder",M.RelativeFile="relativeFile",M.RelativeFileDirname="relativeFileDirname",M.FileDirname="fileDirname",M.FileExtname="fileExtname",M.FileBasename="fileBasename",M.FileBasenameNoExtension="fileBasenameNoExtension",M.FileDirnameBasename="fileDirnameBasename",M.ExecPath="execPath",M.ExecInstallFolder="execInstallFolder",M.PathSeparator="pathSeparator"})(y=e.VariableKind||(e.VariableKind={}));class S extends Error{constructor(_,A){super(A),this.variable=_}}e.VariableError=S}),define(Ce[170],Ie([1,0,19,59,10,26,21,78,142,169,9]),function(ie,e,r,y,S,M,_,A,b,P,O){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.AbstractVariableResolverService=void 0;class E{constructor(k,f,c,d){this._contributedVariables=new Map,this._context=k,this._labelService=f,this._userHomePromise=c,d&&(this._envVariablesPromise=d.then(h=>this.prepareEnv(h)))}prepareEnv(k){if(_.isWindows){const f=Object.create(null);return Object.keys(k).forEach(c=>{f[c.toLowerCase()]=k[c]}),f}return k}resolveWithEnvironment(k,f,c){return this.recursiveResolve({env:this.prepareEnv(k),userHome:void 0},f?f.uri:void 0,c)}async resolveAsync(k,f){const c={env:await this._envVariablesPromise,userHome:await this._userHomePromise};return this.recursiveResolve(c,k?k.uri:void 0,f)}async resolveAnyBase(k,f,c,d){const h=M.deepClone(f);_.isWindows&&h.windows?Object.keys(h.windows).forEach(C=>h[C]=h.windows[C]):_.isMacintosh&&h.osx?Object.keys(h.osx).forEach(C=>h[C]=h.osx[C]):_.isLinux&&h.linux&&Object.keys(h.linux).forEach(C=>h[C]=h.linux[C]),delete h.windows,delete h.osx,delete h.linux;const g={env:await this._envVariablesPromise,userHome:await this._userHomePromise};return this.recursiveResolve(g,k?k.uri:void 0,h,c,d)}async resolveAnyAsync(k,f,c){return this.resolveAnyBase(k,f,c)}async resolveAnyMap(k,f,c){const d=new Map;return{newConfig:await this.resolveAnyBase(k,f,c,d),resolvedVariables:d}}resolveWithInteractionReplace(k,f,c,d){throw new Error("resolveWithInteractionReplace not implemented.")}resolveWithInteraction(k,f,c,d){throw new Error("resolveWithInteraction not implemented.")}contributeVariable(k,f){if(this._contributedVariables.has(k))throw new Error("Variable "+k+" is contributed twice.");this._contributedVariables.set(k,f)}async recursiveResolve(k,f,c,d,h){if(S.isString(c))return this.resolveString(k,f,c,d,h);if(Array.isArray(c))return Promise.all(c.map(g=>this.recursiveResolve(k,f,g,d,h)));if(S.isObject(c)){const g=Object.create(null),C=await Promise.all(Object.keys(c).map(async l=>[await this.resolveString(k,f,l,d,h),await this.recursiveResolve(k,f,c[l],d,h)]));for(const[l,w]of C)g[l]=w;return g}return c}resolveString(k,f,c,d,h){return(0,O.replaceAsync)(c,E.VARIABLE_REGEXP,async(g,C)=>{if(C.includes(E.VARIABLE_LHS))return g;let l=await this.evaluateSingleVariable(k,g,C,f,d);return h?.set(C,l),l!==g&&S.isString(l)&&l.match(E.VARIABLE_REGEXP)&&(l=await this.resolveString(k,f,l,d,h)),l})}fsPath(k){return this._labelService?this._labelService.getUriLabel(k,{noPrefix:!0}):k.fsPath}async evaluateSingleVariable(k,f,c,d,h){let g;const C=c.split(":");C.length>1&&(c=C[0],g=C[1]);const l=u=>{const i=this._context.getFilePath();if(i)return i;throw new P.VariableError(u,(0,b.localize)(0,null,f))},w=u=>{const i=l(u);if(this._context.getWorkspaceFolderPathForFile){const n=this._context.getWorkspaceFolderPathForFile();if(n)return n}throw new P.VariableError(u,(0,b.localize)(1,null,f,r.basename(i)))},t=u=>{if(g){const i=this._context.getFolderUri(g);if(i)return i;throw new P.VariableError(u,(0,b.localize)(2,null,f,g))}if(d)return d;throw this._context.getWorkspaceFolderCount()>1?new P.VariableError(u,(0,b.localize)(3,null,f)):new P.VariableError(u,(0,b.localize)(4,null,f))};switch(c){case"env":if(g){if(k.env){const u=k.env[_.isWindows?g.toLowerCase():g];if(S.isString(u))return u}return""}throw new P.VariableError(P.VariableKind.Env,(0,b.localize)(5,null,f));case"config":if(g){const u=this._context.getConfigurationValue(d,g);if(S.isUndefinedOrNull(u))throw new P.VariableError(P.VariableKind.Config,(0,b.localize)(6,null,f,g));if(S.isObject(u))throw new P.VariableError(P.VariableKind.Config,(0,b.localize)(7,null,f,g));return u}throw new P.VariableError(P.VariableKind.Config,(0,b.localize)(8,null,f));case"command":return this.resolveFromMap(P.VariableKind.Command,f,g,h,"command");case"input":return this.resolveFromMap(P.VariableKind.Input,f,g,h,"input");case"extensionInstallFolder":if(g){const u=await this._context.getExtension(g);if(!u)throw new P.VariableError(P.VariableKind.ExtensionInstallFolder,(0,b.localize)(9,null,f,g));return this.fsPath(u.extensionLocation)}throw new P.VariableError(P.VariableKind.ExtensionInstallFolder,(0,b.localize)(10,null,f));default:switch(c){case"workspaceRoot":case"workspaceFolder":return(0,A.normalizeDriveLetter)(this.fsPath(t(P.VariableKind.WorkspaceFolder)));case"cwd":return d||g?(0,A.normalizeDriveLetter)(this.fsPath(t(P.VariableKind.Cwd))):y.cwd();case"workspaceRootFolderName":case"workspaceFolderBasename":return r.basename(this.fsPath(t(P.VariableKind.WorkspaceFolderBasename)));case"userHome":{if(k.userHome)return k.userHome;throw new P.VariableError(P.VariableKind.UserHome,(0,b.localize)(11,null,f))}case"lineNumber":{const u=this._context.getLineNumber();if(u)return u;throw new P.VariableError(P.VariableKind.LineNumber,(0,b.localize)(12,null,f))}case"selectedText":{const u=this._context.getSelectedText();if(u)return u;throw new P.VariableError(P.VariableKind.SelectedText,(0,b.localize)(13,null,f))}case"file":return l(P.VariableKind.File);case"fileWorkspaceFolder":return w(P.VariableKind.FileWorkspaceFolder);case"relativeFile":return d||g?r.relative(this.fsPath(t(P.VariableKind.RelativeFile)),l(P.VariableKind.RelativeFile)):l(P.VariableKind.RelativeFile);case"relativeFileDirname":{const u=r.dirname(l(P.VariableKind.RelativeFileDirname));if(d||g){const i=r.relative(this.fsPath(t(P.VariableKind.RelativeFileDirname)),u);return i.length===0?".":i}return u}case"fileDirname":return r.dirname(l(P.VariableKind.FileDirname));case"fileExtname":return r.extname(l(P.VariableKind.FileExtname));case"fileBasename":return r.basename(l(P.VariableKind.FileBasename));case"fileBasenameNoExtension":{const u=r.basename(l(P.VariableKind.FileBasenameNoExtension));return u.slice(0,u.length-r.extname(u).length)}case"fileDirnameBasename":return r.basename(r.dirname(l(P.VariableKind.FileDirnameBasename)));case"execPath":{const u=this._context.getExecPath();return u||f}case"execInstallFolder":{const u=this._context.getAppRoot();return u||f}case"pathSeparator":return r.sep;default:try{const u=g?`${c}:${g}`:c;return this.resolveFromMap(P.VariableKind.Unknown,f,u,h,void 0)}catch{return f}}}}resolveFromMap(k,f,c,d,h){if(c&&d){const g=h===void 0?d[c]:d[h+":"+c];if(typeof g=="string")return g;throw new P.VariableError(k,(0,b.localize)(14,null,f))}return f}}e.AbstractVariableResolverService=E,E.VARIABLE_LHS="${",E.VARIABLE_REGEXP=/\$\{(.*?)\}/g}),define(Ce[91],Ie([1,0,3,89]),function(ie,e,r,y){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.preferredSideBySideGroupDirection=e.isEditorGroup=e.OpenEditorContext=e.GroupsOrder=e.isEditorReplacement=e.MergeGroupMode=e.GroupsArrangement=e.GroupLocation=e.GroupOrientation=e.GroupDirection=e.IEditorGroupsService=void 0,e.IEditorGroupsService=(0,r.createDecorator)("editorGroupsService");var S;(function(f){f[f.UP=0]="UP",f[f.DOWN=1]="DOWN",f[f.LEFT=2]="LEFT",f[f.RIGHT=3]="RIGHT"})(S=e.GroupDirection||(e.GroupDirection={}));var M;(function(f){f[f.HORIZONTAL=0]="HORIZONTAL",f[f.VERTICAL=1]="VERTICAL"})(M=e.GroupOrientation||(e.GroupOrientation={}));var _;(function(f){f[f.FIRST=0]="FIRST",f[f.LAST=1]="LAST",f[f.NEXT=2]="NEXT",f[f.PREVIOUS=3]="PREVIOUS"})(_=e.GroupLocation||(e.GroupLocation={}));var A;(function(f){f[f.MAXIMIZE=0]="MAXIMIZE",f[f.EVEN=1]="EVEN",f[f.TOGGLE=2]="TOGGLE"})(A=e.GroupsArrangement||(e.GroupsArrangement={}));var b;(function(f){f[f.COPY_EDITORS=0]="COPY_EDITORS",f[f.MOVE_EDITORS=1]="MOVE_EDITORS"})(b=e.MergeGroupMode||(e.MergeGroupMode={}));function P(f){const c=f;return(0,y.isEditorInput)(c?.editor)&&(0,y.isEditorInput)(c?.replacement)}e.isEditorReplacement=P;var O;(function(f){f[f.CREATION_TIME=0]="CREATION_TIME",f[f.MOST_RECENTLY_ACTIVE=1]="MOST_RECENTLY_ACTIVE",f[f.GRID_APPEARANCE=2]="GRID_APPEARANCE"})(O=e.GroupsOrder||(e.GroupsOrder={}));var E;(function(f){f[f.NEW_EDITOR=1]="NEW_EDITOR",f[f.MOVE_EDITOR=2]="MOVE_EDITOR",f[f.COPY_EDITOR=3]="COPY_EDITOR"})(E=e.OpenEditorContext||(e.OpenEditorContext={}));function m(f){const c=f;return!!c&&typeof c.id=="number"&&Array.isArray(c.editors)}e.isEditorGroup=m;function k(f){return f.getValue("workbench.editor.openSideBySideDirection")==="down"?1:3}e.preferredSideBySideGroupDirection=k}),define(Ce[171],Ie([1,0,3,91]),function(ie,e,r,y){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.isPreferredGroup=e.SIDE_GROUP=e.ACTIVE_GROUP=e.IEditorService=void 0,e.IEditorService=(0,r.createDecorator)("editorService"),e.ACTIVE_GROUP=-1,e.SIDE_GROUP=-2;function S(M){const _=M;return typeof M=="number"||(0,y.isEditorGroup)(_)}e.isPreferredGroup=S}),define(Ce[172],Ie([1,0,3,147]),function(ie,e,r,y){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.IWorkbenchEnvironmentService=void 0,e.IWorkbenchEnvironmentService=(0,r.refineServiceDecorator)(y.IEnvironmentService)}),define(Ce[173],Ie([1,0,27,5,19]),function(ie,e,r,y,S){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtensionDescriptionRegistry=e.DeltaExtensionsResult=void 0;class M{constructor(E){this.removedDueToLooping=E}}e.DeltaExtensionsResult=M;class _{constructor(E){this._onDidChange=new y.Emitter,this.onDidChange=this._onDidChange.event,this._extensionDescriptions=E,this._initialize()}_initialize(){this._extensionDescriptions.sort(b),this._extensionsMap=new Map,this._extensionsArr=[],this._activationMap=new Map;for(const E of this._extensionDescriptions){if(this._extensionsMap.has(r.ExtensionIdentifier.toKey(E.identifier))){console.error("Extension `"+E.identifier.value+"` is already registered");continue}if(this._extensionsMap.set(r.ExtensionIdentifier.toKey(E.identifier),E),this._extensionsArr.push(E),Array.isArray(E.activationEvents))for(let m of E.activationEvents)m==="onUri"&&(m=`onUri:${r.ExtensionIdentifier.toKey(E.identifier)}`),this._activationMap.has(m)||this._activationMap.set(m,[]),this._activationMap.get(m).push(E)}}set(E){this._extensionDescriptions=E,this._initialize(),this._onDidChange.fire(void 0)}deltaExtensions(E,m){this._extensionDescriptions=P(this._extensionDescriptions,m),this._extensionDescriptions=this._extensionDescriptions.concat(E);const k=_._findLoopingExtensions(this._extensionDescriptions);return this._extensionDescriptions=P(this._extensionDescriptions,k.map(f=>f.identifier)),this._initialize(),this._onDidChange.fire(void 0),new M(k)}static _findLoopingExtensions(E){const m=new class{constructor(){this._arcs=new Map,this._nodesSet=new Set,this._nodesArr=[]}addNode(h){this._nodesSet.has(h)||(this._nodesSet.add(h),this._nodesArr.push(h))}addArc(h,g){this.addNode(h),this.addNode(g),this._arcs.has(h)?this._arcs.get(h).push(g):this._arcs.set(h,[g])}getArcs(h){return this._arcs.has(h)?this._arcs.get(h):[]}hasOnlyGoodArcs(h,g){const C=m.getArcs(h);for(let l=0;l<C.length;l++)if(!g.has(C[l]))return!1;return!0}getNodes(){return this._nodesArr}},k=new Map;for(const h of E){const g=r.ExtensionIdentifier.toKey(h.identifier);if(k.set(g,h),h.extensionDependencies)for(const C of h.extensionDependencies){const l=r.ExtensionIdentifier.toKey(C);m.addArc(g,l)}}const f=new Set;m.getNodes().filter(h=>m.getArcs(h).length===0).forEach(h=>f.add(h));const c=m.getNodes().filter(h=>!f.has(h));let d;do{d=!1;for(let h=0;h<c.length;h++){const g=c[h];m.hasOnlyGoodArcs(g,f)&&(c.splice(h,1),h--,f.add(g),d=!0)}}while(d);return c.map(h=>k.get(h))}containsActivationEvent(E){return this._activationMap.has(E)}containsExtension(E){return this._extensionsMap.has(r.ExtensionIdentifier.toKey(E))}getExtensionDescriptionsForActivationEvent(E){const m=this._activationMap.get(E);return m?m.slice(0):[]}getAllExtensionDescriptions(){return this._extensionsArr.slice(0)}getExtensionDescription(E){const m=this._extensionsMap.get(r.ExtensionIdentifier.toKey(E));return m||void 0}getExtensionDescriptionByUUID(E){for(const m of this._extensionsArr)if(m.uuid===E)return m}getExtensionDescriptionByIdOrUUID(E,m){return this.getExtensionDescription(E)??(m?this.getExtensionDescriptionByUUID(m):void 0)}}e.ExtensionDescriptionRegistry=_;var A;(function(O){O[O.Builtin=0]="Builtin",O[O.User=1]="User",O[O.Dev=2]="Dev"})(A||(A={}));function b(O,E){const m=O.isBuiltin?0:O.isUnderDevelopment?2:1,k=E.isBuiltin?0:E.isUnderDevelopment?2:1;if(m!==k)return m-k;const f=S.posix.basename(O.extensionLocation.path),c=S.posix.basename(E.extensionLocation.path);return f<c?-1:f>c?1:0}function P(O,E){const m=new Set;return E.forEach(k=>m.add(r.ExtensionIdentifier.toKey(k))),O.filter(k=>!m.has(r.ExtensionIdentifier.toKey(k.identifier)))}}),define(Ce[92],Ie([1,0,23]),function(ie,e,r){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.NativeLogMarkers=e.isMessageOfType=e.createMessageOfType=e.MessageType=e.ExtensionHostExitCode=e.UIKind=void 0;var y;(function(P){P[P.Desktop=1]="Desktop",P[P.Web=2]="Web"})(y=e.UIKind||(e.UIKind={}));var S;(function(P){P[P.VersionMismatch=55]="VersionMismatch",P[P.UnexpectedError=81]="UnexpectedError"})(S=e.ExtensionHostExitCode||(e.ExtensionHostExitCode={}));var M;(function(P){P[P.Initialized=0]="Initialized",P[P.Ready=1]="Ready",P[P.Terminate=2]="Terminate"})(M=e.MessageType||(e.MessageType={}));function _(P){const O=r.VSBuffer.alloc(1);switch(P){case 0:O.writeUInt8(1,0);break;case 1:O.writeUInt8(2,0);break;case 2:O.writeUInt8(3,0);break}return O}e.createMessageOfType=_;function A(P,O){if(P.byteLength!==1)return!1;switch(P.readUInt8(0)){case 1:return O===0;case 2:return O===1;case 3:return O===2;default:return!1}}e.isMessageOfType=A;var b;(function(P){P.Start="START_NATIVE_LOG",P.End="END_NATIVE_LOG"})(b=e.NativeLogMarkers||(e.NativeLogMarkers={}))}),define(Ce[25],Ie([1,0,5,2,3,27,153]),function(ie,e,r,y,S,M,_){"use strict";var A;Object.defineProperty(e,"__esModule",{value:!0}),e.NullExtensionService=e.toExtensionDescription=e.toExtension=e.ActivationKind=e.ExtensionHostLogFileName=e.ExtensionPointContribution=e.ActivationTimes=e.checkProposedApiEnabled=e.isProposedApiEnabled=e.extensionIdentifiersArrayToSet=e.ExtensionIdentifierSet=e.ExtensionHostExtensions=e.extensionHostKindToString=e.ExtensionHostKind=e.MissingExtensionDependency=e.RemoteRunningLocation=e.LocalWebWorkerRunningLocation=e.LocalProcessRunningLocation=e.IExtensionService=e.webWorkerExtHostConfig=e.nullExtensionDescription=void 0,e.nullExtensionDescription=Object.freeze({identifier:new M.ExtensionIdentifier("nullExtensionDescription"),name:"Null Extension Description",version:"0.0.0",publisher:"vscode",engines:{vscode:""},extensionLocation:y.URI.parse("void:location"),isBuiltin:!1,targetPlatform:"undefined",isUserBuiltin:!1,isUnderDevelopment:!1}),e.webWorkerExtHostConfig="extensions.webWorker",e.IExtensionService=(0,S.createDecorator)("extensionService");class b{constructor(a){this.affinity=a,this.kind=1}equals(a){return this.kind===a.kind&&this.affinity===a.affinity}asString(){return this.affinity===0?"LocalProcess":`LocalProcess${this.affinity}`}}e.LocalProcessRunningLocation=b;class P{constructor(){this.kind=2,this.affinity=0}equals(a){return this.kind===a.kind}asString(){return"LocalWebWorker"}}e.LocalWebWorkerRunningLocation=P;class O{constructor(){this.kind=3,this.affinity=0}equals(a){return this.kind===a.kind}asString(){return"Remote"}}e.RemoteRunningLocation=O;class E{constructor(a){this.dependency=a}}e.MissingExtensionDependency=E;var m;(function(s){s[s.LocalProcess=1]="LocalProcess",s[s.LocalWebWorker=2]="LocalWebWorker",s[s.Remote=3]="Remote"})(m=e.ExtensionHostKind||(e.ExtensionHostKind={}));function k(s){if(s===null)return"None";switch(s){case 1:return"LocalProcess";case 2:return"LocalWebWorker";case 3:return"Remote"}}e.extensionHostKindToString=k;class f{constructor(){this._allExtensions=[],this._myExtensions=[]}toDelta(){return{toRemove:[],toAdd:this._allExtensions,myToRemove:[],myToAdd:this._myExtensions}}set(a,o){const v=[],p=[],T=[],N=[],V=h(this._allExtensions),B=h(a),D=(K,W)=>K.extensionLocation.toString()===W.extensionLocation.toString()||K.isBuiltin===W.isBuiltin||K.isUserBuiltin===W.isUserBuiltin||K.isUnderDevelopment===W.isUnderDevelopment;for(const K of this._allExtensions){const W=B.get(M.ExtensionIdentifier.toKey(K.identifier));if(!W){v.push(K.identifier),V.delete(M.ExtensionIdentifier.toKey(K.identifier));continue}if(!D(K,W)){v.push(K.identifier),V.delete(M.ExtensionIdentifier.toKey(K.identifier));continue}}for(const K of a){const W=V.get(M.ExtensionIdentifier.toKey(K.identifier));if(!W){p.push(K);continue}if(!D(W,K)){v.push(W.identifier),V.delete(M.ExtensionIdentifier.toKey(W.identifier));continue}}const z=d(this._myExtensions),L=d(o);for(const K of this._myExtensions)L.has(M.ExtensionIdentifier.toKey(K))||T.push(K);for(const K of o)z.has(M.ExtensionIdentifier.toKey(K))||N.push(K);const R={toRemove:v,toAdd:p,myToRemove:T,myToAdd:N};return this.delta(R),R}delta(a){const{toRemove:o,toAdd:v,myToRemove:p,myToAdd:T}=a,N=d(o),V=d(p);for(let B=0;B<this._allExtensions.length;B++)N.has(M.ExtensionIdentifier.toKey(this._allExtensions[B].identifier))&&(this._allExtensions.splice(B,1),B--);for(let B=0;B<this._myExtensions.length;B++)V.has(M.ExtensionIdentifier.toKey(this._myExtensions[B]))&&(this._myExtensions.splice(B,1),B--);for(const B of v)this._allExtensions.push(B);for(const B of T)this._myExtensions.push(B)}containsExtension(a){for(const o of this._myExtensions)if(M.ExtensionIdentifier.equals(o,a))return!0;return!1}}e.ExtensionHostExtensions=f;class c{constructor(a){if(this[A]="ExtensionIdentifierSet",this._map=new Map,this._toKey=M.ExtensionIdentifier.toKey,a)for(const o of a)this.add(o)}get size(){return this._map.size}add(a){return this._map.set(this._toKey(a),a),this}clear(){this._map.clear()}delete(a){return this._map.delete(this._toKey(a))}has(a){return this._map.has(this._toKey(a))}forEach(a,o){this._map.forEach(v=>a.call(o,v,v,this))}*entries(){for(const[a,o]of this._map)yield[o,o]}keys(){return this._map.values()}values(){return this._map.values()}[(A=Symbol.toStringTag,Symbol.iterator)](){return this._map.values()}}e.ExtensionIdentifierSet=c;function d(s){const a=new Set;for(const o of s)a.add(M.ExtensionIdentifier.toKey(o));return a}e.extensionIdentifiersArrayToSet=d;function h(s){const a=new Map;for(const o of s)a.set(M.ExtensionIdentifier.toKey(o.identifier),o);return a}function g(s,a){return s.enabledApiProposals?s.enabledApiProposals.includes(a):!1}e.isProposedApiEnabled=g;function C(s,a){if(!g(s,a))throw new Error(`Extension '${s.identifier.value}' CANNOT use API proposal: ${a}.
Its package.json#enabledApiProposals-property declares: ${s.enabledApiProposals?.join(", ")??"[]"} but NOT ${a}.
 The missing proposal MUST be added and you must start in extension development mode or use the following command line switch: --enable-proposed-api ${s.identifier.value}`)}e.checkProposedApiEnabled=C;class l{constructor(a,o,v,p){this.codeLoadingTime=a,this.activateCallTime=o,this.activateResolvedTime=v,this.activationReason=p}}e.ActivationTimes=l;class w{constructor(a,o){this.description=a,this.value=o}}e.ExtensionPointContribution=w,e.ExtensionHostLogFileName="exthost";var t;(function(s){s[s.Normal=0]="Normal",s[s.Immediate=1]="Immediate"})(t=e.ActivationKind||(e.ActivationKind={}));function u(s){return{type:s.isBuiltin?0:1,isBuiltin:s.isBuiltin||s.isUserBuiltin,identifier:{id:(0,_.getGalleryExtensionId)(s.publisher,s.name),uuid:s.uuid},manifest:s,location:s.extensionLocation,targetPlatform:s.targetPlatform,validations:[],isValid:!0}}e.toExtension=u;function i(s,a){return{identifier:new M.ExtensionIdentifier((0,_.getExtensionId)(s.manifest.publisher,s.manifest.name)),isBuiltin:s.type===0,isUserBuiltin:s.type===1&&s.isBuiltin,isUnderDevelopment:!!a,extensionLocation:s.location,...s.manifest,uuid:s.identifier.uuid,targetPlatform:s.targetPlatform,browserNlsBundleUris:s.browserNlsBundleUris}}e.toExtensionDescription=i;class n{constructor(){this.onDidRegisterExtensions=r.Event.None,this.onDidChangeExtensionsStatus=r.Event.None,this.onDidChangeExtensions=r.Event.None,this.onWillActivateByEvent=r.Event.None,this.onDidChangeResponsiveChange=r.Event.None}activateByEvent(a){return Promise.resolve(void 0)}activationEventIsDone(a){return!1}whenInstalledExtensionsRegistered(){return Promise.resolve(!0)}getExtensions(){return Promise.resolve([])}getExtension(){return Promise.resolve(void 0)}readExtensionPointContributions(a){return Promise.resolve(Object.create(null))}getExtensionsStatus(){return Object.create(null)}getInspectPort(a,o){return Promise.resolve(0)}getInspectPorts(a,o){return Promise.resolve([])}stopExtensionHosts(){}async restartExtensionHost(){}async startExtensionHosts(){}async setRemoteEnvironment(a){}canAddExtension(){return!1}canRemoveExtension(){return!1}_activateById(a,o){return Promise.resolve()}}e.NullExtensionService=n}),define(Ce[174],Ie([1,0,12,27,25,14,15]),function(ie,e,r,y,S,M,_){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtensionsActivator=e.FailedExtension=e.HostExtension=e.EmptyExtension=e.ActivatedExtension=e.ExtensionActivationTimesBuilder=e.ExtensionActivationTimes=void 0;class A{constructor(d,h,g,C){this.startup=d,this.codeLoadingTime=h,this.activateCallTime=g,this.activateResolvedTime=C}}e.ExtensionActivationTimes=A,A.NONE=new A(!1,-1,-1,-1);class b{constructor(d){this._startup=d,this._codeLoadingStart=-1,this._codeLoadingStop=-1,this._activateCallStart=-1,this._activateCallStop=-1,this._activateResolveStart=-1,this._activateResolveStop=-1}_delta(d,h){return d===-1||h===-1?-1:h-d}build(){return new A(this._startup,this._delta(this._codeLoadingStart,this._codeLoadingStop),this._delta(this._activateCallStart,this._activateCallStop),this._delta(this._activateResolveStart,this._activateResolveStop))}codeLoadingStart(){this._codeLoadingStart=Date.now()}codeLoadingStop(){this._codeLoadingStop=Date.now()}activateCallStart(){this._activateCallStart=Date.now()}activateCallStop(){this._activateCallStop=Date.now()}activateResolveStart(){this._activateResolveStart=Date.now()}activateResolveStop(){this._activateResolveStop=Date.now()}}e.ExtensionActivationTimesBuilder=b;class P{constructor(d,h,g,C,l,w){this.activationFailed=d,this.activationFailedError=h,this.activationTimes=g,this.module=C,this.exports=l,this.subscriptions=w}}e.ActivatedExtension=P;class O extends P{constructor(d){super(!1,null,d,{activate:void 0,deactivate:void 0},void 0,[])}}e.EmptyExtension=O;class E extends P{constructor(){super(!1,null,A.NONE,{activate:void 0,deactivate:void 0},void 0,[])}}e.HostExtension=E;class m extends P{constructor(d){super(!0,d,A.NONE,{activate:void 0,deactivate:void 0},void 0,[])}}e.FailedExtension=m;let k=class{constructor(d,h,g,C,l){this._logService=l,this._registry=d,this._resolvedExtensionsSet=new Set,h.forEach(w=>this._resolvedExtensionsSet.add(y.ExtensionIdentifier.toKey(w))),this._externalExtensionsMap=new Map,g.forEach(w=>this._externalExtensionsMap.set(y.ExtensionIdentifier.toKey(w),w)),this._host=C,this._operations=new Map,this._alreadyActivatedEvents=Object.create(null)}dispose(){for(const[d,h]of this._operations)h.dispose()}isActivated(d){const h=this._operations.get(y.ExtensionIdentifier.toKey(d));return Boolean(h&&h.value)}getActivatedExtension(d){const h=this._operations.get(y.ExtensionIdentifier.toKey(d));if(!h||!h.value)throw new Error(`Extension '${d.value}' is not known or not activated`);return h.value}async activateByEvent(d,h){if(this._alreadyActivatedEvents[d])return;const g=this._registry.getExtensionDescriptionsForActivationEvent(d);await this._activateExtensions(g.map(C=>({id:C.identifier,reason:{startup:h,extensionId:C.identifier,activationEvent:d}}))),this._alreadyActivatedEvents[d]=!0}activateById(d,h){const g=this._registry.getExtensionDescription(d);if(!g)throw new Error(`Extension '${d}' is not known`);return this._activateExtensions([{id:g.identifier,reason:h}])}async _activateExtensions(d){const h=d.filter(g=>!this.isActivated(g.id)).map(g=>this._handleActivationRequest(g));await Promise.all(h.map(g=>g.wait()))}_handleActivationRequest(d){if(this._operations.has(y.ExtensionIdentifier.toKey(d.id)))return this._operations.get(y.ExtensionIdentifier.toKey(d.id));if(this._externalExtensionsMap.has(y.ExtensionIdentifier.toKey(d.id)))return this._createAndSaveOperation(d,null,[],null);const h=this._registry.getExtensionDescription(d.id);if(!h){const l=new Error(`Cannot activate unknown extension '${d.id.value}'`),w=this._createAndSaveOperation(d,null,[],new m(l));return this._host.onExtensionActivationError(d.id,l,new S.MissingExtensionDependency(d.id.value)),w}const g=[],C=typeof h.extensionDependencies>"u"?[]:h.extensionDependencies;for(const l of C){if(this._resolvedExtensionsSet.has(y.ExtensionIdentifier.toKey(l)))continue;const w=this._operations.get(y.ExtensionIdentifier.toKey(l));if(w){g.push(w);continue}if(this._externalExtensionsMap.has(y.ExtensionIdentifier.toKey(l))){g.push(this._handleActivationRequest({id:this._externalExtensionsMap.get(y.ExtensionIdentifier.toKey(l)),reason:d.reason}));continue}const t=this._registry.getExtensionDescription(l);if(t){if(!t.main&&!t.browser)continue;g.push(this._handleActivationRequest({id:t.identifier,reason:d.reason}));continue}const u=h.displayName||h.identifier.value,i=new Error(`Cannot activate the '${u}' extension because it depends on unknown extension '${l}'`),n=this._createAndSaveOperation(d,h.displayName,[],new m(i));return this._host.onExtensionActivationError(h.identifier,i,new S.MissingExtensionDependency(l)),n}return this._createAndSaveOperation(d,h.displayName,g,null)}_createAndSaveOperation(d,h,g,C){const l=new f(d.id,h,d.reason,g,C,this._host,this._logService);return this._operations.set(y.ExtensionIdentifier.toKey(d.id),l),l}};k=ze([$e(4,M.ILogService)],k),e.ExtensionsActivator=k;let f=class{get value(){return this._value}get friendlyName(){return this._displayName||this._id.value}constructor(d,h,g,C,l,w,t){this._id=d,this._displayName=h,this._reason=g,this._deps=C,this._value=l,this._host=w,this._logService=t,this._barrier=new _.Barrier,this._isDisposed=!1,this._initialize()}dispose(){this._isDisposed=!0}wait(){return this._barrier.wait()}async _initialize(){await this._waitForDepsThenActivate(),this._barrier.open()}async _waitForDepsThenActivate(){if(!this._value){for(;this._deps.length>0;){for(let d=0;d<this._deps.length;d++){const h=this._deps[d];if(h.value&&!h.value.activationFailed){this._deps.splice(d,1),d--;continue}if(h.value&&h.value.activationFailed){const g=new Error(`Cannot activate the '${this.friendlyName}' extension because its dependency '${h.friendlyName}' failed to activate`);g.detail=h.value.activationFailedError,this._value=new m(g),this._host.onExtensionActivationError(this._id,g,null);return}}this._deps.length>0&&await Promise.race(this._deps.map(d=>d.wait()))}await this._activate()}}async _activate(){try{this._value=await this._host.actualActivateExtension(this._id,this._reason)}catch(d){const h=new Error;if(d&&d.name&&(h.name=d.name),d&&d.message?h.message=`Activating extension '${this._id.value}' failed: ${d.message}.`:h.message=`Activating extension '${this._id.value}' failed: ${d}.`,d&&d.stack&&(h.stack=d.stack),this._value=new m(h),this._isDisposed&&r.isCancellationError(d))return;this._host.onExtensionActivationError(this._id,h,null),this._logService.error(`Activating extension ${this._id.value} failed due to an error:`),this._logService.error(d)}}};f=ze([$e(6,M.ILogService)],f)}),define(Ce[175],Ie([1,0,14,28,25]),function(ie,e,r,y,S){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtHostLogService=void 0;let M=class extends r.LogService{constructor(A,b){super(A.createLogger(b.logFile,{name:S.ExtensionHostLogFileName}))}};M=ze([$e(0,r.ILoggerService),$e(1,y.IExtHostInitDataService)],M),e.ExtHostLogService=M});var Je=this&&this.__classPrivateFieldSet||function(ie,e,r,y,S){if(y==="m")throw new TypeError("Private method is not writable");if(y==="a"&&!S)throw new TypeError("Private accessor was defined without a setter");if(typeof e=="function"?ie!==e||!S:!e.has(ie))throw new TypeError("Cannot write private member to an object whose class did not declare it");return y==="a"?S.call(ie,r):S?S.value=r:e.set(ie,r),r},Oe=this&&this.__classPrivateFieldGet||function(ie,e,r,y){if(r==="a"&&!y)throw new TypeError("Private accessor was defined without a getter");if(typeof e=="function"?ie!==e||!y:!e.has(ie))throw new TypeError("Cannot read private member from an object whose class did not declare it");return r==="m"?y:r==="a"?y.call(ie):y?y.value:e.get(ie)};define(Ce[6],Ie([1,0,18,12,77,24,75,9,10,2,42,35,86,64,25]),function(ie,e,r,y,S,M,_,A,b,P,O,E,m,k,f){"use strict";var c,d,h,g,C,l,w,t,u,i,n,s,a,o,v,p,T,N,V,B,D,z,L;Object.defineProperty(e,"__esModule",{value:!0}),e.InteractiveWindowInput=e.TerminalEditorTabInput=e.NotebookDiffEditorTabInput=e.NotebookEditorTabInput=e.WebviewEditorTabInput=e.CustomEditorTabInput=e.TextMergeTabInput=e.TextDiffTabInput=e.TextTabInput=e.TypeHierarchyItem=e.PortAutoForwardAction=e.WorkspaceTrustState=e.ExternalUriOpenerPriority=e.FunctionCoverage=e.BranchCoverage=e.StatementCoverage=e.FileCoverage=e.CoveredCount=e.TestTag=e.TestMessage=e.TestRunRequest=e.TestRunProfileKind=e.TestResultState=e.PortAttributes=e.LinkedEditingRanges=e.StandardTokenType=e.ExtensionRuntime=e.ExtensionMode=e.TimelineItem=e.NotebookRendererScript=e.NotebookControllerAffinity2=e.NotebookControllerAffinity=e.NotebookCellStatusBarItem=e.NotebookEditorRevealType=e.NotebookCellStatusBarAlignment=e.NotebookCellExecutionState=e.NotebookCellKind=e.NotebookCellOutput=e.NotebookCellOutputItem=e.NotebookData=e.NotebookCellData=e.NotebookRange=e.ColorThemeKind=e.ColorTheme=e.FileDecoration=e.ExtensionKind=e.InputBoxValidationSeverity=e.QuickPickItemKind=e.QuickInputButtons=e.DebugConsoleMode=e.SemanticTokensEdits=e.SemanticTokensEdit=e.SemanticTokens=e.SemanticTokensBuilder=e.SemanticTokensLegend=e.CommentThreadState=e.CommentMode=e.CommentThreadCollapsibleState=e.FoldingRangeKind=e.FoldingRange=e.FileSystemError=e.FileChangeType=e.InlineValueContext=e.InlineValueEvaluatableExpression=e.InlineValueVariableLookup=e.InlineValueText=e.InlineCompletionTriggerKindNew=e.InlineCompletionTriggerKind=e.EvaluatableExpression=e.DebugAdapterInlineImplementation=e.DebugAdapterNamedPipeServer=e.DebugAdapterServer=e.DebugAdapterExecutable=e.DataBreakpoint=e.FunctionBreakpoint=e.SourceBreakpoint=e.Breakpoint=e.RelativePattern=e.ConfigurationTarget=e.ThemeColor=e.ThemeIcon=e.DocumentPasteEdit=e.DocumentDropEdit=e.DataTransfer=e.DataTransferItem=e.TreeItemCheckboxState=e.TreeItemCollapsibleState=e.TreeItem=e.ProgressLocation=e.Task=e.CustomExecution=e.TaskScope=e.ShellQuoting=e.ShellExecution=e.ProcessExecution=e.TaskGroup=e.TaskPanelKind=e.TaskRevealKind=e.TerminalProfile=e.TerminalLocation=e.TerminalLink=e.TerminalExitReason=e.SourceControlInputBoxValidationType=e.ColorFormat=e.ColorPresentation=e.ColorInformation=e.Color=e.DocumentLink=e.DecorationRangeBehavior=e.TextDocumentChangeReason=e.TextEditorSelectionChangeKind=e.TextEditorRevealType=e.TextDocumentSaveReason=e.TextEditorLineNumbersStyle=e.StatusBarAlignment=e.ViewColumn=e.InlineSuggestionsNew=e.InlineSuggestionNew=e.InlineSuggestionList=e.InlineSuggestion=e.CompletionList=e.CompletionItem=e.CompletionItemTag=e.CompletionItemKind=e.CompletionTriggerKind=e.InlayHint=e.InlayHintLabelPart=e.InlayHintKind=e.SignatureHelpTriggerKind=e.SignatureHelp=e.SignatureInformation=e.ParameterInformation=e.MarkdownString=e.CodeLens=e.LanguageStatusSeverity=e.CallHierarchyOutgoingCall=e.CallHierarchyIncomingCall=e.CallHierarchyItem=e.SelectionRange=e.CodeActionKind=e.CodeAction=e.CodeActionTriggerKind=e.DocumentSymbol=e.SymbolInformation=e.SymbolTag=e.SymbolKind=e.DocumentHighlight=e.DocumentHighlightKind=e.Hover=e.Diagnostic=e.DiagnosticRelatedInformation=e.Location=e.DiagnosticSeverity=e.DiagnosticTag=e.SnippetString=e.WorkspaceEdit=e.FileEditType=e.SnippetTextEdit=e.NotebookEdit=e.TextEdit=e.EnvironmentVariableMutatorType=e.EndOfLine=e.RemoteAuthorityResolverError=e.ResolvedAuthority=e.Selection=e.Range=e.Position=e.Disposable=void 0;function R(x){function F(){return Reflect.construct(x,arguments,this.constructor)}return Object.defineProperty(F,"name",Object.getOwnPropertyDescriptor(x,"name")),Object.setPrototypeOf(F,x),Object.setPrototypeOf(F.prototype,x.prototype),F}let K=l=class{static from(...F){let te=F;return new l(function(){if(te){for(const we of te)we&&typeof we.dispose=="function"&&we.dispose();te=void 0}})}constructor(F){c.set(this,void 0),Je(this,c,F,"f")}dispose(){typeof Oe(this,c,"f")=="function"&&(Oe(this,c,"f").call(this),Je(this,c,void 0,"f"))}};c=new WeakMap,K=l=ze([R],K),e.Disposable=K;let W=w=class{static Min(...F){if(F.length===0)throw new TypeError;let te=F[0];for(let we=1;we<F.length;we++){const He=F[we];He.isBefore(te)&&(te=He)}return te}static Max(...F){if(F.length===0)throw new TypeError;let te=F[0];for(let we=1;we<F.length;we++){const He=F[we];He.isAfter(te)&&(te=He)}return te}static isPosition(F){if(!F)return!1;if(F instanceof w)return!0;const{line:te,character:we}=F;return typeof te=="number"&&typeof we=="number"}static of(F){if(F instanceof w)return F;if(this.isPosition(F))return new w(F.line,F.character);throw new Error("Invalid argument, is NOT a position-like object")}get line(){return this._line}get character(){return this._character}constructor(F,te){if(F<0)throw(0,y.illegalArgument)("line must be non-negative");if(te<0)throw(0,y.illegalArgument)("character must be non-negative");this._line=F,this._character=te}isBefore(F){return this._line<F._line?!0:F._line<this._line?!1:this._character<F._character}isBeforeOrEqual(F){return this._line<F._line?!0:F._line<this._line?!1:this._character<=F._character}isAfter(F){return!this.isBeforeOrEqual(F)}isAfterOrEqual(F){return!this.isBefore(F)}isEqual(F){return this._line===F._line&&this._character===F._character}compareTo(F){return this._line<F._line?-1:this._line>F.line?1:this._character<F._character?-1:this._character>F._character?1:0}translate(F,te=0){if(F===null||te===null)throw(0,y.illegalArgument)();let we;return typeof F>"u"?we=0:typeof F=="number"?we=F:(we=typeof F.lineDelta=="number"?F.lineDelta:0,te=typeof F.characterDelta=="number"?F.characterDelta:0),we===0&&te===0?this:new w(this.line+we,this.character+te)}with(F,te=this.character){if(F===null||te===null)throw(0,y.illegalArgument)();let we;return typeof F>"u"?we=this.line:typeof F=="number"?we=F:(we=typeof F.line=="number"?F.line:this.line,te=typeof F.character=="number"?F.character:this.character),we===this.line&&te===this.character?this:new w(we,te)}toJSON(){return{line:this.line,character:this.character}}};W=w=ze([R],W),e.Position=W;let $=t=class{static isRange(F){return F instanceof t?!0:F?W.isPosition(F.start)&&W.isPosition(F.end):!1}static of(F){if(F instanceof t)return F;if(this.isRange(F))return new t(F.start,F.end);throw new Error("Invalid argument, is NOT a range-like object")}get start(){return this._start}get end(){return this._end}constructor(F,te,we,He){let Qe,at;if(typeof F=="number"&&typeof te=="number"&&typeof we=="number"&&typeof He=="number"?(Qe=new W(F,te),at=new W(we,He)):W.isPosition(F)&&W.isPosition(te)&&(Qe=W.of(F),at=W.of(te)),!Qe||!at)throw new Error("Invalid arguments");Qe.isBefore(at)?(this._start=Qe,this._end=at):(this._start=at,this._end=Qe)}contains(F){return t.isRange(F)?this.contains(F.start)&&this.contains(F.end):W.isPosition(F)?!(W.of(F).isBefore(this._start)||this._end.isBefore(F)):!1}isEqual(F){return this._start.isEqual(F._start)&&this._end.isEqual(F._end)}intersection(F){const te=W.Max(F.start,this._start),we=W.Min(F.end,this._end);if(!te.isAfter(we))return new t(te,we)}union(F){if(this.contains(F))return this;if(F.contains(this))return F;const te=W.Min(F.start,this._start),we=W.Max(F.end,this.end);return new t(te,we)}get isEmpty(){return this._start.isEqual(this._end)}get isSingleLine(){return this._start.line===this._end.line}with(F,te=this.end){if(F===null||te===null)throw(0,y.illegalArgument)();let we;return F?W.isPosition(F)?we=F:(we=F.start||this.start,te=F.end||this.end):we=this.start,we.isEqual(this._start)&&te.isEqual(this.end)?this:new t(we,te)}toJSON(){return[this.start,this.end]}};$=t=ze([R],$),e.Range=$;let G=u=class extends ${static isSelection(F){return F instanceof u?!0:F?$.isRange(F)&&W.isPosition(F.anchor)&&W.isPosition(F.active)&&typeof F.isReversed=="boolean":!1}get anchor(){return this._anchor}get active(){return this._active}constructor(F,te,we,He){let Qe,at;if(typeof F=="number"&&typeof te=="number"&&typeof we=="number"&&typeof He=="number"?(Qe=new W(F,te),at=new W(we,He)):W.isPosition(F)&&W.isPosition(te)&&(Qe=W.of(F),at=W.of(te)),!Qe||!at)throw new Error("Invalid arguments");super(Qe,at),this._anchor=Qe,this._active=at}get isReversed(){return this._anchor===this._end}toJSON(){return{start:this.start,end:this.end,active:this.active,anchor:this.anchor}}};G=u=ze([R],G),e.Selection=G;class ne{constructor(F,te,we){if(typeof F!="string"||F.length===0)throw(0,y.illegalArgument)("host");if(typeof te!="number"||te===0||Math.round(te)!==te)throw(0,y.illegalArgument)("port");if(typeof we<"u"&&(typeof we!="string"||we.length===0||!/^[0-9A-Za-z\-]+$/.test(we)))throw(0,y.illegalArgument)("connectionToken");this.host=F,this.port=Math.round(te),this.connectionToken=we}}e.ResolvedAuthority=ne;class ge extends Error{static NotAvailable(F,te){return new ge(F,m.RemoteAuthorityResolverErrorCode.NotAvailable,te)}static TemporarilyNotAvailable(F){return new ge(F,m.RemoteAuthorityResolverErrorCode.TemporarilyNotAvailable)}constructor(F,te=m.RemoteAuthorityResolverErrorCode.Unknown,we){super(F),this._message=F,this._code=te,this._detail=we,typeof Object.setPrototypeOf=="function"&&Object.setPrototypeOf(this,ge.prototype)}}e.RemoteAuthorityResolverError=ge;var oe;(function(x){x[x.LF=1]="LF",x[x.CRLF=2]="CRLF"})(oe=e.EndOfLine||(e.EndOfLine={}));var Ee;(function(x){x[x.Replace=1]="Replace",x[x.Append=2]="Append",x[x.Prepend=3]="Prepend"})(Ee=e.EnvironmentVariableMutatorType||(e.EnvironmentVariableMutatorType={}));let ce=i=class{static isTextEdit(F){return F instanceof i?!0:F?$.isRange(F)&&typeof F.newText=="string":!1}static replace(F,te){return new i(F,te)}static insert(F,te){return i.replace(new $(F,F),te)}static delete(F){return i.replace(F,"")}static setEndOfLine(F){const te=new i(new $(new W(0,0),new W(0,0)),"");return te.newEol=F,te}get range(){return this._range}set range(F){if(F&&!$.isRange(F))throw(0,y.illegalArgument)("range");this._range=F}get newText(){return this._newText||""}set newText(F){if(F&&typeof F!="string")throw(0,y.illegalArgument)("newText");this._newText=F}get newEol(){return this._newEol}set newEol(F){if(F&&typeof F!="number")throw(0,y.illegalArgument)("newEol");this._newEol=F}constructor(F,te){this._range=F,this._newText=te}toJSON(){return{range:this.range,newText:this.newText,newEol:this._newEol}}};ce=i=ze([R],ce),e.TextEdit=ce;let me=n=class{static isNotebookCellEdit(F){return F instanceof n?!0:F?Wt.isNotebookRange(F)&&Array.isArray(F.newCells):!1}static replaceCells(F,te){return new n(F,te)}static insertCells(F,te){return new n(new Wt(F,F),te)}static deleteCells(F){return new n(F,[])}static updateCellMetadata(F,te){const we=new n(new Wt(F,F),[]);return we.newCellMetadata=te,we}static updateNotebookMetadata(F){const te=new n(new Wt(0,0),[]);return te.newNotebookMetadata=F,te}constructor(F,te){this.range=F,this.newCells=te}};me=n=ze([R],me),e.NotebookEdit=me;class ee{static isSnippetTextEdit(F){return F instanceof ee?!0:F?$.isRange(F.range)&&Fe.isSnippetString(F.snippet):!1}static replace(F,te){return new ee(F,te)}static insert(F,te){return ee.replace(new $(F,F),te)}constructor(F,te){this.range=F,this.snippet=te}}e.SnippetTextEdit=ee;var be;(function(x){x[x.File=1]="File",x[x.Text=2]="Text",x[x.Cell=3]="Cell",x[x.CellReplace=5]="CellReplace",x[x.Snippet=6]="Snippet"})(be=e.FileEditType||(e.FileEditType={}));let _e=class{constructor(){this._edits=[]}_allEntries(){return this._edits}renameFile(F,te,we,He){this._edits.push({_type:1,from:F,to:te,options:we,metadata:He})}createFile(F,te,we){this._edits.push({_type:1,from:void 0,to:F,options:te,metadata:we})}deleteFile(F,te,we){this._edits.push({_type:1,from:F,to:void 0,options:te,metadata:we})}replaceNotebookMetadata(F,te,we){this._edits.push({_type:3,metadata:we,uri:F,edit:{editType:5,metadata:te},notebookMetadata:te})}replaceNotebookCells(F,te,we,He){const Qe=te.start,at=te.end;(Qe!==at||we.length>0)&&this._edits.push({_type:5,uri:F,index:Qe,count:at-Qe,cells:we,metadata:He})}replaceNotebookCellMetadata(F,te,we,He){this._edits.push({_type:3,metadata:He,uri:F,edit:{editType:8,index:te,metadata:we}})}replace(F,te,we,He){this._edits.push({_type:2,uri:F,edit:new ce(te,we),metadata:He})}insert(F,te,we,He){this.replace(F,new $(te,te),we,He)}delete(F,te,we){this.replace(F,te,"",we)}has(F){return this._edits.some(te=>te._type===2&&te.uri.toString()===F.toString())}set(F,te){if(te)for(const we of te){if(!we)continue;let He,Qe;Array.isArray(we)?(He=we[0],Qe=we[1]):He=we,me.isNotebookCellEdit(He)?He.newCellMetadata?this.replaceNotebookCellMetadata(F,He.range.start,He.newCellMetadata,Qe):He.newNotebookMetadata?this.replaceNotebookMetadata(F,He.newNotebookMetadata,Qe):this.replaceNotebookCells(F,He.range,He.newCells,Qe):ee.isSnippetTextEdit(He)?this._edits.push({_type:6,uri:F,range:He.range,edit:He.snippet,metadata:Qe}):this._edits.push({_type:2,uri:F,edit:He,metadata:Qe})}else{for(let we=0;we<this._edits.length;we++){const He=this._edits[we];switch(He._type){case 2:case 6:case 3:case 5:He.uri.toString()===F.toString()&&(this._edits[we]=void 0);break}}(0,r.coalesceInPlace)(this._edits)}}get(F){const te=[];for(const we of this._edits)we._type===2&&we.uri.toString()===F.toString()&&te.push(we.edit);return te}entries(){const F=new M.ResourceMap;for(const te of this._edits)if(te._type===2){let we=F.get(te.uri);we||(we=[te.uri,[]],F.set(te.uri,we)),we[1].push(te.edit)}return[...F.values()]}get size(){return this.entries().length}toJSON(){return this.entries()}};_e=ze([R],_e),e.WorkspaceEdit=_e;let Fe=s=class{static isSnippetString(F){return F instanceof s?!0:F?typeof F.value=="string":!1}static _escape(F){return F.replace(/\$|}|\\/g,"\\$&")}constructor(F){this._tabstop=1,this.value=F||""}appendText(F){return this.value+=s._escape(F),this}appendTabstop(F=this._tabstop++){return this.value+="$",this.value+=F,this}appendPlaceholder(F,te=this._tabstop++){if(typeof F=="function"){const we=new s;we._tabstop=this._tabstop,F(we),this._tabstop=we._tabstop,F=we.value}else F=s._escape(F);return this.value+="${",this.value+=te,this.value+=":",this.value+=F,this.value+="}",this}appendChoice(F,te=this._tabstop++){const we=F.map(He=>He.replace(/\$|}|\\|,/g,"\\$&")).join(",");return this.value+="${",this.value+=te,this.value+="|",this.value+=we,this.value+="|}",this}appendVariable(F,te){if(typeof te=="function"){const we=new s;we._tabstop=this._tabstop,te(we),this._tabstop=we._tabstop,te=we.value}else typeof te=="string"&&(te=te.replace(/\$|}/g,"\\$&"));return this.value+="${",this.value+=F,te&&(this.value+=":",this.value+=te),this.value+="}",this}};Fe=s=ze([R],Fe),e.SnippetString=Fe;var Be;(function(x){x[x.Unnecessary=1]="Unnecessary",x[x.Deprecated=2]="Deprecated"})(Be=e.DiagnosticTag||(e.DiagnosticTag={}));var Xe;(function(x){x[x.Hint=3]="Hint",x[x.Information=2]="Information",x[x.Warning=1]="Warning",x[x.Error=0]="Error"})(Xe=e.DiagnosticSeverity||(e.DiagnosticSeverity={}));let ke=a=class{static isLocation(F){return F instanceof a?!0:F?$.isRange(F.range)&&P.URI.isUri(F.uri):!1}constructor(F,te){if(this.uri=F,te)if($.isRange(te))this.range=$.of(te);else if(W.isPosition(te))this.range=new $(te,te);else throw new Error("Illegal argument")}toJSON(){return{uri:this.uri,range:this.range}}};ke=a=ze([R],ke),e.Location=ke;let ye=class{static is(F){return F?typeof F.message=="string"&&F.location&&$.isRange(F.location.range)&&P.URI.isUri(F.location.uri):!1}constructor(F,te){this.location=F,this.message=te}static isEqual(F,te){return F===te?!0:!F||!te?!1:F.message===te.message&&F.location.range.isEqual(te.location.range)&&F.location.uri.toString()===te.location.uri.toString()}};ye=ze([R],ye),e.DiagnosticRelatedInformation=ye;let De=class{constructor(F,te,we=Xe.Error){if(!$.isRange(F))throw new TypeError("range must be set");if(!te)throw new TypeError("message must be set");this.range=F,this.message=te,this.severity=we}toJSON(){return{severity:Xe[this.severity],message:this.message,range:this.range,source:this.source,code:this.code}}static isEqual(F,te){return F===te?!0:!F||!te?!1:F.message===te.message&&F.severity===te.severity&&F.code===te.code&&F.severity===te.severity&&F.source===te.source&&F.range.isEqual(te.range)&&(0,r.equals)(F.tags,te.tags)&&(0,r.equals)(F.relatedInformation,te.relatedInformation,ye.isEqual)}};De=ze([R],De),e.Diagnostic=De;let ae=class{constructor(F,te){if(!F)throw new Error("Illegal argument, contents must be defined");Array.isArray(F)?this.contents=F:this.contents=[F],this.range=te}};ae=ze([R],ae),e.Hover=ae;var ue;(function(x){x[x.Text=0]="Text",x[x.Read=1]="Read",x[x.Write=2]="Write"})(ue=e.DocumentHighlightKind||(e.DocumentHighlightKind={}));let Z=class{constructor(F,te=ue.Text){this.range=F,this.kind=te}toJSON(){return{range:this.range,kind:ue[this.kind]}}};Z=ze([R],Z),e.DocumentHighlight=Z;var J;(function(x){x[x.File=0]="File",x[x.Module=1]="Module",x[x.Namespace=2]="Namespace",x[x.Package=3]="Package",x[x.Class=4]="Class",x[x.Method=5]="Method",x[x.Property=6]="Property",x[x.Field=7]="Field",x[x.Constructor=8]="Constructor",x[x.Enum=9]="Enum",x[x.Interface=10]="Interface",x[x.Function=11]="Function",x[x.Variable=12]="Variable",x[x.Constant=13]="Constant",x[x.String=14]="String",x[x.Number=15]="Number",x[x.Boolean=16]="Boolean",x[x.Array=17]="Array",x[x.Object=18]="Object",x[x.Key=19]="Key",x[x.Null=20]="Null",x[x.EnumMember=21]="EnumMember",x[x.Struct=22]="Struct",x[x.Event=23]="Event",x[x.Operator=24]="Operator",x[x.TypeParameter=25]="TypeParameter"})(J=e.SymbolKind||(e.SymbolKind={}));var I;(function(x){x[x.Deprecated=1]="Deprecated"})(I=e.SymbolTag||(e.SymbolTag={}));let U=o=class{static validate(F){if(!F.name)throw new Error("name must not be falsy")}constructor(F,te,we,He,Qe){this.name=F,this.kind=te,this.containerName=Qe,typeof we=="string"&&(this.containerName=we),He instanceof ke?this.location=He:we instanceof $&&(this.location=new ke(He,we)),o.validate(this)}toJSON(){return{name:this.name,kind:J[this.kind],location:this.location,containerName:this.containerName}}};U=o=ze([R],U),e.SymbolInformation=U;let H=v=class{static validate(F){if(!F.name)throw new Error("name must not be falsy");if(!F.range.contains(F.selectionRange))throw new Error("selectionRange must be contained in fullRange");F.children?.forEach(v.validate)}constructor(F,te,we,He,Qe){this.name=F,this.detail=te,this.kind=we,this.range=He,this.selectionRange=Qe,this.children=[],v.validate(this)}};H=v=ze([R],H),e.DocumentSymbol=H;var j;(function(x){x[x.Invoke=1]="Invoke",x[x.Automatic=2]="Automatic"})(j=e.CodeActionTriggerKind||(e.CodeActionTriggerKind={}));let se=class{constructor(F,te){this.title=F,this.kind=te}};se=ze([R],se),e.CodeAction=se;let le=p=class{constructor(F){this.value=F}append(F){return new p(this.value?this.value+p.sep+F:F)}intersects(F){return this.contains(F)||F.contains(this)}contains(F){return this.value===F.value||F.value.startsWith(this.value+p.sep)}};le.sep=".",le=p=ze([R],le),e.CodeActionKind=le,le.Empty=new le(""),le.QuickFix=le.Empty.append("quickfix"),le.Refactor=le.Empty.append("refactor"),le.RefactorExtract=le.Refactor.append("extract"),le.RefactorInline=le.Refactor.append("inline"),le.RefactorMove=le.Refactor.append("move"),le.RefactorRewrite=le.Refactor.append("rewrite"),le.Source=le.Empty.append("source"),le.SourceOrganizeImports=le.Source.append("organizeImports"),le.SourceFixAll=le.Source.append("fixAll");let Y=class{constructor(F,te){if(this.range=F,this.parent=te,te&&!te.range.contains(this.range))throw new Error("Invalid argument: parent must contain this range")}};Y=ze([R],Y),e.SelectionRange=Y;class ve{constructor(F,te,we,He,Qe,at){this.kind=F,this.name=te,this.detail=we,this.uri=He,this.range=Qe,this.selectionRange=at}}e.CallHierarchyItem=ve;class pe{constructor(F,te){this.fromRanges=te,this.from=F}}e.CallHierarchyIncomingCall=pe;class Me{constructor(F,te){this.fromRanges=te,this.to=F}}e.CallHierarchyOutgoingCall=Me;var xe;(function(x){x[x.Information=0]="Information",x[x.Warning=1]="Warning",x[x.Error=2]="Error"})(xe=e.LanguageStatusSeverity||(e.LanguageStatusSeverity={}));let Ye=class{constructor(F,te){this.range=F,this.command=te}get isResolved(){return!!this.command}};Ye=ze([R],Ye),e.CodeLens=Ye;let Ge=T=class{static isMarkdownString(F){return F instanceof T?!0:F&&F.appendCodeblock&&F.appendMarkdown&&F.appendText&&F.value!==void 0}constructor(F,te=!1){d.set(this,void 0),Je(this,d,new S.MarkdownString(F,{supportThemeIcons:te}),"f")}get value(){return Oe(this,d,"f").value}set value(F){Oe(this,d,"f").value=F}get isTrusted(){return Oe(this,d,"f").isTrusted}set isTrusted(F){Oe(this,d,"f").isTrusted=F}get supportThemeIcons(){return Oe(this,d,"f").supportThemeIcons}set supportThemeIcons(F){Oe(this,d,"f").supportThemeIcons=F}get supportHtml(){return Oe(this,d,"f").supportHtml}set supportHtml(F){Oe(this,d,"f").supportHtml=F}get baseUri(){return Oe(this,d,"f").baseUri}set baseUri(F){Oe(this,d,"f").baseUri=F}appendText(F){return Oe(this,d,"f").appendText(F),this}appendMarkdown(F){return Oe(this,d,"f").appendMarkdown(F),this}appendCodeblock(F,te){return Oe(this,d,"f").appendCodeblock(te??"",F),this}};d=new WeakMap,Ge=T=ze([R],Ge),e.MarkdownString=Ge;let Te=class{constructor(F,te){this.label=F,this.documentation=te}};Te=ze([R],Te),e.ParameterInformation=Te;let rt=class{constructor(F,te){this.label=F,this.documentation=te,this.parameters=[]}};rt=ze([R],rt),e.SignatureInformation=rt;let X=class{constructor(){this.activeSignature=0,this.activeParameter=0,this.signatures=[]}};X=ze([R],X),e.SignatureHelp=X;var Q;(function(x){x[x.Invoke=1]="Invoke",x[x.TriggerCharacter=2]="TriggerCharacter",x[x.ContentChange=3]="ContentChange"})(Q=e.SignatureHelpTriggerKind||(e.SignatureHelpTriggerKind={}));var he;(function(x){x[x.Type=1]="Type",x[x.Parameter=2]="Parameter"})(he=e.InlayHintKind||(e.InlayHintKind={}));let Ue=class{constructor(F){this.value=F}};Ue=ze([R],Ue),e.InlayHintLabelPart=Ue;let je=class{constructor(F,te,we){this.position=F,this.label=te,this.kind=we}};je=ze([R],je),e.InlayHint=je;var Ze;(function(x){x[x.Invoke=0]="Invoke",x[x.TriggerCharacter=1]="TriggerCharacter",x[x.TriggerForIncompleteCompletions=2]="TriggerForIncompleteCompletions"})(Ze=e.CompletionTriggerKind||(e.CompletionTriggerKind={}));var Ke;(function(x){x[x.Text=0]="Text",x[x.Method=1]="Method",x[x.Function=2]="Function",x[x.Constructor=3]="Constructor",x[x.Field=4]="Field",x[x.Variable=5]="Variable",x[x.Class=6]="Class",x[x.Interface=7]="Interface",x[x.Module=8]="Module",x[x.Property=9]="Property",x[x.Unit=10]="Unit",x[x.Value=11]="Value",x[x.Enum=12]="Enum",x[x.Keyword=13]="Keyword",x[x.Snippet=14]="Snippet",x[x.Color=15]="Color",x[x.File=16]="File",x[x.Reference=17]="Reference",x[x.Folder=18]="Folder",x[x.EnumMember=19]="EnumMember",x[x.Constant=20]="Constant",x[x.Struct=21]="Struct",x[x.Event=22]="Event",x[x.Operator=23]="Operator",x[x.TypeParameter=24]="TypeParameter",x[x.User=25]="User",x[x.Issue=26]="Issue"})(Ke=e.CompletionItemKind||(e.CompletionItemKind={}));var Ve;(function(x){x[x.Deprecated=1]="Deprecated"})(Ve=e.CompletionItemTag||(e.CompletionItemTag={}));let it=class{constructor(F,te){this.label=F,this.kind=te}toJSON(){return{label:this.label,kind:this.kind&&Ke[this.kind],detail:this.detail,documentation:this.documentation,sortText:this.sortText,filterText:this.filterText,preselect:this.preselect,insertText:this.insertText,textEdit:this.textEdit}}};it=ze([R],it),e.CompletionItem=it;let st=class{constructor(F=[],te=!1){this.items=F,this.isIncomplete=te}};st=ze([R],st),e.CompletionList=st;let dt=class{constructor(F,te,we){this.insertText=F,this.range=te,this.command=we}};dt=ze([R],dt),e.InlineSuggestion=dt;let yt=class{constructor(F){this.commands=void 0,this.items=F}};yt=ze([R],yt),e.InlineSuggestionList=yt;let et=class{constructor(F,te,we){this.insertText=F,this.range=te,this.command=we}};et=ze([R],et),e.InlineSuggestionNew=et;let ut=class{constructor(F,te){this.items=F,this.commands=te}};ut=ze([R],ut),e.InlineSuggestionsNew=ut;var Ot;(function(x){x[x.Active=-1]="Active",x[x.Beside=-2]="Beside",x[x.One=1]="One",x[x.Two=2]="Two",x[x.Three=3]="Three",x[x.Four=4]="Four",x[x.Five=5]="Five",x[x.Six=6]="Six",x[x.Seven=7]="Seven",x[x.Eight=8]="Eight",x[x.Nine=9]="Nine"})(Ot=e.ViewColumn||(e.ViewColumn={}));var Vt;(function(x){x[x.Left=1]="Left",x[x.Right=2]="Right"})(Vt=e.StatusBarAlignment||(e.StatusBarAlignment={}));var At;(function(x){x[x.Off=0]="Off",x[x.On=1]="On",x[x.Relative=2]="Relative"})(At=e.TextEditorLineNumbersStyle||(e.TextEditorLineNumbersStyle={}));var ft;(function(x){x[x.Manual=1]="Manual",x[x.AfterDelay=2]="AfterDelay",x[x.FocusOut=3]="FocusOut"})(ft=e.TextDocumentSaveReason||(e.TextDocumentSaveReason={}));var It;(function(x){x[x.Default=0]="Default",x[x.InCenter=1]="InCenter",x[x.InCenterIfOutsideViewport=2]="InCenterIfOutsideViewport",x[x.AtTop=3]="AtTop"})(It=e.TextEditorRevealType||(e.TextEditorRevealType={}));var Lt;(function(x){x[x.Keyboard=1]="Keyboard",x[x.Mouse=2]="Mouse",x[x.Command=3]="Command"})(Lt=e.TextEditorSelectionChangeKind||(e.TextEditorSelectionChangeKind={}));var xt;(function(x){x[x.Undo=1]="Undo",x[x.Redo=2]="Redo"})(xt=e.TextDocumentChangeReason||(e.TextDocumentChangeReason={}));var qe;(function(x){x[x.OpenOpen=0]="OpenOpen",x[x.ClosedClosed=1]="ClosedClosed",x[x.OpenClosed=2]="OpenClosed",x[x.ClosedOpen=3]="ClosedOpen"})(qe=e.DecorationRangeBehavior||(e.DecorationRangeBehavior={})),function(x){function F(te){switch(te){case"keyboard":return x.Keyboard;case"mouse":return x.Mouse;case"api":return x.Command}}x.fromValue=F}(Lt=e.TextEditorSelectionChangeKind||(e.TextEditorSelectionChangeKind={}));let Ft=class{constructor(F,te){if(te&&!P.URI.isUri(te))throw(0,y.illegalArgument)("target");if(!$.isRange(F)||F.isEmpty)throw(0,y.illegalArgument)("range");this.range=F,this.target=te}};Ft=ze([R],Ft),e.DocumentLink=Ft;let kt=class{constructor(F,te,we,He){this.red=F,this.green=te,this.blue=we,this.alpha=He}};kt=ze([R],kt),e.Color=kt;let Nt=class{constructor(F,te){if(te&&!(te instanceof kt))throw(0,y.illegalArgument)("color");if(!$.isRange(F)||F.isEmpty)throw(0,y.illegalArgument)("range");this.range=F,this.color=te}};Nt=ze([R],Nt),e.ColorInformation=Nt;let gt=class{constructor(F){if(!F||typeof F!="string")throw(0,y.illegalArgument)("label");this.label=F}};gt=ze([R],gt),e.ColorPresentation=gt;var Se;(function(x){x[x.RGB=0]="RGB",x[x.HEX=1]="HEX",x[x.HSL=2]="HSL"})(Se=e.ColorFormat||(e.ColorFormat={}));var Pe;(function(x){x[x.Error=0]="Error",x[x.Warning=1]="Warning",x[x.Information=2]="Information"})(Pe=e.SourceControlInputBoxValidationType||(e.SourceControlInputBoxValidationType={}));var fe;(function(x){x[x.Unknown=0]="Unknown",x[x.Shutdown=1]="Shutdown",x[x.Process=2]="Process",x[x.User=3]="User",x[x.Extension=4]="Extension"})(fe=e.TerminalExitReason||(e.TerminalExitReason={}));class q{constructor(F,te,we){if(this.startIndex=F,this.length=te,this.tooltip=we,typeof F!="number"||F<0)throw(0,y.illegalArgument)("startIndex");if(typeof te!="number"||te<1)throw(0,y.illegalArgument)("length");if(we!==void 0&&typeof we!="string")throw(0,y.illegalArgument)("tooltip")}}e.TerminalLink=q;var Ae;(function(x){x[x.Panel=1]="Panel",x[x.Editor=2]="Editor"})(Ae=e.TerminalLocation||(e.TerminalLocation={}));class Le{constructor(F){if(this.options=F,typeof F!="object")throw(0,y.illegalArgument)("options")}}e.TerminalProfile=Le;var nt;(function(x){x[x.Always=1]="Always",x[x.Silent=2]="Silent",x[x.Never=3]="Never"})(nt=e.TaskRevealKind||(e.TaskRevealKind={}));var We;(function(x){x[x.Shared=1]="Shared",x[x.Dedicated=2]="Dedicated",x[x.New=3]="New"})(We=e.TaskPanelKind||(e.TaskPanelKind={}));let tt=N=class{static from(F){switch(F){case"clean":return N.Clean;case"build":return N.Build;case"rebuild":return N.Rebuild;case"test":return N.Test;default:return}}constructor(F,te){if(this.label=te,typeof F!="string"||typeof te!="string")throw(0,y.illegalArgument)("name");this._id=F}get id(){return this._id}};tt.Clean=new N("clean","Clean"),tt.Build=new N("build","Build"),tt.Rebuild=new N("rebuild","Rebuild"),tt.Test=new N("test","Test"),tt=N=ze([R],tt),e.TaskGroup=tt;function ct(x){let F="";for(let te=0;te<x.length;te++)F+=x[te].replace(/,/g,",,")+",";return F}let mt=class{constructor(F,te,we){if(typeof F!="string")throw(0,y.illegalArgument)("process");this._args=[],this._process=F,te!==void 0&&(Array.isArray(te)?(this._args=te,this._options=we):this._options=te)}get process(){return this._process}set process(F){if(typeof F!="string")throw(0,y.illegalArgument)("process");this._process=F}get args(){return this._args}set args(F){Array.isArray(F)||(F=[]),this._args=F}get options(){return this._options}set options(F){this._options=F}computeId(){const F=[];if(F.push("process"),this._process!==void 0&&F.push(this._process),this._args&&this._args.length>0)for(const te of this._args)F.push(te);return ct(F)}};mt=ze([R],mt),e.ProcessExecution=mt;let Dt=class{constructor(F,te,we){if(this._args=[],Array.isArray(te)){if(!F)throw(0,y.illegalArgument)("command can't be undefined or null");if(typeof F!="string"&&typeof F.value!="string")throw(0,y.illegalArgument)("command");this._command=F,this._args=te,this._options=we}else{if(typeof F!="string")throw(0,y.illegalArgument)("commandLine");this._commandLine=F,this._options=te}}get commandLine(){return this._commandLine}set commandLine(F){if(typeof F!="string")throw(0,y.illegalArgument)("commandLine");this._commandLine=F}get command(){return this._command?this._command:""}set command(F){if(typeof F!="string"&&typeof F.value!="string")throw(0,y.illegalArgument)("command");this._command=F}get args(){return this._args}set args(F){this._args=F||[]}get options(){return this._options}set options(F){this._options=F}computeId(){const F=[];if(F.push("shell"),this._commandLine!==void 0&&F.push(this._commandLine),this._command!==void 0&&F.push(typeof this._command=="string"?this._command:this._command.value),this._args&&this._args.length>0)for(const te of this._args)F.push(typeof te=="string"?te:te.value);return ct(F)}};Dt=ze([R],Dt),e.ShellExecution=Dt;var Et;(function(x){x[x.Escape=1]="Escape",x[x.Strong=2]="Strong",x[x.Weak=3]="Weak"})(Et=e.ShellQuoting||(e.ShellQuoting={}));var wt;(function(x){x[x.Global=1]="Global",x[x.Workspace=2]="Workspace"})(wt=e.TaskScope||(e.TaskScope={}));class Tt{constructor(F){this._callback=F}computeId(){return"customExecution"+(0,O.generateUuid)()}set callback(F){this._callback=F}get callback(){return this._callback}}e.CustomExecution=Tt;let bt=V=class{constructor(F,te,we,He,Qe,at){this.__deprecated=!1,this._definition=this.definition=F;let ht;typeof te=="string"?(this._name=this.name=te,this._source=this.source=we,this.execution=He,ht=Qe,this.__deprecated=!0):te===wt.Global||te===wt.Workspace?(this.target=te,this._name=this.name=we,this._source=this.source=He,this.execution=Qe,ht=at):(this.target=te,this._name=this.name=we,this._source=this.source=He,this.execution=Qe,ht=at),typeof ht=="string"?(this._problemMatchers=[ht],this._hasDefinedMatchers=!0):Array.isArray(ht)?(this._problemMatchers=ht,this._hasDefinedMatchers=!0):(this._problemMatchers=[],this._hasDefinedMatchers=!1),this._isBackground=!1,this._presentationOptions=Object.create(null),this._runOptions=Object.create(null)}get _id(){return this.__id}set _id(F){this.__id=F}get _deprecated(){return this.__deprecated}clear(){this.__id!==void 0&&(this.__id=void 0,this._scope=void 0,this.computeDefinitionBasedOnExecution())}computeDefinitionBasedOnExecution(){this._execution instanceof mt?this._definition={type:V.ProcessType,id:this._execution.computeId()}:this._execution instanceof Dt?this._definition={type:V.ShellType,id:this._execution.computeId()}:this._execution instanceof Tt?this._definition={type:V.ExtensionCallbackType,id:this._execution.computeId()}:this._definition={type:V.EmptyType,id:(0,O.generateUuid)()}}get definition(){return this._definition}set definition(F){if(F==null)throw(0,y.illegalArgument)("Kind can't be undefined or null");this.clear(),this._definition=F}get scope(){return this._scope}set target(F){this.clear(),this._scope=F}get name(){return this._name}set name(F){if(typeof F!="string")throw(0,y.illegalArgument)("name");this.clear(),this._name=F}get execution(){return this._execution}set execution(F){F===null&&(F=void 0),this.clear(),this._execution=F;const te=this._definition.type;(V.EmptyType===te||V.ProcessType===te||V.ShellType===te||V.ExtensionCallbackType===te)&&this.computeDefinitionBasedOnExecution()}get problemMatchers(){return this._problemMatchers}set problemMatchers(F){if(Array.isArray(F))this.clear(),this._problemMatchers=F,this._hasDefinedMatchers=!0;else{this.clear(),this._problemMatchers=[],this._hasDefinedMatchers=!1;return}}get hasDefinedMatchers(){return this._hasDefinedMatchers}get isBackground(){return this._isBackground}set isBackground(F){F!==!0&&F!==!1&&(F=!1),this.clear(),this._isBackground=F}get source(){return this._source}set source(F){if(typeof F!="string"||F.length===0)throw(0,y.illegalArgument)("source must be a string of length > 0");this.clear(),this._source=F}get group(){return this._group}set group(F){F===null&&(F=void 0),this.clear(),this._group=F}get detail(){return this._detail}set detail(F){F===null&&(F=void 0),this._detail=F}get presentationOptions(){return this._presentationOptions}set presentationOptions(F){F==null&&(F=Object.create(null)),this.clear(),this._presentationOptions=F}get runOptions(){return this._runOptions}set runOptions(F){F==null&&(F=Object.create(null)),this.clear(),this._runOptions=F}};bt.ExtensionCallbackType="customExecution",bt.ProcessType="process",bt.ShellType="shell",bt.EmptyType="$empty",bt=V=ze([R],bt),e.Task=bt;var Ct;(function(x){x[x.SourceControl=1]="SourceControl",x[x.Window=10]="Window",x[x.Notification=15]="Notification"})(Ct=e.ProgressLocation||(e.ProgressLocation={}));let Yt=B=class{static isTreeItem(F,te){if(F instanceof B)return!0;const we=F;if(we.label!==void 0&&!(0,b.isString)(we.label)&&!we.label?.label)return console.log("INVALID tree item, invalid label",we.label),!1;if(we.id!==void 0&&!(0,b.isString)(we.id))return console.log("INVALID tree item, invalid id",we.id),!1;if(we.iconPath!==void 0&&!(0,b.isString)(we.iconPath)&&!P.URI.isUri(we.iconPath)&&(!we.iconPath||!(0,b.isString)(we.iconPath.id))){const He=we.iconPath;if(!He||!(0,b.isString)(He.light)&&!P.URI.isUri(He.light)&&!(0,b.isString)(He.dark)&&!P.URI.isUri(He.dark))return console.log("INVALID tree item, invalid iconPath",we.iconPath),!1}if(we.description!==void 0&&!(0,b.isString)(we.description)&&typeof we.description!="boolean")return console.log("INVALID tree item, invalid description",we.description),!1;if(we.resourceUri!==void 0&&!P.URI.isUri(we.resourceUri))return console.log("INVALID tree item, invalid resourceUri",we.resourceUri),!1;if(we.tooltip!==void 0&&!(0,b.isString)(we.tooltip)&&!(we.tooltip instanceof Ge))return console.log("INVALID tree item, invalid tooltip",we.tooltip),!1;if(we.command!==void 0&&!we.command.command)return console.log("INVALID tree item, invalid command",we.command),!1;if(we.collapsibleState!==void 0&&we.collapsibleState<qt.None&&we.collapsibleState>qt.Expanded)return console.log("INVALID tree item, invalid collapsibleState",we.collapsibleState),!1;if(we.contextValue!==void 0&&!(0,b.isString)(we.contextValue))return console.log("INVALID tree item, invalid contextValue",we.contextValue),!1;if(we.accessibilityInformation!==void 0&&!we.accessibilityInformation?.label)return console.log("INVALID tree item, invalid accessibilityInformation",we.accessibilityInformation),!1;if(we.checkboxState!==void 0){(0,f.checkProposedApiEnabled)(te,"treeItemCheckbox");const He=(0,b.isNumber)(we.checkboxState)?we.checkboxState:(0,b.isObject)(we.checkboxState)&&(0,b.isNumber)(we.checkboxState.state)?we.checkboxState.state:void 0,Qe=!(0,b.isNumber)(we.checkboxState)&&(0,b.isObject)(we.checkboxState)?we.checkboxState.tooltip:void 0;if(He===void 0||He!==vt.Checked&&He!==vt.Unchecked||Qe!==void 0&&!(0,b.isString)(Qe))return console.log("INVALID tree item, invalid checkboxState",we.checkboxState),!1}return!0}constructor(F,te=qt.None){this.collapsibleState=te,P.URI.isUri(F)?this.resourceUri=F:this.label=F}};Yt=B=ze([R],Yt),e.TreeItem=Yt;var qt;(function(x){x[x.None=0]="None",x[x.Collapsed=1]="Collapsed",x[x.Expanded=2]="Expanded"})(qt=e.TreeItemCollapsibleState||(e.TreeItemCollapsibleState={}));var vt;(function(x){x[x.Unchecked=0]="Unchecked",x[x.Checked=1]="Checked"})(vt=e.TreeItemCheckboxState||(e.TreeItemCheckboxState={}));let ti=class{async asString(){return typeof this.value=="string"?this.value:JSON.stringify(this.value)}asFile(){}constructor(F,te){this.value=F,this.id=te??(0,O.generateUuid)()}};ti=ze([R],ti),e.DataTransferItem=ti;let ii=class{constructor(F){h.set(this,new Map);for(const[te,we]of F??[]){const He=Oe(this,h,"f").get(te);He?He.push(we):Oe(this,h,"f").set(te,[we])}}get(F){return Oe(this,h,"f").get(F)?.[0]}set(F,te){Oe(this,h,"f").set(F,[te])}forEach(F,te){for(const[we,He]of Oe(this,h,"f"))for(const Qe of He)F.call(te,Qe,we,this)}*[(h=new WeakMap,Symbol.iterator)](){for(const[F,te]of Oe(this,h,"f"))for(const we of te)yield[F,we]}};ii=ze([R],ii),e.DataTransfer=ii;let ni=class{constructor(F){this.insertText=F}};ni=ze([R],ni),e.DocumentDropEdit=ni;let mi=class{constructor(F){this.insertText=F}};mi=ze([R],mi),e.DocumentPasteEdit=mi;let _t=class{constructor(F,te){this.id=F,this.color=te}};_t=ze([R],_t),e.ThemeIcon=_t,_t.File=new _t("file"),_t.Folder=new _t("folder");let ri=class{constructor(F){this.id=F}};ri=ze([R],ri),e.ThemeColor=ri;var Oi;(function(x){x[x.Global=1]="Global",x[x.Workspace=2]="Workspace",x[x.WorkspaceFolder=3]="WorkspaceFolder"})(Oi=e.ConfigurationTarget||(e.ConfigurationTarget={}));let Jt=class{get base(){return this._base}set base(F){this._base=F,this._baseUri=P.URI.file(F)}get baseUri(){return this._baseUri}set baseUri(F){this._baseUri=F,this._base=F.fsPath}constructor(F,te){if(typeof F!="string"&&(!F||!P.URI.isUri(F)&&!P.URI.isUri(F.uri)))throw(0,y.illegalArgument)("base");if(typeof te!="string")throw(0,y.illegalArgument)("pattern");typeof F=="string"?this.baseUri=P.URI.file(F):P.URI.isUri(F)?this.baseUri=F:this.baseUri=F.uri,this.pattern=te}toJSON(){return{pattern:this.pattern,base:this.base,baseUri:this.baseUri.toJSON()}}};Jt=ze([R],Jt),e.RelativePattern=Jt;let zt=class{constructor(F,te,we,He){this.enabled=typeof F=="boolean"?F:!0,typeof te=="string"&&(this.condition=te),typeof we=="string"&&(this.hitCondition=we),typeof He=="string"&&(this.logMessage=He)}get id(){return this._id||(this._id=(0,O.generateUuid)()),this._id}};zt=ze([R],zt),e.Breakpoint=zt;let lt=class extends zt{constructor(F,te,we,He,Qe){if(super(te,we,He,Qe),F===null)throw(0,y.illegalArgument)("location");this.location=F}};lt=ze([R],lt),e.SourceBreakpoint=lt;let gi=class extends zt{constructor(F,te,we,He,Qe){super(te,we,He,Qe),this.functionName=F}};gi=ze([R],gi),e.FunctionBreakpoint=gi;let $t=class extends zt{constructor(F,te,we,He,Qe,at,ht){if(super(He,Qe,at,ht),!te)throw(0,y.illegalArgument)("dataId");this.label=F,this.dataId=te,this.canPersist=we}};$t=ze([R],$t),e.DataBreakpoint=$t;let Kt=class{constructor(F,te,we){this.command=F,this.args=te||[],this.options=we}};Kt=ze([R],Kt),e.DebugAdapterExecutable=Kt;let si=class{constructor(F,te){this.port=F,this.host=te}};si=ze([R],si),e.DebugAdapterServer=si;let pi=class{constructor(F){this.path=F}};pi=ze([R],pi),e.DebugAdapterNamedPipeServer=pi;let oi=class{constructor(F){this.implementation=F}};oi=ze([R],oi),e.DebugAdapterInlineImplementation=oi;let vi=class{constructor(F,te){this.range=F,this.expression=te}};vi=ze([R],vi),e.EvaluatableExpression=vi;var Ci;(function(x){x[x.Invoke=0]="Invoke",x[x.Automatic=1]="Automatic"})(Ci=e.InlineCompletionTriggerKind||(e.InlineCompletionTriggerKind={}));var ai;(function(x){x[x.Invoke=0]="Invoke",x[x.Automatic=1]="Automatic"})(ai=e.InlineCompletionTriggerKindNew||(e.InlineCompletionTriggerKindNew={}));let Ei=class{constructor(F,te){this.range=F,this.text=te}};Ei=ze([R],Ei),e.InlineValueText=Ei;let Zt=class{constructor(F,te,we=!0){this.range=F,this.variableName=te,this.caseSensitiveLookup=we}};Zt=ze([R],Zt),e.InlineValueVariableLookup=Zt;let ei=class{constructor(F,te){this.range=F,this.expression=te}};ei=ze([R],ei),e.InlineValueEvaluatableExpression=ei;let bi=class{constructor(F,te){this.frameId=F,this.stoppedLocation=te}};bi=ze([R],bi),e.InlineValueContext=bi;var Fi;(function(x){x[x.Changed=1]="Changed",x[x.Created=2]="Created",x[x.Deleted=3]="Deleted"})(Fi=e.FileChangeType||(e.FileChangeType={}));let Gt=D=class extends Error{static FileExists(F){return new D(F,E.FileSystemProviderErrorCode.FileExists,D.FileExists)}static FileNotFound(F){return new D(F,E.FileSystemProviderErrorCode.FileNotFound,D.FileNotFound)}static FileNotADirectory(F){return new D(F,E.FileSystemProviderErrorCode.FileNotADirectory,D.FileNotADirectory)}static FileIsADirectory(F){return new D(F,E.FileSystemProviderErrorCode.FileIsADirectory,D.FileIsADirectory)}static NoPermissions(F){return new D(F,E.FileSystemProviderErrorCode.NoPermissions,D.NoPermissions)}static Unavailable(F){return new D(F,E.FileSystemProviderErrorCode.Unavailable,D.Unavailable)}constructor(F,te=E.FileSystemProviderErrorCode.Unknown,we){super(P.URI.isUri(F)?F.toString(!0):F),this.code=we?.name??"Unknown",(0,E.markAsFileSystemProviderError)(this,te),typeof Object.setPrototypeOf=="function"&&Object.setPrototypeOf(this,D.prototype),typeof Error.captureStackTrace=="function"&&typeof we=="function"&&Error.captureStackTrace(this,we)}};Gt=D=ze([R],Gt),e.FileSystemError=Gt;let wi=class{constructor(F,te,we){this.start=F,this.end=te,this.kind=we}};wi=ze([R],wi),e.FoldingRange=wi;var Ni;(function(x){x[x.Comment=1]="Comment",x[x.Imports=2]="Imports",x[x.Region=3]="Region"})(Ni=e.FoldingRangeKind||(e.FoldingRangeKind={}));var Mi;(function(x){x[x.Collapsed=0]="Collapsed",x[x.Expanded=1]="Expanded"})(Mi=e.CommentThreadCollapsibleState||(e.CommentThreadCollapsibleState={}));var Li;(function(x){x[x.Editing=0]="Editing",x[x.Preview=1]="Preview"})(Li=e.CommentMode||(e.CommentMode={}));var Si;(function(x){x[x.Unresolved=0]="Unresolved",x[x.Resolved=1]="Resolved"})(Si=e.CommentThreadState||(e.CommentThreadState={}));class Ii{constructor(F,te=[]){this.tokenTypes=F,this.tokenModifiers=te}}e.SemanticTokensLegend=Ii;function ki(x){return typeof x>"u"||(0,b.isStringArray)(x)}class Ne{constructor(F){if(this._prevLine=0,this._prevChar=0,this._dataIsSortedAndDeltaEncoded=!0,this._data=[],this._dataLen=0,this._tokenTypeStrToInt=new Map,this._tokenModifierStrToInt=new Map,this._hasLegend=!1,F){this._hasLegend=!0;for(let te=0,we=F.tokenTypes.length;te<we;te++)this._tokenTypeStrToInt.set(F.tokenTypes[te],te);for(let te=0,we=F.tokenModifiers.length;te<we;te++)this._tokenModifierStrToInt.set(F.tokenModifiers[te],te)}}push(F,te,we,He,Qe){if(typeof F=="number"&&typeof te=="number"&&typeof we=="number"&&typeof He=="number"&&(typeof Qe=="number"||typeof Qe>"u"))return typeof Qe>"u"&&(Qe=0),this._pushEncoded(F,te,we,He,Qe);if($.isRange(F)&&typeof te=="string"&&ki(we))return this._push(F,te,we);throw(0,y.illegalArgument)()}_push(F,te,we){if(!this._hasLegend)throw new Error("Legend must be provided in constructor");if(F.start.line!==F.end.line)throw new Error("`range` cannot span multiple lines");if(!this._tokenTypeStrToInt.has(te))throw new Error("`tokenType` is not in the provided legend");const He=F.start.line,Qe=F.start.character,at=F.end.character-F.start.character,ht=this._tokenTypeStrToInt.get(te);let Rt=0;if(we)for(const Bt of we){if(!this._tokenModifierStrToInt.has(Bt))throw new Error("`tokenModifier` is not in the provided legend");const Ht=this._tokenModifierStrToInt.get(Bt);Rt|=1<<Ht>>>0}this._pushEncoded(He,Qe,at,ht,Rt)}_pushEncoded(F,te,we,He,Qe){if(this._dataIsSortedAndDeltaEncoded&&(F<this._prevLine||F===this._prevLine&&te<this._prevChar)){this._dataIsSortedAndDeltaEncoded=!1;const Rt=this._data.length/5|0;let Bt=0,Ht=0;for(let jt=0;jt<Rt;jt++){let Xt=this._data[5*jt],yi=this._data[5*jt+1];Xt===0?(Xt=Bt,yi+=Ht):Xt+=Bt,this._data[5*jt]=Xt,this._data[5*jt+1]=yi,Bt=Xt,Ht=yi}}let at=F,ht=te;this._dataIsSortedAndDeltaEncoded&&this._dataLen>0&&(at-=this._prevLine,at===0&&(ht-=this._prevChar)),this._data[this._dataLen++]=at,this._data[this._dataLen++]=ht,this._data[this._dataLen++]=we,this._data[this._dataLen++]=He,this._data[this._dataLen++]=Qe,this._prevLine=F,this._prevChar=te}static _sortAndDeltaEncode(F){const te=[],we=F.length/5|0;for(let ht=0;ht<we;ht++)te[ht]=ht;te.sort((ht,Rt)=>{const Bt=F[5*ht],Ht=F[5*Rt];if(Bt===Ht){const jt=F[5*ht+1],Xt=F[5*Rt+1];return jt-Xt}return Bt-Ht});const He=new Uint32Array(F.length);let Qe=0,at=0;for(let ht=0;ht<we;ht++){const Rt=5*te[ht],Bt=F[Rt+0],Ht=F[Rt+1],jt=F[Rt+2],Xt=F[Rt+3],yi=F[Rt+4],Zi=Bt-Qe,Dn=Zi===0?Ht-at:Ht,Di=5*ht;He[Di+0]=Zi,He[Di+1]=Dn,He[Di+2]=jt,He[Di+3]=Xt,He[Di+4]=yi,Qe=Bt,at=Ht}return He}build(F){return this._dataIsSortedAndDeltaEncoded?new Ut(new Uint32Array(this._data),F):new Ut(Ne._sortAndDeltaEncode(this._data),F)}}e.SemanticTokensBuilder=Ne;class Ut{constructor(F,te){this.resultId=te,this.data=F}}e.SemanticTokens=Ut;class Ti{constructor(F,te,we){this.start=F,this.deleteCount=te,this.data=we}}e.SemanticTokensEdit=Ti;class pt{constructor(F,te){this.resultId=te,this.edits=F}}e.SemanticTokensEdits=pt;var Ui;(function(x){x[x.Separate=0]="Separate",x[x.MergeWithParent=1]="MergeWithParent"})(Ui=e.DebugConsoleMode||(e.DebugConsoleMode={}));let ci=class{constructor(){}};ci.Back={iconPath:new _t("arrow-left")},ci=ze([R],ci),e.QuickInputButtons=ci;var Pi;(function(x){x[x.Separator=-1]="Separator",x[x.Default=0]="Default"})(Pi=e.QuickPickItemKind||(e.QuickPickItemKind={}));var Bi;(function(x){x[x.Info=1]="Info",x[x.Warning=2]="Warning",x[x.Error=3]="Error"})(Bi=e.InputBoxValidationSeverity||(e.InputBoxValidationSeverity={}));var li;(function(x){x[x.UI=1]="UI",x[x.Workspace=2]="Workspace"})(li=e.ExtensionKind||(e.ExtensionKind={}));class xi{static validate(F){if(F.badge){let te=(0,A.nextCharLength)(F.badge,0);if(te<F.badge.length&&(te+=(0,A.nextCharLength)(F.badge,te)),F.badge.length>te)throw new Error("The 'badge'-property must be undefined or a short character")}if(!F.color&&!F.badge&&!F.tooltip)throw new Error("The decoration is empty");return!0}constructor(F,te,we){this.badge=F,this.tooltip=te,this.color=we}}e.FileDecoration=xi;let _i=class{constructor(F){this.kind=F}};_i=ze([R],_i),e.ColorTheme=_i;var zi;(function(x){x[x.Light=1]="Light",x[x.Dark=2]="Dark",x[x.HighContrast=3]="HighContrast",x[x.HighContrastLight=4]="HighContrastLight"})(zi=e.ColorThemeKind||(e.ColorThemeKind={}));class Wt{static isNotebookRange(F){return F instanceof Wt?!0:F?typeof F.start=="number"&&typeof F.end=="number":!1}get start(){return this._start}get end(){return this._end}get isEmpty(){return this._start===this._end}constructor(F,te){if(F<0)throw(0,y.illegalArgument)("start must be positive");if(te<0)throw(0,y.illegalArgument)("end must be positive");F<=te?(this._start=F,this._end=te):(this._start=te,this._end=F)}with(F){let te=this._start,we=this._end;return F.start!==void 0&&(te=F.start),F.end!==void 0&&(we=F.end),te===this._start&&we===this._end?this:new Wt(te,we)}}e.NotebookRange=Wt;class ui{static validate(F){if(typeof F.kind!="number")throw new Error("NotebookCellData MUST have 'kind' property");if(typeof F.value!="string")throw new Error("NotebookCellData MUST have 'value' property");if(typeof F.languageId!="string")throw new Error("NotebookCellData MUST have 'languageId' property")}static isNotebookCellDataArray(F){return Array.isArray(F)&&F.every(te=>ui.isNotebookCellData(te))}static isNotebookCellData(F){return!0}constructor(F,te,we,He,Qe,at,ht){this.kind=F,this.value=te,this.languageId=we,this.mime=He,this.outputs=Qe??[],this.metadata=at,this.executionSummary=ht,ui.validate(this)}}e.NotebookCellData=ui;class $i{constructor(F){this.cells=F}}e.NotebookData=$i;class Mt{static isNotebookCellOutputItem(F){return F instanceof Mt?!0:F?typeof F.mime=="string"&&F.data instanceof Uint8Array:!1}static error(F){const te={name:F.name,message:F.message,stack:F.stack};return Mt.json(te,"application/vnd.code.notebook.error")}static stdout(F){return Mt.text(F,"application/vnd.code.notebook.stdout")}static stderr(F){return Mt.text(F,"application/vnd.code.notebook.stderr")}static bytes(F,te="application/octet-stream"){return new Mt(F,te)}static text(F,te=_.Mimes.text){const we=Oe(Mt,g,"f",C).encode(String(F));return new Mt(we,te)}static json(F,te="text/x-json"){const we=JSON.stringify(F,void 0,"	");return Mt.text(we,te)}constructor(F,te){this.data=F,this.mime=te;const we=(0,_.normalizeMimeType)(te,!0);if(!we)throw new Error(`INVALID mime type: ${te}. Must be in the format "type/subtype[;optionalparameter]"`);this.mime=we}}e.NotebookCellOutputItem=Mt,g=Mt,C={value:new TextEncoder};class di{static isNotebookCellOutput(F){return F instanceof di?!0:!F||typeof F!="object"?!1:typeof F.id=="string"&&Array.isArray(F.items)}static ensureUniqueMimeTypes(F,te=!1){const we=new Set,He=new Set;for(let Qe=0;Qe<F.length;Qe++){const at=F[Qe],ht=(0,_.normalizeMimeType)(at.mime);if(!we.has(ht)||(0,k.isTextStreamMime)(ht)){we.add(ht);continue}He.add(Qe),te&&console.warn(`DUPLICATED mime type '${at.mime}' will be dropped`)}return He.size===0?F:F.filter((Qe,at)=>!He.has(at))}constructor(F,te,we){this.items=di.ensureUniqueMimeTypes(F,!0),typeof te=="string"?(this.id=te,this.metadata=we):(this.id=(0,O.generateUuid)(),this.metadata=te??we)}}e.NotebookCellOutput=di;var Wi;(function(x){x[x.Markup=1]="Markup",x[x.Code=2]="Code"})(Wi=e.NotebookCellKind||(e.NotebookCellKind={}));var Hi;(function(x){x[x.Idle=1]="Idle",x[x.Pending=2]="Pending",x[x.Executing=3]="Executing"})(Hi=e.NotebookCellExecutionState||(e.NotebookCellExecutionState={}));var re;(function(x){x[x.Left=1]="Left",x[x.Right=2]="Right"})(re=e.NotebookCellStatusBarAlignment||(e.NotebookCellStatusBarAlignment={}));var de;(function(x){x[x.Default=0]="Default",x[x.InCenter=1]="InCenter",x[x.InCenterIfOutsideViewport=2]="InCenterIfOutsideViewport",x[x.AtTop=3]="AtTop"})(de=e.NotebookEditorRevealType||(e.NotebookEditorRevealType={}));class Re{constructor(F,te){this.text=F,this.alignment=te}}e.NotebookCellStatusBarItem=Re;var ot;(function(x){x[x.Default=1]="Default",x[x.Preferred=2]="Preferred"})(ot=e.NotebookControllerAffinity||(e.NotebookControllerAffinity={}));var St;(function(x){x[x.Default=1]="Default",x[x.Preferred=2]="Preferred",x[x.Hidden=-1]="Hidden"})(St=e.NotebookControllerAffinity2||(e.NotebookControllerAffinity2={}));class Pt{constructor(F,te=[]){this.uri=F,this.provides=(0,r.asArray)(te)}}e.NotebookRendererScript=Pt;let Vi=class{constructor(F,te){this.label=F,this.timestamp=te}};Vi=ze([R],Vi),e.TimelineItem=Vi;var rn;(function(x){x[x.Production=1]="Production",x[x.Development=2]="Development",x[x.Test=3]="Test"})(rn=e.ExtensionMode||(e.ExtensionMode={}));var sn;(function(x){x[x.Node=1]="Node",x[x.Webworker=2]="Webworker"})(sn=e.ExtensionRuntime||(e.ExtensionRuntime={}));var on;(function(x){x[x.Other=0]="Other",x[x.Comment=1]="Comment",x[x.String=2]="String",x[x.RegEx=3]="RegEx"})(on=e.StandardTokenType||(e.StandardTokenType={}));class an{constructor(F,te){this.ranges=F,this.wordPattern=te}}e.LinkedEditingRanges=an;class cn{constructor(F,te){this._port=F,this._autoForwardAction=te}get port(){return this._port}get autoForwardAction(){return this._autoForwardAction}}e.PortAttributes=cn;var ln;(function(x){x[x.Queued=1]="Queued",x[x.Running=2]="Running",x[x.Passed=3]="Passed",x[x.Failed=4]="Failed",x[x.Skipped=5]="Skipped",x[x.Errored=6]="Errored"})(ln=e.TestResultState||(e.TestResultState={}));var un;(function(x){x[x.Run=1]="Run",x[x.Debug=2]="Debug",x[x.Coverage=3]="Coverage"})(un=e.TestRunProfileKind||(e.TestRunProfileKind={}));let ji=class{constructor(F=void 0,te=void 0,we=void 0){this.include=F,this.exclude=te,this.profile=we}};ji=ze([R],ji),e.TestRunRequest=ji;let qi=z=class{static diff(F,te,we){const He=new z(F);return He.expectedOutput=te,He.actualOutput=we,He}constructor(F){this.message=F}};qi=z=ze([R],qi),e.TestMessage=qi;let Ki=class{constructor(F){this.id=F}};Ki=ze([R],Ki),e.TestTag=Ki;let hi=class{constructor(F,te){this.covered=F,this.total=te}};hi=ze([R],hi),e.CoveredCount=hi;let Gi=L=class{static fromDetails(F,te){const we=new hi(0,0),He=new hi(0,0),Qe=new hi(0,0);for(const ht of te)if("branches"in ht){we.total+=1,we.covered+=ht.executionCount>0?1:0;for(const Rt of ht.branches)He.total+=1,He.covered+=Rt.executionCount>0?1:0}else Qe.total+=1,Qe.covered+=ht.executionCount>0?1:0;const at=new L(F,we,He.total>0?He:void 0,Qe.total>0?Qe:void 0);return at.detailedCoverage=te,at}constructor(F,te,we,He){this.uri=F,this.statementCoverage=te,this.branchCoverage=we,this.functionCoverage=He}};Gi=L=ze([R],Gi),e.FileCoverage=Gi;let Xi=class{constructor(F,te,we=[]){this.executionCount=F,this.location=te,this.branches=we}};Xi=ze([R],Xi),e.StatementCoverage=Xi;let Qi=class{constructor(F,te){this.executionCount=F,this.location=te}};Qi=ze([R],Qi),e.BranchCoverage=Qi;let Yi=class{constructor(F,te){this.executionCount=F,this.location=te}};Yi=ze([R],Yi),e.FunctionCoverage=Yi;var dn;(function(x){x[x.None=0]="None",x[x.Option=1]="Option",x[x.Default=2]="Default",x[x.Preferred=3]="Preferred"})(dn=e.ExternalUriOpenerPriority||(e.ExternalUriOpenerPriority={}));var hn;(function(x){x[x.Untrusted=0]="Untrusted",x[x.Trusted=1]="Trusted",x[x.Unspecified=2]="Unspecified"})(hn=e.WorkspaceTrustState||(e.WorkspaceTrustState={}));var fn;(function(x){x[x.Notify=1]="Notify",x[x.OpenBrowser=2]="OpenBrowser",x[x.OpenPreview=3]="OpenPreview",x[x.Silent=4]="Silent",x[x.Ignore=5]="Ignore",x[x.OpenBrowserOnce=6]="OpenBrowserOnce"})(fn=e.PortAutoForwardAction||(e.PortAutoForwardAction={}));class mn{constructor(F,te,we,He,Qe,at){this.kind=F,this.name=te,this.detail=we,this.uri=He,this.range=Qe,this.selectionRange=at}}e.TypeHierarchyItem=mn;class gn{constructor(F){this.uri=F}}e.TextTabInput=gn;class pn{constructor(F,te){this.original=F,this.modified=te}}e.TextDiffTabInput=pn;class vn{constructor(F,te,we,He){this.base=F,this.input1=te,this.input2=we,this.result=He}}e.TextMergeTabInput=vn;class En{constructor(F,te){this.uri=F,this.viewType=te}}e.CustomEditorTabInput=En;class bn{constructor(F){this.viewType=F}}e.WebviewEditorTabInput=bn;class wn{constructor(F,te){this.uri=F,this.notebookType=te}}e.NotebookEditorTabInput=wn;class Sn{constructor(F,te,we){this.original=F,this.modified=te,this.notebookType=we}}e.NotebookDiffEditorTabInput=Sn;class _n{constructor(){}}e.TerminalEditorTabInput=_n;class yn{constructor(F,te){this.uri=F,this.inputBoxUri=te}}e.InteractiveWindowInput=yn}),define(Ce[93],Ie([1,0,44,13,9,241,123,6,18]),function(ie,e,r,y,S,M,_,A,b){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtHostDocumentLine=e.ExtHostDocumentData=e.getWordDefinitionFor=e.setWordDefinitionFor=void 0;const P=new Map;function O(f,c){c?P.set(f,c):P.delete(f)}e.setWordDefinitionFor=O;function E(f){return P.get(f)}e.getWordDefinitionFor=E;class m extends M.MirrorTextModel{constructor(c,d,h,g,C,l,w,t){super(d,h,g,C),this._proxy=c,this._languageId=l,this._isDirty=w,this.notebook=t,this._isDisposed=!1}dispose(){(0,r.ok)(!this._isDisposed),this._isDisposed=!0,this._isDirty=!1}equalLines(c){return(0,b.equals)(this._lines,c)}get document(){if(!this._document){const c=this;this._document={get uri(){return c._uri},get fileName(){return c._uri.fsPath},get isUntitled(){return c._uri.scheme===y.Schemas.untitled},get languageId(){return c._languageId},get version(){return c._versionId},get isClosed(){return c._isDisposed},get isDirty(){return c._isDirty},save(){return c._save()},getText(d){return d?c._getTextInRange(d):c.getText()},get eol(){return c._eol===`
`?A.EndOfLine.LF:A.EndOfLine.CRLF},get lineCount(){return c._lines.length},lineAt(d){return c._lineAt(d)},offsetAt(d){return c._offsetAt(d)},positionAt(d){return c._positionAt(d)},validateRange(d){return c._validateRange(d)},validatePosition(d){return c._validatePosition(d)},getWordRangeAtPosition(d,h){return c._getWordRangeAtPosition(d,h)}}}return Object.freeze(this._document)}_acceptLanguageId(c){(0,r.ok)(!this._isDisposed),this._languageId=c}_acceptIsDirty(c){(0,r.ok)(!this._isDisposed),this._isDirty=c}_save(){return this._isDisposed?Promise.reject(new Error("Document has been closed")):this._proxy.$trySaveDocument(this._uri)}_getTextInRange(c){const d=this._validateRange(c);if(d.isEmpty)return"";if(d.isSingleLine)return this._lines[d.start.line].substring(d.start.character,d.end.character);const h=this._eol,g=d.start.line,C=d.end.line,l=[];l.push(this._lines[g].substring(d.start.character));for(let w=g+1;w<C;w++)l.push(this._lines[w]);return l.push(this._lines[C].substring(0,d.end.character)),l.join(h)}_lineAt(c){let d;if(c instanceof A.Position?d=c.line:typeof c=="number"&&(d=c),typeof d!="number"||d<0||d>=this._lines.length||Math.floor(d)!==d)throw new Error("Illegal value for `line`");return new k(d,this._lines[d],d===this._lines.length-1)}_offsetAt(c){return c=this._validatePosition(c),this._ensureLineStarts(),this._lineStarts.getPrefixSum(c.line-1)+c.character}_positionAt(c){c=Math.floor(c),c=Math.max(0,c),this._ensureLineStarts();const d=this._lineStarts.getIndexOf(c),h=this._lines[d.index].length;return new A.Position(d.index,Math.min(d.remainder,h))}_validateRange(c){if(!(c instanceof A.Range))throw new Error("Invalid argument");const d=this._validatePosition(c.start),h=this._validatePosition(c.end);return d===c.start&&h===c.end?c:new A.Range(d.line,d.character,h.line,h.character)}_validatePosition(c){if(!(c instanceof A.Position))throw new Error("Invalid argument");if(this._lines.length===0)return c.with(0,0);let{line:d,character:h}=c,g=!1;if(d<0)d=0,h=0,g=!0;else if(d>=this._lines.length)d=this._lines.length-1,h=this._lines[d].length,g=!0;else{const C=this._lines[d].length;h<0?(h=0,g=!0):h>C&&(h=C,g=!0)}return g?new A.Position(d,h):c}_getWordRangeAtPosition(c,d){const h=this._validatePosition(c);if(!d)d=E(this._languageId);else if((0,S.regExpLeadsToEndlessLoop)(d))throw new Error(`[getWordRangeAtPosition]: ignoring custom regexp '${d.source}' because it matches the empty string.`);const g=(0,_.getWordAtText)(h.character+1,(0,_.ensureValidWordDefinition)(d),this._lines[h.line],0);if(g)return new A.Range(h.line,g.startColumn-1,h.line,g.endColumn-1)}}e.ExtHostDocumentData=m;class k{constructor(c,d,h){this._line=c,this._text=d,this._isLastLine=h}get lineNumber(){return this._line}get text(){return this._text}get range(){return new A.Range(this._line,0,this._line,this._text.length)}get rangeIncludingLineBreak(){return this._isLastLine?this.range:new A.Range(this._line,0,this._line+1,0)}get firstNonWhitespaceCharacterIndex(){return/^(\s*)/.exec(this._text)[1].length}get isEmptyOrWhitespace(){return this.firstNonWhitespaceCharacterIndex===this._text.length}}e.ExtHostDocumentLine=k}),define(Ce[176],Ie([1,0,6,11,5]),function(ie,e,r,y,S){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtHostTheming=void 0;let M=class{constructor(A){this._actual=new r.ColorTheme(r.ColorThemeKind.Dark),this._onDidChangeActiveColorTheme=new S.Emitter}get activeColorTheme(){return this._actual}$onColorThemeChange(A){let b;switch(A){case"light":b=r.ColorThemeKind.Light;break;case"hcDark":b=r.ColorThemeKind.HighContrast;break;case"hcLight":b=r.ColorThemeKind.HighContrastLight;break;default:b=r.ColorThemeKind.Dark}this._actual=new r.ColorTheme(b),this._onDidChangeActiveColorTheme.fire(this._actual)}get onDidChangeActiveColorTheme(){return this._onDidChangeActiveColorTheme.event}};M=ze([$e(0,y.IExtHostRpcService)],M),e.ExtHostTheming=M}),define(Ce[8],Ie([1,0,18,23,77,24,107,76,26,10,2,49,66,82,90,89,64,47,48,171,6,177]),function(ie,e,r,y,S,M,_,A,b,P,O,E,m,k,f,c,d,h,g,C,l,w){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.DataTransfer=e.DataTransferItem=e.ViewBadge=e.TypeHierarchyItem=e.CodeActionTriggerKind=e.TestCoverage=e.TestResults=e.TestItem=e.TestTag=e.TestMessage=e.NotebookRendererScript=e.NotebookDocumentContentOptions=e.NotebookStatusBarItem=e.NotebookExclusiveDocumentPattern=e.NotebookCellOutput=e.NotebookCellOutputItem=e.NotebookCellData=e.NotebookData=e.NotebookCellKind=e.NotebookCellExecutionState=e.NotebookCellExecutionSummary=e.NotebookRange=e.LanguageSelector=e.GlobPattern=e.TextEditorOpenOptions=e.FoldingRangeKind=e.FoldingRange=e.ProgressLocation=e.EndOfLine=e.TextEditorLineNumbersStyle=e.TextDocumentSaveReason=e.SelectionRange=e.Color=e.ColorPresentation=e.DocumentLink=e.InlayHintKind=e.InlayHintLabelPart=e.InlayHint=e.SignatureHelp=e.SignatureInformation=e.ParameterInformation=e.CompletionItem=e.CompletionItemKind=e.CompletionItemTag=e.CompletionContext=e.CompletionTriggerKind=e.DocumentHighlight=e.InlineValueContext=e.InlineValue=e.EvaluatableExpression=e.Hover=e.DefinitionLink=e.location=e.CallHierarchyOutgoingCall=e.CallHierarchyIncomingCall=e.CallHierarchyItem=e.DocumentSymbol=e.WorkspaceSymbol=e.SymbolTag=e.SymbolKind=e.WorkspaceEdit=e.TextEdit=e.DecorationRenderOptions=e.DecorationRangeBehavior=e.ThemableDecorationRenderOptions=e.ThemableDecorationAttachmentRenderOptions=e.pathOrURIToURI=e.fromRangeOrRangeWithMessage=e.MarkdownString=e.isDecorationOptionsArr=e.ViewColumn=e.DiagnosticSeverity=e.DiagnosticRelatedInformation=e.Diagnostic=e.DiagnosticTag=e.DocumentSelector=e.Position=e.TokenType=e.Range=e.Selection=void 0;var t;(function(Se){function Pe(q){const{selectionStartLineNumber:Ae,selectionStartColumn:Le,positionLineNumber:nt,positionColumn:We}=q,tt=new l.Position(Ae-1,Le-1),ct=new l.Position(nt-1,We-1);return new l.Selection(tt,ct)}Se.to=Pe;function fe(q){const{anchor:Ae,active:Le}=q;return{selectionStartLineNumber:Ae.line+1,selectionStartColumn:Ae.character+1,positionLineNumber:Le.line+1,positionColumn:Le.character+1}}Se.from=fe})(t=e.Selection||(e.Selection={}));var u;(function(Se){function Pe(q){if(!q)return;const{start:Ae,end:Le}=q;return{startLineNumber:Ae.line+1,startColumn:Ae.character+1,endLineNumber:Le.line+1,endColumn:Le.character+1}}Se.from=Pe;function fe(q){if(!q)return;const{startLineNumber:Ae,startColumn:Le,endLineNumber:nt,endColumn:We}=q;return new l.Range(Ae-1,Le-1,nt-1,We-1)}Se.to=fe})(u=e.Range||(e.Range={}));var i;(function(Se){function Pe(fe){switch(fe){case 1:return l.StandardTokenType.Comment;case 0:return l.StandardTokenType.Other;case 3:return l.StandardTokenType.RegEx;case 2:return l.StandardTokenType.String}}Se.to=Pe})(i=e.TokenType||(e.TokenType={}));var n;(function(Se){function Pe(q){return new l.Position(q.lineNumber-1,q.column-1)}Se.to=Pe;function fe(q){return{lineNumber:q.line+1,column:q.character+1}}Se.from=fe})(n=e.Position||(e.Position={}));var s;(function(Se){function Pe(Ae,Le){return(0,r.coalesce)((0,r.asArray)(Ae).map(nt=>fe(nt,Le)))}Se.from=Pe;function fe(Ae,Le){if(typeof Ae=="string")return{$serialized:!0,language:Ae};if(Ae)return{$serialized:!0,language:Ae.language,scheme:q(Ae.scheme,Le),pattern:he.from(Ae.pattern)??void 0,exclusive:Ae.exclusive,notebookType:Ae.notebookType}}function q(Ae,Le){return Le&&typeof Ae=="string"?Le.transformOutgoingScheme(Ae):Ae}})(s=e.DocumentSelector||(e.DocumentSelector={}));var a;(function(Se){function Pe(q){switch(q){case l.DiagnosticTag.Unnecessary:return 1;case l.DiagnosticTag.Deprecated:return 2}}Se.from=Pe;function fe(q){switch(q){case 1:return l.DiagnosticTag.Unnecessary;case 2:return l.DiagnosticTag.Deprecated;default:return}}Se.to=fe})(a=e.DiagnosticTag||(e.DiagnosticTag={}));var o;(function(Se){function Pe(q){let Ae;return q.code&&((0,P.isString)(q.code)||(0,P.isNumber)(q.code)?Ae=String(q.code):Ae={value:String(q.code.value),target:q.code.target}),{...u.from(q.range),message:q.message,source:q.source,code:Ae,severity:p.from(q.severity),relatedInformation:q.relatedInformation&&q.relatedInformation.map(v.from),tags:Array.isArray(q.tags)?(0,r.coalesce)(q.tags.map(a.from)):void 0}}Se.from=Pe;function fe(q){const Ae=new l.Diagnostic(u.to(q),q.message,p.to(q.severity));return Ae.source=q.source,Ae.code=(0,P.isString)(q.code)?q.code:q.code?.value,Ae.relatedInformation=q.relatedInformation&&q.relatedInformation.map(v.to),Ae.tags=q.tags&&(0,r.coalesce)(q.tags.map(a.to)),Ae}Se.to=fe})(o=e.Diagnostic||(e.Diagnostic={}));var v;(function(Se){function Pe(q){return{...u.from(q.location.range),message:q.message,resource:q.location.uri}}Se.from=Pe;function fe(q){return new l.DiagnosticRelatedInformation(new l.Location(q.resource,u.to(q)),q.message)}Se.to=fe})(v=e.DiagnosticRelatedInformation||(e.DiagnosticRelatedInformation={}));var p;(function(Se){function Pe(q){switch(q){case l.DiagnosticSeverity.Error:return k.MarkerSeverity.Error;case l.DiagnosticSeverity.Warning:return k.MarkerSeverity.Warning;case l.DiagnosticSeverity.Information:return k.MarkerSeverity.Info;case l.DiagnosticSeverity.Hint:return k.MarkerSeverity.Hint}return k.MarkerSeverity.Error}Se.from=Pe;function fe(q){switch(q){case k.MarkerSeverity.Info:return l.DiagnosticSeverity.Information;case k.MarkerSeverity.Warning:return l.DiagnosticSeverity.Warning;case k.MarkerSeverity.Error:return l.DiagnosticSeverity.Error;case k.MarkerSeverity.Hint:return l.DiagnosticSeverity.Hint;default:return l.DiagnosticSeverity.Error}}Se.to=fe})(p=e.DiagnosticSeverity||(e.DiagnosticSeverity={}));var T;(function(Se){function Pe(q){return typeof q=="number"&&q>=l.ViewColumn.One?q-1:q===l.ViewColumn.Beside?C.SIDE_GROUP:C.ACTIVE_GROUP}Se.from=Pe;function fe(q){if(typeof q=="number"&&q>=0)return q+1;throw new Error("invalid 'EditorGroupColumn'")}Se.to=fe})(T=e.ViewColumn||(e.ViewColumn={}));function N(Se){return typeof Se.range<"u"}function V(Se){return Se.length===0?!0:!!N(Se[0])}e.isDecorationOptionsArr=V;var B;(function(Se){function Pe(We){return We.map(Se.from)}Se.fromMany=Pe;function fe(We){return We&&typeof We=="object"&&typeof We.language=="string"&&typeof We.value=="string"}function q(We){let tt;if(fe(We)){const{language:Et,value:wt}=We;tt={value:"```"+Et+`
`+wt+"\n```\n"}}else l.MarkdownString.isMarkdownString(We)?tt={value:We.value,isTrusted:We.isTrusted,supportThemeIcons:We.supportThemeIcons,supportHtml:We.supportHtml,baseUri:We.baseUri}:typeof We=="string"?tt={value:We}:tt={value:""};const ct=Object.create(null);tt.uris=ct;const mt=Et=>{try{let wt=O.URI.parse(Et,!0);wt=wt.with({query:Ae(wt.query,ct)}),ct[Et]=wt}catch{}return""},Dt=new _.marked.Renderer;return Dt.link=mt,Dt.image=Et=>typeof Et=="string"?mt(S.parseHrefAndDimensions(Et).href):"",(0,_.marked)(tt.value,{renderer:Dt}),tt}Se.from=q;function Ae(We,tt){if(!We)return We;let ct;try{ct=(0,A.parse)(We)}catch{}if(!ct)return We;let mt=!1;return ct=(0,b.cloneAndChange)(ct,Dt=>{if(O.URI.isUri(Dt)){const Et=`__uri_${Math.random().toString(16).slice(2,8)}`;return tt[Et]=Dt,mt=!0,Et}else return}),mt?JSON.stringify(ct):We}function Le(We){const tt=new l.MarkdownString(We.value,We.supportThemeIcons);return tt.isTrusted=We.isTrusted,tt.supportHtml=We.supportHtml,tt.baseUri=We.baseUri?O.URI.from(We.baseUri):void 0,tt}Se.to=Le;function nt(We){if(!!We)return typeof We=="string"?We:Se.from(We)}Se.fromStrict=nt})(B=e.MarkdownString||(e.MarkdownString={}));function D(Se){return V(Se)?Se.map(Pe=>({range:u.from(Pe.range),hoverMessage:Array.isArray(Pe.hoverMessage)?B.fromMany(Pe.hoverMessage):Pe.hoverMessage?B.from(Pe.hoverMessage):void 0,renderOptions:Pe.renderOptions})):Se.map(Pe=>({range:u.from(Pe)}))}e.fromRangeOrRangeWithMessage=D;function z(Se){return typeof Se>"u"?Se:typeof Se=="string"?O.URI.file(Se):Se}e.pathOrURIToURI=z;var L;(function(Se){function Pe(fe){return typeof fe>"u"?fe:{contentText:fe.contentText,contentIconPath:fe.contentIconPath?z(fe.contentIconPath):void 0,border:fe.border,borderColor:fe.borderColor,fontStyle:fe.fontStyle,fontWeight:fe.fontWeight,textDecoration:fe.textDecoration,color:fe.color,backgroundColor:fe.backgroundColor,margin:fe.margin,width:fe.width,height:fe.height}}Se.from=Pe})(L=e.ThemableDecorationAttachmentRenderOptions||(e.ThemableDecorationAttachmentRenderOptions={}));var R;(function(Se){function Pe(fe){return typeof fe>"u"?fe:{backgroundColor:fe.backgroundColor,outline:fe.outline,outlineColor:fe.outlineColor,outlineStyle:fe.outlineStyle,outlineWidth:fe.outlineWidth,border:fe.border,borderColor:fe.borderColor,borderRadius:fe.borderRadius,borderSpacing:fe.borderSpacing,borderStyle:fe.borderStyle,borderWidth:fe.borderWidth,fontStyle:fe.fontStyle,fontWeight:fe.fontWeight,textDecoration:fe.textDecoration,cursor:fe.cursor,color:fe.color,opacity:fe.opacity,letterSpacing:fe.letterSpacing,gutterIconPath:fe.gutterIconPath?z(fe.gutterIconPath):void 0,gutterIconSize:fe.gutterIconSize,overviewRulerColor:fe.overviewRulerColor,before:fe.before?L.from(fe.before):void 0,after:fe.after?L.from(fe.after):void 0}}Se.from=Pe})(R=e.ThemableDecorationRenderOptions||(e.ThemableDecorationRenderOptions={}));var K;(function(Se){function Pe(fe){if(typeof fe>"u")return fe;switch(fe){case l.DecorationRangeBehavior.OpenOpen:return 0;case l.DecorationRangeBehavior.ClosedClosed:return 1;case l.DecorationRangeBehavior.OpenClosed:return 2;case l.DecorationRangeBehavior.ClosedOpen:return 3}}Se.from=Pe})(K=e.DecorationRangeBehavior||(e.DecorationRangeBehavior={}));var W;(function(Se){function Pe(fe){return{isWholeLine:fe.isWholeLine,rangeBehavior:fe.rangeBehavior?K.from(fe.rangeBehavior):void 0,overviewRulerLane:fe.overviewRulerLane,light:fe.light?R.from(fe.light):void 0,dark:fe.dark?R.from(fe.dark):void 0,backgroundColor:fe.backgroundColor,outline:fe.outline,outlineColor:fe.outlineColor,outlineStyle:fe.outlineStyle,outlineWidth:fe.outlineWidth,border:fe.border,borderColor:fe.borderColor,borderRadius:fe.borderRadius,borderSpacing:fe.borderSpacing,borderStyle:fe.borderStyle,borderWidth:fe.borderWidth,fontStyle:fe.fontStyle,fontWeight:fe.fontWeight,textDecoration:fe.textDecoration,cursor:fe.cursor,color:fe.color,opacity:fe.opacity,letterSpacing:fe.letterSpacing,gutterIconPath:fe.gutterIconPath?z(fe.gutterIconPath):void 0,gutterIconSize:fe.gutterIconSize,overviewRulerColor:fe.overviewRulerColor,before:fe.before?L.from(fe.before):void 0,after:fe.after?L.from(fe.after):void 0}}Se.from=Pe})(W=e.DecorationRenderOptions||(e.DecorationRenderOptions={}));var $;(function(Se){function Pe(q){return{text:q.newText,eol:q.newEol&&Ge.from(q.newEol),range:u.from(q.range)}}Se.from=Pe;function fe(q){const Ae=new l.TextEdit(u.to(q.range),q.text);return Ae.newEol=typeof q.eol>"u"?void 0:Ge.to(q.eol),Ae}Se.to=fe})($=e.TextEdit||(e.TextEdit={}));var G;(function(Se){function Pe(q,Ae){const Le={edits:[]};if(q instanceof l.WorkspaceEdit){const nt=new M.ResourceSet;for(const We of q._allEntries())We._type===1&&O.URI.isUri(We.to)&&We.from===void 0&&nt.add(We.to);for(const We of q._allEntries())We._type===1?Le.edits.push({oldResource:We.from,newResource:We.to,options:{...We.options,contentsBase64:We.options?.contents&&(0,y.encodeBase64)(y.VSBuffer.wrap(We.options.contents))},metadata:We.metadata}):We._type===2?Le.edits.push({resource:We.uri,textEdit:$.from(We.edit),versionId:nt.has(We.uri)?void 0:Ae?.getTextDocumentVersion(We.uri),metadata:We.metadata}):We._type===6?Le.edits.push({resource:We.uri,textEdit:{range:u.from(We.range),text:We.edit.value,insertAsSnippet:!0},versionId:nt.has(We.uri)?void 0:Ae?.getTextDocumentVersion(We.uri),metadata:We.metadata}):We._type===3?Le.edits.push({metadata:We.metadata,resource:We.uri,cellEdit:We.edit,notebookMetadata:We.notebookMetadata,notebookVersionId:Ae?.getNotebookDocumentVersion(We.uri)}):We._type===5&&Le.edits.push({metadata:We.metadata,resource:We.uri,notebookVersionId:Ae?.getNotebookDocumentVersion(We.uri),cellEdit:{editType:1,index:We.index,count:We.count,cells:We.cells.map(st.from)}})}return Le}Se.from=Pe;function fe(q){const Ae=new l.WorkspaceEdit;for(const Le of q.edits)Le.textEdit?Ae.replace(O.URI.revive(Le.resource),u.to(Le.textEdit.range),Le.textEdit.text):Ae.renameFile(O.URI.revive(Le.oldResource),O.URI.revive(Le.newResource),Le.options);return Ae}Se.to=fe})(G=e.WorkspaceEdit||(e.WorkspaceEdit={}));var ne;(function(Se){const Pe=Object.create(null);Pe[l.SymbolKind.File]=0,Pe[l.SymbolKind.Module]=1,Pe[l.SymbolKind.Namespace]=2,Pe[l.SymbolKind.Package]=3,Pe[l.SymbolKind.Class]=4,Pe[l.SymbolKind.Method]=5,Pe[l.SymbolKind.Property]=6,Pe[l.SymbolKind.Field]=7,Pe[l.SymbolKind.Constructor]=8,Pe[l.SymbolKind.Enum]=9,Pe[l.SymbolKind.Interface]=10,Pe[l.SymbolKind.Function]=11,Pe[l.SymbolKind.Variable]=12,Pe[l.SymbolKind.Constant]=13,Pe[l.SymbolKind.String]=14,Pe[l.SymbolKind.Number]=15,Pe[l.SymbolKind.Boolean]=16,Pe[l.SymbolKind.Array]=17,Pe[l.SymbolKind.Object]=18,Pe[l.SymbolKind.Key]=19,Pe[l.SymbolKind.Null]=20,Pe[l.SymbolKind.EnumMember]=21,Pe[l.SymbolKind.Struct]=22,Pe[l.SymbolKind.Event]=23,Pe[l.SymbolKind.Operator]=24,Pe[l.SymbolKind.TypeParameter]=25;function fe(Ae){return typeof Pe[Ae]=="number"?Pe[Ae]:6}Se.from=fe;function q(Ae){for(const Le in Pe)if(Pe[Le]===Ae)return Number(Le);return l.SymbolKind.Property}Se.to=q})(ne=e.SymbolKind||(e.SymbolKind={}));var ge;(function(Se){function Pe(q){switch(q){case l.SymbolTag.Deprecated:return 1}}Se.from=Pe;function fe(q){switch(q){case 1:return l.SymbolTag.Deprecated}}Se.to=fe})(ge=e.SymbolTag||(e.SymbolTag={}));var oe;(function(Se){function Pe(q){return{name:q.name,kind:ne.from(q.kind),tags:q.tags&&q.tags.map(ge.from),containerName:q.containerName,location:be.from(q.location)}}Se.from=Pe;function fe(q){const Ae=new l.SymbolInformation(q.name,ne.to(q.kind),q.containerName,be.to(q.location));return Ae.tags=q.tags&&q.tags.map(ge.to),Ae}Se.to=fe})(oe=e.WorkspaceSymbol||(e.WorkspaceSymbol={}));var Ee;(function(Se){function Pe(q){const Ae={name:q.name||"!!MISSING: name!!",detail:q.detail,range:u.from(q.range),selectionRange:u.from(q.selectionRange),kind:ne.from(q.kind),tags:q.tags?.map(ge.from)??[]};return q.children&&(Ae.children=q.children.map(Pe)),Ae}Se.from=Pe;function fe(q){const Ae=new l.DocumentSymbol(q.name,q.detail,ne.to(q.kind),u.to(q.range),u.to(q.selectionRange));return(0,r.isNonEmptyArray)(q.tags)&&(Ae.tags=q.tags.map(ge.to)),q.children&&(Ae.children=q.children.map(fe)),Ae}Se.to=fe})(Ee=e.DocumentSymbol||(e.DocumentSymbol={}));var ce;(function(Se){function Pe(q){const Ae=new l.CallHierarchyItem(ne.to(q.kind),q.name,q.detail||"",O.URI.revive(q.uri),u.to(q.range),u.to(q.selectionRange));return Ae._sessionId=q._sessionId,Ae._itemId=q._itemId,Ae}Se.to=Pe;function fe(q,Ae,Le){if(Ae=Ae??q._sessionId,Le=Le??q._itemId,Ae===void 0||Le===void 0)throw new Error("invalid item");return{_sessionId:Ae,_itemId:Le,name:q.name,detail:q.detail,kind:ne.from(q.kind),uri:q.uri,range:u.from(q.range),selectionRange:u.from(q.selectionRange),tags:q.tags?.map(ge.from)}}Se.from=fe})(ce=e.CallHierarchyItem||(e.CallHierarchyItem={}));var me;(function(Se){function Pe(fe){return new l.CallHierarchyIncomingCall(ce.to(fe.from),fe.fromRanges.map(q=>u.to(q)))}Se.to=Pe})(me=e.CallHierarchyIncomingCall||(e.CallHierarchyIncomingCall={}));var ee;(function(Se){function Pe(fe){return new l.CallHierarchyOutgoingCall(ce.to(fe.to),fe.fromRanges.map(q=>u.to(q)))}Se.to=Pe})(ee=e.CallHierarchyOutgoingCall||(e.CallHierarchyOutgoingCall={}));var be;(function(Se){function Pe(q){return{range:q.range&&u.from(q.range),uri:q.uri}}Se.from=Pe;function fe(q){return new l.Location(O.URI.revive(q.uri),u.to(q.range))}Se.to=fe})(be=e.location||(e.location={}));var _e;(function(Se){function Pe(q){const Ae=q,Le=q;return{originSelectionRange:Ae.originSelectionRange?u.from(Ae.originSelectionRange):void 0,uri:Ae.targetUri?Ae.targetUri:Le.uri,range:u.from(Ae.targetRange?Ae.targetRange:Le.range),targetSelectionRange:Ae.targetSelectionRange?u.from(Ae.targetSelectionRange):void 0}}Se.from=Pe;function fe(q){return{targetUri:O.URI.revive(q.uri),targetRange:u.to(q.range),targetSelectionRange:q.targetSelectionRange?u.to(q.targetSelectionRange):void 0,originSelectionRange:q.originSelectionRange?u.to(q.originSelectionRange):void 0}}Se.to=fe})(_e=e.DefinitionLink||(e.DefinitionLink={}));var Fe;(function(Se){function Pe(q){return{range:u.from(q.range),contents:B.fromMany(q.contents)}}Se.from=Pe;function fe(q){return new l.Hover(q.contents.map(B.to),u.to(q.range))}Se.to=fe})(Fe=e.Hover||(e.Hover={}));var Be;(function(Se){function Pe(q){return{range:u.from(q.range),expression:q.expression}}Se.from=Pe;function fe(q){return new l.EvaluatableExpression(u.to(q.range),q.expression)}Se.to=fe})(Be=e.EvaluatableExpression||(e.EvaluatableExpression={}));var Xe;(function(Se){function Pe(q){if(q instanceof l.InlineValueText)return{type:"text",range:u.from(q.range),text:q.text};if(q instanceof l.InlineValueVariableLookup)return{type:"variable",range:u.from(q.range),variableName:q.variableName,caseSensitiveLookup:q.caseSensitiveLookup};if(q instanceof l.InlineValueEvaluatableExpression)return{type:"expression",range:u.from(q.range),expression:q.expression};throw new Error("Unknown 'InlineValue' type")}Se.from=Pe;function fe(q){switch(q.type){case"text":return{range:u.to(q.range),text:q.text};case"variable":return{range:u.to(q.range),variableName:q.variableName,caseSensitiveLookup:q.caseSensitiveLookup};case"expression":return{range:u.to(q.range),expression:q.expression}}}Se.to=fe})(Xe=e.InlineValue||(e.InlineValue={}));var ke;(function(Se){function Pe(q){return{frameId:q.frameId,stoppedLocation:u.from(q.stoppedLocation)}}Se.from=Pe;function fe(q){return new l.InlineValueContext(q.frameId,u.to(q.stoppedLocation))}Se.to=fe})(ke=e.InlineValueContext||(e.InlineValueContext={}));var ye;(function(Se){function Pe(q){return{range:u.from(q.range),kind:q.kind}}Se.from=Pe;function fe(q){return new l.DocumentHighlight(u.to(q.range),q.kind)}Se.to=fe})(ye=e.DocumentHighlight||(e.DocumentHighlight={}));var De;(function(Se){function Pe(fe){switch(fe){case 1:return l.CompletionTriggerKind.TriggerCharacter;case 2:return l.CompletionTriggerKind.TriggerForIncompleteCompletions;case 0:default:return l.CompletionTriggerKind.Invoke}}Se.to=Pe})(De=e.CompletionTriggerKind||(e.CompletionTriggerKind={}));var ae;(function(Se){function Pe(fe){return{triggerKind:De.to(fe.triggerKind),triggerCharacter:fe.triggerCharacter}}Se.to=Pe})(ae=e.CompletionContext||(e.CompletionContext={}));var ue;(function(Se){function Pe(q){switch(q){case l.CompletionItemTag.Deprecated:return 1}}Se.from=Pe;function fe(q){switch(q){case 1:return l.CompletionItemTag.Deprecated}}Se.to=fe})(ue=e.CompletionItemTag||(e.CompletionItemTag={}));var Z;(function(Se){const Pe=new Map([[l.CompletionItemKind.Method,0],[l.CompletionItemKind.Function,1],[l.CompletionItemKind.Constructor,2],[l.CompletionItemKind.Field,3],[l.CompletionItemKind.Variable,4],[l.CompletionItemKind.Class,5],[l.CompletionItemKind.Interface,7],[l.CompletionItemKind.Struct,6],[l.CompletionItemKind.Module,8],[l.CompletionItemKind.Property,9],[l.CompletionItemKind.Unit,12],[l.CompletionItemKind.Value,13],[l.CompletionItemKind.Constant,14],[l.CompletionItemKind.Enum,15],[l.CompletionItemKind.EnumMember,16],[l.CompletionItemKind.Keyword,17],[l.CompletionItemKind.Snippet,27],[l.CompletionItemKind.Text,18],[l.CompletionItemKind.Color,19],[l.CompletionItemKind.File,20],[l.CompletionItemKind.Reference,21],[l.CompletionItemKind.Folder,23],[l.CompletionItemKind.Event,10],[l.CompletionItemKind.Operator,11],[l.CompletionItemKind.TypeParameter,24],[l.CompletionItemKind.Issue,26],[l.CompletionItemKind.User,25]]);function fe(Le){return Pe.get(Le)??9}Se.from=fe;const q=new Map([[0,l.CompletionItemKind.Method],[1,l.CompletionItemKind.Function],[2,l.CompletionItemKind.Constructor],[3,l.CompletionItemKind.Field],[4,l.CompletionItemKind.Variable],[5,l.CompletionItemKind.Class],[7,l.CompletionItemKind.Interface],[6,l.CompletionItemKind.Struct],[8,l.CompletionItemKind.Module],[9,l.CompletionItemKind.Property],[12,l.CompletionItemKind.Unit],[13,l.CompletionItemKind.Value],[14,l.CompletionItemKind.Constant],[15,l.CompletionItemKind.Enum],[16,l.CompletionItemKind.EnumMember],[17,l.CompletionItemKind.Keyword],[27,l.CompletionItemKind.Snippet],[18,l.CompletionItemKind.Text],[19,l.CompletionItemKind.Color],[20,l.CompletionItemKind.File],[21,l.CompletionItemKind.Reference],[23,l.CompletionItemKind.Folder],[10,l.CompletionItemKind.Event],[11,l.CompletionItemKind.Operator],[24,l.CompletionItemKind.TypeParameter],[25,l.CompletionItemKind.User],[26,l.CompletionItemKind.Issue]]);function Ae(Le){return q.get(Le)??l.CompletionItemKind.Property}Se.to=Ae})(Z=e.CompletionItemKind||(e.CompletionItemKind={}));var J;(function(Se){function Pe(fe,q){const Ae=new l.CompletionItem(fe.label);return Ae.insertText=fe.insertText,Ae.kind=Z.to(fe.kind),Ae.tags=fe.tags?.map(ue.to),Ae.detail=fe.detail,Ae.documentation=S.isMarkdownString(fe.documentation)?B.to(fe.documentation):fe.documentation,Ae.sortText=fe.sortText,Ae.filterText=fe.filterText,Ae.preselect=fe.preselect,Ae.commitCharacters=fe.commitCharacters,E.Range.isIRange(fe.range)?Ae.range=u.to(fe.range):typeof fe.range=="object"&&(Ae.range={inserting:u.to(fe.range.insert),replacing:u.to(fe.range.replace)}),Ae.keepWhitespace=typeof fe.insertTextRules>"u"?!1:Boolean(fe.insertTextRules&1),typeof fe.insertTextRules<"u"&&fe.insertTextRules&4?Ae.insertText=new l.SnippetString(fe.insertText):(Ae.insertText=fe.insertText,Ae.textEdit=Ae.range instanceof l.Range?new l.TextEdit(Ae.range,Ae.insertText):void 0),fe.additionalTextEdits&&fe.additionalTextEdits.length>0&&(Ae.additionalTextEdits=fe.additionalTextEdits.map(Le=>$.to(Le))),Ae.command=q&&fe.command?q.fromInternal(fe.command):void 0,Ae}Se.to=Pe})(J=e.CompletionItem||(e.CompletionItem={}));var I;(function(Se){function Pe(q){if(typeof q.label!="string"&&!Array.isArray(q.label))throw new TypeError("Invalid label");return{label:q.label,documentation:B.fromStrict(q.documentation)}}Se.from=Pe;function fe(q){return{label:q.label,documentation:S.isMarkdownString(q.documentation)?B.to(q.documentation):q.documentation}}Se.to=fe})(I=e.ParameterInformation||(e.ParameterInformation={}));var U;(function(Se){function Pe(q){return{label:q.label,documentation:B.fromStrict(q.documentation),parameters:Array.isArray(q.parameters)?q.parameters.map(I.from):[],activeParameter:q.activeParameter}}Se.from=Pe;function fe(q){return{label:q.label,documentation:S.isMarkdownString(q.documentation)?B.to(q.documentation):q.documentation,parameters:Array.isArray(q.parameters)?q.parameters.map(I.to):[],activeParameter:q.activeParameter}}Se.to=fe})(U=e.SignatureInformation||(e.SignatureInformation={}));var H;(function(Se){function Pe(q){return{activeSignature:q.activeSignature,activeParameter:q.activeParameter,signatures:Array.isArray(q.signatures)?q.signatures.map(U.from):[]}}Se.from=Pe;function fe(q){return{activeSignature:q.activeSignature,activeParameter:q.activeParameter,signatures:Array.isArray(q.signatures)?q.signatures.map(U.to):[]}}Se.to=fe})(H=e.SignatureHelp||(e.SignatureHelp={}));var j;(function(Se){function Pe(fe,q){const Ae=new l.InlayHint(n.to(q.position),typeof q.label=="string"?q.label:q.label.map(se.to.bind(void 0,fe)),q.kind&&le.to(q.kind));return Ae.textEdits=q.textEdits&&q.textEdits.map($.to),Ae.tooltip=S.isMarkdownString(q.tooltip)?B.to(q.tooltip):q.tooltip,Ae.paddingLeft=q.paddingLeft,Ae.paddingRight=q.paddingRight,Ae}Se.to=Pe})(j=e.InlayHint||(e.InlayHint={}));var se;(function(Se){function Pe(fe,q){const Ae=new l.InlayHintLabelPart(q.label);return Ae.tooltip=S.isMarkdownString(q.tooltip)?B.to(q.tooltip):q.tooltip,m.Command.is(q.command)&&(Ae.command=fe.fromInternal(q.command)),q.location&&(Ae.location=be.to(q.location)),Ae}Se.to=Pe})(se=e.InlayHintLabelPart||(e.InlayHintLabelPart={}));var le;(function(Se){function Pe(q){return q}Se.from=Pe;function fe(q){return q}Se.to=fe})(le=e.InlayHintKind||(e.InlayHintKind={}));var Y;(function(Se){function Pe(q){return{range:u.from(q.range),url:q.target,tooltip:q.tooltip}}Se.from=Pe;function fe(q){let Ae;if(q.url)try{Ae=typeof q.url=="string"?O.URI.parse(q.url,!0):O.URI.revive(q.url)}catch{}return new l.DocumentLink(u.to(q.range),Ae)}Se.to=fe})(Y=e.DocumentLink||(e.DocumentLink={}));var ve;(function(Se){function Pe(q){const Ae=new l.ColorPresentation(q.label);return q.textEdit&&(Ae.textEdit=$.to(q.textEdit)),q.additionalTextEdits&&(Ae.additionalTextEdits=q.additionalTextEdits.map(Le=>$.to(Le))),Ae}Se.to=Pe;function fe(q){return{label:q.label,textEdit:q.textEdit?$.from(q.textEdit):void 0,additionalTextEdits:q.additionalTextEdits?q.additionalTextEdits.map(Ae=>$.from(Ae)):void 0}}Se.from=fe})(ve=e.ColorPresentation||(e.ColorPresentation={}));var pe;(function(Se){function Pe(q){return new l.Color(q[0],q[1],q[2],q[3])}Se.to=Pe;function fe(q){return[q.red,q.green,q.blue,q.alpha]}Se.from=fe})(pe=e.Color||(e.Color={}));var Me;(function(Se){function Pe(q){return{range:u.from(q.range)}}Se.from=Pe;function fe(q){return new l.SelectionRange(u.to(q.range))}Se.to=fe})(Me=e.SelectionRange||(e.SelectionRange={}));var xe;(function(Se){function Pe(fe){switch(fe){case 2:return l.TextDocumentSaveReason.AfterDelay;case 1:return l.TextDocumentSaveReason.Manual;case 3:case 4:return l.TextDocumentSaveReason.FocusOut}}Se.to=Pe})(xe=e.TextDocumentSaveReason||(e.TextDocumentSaveReason={}));var Ye;(function(Se){function Pe(q){switch(q){case l.TextEditorLineNumbersStyle.Off:return 0;case l.TextEditorLineNumbersStyle.Relative:return 2;case l.TextEditorLineNumbersStyle.On:default:return 1}}Se.from=Pe;function fe(q){switch(q){case 0:return l.TextEditorLineNumbersStyle.Off;case 2:return l.TextEditorLineNumbersStyle.Relative;case 1:default:return l.TextEditorLineNumbersStyle.On}}Se.to=fe})(Ye=e.TextEditorLineNumbersStyle||(e.TextEditorLineNumbersStyle={}));var Ge;(function(Se){function Pe(q){if(q===l.EndOfLine.CRLF)return 1;if(q===l.EndOfLine.LF)return 0}Se.from=Pe;function fe(q){if(q===1)return l.EndOfLine.CRLF;if(q===0)return l.EndOfLine.LF}Se.to=fe})(Ge=e.EndOfLine||(e.EndOfLine={}));var Te;(function(Se){function Pe(fe){if(typeof fe=="object")return fe.viewId;switch(fe){case l.ProgressLocation.SourceControl:return 3;case l.ProgressLocation.Window:return 10;case l.ProgressLocation.Notification:return 15}throw new Error("Unknown 'ProgressLocation'")}Se.from=Pe})(Te=e.ProgressLocation||(e.ProgressLocation={}));var rt;(function(Se){function Pe(fe){const q={start:fe.start+1,end:fe.end+1};return fe.kind&&(q.kind=X.from(fe.kind)),q}Se.from=Pe})(rt=e.FoldingRange||(e.FoldingRange={}));var X;(function(Se){function Pe(fe){if(fe)switch(fe){case l.FoldingRangeKind.Comment:return m.FoldingRangeKind.Comment;case l.FoldingRangeKind.Imports:return m.FoldingRangeKind.Imports;case l.FoldingRangeKind.Region:return m.FoldingRangeKind.Region}}Se.from=Pe})(X=e.FoldingRangeKind||(e.FoldingRangeKind={}));var Q;(function(Se){function Pe(fe){if(fe)return{pinned:typeof fe.preview=="boolean"?!fe.preview:void 0,inactive:fe.background,preserveFocus:fe.preserveFocus,selection:typeof fe.selection=="object"?u.from(fe.selection):void 0,override:typeof fe.override=="boolean"?c.DEFAULT_EDITOR_ASSOCIATION.id:void 0}}Se.from=Pe})(Q=e.TextEditorOpenOptions||(e.TextEditorOpenOptions={}));var he;(function(Se){function Pe(Le){return Le instanceof l.RelativePattern?Le.toJSON():typeof Le=="string"?Le:fe(Le)||q(Le)?new l.RelativePattern(Le.baseUri??Le.base,Le.pattern).toJSON():Le}Se.from=Pe;function fe(Le){const nt=Le;return nt?O.URI.isUri(nt.baseUri)&&typeof nt.pattern=="string":!1}function q(Le){const nt=Le;return nt?typeof nt.base=="string"&&typeof nt.pattern=="string":!1}function Ae(Le){return typeof Le=="string"?Le:new l.RelativePattern(O.URI.revive(Le.baseUri),Le.pattern)}Se.to=Ae})(he=e.GlobPattern||(e.GlobPattern={}));var Ue;(function(Se){function Pe(fe){if(fe){if(Array.isArray(fe))return fe.map(Pe);if(typeof fe=="string")return fe;{const q=fe;return{language:q.language,scheme:q.scheme,pattern:he.from(q.pattern),exclusive:q.exclusive,notebookType:q.notebookType}}}else return}Se.from=Pe})(Ue=e.LanguageSelector||(e.LanguageSelector={}));var je;(function(Se){function Pe(q){return{start:q.start,end:q.end}}Se.from=Pe;function fe(q){return new l.NotebookRange(q.start,q.end)}Se.to=fe})(je=e.NotebookRange||(e.NotebookRange={}));var Ze;(function(Se){function Pe(q){return{timing:typeof q.runStartTime=="number"&&typeof q.runEndTime=="number"?{startTime:q.runStartTime,endTime:q.runEndTime}:void 0,executionOrder:q.executionOrder,success:q.lastRunSuccess}}Se.to=Pe;function fe(q){return{lastRunSuccess:q.success,runStartTime:q.timing?.startTime,runEndTime:q.timing?.endTime,executionOrder:q.executionOrder}}Se.from=fe})(Ze=e.NotebookCellExecutionSummary||(e.NotebookCellExecutionSummary={}));var Ke;(function(Se){function Pe(fe){if(fe===d.NotebookCellExecutionState.Unconfirmed)return l.NotebookCellExecutionState.Pending;if(fe===d.NotebookCellExecutionState.Pending)return;if(fe===d.NotebookCellExecutionState.Executing)return l.NotebookCellExecutionState.Executing;throw new Error(`Unknown state: ${fe}`)}Se.to=Pe})(Ke=e.NotebookCellExecutionState||(e.NotebookCellExecutionState={}));var Ve;(function(Se){function Pe(q){switch(q){case l.NotebookCellKind.Markup:return d.CellKind.Markup;case l.NotebookCellKind.Code:default:return d.CellKind.Code}}Se.from=Pe;function fe(q){switch(q){case d.CellKind.Markup:return l.NotebookCellKind.Markup;case d.CellKind.Code:default:return l.NotebookCellKind.Code}}Se.to=fe})(Ve=e.NotebookCellKind||(e.NotebookCellKind={}));var it;(function(Se){function Pe(q){const Ae={metadata:q.metadata??Object.create(null),cells:[]};for(const Le of q.cells)l.NotebookCellData.validate(Le),Ae.cells.push(st.from(Le));return Ae}Se.from=Pe;function fe(q){const Ae=new l.NotebookData(q.cells.map(st.to));return(0,P.isEmptyObject)(q.metadata)||(Ae.metadata=q.metadata),Ae}Se.to=fe})(it=e.NotebookData||(e.NotebookData={}));var st;(function(Se){function Pe(q){return{cellKind:Ve.from(q.kind),language:q.languageId,mime:q.mime,source:q.value,metadata:q.metadata,internalMetadata:Ze.from(q.executionSummary??{}),outputs:q.outputs?q.outputs.map(yt.from):[]}}Se.from=Pe;function fe(q){return new l.NotebookCellData(Ve.to(q.cellKind),q.source,q.language,q.mime,q.outputs?q.outputs.map(yt.to):void 0,q.metadata,q.internalMetadata?Ze.to(q.internalMetadata):void 0)}Se.to=fe})(st=e.NotebookCellData||(e.NotebookCellData={}));var dt;(function(Se){function Pe(q){return{mime:q.mime,valueBytes:y.VSBuffer.wrap(q.data)}}Se.from=Pe;function fe(q){return new l.NotebookCellOutputItem(q.valueBytes.buffer,q.mime)}Se.to=fe})(dt=e.NotebookCellOutputItem||(e.NotebookCellOutputItem={}));var yt;(function(Se){function Pe(q){return{outputId:q.id,items:q.items.map(dt.from),metadata:q.metadata}}Se.from=Pe;function fe(q){const Ae=q.items.map(dt.to);return new l.NotebookCellOutput(Ae,q.outputId,q.metadata)}Se.to=fe})(yt=e.NotebookCellOutput||(e.NotebookCellOutput={}));var et;(function(Se){function Pe(Ae){return q(Ae)?{include:(0,P.withNullAsUndefined)(he.from(Ae.include)),exclude:(0,P.withNullAsUndefined)(he.from(Ae.exclude))}:(0,P.withNullAsUndefined)(he.from(Ae))}Se.from=Pe;function fe(Ae){return q(Ae)?{include:he.to(Ae.include),exclude:he.to(Ae.exclude)}:he.to(Ae)}Se.to=fe;function q(Ae){const Le=Ae;return Le?!(0,P.isUndefinedOrNull)(Le.include)&&!(0,P.isUndefinedOrNull)(Le.exclude):!1}})(et=e.NotebookExclusiveDocumentPattern||(e.NotebookExclusiveDocumentPattern={}));var ut;(function(Se){function Pe(fe,q,Ae){const Le=typeof fe.command=="string"?{title:"",command:fe.command}:fe.command;return{alignment:fe.alignment===l.NotebookCellStatusBarAlignment.Left?1:2,command:q.toInternal(Le,Ae),text:fe.text,tooltip:fe.tooltip,accessibilityInformation:fe.accessibilityInformation,priority:fe.priority}}Se.from=Pe})(ut=e.NotebookStatusBarItem||(e.NotebookStatusBarItem={}));var Ot;(function(Se){function Pe(fe){return{transientOutputs:fe?.transientOutputs??!1,transientCellMetadata:fe?.transientCellMetadata??{},transientDocumentMetadata:fe?.transientDocumentMetadata??{},cellContentMetadata:fe?.cellContentMetadata??{}}}Se.from=Pe})(Ot=e.NotebookDocumentContentOptions||(e.NotebookDocumentContentOptions={}));var Vt;(function(Se){function Pe(q){return{uri:q.uri,provides:q.provides}}Se.from=Pe;function fe(q){return new l.NotebookRendererScript(O.URI.revive(q.uri),q.provides)}Se.to=fe})(Vt=e.NotebookRendererScript||(e.NotebookRendererScript={}));var At;(function(Se){function Pe(q){return{message:B.fromStrict(q.message)||"",type:0,expected:q.expectedOutput,actual:q.actualOutput,location:q.location&&{range:u.from(q.location.range),uri:q.location.uri}}}Se.from=Pe;function fe(q){const Ae=new l.TestMessage(typeof q.message=="string"?q.message:B.to(q.message));return Ae.actualOutput=q.actual,Ae.expectedOutput=q.expected,Ae.location=q.location?be.to(q.location):void 0,Ae}Se.to=fe})(At=e.TestMessage||(e.TestMessage={}));var ft;(function(Se){Se.namespace=g.namespaceTestTag,Se.denamespace=g.denamespaceTestTag})(ft=e.TestTag||(e.TestTag={}));var It;(function(Se){function Pe(q){const Ae=(0,f.getPrivateApiFor)(q).controllerId;return{extId:h.TestId.fromExtHostTestItem(q,Ae).toString(),label:q.label,uri:O.URI.revive(q.uri),busy:q.busy,tags:q.tags.map(Le=>ft.namespace(Ae,Le.id)),range:E.Range.lift(u.from(q.range)),description:q.description||null,sortText:q.sortText||null,error:q.error&&B.fromStrict(q.error)||null}}Se.from=Pe;function fe(q){return{parent:void 0,error:void 0,id:h.TestId.fromString(q.extId).localId,label:q.label,uri:O.URI.revive(q.uri),tags:(q.tags||[]).map(Ae=>{const{tagId:Le}=ft.denamespace(Ae);return new l.TestTag(Le)}),children:{add:()=>{},delete:()=>{},forEach:()=>{},*[Symbol.iterator](){},get:()=>{},replace:()=>{},size:0},range:u.to(q.range||void 0),canResolveChildren:!1,busy:q.busy,description:q.description||void 0,sortText:q.sortText||void 0}}Se.toPlain=fe})(It=e.TestItem||(e.TestItem={})),function(Se){function Pe(q){return{id:q.id}}Se.from=Pe;function fe(q){return new l.TestTag(q.id)}Se.to=fe}(ft=e.TestTag||(e.TestTag={}));var Lt;(function(Se){const Pe=(q,Ae)=>{const Le=[];for(const[We,tt]of Ae)h.TestId.compare(tt.item.extId,We)===2&&(Ae.delete(We),Le.push(tt));const nt={...It.toPlain(q.item),parent:void 0,taskStates:q.tasks.map(We=>({state:We.state,duration:We.duration,messages:We.messages.filter(tt=>tt.type===0).map(At.to)})),children:Le.map(We=>Pe(We,Ae))};for(const We of nt.children)We.parent=nt;return nt};function fe(q){const Ae=[],Le=new Map;for(const nt of q.items)Le.set(nt.item.extId,nt),q.request.targets.some(We=>We.controllerId===nt.controllerId&&We.testIds.includes(nt.item.extId))&&Ae.push(nt);return{completedAt:q.completedAt,results:Ae.map(nt=>Pe(nt,Le))}}Se.to=fe})(Lt=e.TestResults||(e.TestResults={}));var xt;(function(Se){function Pe(Le){return{covered:Le.covered,total:Le.covered}}function fe(Le){return"line"in Le?n.from(Le):u.from(Le)}function q(Le){return"branches"in Le?{count:Le.executionCount,location:fe(Le.location),type:1,branches:Le.branches.length?Le.branches.map(nt=>({count:nt.executionCount,location:nt.location&&fe(nt.location)})):void 0}:{type:0,count:Le.executionCount,location:fe(Le.location)}}Se.fromDetailed=q;function Ae(Le){return{uri:Le.uri,statement:Pe(Le.statementCoverage),branch:Le.branchCoverage&&Pe(Le.branchCoverage),function:Le.functionCoverage&&Pe(Le.functionCoverage),details:Le.detailedCoverage?.map(q)}}Se.fromFile=Ae})(xt=e.TestCoverage||(e.TestCoverage={}));var qe;(function(Se){function Pe(fe){switch(fe){case 1:return l.CodeActionTriggerKind.Invoke;case 2:return l.CodeActionTriggerKind.Automatic}}Se.to=Pe})(qe=e.CodeActionTriggerKind||(e.CodeActionTriggerKind={}));var Ft;(function(Se){function Pe(q){const Ae=new l.TypeHierarchyItem(ne.to(q.kind),q.name,q.detail||"",O.URI.revive(q.uri),u.to(q.range),u.to(q.selectionRange));return Ae._sessionId=q._sessionId,Ae._itemId=q._itemId,Ae}Se.to=Pe;function fe(q,Ae,Le){if(Ae=Ae??q._sessionId,Le=Le??q._itemId,Ae===void 0||Le===void 0)throw new Error("invalid item");return{_sessionId:Ae,_itemId:Le,kind:ne.from(q.kind),name:q.name,detail:q.detail??"",uri:q.uri,range:u.from(q.range),selectionRange:u.from(q.selectionRange),tags:q.tags?.map(ge.from)}}Se.from=fe})(Ft=e.TypeHierarchyItem||(e.TypeHierarchyItem={}));var kt;(function(Se){function Pe(fe){if(!!fe)return{value:fe.value,tooltip:fe.tooltip}}Se.from=Pe})(kt=e.ViewBadge||(e.ViewBadge={}));var Nt;(function(Se){function Pe(fe,q){const Ae=fe.fileData;return Ae?new class extends l.DataTransferItem{asFile(){return{name:Ae.name,uri:O.URI.revive(Ae.uri),data:(0,w.once)(()=>q())}}}("",fe.id):new l.DataTransferItem(fe.asString)}Se.toDataTransferItem=Pe})(Nt=e.DataTransferItem||(e.DataTransferItem={}));var gt;(function(Se){function Pe(q,Ae){const Le=q.items.map(([nt,We])=>[nt,Nt.toDataTransferItem(We,()=>Ae(We.id))]);return new l.DataTransfer(Le)}Se.toDataTransfer=Pe;async function fe(q){const Ae={items:[]},Le=[];return q.forEach((nt,We)=>{Le.push((async()=>{const tt=await nt.asString(),ct=nt.asFile();Ae.items.push([We,{id:nt.id,asString:tt,fileData:ct?{name:ct.name,uri:ct.uri}:void 0}])})())}),await Promise.all(Le),Ae}Se.toDataTransferDTO=fe})(gt=e.DataTransfer||(e.DataTransfer={}))}),define(Ce[178],Ie([1,0,2,12,6,8,242]),function(ie,e,r,y,S,M,_){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtHostDocumentSaveParticipant=void 0;class A{constructor(P,O,E,m={timeout:1500,errors:3}){this._logService=P,this._documents=O,this._mainThreadBulkEdits=E,this._thresholds=m,this._callbacks=new _.LinkedList,this._badListeners=new WeakMap}dispose(){this._callbacks.clear()}getOnWillSaveTextDocumentEvent(P){return(O,E,m)=>{const f={dispose:this._callbacks.push([O,E,P])};return Array.isArray(m)&&m.push(f),f}}async $participateInSave(P,O){const E=r.URI.revive(P);let m=!1;const k=setTimeout(()=>m=!0,this._thresholds.timeout),f=[];try{for(const c of[...this._callbacks]){if(m)break;const d=this._documents.getDocument(E),h=await this._deliverEventAsyncAndBlameBadListeners(c,{document:d,reason:M.TextDocumentSaveReason.to(O)});f.push(h)}}finally{clearTimeout(k)}return f}_deliverEventAsyncAndBlameBadListeners([P,O,E],m){const k=this._badListeners.get(P);return typeof k=="number"&&k>this._thresholds.errors?Promise.resolve(!1):this._deliverEventAsync(E,P,O,m).then(()=>!0,f=>{if(this._logService.error(`onWillSaveTextDocument-listener from extension '${E.identifier.value}' threw ERROR`),this._logService.error(f),!(f instanceof Error)||f.message!=="concurrent_edits"){const c=this._badListeners.get(P);this._badListeners.set(P,c?c+1:1),typeof c=="number"&&c>this._thresholds.errors&&this._logService.info(`onWillSaveTextDocument-listener from extension '${E.identifier.value}' will now be IGNORED because of timeouts and/or errors`)}return!1})}_deliverEventAsync(P,O,E,m){const k=[],f=Date.now(),{document:c,reason:d}=m,{version:h}=c,g=Object.freeze({document:c,reason:d,waitUntil(C){if(Object.isFrozen(k))throw(0,y.illegalState)("waitUntil can not be called async");k.push(Promise.resolve(C))}});try{O.apply(E,[g])}catch(C){return Promise.reject(C)}return Object.freeze(k),new Promise((C,l)=>{const w=setTimeout(()=>l(new Error("timeout")),this._thresholds.timeout);return Promise.all(k).then(t=>{this._logService.debug(`onWillSaveTextDocument-listener from extension '${P.identifier.value}' finished after ${Date.now()-f}ms`),clearTimeout(w),C(t)}).catch(t=>{clearTimeout(w),l(t)})}).then(C=>{const l={edits:[]};for(const w of C)if(Array.isArray(w)&&w.every(t=>t instanceof S.TextEdit))for(const{newText:t,newEol:u,range:i}of w)l.edits.push({resource:c.uri,versionId:void 0,textEdit:{range:i&&M.Range.from(i),text:t,eol:u&&M.EndOfLine.from(u)}});if(l.edits.length!==0)return h===c.version?this._mainThreadBulkEdits.$tryApplyWorkspaceEdit(l):Promise.reject(new Error("concurrent_edits"))})}}e.ExtHostDocumentSaveParticipant=A}),define(Ce[179],Ie([1,0,13,2,8,6,64]),function(ie,e,r,y,S,M,_){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtHostNotebookDocument=e.ExtHostCell=void 0;class A{constructor(E,m,k,f){this.start=E,this.deletedCount=m,this.deletedItems=k,this.items=f}asApiEvent(){return{range:new M.NotebookRange(this.start,this.start+this.deletedCount),addedCells:this.items.map(E=>E.apiCell),removedCells:this.deletedItems}}}class b{static asModelAddData(E,m){return{EOL:m.eol,lines:m.source,languageId:m.language,uri:m.uri,isDirty:!1,versionId:1,notebook:E}}constructor(E,m,k){this.notebook=E,this._extHostDocument=m,this._cellData=k,this.handle=k.handle,this.uri=y.URI.revive(k.uri),this.cellKind=k.cellKind,this._outputs=k.outputs.map(S.NotebookCellOutput.to),this._internalMetadata=k.internalMetadata??{},this._metadata=Object.freeze(k.metadata??{}),this._previousResult=Object.freeze(S.NotebookCellExecutionSummary.to(k.internalMetadata??{}))}get internalMetadata(){return this._internalMetadata}get apiCell(){if(!this._apiCell){const E=this,m=this._extHostDocument.getDocument(this.uri);if(!m)throw new Error(`MISSING extHostDocument for notebook cell: ${this.uri}`);const k={get index(){return E.notebook.getCellIndex(E)},notebook:E.notebook.apiNotebook,kind:S.NotebookCellKind.to(this._cellData.cellKind),document:m.document,get mime(){return E._mime},set mime(f){E._mime=f},get outputs(){return E._outputs.slice(0)},get metadata(){return E._metadata},get executionSummary(){return E._previousResult}};this._apiCell=Object.freeze(k)}return this._apiCell}setOutputs(E){this._outputs=E.map(S.NotebookCellOutput.to)}setOutputItems(E,m,k){const f=k.map(S.NotebookCellOutputItem.to),c=this._outputs.find(d=>d.id===E);c&&(m||(c.items.length=0),c.items.push(...f))}setMetadata(E){this._metadata=Object.freeze(E)}setInternalMetadata(E){this._internalMetadata=E,this._previousResult=Object.freeze(S.NotebookCellExecutionSummary.to(E))}setMime(E){}}e.ExtHostCell=b;class P{constructor(E,m,k,f,c){this._proxy=E,this._textDocumentsAndEditors=m,this._textDocuments=k,this.uri=f,this.handle=P._handlePool++,this._cells=[],this._versionId=0,this._isDirty=!1,this._disposed=!1,this._notebookType=c.viewType,this._metadata=Object.freeze(c.metadata??Object.create(null)),this._spliceNotebookCells([[0,0,c.cells]],!0,void 0),this._versionId=c.versionId}dispose(){this._disposed=!0}get apiNotebook(){if(!this._notebook){const E=this,m={get uri(){return E.uri},get version(){return E._versionId},get notebookType(){return E._notebookType},get isDirty(){return E._isDirty},get isUntitled(){return E.uri.scheme===r.Schemas.untitled},get isClosed(){return E._disposed},get metadata(){return E._metadata},get cellCount(){return E._cells.length},cellAt(k){return k=E._validateIndex(k),E._cells[k].apiCell},getCells(k){return(k?E._getCells(k):E._cells).map(c=>c.apiCell)},save(){return E._save()}};this._notebook=Object.freeze(m)}return this._notebook}acceptDocumentPropertiesChanged(E){E.metadata&&(this._metadata=Object.freeze({...this._metadata,...E.metadata}))}acceptDirty(E){this._isDirty=E}acceptModelChanged(E,m,k){this._versionId=E.versionId,this._isDirty=m,this.acceptDocumentPropertiesChanged({metadata:k});const f={notebook:this.apiNotebook,metadata:k,cellChanges:[],contentChanges:[]},c=[];for(const h of E.rawEvents)h.kind===_.NotebookCellsChangeType.ModelChange?this._spliceNotebookCells(h.changes,!1,f.contentChanges):h.kind===_.NotebookCellsChangeType.Move?this._moveCell(h.index,h.newIdx,f.contentChanges):h.kind===_.NotebookCellsChangeType.Output?(this._setCellOutputs(h.index,h.outputs),c.push({cell:this._cells[h.index].apiCell,outputs:this._cells[h.index].apiCell.outputs})):h.kind===_.NotebookCellsChangeType.OutputItem?(this._setCellOutputItems(h.index,h.outputId,h.append,h.outputItems),c.push({cell:this._cells[h.index].apiCell,outputs:this._cells[h.index].apiCell.outputs})):h.kind===_.NotebookCellsChangeType.ChangeCellLanguage?(this._changeCellLanguage(h.index,h.language),c.push({cell:this._cells[h.index].apiCell,document:this._cells[h.index].apiCell.document})):h.kind===_.NotebookCellsChangeType.ChangeCellContent?c.push({cell:this._cells[h.index].apiCell,document:this._cells[h.index].apiCell.document}):h.kind===_.NotebookCellsChangeType.ChangeCellMime?this._changeCellMime(h.index,h.mime):h.kind===_.NotebookCellsChangeType.ChangeCellMetadata?(this._changeCellMetadata(h.index,h.metadata),c.push({cell:this._cells[h.index].apiCell,metadata:this._cells[h.index].apiCell.metadata})):h.kind===_.NotebookCellsChangeType.ChangeCellInternalMetadata&&(this._changeCellInternalMetadata(h.index,h.internalMetadata),c.push({cell:this._cells[h.index].apiCell,executionSummary:this._cells[h.index].apiCell.executionSummary}));const d=new Map;for(let h=0;h<c.length;h++){const g=c[h],C=d.get(g.cell);if(C===void 0){const l=f.cellChanges.push({document:void 0,executionSummary:void 0,metadata:void 0,outputs:void 0,...g});d.set(g.cell,l-1)}else f.cellChanges[C]={...f.cellChanges[C],...g}}return Object.freeze(f),Object.freeze(f.cellChanges),Object.freeze(f.contentChanges),f}_validateIndex(E){return E=E|0,E<0?0:E>=this._cells.length?this._cells.length-1:E}_validateRange(E){let m=E.start|0,k=E.end|0;return m<0&&(m=0),k>this._cells.length&&(k=this._cells.length),E.with({start:m,end:k})}_getCells(E){E=this._validateRange(E);const m=[];for(let k=E.start;k<E.end;k++)m.push(this._cells[k]);return m}async _save(){return this._disposed?Promise.reject(new Error("Notebook has been closed")):this._proxy.$trySaveNotebook(this.uri)}_spliceNotebookCells(E,m,k){if(this._disposed)return;const f=[],c=[],d=[];if(E.reverse().forEach(h=>{const C=h[2].map(t=>{const u=new b(this,this._textDocumentsAndEditors,t);return m||c.push(b.asModelAddData(this.apiNotebook,t)),u}),l=new A(h[0],h[1],[],C),w=this._cells.splice(h[0],h[1],...C);for(const t of w)d.push(t.uri),l.deletedItems.push(t.apiCell);f.push(l)}),this._textDocumentsAndEditors.acceptDocumentsAndEditorsDelta({addedDocuments:c,removedDocuments:d}),k)for(const h of f)k.push(h.asApiEvent())}_moveCell(E,m,k){const f=this._cells.splice(E,1);this._cells.splice(m,0,...f);const c=[new A(E,1,f.map(d=>d.apiCell),[]),new A(m,0,[],f)];for(const d of c)k.push(d.asApiEvent())}_setCellOutputs(E,m){this._cells[E].setOutputs(m)}_setCellOutputItems(E,m,k,f){this._cells[E].setOutputItems(m,k,f)}_changeCellLanguage(E,m){const k=this._cells[E];k.apiCell.document.languageId!==m&&this._textDocuments.$acceptModelLanguageChanged(k.uri,m)}_changeCellMime(E,m){const k=this._cells[E];k.apiCell.mime=m}_changeCellMetadata(E,m){this._cells[E].setMetadata(m)}_changeCellInternalMetadata(E,m){this._cells[E].setInternalMetadata(m)}getCellFromApiCell(E){return this._cells.find(m=>m.apiCell===E)}getCellFromIndex(E){return this._cells[E]}getCell(E){return this._cells.find(m=>m.handle===E)}getCellIndex(E){return this._cells.indexOf(E)}}e.ExtHostNotebookDocument=P,P._handlePool=0}),define(Ce[94],Ie([1,0,12,8,6]),function(ie,e,r,y,S){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtHostNotebookEditor=void 0;class M{constructor(A,b,P,O,E,m){this.id=A,this._proxy=b,this.notebookData=P,this._selections=[],this._visibleRanges=[],this._visible=!1,this._selections=E,this._visibleRanges=O,this._viewColumn=m}get apiEditor(){if(!this._editor){const A=this;this._editor={get document(){return A.notebookData.apiNotebook},get notebook(){return A.notebookData.apiNotebook},get selection(){return A._selections[0]},set selection(b){this.selections=[b]},get selections(){return A._selections},set selections(b){if(!Array.isArray(b)||!b.every(S.NotebookRange.isNotebookRange))throw(0,r.illegalArgument)("selections");A._selections=b,A._trySetSelections(b)},get visibleRanges(){return A._visibleRanges},revealRange(b,P){A._proxy.$tryRevealRange(A.id,y.NotebookRange.from(b),P??S.NotebookEditorRevealType.Default)},get viewColumn(){return A._viewColumn}},M.apiEditorsToExtHost.set(this._editor,this)}return this._editor}get visible(){return this._visible}_acceptVisibility(A){this._visible=A}_acceptVisibleRanges(A){this._visibleRanges=A}_acceptSelections(A){this._selections=A}_trySetSelections(A){this._proxy.$trySetSelections(this.id,A.map(y.NotebookRange.from))}_acceptViewColumn(A){this._viewColumn=A}}e.ExtHostNotebookEditor=M,M.apiEditorsToExtHost=new WeakMap}),define(Ce[180],Ie([1,0,5,14,8]),function(ie,e,r,y,S){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtHostNotebookEditors=void 0;let M=class{constructor(A,b){this._logService=A,this._notebooksAndEditors=b,this._onDidChangeNotebookEditorSelection=new r.Emitter,this._onDidChangeNotebookEditorVisibleRanges=new r.Emitter,this.onDidChangeNotebookEditorSelection=this._onDidChangeNotebookEditorSelection.event,this.onDidChangeNotebookEditorVisibleRanges=this._onDidChangeNotebookEditorVisibleRanges.event}$acceptEditorPropertiesChanged(A,b){this._logService.debug("ExtHostNotebook#$acceptEditorPropertiesChanged",A,b);const P=this._notebooksAndEditors.getEditorById(A);b.visibleRanges&&P._acceptVisibleRanges(b.visibleRanges.ranges.map(S.NotebookRange.to)),b.selections&&P._acceptSelections(b.selections.selections.map(S.NotebookRange.to)),b.visibleRanges&&this._onDidChangeNotebookEditorVisibleRanges.fire({notebookEditor:P.apiEditor,visibleRanges:P.apiEditor.visibleRanges}),b.selections&&this._onDidChangeNotebookEditorSelection.fire(Object.freeze({notebookEditor:P.apiEditor,selections:P.apiEditor.selections}))}$acceptEditorViewColumns(A){for(const b in A)this._notebooksAndEditors.getEditorById(b)._acceptViewColumn(S.ViewColumn.to(A[b]))}};M=ze([$e(0,y.ILogService)],M),e.ExtHostNotebookEditors=M}),define(Ce[181],Ie([1,0,8,151,132,20,55,12]),function(ie,e,r,y,S,M,_,A){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtHostProgress=void 0;class b{constructor(m){this._handles=0,this._mapHandleToCancellationSource=new Map,this._proxy=m}async withProgress(m,k,f){const c=this._handles++,{title:d,location:h,cancellable:g}=k,C={label:(0,S.localize)(0,null,m.displayName||m.name),id:m.identifier.value};return this._proxy.$startProgress(c,{location:r.ProgressLocation.from(h),title:d,source:C,cancellable:g},m.isUnderDevelopment?void 0:m.identifier.value).catch(A.onUnexpectedExternalError),this._withProgress(c,f,!!g)}_withProgress(m,k,f){let c;f&&(c=new M.CancellationTokenSource,this._mapHandleToCancellationSource.set(m,c));const d=g=>{this._proxy.$progressEnd(g),this._mapHandleToCancellationSource.delete(g),c?.dispose()};let h;try{h=k(new O(this._proxy,m),f&&c?c.token:M.CancellationToken.None)}catch(g){throw d(m),g}return h.then(g=>d(m),g=>d(m)),h}$acceptProgressCanceled(m){const k=this._mapHandleToCancellationSource.get(m);k&&(k.cancel(),this._mapHandleToCancellationSource.delete(m))}}e.ExtHostProgress=b;function P(E,m){return E.message=m.message,typeof m.increment=="number"&&(typeof E.increment=="number"?E.increment+=m.increment:E.increment=m.increment),E}class O extends y.Progress{constructor(m,k){super(f=>this.throttledReport(f)),this._proxy=m,this._handle=k}throttledReport(m){this._proxy.$progressReport(this._handle,m)}}ze([(0,_.throttle)(100,(E,m)=>P(E,m),()=>Object.create(null))],O.prototype,"throttledReport",null)}),define(Ce[95],Ie([1,0,49,90,47,65,48,8,2]),function(ie,e,r,y,S,M,_,A,b){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtHostTestItemCollection=e.TestItemRootImpl=e.TestItemImpl=e.toItemFromContext=void 0;const P=(C,l,w,t)=>{let u=l;return{enumerable:!0,configurable:!1,get(){return u},set(i){if(!w(u,i)){const n=u;u=i,C.listener?.(t(i,n))}}}},O=(C,l)=>C===l,E={range:(C,l)=>C===l?!0:!C||!l?!1:C.isEqual(l),label:O,description:O,sortText:O,busy:O,error:O,canResolveChildren:O,tags:(C,l)=>!(C.length!==l.length||C.some(w=>!l.find(t=>w.id===t.id)))},m=C=>l=>({op:4,update:C(l)}),k=(C,l)=>({range:(()=>{let w;const t=m(u=>({range:r.Range.lift(A.Range.from(u))}));return{enumerable:!0,configurable:!1,get(){return w},set(u){C.listener?.({op:6}),E.range(w,u)||(w=u,C.listener?.(t(u)))}}})(),label:P(C,l,E.label,m(w=>({label:w}))),description:P(C,void 0,E.description,m(w=>({description:w}))),sortText:P(C,void 0,E.sortText,m(w=>({sortText:w}))),canResolveChildren:P(C,!1,E.canResolveChildren,w=>({op:2,state:w})),busy:P(C,!1,E.busy,m(w=>({busy:w}))),error:P(C,void 0,E.error,m(w=>({error:A.MarkdownString.fromStrict(w)||null}))),tags:P(C,[],E.tags,(w,t)=>({op:1,new:w.map(A.TestTag.from),old:t.map(A.TestTag.from)}))}),f=C=>{const l=S.TestId.fromString(C.extId),w=new d(l.controllerId,l.localId,C.label,b.URI.revive(C.uri)||void 0);return w.range=A.Range.to(C.range||void 0),w.description=C.description||void 0,w.sortText=C.sortText||void 0,w.tags=C.tags.map(t=>A.TestTag.to({id:(0,_.denamespaceTestTag)(t).tagId})),w},c=C=>{let l;for(const w of C.tests){const t=f(w.item);(0,y.getPrivateApiFor)(t).parent=l,l=t}return l};e.toItemFromContext=c;class d{constructor(l,w,t,u){if(w.includes("\0"))throw new Error(`Test IDs may not include the ${JSON.stringify(w)} symbol`);const i=(0,y.createPrivateApiFor)(this,l);Object.defineProperties(this,{id:{value:w,enumerable:!0,writable:!1},uri:{value:u,enumerable:!0,writable:!1},parent:{enumerable:!1,get(){return i.parent instanceof h?void 0:i.parent}},children:{value:(0,M.createTestItemChildren)(i,y.getPrivateApiFor,d),enumerable:!0,writable:!1},...k(i,t)})}}e.TestItemImpl=d;class h extends d{constructor(l,w){super(l,l,w,void 0)}}e.TestItemRootImpl=h;class g extends M.TestItemCollection{constructor(l,w,t){super({controllerId:l,getDocumentVersion:u=>u&&t.getDocument(u)?.version,getApiFor:y.getPrivateApiFor,getChildren:u=>u.children,root:new h(l,w),toITestItem:A.TestItem.from})}}e.ExtHostTestItemCollection=g}),define(Ce[96],Ie([1,0,44,12,74,8,6]),function(ie,e,r,y,S,M,_){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtHostTextEditor=e.ExtHostTextEditorOptions=e.TextEditorEdit=e.TextEditorDecorationType=void 0;class A{constructor(m,k,f){const c=A._Keys.nextId();m.$registerTextEditorDecorationType(k.identifier,c,M.DecorationRenderOptions.from(f)),this.value=Object.freeze({key:c,dispose(){m.$removeTextEditorDecorationType(c)}})}}e.TextEditorDecorationType=A,A._Keys=new S.IdGenerator("TextEditorDecorationType");class b{constructor(m,k){this._collectedEdits=[],this._setEndOfLine=void 0,this._finalized=!1,this._document=m,this._documentVersionId=m.version,this._undoStopBefore=k.undoStopBefore,this._undoStopAfter=k.undoStopAfter}finalize(){return this._finalized=!0,{documentVersionId:this._documentVersionId,edits:this._collectedEdits,setEndOfLine:this._setEndOfLine,undoStopBefore:this._undoStopBefore,undoStopAfter:this._undoStopAfter}}_throwIfFinalized(){if(this._finalized)throw new Error("Edit is only valid while callback runs")}replace(m,k){this._throwIfFinalized();let f=null;if(m instanceof _.Position)f=new _.Range(m,m);else if(m instanceof _.Range)f=m;else throw new Error("Unrecognized location");this._pushEdit(f,k,!1)}insert(m,k){this._throwIfFinalized(),this._pushEdit(new _.Range(m,m),k,!0)}delete(m){this._throwIfFinalized();let k=null;if(m instanceof _.Range)k=m;else throw new Error("Unrecognized location");this._pushEdit(k,null,!0)}_pushEdit(m,k,f){const c=this._document.validateRange(m);this._collectedEdits.push({range:c,text:k,forceMoveMarkers:f})}setEndOfLine(m){if(this._throwIfFinalized(),m!==_.EndOfLine.LF&&m!==_.EndOfLine.CRLF)throw(0,y.illegalArgument)("endOfLine");this._setEndOfLine=m}}e.TextEditorEdit=b;class P{constructor(m,k,f,c){this._proxy=m,this._id=k,this._accept(f),this._logService=c;const d=this;this.value={get tabSize(){return d._tabSize},set tabSize(h){d._setTabSize(h)},get insertSpaces(){return d._insertSpaces},set insertSpaces(h){d._setInsertSpaces(h)},get cursorStyle(){return d._cursorStyle},set cursorStyle(h){d._setCursorStyle(h)},get lineNumbers(){return d._lineNumbers},set lineNumbers(h){d._setLineNumbers(h)}}}_accept(m){this._tabSize=m.tabSize,this._insertSpaces=m.insertSpaces,this._cursorStyle=m.cursorStyle,this._lineNumbers=M.TextEditorLineNumbersStyle.to(m.lineNumbers)}_validateTabSize(m){if(m==="auto")return"auto";if(typeof m=="number"){const k=Math.floor(m);return k>0?k:null}if(typeof m=="string"){const k=parseInt(m,10);return isNaN(k)?null:k>0?k:null}return null}_setTabSize(m){const k=this._validateTabSize(m);if(k!==null){if(typeof k=="number"){if(this._tabSize===k)return;this._tabSize=k}this._warnOnError("setTabSize",this._proxy.$trySetOptions(this._id,{tabSize:k}))}}_validateInsertSpaces(m){return m==="auto"?"auto":m==="false"?!1:Boolean(m)}_setInsertSpaces(m){const k=this._validateInsertSpaces(m);if(typeof k=="boolean"){if(this._insertSpaces===k)return;this._insertSpaces=k}this._warnOnError("setInsertSpaces",this._proxy.$trySetOptions(this._id,{insertSpaces:k}))}_setCursorStyle(m){this._cursorStyle!==m&&(this._cursorStyle=m,this._warnOnError("setCursorStyle",this._proxy.$trySetOptions(this._id,{cursorStyle:m})))}_setLineNumbers(m){this._lineNumbers!==m&&(this._lineNumbers=m,this._warnOnError("setLineNumbers",this._proxy.$trySetOptions(this._id,{lineNumbers:M.TextEditorLineNumbersStyle.from(m)})))}assign(m){const k={};let f=!1;if(typeof m.tabSize<"u"){const c=this._validateTabSize(m.tabSize);c==="auto"?(f=!0,k.tabSize=c):typeof c=="number"&&this._tabSize!==c&&(this._tabSize=c,f=!0,k.tabSize=c)}if(typeof m.insertSpaces<"u"){const c=this._validateInsertSpaces(m.insertSpaces);c==="auto"?(f=!0,k.insertSpaces=c):this._insertSpaces!==c&&(this._insertSpaces=c,f=!0,k.insertSpaces=c)}typeof m.cursorStyle<"u"&&this._cursorStyle!==m.cursorStyle&&(this._cursorStyle=m.cursorStyle,f=!0,k.cursorStyle=m.cursorStyle),typeof m.lineNumbers<"u"&&this._lineNumbers!==m.lineNumbers&&(this._lineNumbers=m.lineNumbers,f=!0,k.lineNumbers=M.TextEditorLineNumbersStyle.from(m.lineNumbers)),f&&this._warnOnError("setOptions",this._proxy.$trySetOptions(this._id,k))}_warnOnError(m,k){k.catch(f=>{this._logService.warn(`ExtHostTextEditorOptions '${m}' failed:'`),this._logService.warn(f)})}}e.ExtHostTextEditorOptions=P;class O{constructor(m,k,f,c,d,h,g,C){this.id=m,this._proxy=k,this._logService=f,this._disposed=!1,this._hasDecorationsForKey=new Set,this._selections=d,this._options=new P(this._proxy,this.id,h,f),this._visibleRanges=g,this._viewColumn=C;const l=this;this.value=Object.freeze({get document(){return c.getValue()},set document(w){throw(0,y.readonly)("document")},get selection(){return l._selections&&l._selections[0]},set selection(w){if(!(w instanceof _.Selection))throw(0,y.illegalArgument)("selection");l._selections=[w],l._trySetSelection()},get selections(){return l._selections},set selections(w){if(!Array.isArray(w)||w.some(t=>!(t instanceof _.Selection)))throw(0,y.illegalArgument)("selections");l._selections=w,l._trySetSelection()},get visibleRanges(){return l._visibleRanges},set visibleRanges(w){throw(0,y.readonly)("visibleRanges")},get options(){return l._options.value},set options(w){l._disposed||l._options.assign(w)},get viewColumn(){return l._viewColumn},set viewColumn(w){throw(0,y.readonly)("viewColumn")},edit(w,t={undoStopBefore:!0,undoStopAfter:!0}){if(l._disposed)return Promise.reject(new Error("TextEditor#edit not possible on closed editors"));const u=new b(c.getValue(),t);return w(u),l._applyEdit(u)},insertSnippet(w,t,u={undoStopBefore:!0,undoStopAfter:!0}){if(l._disposed)return Promise.reject(new Error("TextEditor#insertSnippet not possible on closed editors"));let i;if(!t||Array.isArray(t)&&t.length===0)i=l._selections.map(n=>M.Range.from(n));else if(t instanceof _.Position){const{lineNumber:n,column:s}=M.Position.from(t);i=[{startLineNumber:n,startColumn:s,endLineNumber:n,endColumn:s}]}else if(t instanceof _.Range)i=[M.Range.from(t)];else{i=[];for(const n of t)if(n instanceof _.Range)i.push(M.Range.from(n));else{const{lineNumber:s,column:a}=M.Position.from(n);i.push({startLineNumber:s,startColumn:a,endLineNumber:s,endColumn:a})}}return k.$tryInsertSnippet(m,c.getValue().version,w.value,i,u)},setDecorations(w,t){const u=t.length===0;u&&!l._hasDecorationsForKey.has(w.key)||(u?l._hasDecorationsForKey.delete(w.key):l._hasDecorationsForKey.add(w.key),l._runOnProxy(()=>{if(M.isDecorationOptionsArr(t))return k.$trySetDecorations(m,w.key,M.fromRangeOrRangeWithMessage(t));{const i=new Array(4*t.length);for(let n=0,s=t.length;n<s;n++){const a=t[n];i[4*n]=a.start.line+1,i[4*n+1]=a.start.character+1,i[4*n+2]=a.end.line+1,i[4*n+3]=a.end.character+1}return k.$trySetDecorationsFast(m,w.key,i)}}))},revealRange(w,t){l._runOnProxy(()=>k.$tryRevealRange(m,M.Range.from(w),t||_.TextEditorRevealType.Default))},show(w){k.$tryShowEditor(m,M.ViewColumn.from(w))},hide(){k.$tryHideEditor(m)}})}dispose(){(0,r.ok)(!this._disposed),this._disposed=!0}_acceptOptions(m){(0,r.ok)(!this._disposed),this._options._accept(m)}_acceptVisibleRanges(m){(0,r.ok)(!this._disposed),this._visibleRanges=m}_acceptViewColumn(m){(0,r.ok)(!this._disposed),this._viewColumn=m}_acceptSelections(m){(0,r.ok)(!this._disposed),this._selections=m}async _trySetSelection(){const m=this._selections.map(M.Selection.from);return await this._runOnProxy(()=>this._proxy.$trySetSelections(this.id,m)),this.value}_applyEdit(m){const k=m.finalize();if(k.edits.length===0&&!k.setEndOfLine)return Promise.resolve(!0);const f=k.edits.map(d=>d.range);f.sort((d,h)=>d.end.line===h.end.line?d.end.character===h.end.character?d.start.line===h.start.line?d.start.character-h.start.character:d.start.line-h.start.line:d.end.character-h.end.character:d.end.line-h.end.line);for(let d=0,h=f.length-1;d<h;d++){const g=f[d].end;if(f[d+1].start.isBefore(g))return Promise.reject(new Error("Overlapping ranges are not allowed!"))}const c=k.edits.map(d=>({range:M.Range.from(d.range),text:d.text,forceMoveMarkers:d.forceMoveMarkers}));return this._proxy.$tryApplyEdits(this.id,k.documentVersionId,c,{setEndOfLine:typeof k.setEndOfLine=="number"?M.EndOfLine.from(k.setEndOfLine):void 0,undoStopBefore:k.undoStopBefore,undoStopAfter:k.undoStopAfter})}_runOnProxy(m){return this._disposed?(this._logService.warn("TextEditor is closed/disposed"),Promise.resolve(void 0)):m().then(()=>this,k=>(k instanceof Error&&k.name==="DISPOSED"||this._logService.warn(k),null))}}e.ExtHostTextEditor=O}),define(Ce[182],Ie([1,0]),function(ie,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.allApiProposals=void 0,e.allApiProposals=Object.freeze({authSession:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.authSession.d.ts",commentsResolvedState:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.commentsResolvedState.d.ts",contribCommentPeekContext:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.contribCommentPeekContext.d.ts",contribEditSessions:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.contribEditSessions.d.ts",contribEditorContentMenu:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.contribEditorContentMenu.d.ts",contribLabelFormatterWorkspaceTooltip:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.contribLabelFormatterWorkspaceTooltip.d.ts",contribMenuBarHome:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.contribMenuBarHome.d.ts",contribMergeEditorMenus:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.contribMergeEditorMenus.d.ts",contribRemoteHelp:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.contribRemoteHelp.d.ts",contribShareMenu:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.contribShareMenu.d.ts",contribViewsRemote:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.contribViewsRemote.d.ts",contribViewsWelcome:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.contribViewsWelcome.d.ts",customEditorMove:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.customEditorMove.d.ts",diffCommand:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.diffCommand.d.ts",diffContentOptions:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.diffContentOptions.d.ts",documentFiltersExclusive:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.documentFiltersExclusive.d.ts",documentPaste:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.documentPaste.d.ts",editSessionIdentityProvider:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.editSessionIdentityProvider.d.ts",editorInsets:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.editorInsets.d.ts",envShellEvent:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.envShellEvent.d.ts",extensionLog:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.extensionLog.d.ts",extensionRuntime:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.extensionRuntime.d.ts",extensionsAny:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.extensionsAny.d.ts",externalUriOpener:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.externalUriOpener.d.ts",fileSearchProvider:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.fileSearchProvider.d.ts",findTextInFiles:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.findTextInFiles.d.ts",fsChunks:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.fsChunks.d.ts",idToken:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.idToken.d.ts",inlineCompletionsAdditions:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.inlineCompletionsAdditions.d.ts",inlineCompletionsNew:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.inlineCompletionsNew.d.ts",interactiveWindow:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.interactiveWindow.d.ts",ipc:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.ipc.d.ts",localization:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.localization.d.ts",notebookCellExecutionState:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.notebookCellExecutionState.d.ts",notebookContentProvider:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.notebookContentProvider.d.ts",notebookControllerAffinityHidden:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.notebookControllerAffinityHidden.d.ts",notebookControllerKind:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.notebookControllerKind.d.ts",notebookDebugOptions:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.notebookDebugOptions.d.ts",notebookDeprecated:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.notebookDeprecated.d.ts",notebookEditor:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.notebookEditor.d.ts",notebookKernelSource:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.notebookKernelSource.d.ts",notebookLiveShare:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.notebookLiveShare.d.ts",notebookMessaging:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.notebookMessaging.d.ts",notebookMime:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.notebookMime.d.ts",portsAttributes:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.portsAttributes.d.ts",quickPickSortByLabel:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.quickPickSortByLabel.d.ts",resolvers:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.resolvers.d.ts",scmActionButton:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.scmActionButton.d.ts",scmSelectedProvider:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.scmSelectedProvider.d.ts",scmValidation:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.scmValidation.d.ts",tabInputTextMerge:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.tabInputTextMerge.d.ts",taskPresentationGroup:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.taskPresentationGroup.d.ts",telemetry:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.telemetry.d.ts",telemetryLog:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.telemetryLog.d.ts",terminalDataWriteEvent:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.terminalDataWriteEvent.d.ts",terminalDimensions:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.terminalDimensions.d.ts",testCoverage:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.testCoverage.d.ts",testObserver:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.testObserver.d.ts",textSearchProvider:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.textSearchProvider.d.ts",timeline:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.timeline.d.ts",tokenInformation:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.tokenInformation.d.ts",treeItemCheckbox:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.treeItemCheckbox.d.ts",treeViewReveal:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.treeViewReveal.d.ts",tunnels:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.tunnels.d.ts",workspaceEditIsRefactoring:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.workspaceEditIsRefactoring.d.ts",workspaceTrust:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.workspaceTrust.d.ts"})}),define(Ce[183],Ie([1,0,143,12,29,81,84,30,27,182,150]),function(ie,e,r,y,S,M,_,A,b,P,O){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtensionsRegistry=e.ExtensionsRegistryImpl=e.schema=e.ExtensionPoint=e.ExtensionPointUserDelta=e.ExtensionMessageCollector=void 0;const E=A.Registry.as(_.Extensions.JSONContribution);class m{constructor(l,w,t){this._messageHandler=l,this._extension=w,this._extensionPointId=t}_msg(l,w){this._messageHandler({type:l,message:w,extensionId:this._extension.identifier,extensionPointId:this._extensionPointId})}error(l){this._msg(S.default.Error,l)}warn(l){this._msg(S.default.Warning,l)}info(l){this._msg(S.default.Info,l)}}e.ExtensionMessageCollector=m;class k{static _toSet(l){const w=new Set;for(let t=0,u=l.length;t<u;t++)w.add(b.ExtensionIdentifier.toKey(l[t].description.identifier));return w}static compute(l,w){if(!l||!l.length)return new k(w,[]);if(!w||!w.length)return new k([],l);const t=this._toSet(l),u=this._toSet(w),i=w.filter(s=>!t.has(b.ExtensionIdentifier.toKey(s.description.identifier))),n=l.filter(s=>!u.has(b.ExtensionIdentifier.toKey(s.description.identifier)));return new k(i,n)}constructor(l,w){this.added=l,this.removed=w}}e.ExtensionPointUserDelta=k;class f{constructor(l,w){this.name=l,this.defaultExtensionKind=w,this._handler=null,this._users=null,this._delta=null}setHandler(l){if(this._handler!==null)throw new Error("Handler already set!");this._handler=l,this._handle()}acceptUsers(l){this._delta=k.compute(this._users,l),this._users=l,this._handle()}_handle(){if(!(this._handler===null||this._users===null||this._delta===null))try{this._handler(this._users,this._delta)}catch(l){(0,y.onUnexpectedError)(l)}}}e.ExtensionPoint=f;const c={type:"string",enum:["ui","workspace"],enumDescriptions:[r.localize(0,null),r.localize(1,null)]},d="vscode://schemas/vscode-extensions";e.schema={properties:{engines:{type:"object",description:r.localize(2,null),properties:{vscode:{type:"string",description:r.localize(3,null),default:"^1.22.0"}}},publisher:{description:r.localize(4,null),type:"string"},displayName:{description:r.localize(5,null),type:"string"},categories:{description:r.localize(6,null),type:"array",uniqueItems:!0,items:{oneOf:[{type:"string",enum:b.EXTENSION_CATEGORIES},{type:"string",const:"Languages",deprecationMessage:r.localize(7,null)}]}},galleryBanner:{type:"object",description:r.localize(8,null),properties:{color:{description:r.localize(9,null),type:"string"},theme:{description:r.localize(10,null),type:"string",enum:["dark","light"]}}},contributes:{description:r.localize(11,null),type:"object",properties:{},default:{}},preview:{type:"boolean",description:r.localize(12,null)},enableProposedApi:{type:"boolean",deprecationMessage:r.localize(13,null)},enabledApiProposals:{markdownDescription:r.localize(14,null),type:"array",uniqueItems:!0,items:{type:"string",enum:Object.keys(P.allApiProposals),markdownEnumDescriptions:Object.values(P.allApiProposals)}},activationEvents:{description:r.localize(15,null),type:"array",items:{type:"string",defaultSnippets:[{label:"onWebviewPanel",description:r.localize(16,null),body:"onWebviewPanel:viewType"},{label:"onLanguage",description:r.localize(17,null),body:"onLanguage:${1:languageId}"},{label:"onCommand",description:r.localize(18,null),body:"onCommand:${2:commandId}"},{label:"onDebug",description:r.localize(19,null),body:"onDebug"},{label:"onDebugInitialConfigurations",description:r.localize(20,null),body:"onDebugInitialConfigurations"},{label:"onDebugDynamicConfigurations",description:r.localize(21,null),body:"onDebugDynamicConfigurations"},{label:"onDebugResolve",description:r.localize(22,null),body:"onDebugResolve:${6:type}"},{label:"onDebugAdapterProtocolTracker",description:r.localize(23,null),body:"onDebugAdapterProtocolTracker:${6:type}"},{label:"workspaceContains",description:r.localize(24,null),body:"workspaceContains:${4:filePattern}"},{label:"onStartupFinished",description:r.localize(25,null),body:"onStartupFinished"},{label:"onTaskType",description:r.localize(26,null),body:"onTaskType:${1:taskType}"},{label:"onFileSystem",description:r.localize(27,null),body:"onFileSystem:${1:scheme}"},{label:"onEditSession",description:r.localize(28,null),body:"onEditSession:${1:scheme}"},{label:"onSearch",description:r.localize(29,null),body:"onSearch:${7:scheme}"},{label:"onView",body:"onView:${5:viewId}",description:r.localize(30,null)},{label:"onIdentity",body:"onIdentity:${8:identity}",description:r.localize(31,null)},{label:"onUri",body:"onUri",description:r.localize(32,null)},{label:"onOpenExternalUri",body:"onOpenExternalUri",description:r.localize(33,null)},{label:"onCustomEditor",body:"onCustomEditor:${9:viewType}",description:r.localize(34,null)},{label:"onNotebook",body:"onNotebook:${1:type}",description:r.localize(35,null)},{label:"onAuthenticationRequest",body:"onAuthenticationRequest:${11:authenticationProviderId}",description:r.localize(36,null)},{label:"onRenderer",description:r.localize(37,null),body:"onRenderer:${11:rendererId}"},{label:"onTerminalProfile",body:"onTerminalProfile:${1:terminalId}",description:r.localize(38,null)},{label:"onWalkthrough",body:"onWalkthrough:${1:walkthroughID}",description:r.localize(39,null)},{label:"*",description:r.localize(40,null),body:"*"}]}},badges:{type:"array",description:r.localize(41,null),items:{type:"object",required:["url","href","description"],properties:{url:{type:"string",description:r.localize(42,null)},href:{type:"string",description:r.localize(43,null)},description:{type:"string",description:r.localize(44,null)}}}},markdown:{type:"string",description:r.localize(45,null),enum:["github","standard"],default:"github"},qna:{default:"marketplace",description:r.localize(46,null),anyOf:[{type:["string","boolean"],enum:["marketplace",!1]},{type:"string"}]},extensionDependencies:{description:r.localize(47,null),type:"array",uniqueItems:!0,items:{type:"string",pattern:M.EXTENSION_IDENTIFIER_PATTERN}},extensionPack:{description:r.localize(48,null),type:"array",uniqueItems:!0,items:{type:"string",pattern:M.EXTENSION_IDENTIFIER_PATTERN}},extensionKind:{description:r.localize(49,null),type:"array",items:c,default:["workspace"],defaultSnippets:[{body:["ui"],description:r.localize(50,null)},{body:["workspace"],description:r.localize(51,null)},{body:["ui","workspace"],description:r.localize(52,null)},{body:["workspace","ui"],description:r.localize(53,null)},{body:[],description:r.localize(54,null)}]},capabilities:{description:r.localize(55,null),type:"object",properties:{virtualWorkspaces:{description:r.localize(56,null),type:["boolean","object"],defaultSnippets:[{label:"limited",body:{supported:"${1:limited}",description:"${2}"}},{label:"false",body:{supported:!1,description:"${2}"}}],default:(!0).valueOf,properties:{supported:{markdownDescription:r.localize(57,null),type:["string","boolean"],enum:["limited",!0,!1],enumDescriptions:[r.localize(58,null),r.localize(59,null),r.localize(60,null)]},description:{type:"string",markdownDescription:r.localize(61,null)}}},untrustedWorkspaces:{description:r.localize(62,null),type:"object",required:["supported"],defaultSnippets:[{body:{supported:"${1:limited}",description:"${2}"}}],properties:{supported:{markdownDescription:r.localize(63,null),type:["string","boolean"],enum:["limited",!0,!1],enumDescriptions:[r.localize(64,null),r.localize(65,null),r.localize(66,null)]},restrictedConfigurations:{description:r.localize(67,null),type:"array",items:{type:"string"}},description:{type:"string",markdownDescription:r.localize(68,null)}}}}},sponsor:{description:r.localize(69,null),type:"object",defaultSnippets:[{body:{url:"${1:https:}"}}],properties:{url:{description:r.localize(70,null),type:"string"}}},scripts:{type:"object",properties:{"vscode:prepublish":{description:r.localize(71,null),type:"string"},"vscode:uninstall":{description:r.localize(72,null),type:"string"}}},icon:{type:"string",description:r.localize(73,null)},l10n:{type:"string",description:r.localize(74,null)}}};class h{constructor(){this._extensionPoints=new Map}registerExtensionPoint(l){if(this._extensionPoints.has(l.extensionPoint))throw new Error("Duplicate extension point: "+l.extensionPoint);const w=new f(l.extensionPoint,l.defaultExtensionKind);return this._extensionPoints.set(l.extensionPoint,w),e.schema.properties.contributes.properties[l.extensionPoint]=l.jsonSchema,E.registerSchema(d,e.schema),w}getExtensionPoints(){return Array.from(this._extensionPoints.values())}}e.ExtensionsRegistryImpl=h;const g={ExtensionsRegistry:"ExtensionsRegistry"};A.Registry.add(g.ExtensionsRegistry,new h),e.ExtensionsRegistry=A.Registry.as(g.ExtensionsRegistry),E.registerSchema(d,e.schema),E.registerSchema(O.productSchemaId,{properties:{extensionEnabledApiProposals:{description:r.localize(75,null),type:"object",properties:{},additionalProperties:{anyOf:[{type:"array",uniqueItems:!0,items:{type:"string",enum:Object.keys(P.allApiProposals),markdownEnumDescriptions:Object.values(P.allApiProposals)}}]}}}})}),define(Ce[184],Ie([1,0,140,10,26,183,39,5]),function(ie,e,r,y,S,M,_,A){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.TaskDefinitionRegistry=e.TaskDefinitionRegistryImpl=void 0;const b={type:"object",additionalProperties:!1,properties:{type:{type:"string",description:r.localize(0,null)},required:{type:"array",items:{type:"string"}},properties:{type:"object",description:r.localize(1,null),additionalProperties:{$ref:"http://json-schema.org/draft-07/schema#"}},when:{type:"string",markdownDescription:r.localize(2,null),default:""}}};var P;(function(m){function k(f,c,d){if(!f)return;const h=y.isString(f.type)?f.type:void 0;if(!h||h.length===0){d.error(r.localize(3,null));return}const g=[];if(Array.isArray(f.required))for(const C of f.required)y.isString(C)&&g.push(C);return{extensionId:c.value,taskType:h,required:g,properties:f.properties?S.deepClone(f.properties):{},when:f.when?_.ContextKeyExpr.deserialize(f.when):void 0}}m.from=k})(P||(P={}));const O=M.ExtensionsRegistry.registerExtensionPoint({extensionPoint:"taskDefinitions",jsonSchema:{description:r.localize(4,null),type:"array",items:b}});class E{constructor(){this._onDefinitionsChanged=new A.Emitter,this.onDefinitionsChanged=this._onDefinitionsChanged.event,this.taskTypes=Object.create(null),this.readyPromise=new Promise((k,f)=>{O.setHandler((c,d)=>{this._schema=void 0;try{for(const h of d.removed){const g=h.value;for(const C of g)this.taskTypes&&C.type&&this.taskTypes[C.type]&&delete this.taskTypes[C.type]}for(const h of d.added){const g=h.value;for(const C of g){const l=P.from(C,h.description.identifier,h.collector);l&&(this.taskTypes[l.taskType]=l)}}(d.removed.length>0||d.added.length>0)&&this._onDefinitionsChanged.fire()}catch{}k(void 0)})})}onReady(){return this.readyPromise}get(k){return this.taskTypes[k]}all(){return Object.keys(this.taskTypes).map(k=>this.taskTypes[k])}getJsonSchema(){if(this._schema===void 0){const k=[];for(const f of this.all()){const c={type:"object",additionalProperties:!1};f.required.length>0&&(c.required=f.required.slice(0)),f.properties!==void 0?c.properties=S.deepClone(f.properties):c.properties=Object.create(null),c.properties.type={type:"string",enum:[f.taskType]},k.push(c)}this._schema={oneOf:k}}return this._schema}}e.TaskDefinitionRegistryImpl=E,e.TaskDefinitionRegistry=new E}),define(Ce[185],Ie([1,0,141,10,22,26,39,184]),function(ie,e,r,y,S,M,_,A){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.TaskDefinition=e.TasksSchemaProperties=e.TaskSettingId=e.KeyedTaskIdentifier=e.TaskEvent=e.TaskRunSource=e.TaskRunType=e.TaskEventKind=e.TaskSorter=e.JsonSchemaVersion=e.ExecutionEngine=e.InMemoryTask=e.ContributedTask=e.ConfiguringTask=e.CustomTask=e.CommonTask=e.RunOptions=e.RunOnOptions=e.DependsOrder=e.TaskSourceKind=e.TaskScope=e.TaskGroup=e.CommandString=e.RuntimeType=e.PresentationOptions=e.PanelKind=e.RevealProblemKind=e.RevealKind=e.CommandOptions=e.CUSTOMIZED_TASK_TYPE=e.ShellQuoting=e.TASKS_CATEGORY=e.TASK_RUNNING_STATE=e.USER_TASKS_GROUP_KEY=void 0,e.USER_TASKS_GROUP_KEY="settings",e.TASK_RUNNING_STATE=new _.RawContextKey("taskRunning",!1,r.localize(0,null)),e.TASKS_CATEGORY={value:r.localize(1,null),original:"Tasks"};var b;(function(R){R[R.Escape=1]="Escape",R[R.Strong=2]="Strong",R[R.Weak=3]="Weak"})(b=e.ShellQuoting||(e.ShellQuoting={})),e.CUSTOMIZED_TASK_TYPE="$customized",function(R){function K(W){if(!W)return R.Strong;switch(W.toLowerCase()){case"escape":return R.Escape;case"strong":return R.Strong;case"weak":return R.Weak;default:return R.Strong}}R.from=K}(b=e.ShellQuoting||(e.ShellQuoting={}));var P;(function(R){R.defaults={cwd:"${workspaceFolder}"}})(P=e.CommandOptions||(e.CommandOptions={}));var O;(function(R){R[R.Always=1]="Always",R[R.Silent=2]="Silent",R[R.Never=3]="Never"})(O=e.RevealKind||(e.RevealKind={})),function(R){function K(W){switch(W.toLowerCase()){case"always":return R.Always;case"silent":return R.Silent;case"never":return R.Never;default:return R.Always}}R.fromString=K}(O=e.RevealKind||(e.RevealKind={}));var E;(function(R){R[R.Never=1]="Never",R[R.OnProblem=2]="OnProblem",R[R.Always=3]="Always"})(E=e.RevealProblemKind||(e.RevealProblemKind={})),function(R){function K(W){switch(W.toLowerCase()){case"always":return R.Always;case"never":return R.Never;case"onproblem":return R.OnProblem;default:return R.OnProblem}}R.fromString=K}(E=e.RevealProblemKind||(e.RevealProblemKind={}));var m;(function(R){R[R.Shared=1]="Shared",R[R.Dedicated=2]="Dedicated",R[R.New=3]="New"})(m=e.PanelKind||(e.PanelKind={})),function(R){function K(W){switch(W.toLowerCase()){case"shared":return R.Shared;case"dedicated":return R.Dedicated;case"new":return R.New;default:return R.Shared}}R.fromString=K}(m=e.PanelKind||(e.PanelKind={}));var k;(function(R){R.defaults={echo:!0,reveal:O.Always,revealProblems:E.Never,focus:!1,panel:m.Shared,showReuseMessage:!0,clear:!1}})(k=e.PresentationOptions||(e.PresentationOptions={}));var f;(function(R){R[R.Shell=1]="Shell",R[R.Process=2]="Process",R[R.CustomExecution=3]="CustomExecution"})(f=e.RuntimeType||(e.RuntimeType={})),function(R){function K($){switch($.toLowerCase()){case"shell":return R.Shell;case"process":return R.Process;case"customExecution":return R.CustomExecution;default:return R.Process}}R.fromString=K;function W($){switch($){case R.Shell:return"shell";case R.Process:return"process";case R.CustomExecution:return"customExecution";default:return"process"}}R.toString=W}(f=e.RuntimeType||(e.RuntimeType={}));var c;(function(R){function K(W){return y.isString(W)?W:W.value}R.value=K})(c=e.CommandString||(e.CommandString={}));var d;(function(R){R.Clean={_id:"clean",isDefault:!1},R.Build={_id:"build",isDefault:!1},R.Rebuild={_id:"rebuild",isDefault:!1},R.Test={_id:"test",isDefault:!1};function K($){return $===R.Clean._id||$===R.Build._id||$===R.Rebuild._id||$===R.Test._id}R.is=K;function W($){if($!==void 0)return y.isString($)?K($)?{_id:$,isDefault:!1}:void 0:$}R.from=W})(d=e.TaskGroup||(e.TaskGroup={}));var h;(function(R){R[R.Global=1]="Global",R[R.Workspace=2]="Workspace",R[R.Folder=3]="Folder"})(h=e.TaskScope||(e.TaskScope={}));var g;(function(R){R.Workspace="workspace",R.Extension="extension",R.InMemory="inMemory",R.WorkspaceFile="workspaceFile",R.User="user";function K(W){switch(W){case R.User:return 2;case R.WorkspaceFile:return 5;default:return 6}}R.toConfigurationTarget=K})(g=e.TaskSourceKind||(e.TaskSourceKind={}));var C;(function(R){R.parallel="parallel",R.sequence="sequence"})(C=e.DependsOrder||(e.DependsOrder={}));var l;(function(R){R[R.default=1]="default",R[R.folderOpen=2]="folderOpen"})(l=e.RunOnOptions||(e.RunOnOptions={}));var w;(function(R){R.defaults={reevaluateOnRerun:!0,runOn:l.default,instanceLimit:1}})(w=e.RunOptions||(e.RunOptions={}));class t{constructor(K,W,$,G,ne,ge){this._label="",this._id=K,W&&(this._label=W),$&&(this.type=$),this.runOptions=G,this.configurationProperties=ne,this._source=ge}getDefinition(K){}getMapKey(){return this._id}getRecentlyUsedKey(){}getCommonTaskId(){const K={folder:this.getFolderId(),id:this._id};return JSON.stringify(K)}clone(){return this.fromObject(Object.assign({},this))}getWorkspaceFolder(){}getWorkspaceFileName(){}getTelemetryKind(){return"unknown"}matches(K,W=!1){if(K===void 0)return!1;if(y.isString(K))return K===this._label||K===this.configurationProperties.identifier||W&&K===this._id;const $=this.getDefinition(!0);return $!==void 0&&$._key===K._key}getQualifiedLabel(){const K=this.getWorkspaceFolder();return K?`${this._label} (${K.name})`:this._label}getTaskExecution(){return{id:this._id,task:this}}addTaskLoadMessages(K){this._taskLoadMessages===void 0&&(this._taskLoadMessages=[]),K&&(this._taskLoadMessages=this._taskLoadMessages.concat(K))}get taskLoadMessages(){return this._taskLoadMessages}}e.CommonTask=t;class u extends t{constructor(K,W,$,G,ne,ge,oe,Ee){super(K,$,void 0,oe,Ee,W),this.command={},this._source=W,this.hasDefinedMatchers=ge,ne&&(this.command=ne)}clone(){return new u(this._id,this._source,this._label,this.type,this.command,this.hasDefinedMatchers,this.runOptions,this.configurationProperties)}customizes(){if(this._source&&this._source.customizes)return this._source.customizes}getDefinition(K=!1){if(K&&this._source.customizes!==void 0)return this._source.customizes;{let W;switch(this.command?this.command.runtime:void 0){case f.Shell:W="shell";break;case f.Process:W="process";break;case f.CustomExecution:W="customExecution";break;case void 0:W="$composite";break;default:throw new Error("Unexpected task runtime")}return{type:W,_key:this._id,id:this._id}}}static is(K){return K instanceof u}getMapKey(){const K=this._source.config.workspaceFolder;return K?`${K.uri.toString()}|${this._id}|${this.instance}`:`${this._id}|${this.instance}`}getFolderId(){return this._source.kind===g.User?e.USER_TASKS_GROUP_KEY:this._source.config.workspaceFolder?.uri.toString()}getCommonTaskId(){return this._source.customizes?super.getCommonTaskId():this.getRecentlyUsedKey()??super.getCommonTaskId()}getRecentlyUsedKey(){const K=this.getFolderId();if(!K)return;let W=this.configurationProperties.identifier;this._source.kind!==g.Workspace&&(W+=this._source.kind);const $={type:e.CUSTOMIZED_TASK_TYPE,folder:K,id:W};return JSON.stringify($)}getWorkspaceFolder(){return this._source.config.workspaceFolder}getWorkspaceFileName(){return this._source.config.workspace&&this._source.config.workspace.configuration?S.basename(this._source.config.workspace.configuration):void 0}getTelemetryKind(){return this._source.customizes?"workspace>extension":"workspace"}fromObject(K){return new u(K._id,K._source,K._label,K.type,K.command,K.hasDefinedMatchers,K.runOptions,K.configurationProperties)}}e.CustomTask=u;class i extends t{constructor(K,W,$,G,ne,ge,oe){super(K,$,G,ge,oe,W),this._source=W,this.configures=ne}static is(K){return K instanceof i}fromObject(K){return K}getDefinition(){return this.configures}getWorkspaceFileName(){return this._source.config.workspace&&this._source.config.workspace.configuration?S.basename(this._source.config.workspace.configuration):void 0}getWorkspaceFolder(){return this._source.config.workspaceFolder}getFolderId(){return this._source.kind===g.User?e.USER_TASKS_GROUP_KEY:this._source.config.workspaceFolder?.uri.toString()}getRecentlyUsedKey(){const K=this.getFolderId();if(!K)return;let W=this.configurationProperties.identifier;this._source.kind!==g.Workspace&&(W+=this._source.kind);const $={type:e.CUSTOMIZED_TASK_TYPE,folder:K,id:W};return JSON.stringify($)}}e.ConfiguringTask=i;class n extends t{constructor(K,W,$,G,ne,ge,oe,Ee,ce){super(K,$,G,Ee,ce,W),this.defines=ne,this.hasDefinedMatchers=oe,this.command=ge,this.icon=ce.icon,this.hide=ce.hide}clone(){return new n(this._id,this._source,this._label,this.type,this.defines,this.command,this.hasDefinedMatchers,this.runOptions,this.configurationProperties)}getDefinition(){return this.defines}static is(K){return K instanceof n}getMapKey(){const K=this._source.workspaceFolder;return K?`${this._source.scope.toString()}|${K.uri.toString()}|${this._id}|${this.instance}`:`${this._source.scope.toString()}|${this._id}|${this.instance}`}getFolderId(){if(this._source.scope===3&&this._source.workspaceFolder)return this._source.workspaceFolder.uri.toString()}getRecentlyUsedKey(){const K={type:"contributed",scope:this._source.scope,id:this._id};return K.folder=this.getFolderId(),JSON.stringify(K)}getWorkspaceFolder(){return this._source.workspaceFolder}getTelemetryKind(){return"extension"}fromObject(K){return new n(K._id,K._source,K._label,K.type,K.defines,K.command,K.hasDefinedMatchers,K.runOptions,K.configurationProperties)}}e.ContributedTask=n;class s extends t{constructor(K,W,$,G,ne,ge){super(K,$,G,ne,ge,W),this._source=W}clone(){return new s(this._id,this._source,this._label,this.type,this.runOptions,this.configurationProperties)}static is(K){return K instanceof s}getTelemetryKind(){return"composite"}getMapKey(){return`${this._id}|${this.instance}`}getFolderId(){}fromObject(K){return new s(K._id,K._source,K._label,K.type,K.runOptions,K.configurationProperties)}}e.InMemoryTask=s;var a;(function(R){R[R.Process=1]="Process",R[R.Terminal=2]="Terminal"})(a=e.ExecutionEngine||(e.ExecutionEngine={})),function(R){R._default=R.Terminal}(a=e.ExecutionEngine||(e.ExecutionEngine={}));var o;(function(R){R[R.V0_1_0=1]="V0_1_0",R[R.V2_0_0=2]="V2_0_0"})(o=e.JsonSchemaVersion||(e.JsonSchemaVersion={}));class v{constructor(K){this._order=new Map;for(let W=0;W<K.length;W++)this._order.set(K[W].uri.toString(),W)}compare(K,W){const $=K.getWorkspaceFolder(),G=W.getWorkspaceFolder();if($&&G){let ne=this._order.get($.uri.toString());ne=ne===void 0?0:ne+1;let ge=this._order.get(G.uri.toString());return ge=ge===void 0?0:ge+1,ne===ge?K._label.localeCompare(W._label):ne-ge}else return!$&&G?-1:$&&!G?1:0}}e.TaskSorter=v;var p;(function(R){R.DependsOnStarted="dependsOnStarted",R.AcquiredInput="acquiredInput",R.Start="start",R.ProcessStarted="processStarted",R.Active="active",R.Inactive="inactive",R.Changed="changed",R.Terminated="terminated",R.ProcessEnded="processEnded",R.End="end"})(p=e.TaskEventKind||(e.TaskEventKind={}));var T;(function(R){R.SingleRun="singleRun",R.Background="background"})(T=e.TaskRunType||(e.TaskRunType={}));var N;(function(R){R[R.System=0]="System",R[R.User=1]="User",R[R.FolderOpen=2]="FolderOpen",R[R.ConfigurationChange=3]="ConfigurationChange",R[R.Reconnect=4]="Reconnect"})(N=e.TaskRunSource||(e.TaskRunSource={}));var V;(function(R){function K(W,$,G,ne,ge){if($){const oe={kind:W,taskId:$._id,taskName:$.configurationProperties.name,runType:$.configurationProperties.isBackground?"background":"singleRun",group:$.configurationProperties.group,processId:void 0,exitCode:void 0,terminalId:void 0,__task:$};return W==="start"?(oe.terminalId=G,oe.resolvedVariables=ne):W==="processStarted"?oe.processId=G:W==="processEnded"&&(oe.exitCode=G),Object.freeze(oe)}else return Object.freeze({kind:"changed"})}R.create=K})(V=e.TaskEvent||(e.TaskEvent={}));var B;(function(R){function K($){const G=Object.keys($).sort();let ne="";for(const ge of G){let oe=$[ge];oe instanceof Object?oe=K(oe):typeof oe=="string"&&(oe=oe.replace(/,/g,",,")),ne+=ge+","+oe+","}return ne}function W($){const ne={_key:K($),type:$.taskType};return Object.assign(ne,$),ne}R.create=W})(B=e.KeyedTaskIdentifier||(e.KeyedTaskIdentifier={}));var D;(function(R){R.AutoDetect="task.autoDetect",R.SaveBeforeRun="task.saveBeforeRun",R.ShowDecorations="task.showDecorations",R.ProblemMatchersNeverPrompt="task.problemMatchers.neverPrompt",R.SlowProviderWarning="task.slowProviderWarning",R.QuickOpenHistory="task.quickOpen.history",R.QuickOpenDetail="task.quickOpen.detail",R.QuickOpenSkip="task.quickOpen.skip",R.QuickOpenShowAll="task.quickOpen.showAll",R.AllowAutomaticTasks="task.allowAutomaticTasks",R.Reconnection="task.reconnection"})(D=e.TaskSettingId||(e.TaskSettingId={}));var z;(function(R){R.Tasks="tasks",R.SuppressTaskName="tasks.suppressTaskName",R.Windows="tasks.windows",R.Osx="tasks.osx",R.Linux="tasks.linux",R.ShowOutput="tasks.showOutput",R.IsShellCommand="tasks.isShellCommand",R.ServiceTestSetting="tasks.service.testSetting"})(z=e.TasksSchemaProperties||(e.TasksSchemaProperties={}));var L;(function(R){function K(W,$){const G=A.TaskDefinitionRegistry.get(W.type);if(G===void 0){const Ee=M.deepClone(W);return delete Ee._key,B.create(Ee)}const ne=Object.create(null);ne.type=G.taskType;const ge=new Set;G.required.forEach(Ee=>ge.add(Ee));const oe=G.properties;for(const Ee of Object.keys(oe)){const ce=W[Ee];if(ce!=null)ne[Ee]=ce;else if(ge.has(Ee)){const me=oe[Ee];if(me.default!==void 0)ne[Ee]=M.deepClone(me.default);else switch(me.type){case"boolean":ne[Ee]=!1;break;case"number":case"integer":ne[Ee]=0;break;case"string":ne[Ee]="";break;default:$.error(r.localize(2,null,JSON.stringify(W,void 0,0),Ee));return}}}return B.create(ne)}R.createTaskIdentifier=K})(L=e.TaskDefinition||(e.TaskDefinition={}))}),define(Ce[186],Ie([1,0,12]),function(ie,e,r){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.CanceledLazyPromise=e.LazyPromise=void 0;class y{constructor(){this._actual=null,this._actualOk=null,this._actualErr=null,this._hasValue=!1,this._value=null,this._hasErr=!1,this._err=null}get[Symbol.toStringTag](){return this.toString()}_ensureActual(){return this._actual||(this._actual=new Promise((_,A)=>{this._actualOk=_,this._actualErr=A,this._hasValue&&this._actualOk(this._value),this._hasErr&&this._actualErr(this._err)})),this._actual}resolveOk(_){this._hasValue||this._hasErr||(this._hasValue=!0,this._value=_,this._actual&&this._actualOk(_))}resolveErr(_){this._hasValue||this._hasErr||(this._hasErr=!0,this._err=_,this._actual?this._actualErr(_):(0,r.onUnexpectedError)(_))}then(_,A){return this._ensureActual().then(_,A)}catch(_){return this._ensureActual().then(void 0,_)}finally(_){return this._ensureActual().finally(_)}}e.LazyPromise=y;class S extends y{constructor(){super(),this._hasErr=!0,this._err=new r.CancellationError}}e.CanceledLazyPromise=S}),define(Ce[40],Ie([1,0]),function(ie,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.SerializableObjectWithBuffers=e.getStringIdentifierForProxy=e.createProxyIdentifier=e.ProxyIdentifier=void 0;class r{constructor(b){this._proxyIdentifierBrand=void 0,this.sid=b,this.nid=++r.count}}e.ProxyIdentifier=r,r.count=0;const y=[];function S(A){const b=new r(A);return y[b.nid]=b,b}e.createProxyIdentifier=S;function M(A){return y[A].sid}e.getStringIdentifierForProxy=M;class _{constructor(b){this.value=b}}e.SerializableObjectWithBuffers=_}),define(Ce[4],Ie([1,0,40]),function(ie,e,r){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtHostContext=e.MainContext=e.ExtHostTestingResource=e.ISuggestResultDtoField=e.ISuggestDataDtoField=e.IdObject=e.CandidatePortSource=e.NotebookEditorRevealType=e.CellOutputKind=e.WebviewMessageArrayBufferViewType=e.WebviewEditorCapabilities=e.TabModelOperationKind=e.TabInputKind=e.TextEditorRevealType=void 0;var y;(function(c){c[c.Default=0]="Default",c[c.InCenter=1]="InCenter",c[c.InCenterIfOutsideViewport=2]="InCenterIfOutsideViewport",c[c.AtTop=3]="AtTop"})(y=e.TextEditorRevealType||(e.TextEditorRevealType={}));var S;(function(c){c[c.UnknownInput=0]="UnknownInput",c[c.TextInput=1]="TextInput",c[c.TextDiffInput=2]="TextDiffInput",c[c.TextMergeInput=3]="TextMergeInput",c[c.NotebookInput=4]="NotebookInput",c[c.NotebookDiffInput=5]="NotebookDiffInput",c[c.CustomEditorInput=6]="CustomEditorInput",c[c.WebviewEditorInput=7]="WebviewEditorInput",c[c.TerminalEditorInput=8]="TerminalEditorInput",c[c.InteractiveEditorInput=9]="InteractiveEditorInput"})(S=e.TabInputKind||(e.TabInputKind={}));var M;(function(c){c[c.TAB_OPEN=0]="TAB_OPEN",c[c.TAB_CLOSE=1]="TAB_CLOSE",c[c.TAB_UPDATE=2]="TAB_UPDATE",c[c.TAB_MOVE=3]="TAB_MOVE"})(M=e.TabModelOperationKind||(e.TabModelOperationKind={}));var _;(function(c){c[c.Editable=0]="Editable",c[c.SupportsHotExit=1]="SupportsHotExit"})(_=e.WebviewEditorCapabilities||(e.WebviewEditorCapabilities={}));var A;(function(c){c[c.Int8Array=1]="Int8Array",c[c.Uint8Array=2]="Uint8Array",c[c.Uint8ClampedArray=3]="Uint8ClampedArray",c[c.Int16Array=4]="Int16Array",c[c.Uint16Array=5]="Uint16Array",c[c.Int32Array=6]="Int32Array",c[c.Uint32Array=7]="Uint32Array",c[c.Float32Array=8]="Float32Array",c[c.Float64Array=9]="Float64Array",c[c.BigInt64Array=10]="BigInt64Array",c[c.BigUint64Array=11]="BigUint64Array"})(A=e.WebviewMessageArrayBufferViewType||(e.WebviewMessageArrayBufferViewType={}));var b;(function(c){c[c.Text=1]="Text",c[c.Error=2]="Error",c[c.Rich=3]="Rich"})(b=e.CellOutputKind||(e.CellOutputKind={}));var P;(function(c){c[c.Default=0]="Default",c[c.InCenter=1]="InCenter",c[c.InCenterIfOutsideViewport=2]="InCenterIfOutsideViewport",c[c.AtTop=3]="AtTop"})(P=e.NotebookEditorRevealType||(e.NotebookEditorRevealType={}));var O;(function(c){c[c.None=0]="None",c[c.Process=1]="Process",c[c.Output=2]="Output"})(O=e.CandidatePortSource||(e.CandidatePortSource={}));class E{static mixin(d){return d._id=E._n++,d}}e.IdObject=E,E._n=0;var m;(function(c){c.label="a",c.kind="b",c.detail="c",c.documentation="d",c.sortText="e",c.filterText="f",c.preselect="g",c.insertText="h",c.insertTextRules="i",c.range="j",c.commitCharacters="k",c.additionalTextEdits="l",c.command="m",c.kindModifier="n"})(m=e.ISuggestDataDtoField||(e.ISuggestDataDtoField={}));var k;(function(c){c.defaultRanges="a",c.completions="b",c.isIncomplete="c",c.duration="d"})(k=e.ISuggestResultDtoField||(e.ISuggestResultDtoField={}));var f;(function(c){c[c.Workspace=0]="Workspace",c[c.TextDocument=1]="TextDocument"})(f=e.ExtHostTestingResource||(e.ExtHostTestingResource={})),e.MainContext={MainThreadAuthentication:(0,r.createProxyIdentifier)("MainThreadAuthentication"),MainThreadBulkEdits:(0,r.createProxyIdentifier)("MainThreadBulkEdits"),MainThreadClipboard:(0,r.createProxyIdentifier)("MainThreadClipboard"),MainThreadCommands:(0,r.createProxyIdentifier)("MainThreadCommands"),MainThreadComments:(0,r.createProxyIdentifier)("MainThreadComments"),MainThreadConfiguration:(0,r.createProxyIdentifier)("MainThreadConfiguration"),MainThreadConsole:(0,r.createProxyIdentifier)("MainThreadConsole"),MainThreadDebugService:(0,r.createProxyIdentifier)("MainThreadDebugService"),MainThreadDecorations:(0,r.createProxyIdentifier)("MainThreadDecorations"),MainThreadDiagnostics:(0,r.createProxyIdentifier)("MainThreadDiagnostics"),MainThreadDialogs:(0,r.createProxyIdentifier)("MainThreadDiaglogs"),MainThreadDocuments:(0,r.createProxyIdentifier)("MainThreadDocuments"),MainThreadDocumentContentProviders:(0,r.createProxyIdentifier)("MainThreadDocumentContentProviders"),MainThreadTextEditors:(0,r.createProxyIdentifier)("MainThreadTextEditors"),MainThreadEditorInsets:(0,r.createProxyIdentifier)("MainThreadEditorInsets"),MainThreadEditorTabs:(0,r.createProxyIdentifier)("MainThreadEditorTabs"),MainThreadErrors:(0,r.createProxyIdentifier)("MainThreadErrors"),MainThreadTreeViews:(0,r.createProxyIdentifier)("MainThreadTreeViews"),MainThreadDownloadService:(0,r.createProxyIdentifier)("MainThreadDownloadService"),MainThreadKeytar:(0,r.createProxyIdentifier)("MainThreadKeytar"),MainThreadLanguageFeatures:(0,r.createProxyIdentifier)("MainThreadLanguageFeatures"),MainThreadLanguages:(0,r.createProxyIdentifier)("MainThreadLanguages"),MainThreadLogger:(0,r.createProxyIdentifier)("MainThreadLogger"),MainThreadMessageService:(0,r.createProxyIdentifier)("MainThreadMessageService"),MainThreadOutputService:(0,r.createProxyIdentifier)("MainThreadOutputService"),MainThreadProgress:(0,r.createProxyIdentifier)("MainThreadProgress"),MainThreadQuickOpen:(0,r.createProxyIdentifier)("MainThreadQuickOpen"),MainThreadStatusBar:(0,r.createProxyIdentifier)("MainThreadStatusBar"),MainThreadSecretState:(0,r.createProxyIdentifier)("MainThreadSecretState"),MainThreadStorage:(0,r.createProxyIdentifier)("MainThreadStorage"),MainThreadTelemetry:(0,r.createProxyIdentifier)("MainThreadTelemetry"),MainThreadTerminalService:(0,r.createProxyIdentifier)("MainThreadTerminalService"),MainThreadWebviews:(0,r.createProxyIdentifier)("MainThreadWebviews"),MainThreadWebviewPanels:(0,r.createProxyIdentifier)("MainThreadWebviewPanels"),MainThreadWebviewViews:(0,r.createProxyIdentifier)("MainThreadWebviewViews"),MainThreadCustomEditors:(0,r.createProxyIdentifier)("MainThreadCustomEditors"),MainThreadUrls:(0,r.createProxyIdentifier)("MainThreadUrls"),MainThreadUriOpeners:(0,r.createProxyIdentifier)("MainThreadUriOpeners"),MainThreadWorkspace:(0,r.createProxyIdentifier)("MainThreadWorkspace"),MainThreadFileSystem:(0,r.createProxyIdentifier)("MainThreadFileSystem"),MainThreadExtensionService:(0,r.createProxyIdentifier)("MainThreadExtensionService"),MainThreadSCM:(0,r.createProxyIdentifier)("MainThreadSCM"),MainThreadSearch:(0,r.createProxyIdentifier)("MainThreadSearch"),MainThreadTask:(0,r.createProxyIdentifier)("MainThreadTask"),MainThreadWindow:(0,r.createProxyIdentifier)("MainThreadWindow"),MainThreadLabelService:(0,r.createProxyIdentifier)("MainThreadLabelService"),MainThreadNotebook:(0,r.createProxyIdentifier)("MainThreadNotebook"),MainThreadNotebookDocuments:(0,r.createProxyIdentifier)("MainThreadNotebookDocumentsShape"),MainThreadNotebookEditors:(0,r.createProxyIdentifier)("MainThreadNotebookEditorsShape"),MainThreadNotebookKernels:(0,r.createProxyIdentifier)("MainThreadNotebookKernels"),MainThreadNotebookRenderers:(0,r.createProxyIdentifier)("MainThreadNotebookRenderers"),MainThreadInteractive:(0,r.createProxyIdentifier)("MainThreadInteractive"),MainThreadTheming:(0,r.createProxyIdentifier)("MainThreadTheming"),MainThreadTunnelService:(0,r.createProxyIdentifier)("MainThreadTunnelService"),MainThreadTimeline:(0,r.createProxyIdentifier)("MainThreadTimeline"),MainThreadTesting:(0,r.createProxyIdentifier)("MainThreadTesting"),MainThreadLocalization:(0,r.createProxyIdentifier)("MainThreadLocalizationShape")},e.ExtHostContext={ExtHostCommands:(0,r.createProxyIdentifier)("ExtHostCommands"),ExtHostConfiguration:(0,r.createProxyIdentifier)("ExtHostConfiguration"),ExtHostDiagnostics:(0,r.createProxyIdentifier)("ExtHostDiagnostics"),ExtHostDebugService:(0,r.createProxyIdentifier)("ExtHostDebugService"),ExtHostDecorations:(0,r.createProxyIdentifier)("ExtHostDecorations"),ExtHostDocumentsAndEditors:(0,r.createProxyIdentifier)("ExtHostDocumentsAndEditors"),ExtHostDocuments:(0,r.createProxyIdentifier)("ExtHostDocuments"),ExtHostDocumentContentProviders:(0,r.createProxyIdentifier)("ExtHostDocumentContentProviders"),ExtHostDocumentSaveParticipant:(0,r.createProxyIdentifier)("ExtHostDocumentSaveParticipant"),ExtHostEditors:(0,r.createProxyIdentifier)("ExtHostEditors"),ExtHostTreeViews:(0,r.createProxyIdentifier)("ExtHostTreeViews"),ExtHostFileSystem:(0,r.createProxyIdentifier)("ExtHostFileSystem"),ExtHostFileSystemInfo:(0,r.createProxyIdentifier)("ExtHostFileSystemInfo"),ExtHostFileSystemEventService:(0,r.createProxyIdentifier)("ExtHostFileSystemEventService"),ExtHostLanguages:(0,r.createProxyIdentifier)("ExtHostLanguages"),ExtHostLanguageFeatures:(0,r.createProxyIdentifier)("ExtHostLanguageFeatures"),ExtHostQuickOpen:(0,r.createProxyIdentifier)("ExtHostQuickOpen"),ExtHostExtensionService:(0,r.createProxyIdentifier)("ExtHostExtensionService"),ExtHostLogLevelServiceShape:(0,r.createProxyIdentifier)("ExtHostLogLevelServiceShape"),ExtHostTerminalService:(0,r.createProxyIdentifier)("ExtHostTerminalService"),ExtHostSCM:(0,r.createProxyIdentifier)("ExtHostSCM"),ExtHostSearch:(0,r.createProxyIdentifier)("ExtHostSearch"),ExtHostTask:(0,r.createProxyIdentifier)("ExtHostTask"),ExtHostWorkspace:(0,r.createProxyIdentifier)("ExtHostWorkspace"),ExtHostWindow:(0,r.createProxyIdentifier)("ExtHostWindow"),ExtHostWebviews:(0,r.createProxyIdentifier)("ExtHostWebviews"),ExtHostWebviewPanels:(0,r.createProxyIdentifier)("ExtHostWebviewPanels"),ExtHostCustomEditors:(0,r.createProxyIdentifier)("ExtHostCustomEditors"),ExtHostWebviewViews:(0,r.createProxyIdentifier)("ExtHostWebviewViews"),ExtHostEditorInsets:(0,r.createProxyIdentifier)("ExtHostEditorInsets"),ExtHostEditorTabs:(0,r.createProxyIdentifier)("ExtHostEditorTabs"),ExtHostProgress:(0,r.createProxyIdentifier)("ExtHostProgress"),ExtHostComments:(0,r.createProxyIdentifier)("ExtHostComments"),ExtHostSecretState:(0,r.createProxyIdentifier)("ExtHostSecretState"),ExtHostStorage:(0,r.createProxyIdentifier)("ExtHostStorage"),ExtHostUrls:(0,r.createProxyIdentifier)("ExtHostUrls"),ExtHostUriOpeners:(0,r.createProxyIdentifier)("ExtHostUriOpeners"),ExtHostOutputService:(0,r.createProxyIdentifier)("ExtHostOutputService"),ExtHosLabelService:(0,r.createProxyIdentifier)("ExtHostLabelService"),ExtHostNotebook:(0,r.createProxyIdentifier)("ExtHostNotebook"),ExtHostNotebookDocuments:(0,r.createProxyIdentifier)("ExtHostNotebookDocuments"),ExtHostNotebookEditors:(0,r.createProxyIdentifier)("ExtHostNotebookEditors"),ExtHostNotebookKernels:(0,r.createProxyIdentifier)("ExtHostNotebookKernels"),ExtHostNotebookRenderers:(0,r.createProxyIdentifier)("ExtHostNotebookRenderers"),ExtHostInteractive:(0,r.createProxyIdentifier)("ExtHostInteractive"),ExtHostTheming:(0,r.createProxyIdentifier)("ExtHostTheming"),ExtHostTunnelService:(0,r.createProxyIdentifier)("ExtHostTunnelService"),ExtHostAuthentication:(0,r.createProxyIdentifier)("ExtHostAuthentication"),ExtHostTimeline:(0,r.createProxyIdentifier)("ExtHostTimeline"),ExtHostTesting:(0,r.createProxyIdentifier)("ExtHostTesting"),ExtHostTelemetry:(0,r.createProxyIdentifier)("ExtHostTelemetry"),ExtHostLocalization:(0,r.createProxyIdentifier)("ExtHostLocalization")}}),define(Ce[67],Ie([1,0,3,14,4,11]),function(ie,e,r,y,S,M){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.NullApiDeprecationService=e.ExtHostApiDeprecationService=e.IExtHostApiDeprecationService=void 0,e.IExtHostApiDeprecationService=(0,r.createDecorator)("IExtHostApiDeprecationService");let _=class{constructor(b,P){this._extHostLogService=P,this._reportedUsages=new Set,this._telemetryShape=b.getProxy(S.MainContext.MainThreadTelemetry)}report(b,P,O){const E=this.getUsageKey(b,P);this._reportedUsages.has(E)||(this._reportedUsages.add(E),P.isUnderDevelopment&&this._extHostLogService.warn(`[Deprecation Warning] '${b}' is deprecated. ${O}`),this._telemetryShape.$publicLog2("extHostDeprecatedApiUsage",{extensionId:P.identifier.value,apiId:b}))}getUsageKey(b,P){return`${b}-${P.identifier.value}`}};_=ze([$e(0,M.IExtHostRpcService),$e(1,y.ILogService)],_),e.ExtHostApiDeprecationService=_,e.NullApiDeprecationService=Object.freeze(new class{report(A,b,P){}})}),define(Ce[187],Ie([1,0,5,4,6,27]),function(ie,e,r,y,S,M){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtHostAuthentication=void 0;class _{constructor(b){this._authenticationProviders=new Map,this._providers=[],this._onDidChangeSessions=new r.Emitter,this.onDidChangeSessions=this._onDidChangeSessions.event,this._inFlightRequests=new Map,this._proxy=b.getProxy(y.MainContext.MainThreadAuthentication)}$setProviders(b){return this._providers=b,Promise.resolve()}async getSession(b,P,O,E={}){const m=M.ExtensionIdentifier.toKey(b.identifier),k=this._inFlightRequests.get(m)||[],f=[...O].sort().join(" ");let c=k.find(d=>d.providerId===P&&d.scopes===f);if(c)return c.result;{const d=this._getSession(b,m,P,O,E);c={providerId:P,scopes:f,result:d},k.push(c),this._inFlightRequests.set(m,k);try{await d}finally{const h=k.findIndex(g=>g.providerId===P&&g.scopes===f);h>-1&&(k.splice(h),this._inFlightRequests.set(m,k))}return d}}async _getSession(b,P,O,E,m={}){await this._proxy.$ensureProvider(O);const k=b.displayName||b.name;return this._proxy.$getSession(O,E,P,k,m)}async removeSession(b,P){const O=this._authenticationProviders.get(b);return O?O.provider.removeSession(P):this._proxy.$removeSession(b,P)}registerAuthenticationProvider(b,P,O,E){if(this._authenticationProviders.get(b))throw new Error(`An authentication provider with id '${b}' is already registered.`);this._authenticationProviders.set(b,{label:P,provider:O,options:E??{supportsMultipleAccounts:!1}}),this._providers.find(k=>k.id===b)||this._providers.push({id:b,label:P});const m=O.onDidChangeSessions(k=>{this._proxy.$sendDidChangeSessions(b,{added:k.added??[],changed:k.changed??[],removed:k.removed??[]})});return this._proxy.$registerAuthenticationProvider(b,P,E?.supportsMultipleAccounts??!1),new S.Disposable(()=>{m.dispose(),this._authenticationProviders.delete(b);const k=this._providers.findIndex(f=>f.id===b);k>-1&&this._providers.splice(k),this._proxy.$unregisterAuthenticationProvider(b)})}$createSession(b,P){const O=this._authenticationProviders.get(b);if(O)return Promise.resolve(O.provider.createSession(P));throw new Error(`Unable to find authentication provider with handle: ${b}`)}$removeSession(b,P){const O=this._authenticationProviders.get(b);if(O)return Promise.resolve(O.provider.removeSession(P));throw new Error(`Unable to find authentication provider with handle: ${b}`)}$getSessions(b,P){const O=this._authenticationProviders.get(b);if(O)return Promise.resolve(O.provider.getSessions(P));throw new Error(`Unable to find authentication provider with handle: ${b}`)}$onDidChangeAuthenticationSessions(b,P){return this._onDidChangeSessions.fire({provider:{id:b,label:P}}),Promise.resolve()}}e.ExtHostAuthentication=_}),define(Ce[188],Ie([1,0,4,11,8,25]),function(ie,e,r,y,S,M){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtHostBulkEdits=void 0;let _=class{constructor(b,P){this._proxy=b.getProxy(r.MainContext.MainThreadBulkEdits),this._versionInformationProvider={getTextDocumentVersion:O=>P.getDocument(O)?.version,getNotebookDocumentVersion:()=>{}}}applyWorkspaceEdit(b,P,O){const E=(0,M.isProposedApiEnabled)(P,"workspaceEditIsRefactoring");O&&!E&&(console.warn(`Extension '${P.identifier.value}' uses a proposed API 'workspaceEditIsRefactoring' which is NOT enabled for it`),O=void 0);const m=S.WorkspaceEdit.from(b,this._versionInformationProvider);return this._proxy.$tryApplyWorkspaceEdit(m,void 0,O?.isRefactoring??!1)}};_=ze([$e(0,y.IExtHostRpcService)],_),e.ExtHostBulkEdits=_}),define(Ce[189],Ie([1,0,4]),function(ie,e,r){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtHostClipboard=void 0;class y{constructor(M){const _=M.getProxy(r.MainContext.MainThreadClipboard);this.value=Object.freeze({readText(){return _.$readText()},writeText(A){return _.$writeText(A)}})}}e.ExtHostClipboard=y});var Je=this&&this.__classPrivateFieldSet||function(ie,e,r,y,S){if(y==="m")throw new TypeError("Private method is not writable");if(y==="a"&&!S)throw new TypeError("Private accessor was defined without a setter");if(typeof e=="function"?ie!==e||!S:!e.has(ie))throw new TypeError("Cannot write private member to an object whose class did not declare it");return y==="a"?S.call(ie,r):S?S.value=r:e.set(ie,r),r},Oe=this&&this.__classPrivateFieldGet||function(ie,e,r,y){if(r==="a"&&!y)throw new TypeError("Private accessor was defined without a getter");if(typeof e=="function"?ie!==e||!y:!e.has(ie))throw new TypeError("Cannot read private member from an object whose class did not declare it");return r==="m"?y:r==="a"?y.call(ie):y?y.value:e.get(ie)};define(Ce[37],Ie([1,0,10,6,8,26,4,18,14,76,49,243,2,7,3,11,95,23,40,43]),function(ie,e,r,y,S,M,_,A,b,P,O,E,m,k,f,c,d,h,g,C){"use strict";var l,w;Object.defineProperty(e,"__esModule",{value:!0}),e.ApiCommand=e.ApiCommandResult=e.ApiCommandArgument=e.CommandsConverter=e.IExtHostCommands=e.ExtHostCommands=void 0;let t=class{constructor(o,v){l.set(this,void 0),this._commands=new Map,this._apiCommands=new Map,w.set(this,void 0),Je(this,l,o.getProxy(_.MainContext.MainThreadCommands),"f"),this._logService=v,Je(this,w,o.getProxy(_.MainContext.MainThreadTelemetry),"f"),this.converter=new u(this,p=>{const T=this._apiCommands.get(p);return T?.result===n.Void?T:void 0},v),this._argumentProcessors=[{processArgument(p){return(0,P.revive)(p)}},{processArgument(p){return(0,M.cloneAndChange)(p,function(T){if(O.Range.isIRange(T))return S.Range.to(T);if(E.Position.isIPosition(T))return S.Position.to(T);if(O.Range.isIRange(T.range)&&m.URI.isUri(T.uri))return S.location.to(T);if(T instanceof h.VSBuffer)return T.buffer.buffer;if(!Array.isArray(T))return T})}}]}registerArgumentProcessor(o){this._argumentProcessors.push(o)}registerApiCommand(o){const v=this.registerCommand(!1,o.id,async(...p)=>{const T=o.args.map((V,B)=>{if(!V.validate(p[B]))throw new Error(`Invalid argument '${V.name}' when running '${o.id}', received: ${p[B]}`);return V.convert(p[B])}),N=await this.executeCommand(o.internalId,...T);return o.result.convert(N,p,this.converter)},void 0,{description:o.description,args:o.args,returns:o.result.description});return this._apiCommands.set(o.id,o),new y.Disposable(()=>{v.dispose(),this._apiCommands.delete(o.id)})}registerCommand(o,v,p,T,N,V){if(this._logService.trace("ExtHostCommands#registerCommand",v),!v.trim().length)throw new Error("invalid id");if(this._commands.has(v))throw new Error(`command '${v}' already exists`);return this._commands.set(v,{callback:p,thisArg:T,description:N,extension:V}),o&&Oe(this,l,"f").$registerCommand(v),new y.Disposable(()=>{this._commands.delete(v)&&o&&Oe(this,l,"f").$unregisterCommand(v)})}executeCommand(o,...v){return this._logService.trace("ExtHostCommands#executeCommand",o),this._doExecuteCommand(o,v,!0)}async _doExecuteCommand(o,v,p){if(this._commands.has(o))return Oe(this,l,"f").$fireCommandActivationEvent(o),this._executeContributedCommand(o,v,!1);{let T=!1;const N=(0,M.cloneAndChange)(v,function(V){if(V instanceof y.Position)return S.Position.from(V);if(V instanceof y.Range)return S.Range.from(V);if(V instanceof y.Location)return S.location.from(V);if(y.NotebookRange.isNotebookRange(V))return S.NotebookRange.from(V);if(V instanceof ArrayBuffer)return T=!0,h.VSBuffer.wrap(new Uint8Array(V));if(V instanceof Uint8Array)return T=!0,h.VSBuffer.wrap(V);if(V instanceof h.VSBuffer)return T=!0,V;if(!Array.isArray(V))return V});try{const V=await Oe(this,l,"f").$executeCommand(o,T?new g.SerializableObjectWithBuffers(N):N,p);return(0,P.revive)(V)}catch(V){if(V instanceof Error&&V.message==="$executeCommand:retry")return this._doExecuteCommand(o,v,!1);throw V}}}async _executeContributedCommand(o,v,p){const T=this._commands.get(o);if(!T)throw new Error("Unknown command");this._reportTelemetry(T,o);const{callback:N,thisArg:V,description:B}=T;if(B)for(let D=0;D<B.args.length;D++)try{(0,r.validateConstraint)(v[D],B.args[D].constraint)}catch{throw new Error(`Running the contributed command: '${o}' failed. Illegal argument '${B.args[D].name}' - ${B.args[D].description}`)}try{return await N.apply(V,v)}catch(D){if(o===this.converter.delegatingCommandId){const z=this.converter.getActualCommand(...v);z&&(o=z.command)}throw this._logService.error(D,o,T.extension?.identifier),p?new class extends Error{constructor(){super((0,C.toErrorMessage)(D)),this.id=o,this.source=T.extension?.displayName??T.extension?.name}}:D}}_reportTelemetry(o,v){!o.extension||o.extension.isBuiltin||Oe(this,w,"f").$publicLog2("Extension:ActionExecuted",{extensionId:o.extension.identifier.value,id:v})}$executeContributedCommand(o,...v){return this._logService.trace("ExtHostCommands#$executeContributedCommand",o),this._commands.has(o)?(v=v.map(p=>this._argumentProcessors.reduce((T,N)=>N.processArgument(T),p)),this._executeContributedCommand(o,v,!0)):Promise.reject(new Error(`Contributed command '${o}' does not exist.`))}getCommands(o=!1){return this._logService.trace("ExtHostCommands#getCommands",o),Oe(this,l,"f").$getCommands().then(v=>(o&&(v=v.filter(p=>p[0]!=="_")),v))}$getContributedCommandHandlerDescriptions(){const o=Object.create(null);for(const[v,p]of this._commands){const{description:T}=p;T&&(o[v]=T)}return Promise.resolve(o)}};l=new WeakMap,w=new WeakMap,t=ze([$e(0,c.IExtHostRpcService),$e(1,b.ILogService)],t),e.ExtHostCommands=t,e.IExtHostCommands=(0,f.createDecorator)("IExtHostCommands");class u{constructor(o,v,p){this._commands=o,this._lookupApiCommand=v,this._logService=p,this.delegatingCommandId=`_vscode_delegate_cmd_${Date.now().toString(36)}`,this._cache=new Map,this._cachIdPool=0,this._commands.registerCommand(!0,this.delegatingCommandId,this._executeConvertedCommand,this)}toInternal(o,v){if(!o)return;const p={$ident:void 0,id:o.command,title:o.title,tooltip:o.tooltip};if(!o.command)return p;const T=this._lookupApiCommand(o.command);if(T)p.id=T.internalId,p.arguments=T.args.map((N,V)=>N.convert(o.arguments&&o.arguments[V]));else if((0,A.isNonEmptyArray)(o.arguments)){const N=++this._cachIdPool;this._cache.set(N,o),v.add((0,k.toDisposable)(()=>{this._cache.delete(N),this._logService.trace("CommandsConverter#DISPOSE",N)})),p.$ident=N,p.id=this.delegatingCommandId,p.arguments=[N],this._logService.trace("CommandsConverter#CREATE",o.command,N)}return p}fromInternal(o){return typeof o.$ident=="number"?this._cache.get(o.$ident):{command:o.id,title:o.title,arguments:o.arguments}}getActualCommand(...o){return this._cache.get(o[0])}_executeConvertedCommand(...o){const v=this.getActualCommand(...o);return this._logService.trace("CommandsConverter#EXECUTE",o[0],v?v.command:"MISSING"),v?this._commands.executeCommand(v.command,...v.arguments||[]):Promise.reject("actual command NOT FOUND")}}e.CommandsConverter=u;class i{constructor(o,v,p,T){this.name=o,this.description=v,this.validate=p,this.convert=T}optional(){return new i(this.name,`(optional) ${this.description}`,o=>o==null||this.validate(o),o=>o===void 0?void 0:o===null?null:this.convert(o))}with(o,v){return new i(o??this.name,v??this.description,this.validate,this.convert)}}e.ApiCommandArgument=i,i.Uri=new i("uri","Uri of a text document",a=>m.URI.isUri(a),a=>a),i.Position=new i("position","A position in a text document",a=>y.Position.isPosition(a),S.Position.from),i.Range=new i("range","A range in a text document",a=>y.Range.isRange(a),S.Range.from),i.Selection=new i("selection","A selection in a text document",a=>y.Selection.isSelection(a),S.Selection.from),i.Number=new i("number","",a=>typeof a=="number",a=>a),i.String=new i("string","",a=>typeof a=="string",a=>a),i.CallHierarchyItem=new i("item","A call hierarchy item",a=>a instanceof y.CallHierarchyItem,S.CallHierarchyItem.from),i.TypeHierarchyItem=new i("item","A type hierarchy item",a=>a instanceof y.TypeHierarchyItem,S.TypeHierarchyItem.from),i.TestItem=new i("testItem","A VS Code TestItem",a=>a instanceof d.TestItemImpl,S.TestItem.from);class n{constructor(o,v){this.description=o,this.convert=v}}e.ApiCommandResult=n,n.Void=new n("no result",a=>a);class s{constructor(o,v,p,T,N){this.id=o,this.internalId=v,this.description=p,this.args=T,this.result=N}}e.ApiCommand=s}),define(Ce[190],Ie([1,0,2,8,6,66,37,18,79,83,13]),function(ie,e,r,y,S,M,_,A,b,P,O){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtHostApiCommands=void 0;const E=[new _.ApiCommand("vscode.executeDocumentHighlights","_executeDocumentHighlights","Execute document highlight provider.",[_.ApiCommandArgument.Uri,_.ApiCommandArgument.Position],new _.ApiCommandResult("A promise that resolves to an array of DocumentHighlight-instances.",k(y.DocumentHighlight.to))),new _.ApiCommand("vscode.executeDocumentSymbolProvider","_executeDocumentSymbolProvider","Execute document symbol provider.",[_.ApiCommandArgument.Uri],new _.ApiCommandResult("A promise that resolves to an array of SymbolInformation and DocumentSymbol instances.",(c,d)=>{if((0,A.isFalsyOrEmpty)(c))return;class h extends S.SymbolInformation{static to(C){const l=new h(C.name,y.SymbolKind.to(C.kind),C.containerName||"",new S.Location(d[0],y.Range.to(C.range)));return l.detail=C.detail,l.range=l.location.range,l.selectionRange=y.Range.to(C.selectionRange),l.children=C.children?C.children.map(h.to):[],l}}return c.map(h.to)})),new _.ApiCommand("vscode.executeFormatDocumentProvider","_executeFormatDocumentProvider","Execute document format provider.",[_.ApiCommandArgument.Uri,new _.ApiCommandArgument("options","Formatting options",c=>!0,c=>c)],new _.ApiCommandResult("A promise that resolves to an array of TextEdits.",k(y.TextEdit.to))),new _.ApiCommand("vscode.executeFormatRangeProvider","_executeFormatRangeProvider","Execute range format provider.",[_.ApiCommandArgument.Uri,_.ApiCommandArgument.Range,new _.ApiCommandArgument("options","Formatting options",c=>!0,c=>c)],new _.ApiCommandResult("A promise that resolves to an array of TextEdits.",k(y.TextEdit.to))),new _.ApiCommand("vscode.executeFormatOnTypeProvider","_executeFormatOnTypeProvider","Execute format on type provider.",[_.ApiCommandArgument.Uri,_.ApiCommandArgument.Position,new _.ApiCommandArgument("ch","Trigger character",c=>typeof c=="string",c=>c),new _.ApiCommandArgument("options","Formatting options",c=>!0,c=>c)],new _.ApiCommandResult("A promise that resolves to an array of TextEdits.",k(y.TextEdit.to))),new _.ApiCommand("vscode.executeDefinitionProvider","_executeDefinitionProvider","Execute all definition providers.",[_.ApiCommandArgument.Uri,_.ApiCommandArgument.Position],new _.ApiCommandResult("A promise that resolves to an array of Location or LocationLink instances.",f)),new _.ApiCommand("vscode.executeTypeDefinitionProvider","_executeTypeDefinitionProvider","Execute all type definition providers.",[_.ApiCommandArgument.Uri,_.ApiCommandArgument.Position],new _.ApiCommandResult("A promise that resolves to an array of Location or LocationLink instances.",f)),new _.ApiCommand("vscode.executeDeclarationProvider","_executeDeclarationProvider","Execute all declaration providers.",[_.ApiCommandArgument.Uri,_.ApiCommandArgument.Position],new _.ApiCommandResult("A promise that resolves to an array of Location or LocationLink instances.",f)),new _.ApiCommand("vscode.executeImplementationProvider","_executeImplementationProvider","Execute all implementation providers.",[_.ApiCommandArgument.Uri,_.ApiCommandArgument.Position],new _.ApiCommandResult("A promise that resolves to an array of Location or LocationLink instances.",f)),new _.ApiCommand("vscode.executeReferenceProvider","_executeReferenceProvider","Execute all reference providers.",[_.ApiCommandArgument.Uri,_.ApiCommandArgument.Position],new _.ApiCommandResult("A promise that resolves to an array of Location-instances.",k(y.location.to))),new _.ApiCommand("vscode.executeHoverProvider","_executeHoverProvider","Execute all hover providers.",[_.ApiCommandArgument.Uri,_.ApiCommandArgument.Position],new _.ApiCommandResult("A promise that resolves to an array of Hover-instances.",k(y.Hover.to))),new _.ApiCommand("vscode.executeSelectionRangeProvider","_executeSelectionRangeProvider","Execute selection range provider.",[_.ApiCommandArgument.Uri,new _.ApiCommandArgument("position","A position in a text document",c=>Array.isArray(c)&&c.every(d=>S.Position.isPosition(d)),c=>c.map(y.Position.from))],new _.ApiCommandResult("A promise that resolves to an array of ranges.",c=>c.map(d=>{let h;for(const g of d.reverse())h=new S.SelectionRange(y.Range.to(g),h);return h}))),new _.ApiCommand("vscode.executeWorkspaceSymbolProvider","_executeWorkspaceSymbolProvider","Execute all workspace symbol providers.",[_.ApiCommandArgument.String.with("query","Search string")],new _.ApiCommandResult("A promise that resolves to an array of SymbolInformation-instances.",c=>c.map(y.WorkspaceSymbol.to))),new _.ApiCommand("vscode.prepareCallHierarchy","_executePrepareCallHierarchy","Prepare call hierarchy at a position inside a document",[_.ApiCommandArgument.Uri,_.ApiCommandArgument.Position],new _.ApiCommandResult("A CallHierarchyItem or undefined",c=>c.map(y.CallHierarchyItem.to))),new _.ApiCommand("vscode.provideIncomingCalls","_executeProvideIncomingCalls","Compute incoming calls for an item",[_.ApiCommandArgument.CallHierarchyItem],new _.ApiCommandResult("A CallHierarchyItem or undefined",c=>c.map(y.CallHierarchyIncomingCall.to))),new _.ApiCommand("vscode.provideOutgoingCalls","_executeProvideOutgoingCalls","Compute outgoing calls for an item",[_.ApiCommandArgument.CallHierarchyItem],new _.ApiCommandResult("A CallHierarchyItem or undefined",c=>c.map(y.CallHierarchyOutgoingCall.to))),new _.ApiCommand("vscode.prepareRename","_executePrepareRename","Execute the prepareRename of rename provider.",[_.ApiCommandArgument.Uri,_.ApiCommandArgument.Position],new _.ApiCommandResult("A promise that resolves to a range and placeholder text.",c=>{if(!!c)return{range:y.Range.to(c.range),placeholder:c.text}})),new _.ApiCommand("vscode.executeDocumentRenameProvider","_executeDocumentRenameProvider","Execute rename provider.",[_.ApiCommandArgument.Uri,_.ApiCommandArgument.Position,_.ApiCommandArgument.String.with("newName","The new symbol name")],new _.ApiCommandResult("A promise that resolves to a WorkspaceEdit.",c=>{if(!!c){if(c.rejectReason)throw new Error(c.rejectReason);return y.WorkspaceEdit.to(c)}})),new _.ApiCommand("vscode.executeLinkProvider","_executeLinkProvider","Execute document link provider.",[_.ApiCommandArgument.Uri,_.ApiCommandArgument.Number.with("linkResolveCount","Number of links that should be resolved, only when links are unresolved.").optional()],new _.ApiCommandResult("A promise that resolves to an array of DocumentLink-instances.",c=>c.map(y.DocumentLink.to))),new _.ApiCommand("vscode.provideDocumentSemanticTokensLegend","_provideDocumentSemanticTokensLegend","Provide semantic tokens legend for a document",[_.ApiCommandArgument.Uri],new _.ApiCommandResult("A promise that resolves to SemanticTokensLegend.",c=>{if(!!c)return new S.SemanticTokensLegend(c.tokenTypes,c.tokenModifiers)})),new _.ApiCommand("vscode.provideDocumentSemanticTokens","_provideDocumentSemanticTokens","Provide semantic tokens for a document",[_.ApiCommandArgument.Uri],new _.ApiCommandResult("A promise that resolves to SemanticTokens.",c=>{if(!c)return;const d=(0,b.decodeSemanticTokensDto)(c);if(d.type==="full")return new S.SemanticTokens(d.data,void 0)})),new _.ApiCommand("vscode.provideDocumentRangeSemanticTokensLegend","_provideDocumentRangeSemanticTokensLegend","Provide semantic tokens legend for a document range",[_.ApiCommandArgument.Uri,_.ApiCommandArgument.Range.optional()],new _.ApiCommandResult("A promise that resolves to SemanticTokensLegend.",c=>{if(!!c)return new S.SemanticTokensLegend(c.tokenTypes,c.tokenModifiers)})),new _.ApiCommand("vscode.provideDocumentRangeSemanticTokens","_provideDocumentRangeSemanticTokens","Provide semantic tokens for a document range",[_.ApiCommandArgument.Uri,_.ApiCommandArgument.Range],new _.ApiCommandResult("A promise that resolves to SemanticTokens.",c=>{if(!c)return;const d=(0,b.decodeSemanticTokensDto)(c);if(d.type==="full")return new S.SemanticTokens(d.data,void 0)})),new _.ApiCommand("vscode.executeCompletionItemProvider","_executeCompletionItemProvider","Execute completion item provider.",[_.ApiCommandArgument.Uri,_.ApiCommandArgument.Position,_.ApiCommandArgument.String.with("triggerCharacter","Trigger completion when the user types the character, like `,` or `(`").optional(),_.ApiCommandArgument.Number.with("itemResolveCount","Number of completions to resolve (too large numbers slow down completions)").optional()],new _.ApiCommandResult("A promise that resolves to a CompletionList-instance.",(c,d,h)=>{if(!c)return new S.CompletionList([]);const g=c.suggestions.map(C=>y.CompletionItem.to(C,h));return new S.CompletionList(g,c.incomplete)})),new _.ApiCommand("vscode.executeSignatureHelpProvider","_executeSignatureHelpProvider","Execute signature help provider.",[_.ApiCommandArgument.Uri,_.ApiCommandArgument.Position,_.ApiCommandArgument.String.with("triggerCharacter","Trigger signature help when the user types the character, like `,` or `(`").optional()],new _.ApiCommandResult("A promise that resolves to SignatureHelp.",c=>{if(c)return y.SignatureHelp.to(c)})),new _.ApiCommand("vscode.executeCodeLensProvider","_executeCodeLensProvider","Execute code lens provider.",[_.ApiCommandArgument.Uri,_.ApiCommandArgument.Number.with("itemResolveCount","Number of lenses that should be resolved and returned. Will only return resolved lenses, will impact performance)").optional()],new _.ApiCommandResult("A promise that resolves to an array of CodeLens-instances.",(c,d,h)=>k(g=>new S.CodeLens(y.Range.to(g.range),g.command&&h.fromInternal(g.command)))(c))),new _.ApiCommand("vscode.executeCodeActionProvider","_executeCodeActionProvider","Execute code action provider.",[_.ApiCommandArgument.Uri,new _.ApiCommandArgument("rangeOrSelection","Range in a text document. Some refactoring provider requires Selection object.",c=>S.Range.isRange(c),c=>S.Selection.isSelection(c)?y.Selection.from(c):y.Range.from(c)),_.ApiCommandArgument.String.with("kind","Code action kind to return code actions for").optional(),_.ApiCommandArgument.Number.with("itemResolveCount","Number of code actions to resolve (too large numbers slow down code actions)").optional()],new _.ApiCommandResult("A promise that resolves to an array of Command-instances.",(c,d,h)=>k(g=>{if(g._isSynthetic){if(!g.command)throw new Error("Synthetic code actions must have a command");return h.fromInternal(g.command)}else{const C=new S.CodeAction(g.title,g.kind?new S.CodeActionKind(g.kind):void 0);return g.edit&&(C.edit=y.WorkspaceEdit.to(g.edit)),g.command&&(C.command=h.fromInternal(g.command)),C.isPreferred=g.isPreferred,C}})(c))),new _.ApiCommand("vscode.executeDocumentColorProvider","_executeDocumentColorProvider","Execute document color provider.",[_.ApiCommandArgument.Uri],new _.ApiCommandResult("A promise that resolves to an array of ColorInformation objects.",c=>c?c.map(d=>new S.ColorInformation(y.Range.to(d.range),y.Color.to(d.color))):[])),new _.ApiCommand("vscode.executeColorPresentationProvider","_executeColorPresentationProvider","Execute color presentation provider.",[new _.ApiCommandArgument("color","The color to show and insert",c=>c instanceof S.Color,y.Color.from),new _.ApiCommandArgument("context","Context object with uri and range",c=>!0,c=>({uri:c.uri,range:y.Range.from(c.range)}))],new _.ApiCommandResult("A promise that resolves to an array of ColorPresentation objects.",c=>c?c.map(y.ColorPresentation.to):[])),new _.ApiCommand("vscode.executeInlayHintProvider","_executeInlayHintProvider","Execute inlay hints provider",[_.ApiCommandArgument.Uri,_.ApiCommandArgument.Range],new _.ApiCommandResult("A promise that resolves to an array of Inlay objects",(c,d,h)=>c.map(y.InlayHint.to.bind(void 0,h)))),new _.ApiCommand("vscode.resolveNotebookContentProviders","_resolveNotebookContentProvider","Resolve Notebook Content Providers",[],new _.ApiCommandResult("A promise that resolves to an array of NotebookContentProvider static info objects.",k(c=>({viewType:c.viewType,displayName:c.displayName,options:{transientOutputs:c.options.transientOutputs,transientCellMetadata:c.options.transientCellMetadata,transientDocumentMetadata:c.options.transientDocumentMetadata},filenamePattern:c.filenamePattern.map(d=>y.NotebookExclusiveDocumentPattern.to(d))})))),new _.ApiCommand("vscode.executeInlineValueProvider","_executeInlineValueProvider","Execute inline value provider",[_.ApiCommandArgument.Uri,_.ApiCommandArgument.Range],new _.ApiCommandResult("A promise that resolves to an array of InlineValue objects",c=>c.map(y.InlineValue.to))),new _.ApiCommand("vscode.open","_workbench.open","Opens the provided resource in the editor. Can be a text or binary file, or an http(s) URL. If you need more control over the options for opening a text file, use vscode.window.showTextDocument instead.",[new _.ApiCommandArgument("uriOrString","Uri-instance or string (only http/https)",c=>r.URI.isUri(c)||typeof c=="string"&&(0,P.matchesSomeScheme)(c,O.Schemas.http,O.Schemas.https),c=>c),new _.ApiCommandArgument("columnOrOptions","Either the column in which to open or editor options, see vscode.TextDocumentShowOptions",c=>c===void 0||typeof c=="number"||typeof c=="object",c=>c&&(typeof c=="number"?[y.ViewColumn.from(c),void 0]:[y.ViewColumn.from(c.viewColumn),y.TextEditorOpenOptions.from(c)])).optional(),_.ApiCommandArgument.String.with("label","").optional()],_.ApiCommandResult.Void),new _.ApiCommand("vscode.openWith","_workbench.openWith","Opens the provided resource with a specific editor.",[_.ApiCommandArgument.Uri.with("resource","Resource to open"),_.ApiCommandArgument.String.with("viewId","Custom editor view id or 'default' to use VS Code's default editor"),new _.ApiCommandArgument("columnOrOptions","Either the column in which to open or editor options, see vscode.TextDocumentShowOptions",c=>c===void 0||typeof c=="number"||typeof c=="object",c=>c&&(typeof c=="number"?[y.ViewColumn.from(c),void 0]:[y.ViewColumn.from(c.viewColumn),y.TextEditorOpenOptions.from(c)])).optional()],_.ApiCommandResult.Void),new _.ApiCommand("vscode.diff","_workbench.diff","Opens the provided resources in the diff editor to compare their contents.",[_.ApiCommandArgument.Uri.with("left","Left-hand side resource of the diff editor"),_.ApiCommandArgument.Uri.with("right","Right-hand side resource of the diff editor"),_.ApiCommandArgument.String.with("title","Human readable title for the diff editor").optional(),new _.ApiCommandArgument("columnOrOptions","Either the column in which to open or editor options, see vscode.TextDocumentShowOptions",c=>c===void 0||typeof c=="object",c=>c&&[y.ViewColumn.from(c.viewColumn),y.TextEditorOpenOptions.from(c)]).optional()],_.ApiCommandResult.Void),new _.ApiCommand("vscode.prepareTypeHierarchy","_executePrepareTypeHierarchy","Prepare type hierarchy at a position inside a document",[_.ApiCommandArgument.Uri,_.ApiCommandArgument.Position],new _.ApiCommandResult("A TypeHierarchyItem or undefined",c=>c.map(y.TypeHierarchyItem.to))),new _.ApiCommand("vscode.provideSupertypes","_executeProvideSupertypes","Compute supertypes for an item",[_.ApiCommandArgument.TypeHierarchyItem],new _.ApiCommandResult("A TypeHierarchyItem or undefined",c=>c.map(y.TypeHierarchyItem.to))),new _.ApiCommand("vscode.provideSubtypes","_executeProvideSubtypes","Compute subtypes for an item",[_.ApiCommandArgument.TypeHierarchyItem],new _.ApiCommandResult("A TypeHierarchyItem or undefined",c=>c.map(y.TypeHierarchyItem.to))),new _.ApiCommand("vscode.revealTestInExplorer","_revealTestInExplorer","Reveals a test instance in the explorer",[_.ApiCommandArgument.TestItem],_.ApiCommandResult.Void),new _.ApiCommand("vscode.experimental.editSession.continue","_workbench.experimental.editSessions.actions.continueEditSession","Continue the current edit session in a different workspace",[_.ApiCommandArgument.Uri.with("workspaceUri","The target workspace to continue the current edit session in")],_.ApiCommandResult.Void)];class m{static register(d){E.forEach(d.registerApiCommand,d)}}e.ExtHostApiCommands=m;function k(c){return d=>{if(Array.isArray(d))return d.map(c)}}function f(c){if(!Array.isArray(c))return;const d=[];for(const h of c)M.isLocationLink(h)?d.push(y.DefinitionLink.to(h)):d.push(y.location.to(h));return d}}),define(Ce[191],Ie([1,0,15,55,5,7,2,66,27,8,6,25,4]),function(ie,e,r,y,S,M,_,A,b,P,O,E,m){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.createExtHostComments=void 0;function k(f,c,d){const h=f.getProxy(m.MainContext.MainThreadComments);class g{constructor(){this._commentControllers=new Map,this._commentControllersByExtension=new Map,c.registerArgumentProcessor({processArgument:a=>{if(a&&a.$mid===6){const o=this._commentControllers.get(a.handle);return o?o.value:a}else if(a&&a.$mid===7){const o=this._commentControllers.get(a.commentControlHandle);if(!o)return a;const v=o.getCommentThread(a.commentThreadHandle);return v?v.value:a}else if(a&&a.$mid===8){const o=this._commentControllers.get(a.thread.commentControlHandle);if(!o)return a;const v=o.getCommentThread(a.thread.commentThreadHandle);return v?{thread:v.value,text:a.text}:a}else if(a&&a.$mid===9){const o=this._commentControllers.get(a.thread.commentControlHandle);if(!o)return a;const v=o.getCommentThread(a.thread.commentThreadHandle);if(!v)return a;const p=a.commentUniqueId,T=v.getCommentByUniqueId(p);return T||a}else if(a&&a.$mid===10){const o=this._commentControllers.get(a.thread.commentControlHandle);if(!o)return a;const v=o.getCommentThread(a.thread.commentThreadHandle);if(!v)return a;const p=a.text,T=a.commentUniqueId,N=v.getCommentByUniqueId(T);return N?(typeof N.body=="string"?N.body=p:N.body.value=p,N):a}return a}})}createCommentController(a,o,v){const p=g.handlePool++,T=new l(a,p,o,v);this._commentControllers.set(T.handle,T);const N=this._commentControllersByExtension.get(b.ExtensionIdentifier.toKey(a.identifier))||[];return N.push(T),this._commentControllersByExtension.set(b.ExtensionIdentifier.toKey(a.identifier),N),T.value}$createCommentThreadTemplate(a,o,v){const p=this._commentControllers.get(a);!p||p.$createCommentThreadTemplate(o,v)}async $updateCommentThreadTemplate(a,o,v){const p=this._commentControllers.get(a);!p||p.$updateCommentThreadTemplate(o,v)}$deleteCommentThread(a,o){this._commentControllers.get(a)?.$deleteCommentThread(o)}$provideCommentingRanges(a,o,v){const p=this._commentControllers.get(a);if(!p||!p.commentingRangeProvider)return Promise.resolve(void 0);const T=d.getDocument(_.URI.revive(o));return(0,r.asPromise)(()=>p.commentingRangeProvider.provideCommentingRanges(T,v)).then(N=>N?N.map(V=>P.Range.from(V)):void 0)}$toggleReaction(a,o,v,p,T){const N=this._commentControllers.get(a);return!N||!N.reactionHandler?Promise.resolve(void 0):(0,r.asPromise)(()=>{const V=N.getCommentThread(o);if(V){const B=V.getCommentByUniqueId(p.uniqueIdInThread);if(N!==void 0&&B&&N.reactionHandler)return N.reactionHandler(B,u(T))}return Promise.resolve(void 0)})}dispose(){}}g.handlePool=0;class C{set threadId(a){this._id=a}get threadId(){return this._id}get id(){return this._id}get resource(){return this._uri}get uri(){return this._uri}set range(a){a.isEqual(this._range)||(this._range=a,this.modifications.range=a,this._onDidUpdateCommentThread.fire())}get range(){return this._range}set canReply(a){this._canReply!==a&&(this._canReply=a,this.modifications.canReply=a,this._onDidUpdateCommentThread.fire())}get canReply(){return this._canReply}get label(){return this._label}set label(a){this._label=a,this.modifications.label=a,this._onDidUpdateCommentThread.fire()}get contextValue(){return this._contextValue}set contextValue(a){this._contextValue=a,this.modifications.contextValue=a,this._onDidUpdateCommentThread.fire()}get comments(){return this._comments}set comments(a){this._comments=a,this.modifications.comments=a,this._onDidUpdateCommentThread.fire()}get collapsibleState(){return this._collapseState}set collapsibleState(a){this._collapseState=a,this.modifications.collapsibleState=a,this._onDidUpdateCommentThread.fire()}get state(){return(0,E.checkProposedApiEnabled)(this.extensionDescription,"commentsResolvedState"),this._state}set state(a){(0,E.checkProposedApiEnabled)(this.extensionDescription,"commentsResolvedState"),this._state=a,this.modifications.state=a,this._onDidUpdateCommentThread.fire()}get isDisposed(){return this._isDiposed}constructor(a,o,v,p,T,N,V,B){this._commentControllerHandle=o,this._id=v,this._uri=p,this._range=T,this._comments=N,this.extensionDescription=V,this._isTemplate=B,this.handle=C._handlePool++,this.commentHandle=0,this.modifications=Object.create(null),this._onDidUpdateCommentThread=new S.Emitter,this.onDidUpdateCommentThread=this._onDidUpdateCommentThread.event,this._canReply=!0,this._commentsMap=new Map,this._acceptInputDisposables=new M.MutableDisposable,this._acceptInputDisposables.value=new M.DisposableStore,this._id===void 0&&(this._id=`${a}.${this.handle}`),h.$createCommentThread(o,this.handle,this._id,this._uri,P.Range.from(this._range),V.identifier,this._isTemplate),this._localDisposables=[],this._isDiposed=!1,this._localDisposables.push(this.onDidUpdateCommentThread(()=>{this.eventuallyUpdateCommentThread()})),this.comments=N,this._localDisposables.push({dispose:()=>{h.$deleteCommentThread(o,this.handle)}});const D=this;this.value={get uri(){return D.uri},get range(){return D.range},set range(z){D.range=z},get comments(){return D.comments},set comments(z){D.comments=z},get collapsibleState(){return D.collapsibleState},set collapsibleState(z){D.collapsibleState=z},get canReply(){return D.canReply},set canReply(z){D.canReply=z},get contextValue(){return D.contextValue},set contextValue(z){D.contextValue=z},get label(){return D.label},set label(z){D.label=z},get state(){return D.state},set state(z){D.state=z},dispose:()=>{D.dispose()}}}updateIsTemplate(){this._isTemplate&&(this._isTemplate=!1,this.modifications.isTemplate=!1)}eventuallyUpdateCommentThread(){if(this._isDiposed)return;this.updateIsTemplate(),this._acceptInputDisposables.value||(this._acceptInputDisposables.value=new M.DisposableStore);const a=v=>Object.prototype.hasOwnProperty.call(this.modifications,v),o={};a("range")&&(o.range=P.Range.from(this._range)),a("label")&&(o.label=this.label),a("contextValue")&&(o.contextValue=this.contextValue??null),a("comments")&&(o.comments=this._comments.map(v=>w(this,v,this._commentsMap))),a("collapsibleState")&&(o.collapseState=i(this._collapseState)),a("canReply")&&(o.canReply=this.canReply),a("state")&&(o.state=n(this._state)),a("isTemplate")&&(o.isTemplate=this._isTemplate),this.modifications={},h.$updateCommentThread(this._commentControllerHandle,this.handle,this._id,this._uri,o)}getCommentByUniqueId(a){for(const o of this._commentsMap){const v=o[0],p=o[1];if(a===p)return v}}dispose(){this._isDiposed=!0,this._acceptInputDisposables.dispose(),this._localDisposables.forEach(a=>a.dispose())}}C._handlePool=0,ze([(0,y.debounce)(100)],C.prototype,"eventuallyUpdateCommentThread",null);class l{get id(){return this._id}get label(){return this._label}get handle(){return this._handle}get commentingRangeProvider(){return this._commentingRangeProvider}set commentingRangeProvider(a){this._commentingRangeProvider=a,h.$updateCommentingRanges(this.handle)}get reactionHandler(){return this._reactionHandler}set reactionHandler(a){this._reactionHandler=a,h.$updateCommentControllerFeatures(this.handle,{reactionHandler:!!a})}get options(){return this._options}set options(a){this._options=a,h.$updateCommentControllerFeatures(this.handle,{options:this._options})}constructor(a,o,v,p){this._extension=a,this._handle=o,this._id=v,this._label=p,this._threads=new Map,h.$registerCommentController(this.handle,v,p);const T=this;this.value=Object.freeze({id:T.id,label:T.label,get options(){return T.options},set options(N){T.options=N},get commentingRangeProvider(){return T.commentingRangeProvider},set commentingRangeProvider(N){T.commentingRangeProvider=N},get reactionHandler(){return T.reactionHandler},set reactionHandler(N){T.reactionHandler=N},createCommentThread(N,V,B){return T.createCommentThread(N,V,B).value},dispose:()=>{T.dispose()}}),this._localDisposables=[],this._localDisposables.push({dispose:()=>{h.$unregisterCommentController(this.handle)}})}createCommentThread(a,o,v,p){if(typeof a=="string"){const T=new C(this.id,this.handle,a,o,v,p,this._extension,!1);return this._threads.set(T.handle,T),T}else{const T=new C(this.id,this.handle,void 0,a,o,v,this._extension,!1);return this._threads.set(T.handle,T),T}}$createCommentThreadTemplate(a,o){const v=new C(this.id,this.handle,void 0,_.URI.revive(a),P.Range.to(o),[],this._extension,!0);return v.collapsibleState=A.CommentThreadCollapsibleState.Expanded,this._threads.set(v.handle,v),v}$updateCommentThreadTemplate(a,o){const v=this._threads.get(a);v&&(v.range=P.Range.to(o))}$deleteCommentThread(a){this._threads.get(a)?.dispose(),this._threads.delete(a)}getCommentThread(a){return this._threads.get(a)}dispose(){this._threads.forEach(a=>{a.dispose()}),this._localDisposables.forEach(a=>a.dispose())}}function w(s,a,o){let v=o.get(a);v||(v=++s.commentHandle,o.set(a,v));const p=a.author&&a.author.iconPath?a.author.iconPath.toString():void 0;return{mode:a.mode,contextValue:a.contextValue,uniqueIdInThread:v,body:typeof a.body=="string"?a.body:P.MarkdownString.from(a.body),userName:a.author.name,userIconPath:p,label:a.label,commentReactions:a.reactions?a.reactions.map(T=>t(T)):void 0,timestamp:a.timestamp?.toJSON()}}function t(s){return{label:s.label,iconPath:s.iconPath?P.pathOrURIToURI(s.iconPath):void 0,count:s.count,hasReacted:s.authorHasReacted}}function u(s){return{label:s.label||"",count:s.count||0,iconPath:s.iconPath?_.URI.revive(s.iconPath):"",authorHasReacted:s.hasReacted||!1}}function i(s){if(s!==void 0)switch(s){case O.CommentThreadCollapsibleState.Expanded:return A.CommentThreadCollapsibleState.Expanded;case O.CommentThreadCollapsibleState.Collapsed:return A.CommentThreadCollapsibleState.Collapsed}return A.CommentThreadCollapsibleState.Collapsed}function n(s){if(s!==void 0)switch(s){case O.CommentThreadState.Unresolved:return A.CommentThreadState.Unresolved;case O.CommentThreadState.Resolved:return A.CommentThreadState.Resolved}return A.CommentThreadState.Unresolved}return new g}e.createExtHostComments=k}),define(Ce[192],Ie([1,0,26,4,28,11]),function(ie,e,r,y,S,M){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.AbstractExtHostConsoleForwarder=void 0;let _=class{constructor(O,E){this._mainThreadConsole=O.getProxy(y.MainContext.MainThreadConsole),this._includeStack=E.consoleForward.includeStack,this._logNative=E.consoleForward.logNative,this._wrapConsoleMethod("info","log"),this._wrapConsoleMethod("log","log"),this._wrapConsoleMethod("warn","warn"),this._wrapConsoleMethod("error","error")}_wrapConsoleMethod(O,E){const m=this,k=console[O];Object.defineProperty(console,O,{set:()=>{},get:()=>function(){m._handleConsoleCall(O,E,k,arguments)}})}_handleConsoleCall(O,E,m,k){this._mainThreadConsole.$logExtensionHostMessage({type:"__$console",severity:E,arguments:b(k,this._includeStack)}),this._logNative&&this._nativeConsoleLogMessage(O,m,k)}};_=ze([$e(0,M.IExtHostRpcService),$e(1,S.IExtHostInitDataService)],_),e.AbstractExtHostConsoleForwarder=_;const A=1e5;function b(P,O){const E=[];if(P.length)for(let m=0;m<P.length;m++){let k=P[m];if(typeof k>"u")k="undefined";else if(k instanceof Error){const f=k;f.stack?k=f.stack:k=f.toString()}E.push(k)}if(O){const m=new Error().stack;m&&E.push({__$stack:m.split(`
`).slice(3).join(`
`)})}try{const m=(0,r.safeStringify)(E);return m.length>A?"Output omitted for a large object that exceeds the limits":m}catch(m){return`Output omitted for an object that cannot be inspected ('${m.toString()}')`}}}),define(Ce[97],Ie([1,0,2,4,6,3,11,14,18,9,19]),function(ie,e,r,y,S,M,_,A,b,P,O){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.IExtHostDecorations=e.ExtHostDecorations=void 0;let E=class Ai{constructor(k,f){this._logService=f,this._provider=new Map,this._proxy=k.getProxy(y.MainContext.MainThreadDecorations)}registerFileDecorationProvider(k,f){const c=Ai._handlePool++;this._provider.set(c,{provider:k,extensionId:f}),this._proxy.$registerDecorationProvider(c,f.value);const d=k.onDidChangeFileDecorations&&k.onDidChangeFileDecorations(h=>{if(!h){this._proxy.$onDidChange(c,null);return}const g=(0,b.asArray)(h);if(g.length<=Ai._maxEventSize){this._proxy.$onDidChange(c,g);return}this._logService.warn("[Decorations] CAPPING events from decorations provider",f.value,g.length);const C=g.map(t=>({uri:t,rank:(0,P.count)(t.path,"/")})),l=(0,b.groupBy)(C,(t,u)=>t.rank-u.rank||(0,P.compare)(t.uri.path,u.uri.path)),w=[];e:for(const t of l){let u;for(const i of t){const n=(0,O.dirname)(i.uri.path);if(u!==n&&(u=n,w.push(i.uri)>=Ai._maxEventSize))break e}}this._proxy.$onDidChange(c,w)});return new S.Disposable(()=>{d?.dispose(),this._proxy.$unregisterDecorationProvider(c),this._provider.delete(c)})}async $provideDecorations(k,f,c){if(!this._provider.has(k))return Object.create(null);const d=Object.create(null),{provider:h,extensionId:g}=this._provider.get(k);return await Promise.all(f.map(async C=>{try{const{uri:l,id:w}=C,t=await Promise.resolve(h.provideFileDecoration(r.URI.revive(l),c));if(!t)return;try{S.FileDecoration.validate(t),d[w]=[t.propagate,t.tooltip,t.badge,t.color]}catch(u){this._logService.warn(`INVALID decoration from extension '${g.value}': ${u}`)}}catch(l){this._logService.error(l)}})),d}};E._handlePool=0,E._maxEventSize=250,E=ze([$e(0,_.IExtHostRpcService),$e(1,A.ILogService)],E),e.ExtHostDecorations=E,e.IExtHostDecorations=(0,M.createDecorator)("IExtHostDecorations")});var Je=this&&this.__classPrivateFieldSet||function(ie,e,r,y,S){if(y==="m")throw new TypeError("Private method is not writable");if(y==="a"&&!S)throw new TypeError("Private accessor was defined without a setter");if(typeof e=="function"?ie!==e||!S:!e.has(ie))throw new TypeError("Cannot write private member to an object whose class did not declare it");return y==="a"?S.call(ie,r):S?S.value=r:e.set(ie,r),r},Oe=this&&this.__classPrivateFieldGet||function(ie,e,r,y){if(r==="a"&&!y)throw new TypeError("Private accessor was defined without a getter");if(typeof e=="function"?ie!==e||!y:!e.has(ie))throw new TypeError("Cannot read private member from an object whose class did not declare it");return r==="m"?y:r==="a"?y.call(ie):y?y.value:e.get(ie)};define(Ce[193],Ie([1,0,130,82,2,4,6,8,5,14,24,36]),function(ie,e,r,y,S,M,_,A,b,P,O,E){"use strict";var m,k,f;Object.defineProperty(e,"__esModule",{value:!0}),e.ExtHostDiagnostics=e.DiagnosticCollection=void 0;class c{constructor(g,C,l,w,t,u){this._name=g,this._owner=C,this._maxDiagnosticsPerFile=l,m.set(this,void 0),k.set(this,void 0),f.set(this,void 0),this._isDisposed=!1,Je(this,f,new O.ResourceMap(i=>w.getComparisonKey(i)),"f"),Je(this,m,t,"f"),Je(this,k,u,"f")}dispose(){this._isDisposed||(Oe(this,k,"f").fire([...Oe(this,f,"f").keys()]),Oe(this,m,"f")?.$clear(this._owner),Oe(this,f,"f").clear(),this._isDisposed=!0)}get name(){return this._checkDisposed(),this._name}set(g,C){if(!g){this.clear();return}this._checkDisposed();let l=[];if(S.URI.isUri(g)){if(!C){this.delete(g);return}Oe(this,f,"f").set(g,C.slice()),l=[g]}else if(Array.isArray(g)){l=[];let t;g=[...g].sort(c._compareIndexedTuplesByUri);for(const u of g){const[i,n]=u;if((!t||i.toString()!==t.toString())&&(t&&Oe(this,f,"f").get(t).length===0&&Oe(this,f,"f").delete(t),t=i,l.push(i),Oe(this,f,"f").set(i,[])),n)Oe(this,f,"f").get(i)?.push(...n);else{const s=Oe(this,f,"f").get(i);s&&(s.length=0)}}}if(Oe(this,k,"f").fire(l),!Oe(this,m,"f"))return;const w=[];for(const t of l){let u=[];const i=Oe(this,f,"f").get(t);if(i)if(i.length>this._maxDiagnosticsPerFile){u=[];const n=[_.DiagnosticSeverity.Error,_.DiagnosticSeverity.Warning,_.DiagnosticSeverity.Information,_.DiagnosticSeverity.Hint];e:for(let s=0;s<4;s++)for(const a of i)if(a.severity===n[s]&&u.push(A.Diagnostic.from(a))===this._maxDiagnosticsPerFile)break e;u.push({severity:y.MarkerSeverity.Info,message:(0,r.localize)(0,null,i.length-this._maxDiagnosticsPerFile),startLineNumber:u[u.length-1].startLineNumber,startColumn:u[u.length-1].startColumn,endLineNumber:u[u.length-1].endLineNumber,endColumn:u[u.length-1].endColumn})}else u=i.map(n=>A.Diagnostic.from(n));w.push([t,u])}Oe(this,m,"f").$changeMany(this._owner,w)}delete(g){this._checkDisposed(),Oe(this,k,"f").fire([g]),Oe(this,f,"f").delete(g),Oe(this,m,"f")?.$changeMany(this._owner,[[g,void 0]])}clear(){this._checkDisposed(),Oe(this,k,"f").fire([...Oe(this,f,"f").keys()]),Oe(this,f,"f").clear(),Oe(this,m,"f")?.$clear(this._owner)}forEach(g,C){this._checkDisposed();for(const[l,w]of this)g.call(C,l,w,this)}*[(m=new WeakMap,k=new WeakMap,f=new WeakMap,Symbol.iterator)](){this._checkDisposed();for(const g of Oe(this,f,"f").keys())yield[g,this.get(g)]}get(g){this._checkDisposed();const C=Oe(this,f,"f").get(g);return Array.isArray(C)?Object.freeze(C.slice(0)):[]}has(g){return this._checkDisposed(),Array.isArray(Oe(this,f,"f").get(g))}_checkDisposed(){if(this._isDisposed)throw new Error("illegal state - object is disposed")}static _compareIndexedTuplesByUri(g,C){return g[0].toString()<C[0].toString()?-1:g[0].toString()>C[0].toString()?1:0}}e.DiagnosticCollection=c;let d=class fi{static _mapper(g){const C=new O.ResourceMap;for(const l of g)C.set(l,l);return{uris:Object.freeze(Array.from(C.values()))}}constructor(g,C,l){this._logService=C,this._fileSystemInfoService=l,this._collections=new Map,this._onDidChangeDiagnostics=new b.DebounceEmitter({merge:w=>w.flat(),delay:50}),this.onDidChangeDiagnostics=b.Event.map(this._onDidChangeDiagnostics.event,fi._mapper),this._proxy=g.getProxy(M.MainContext.MainThreadDiagnostics)}createDiagnosticCollection(g,C){const{_collections:l,_proxy:w,_onDidChangeDiagnostics:t,_logService:u,_fileSystemInfoService:i}=this,n=new class{$changeMany(o,v){w.$changeMany(o,v),u.trace("[DiagnosticCollection] change many (extension, owner, uris)",g.value,o,v.length===0?"CLEARING":v)}$clear(o){w.$clear(o),u.trace("[DiagnosticCollection] remove all (extension, owner)",g.value,o)}dispose(){w.dispose()}};let s;if(!C)C="_generated_diagnostic_collection_name_#"+fi._idPool++,s=C;else if(!l.has(C))s=C;else{this._logService.warn(`DiagnosticCollection with name '${C}' does already exist.`);do s=C+fi._idPool++;while(l.has(s))}return new class extends c{constructor(){super(C,s,fi._maxDiagnosticsPerFile,i.extUri,n,t),l.set(s,this)}dispose(){super.dispose(),l.delete(s)}}}getDiagnostics(g){if(g)return this._getDiagnostics(g);{const C=new Map,l=[];for(const w of this._collections.values())w.forEach((t,u)=>{let i=C.get(t.toString());typeof i>"u"&&(i=l.length,C.set(t.toString(),i),l.push([t,[]])),l[i][1]=l[i][1].concat(...u)});return l}}_getDiagnostics(g){let C=[];for(const l of this._collections.values())l.has(g)&&(C=C.concat(l.get(g)));return C}$acceptMarkersChange(g){if(!this._mirrorCollection){const C="_generated_mirror",l=new c(C,C,fi._maxDiagnosticsPerFile,this._fileSystemInfoService.extUri,void 0,this._onDidChangeDiagnostics);this._collections.set(C,l),this._mirrorCollection=l}for(const[C,l]of g)this._mirrorCollection.set(S.URI.revive(C),l.map(A.Diagnostic.to))}};d._idPool=0,d._maxDiagnosticsPerFile=1e3,d=ze([$e(1,P.ILogService),$e(2,E.IExtHostFileSystemInfo)],d),e.ExtHostDiagnostics=d}),define(Ce[194],Ie([1,0,2,4]),function(ie,e,r,y){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtHostDialogs=void 0;class S{constructor(_){this._proxy=_.getProxy(y.MainContext.MainThreadDialogs)}showOpenDialog(_){return this._proxy.$showOpenDialog(_).then(A=>A?A.map(b=>r.URI.revive(b)):void 0)}showSaveDialog(_){return this._proxy.$showSaveDialog(_).then(A=>A?r.URI.revive(A):void 0)}}e.ExtHostDialogs=S}),define(Ce[195],Ie([1,0,12,2,6,4,13,20,9]),function(ie,e,r,y,S,M,_,A,b){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtHostDocumentContentProvider=void 0;class P{constructor(E,m,k){this._documentsAndEditors=m,this._logService=k,this._documentContentProviders=new Map,this._proxy=E.getProxy(M.MainContext.MainThreadDocumentContentProviders)}registerTextDocumentContentProvider(E,m){if(Object.keys(_.Schemas).indexOf(E)>=0)throw new Error(`scheme '${E}' already registered`);const k=P._handlePool++;this._documentContentProviders.set(k,m),this._proxy.$registerTextContentProvider(k,E);let f;return typeof m.onDidChange=="function"&&(f=m.onDidChange(c=>{if(c.scheme!==E){this._logService.warn(`Provider for scheme '${E}' is firing event for schema '${c.scheme}' which will be IGNORED`);return}this._documentsAndEditors.getDocument(c)&&this.$provideTextDocumentContent(k,c).then(d=>{if(!d&&typeof d!="string")return;const h=this._documentsAndEditors.getDocument(c);if(!h)return;const g=(0,b.splitLines)(d);if(!h.equalLines(g))return this._proxy.$onVirtualDocumentChange(c,d)},r.onUnexpectedError)})),new S.Disposable(()=>{this._documentContentProviders.delete(k)&&this._proxy.$unregisterTextContentProvider(k),f&&(f.dispose(),f=void 0)})}$provideTextDocumentContent(E,m){const k=this._documentContentProviders.get(E);return k?Promise.resolve(k.provideTextDocumentContent(y.URI.revive(m),A.CancellationToken.None)):Promise.reject(new Error(`unsupported uri-scheme: ${m.scheme}`))}}e.ExtHostDocumentContentProvider=P,P._handlePool=0}),define(Ce[196],Ie([1,0,5,7,2,4,93,8,10,26,6]),function(ie,e,r,y,S,M,_,A,b,P,O){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtHostDocuments=void 0;class E{constructor(k,f){this._onDidAddDocument=new r.Emitter,this._onDidRemoveDocument=new r.Emitter,this._onDidChangeDocument=new r.Emitter,this._onDidSaveDocument=new r.Emitter,this.onDidAddDocument=this._onDidAddDocument.event,this.onDidRemoveDocument=this._onDidRemoveDocument.event,this.onDidChangeDocument=this._onDidChangeDocument.event,this.onDidSaveDocument=this._onDidSaveDocument.event,this._toDispose=new y.DisposableStore,this._documentLoader=new Map,this._proxy=k.getProxy(M.MainContext.MainThreadDocuments),this._documentsAndEditors=f,this._documentsAndEditors.onDidRemoveDocuments(c=>{for(const d of c)this._onDidRemoveDocument.fire(d.document)},void 0,this._toDispose),this._documentsAndEditors.onDidAddDocuments(c=>{for(const d of c)this._onDidAddDocument.fire(d.document)},void 0,this._toDispose)}dispose(){this._toDispose.dispose()}getAllDocumentData(){return[...this._documentsAndEditors.allDocuments()]}getDocumentData(k){if(!k)return;const f=this._documentsAndEditors.getDocument(k);if(f)return f}getDocument(k){const f=this.getDocumentData(k);if(!f?.document)throw new Error(`Unable to retrieve document from URI '${k}'`);return f.document}ensureDocumentData(k){const f=this._documentsAndEditors.getDocument(k);if(f)return Promise.resolve(f);let c=this._documentLoader.get(k.toString());return c||(c=this._proxy.$tryOpenDocument(k).then(d=>{this._documentLoader.delete(k.toString());const h=S.URI.revive(d);return(0,b.assertIsDefined)(this._documentsAndEditors.getDocument(h))},d=>(this._documentLoader.delete(k.toString()),Promise.reject(d))),this._documentLoader.set(k.toString(),c)),c}createDocumentData(k){return this._proxy.$tryCreateDocument(k).then(f=>S.URI.revive(f))}$acceptModelLanguageChanged(k,f){const c=S.URI.revive(k),d=this._documentsAndEditors.getDocument(c);if(!d)throw new Error("unknown document");this._onDidRemoveDocument.fire(d.document),d._acceptLanguageId(f),this._onDidAddDocument.fire(d.document)}$acceptModelSaved(k){const f=S.URI.revive(k),c=this._documentsAndEditors.getDocument(f);if(!c)throw new Error("unknown document");this.$acceptDirtyStateChanged(k,!1),this._onDidSaveDocument.fire(c.document)}$acceptDirtyStateChanged(k,f){const c=S.URI.revive(k),d=this._documentsAndEditors.getDocument(c);if(!d)throw new Error("unknown document");d._acceptIsDirty(f),this._onDidChangeDocument.fire({document:d.document,contentChanges:[],reason:void 0})}$acceptModelChanged(k,f,c){const d=S.URI.revive(k),h=this._documentsAndEditors.getDocument(d);if(!h)throw new Error("unknown document");h._acceptIsDirty(c),h.onEvents(f);let g;f.isUndoing?g=O.TextDocumentChangeReason.Undo:f.isRedoing&&(g=O.TextDocumentChangeReason.Redo),this._onDidChangeDocument.fire((0,P.deepFreeze)({document:h.document,contentChanges:f.changes.map(C=>({range:A.Range.to(C.range),rangeOffset:C.rangeOffset,rangeLength:C.rangeLength,text:C.text})),reason:g}))}setWordDefinitionFor(k,f){(0,_.setWordDefinitionFor)(k,f)}}e.ExtHostDocuments=E}),define(Ce[50],Ie([1,0,44,5,7,2,3,4,93,11,96,8,14,24,13,166,197]),function(ie,e,r,y,S,M,_,A,b,P,O,E,m,k,f,c,d){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.IExtHostDocumentsAndEditors=e.ExtHostDocumentsAndEditors=void 0;class h{constructor(l){this.value=l,this._count=0}ref(){this._count++}unref(){return--this._count===0}}let g=class{constructor(l,w){this._extHostRpc=l,this._logService=w,this._activeEditorId=null,this._editors=new Map,this._documents=new k.ResourceMap,this._onDidAddDocuments=new y.Emitter,this._onDidRemoveDocuments=new y.Emitter,this._onDidChangeVisibleTextEditors=new y.Emitter,this._onDidChangeActiveTextEditor=new y.Emitter,this.onDidAddDocuments=this._onDidAddDocuments.event,this.onDidRemoveDocuments=this._onDidRemoveDocuments.event,this.onDidChangeVisibleTextEditors=this._onDidChangeVisibleTextEditors.event,this.onDidChangeActiveTextEditor=this._onDidChangeActiveTextEditor.event}$acceptDocumentsAndEditorsDelta(l){this.acceptDocumentsAndEditorsDelta(l)}acceptDocumentsAndEditorsDelta(l){const w=[],t=[],u=[];if(l.removedDocuments)for(const i of l.removedDocuments){const n=M.URI.revive(i),s=this._documents.get(n);s?.unref()&&(this._documents.delete(n),w.push(s.value))}if(l.addedDocuments)for(const i of l.addedDocuments){const n=M.URI.revive(i.uri);let s=this._documents.get(n);if(s&&n.scheme!==f.Schemas.vscodeNotebookCell&&n.scheme!==f.Schemas.vscodeInteractiveInput)throw new Error(`document '${n} already exists!'`);s||(s=new h(new b.ExtHostDocumentData(this._extHostRpc.getProxy(A.MainContext.MainThreadDocuments),n,i.lines,i.EOL,i.versionId,i.languageId,i.isDirty,i.notebook)),this._documents.set(n,s),t.push(s.value)),s.ref()}if(l.removedEditors)for(const i of l.removedEditors){const n=this._editors.get(i);this._editors.delete(i),n&&u.push(n)}if(l.addedEditors)for(const i of l.addedEditors){const n=M.URI.revive(i.documentUri);r.ok(this._documents.has(n),`document '${n}' does not exist`),r.ok(!this._editors.has(i.id),`editor '${i.id}' already exists!`);const s=this._documents.get(n).value,a=new O.ExtHostTextEditor(i.id,this._extHostRpc.getProxy(A.MainContext.MainThreadTextEditors),this._logService,new d.Lazy(()=>s.document),i.selections.map(E.Selection.to),i.options,i.visibleRanges.map(o=>E.Range.to(o)),typeof i.editorPosition=="number"?E.ViewColumn.to(i.editorPosition):void 0);this._editors.set(i.id,a)}l.newActiveEditor!==void 0&&(r.ok(l.newActiveEditor===null||this._editors.has(l.newActiveEditor),`active editor '${l.newActiveEditor}' does not exist`),this._activeEditorId=l.newActiveEditor),(0,S.dispose)(w),(0,S.dispose)(u),l.removedDocuments&&this._onDidRemoveDocuments.fire(w),l.addedDocuments&&this._onDidAddDocuments.fire(t),(l.removedEditors||l.addedEditors)&&this._onDidChangeVisibleTextEditors.fire(this.allEditors().map(i=>i.value)),l.newActiveEditor!==void 0&&this._onDidChangeActiveTextEditor.fire(this.activeEditor())}getDocument(l){return this._documents.get(l)?.value}allDocuments(){return c.Iterable.map(this._documents.values(),l=>l.value)}getEditor(l){return this._editors.get(l)}activeEditor(l){if(!this._activeEditorId)return;const w=this._editors.get(this._activeEditorId);return l?w:w?.value}allEditors(){return[...this._editors.values()]}};g=ze([$e(0,P.IExtHostRpcService),$e(1,m.ILogService)],g),e.ExtHostDocumentsAndEditors=g,e.IExtHostDocumentsAndEditors=(0,_.createDecorator)("IExtHostDocumentsAndEditors")}),define(Ce[51],Ie([1,0,8,4,2,5,3,6,11,10,73]),function(ie,e,r,y,S,M,_,A,b,P,O){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtHostEditorTabs=e.IExtHostEditorTabs=void 0,e.IExtHostEditorTabs=(0,_.createDecorator)("IExtHostEditorTabs");class E{constructor(d,h,g){this._activeTabIdGetter=g,this._parentGroup=h,this.acceptDtoUpdate(d)}get apiObject(){if(!this._apiObject){const d=this,h={get isActive(){return d._dto.id===d._activeTabIdGetter()},get label(){return d._dto.label},get input(){return d._input},get isDirty(){return d._dto.isDirty},get isPinned(){return d._dto.isPinned},get isPreview(){return d._dto.isPreview},get group(){return d._parentGroup.apiObject}};this._apiObject=Object.freeze(h)}return this._apiObject}get tabId(){return this._dto.id}acceptDtoUpdate(d){this._dto=d,this._input=this._initInput()}_initInput(){switch(this._dto.input.kind){case 1:return new A.TextTabInput(S.URI.revive(this._dto.input.uri));case 2:return new A.TextDiffTabInput(S.URI.revive(this._dto.input.original),S.URI.revive(this._dto.input.modified));case 3:return new A.TextMergeTabInput(S.URI.revive(this._dto.input.base),S.URI.revive(this._dto.input.input1),S.URI.revive(this._dto.input.input2),S.URI.revive(this._dto.input.result));case 6:return new A.CustomEditorTabInput(S.URI.revive(this._dto.input.uri),this._dto.input.viewType);case 7:return new A.WebviewEditorTabInput(this._dto.input.viewType);case 4:return new A.NotebookEditorTabInput(S.URI.revive(this._dto.input.uri),this._dto.input.notebookType);case 5:return new A.NotebookDiffEditorTabInput(S.URI.revive(this._dto.input.original),S.URI.revive(this._dto.input.modified),this._dto.input.notebookType);case 8:return new A.TerminalEditorTabInput;case 9:return new A.InteractiveWindowInput(S.URI.revive(this._dto.input.uri),S.URI.revive(this._dto.input.inputBoxUri));default:return}}}class m{constructor(d,h){this._tabs=[],this._activeTabId="",this._dto=d,this._activeGroupIdGetter=h;for(const g of d.tabs)g.isActive&&(this._activeTabId=g.id),this._tabs.push(new E(g,this,()=>this.activeTabId()))}get apiObject(){if(!this._apiObject){const d=this,h={get isActive(){return d._dto.groupId===d._activeGroupIdGetter()},get viewColumn(){return r.ViewColumn.to(d._dto.viewColumn)},get activeTab(){return d._tabs.find(g=>g.tabId===d._activeTabId)?.apiObject},get tabs(){return Object.freeze(d._tabs.map(g=>g.apiObject))}};this._apiObject=Object.freeze(h)}return this._apiObject}get groupId(){return this._dto.groupId}get tabs(){return this._tabs}acceptGroupDtoUpdate(d){this._dto=d}acceptTabOperation(d){if(d.kind===0){const g=new E(d.tabDto,this,()=>this.activeTabId());return this._tabs.splice(d.index,0,g),d.tabDto.isActive&&(this._activeTabId=g.tabId),g}else if(d.kind===1){const g=this._tabs.splice(d.index,1)[0];if(!g)throw new Error(`Tab close updated received for index ${d.index} which does not exist`);return g.tabId===this._activeTabId&&(this._activeTabId=""),g}else if(d.kind===3){if(d.oldIndex===void 0)throw new Error("Invalid old index on move IPC");const g=this._tabs.splice(d.oldIndex,1)[0];if(!g)throw new Error(`Tab move updated received for index ${d.oldIndex} which does not exist`);return this._tabs.splice(d.index,0,g),g}const h=this._tabs.find(g=>g.tabId===d.tabDto.id);if(!h)throw new Error("INVALID tab");return d.tabDto.isActive?this._activeTabId=d.tabDto.id:this._activeTabId===d.tabDto.id&&!d.tabDto.isActive&&(this._activeTabId=""),h.acceptDtoUpdate(d.tabDto),h}activeTabId(){return this._activeTabId}}let k=class{constructor(d){this._onDidChangeTabs=new M.Emitter,this._onDidChangeTabGroups=new M.Emitter,this._extHostTabGroups=[],this._proxy=d.getProxy(y.MainContext.MainThreadEditorTabs)}get tabGroups(){if(!this._apiObject){const d=this,h={onDidChangeTabGroups:d._onDidChangeTabGroups.event,onDidChangeTabs:d._onDidChangeTabs.event,get all(){return Object.freeze(d._extHostTabGroups.map(g=>g.apiObject))},get activeTabGroup(){const g=d._activeGroupId;return(0,P.assertIsDefined)(d._extHostTabGroups.find(l=>l.groupId===g)?.apiObject)},close:async(g,C)=>{const l=Array.isArray(g)?g:[g];return l.length?f(l[0])?this._closeGroups(l,C):this._closeTabs(l,C):!0}};this._apiObject=Object.freeze(h)}return this._apiObject}$acceptEditorTabModel(d){const h=new Set(this._extHostTabGroups.map(i=>i.groupId)),g=new Set(d.map(i=>i.groupId)),C=(0,O.diffSets)(h,g),l=this._extHostTabGroups.filter(i=>C.removed.includes(i.groupId)).map(i=>i.apiObject),w=[],t=[];this._extHostTabGroups=d.map(i=>{const n=new m(i,()=>this._activeGroupId);return C.added.includes(n.groupId)?w.push(n.apiObject):t.push(n.apiObject),n});const u=(0,P.assertIsDefined)(d.find(i=>i.isActive===!0)?.groupId);u!==void 0&&this._activeGroupId!==u&&(this._activeGroupId=u),this._onDidChangeTabGroups.fire(Object.freeze({opened:w,closed:l,changed:t}))}$acceptTabGroupUpdate(d){const h=this._extHostTabGroups.find(g=>g.groupId===d.groupId);if(!h)throw new Error("Update Group IPC call received before group creation.");h.acceptGroupDtoUpdate(d),d.isActive&&(this._activeGroupId=d.groupId),this._onDidChangeTabGroups.fire(Object.freeze({changed:[h.apiObject],opened:[],closed:[]}))}$acceptTabOperation(d){const h=this._extHostTabGroups.find(C=>C.groupId===d.groupId);if(!h)throw new Error("Update Tabs IPC call received before group creation.");const g=h.acceptTabOperation(d);switch(d.kind){case 0:this._onDidChangeTabs.fire(Object.freeze({opened:[g.apiObject],closed:[],changed:[]}));return;case 1:this._onDidChangeTabs.fire(Object.freeze({opened:[],closed:[g.apiObject],changed:[]}));return;case 3:case 2:this._onDidChangeTabs.fire(Object.freeze({opened:[],closed:[],changed:[g.apiObject]}));return}}_findExtHostTabFromApi(d){for(const h of this._extHostTabGroups)for(const g of h.tabs)if(g.apiObject===d)return g}_findExtHostTabGroupFromApi(d){return this._extHostTabGroups.find(h=>h.apiObject===d)}async _closeTabs(d,h){const g=[];for(const C of d){const l=this._findExtHostTabFromApi(C);if(!l)throw new Error("Tab close: Invalid tab not found!");g.push(l.tabId)}return this._proxy.$closeTab(g,h)}async _closeGroups(d,h){const g=[];for(const C of d){const l=this._findExtHostTabGroupFromApi(C);if(!l)throw new Error("Group close: Invalid group not found!");g.push(l.groupId)}return this._proxy.$closeGroup(g,h)}};k=ze([$e(0,b.IExtHostRpcService)],k),e.ExtHostEditorTabs=k;function f(c){return c.tabs!==void 0}}),define(Ce[198],Ie([1,0,2,4,7,6,8,244,9,23,25]),function(ie,e,r,y,S,M,_,A,b,P,O){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtHostFileSystem=void 0;class E{constructor(){this._schemes=[]}add(f){this._stateMachine=void 0,this._schemes.push(f)}delete(f){const c=this._schemes.indexOf(f);c>=0&&(this._schemes.splice(c,1),this._stateMachine=void 0)}_initStateMachine(){if(!this._stateMachine){const f=this._schemes.sort(),c=[];let d,h,g=14,C=14;for(const l of f){let w=d?(0,b.commonPrefixLength)(d,l):0;for(w===0?h=1:h=C;w<l.length;w++)w+1===l.length?(g=C,C=9):C+=1,c.push([h,l.toUpperCase().charCodeAt(w),C]),c.push([h,l.toLowerCase().charCodeAt(w),C]),h=C;d=l,C=g}c.push([9,58,10]),c.push([10,47,12]),this._stateMachine=new A.StateMachine(c)}}provideDocumentLinks(f){this._initStateMachine();const c=[],d=A.LinkComputer.computeLinks({getLineContent(h){return f.lineAt(h-1).text},getLineCount(){return f.lineCount}},this._stateMachine);for(const h of d){const g=_.DocumentLink.to(h);g.target&&c.push(g)}return c}}class m{constructor(f,c){this._extHostLanguageFeatures=c,this._linkProvider=new E,this._fsProvider=new Map,this._registeredSchemes=new Set,this._watches=new Map,this._handlePool=0,this._proxy=f.getProxy(y.MainContext.MainThreadFileSystem)}dispose(){this._linkProviderRegistration?.dispose()}registerFileSystemProvider(f,c,d,h={}){if(this._registeredSchemes.has(c))throw new Error(`a provider for the scheme '${c}' is already registered`);this._linkProviderRegistration||(this._linkProviderRegistration=this._extHostLanguageFeatures.registerDocumentLinkProvider(f,"*",this._linkProvider));const g=this._handlePool++;this._linkProvider.add(c),this._registeredSchemes.add(c),this._fsProvider.set(g,d);let C=2;h.isCaseSensitive&&(C+=1024),h.isReadonly&&(C+=2048),typeof d.copy=="function"&&(C+=8),typeof d.open=="function"&&typeof d.close=="function"&&typeof d.read=="function"&&typeof d.write=="function"&&((0,O.checkProposedApiEnabled)(f,"fsChunks"),C+=4),this._proxy.$registerFileSystemProvider(g,c,C).catch(w=>{console.error(`FAILED to register filesystem provider of ${f.identifier.value}-extension for the scheme ${c}`),console.error(w)});const l=d.onDidChangeFile(w=>{const t=[];for(const u of w){const{uri:i,type:n}=u;if(i.scheme!==c)continue;let s;switch(n){case M.FileChangeType.Changed:s=0;break;case M.FileChangeType.Created:s=1;break;case M.FileChangeType.Deleted:s=2;break;default:throw new Error("Unknown FileChangeType")}t.push({resource:i,type:s})}this._proxy.$onFileSystemChange(g,t)});return(0,S.toDisposable)(()=>{l.dispose(),this._linkProvider.delete(c),this._registeredSchemes.delete(c),this._fsProvider.delete(g),this._proxy.$unregisterProvider(g)})}static _asIStat(f){const{type:c,ctime:d,mtime:h,size:g,permissions:C}=f;return{type:c,ctime:d,mtime:h,size:g,permissions:C}}$stat(f,c){return Promise.resolve(this._getFsProvider(f).stat(r.URI.revive(c))).then(d=>m._asIStat(d))}$readdir(f,c){return Promise.resolve(this._getFsProvider(f).readDirectory(r.URI.revive(c)))}$readFile(f,c){return Promise.resolve(this._getFsProvider(f).readFile(r.URI.revive(c))).then(d=>P.VSBuffer.wrap(d))}$writeFile(f,c,d,h){return Promise.resolve(this._getFsProvider(f).writeFile(r.URI.revive(c),d.buffer,h))}$delete(f,c,d){return Promise.resolve(this._getFsProvider(f).delete(r.URI.revive(c),d))}$rename(f,c,d,h){return Promise.resolve(this._getFsProvider(f).rename(r.URI.revive(c),r.URI.revive(d),h))}$copy(f,c,d,h){const g=this._getFsProvider(f);if(!g.copy)throw new Error('FileSystemProvider does not implement "copy"');return Promise.resolve(g.copy(r.URI.revive(c),r.URI.revive(d),h))}$mkdir(f,c){return Promise.resolve(this._getFsProvider(f).createDirectory(r.URI.revive(c)))}$watch(f,c,d,h){const g=this._getFsProvider(f).watch(r.URI.revive(d),h);this._watches.set(c,g)}$unwatch(f,c){const d=this._watches.get(c);d&&(d.dispose(),this._watches.delete(c))}$open(f,c,d){const h=this._getFsProvider(f);if(!h.open)throw new Error('FileSystemProvider does not implement "open"');return Promise.resolve(h.open(r.URI.revive(c),d))}$close(f,c){const d=this._getFsProvider(f);if(!d.close)throw new Error('FileSystemProvider does not implement "close"');return Promise.resolve(d.close(c))}$read(f,c,d,h){const g=this._getFsProvider(f);if(!g.read)throw new Error('FileSystemProvider does not implement "read"');const C=P.VSBuffer.alloc(h);return Promise.resolve(g.read(c,d,C.buffer,0,h)).then(l=>C.slice(0,l))}$write(f,c,d,h){const g=this._getFsProvider(f);if(!g.write)throw new Error('FileSystemProvider does not implement "write"');return Promise.resolve(g.write(c,d,h.buffer,0,h.byteLength))}_getFsProvider(f){const c=this._fsProvider.get(f);if(!c){const d=new Error;throw d.name="ENOPRO",d.message="no provider",d}return c}}e.ExtHostFileSystem=m}),define(Ce[52],Ie([1,0,4,35,6,23,3,11,36,7]),function(ie,e,r,y,S,M,_,A,b,P){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.IExtHostConsumerFileSystem=e.ExtHostConsumerFileSystem=void 0;let O=class Qt{constructor(m,k){this._fileSystemProvider=new Map,this._proxy=m.getProxy(r.MainContext.MainThreadFileSystem);const f=this;this.value=Object.freeze({async stat(c){try{const d=f._fileSystemProvider.get(c.scheme);if(!d)return await f._proxy.$stat(c);await f._proxy.$ensureActivation(c.scheme);const h=await d.stat(c);return{type:h.type,ctime:h.ctime,mtime:h.mtime,size:h.size,permissions:h.permissions}}catch(d){Qt._handleError(d)}},async readDirectory(c){try{const d=f._fileSystemProvider.get(c.scheme);return d?(await f._proxy.$ensureActivation(c.scheme),(await d.readDirectory(c)).slice()):await f._proxy.$readdir(c)}catch(d){return Qt._handleError(d)}},async createDirectory(c){try{return await f._proxy.$mkdir(c)}catch(d){return Qt._handleError(d)}},async readFile(c){try{const d=f._fileSystemProvider.get(c.scheme);return d?(await f._proxy.$ensureActivation(c.scheme),(await d.readFile(c)).slice()):(await f._proxy.$readFile(c)).buffer}catch(d){return Qt._handleError(d)}},async writeFile(c,d){try{return await f._proxy.$writeFile(c,M.VSBuffer.wrap(d))}catch(h){return Qt._handleError(h)}},async delete(c,d){try{const h=f._fileSystemProvider.get(c.scheme);return h?(await f._proxy.$ensureActivation(c.scheme),await h.delete(c,{recursive:!1,...d})):await f._proxy.$delete(c,{recursive:!1,useTrash:!1,...d})}catch(h){return Qt._handleError(h)}},async rename(c,d,h){try{return await f._proxy.$rename(c,d,{overwrite:!1,...h})}catch(g){return Qt._handleError(g)}},async copy(c,d,h){try{return await f._proxy.$copy(c,d,{overwrite:!1,...h})}catch(g){return Qt._handleError(g)}},isWritableFileSystem(c){const d=k.getCapabilities(c);if(typeof d=="number")return!(d&2048)}})}static _handleError(m){if(m instanceof S.FileSystemError)throw m;if(!(m instanceof Error))throw new S.FileSystemError(String(m));if(m.name==="ENOPRO")throw S.FileSystemError.Unavailable(m.message);switch(m.name){case y.FileSystemProviderErrorCode.FileExists:throw S.FileSystemError.FileExists(m.message);case y.FileSystemProviderErrorCode.FileNotFound:throw S.FileSystemError.FileNotFound(m.message);case y.FileSystemProviderErrorCode.FileNotADirectory:throw S.FileSystemError.FileNotADirectory(m.message);case y.FileSystemProviderErrorCode.FileIsADirectory:throw S.FileSystemError.FileIsADirectory(m.message);case y.FileSystemProviderErrorCode.NoPermissions:throw S.FileSystemError.NoPermissions(m.message);case y.FileSystemProviderErrorCode.Unavailable:throw S.FileSystemError.Unavailable(m.message);default:throw new S.FileSystemError(m.message,m.name)}}addFileSystemProvider(m,k){return this._fileSystemProvider.set(m,k),(0,P.toDisposable)(()=>this._fileSystemProvider.delete(m))}};O=ze([$e(0,A.IExtHostRpcService),$e(1,b.IExtHostFileSystemInfo)],O),e.ExtHostConsumerFileSystem=O,e.IExtHostConsumerFileSystem=(0,_.createDecorator)("IExtHostConsumerFileSystem")}),define(Ce[199],Ie([1,0,5,34,2,4,8,6]),function(ie,e,r,y,S,M,_,A){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtHostFileSystemEventService=void 0;class b{get ignoreCreateEvents(){return Boolean(this._config&1)}get ignoreChangeEvents(){return Boolean(this._config&2)}get ignoreDeleteEvents(){return Boolean(this._config&4)}constructor(E,m,k,f,c,d,h,g){this._onDidCreate=new r.Emitter,this._onDidChange=new r.Emitter,this._onDidDelete=new r.Emitter;const C=this.ensureWatching(E,k,c);this._config=0,d&&(this._config+=1),h&&(this._config+=2),g&&(this._config+=4);const l=(0,y.parse)(c),w=typeof c=="string",t=f(u=>{if(!d)for(const i of u.created){const n=S.URI.revive(i);l(n.fsPath)&&(!w||m.getWorkspaceFolder(n))&&this._onDidCreate.fire(n)}if(!h)for(const i of u.changed){const n=S.URI.revive(i);l(n.fsPath)&&(!w||m.getWorkspaceFolder(n))&&this._onDidChange.fire(n)}if(!g)for(const i of u.deleted){const n=S.URI.revive(i);l(n.fsPath)&&(!w||m.getWorkspaceFolder(n))&&this._onDidDelete.fire(n)}});this._disposable=A.Disposable.from(C,this._onDidCreate,this._onDidChange,this._onDidDelete,t)}ensureWatching(E,m,k){const f=A.Disposable.from();if(typeof k=="string")return f;const c=E.getProxy(M.MainContext.MainThreadFileSystem);let d=!1;(k.pattern.includes(y.GLOBSTAR)||k.pattern.includes(y.GLOB_SPLIT))&&(d=!0);const h=Math.random();return c.$watch(m.identifier.value,h,k.baseUri,{recursive:d,excludes:[]}),A.Disposable.from({dispose:()=>c.$unwatch(h)})}dispose(){this._disposable.dispose()}get onDidCreate(){return this._onDidCreate.event}get onDidChange(){return this._onDidChange.event}get onDidDelete(){return this._onDidDelete.event}}class P{constructor(E,m,k){this._mainContext=E,this._logService=m,this._extHostDocumentsAndEditors=k,this._onFileSystemEvent=new r.Emitter,this._onDidRenameFile=new r.Emitter,this._onDidCreateFile=new r.Emitter,this._onDidDeleteFile=new r.Emitter,this._onWillRenameFile=new r.AsyncEmitter,this._onWillCreateFile=new r.AsyncEmitter,this._onWillDeleteFile=new r.AsyncEmitter,this.onDidRenameFile=this._onDidRenameFile.event,this.onDidCreateFile=this._onDidCreateFile.event,this.onDidDeleteFile=this._onDidDeleteFile.event}createFileSystemWatcher(E,m,k,f,c,d){return new b(this._mainContext,E,m,this._onFileSystemEvent.event,_.GlobPattern.from(k),f,c,d)}$onFileEvent(E){this._onFileSystemEvent.fire(E)}$onDidRunFileOperation(E,m){switch(E){case 2:this._onDidRenameFile.fire(Object.freeze({files:m.map(k=>({oldUri:S.URI.revive(k.source),newUri:S.URI.revive(k.target)}))}));break;case 1:this._onDidDeleteFile.fire(Object.freeze({files:m.map(k=>S.URI.revive(k.target))}));break;case 0:case 3:this._onDidCreateFile.fire(Object.freeze({files:m.map(k=>S.URI.revive(k.target))}));break;default:}}getOnWillRenameFileEvent(E){return this._createWillExecuteEvent(E,this._onWillRenameFile)}getOnWillCreateFileEvent(E){return this._createWillExecuteEvent(E,this._onWillCreateFile)}getOnWillDeleteFileEvent(E){return this._createWillExecuteEvent(E,this._onWillDeleteFile)}_createWillExecuteEvent(E,m){return(k,f,c)=>{const d=function(g){k.call(f,g)};return d.extension=E,m.event(d,void 0,c)}}async $onWillRunFileOperation(E,m,k,f){switch(E){case 2:return await this._fireWillEvent(this._onWillRenameFile,{files:m.map(c=>({oldUri:S.URI.revive(c.source),newUri:S.URI.revive(c.target)}))},k,f);case 1:return await this._fireWillEvent(this._onWillDeleteFile,{files:m.map(c=>S.URI.revive(c.target))},k,f);case 0:case 3:return await this._fireWillEvent(this._onWillCreateFile,{files:m.map(c=>S.URI.revive(c.target))},k,f)}}async _fireWillEvent(E,m,k,f){const c=new Set,d=[];if(await E.fireAsync(m,f,async(g,C)=>{const l=Date.now(),w=await Promise.resolve(g);w instanceof A.WorkspaceEdit&&(d.push([C.extension,w]),c.add(C.extension.displayName??C.extension.identifier.value)),Date.now()-l>k&&this._logService.warn("SLOW file-participant",C.extension.identifier)}),f.isCancellationRequested||d.length===0)return;const h={edits:[]};for(const[,g]of d){const{edits:C}=_.WorkspaceEdit.from(g,{getTextDocumentVersion:l=>this._extHostDocumentsAndEditors.getDocument(l)?.version,getNotebookDocumentVersion:()=>{}});h.edits=h.edits.concat(C)}return{edit:h,extensionNames:Array.from(c)}}}e.ExtHostFileSystemEventService=P}),define(Ce[200],Ie([1,0,2,37]),function(ie,e,r,y){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtHostInteractive=void 0;class S{constructor(_,A,b,P,O){this._extHostNotebooks=A,this._textDocumentsAndEditors=b,this._commands=P;const E=new y.ApiCommand("interactive.open","_interactive.open","Open interactive window and return notebook editor and input URI",[new y.ApiCommandArgument("showOptions","Show Options",m=>!0,m=>m),new y.ApiCommandArgument("resource","Interactive resource Uri",m=>!0,m=>m),new y.ApiCommandArgument("controllerId","Notebook controller Id",m=>!0,m=>m),new y.ApiCommandArgument("title","Interactive editor title",m=>!0,m=>m)],new y.ApiCommandResult("Notebook and input URI",m=>{if(O.debug("[ExtHostInteractive] open iw with notebook editor id",m.notebookEditorId),m.notebookEditorId!==void 0){const k=this._extHostNotebooks.getEditorById(m.notebookEditorId);return O.debug("[ExtHostInteractive] notebook editor found",k.id),{notebookUri:r.URI.revive(m.notebookUri),inputUri:r.URI.revive(m.inputUri),notebookEditor:k.apiEditor}}return O.debug("[ExtHostInteractive] notebook editor not found, uris for the interactive document",m.notebookUri,m.inputUri),{notebookUri:r.URI.revive(m.notebookUri),inputUri:r.URI.revive(m.inputUri)}}));this._commands.registerApiCommand(E)}$willAddInteractiveDocument(_,A,b,P){this._textDocumentsAndEditors.acceptDocumentsAndEditorsDelta({addedDocuments:[{EOL:A,lines:[""],languageId:b,uri:_,isDirty:!1,versionId:1,notebook:this._extHostNotebooks.getNotebookDocument(r.URI.revive(P))?.apiNotebook}]})}$willRemoveInteractiveDocument(_,A){this._textDocumentsAndEditors.acceptDocumentsAndEditorsDelta({removedDocuments:[_]})}}e.ExtHostInteractive=S}),define(Ce[201],Ie([1,0,7,4]),function(ie,e,r,y){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtHostLabelService=void 0;class S{constructor(_){this._handlePool=0,this._proxy=_.getProxy(y.MainContext.MainThreadLabelService)}$registerResourceLabelFormatter(_){const A=this._handlePool++;return this._proxy.$registerResourceLabelFormatter(A,_),(0,r.toDisposable)(()=>{this._proxy.$unregisterResourceLabelFormatter(A)})}}e.ExtHostLabelService=S}),define(Ce[202],Ie([1,0,2,26,8,6,66,4,9,49,18,10,245,20,7,79,74,61,203,12,15,25]),function(ie,e,r,y,S,M,_,A,b,P,O,E,m,k,f,c,d,h,g,C,l,w){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtHostLanguageFeatures=e.DocumentRangeSemanticTokensAdapter=e.DocumentSemanticTokensAdapter=void 0;class t{constructor(I,U){this._documents=I,this._provider=U}async provideDocumentSymbols(I,U){const H=this._documents.getDocument(I),j=await this._provider.provideDocumentSymbols(H,U);if(!(0,O.isFalsyOrEmpty)(j))return j[0]instanceof M.DocumentSymbol?j.map(S.DocumentSymbol.from):t._asDocumentSymbolTree(j)}static _asDocumentSymbolTree(I){I=I.slice(0).sort((j,se)=>{let le=j.location.range.start.compareTo(se.location.range.start);return le===0&&(le=se.location.range.end.compareTo(j.location.range.end)),le});const U=[],H=[];for(const j of I){const se={name:j.name||"!!MISSING: name!!",kind:S.SymbolKind.from(j.kind),tags:j.tags?.map(S.SymbolTag.from)||[],detail:"",containerName:j.containerName,range:S.Range.from(j.location.range),selectionRange:S.Range.from(j.location.range),children:[]};for(;;){if(H.length===0){H.push(se),U.push(se);break}const le=H[H.length-1];if(P.Range.containsRange(le.range,se.range)&&!P.Range.equalsRange(le.range,se.range)){le.children?.push(se),H.push(se);break}H.pop()}}return U}}class u{constructor(I,U,H){this._documents=I,this._commands=U,this._provider=H,this._cache=new h.Cache("CodeLens"),this._disposables=new Map}async provideCodeLenses(I,U){const H=this._documents.getDocument(I),j=await this._provider.provideCodeLenses(H,U);if(!j||U.isCancellationRequested)return;const se=this._cache.add(j),le=new f.DisposableStore;this._disposables.set(se,le);const Y={cacheId:se,lenses:[]};for(let ve=0;ve<j.length;ve++)Y.lenses.push({cacheId:[se,ve],range:S.Range.from(j[ve].range),command:this._commands.toInternal(j[ve].command,le)});return Y}async resolveCodeLens(I,U){const H=I.cacheId&&this._cache.get(...I.cacheId);if(!H)return;let j;if(typeof this._provider.resolveCodeLens!="function"||H.isResolved?j=H:j=await this._provider.resolveCodeLens(H,U),j||(j=H),U.isCancellationRequested)return;const se=I.cacheId&&this._disposables.get(I.cacheId[0]);if(!!se)return I.command=this._commands.toInternal(j.command??u._badCmd,se),I}releaseCodeLenses(I){this._disposables.get(I)?.dispose(),this._disposables.delete(I),this._cache.delete(I)}}u._badCmd={command:"missing",title:"!!MISSING: command!!"};function i(J){return Array.isArray(J)?J.map(S.DefinitionLink.from):J?[S.DefinitionLink.from(J)]:[]}class n{constructor(I,U){this._documents=I,this._provider=U}async provideDefinition(I,U,H){const j=this._documents.getDocument(I),se=S.Position.to(U),le=await this._provider.provideDefinition(j,se,H);return i(le)}}class s{constructor(I,U){this._documents=I,this._provider=U}async provideDeclaration(I,U,H){const j=this._documents.getDocument(I),se=S.Position.to(U),le=await this._provider.provideDeclaration(j,se,H);return i(le)}}class a{constructor(I,U){this._documents=I,this._provider=U}async provideImplementation(I,U,H){const j=this._documents.getDocument(I),se=S.Position.to(U),le=await this._provider.provideImplementation(j,se,H);return i(le)}}class o{constructor(I,U){this._documents=I,this._provider=U}async provideTypeDefinition(I,U,H){const j=this._documents.getDocument(I),se=S.Position.to(U),le=await this._provider.provideTypeDefinition(j,se,H);return i(le)}}class v{constructor(I,U){this._documents=I,this._provider=U}async provideHover(I,U,H){const j=this._documents.getDocument(I),se=S.Position.to(U),le=await this._provider.provideHover(j,se,H);if(!(!le||(0,O.isFalsyOrEmpty)(le.contents)))return le.range||(le.range=j.getWordRangeAtPosition(se)),le.range||(le.range=new M.Range(se,se)),S.Hover.from(le)}}class p{constructor(I,U){this._documents=I,this._provider=U}async provideEvaluatableExpression(I,U,H){const j=this._documents.getDocument(I),se=S.Position.to(U),le=await this._provider.provideEvaluatableExpression(j,se,H);if(le)return S.EvaluatableExpression.from(le)}}class T{constructor(I,U){this._documents=I,this._provider=U}async provideInlineValues(I,U,H,j){const se=this._documents.getDocument(I),le=await this._provider.provideInlineValues(se,S.Range.to(U),S.InlineValueContext.to(H),j);if(Array.isArray(le))return le.map(Y=>S.InlineValue.from(Y))}}class N{constructor(I,U){this._documents=I,this._provider=U}async provideDocumentHighlights(I,U,H){const j=this._documents.getDocument(I),se=S.Position.to(U),le=await this._provider.provideDocumentHighlights(j,se,H);if(Array.isArray(le))return le.map(S.DocumentHighlight.from)}}class V{constructor(I,U){this._documents=I,this._provider=U}async provideLinkedEditingRanges(I,U,H){const j=this._documents.getDocument(I),se=S.Position.to(U),le=await this._provider.provideLinkedEditingRanges(j,se,H);if(le&&Array.isArray(le.ranges))return{ranges:(0,O.coalesce)(le.ranges.map(S.Range.from)),wordPattern:le.wordPattern}}}class B{constructor(I,U){this._documents=I,this._provider=U}async provideReferences(I,U,H,j){const se=this._documents.getDocument(I),le=S.Position.to(U),Y=await this._provider.provideReferences(se,le,H,j);if(Array.isArray(Y))return Y.map(S.location.from)}}class D{constructor(I,U,H,j,se,le,Y){this._documents=I,this._commands=U,this._diagnostics=H,this._provider=j,this._logService=se,this._extension=le,this._apiDeprecation=Y,this._cache=new h.Cache("CodeAction"),this._disposables=new Map}async provideCodeActions(I,U,H,j){const se=this._documents.getDocument(I),le=m.Selection.isISelection(U)?S.Selection.to(U):S.Range.to(U),Y=[];for(const Ge of this._diagnostics.getDiagnostics(I))if(le.intersection(Ge.range)&&Y.push(Ge)>D._maxCodeActionsPerFile)break;const ve={diagnostics:Y,only:H.only?new M.CodeActionKind(H.only):void 0,triggerKind:S.CodeActionTriggerKind.to(H.trigger)},pe=await this._provider.provideCodeActions(se,le,ve,j);if(!(0,O.isNonEmptyArray)(pe)||j.isCancellationRequested)return;const Me=this._cache.add(pe),xe=new f.DisposableStore;this._disposables.set(Me,xe);const Ye=[];for(let Ge=0;Ge<pe.length;Ge++){const Te=pe[Ge];!Te||(D._isCommand(Te)?(this._apiDeprecation.report("CodeActionProvider.provideCodeActions - return commands",this._extension,"Return 'CodeAction' instances instead."),Ye.push({_isSynthetic:!0,title:Te.title,command:this._commands.toInternal(Te,xe)})):(ve.only&&(Te.kind?ve.only.contains(Te.kind)||this._logService.warn(`${this._extension.identifier.value} - Code actions of kind '${ve.only.value} 'requested but returned code action is of kind '${Te.kind.value}'. Code action will be dropped. Please check 'CodeActionContext.only' to only return requested code actions.`):this._logService.warn(`${this._extension.identifier.value} - Code actions of kind '${ve.only.value} 'requested but returned code action does not have a 'kind'. Code action will be dropped. Please set 'CodeAction.kind'.`)),Ye.push({cacheId:[Me,Ge],title:Te.title,command:Te.command&&this._commands.toInternal(Te.command,xe),diagnostics:Te.diagnostics&&Te.diagnostics.map(S.Diagnostic.from),edit:Te.edit&&S.WorkspaceEdit.from(Te.edit,void 0),kind:Te.kind&&Te.kind.value,isPreferred:Te.isPreferred,disabled:Te.disabled?.reason})))}return{cacheId:Me,actions:Ye}}async resolveCodeAction(I,U){const[H,j]=I,se=this._cache.get(H,j);if(!se||D._isCommand(se)||!this._provider.resolveCodeAction)return;const le=await this._provider.resolveCodeAction(se,U)??se;return le?.edit?S.WorkspaceEdit.from(le.edit,void 0):void 0}releaseCodeActions(I){this._disposables.get(I)?.dispose(),this._disposables.delete(I),this._cache.delete(I)}static _isCommand(I){return typeof I.command=="string"&&typeof I.title=="string"}}D._maxCodeActionsPerFile=1e3;class z{constructor(I,U,H,j){this._proxy=I,this._documents=U,this._provider=H,this._handle=j}async prepareDocumentPaste(I,U,H,j){if(!this._provider.prepareDocumentPaste)return;const se=this._documents.getDocument(I),le=U.map(ve=>S.Range.to(ve)),Y=S.DataTransfer.toDataTransfer(H,()=>{throw new C.NotImplementedError});return await this._provider.prepareDocumentPaste(se,le,Y,j),S.DataTransfer.toDataTransferDTO(Y)}async providePasteEdits(I,U,H,j,se){const le=this._documents.getDocument(U),Y=H.map(Me=>S.Range.to(Me)),ve=S.DataTransfer.toDataTransfer(j,async Me=>(await this._proxy.$resolvePasteFileData(this._handle,I,Me)).buffer),pe=await this._provider.provideDocumentPasteEdits(le,Y,ve,se);if(!!pe)return{insertText:typeof pe.insertText=="string"?pe.insertText:{snippet:pe.insertText.value},additionalEdit:pe.additionalEdit?S.WorkspaceEdit.from(pe.additionalEdit,void 0):void 0}}}class L{constructor(I,U){this._documents=I,this._provider=U}async provideDocumentFormattingEdits(I,U,H){const j=this._documents.getDocument(I),se=await this._provider.provideDocumentFormattingEdits(j,U,H);if(Array.isArray(se))return se.map(S.TextEdit.from)}}class R{constructor(I,U){this._documents=I,this._provider=U}async provideDocumentRangeFormattingEdits(I,U,H,j){const se=this._documents.getDocument(I),le=S.Range.to(U),Y=await this._provider.provideDocumentRangeFormattingEdits(se,le,H,j);if(Array.isArray(Y))return Y.map(S.TextEdit.from)}}class K{constructor(I,U){this._documents=I,this._provider=U,this.autoFormatTriggerCharacters=[]}async provideOnTypeFormattingEdits(I,U,H,j,se){const le=this._documents.getDocument(I),Y=S.Position.to(U),ve=await this._provider.provideOnTypeFormattingEdits(le,Y,H,j,se);if(Array.isArray(ve))return ve.map(S.TextEdit.from)}}class W{constructor(I,U){this._provider=I,this._logService=U,this._cache=new h.Cache("WorkspaceSymbols")}async provideWorkspaceSymbols(I,U){const H=await this._provider.provideWorkspaceSymbols(I,U);if(!(0,O.isNonEmptyArray)(H))return{symbols:[]};const j=this._cache.add(H),se={cacheId:j,symbols:[]};for(let le=0;le<H.length;le++){const Y=H[le];if(!Y||!Y.name){this._logService.warn("INVALID SymbolInformation",Y);continue}se.symbols.push({...S.WorkspaceSymbol.from(Y),cacheId:[j,le]})}return se}async resolveWorkspaceSymbol(I,U){if(typeof this._provider.resolveWorkspaceSymbol!="function"||!I.cacheId)return I;const H=this._cache.get(...I.cacheId);if(H){const j=await this._provider.resolveWorkspaceSymbol(H,U);return j&&(0,y.mixin)(I,S.WorkspaceSymbol.from(j),!0)}}releaseWorkspaceSymbols(I){this._cache.delete(I)}}class ${static supportsResolving(I){return typeof I.prepareRename=="function"}constructor(I,U,H){this._documents=I,this._provider=U,this._logService=H}async provideRenameEdits(I,U,H,j){const se=this._documents.getDocument(I),le=S.Position.to(U);try{const Y=await this._provider.provideRenameEdits(se,le,H,j);return Y?S.WorkspaceEdit.from(Y):void 0}catch(Y){const ve=$._asMessage(Y);return ve?{rejectReason:ve,edits:void 0}:Promise.reject(Y)}}async resolveRenameLocation(I,U,H){if(typeof this._provider.prepareRename!="function")return Promise.resolve(void 0);const j=this._documents.getDocument(I),se=S.Position.to(U);try{const le=await this._provider.prepareRename(j,se,H);let Y,ve;if(M.Range.isRange(le)?(Y=le,ve=j.getText(le)):(0,E.isObject)(le)&&(Y=le.range,ve=le.placeholder),!Y||!ve)return;if(Y.start.line>se.line||Y.end.line<se.line){this._logService.warn("INVALID rename location: position line must be within range start/end lines");return}return{range:S.Range.from(Y),text:ve}}catch(le){const Y=$._asMessage(le);return Y?{rejectReason:Y,range:void 0,text:void 0}:Promise.reject(le)}}static _asMessage(I){return typeof I=="string"?I:I instanceof Error&&typeof I.message=="string"?I.message:void 0}}class G{constructor(I,U){this.resultId=I,this.tokens=U}}class ne{constructor(I,U){this._documents=I,this._provider=U,this._nextResultId=1,this._previousResults=new Map}async provideDocumentSemanticTokens(I,U,H){const j=this._documents.getDocument(I),se=U!==0?this._previousResults.get(U):null;let le=typeof se?.resultId=="string"&&typeof this._provider.provideDocumentSemanticTokensEdits=="function"?await this._provider.provideDocumentSemanticTokensEdits(j,se.resultId,H):await this._provider.provideDocumentSemanticTokens(j,H);return se&&this._previousResults.delete(U),le?(le=ne._fixProvidedSemanticTokens(le),this._send(ne._convertToEdits(se,le),le)):null}async releaseDocumentSemanticColoring(I){this._previousResults.delete(I)}static _fixProvidedSemanticTokens(I){return ne._isSemanticTokens(I)?ne._isCorrectSemanticTokens(I)?I:new M.SemanticTokens(new Uint32Array(I.data),I.resultId):ne._isSemanticTokensEdits(I)?ne._isCorrectSemanticTokensEdits(I)?I:new M.SemanticTokensEdits(I.edits.map(U=>new M.SemanticTokensEdit(U.start,U.deleteCount,U.data?new Uint32Array(U.data):U.data)),I.resultId):I}static _isSemanticTokens(I){return I&&!!I.data}static _isCorrectSemanticTokens(I){return I.data instanceof Uint32Array}static _isSemanticTokensEdits(I){return I&&Array.isArray(I.edits)}static _isCorrectSemanticTokensEdits(I){for(const U of I.edits)if(!(U.data instanceof Uint32Array))return!1;return!0}static _convertToEdits(I,U){if(!ne._isSemanticTokens(U)||!I||!I.tokens)return U;const H=I.tokens,j=H.length,se=U.data,le=se.length;let Y=0;const ve=Math.min(j,le);for(;Y<ve&&H[Y]===se[Y];)Y++;if(Y===j&&Y===le)return new M.SemanticTokensEdits([],U.resultId);let pe=0;const Me=ve-Y;for(;pe<Me&&H[j-pe-1]===se[le-pe-1];)pe++;return new M.SemanticTokensEdits([{start:Y,deleteCount:j-Y-pe,data:se.subarray(Y,le-pe)}],U.resultId)}_send(I,U){if(ne._isSemanticTokens(I)){const H=this._nextResultId++;return this._previousResults.set(H,new G(I.resultId,I.data)),(0,c.encodeSemanticTokensDto)({id:H,type:"full",data:I.data})}if(ne._isSemanticTokensEdits(I)){const H=this._nextResultId++;return ne._isSemanticTokens(U)?this._previousResults.set(H,new G(U.resultId,U.data)):this._previousResults.set(H,new G(I.resultId)),(0,c.encodeSemanticTokensDto)({id:H,type:"delta",deltas:(I.edits||[]).map(j=>({start:j.start,deleteCount:j.deleteCount,data:j.data}))})}return null}}e.DocumentSemanticTokensAdapter=ne;class ge{constructor(I,U){this._documents=I,this._provider=U}async provideDocumentRangeSemanticTokens(I,U,H){const j=this._documents.getDocument(I),se=await this._provider.provideDocumentRangeSemanticTokens(j,S.Range.to(U),H);return se?this._send(se):null}_send(I){return(0,c.encodeSemanticTokensDto)({id:0,type:"full",data:I.data})}}e.DocumentRangeSemanticTokensAdapter=ge;class oe{static supportsResolving(I){return typeof I.resolveCompletionItem=="function"}constructor(I,U,H,j,se){this._documents=I,this._commands=U,this._provider=H,this._apiDeprecation=j,this._extension=se,this._cache=new h.Cache("CompletionItem"),this._disposables=new Map}async provideCompletionItems(I,U,H,j){const se=this._documents.getDocument(I),le=S.Position.to(U),Y=se.getWordRangeAtPosition(le)||new M.Range(le,le),ve=Y.with({end:le}),pe=new g.StopWatch(!0),Me=await this._provider.provideCompletionItems(se,le,j,S.CompletionContext.to(H));if(!Me||j.isCancellationRequested)return;const xe=Array.isArray(Me)?new M.CompletionList(Me):Me,Ye=oe.supportsResolving(this._provider)?this._cache.add(xe.items):this._cache.add([]),Ge=new f.DisposableStore;this._disposables.set(Ye,Ge);const Te=[],rt={x:Ye,b:Te,a:{replace:S.Range.from(Y),insert:S.Range.from(ve)},c:xe.isIncomplete||void 0,d:pe.elapsed()};for(let X=0;X<xe.items.length;X++){const Q=xe.items[X],he=this._convertCompletionItem(Q,[Ye,X],ve,Y);Te.push(he)}return rt}async resolveCompletionItem(I,U){if(typeof this._provider.resolveCompletionItem!="function")return;const H=this._cache.get(...I);if(!H)return;const j=await this._provider.resolveCompletionItem(H,U);if(!!j)return this._convertCompletionItem(j,I)}releaseCompletionItems(I){this._disposables.get(I)?.dispose(),this._disposables.delete(I),this._cache.delete(I)}_convertCompletionItem(I,U,H,j){const se=this._disposables.get(U[0]);if(!se)throw Error("DisposableStore is missing...");const le={x:U,a:I.label,b:I.kind!==void 0?S.CompletionItemKind.from(I.kind):void 0,n:I.tags&&I.tags.map(S.CompletionItemTag.from),c:I.detail,d:typeof I.documentation>"u"?void 0:S.MarkdownString.fromStrict(I.documentation),e:I.sortText!==I.label?I.sortText:void 0,f:I.filterText!==I.label?I.filterText:void 0,g:I.preselect||void 0,i:I.keepWhitespace?1:0,k:I.commitCharacters,l:I.additionalTextEdits&&I.additionalTextEdits.map(S.TextEdit.from),m:this._commands.toInternal(I.command,se)};I.textEdit?(this._apiDeprecation.report("CompletionItem.textEdit",this._extension,"Use 'CompletionItem.insertText' and 'CompletionItem.range' instead."),le.h=I.textEdit.newText):typeof I.insertText=="string"?le.h=I.insertText:I.insertText instanceof M.SnippetString&&(le.h=I.insertText.value,le.i|=4);let Y;return I.textEdit?Y=I.textEdit.range:I.range&&(Y=I.range),M.Range.isRange(Y)?le.j=S.Range.from(Y):Y&&(!H?.isEqual(Y.inserting)||!j?.isEqual(Y.replacing))&&(le.j={insert:S.Range.from(Y.inserting),replace:S.Range.from(Y.replacing)}),le}}class Ee{async provideInlineCompletions(I,U,H,j){}disposeCompletions(I){}handleDidShowCompletionItem(I,U){}}class ce extends Ee{constructor(I,U,H,j){super(),this._extension=I,this._documents=U,this._provider=H,this._commands=j,this._references=new ee,this._isAdditionsProposedApiEnabled=(0,w.isProposedApiEnabled)(this._extension,"inlineCompletionsAdditions"),this.languageTriggerKindToVSCodeTriggerKind={[_.InlineCompletionTriggerKind.Automatic]:M.InlineCompletionTriggerKind.Automatic,[_.InlineCompletionTriggerKind.Explicit]:M.InlineCompletionTriggerKind.Invoke}}get supportsHandleDidShowCompletionItem(){return(0,w.isProposedApiEnabled)(this._extension,"inlineCompletionsAdditions")&&typeof this._provider.handleDidShowCompletionItem=="function"}async provideInlineCompletions(I,U,H,j){const se=this._documents.getDocument(I),le=S.Position.to(U),Y=await this._provider.provideInlineCompletionItems(se,le,{selectedCompletionInfo:H.selectedSuggestionInfo?{range:S.Range.to(H.selectedSuggestionInfo.range),text:H.selectedSuggestionInfo.text}:void 0,triggerKind:this.languageTriggerKindToVSCodeTriggerKind[H.triggerKind]},j);if(!Y||j.isCancellationRequested)return;const ve=Array.isArray(Y)?Y:Y.items,pe=this._isAdditionsProposedApiEnabled?Array.isArray(Y)?[]:Y.commands||[]:[];let Me;return{pid:this._references.createReferenceId({dispose(){Me?.dispose()},items:ve}),items:ve.map((Ye,Ge)=>{let Te;Ye.command&&(Me||(Me=new f.DisposableStore),Te=this._commands.toInternal(Ye.command,Me));const rt=Ye.insertText;return{insertText:typeof rt=="string"?rt:{snippet:rt.value},filterText:Ye.filterText,range:Ye.range?S.Range.from(Ye.range):void 0,command:Te,idx:Ge,completeBracketPairs:this._isAdditionsProposedApiEnabled?Ye.completeBracketPairs:!1}}),commands:pe.map(Ye=>(Me||(Me=new f.DisposableStore),this._commands.toInternal(Ye,Me)))}}disposeCompletions(I){this._references.disposeReferenceId(I)?.dispose()}handleDidShowCompletionItem(I,U){const H=this._references.get(I)?.items[U];H&&this._provider.handleDidShowCompletionItem&&this._isAdditionsProposedApiEnabled&&this._provider.handleDidShowCompletionItem(H)}}class me extends Ee{constructor(I,U,H,j){super(),this.extension=I,this._documents=U,this._provider=H,this._commands=j,this._references=new ee,this.isAdditionProposedApiEnabled=(0,w.isProposedApiEnabled)(this.extension,"inlineCompletionsAdditions"),this.languageTriggerKindToVSCodeTriggerKind={[_.InlineCompletionTriggerKind.Automatic]:M.InlineCompletionTriggerKindNew.Automatic,[_.InlineCompletionTriggerKind.Explicit]:M.InlineCompletionTriggerKindNew.Invoke}}async provideInlineCompletions(I,U,H,j){const se=this._documents.getDocument(I),le=S.Position.to(U),Y=await this._provider.provideInlineCompletionItems(se,le,{selectedCompletionInfo:H.selectedSuggestionInfo?{range:S.Range.to(H.selectedSuggestionInfo.range),text:H.selectedSuggestionInfo.text}:void 0,triggerKind:this.languageTriggerKindToVSCodeTriggerKind[H.triggerKind]},j);if(!Y||j.isCancellationRequested)return;const ve=Array.isArray(Y)?Y:Y.items,pe=Array.isArray(Y)?[]:Y.commands||[];let Me;return{pid:this._references.createReferenceId({dispose(){Me?.dispose()},items:ve}),items:ve.map((Ye,Ge)=>{let Te;Ye.command&&(Me||(Me=new f.DisposableStore),Te=this._commands.toInternal(Ye.command,Me));const rt=Ye.insertText;return{insertText:typeof rt=="string"?rt:{snippet:rt.value},filterText:Ye.filterText,range:Ye.range?S.Range.from(Ye.range):void 0,command:Te,idx:Ge,completeBracketPairs:this.isAdditionProposedApiEnabled?Ye.completeBracketPairs:!1}}),commands:pe.map(Ye=>(Me||(Me=new f.DisposableStore),this._commands.toInternal(Ye,Me)))}}disposeCompletions(I){this._references.disposeReferenceId(I)?.dispose()}handleDidShowCompletionItem(I,U){const H=this._references.get(I)?.items[U];H&&this._provider.handleDidShowCompletionItem&&this.isAdditionProposedApiEnabled&&this._provider.handleDidShowCompletionItem(H)}}class ee{constructor(){this._references=new Map,this._idPool=1}createReferenceId(I){const U=this._idPool++;return this._references.set(U,I),U}disposeReferenceId(I){const U=this._references.get(I);return this._references.delete(I),U}get(I){return this._references.get(I)}}class be{constructor(I,U){this._documents=I,this._provider=U,this._cache=new h.Cache("SignatureHelp")}async provideSignatureHelp(I,U,H,j){const se=this._documents.getDocument(I),le=S.Position.to(U),Y=this.reviveContext(H),ve=await this._provider.provideSignatureHelp(se,le,j,Y);if(ve){const pe=this._cache.add([ve]);return{...S.SignatureHelp.from(ve),id:pe}}}reviveContext(I){let U;if(I.activeSignatureHelp){const H=S.SignatureHelp.to(I.activeSignatureHelp),j=this._cache.get(I.activeSignatureHelp.id,0);j?(U=j,U.activeSignature=H.activeSignature,U.activeParameter=H.activeParameter):U=H}return{...I,activeSignatureHelp:U}}releaseSignatureHelp(I){this._cache.delete(I)}}class _e{constructor(I,U,H,j,se){this._documents=I,this._commands=U,this._provider=H,this._logService=j,this._extension=se,this._cache=new h.Cache("InlayHints"),this._disposables=new Map}async provideInlayHints(I,U,H){const j=this._documents.getDocument(I),se=S.Range.to(U),le=await this._provider.provideInlayHints(j,se,H);if(!Array.isArray(le)||le.length===0){this._logService.trace(`[InlayHints] NO inlay hints from '${this._extension.identifier.value}' for ${U}`);return}if(H.isCancellationRequested)return;const Y=this._cache.add(le);this._disposables.set(Y,new f.DisposableStore);const ve={hints:[],cacheId:Y};for(let pe=0;pe<le.length;pe++)this._isValidInlayHint(le[pe],se)&&ve.hints.push(this._convertInlayHint(le[pe],[Y,pe]));return this._logService.trace(`[InlayHints] ${ve.hints.length} inlay hints from '${this._extension.identifier.value}' for ${U}`),ve}async resolveInlayHint(I,U){if(typeof this._provider.resolveInlayHint!="function")return;const H=this._cache.get(...I);if(!H)return;const j=await this._provider.resolveInlayHint(H,U);if(!!j&&!!this._isValidInlayHint(j))return this._convertInlayHint(j,I)}releaseHints(I){this._disposables.get(I)?.dispose(),this._disposables.delete(I),this._cache.delete(I)}_isValidInlayHint(I,U){return I.label.length===0||Array.isArray(I.label)&&I.label.every(H=>H.value.length===0)?(console.log("INVALID inlay hint, empty label",I),!1):!(U&&!U.contains(I.position))}_convertInlayHint(I,U){const H=this._disposables.get(U[0]);if(!H)throw Error("DisposableStore is missing...");const j={label:"",cacheId:U,tooltip:S.MarkdownString.fromStrict(I.tooltip),position:S.Position.from(I.position),textEdits:I.textEdits&&I.textEdits.map(S.TextEdit.from),kind:I.kind&&S.InlayHintKind.from(I.kind),paddingLeft:I.paddingLeft,paddingRight:I.paddingRight};return typeof I.label=="string"?j.label=I.label:j.label=I.label.map(se=>{const le={label:se.value};return le.tooltip=S.MarkdownString.fromStrict(se.tooltip),M.Location.isLocation(se.location)&&(le.location=S.location.from(se.location)),se.command&&(le.command=this._commands.toInternal(se.command,H)),le}),j}}class Fe{constructor(I,U){this._documents=I,this._provider=U,this._cache=new h.Cache("DocumentLink")}async provideLinks(I,U){const H=this._documents.getDocument(I),j=await this._provider.provideDocumentLinks(H,U);if(!(!Array.isArray(j)||j.length===0)&&!U.isCancellationRequested){if(typeof this._provider.resolveDocumentLink!="function")return{links:j.filter(Fe._validateLink).map(S.DocumentLink.from)};{const se=this._cache.add(j),le={links:[],cacheId:se};for(let Y=0;Y<j.length;Y++){if(!Fe._validateLink(j[Y]))continue;const ve=S.DocumentLink.from(j[Y]);ve.cacheId=[se,Y],le.links.push(ve)}return le}}}static _validateLink(I){return I.target&&I.target.path.length>5e4?(console.warn("DROPPING link because it is too long"),!1):!0}async resolveLink(I,U){if(typeof this._provider.resolveDocumentLink!="function")return;const H=this._cache.get(...I);if(!H)return;const j=await this._provider.resolveDocumentLink(H,U);if(!(!j||!Fe._validateLink(j)))return S.DocumentLink.from(j)}releaseLinks(I){this._cache.delete(I)}}class Be{constructor(I,U){this._documents=I,this._provider=U}async provideColors(I,U){const H=this._documents.getDocument(I),j=await this._provider.provideDocumentColors(H,U);return Array.isArray(j)?j.map(le=>({color:S.Color.from(le.color),range:S.Range.from(le.range)})):[]}async provideColorPresentations(I,U,H){const j=this._documents.getDocument(I),se=S.Range.to(U.range),le=S.Color.to(U.color),Y=await this._provider.provideColorPresentations(le,{document:j,range:se},H);if(!!Array.isArray(Y))return Y.map(S.ColorPresentation.from)}}class Xe{constructor(I,U){this._documents=I,this._provider=U}async provideFoldingRanges(I,U,H){const j=this._documents.getDocument(I),se=await this._provider.provideFoldingRanges(j,U,H);if(!!Array.isArray(se))return se.map(S.FoldingRange.from)}}class ke{constructor(I,U,H){this._documents=I,this._provider=U,this._logService=H}async provideSelectionRanges(I,U,H){const j=this._documents.getDocument(I),se=U.map(S.Position.to),le=await this._provider.provideSelectionRanges(j,se,H);if(!(0,O.isNonEmptyArray)(le))return[];if(le.length!==se.length)return this._logService.warn("BAD selection ranges, provider must return ranges for each position"),[];const Y=[];for(let ve=0;ve<se.length;ve++){const pe=[];Y.push(pe);let Me=se[ve],xe=le[ve];for(;;){if(!xe.range.contains(Me))throw new Error("INVALID selection range, must contain the previous range");if(pe.push(S.SelectionRange.from(xe)),!xe.parent)break;Me=xe.range,xe=xe.parent}}return Y}}class ye{constructor(I,U){this._documents=I,this._provider=U,this._idPool=new d.IdGenerator(""),this._cache=new Map}async prepareSession(I,U,H){const j=this._documents.getDocument(I),se=S.Position.to(U),le=await this._provider.prepareCallHierarchy(j,se,H);if(!le)return;const Y=this._idPool.nextId();return this._cache.set(Y,new Map),Array.isArray(le)?le.map(ve=>this._cacheAndConvertItem(Y,ve)):[this._cacheAndConvertItem(Y,le)]}async provideCallsTo(I,U,H){const j=this._itemFromCache(I,U);if(!j)throw new Error("missing call hierarchy item");const se=await this._provider.provideCallHierarchyIncomingCalls(j,H);if(!!se)return se.map(le=>({from:this._cacheAndConvertItem(I,le.from),fromRanges:le.fromRanges.map(Y=>S.Range.from(Y))}))}async provideCallsFrom(I,U,H){const j=this._itemFromCache(I,U);if(!j)throw new Error("missing call hierarchy item");const se=await this._provider.provideCallHierarchyOutgoingCalls(j,H);if(!!se)return se.map(le=>({to:this._cacheAndConvertItem(I,le.to),fromRanges:le.fromRanges.map(Y=>S.Range.from(Y))}))}releaseSession(I){this._cache.delete(I)}_cacheAndConvertItem(I,U){const H=this._cache.get(I),j=S.CallHierarchyItem.from(U,I,H.size.toString(36));return H.set(j._itemId,U),j}_itemFromCache(I,U){return this._cache.get(I)?.get(U)}}class De{constructor(I,U){this._documents=I,this._provider=U,this._idPool=new d.IdGenerator(""),this._cache=new Map}async prepareSession(I,U,H){const j=this._documents.getDocument(I),se=S.Position.to(U),le=await this._provider.prepareTypeHierarchy(j,se,H);if(!le)return;const Y=this._idPool.nextId();return this._cache.set(Y,new Map),Array.isArray(le)?le.map(ve=>this._cacheAndConvertItem(Y,ve)):[this._cacheAndConvertItem(Y,le)]}async provideSupertypes(I,U,H){const j=this._itemFromCache(I,U);if(!j)throw new Error("missing type hierarchy item");const se=await this._provider.provideTypeHierarchySupertypes(j,H);if(!!se)return se.map(le=>this._cacheAndConvertItem(I,le))}async provideSubtypes(I,U,H){const j=this._itemFromCache(I,U);if(!j)throw new Error("missing type hierarchy item");const se=await this._provider.provideTypeHierarchySubtypes(j,H);if(!!se)return se.map(le=>this._cacheAndConvertItem(I,le))}releaseSession(I){this._cache.delete(I)}_cacheAndConvertItem(I,U){const H=this._cache.get(I),j=S.TypeHierarchyItem.from(U,I,H.size.toString(36));return H.set(j._itemId,U),j}_itemFromCache(I,U){return this._cache.get(I)?.get(U)}}class ae{constructor(I,U,H,j){this._proxy=I,this._documents=U,this._provider=H,this._handle=j}async provideDocumentOnDropEdits(I,U,H,j,se){const le=this._documents.getDocument(U),Y=S.Position.to(H),ve=S.DataTransfer.toDataTransfer(j,async Me=>(await this._proxy.$resolveDocumentOnDropFileData(this._handle,I,Me)).buffer),pe=await this._provider.provideDocumentDropEdits(le,Y,ve,se);if(!!pe)return{insertText:typeof pe.insertText=="string"?pe.insertText:{snippet:pe.insertText.value},additionalEdit:pe.additionalEdit?S.WorkspaceEdit.from(pe.additionalEdit,void 0):void 0}}}class ue{constructor(I,U){this.adapter=I,this.extension=U}}class Z{constructor(I,U,H,j,se,le,Y){this._adapter=new Map,this._uriTransformer=U,this._proxy=I.getProxy(A.MainContext.MainThreadLanguageFeatures),this._documents=H,this._commands=j,this._diagnostics=se,this._logService=le,this._apiDeprecation=Y}_transformDocumentSelector(I){return S.DocumentSelector.from(I,this._uriTransformer)}_createDisposable(I){return new M.Disposable(()=>{this._adapter.delete(I),this._proxy.$unregister(I)})}_nextHandle(){return Z._handlePool++}async _withAdapter(I,U,H,j,se,le=!1){const Y=this._adapter.get(I);if(!Y||!(Y.adapter instanceof U))return j;const ve=Date.now();le||this._logService.trace(`[${Y.extension.identifier.value}] INVOKE provider '${H.toString().replace(/[\r\n]/g,"")}'`);const pe=H(Y.adapter,Y.extension);return Promise.resolve(pe).catch(Me=>{(0,C.isCancellationError)(Me)||(this._logService.error(`[${Y.extension.identifier.value}] provider FAILED`),this._logService.error(Me))}).finally(()=>{le||this._logService.trace(`[${Y.extension.identifier.value}] provider DONE after ${Date.now()-ve}ms`)}),k.CancellationToken.isCancellationToken(se)?(0,l.raceCancellationError)(pe,se):pe}_addNewAdapter(I,U){const H=this._nextHandle();return this._adapter.set(H,new ue(I,U)),H}static _extLabel(I){return I.displayName||I.name}registerDocumentSymbolProvider(I,U,H,j){const se=this._addNewAdapter(new t(this._documents,H),I),le=j&&j.label||Z._extLabel(I);return this._proxy.$registerDocumentSymbolProvider(se,this._transformDocumentSelector(U),le),this._createDisposable(se)}$provideDocumentSymbols(I,U,H){return this._withAdapter(I,t,j=>j.provideDocumentSymbols(r.URI.revive(U),H),void 0,H)}registerCodeLensProvider(I,U,H){const j=this._nextHandle(),se=typeof H.onDidChangeCodeLenses=="function"?this._nextHandle():void 0;this._adapter.set(j,new ue(new u(this._documents,this._commands.converter,H),I)),this._proxy.$registerCodeLensSupport(j,this._transformDocumentSelector(U),se);let le=this._createDisposable(j);if(se!==void 0){const Y=H.onDidChangeCodeLenses(ve=>this._proxy.$emitCodeLensEvent(se));le=M.Disposable.from(le,Y)}return le}$provideCodeLenses(I,U,H){return this._withAdapter(I,u,j=>j.provideCodeLenses(r.URI.revive(U),H),void 0,H)}$resolveCodeLens(I,U,H){return this._withAdapter(I,u,j=>j.resolveCodeLens(U,H),void 0,void 0)}$releaseCodeLenses(I,U){this._withAdapter(I,u,H=>Promise.resolve(H.releaseCodeLenses(U)),void 0,void 0)}registerDefinitionProvider(I,U,H){const j=this._addNewAdapter(new n(this._documents,H),I);return this._proxy.$registerDefinitionSupport(j,this._transformDocumentSelector(U)),this._createDisposable(j)}$provideDefinition(I,U,H,j){return this._withAdapter(I,n,se=>se.provideDefinition(r.URI.revive(U),H,j),[],j)}registerDeclarationProvider(I,U,H){const j=this._addNewAdapter(new s(this._documents,H),I);return this._proxy.$registerDeclarationSupport(j,this._transformDocumentSelector(U)),this._createDisposable(j)}$provideDeclaration(I,U,H,j){return this._withAdapter(I,s,se=>se.provideDeclaration(r.URI.revive(U),H,j),[],j)}registerImplementationProvider(I,U,H){const j=this._addNewAdapter(new a(this._documents,H),I);return this._proxy.$registerImplementationSupport(j,this._transformDocumentSelector(U)),this._createDisposable(j)}$provideImplementation(I,U,H,j){return this._withAdapter(I,a,se=>se.provideImplementation(r.URI.revive(U),H,j),[],j)}registerTypeDefinitionProvider(I,U,H){const j=this._addNewAdapter(new o(this._documents,H),I);return this._proxy.$registerTypeDefinitionSupport(j,this._transformDocumentSelector(U)),this._createDisposable(j)}$provideTypeDefinition(I,U,H,j){return this._withAdapter(I,o,se=>se.provideTypeDefinition(r.URI.revive(U),H,j),[],j)}registerHoverProvider(I,U,H,j){const se=this._addNewAdapter(new v(this._documents,H),I);return this._proxy.$registerHoverProvider(se,this._transformDocumentSelector(U)),this._createDisposable(se)}$provideHover(I,U,H,j){return this._withAdapter(I,v,se=>se.provideHover(r.URI.revive(U),H,j),void 0,j)}registerEvaluatableExpressionProvider(I,U,H,j){const se=this._addNewAdapter(new p(this._documents,H),I);return this._proxy.$registerEvaluatableExpressionProvider(se,this._transformDocumentSelector(U)),this._createDisposable(se)}$provideEvaluatableExpression(I,U,H,j){return this._withAdapter(I,p,se=>se.provideEvaluatableExpression(r.URI.revive(U),H,j),void 0,j)}registerInlineValuesProvider(I,U,H,j){const se=typeof H.onDidChangeInlineValues=="function"?this._nextHandle():void 0,le=this._addNewAdapter(new T(this._documents,H),I);this._proxy.$registerInlineValuesProvider(le,this._transformDocumentSelector(U),se);let Y=this._createDisposable(le);if(se!==void 0){const ve=H.onDidChangeInlineValues(pe=>this._proxy.$emitInlineValuesEvent(se));Y=M.Disposable.from(Y,ve)}return Y}$provideInlineValues(I,U,H,j,se){return this._withAdapter(I,T,le=>le.provideInlineValues(r.URI.revive(U),H,j,se),void 0,se)}registerDocumentHighlightProvider(I,U,H){const j=this._addNewAdapter(new N(this._documents,H),I);return this._proxy.$registerDocumentHighlightProvider(j,this._transformDocumentSelector(U)),this._createDisposable(j)}$provideDocumentHighlights(I,U,H,j){return this._withAdapter(I,N,se=>se.provideDocumentHighlights(r.URI.revive(U),H,j),void 0,j)}registerLinkedEditingRangeProvider(I,U,H){const j=this._addNewAdapter(new V(this._documents,H),I);return this._proxy.$registerLinkedEditingRangeProvider(j,this._transformDocumentSelector(U)),this._createDisposable(j)}$provideLinkedEditingRanges(I,U,H,j){return this._withAdapter(I,V,async se=>{const le=await se.provideLinkedEditingRanges(r.URI.revive(U),H,j);if(le)return{ranges:le.ranges,wordPattern:le.wordPattern?Z._serializeRegExp(le.wordPattern):void 0}},void 0,j)}registerReferenceProvider(I,U,H){const j=this._addNewAdapter(new B(this._documents,H),I);return this._proxy.$registerReferenceSupport(j,this._transformDocumentSelector(U)),this._createDisposable(j)}$provideReferences(I,U,H,j,se){return this._withAdapter(I,B,le=>le.provideReferences(r.URI.revive(U),H,j,se),void 0,se)}registerCodeActionProvider(I,U,H,j){const se=new f.DisposableStore,le=this._addNewAdapter(new D(this._documents,this._commands.converter,this._diagnostics,H,this._logService,I,this._apiDeprecation),I);return this._proxy.$registerQuickFixSupport(le,this._transformDocumentSelector(U),{providedKinds:j?.providedCodeActionKinds?.map(Y=>Y.value),documentation:j?.documentation?.map(Y=>({kind:Y.kind.value,command:this._commands.converter.toInternal(Y.command,se)}))},Z._extLabel(I),Boolean(H.resolveCodeAction)),se.add(this._createDisposable(le)),se}$provideCodeActions(I,U,H,j,se){return this._withAdapter(I,D,le=>le.provideCodeActions(r.URI.revive(U),H,j,se),void 0,se)}$resolveCodeAction(I,U,H){return this._withAdapter(I,D,j=>j.resolveCodeAction(U,H),void 0,void 0)}$releaseCodeActions(I,U){this._withAdapter(I,D,H=>Promise.resolve(H.releaseCodeActions(U)),void 0,void 0)}registerDocumentFormattingEditProvider(I,U,H){const j=this._addNewAdapter(new L(this._documents,H),I);return this._proxy.$registerDocumentFormattingSupport(j,this._transformDocumentSelector(U),I.identifier,I.displayName||I.name),this._createDisposable(j)}$provideDocumentFormattingEdits(I,U,H,j){return this._withAdapter(I,L,se=>se.provideDocumentFormattingEdits(r.URI.revive(U),H,j),void 0,j)}registerDocumentRangeFormattingEditProvider(I,U,H){const j=this._addNewAdapter(new R(this._documents,H),I);return this._proxy.$registerRangeFormattingSupport(j,this._transformDocumentSelector(U),I.identifier,I.displayName||I.name),this._createDisposable(j)}$provideDocumentRangeFormattingEdits(I,U,H,j,se){return this._withAdapter(I,R,le=>le.provideDocumentRangeFormattingEdits(r.URI.revive(U),H,j,se),void 0,se)}registerOnTypeFormattingEditProvider(I,U,H,j){const se=this._addNewAdapter(new K(this._documents,H),I);return this._proxy.$registerOnTypeFormattingSupport(se,this._transformDocumentSelector(U),j,I.identifier),this._createDisposable(se)}$provideOnTypeFormattingEdits(I,U,H,j,se,le){return this._withAdapter(I,K,Y=>Y.provideOnTypeFormattingEdits(r.URI.revive(U),H,j,se,le),void 0,le)}registerWorkspaceSymbolProvider(I,U){const H=this._addNewAdapter(new W(U,this._logService),I);return this._proxy.$registerNavigateTypeSupport(H,typeof U.resolveWorkspaceSymbol=="function"),this._createDisposable(H)}$provideWorkspaceSymbols(I,U,H){return this._withAdapter(I,W,j=>j.provideWorkspaceSymbols(U,H),{symbols:[]},H)}$resolveWorkspaceSymbol(I,U,H){return this._withAdapter(I,W,j=>j.resolveWorkspaceSymbol(U,H),void 0,void 0)}$releaseWorkspaceSymbols(I,U){this._withAdapter(I,W,H=>H.releaseWorkspaceSymbols(U),void 0,void 0)}registerRenameProvider(I,U,H){const j=this._addNewAdapter(new $(this._documents,H,this._logService),I);return this._proxy.$registerRenameSupport(j,this._transformDocumentSelector(U),$.supportsResolving(H)),this._createDisposable(j)}$provideRenameEdits(I,U,H,j,se){return this._withAdapter(I,$,le=>le.provideRenameEdits(r.URI.revive(U),H,j,se),void 0,se)}$resolveRenameLocation(I,U,H,j){return this._withAdapter(I,$,se=>se.resolveRenameLocation(r.URI.revive(U),H,j),void 0,j)}registerDocumentSemanticTokensProvider(I,U,H,j){const se=this._addNewAdapter(new ne(this._documents,H),I),le=typeof H.onDidChangeSemanticTokens=="function"?this._nextHandle():void 0;this._proxy.$registerDocumentSemanticTokensProvider(se,this._transformDocumentSelector(U),j,le);let Y=this._createDisposable(se);if(le){const ve=H.onDidChangeSemanticTokens(pe=>this._proxy.$emitDocumentSemanticTokensEvent(le));Y=M.Disposable.from(Y,ve)}return Y}$provideDocumentSemanticTokens(I,U,H,j){return this._withAdapter(I,ne,se=>se.provideDocumentSemanticTokens(r.URI.revive(U),H,j),null,j)}$releaseDocumentSemanticTokens(I,U){this._withAdapter(I,ne,H=>H.releaseDocumentSemanticColoring(U),void 0,void 0)}registerDocumentRangeSemanticTokensProvider(I,U,H,j){const se=this._addNewAdapter(new ge(this._documents,H),I);return this._proxy.$registerDocumentRangeSemanticTokensProvider(se,this._transformDocumentSelector(U),j),this._createDisposable(se)}$provideDocumentRangeSemanticTokens(I,U,H,j){return this._withAdapter(I,ge,se=>se.provideDocumentRangeSemanticTokens(r.URI.revive(U),H,j),null,j)}registerCompletionItemProvider(I,U,H,j){const se=this._addNewAdapter(new oe(this._documents,this._commands.converter,H,this._apiDeprecation,I),I);return this._proxy.$registerCompletionsProvider(se,this._transformDocumentSelector(U),j,oe.supportsResolving(H),`${I.identifier.value}(${j.join("")})`),this._createDisposable(se)}$provideCompletionItems(I,U,H,j,se){return this._withAdapter(I,oe,le=>le.provideCompletionItems(r.URI.revive(U),H,j,se),void 0,se)}$resolveCompletionItem(I,U,H){return this._withAdapter(I,oe,j=>j.resolveCompletionItem(U,H),void 0,H)}$releaseCompletionItems(I,U){this._withAdapter(I,oe,H=>H.releaseCompletionItems(U),void 0,void 0)}registerInlineCompletionsProvider(I,U,H){const j=new ce(I,this._documents,H,this._commands.converter),se=this._addNewAdapter(j,I);return this._proxy.$registerInlineCompletionsSupport(se,this._transformDocumentSelector(U),j.supportsHandleDidShowCompletionItem),this._createDisposable(se)}registerInlineCompletionsProviderNew(I,U,H){const j=this._addNewAdapter(new me(I,this._documents,H,this._commands.converter),I);return this._proxy.$registerInlineCompletionsSupport(j,this._transformDocumentSelector(U),!0),this._createDisposable(j)}$provideInlineCompletions(I,U,H,j,se){return this._withAdapter(I,Ee,le=>le.provideInlineCompletions(r.URI.revive(U),H,j,se),void 0,se)}$handleInlineCompletionDidShow(I,U,H){this._withAdapter(I,Ee,async j=>{j.handleDidShowCompletionItem(U,H)},void 0,void 0)}$freeInlineCompletionsList(I,U){this._withAdapter(I,Ee,async H=>{H.disposeCompletions(U)},void 0,void 0)}registerSignatureHelpProvider(I,U,H,j){const se=Array.isArray(j)?{triggerCharacters:j,retriggerCharacters:[]}:j,le=this._addNewAdapter(new be(this._documents,H),I);return this._proxy.$registerSignatureHelpProvider(le,this._transformDocumentSelector(U),se),this._createDisposable(le)}$provideSignatureHelp(I,U,H,j,se){return this._withAdapter(I,be,le=>le.provideSignatureHelp(r.URI.revive(U),H,j,se),void 0,se)}$releaseSignatureHelp(I,U){this._withAdapter(I,be,H=>H.releaseSignatureHelp(U),void 0,void 0)}registerInlayHintsProvider(I,U,H){const j=typeof H.onDidChangeInlayHints=="function"?this._nextHandle():void 0,se=this._addNewAdapter(new _e(this._documents,this._commands.converter,H,this._logService,I),I);this._proxy.$registerInlayHintsProvider(se,this._transformDocumentSelector(U),typeof H.resolveInlayHint=="function",j,Z._extLabel(I));let le=this._createDisposable(se);if(j!==void 0){const Y=H.onDidChangeInlayHints(ve=>this._proxy.$emitInlayHintsEvent(j));le=M.Disposable.from(le,Y)}return le}$provideInlayHints(I,U,H,j){return this._withAdapter(I,_e,se=>se.provideInlayHints(r.URI.revive(U),H,j),void 0,j)}$resolveInlayHint(I,U,H){return this._withAdapter(I,_e,j=>j.resolveInlayHint(U,H),void 0,H)}$releaseInlayHints(I,U){this._withAdapter(I,_e,H=>H.releaseHints(U),void 0,void 0)}registerDocumentLinkProvider(I,U,H){const j=this._addNewAdapter(new Fe(this._documents,H),I);return this._proxy.$registerDocumentLinkProvider(j,this._transformDocumentSelector(U),typeof H.resolveDocumentLink=="function"),this._createDisposable(j)}$provideDocumentLinks(I,U,H){return this._withAdapter(I,Fe,j=>j.provideLinks(r.URI.revive(U),H),void 0,H,U.scheme==="output")}$resolveDocumentLink(I,U,H){return this._withAdapter(I,Fe,j=>j.resolveLink(U,H),void 0,void 0,!0)}$releaseDocumentLinks(I,U){this._withAdapter(I,Fe,H=>H.releaseLinks(U),void 0,void 0,!0)}registerColorProvider(I,U,H){const j=this._addNewAdapter(new Be(this._documents,H),I);return this._proxy.$registerDocumentColorProvider(j,this._transformDocumentSelector(U)),this._createDisposable(j)}$provideDocumentColors(I,U,H){return this._withAdapter(I,Be,j=>j.provideColors(r.URI.revive(U),H),[],H)}$provideColorPresentations(I,U,H,j){return this._withAdapter(I,Be,se=>se.provideColorPresentations(r.URI.revive(U),H,j),void 0,j)}registerFoldingRangeProvider(I,U,H){const j=this._nextHandle(),se=typeof H.onDidChangeFoldingRanges=="function"?this._nextHandle():void 0;this._adapter.set(j,new ue(new Xe(this._documents,H),I)),this._proxy.$registerFoldingRangeProvider(j,this._transformDocumentSelector(U),se);let le=this._createDisposable(j);if(se!==void 0){const Y=H.onDidChangeFoldingRanges(()=>this._proxy.$emitFoldingRangeEvent(se));le=M.Disposable.from(le,Y)}return le}$provideFoldingRanges(I,U,H,j){return this._withAdapter(I,Xe,se=>se.provideFoldingRanges(r.URI.revive(U),H,j),void 0,j)}registerSelectionRangeProvider(I,U,H){const j=this._addNewAdapter(new ke(this._documents,H,this._logService),I);return this._proxy.$registerSelectionRangeProvider(j,this._transformDocumentSelector(U)),this._createDisposable(j)}$provideSelectionRanges(I,U,H,j){return this._withAdapter(I,ke,se=>se.provideSelectionRanges(r.URI.revive(U),H,j),[],j)}registerCallHierarchyProvider(I,U,H){const j=this._addNewAdapter(new ye(this._documents,H),I);return this._proxy.$registerCallHierarchyProvider(j,this._transformDocumentSelector(U)),this._createDisposable(j)}$prepareCallHierarchy(I,U,H,j){return this._withAdapter(I,ye,se=>Promise.resolve(se.prepareSession(r.URI.revive(U),H,j)),void 0,j)}$provideCallHierarchyIncomingCalls(I,U,H,j){return this._withAdapter(I,ye,se=>se.provideCallsTo(U,H,j),void 0,j)}$provideCallHierarchyOutgoingCalls(I,U,H,j){return this._withAdapter(I,ye,se=>se.provideCallsFrom(U,H,j),void 0,j)}$releaseCallHierarchy(I,U){this._withAdapter(I,ye,H=>Promise.resolve(H.releaseSession(U)),void 0,void 0)}registerTypeHierarchyProvider(I,U,H){const j=this._addNewAdapter(new De(this._documents,H),I);return this._proxy.$registerTypeHierarchyProvider(j,this._transformDocumentSelector(U)),this._createDisposable(j)}$prepareTypeHierarchy(I,U,H,j){return this._withAdapter(I,De,se=>Promise.resolve(se.prepareSession(r.URI.revive(U),H,j)),void 0,j)}$provideTypeHierarchySupertypes(I,U,H,j){return this._withAdapter(I,De,se=>se.provideSupertypes(U,H,j),void 0,j)}$provideTypeHierarchySubtypes(I,U,H,j){return this._withAdapter(I,De,se=>se.provideSubtypes(U,H,j),void 0,j)}$releaseTypeHierarchy(I,U){this._withAdapter(I,De,H=>Promise.resolve(H.releaseSession(U)),void 0,void 0)}registerDocumentOnDropEditProvider(I,U,H){const j=this._nextHandle();return this._adapter.set(j,new ue(new ae(this._proxy,this._documents,H,j),I)),this._proxy.$registerDocumentOnDropEditProvider(j,this._transformDocumentSelector(U)),this._createDisposable(j)}$provideDocumentOnDropEdits(I,U,H,j,se,le){return this._withAdapter(I,ae,Y=>Promise.resolve(Y.provideDocumentOnDropEdits(U,r.URI.revive(H),j,se,le)),void 0,void 0)}registerDocumentPasteEditProvider(I,U,H,j){const se=this._nextHandle();return this._adapter.set(se,new ue(new z(this._proxy,this._documents,H,se),I)),this._proxy.$registerPasteEditProvider(se,this._transformDocumentSelector(U),!!H.prepareDocumentPaste,j.pasteMimeTypes),this._createDisposable(se)}$prepareDocumentPaste(I,U,H,j,se){return this._withAdapter(I,z,le=>le.prepareDocumentPaste(r.URI.revive(U),H,j,se),void 0,se)}$providePasteEdits(I,U,H,j,se,le){return this._withAdapter(I,z,Y=>Y.providePasteEdits(U,r.URI.revive(H),j,se,le),void 0,le)}static _serializeRegExp(I){return{pattern:I.source,flags:(0,b.regExpFlags)(I)}}static _serializeIndentationRule(I){return{decreaseIndentPattern:Z._serializeRegExp(I.decreaseIndentPattern),increaseIndentPattern:Z._serializeRegExp(I.increaseIndentPattern),indentNextLinePattern:I.indentNextLinePattern?Z._serializeRegExp(I.indentNextLinePattern):void 0,unIndentedLinePattern:I.unIndentedLinePattern?Z._serializeRegExp(I.unIndentedLinePattern):void 0}}static _serializeOnEnterRule(I){return{beforeText:Z._serializeRegExp(I.beforeText),afterText:I.afterText?Z._serializeRegExp(I.afterText):void 0,previousLineText:I.previousLineText?Z._serializeRegExp(I.previousLineText):void 0,action:I.action}}static _serializeOnEnterRules(I){return I.map(Z._serializeOnEnterRule)}setLanguageConfiguration(I,U,H){const{wordPattern:j}=H;if(j&&(0,b.regExpLeadsToEndlessLoop)(j))throw new Error(`Invalid language configuration: wordPattern '${j}' is not allowed to match the empty string.`);j?this._documents.setWordDefinitionFor(U,j):this._documents.setWordDefinitionFor(U,void 0),H.__electricCharacterSupport&&this._apiDeprecation.report("LanguageConfiguration.__electricCharacterSupport",I,"Do not use."),H.__characterPairSupport&&this._apiDeprecation.report("LanguageConfiguration.__characterPairSupport",I,"Do not use.");const se=this._nextHandle(),le={comments:H.comments,brackets:H.brackets,wordPattern:H.wordPattern?Z._serializeRegExp(H.wordPattern):void 0,indentationRules:H.indentationRules?Z._serializeIndentationRule(H.indentationRules):void 0,onEnterRules:H.onEnterRules?Z._serializeOnEnterRules(H.onEnterRules):void 0,__electricCharacterSupport:H.__electricCharacterSupport,__characterPairSupport:H.__characterPairSupport};return this._proxy.$setLanguageConfiguration(se,U,le),this._createDisposable(se)}$setWordDefinitions(I){for(const U of I)this._documents.setWordDefinitionFor(U.languageId,new RegExp(U.regexSource,U.regexFlags))}}e.ExtHostLanguageFeatures=Z,Z._handlePool=0}),define(Ce[204],Ie([1,0,4,8,6,29,15,7]),function(ie,e,r,y,S,M,_,A){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtHostLanguages=void 0;class b{constructor(O,E,m,k){this._documents=E,this._commands=m,this._uriTransformer=k,this._languageIds=[],this._handlePool=0,this._ids=new Set,this._proxy=O.getProxy(r.MainContext.MainThreadLanguages)}$acceptLanguageIds(O){this._languageIds=O}async getLanguages(){return this._languageIds.slice(0)}async changeLanguage(O,E){await this._proxy.$changeLanguage(O,E);const m=this._documents.getDocumentData(O);if(!m)throw new Error(`document '${O.toString()}' NOT found`);return m.document}async tokenAtPosition(O,E){const m=O.version,k=y.Position.from(E),f=await this._proxy.$tokensAtPosition(O.uri,k),c={type:S.StandardTokenType.Other,range:O.getWordRangeAtPosition(E)??new S.Range(E.line,E.character,E.line,E.character)};if(!f)return c;const d={range:y.Range.to(f.range),type:y.TokenType.to(f.type)};return!d.range.contains(E)||m!==O.version?c:d}createLanguageStatusItem(O,E,m){const k=this._handlePool++,f=this._proxy,c=this._ids,d=`${O.identifier.value}/${E}`;if(c.has(d))throw new Error(`LanguageStatusItem with id '${E}' ALREADY exists`);c.add(d);const h={selector:m,id:E,name:O.displayName??O.name,severity:S.LanguageStatusSeverity.Information,command:void 0,text:"",detail:"",busy:!1};let g;const C=new A.DisposableStore,l=()=>{g?.dispose(),g=(0,_.disposableTimeout)(()=>{C.clear(),this._proxy.$setLanguageStatus(k,{id:d,name:h.name??O.displayName??O.name,source:O.displayName??O.name,selector:y.DocumentSelector.from(h.selector,this._uriTransformer),label:h.text,detail:h.detail??"",severity:h.severity===S.LanguageStatusSeverity.Error?M.default.Error:h.severity===S.LanguageStatusSeverity.Warning?M.default.Warning:M.default.Info,command:h.command&&this._commands.toInternal(h.command,C),accessibilityInfo:h.accessibilityInformation,busy:h.busy})},0)},w={dispose(){C.dispose(),g?.dispose(),f.$removeLanguageStatus(k),c.delete(d)},get id(){return h.id},get name(){return h.name},set name(t){h.name=t,l()},get selector(){return h.selector},set selector(t){h.selector=t,l()},get text(){return h.text},set text(t){h.text=t,l()},get detail(){return h.detail},set detail(t){h.detail=t,l()},get severity(){return h.severity},set severity(t){h.severity=t,l()},get accessibilityInformation(){return h.accessibilityInformation},set accessibilityInformation(t){h.accessibilityInformation=t,l()},get command(){return h.command},set command(t){h.command=t,l()},get busy(){return h.busy},set busy(t){h.busy=t,l()}};return l(),w}}e.ExtHostLanguages=b}),define(Ce[68],Ie([1,0,21,9,2,3,14,4,11]),function(ie,e,r,y,S,M,_,A,b){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.IExtHostLocalizationService=e.ExtHostLocalizationService=void 0;let P=class{constructor(E,m){this.logService=m,this.bundleCache=new Map,this._proxy=E.getProxy(A.MainContext.MainThreadLocalization)}getMessage(E,m){const{message:k,args:f,comment:c}=m;if(r.Language.isDefault())return(0,y.format)(k,f);let d=k;c&&c.length>0&&(d+=`/${c.join()}`);const h=this.bundleCache.get(E)?.contents[d];return h||this.logService.warn(`Using default string since no string found in i18n bundle that has the key: ${d}`),(0,y.format)(h??d,f)}getBundle(E){return this.bundleCache.get(E)?.contents??{}}getBundleUri(E){return this.bundleCache.get(E)?.uri}async initializeLocalizedMessages(E){if(r.Language.isDefault()||!E.l10n||this.bundleCache.has(E.identifier.value))return;let m;const k=this.getBundleLocation(E);if(!k){this.logService.error(`No bundle location found for extension ${E.identifier.value}`);return}const f=S.URI.joinPath(k,`bundle.l10n.${r.Language.value()}.json`);try{const c=await this._proxy.$fetchBundleContents(f);m=JSON.parse(c)}catch(c){this.logService.error(`Failed to load translations for ${E.identifier.value} from ${f}: ${c.message}`);return}m&&this.bundleCache.set(E.identifier.value,{contents:m,uri:f})}getBundleLocation(E){return E.l10n?S.URI.joinPath(E.extensionLocation,E.l10n):void 0}};P=ze([$e(0,b.IExtHostRpcService),$e(1,_.ILogService)],P),e.ExtHostLocalizationService=P,e.IExtHostLocalizationService=(0,M.createDecorator)("IExtHostLocalizationService")}),define(Ce[205],Ie([1,0,14,4,28,11,5]),function(ie,e,r,y,S,M,_){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtHostLoggerService=void 0;let A=class extends r.AbstractLoggerService{constructor(O,E){const m=new _.Emitter;super(E.logLevel,m.event),this._proxy=O.getProxy(y.MainContext.MainThreadLogger),this._onDidChangeLogLevel=this._register(m)}$setLevel(O){this._onDidChangeLogLevel.fire(O)}doCreateLogger(O,E,m){return new b(this._proxy,O,E,m)}};A=ze([$e(0,M.IExtHostRpcService),$e(1,S.IExtHostInitDataService)],A),e.ExtHostLoggerService=A;class b extends r.AbstractMessageLogger{constructor(O,E,m,k){super(k?.always),this.proxy=O,this.file=E,this.isLoggerCreated=!1,this.buffer=[],this.setLevel(m),this.proxy.$createLogger(E,k).then(()=>{this.doLog(this.buffer),this.isLoggerCreated=!0})}log(O,E){const m=[[O,E]];this.isLoggerCreated?this.doLog(m):this.buffer.push(...m)}doLog(O){this.proxy.$log(this.file,O)}}}),define(Ce[206],Ie([1,0,4,14,25]),function(ie,e,r,y,S){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtHostMessageService=void 0;function M(A){return A&&A.title}let _=class{constructor(b,P){this._logService=P,this._proxy=b.getProxy(r.MainContext.MainThreadMessageService)}showMessage(b,P,O,E,m){const k={source:{identifier:b.identifier,label:b.displayName||b.name}};let f;typeof E=="string"||M(E)?f=[E,...m]:(k.modal=E?.modal,k.useCustom=E?.useCustom,k.detail=E?.detail,f=m),k.useCustom&&(0,S.checkProposedApiEnabled)(b,"resolvers");const c=[];for(let d=0;d<f.length;d++){const h=f[d];if(typeof h=="string")c.push({title:h,handle:d,isCloseAffordance:!1});else if(typeof h=="object"){const{title:g,isCloseAffordance:C}=h;c.push({title:g,isCloseAffordance:!!C,handle:d})}else this._logService.warn("Invalid message item:",h)}return this._proxy.$showMessage(P,O,k,c).then(d=>{if(typeof d=="number")return f[d]})}};_=ze([$e(1,y.ILogService)],_),e.ExtHostMessageService=_}),define(Ce[207],Ie([1,0,23,5,7,24,9,10,2,61,4,37,8,6,40,179,94]),function(ie,e,r,y,S,M,_,A,b,P,O,E,m,k,f,c,d){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtHostNotebookController=void 0;class h{get activeNotebookEditor(){return this._activeNotebookEditor?.apiEditor}get visibleNotebookEditors(){return this._visibleNotebookEditors.map(C=>C.apiEditor)}constructor(C,l,w,t){this._textDocumentsAndEditors=w,this._textDocuments=t,this._notebookContentProviders=new Map,this._notebookStatusBarItemProviders=new Map,this._documents=new M.ResourceMap,this._editors=new Map,this._onDidChangeActiveNotebookEditor=new y.Emitter,this.onDidChangeActiveNotebookEditor=this._onDidChangeActiveNotebookEditor.event,this._visibleNotebookEditors=[],this._onDidOpenNotebookDocument=new y.Emitter,this.onDidOpenNotebookDocument=this._onDidOpenNotebookDocument.event,this._onDidCloseNotebookDocument=new y.Emitter,this.onDidCloseNotebookDocument=this._onDidCloseNotebookDocument.event,this._onDidChangeVisibleNotebookEditors=new y.Emitter,this.onDidChangeVisibleNotebookEditors=this._onDidChangeVisibleNotebookEditors.event,this._statusBarCache=new P.Cache("NotebookCellStatusBarCache"),this._handlePool=0,this._notebookSerializer=new Map,this._notebookProxy=C.getProxy(O.MainContext.MainThreadNotebook),this._notebookDocumentsProxy=C.getProxy(O.MainContext.MainThreadNotebookDocuments),this._notebookEditorsProxy=C.getProxy(O.MainContext.MainThreadNotebookEditors),this._commandsConverter=l.converter,l.registerArgumentProcessor({processArgument:u=>{if(u&&u.$mid===12){const i=u.notebookEditor?.notebookUri,n=u.cell.handle,a=this._documents.get(i)?.getCell(n);if(a)return a.apiCell}return u}}),h._registerApiCommands(l)}getEditorById(C){const l=this._editors.get(C);if(!l)throw new Error(`unknown text editor: ${C}. known editors: ${[...this._editors.keys()]} `);return l}getIdByEditor(C){for(const[l,w]of this._editors)if(w.apiEditor===C)return l}get notebookDocuments(){return[...this._documents.values()]}getNotebookDocument(C,l){const w=this._documents.get(C);if(!w&&!l)throw new Error(`NO notebook document for '${C}'`);return w}_getProviderData(C){const l=this._notebookContentProviders.get(C);if(!l)throw new Error(`NO provider for '${C}'`);return l}registerNotebookContentProvider(C,l,w,t,u){if((0,_.isFalsyOrWhitespace)(l))throw new Error("viewType cannot be empty or just whitespace");if(this._notebookContentProviders.has(l))throw new Error(`Notebook provider for '${l}' already registered`);return this._notebookContentProviders.set(l,{extension:C,provider:w}),this._notebookProxy.$registerNotebookProvider({id:C.identifier,location:C.extensionLocation},l,m.NotebookDocumentContentOptions.from(t),h._convertNotebookRegistrationData(C,u)),new k.Disposable(()=>{this._notebookContentProviders.delete(l),this._notebookProxy.$unregisterNotebookProvider(l)})}static _convertNotebookRegistrationData(C,l){if(!l)return;const w=l.filenamePattern.map(t=>m.NotebookExclusiveDocumentPattern.from(t)).filter(t=>t!==void 0);if(l.filenamePattern&&!w){console.warn(`Notebook content provider view options file name pattern is invalid ${l.filenamePattern}`);return}return{extension:C.identifier,providerDisplayName:C.displayName||C.name,displayName:l.displayName,filenamePattern:w,exclusive:l.exclusive||!1}}registerNotebookCellStatusBarItemProvider(C,l,w){const t=h._notebookStatusBarItemProviderHandlePool++,u=typeof w.onDidChangeCellStatusBarItems=="function"?h._notebookStatusBarItemProviderHandlePool++:void 0;this._notebookStatusBarItemProviders.set(t,w),this._notebookProxy.$registerNotebookCellStatusBarItemProvider(t,u,l);let i;return u!==void 0&&(i=w.onDidChangeCellStatusBarItems(n=>this._notebookProxy.$emitCellStatusBarEvent(u))),new k.Disposable(()=>{this._notebookStatusBarItemProviders.delete(t),this._notebookProxy.$unregisterNotebookCellStatusBarItemProvider(t,u),i?.dispose()})}async createNotebookDocument(C){const l=await this._notebookDocumentsProxy.$tryCreateNotebook({viewType:C.viewType,content:C.content&&m.NotebookData.from(C.content)});return b.URI.revive(l)}async openNotebookDocument(C){const l=this._documents.get(C);if(l)return l.apiNotebook;const w=await this._notebookDocumentsProxy.$tryOpenNotebook(C),t=this._documents.get(b.URI.revive(w));return(0,A.assertIsDefined)(t?.apiNotebook)}async showNotebookDocument(C,l){b.URI.isUri(C)&&(C=await this.openNotebookDocument(C));let w;typeof l=="object"?w={position:m.ViewColumn.from(l.viewColumn),preserveFocus:l.preserveFocus,selections:l.selections&&l.selections.map(m.NotebookRange.from),pinned:typeof l.preview=="boolean"?!l.preview:void 0}:w={preserveFocus:!1};const t=await this._notebookEditorsProxy.$tryShowNotebookDocument(C.uri,C.notebookType,w),u=t&&this._editors.get(t)?.apiEditor;if(u)return u;throw t?new Error(`Could NOT open editor for "${C.uri.toString()}" because another editor opened in the meantime.`):new Error(`Could NOT open editor for "${C.uri.toString()}".`)}async $provideNotebookCellStatusBarItems(C,l,w,t){const u=this._notebookStatusBarItemProviders.get(C),i=b.URI.revive(l),n=this._documents.get(i);if(!n||!u)return;const s=n.getCellFromIndex(w);if(!s)return;const a=await u.provideCellStatusBarItems(s.apiCell,t);if(!a)return;const o=new S.DisposableStore,v=this._statusBarCache.add([o]),T=(Array.isArray(a)?a:[a]).map(N=>m.NotebookStatusBarItem.from(N,this._commandsConverter,o));return{cacheId:v,items:T}}$releaseNotebookCellStatusBarItems(C){this._statusBarCache.delete(C)}registerNotebookSerializer(C,l,w,t,u){if((0,_.isFalsyOrWhitespace)(l))throw new Error("viewType cannot be empty or just whitespace");const i=this._handlePool++;return this._notebookSerializer.set(i,w),this._notebookProxy.$registerNotebookSerializer(i,{id:C.identifier,location:C.extensionLocation},l,m.NotebookDocumentContentOptions.from(t),h._convertNotebookRegistrationData(C,u)),(0,S.toDisposable)(()=>{this._notebookProxy.$unregisterNotebookSerializer(i)})}async $dataToNotebook(C,l,w){const t=this._notebookSerializer.get(C);if(!t)throw new Error("NO serializer found");const u=await t.deserializeNotebook(l.buffer,w);return new f.SerializableObjectWithBuffers(m.NotebookData.from(u))}async $notebookToData(C,l,w){const t=this._notebookSerializer.get(C);if(!t)throw new Error("NO serializer found");const u=await t.serializeNotebook(m.NotebookData.to(l.value),w);return r.VSBuffer.wrap(u)}async $openNotebook(C,l,w,t,u){const{provider:i}=this._getProviderData(C),n=await i.openNotebook(b.URI.revive(l),{backupId:w,untitledDocumentData:t?.buffer},u);return new f.SerializableObjectWithBuffers({metadata:n.metadata??Object.create(null),cells:n.cells.map(m.NotebookCellData.from)})}_createExtHostEditor(C,l,w){if(this._editors.has(l))throw new Error(`editor with id ALREADY EXSIST: ${l}`);const t=new d.ExtHostNotebookEditor(l,this._notebookEditorsProxy,C,w.visibleRanges.map(m.NotebookRange.to),w.selections.map(m.NotebookRange.to),typeof w.viewColumn=="number"?m.ViewColumn.to(w.viewColumn):void 0);this._editors.set(l,t)}$acceptDocumentAndEditorsDelta(C){if(C.value.removedDocuments)for(const w of C.value.removedDocuments){const t=b.URI.revive(w),u=this._documents.get(t);u&&(u.dispose(),this._documents.delete(t),this._textDocumentsAndEditors.$acceptDocumentsAndEditorsDelta({removedDocuments:u.apiNotebook.getCells().map(i=>i.document.uri)}),this._onDidCloseNotebookDocument.fire(u.apiNotebook));for(const i of this._editors.values())i.notebookData.uri.toString()===t.toString()&&this._editors.delete(i.id)}if(C.value.addedDocuments){const w=[];for(const t of C.value.addedDocuments){const u=b.URI.revive(t.uri);if(this._documents.has(u))throw new Error(`adding EXISTING notebook ${u} `);const i=new c.ExtHostNotebookDocument(this._notebookDocumentsProxy,this._textDocumentsAndEditors,this._textDocuments,u,t);w.push(...t.cells.map(n=>c.ExtHostCell.asModelAddData(i.apiNotebook,n))),this._documents.get(u)?.dispose(),this._documents.set(u,i),this._textDocumentsAndEditors.$acceptDocumentsAndEditorsDelta({addedDocuments:w}),this._onDidOpenNotebookDocument.fire(i.apiNotebook)}}if(C.value.addedEditors)for(const w of C.value.addedEditors){if(this._editors.has(w.id))return;const t=b.URI.revive(w.documentUri),u=this._documents.get(t);u&&this._createExtHostEditor(u,w.id,w)}const l=[];if(C.value.removedEditors)for(const w of C.value.removedEditors){const t=this._editors.get(w);t&&(this._editors.delete(w),this._activeNotebookEditor?.id===t.id&&(this._activeNotebookEditor=void 0),l.push(t))}if(C.value.visibleEditors){this._visibleNotebookEditors=C.value.visibleEditors.map(t=>this._editors.get(t)).filter(t=>!!t);const w=new Set;this._visibleNotebookEditors.forEach(t=>w.add(t.id));for(const t of this._editors.values()){const u=w.has(t.id);t._acceptVisibility(u)}this._visibleNotebookEditors=[...this._editors.values()].map(t=>t).filter(t=>t.visible),this._onDidChangeVisibleNotebookEditors.fire(this.visibleNotebookEditors)}C.value.newActiveEditor===null?this._activeNotebookEditor=void 0:C.value.newActiveEditor&&(this._activeNotebookEditor=this._editors.get(C.value.newActiveEditor)),C.value.newActiveEditor!==void 0&&this._onDidChangeActiveNotebookEditor.fire(this._activeNotebookEditor?.apiEditor)}static _registerApiCommands(C){const l=E.ApiCommandArgument.String.with("notebookType","A notebook type"),w=new E.ApiCommand("vscode.executeDataToNotebook","_executeDataToNotebook","Invoke notebook serializer",[l,new E.ApiCommandArgument("data","Bytes to convert to data",u=>u instanceof Uint8Array,u=>r.VSBuffer.wrap(u))],new E.ApiCommandResult("Notebook Data",u=>m.NotebookData.to(u.value))),t=new E.ApiCommand("vscode.executeNotebookToData","_executeNotebookToData","Invoke notebook serializer",[l,new E.ApiCommandArgument("NotebookData","Notebook data to convert to bytes",u=>!0,u=>new f.SerializableObjectWithBuffers(m.NotebookData.from(u)))],new E.ApiCommandResult("Bytes",u=>u.buffer));C.registerApiCommand(w),C.registerApiCommand(t)}}e.ExtHostNotebookController=h,h._notebookStatusBarItemProviderHandlePool=0}),define(Ce[208],Ie([1,0,18,15,20,5,7,24,2,27,14,4,37,8,6,63,167,25,40]),function(ie,e,r,y,S,M,_,A,b,P,O,E,m,k,f,c,d,h,g){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.createKernelId=e.ExtHostNotebookKernels=void 0;let C=class{constructor(n,s,a,o,v){this._initData=s,this._extHostNotebook=a,this._commands=o,this._logService=v,this._activeExecutions=new A.ResourceMap,this._kernelData=new Map,this._handlePool=0,this._onDidChangeCellExecutionState=new M.Emitter,this.onDidChangeNotebookCellExecutionState=this._onDidChangeCellExecutionState.event,this._proxy=n.getProxy(E.MainContext.MainThreadNotebookKernels);const p=new m.ApiCommand("notebook.selectKernel","_notebook.selectKernel","Trigger kernel picker for specified notebook editor widget",[new m.ApiCommandArgument("options","Select kernel options",T=>!0,T=>{if(T&&"notebookEditor"in T&&"id"in T){const N=this._extHostNotebook.getIdByEditor(T.notebookEditor);return{id:T.id,extension:T.extension,notebookEditorId:N}}else if(T&&"notebookEditor"in T){const N=this._extHostNotebook.getIdByEditor(T.notebookEditor);if(N===void 0)throw new Error(`Cannot invoke 'notebook.selectKernel' for unrecognized notebook editor ${T.notebookEditor.document.uri.toString()}`);return{notebookEditorId:N}}return T})],m.ApiCommandResult.Void);this._commands.registerApiCommand(p)}createNotebookController(n,s,a,o,v,p){for(const oe of this._kernelData.values())if(oe.controller.id===s&&P.ExtensionIdentifier.equals(n.identifier,oe.extensionId))throw new Error(`notebook controller with id '${s}' ALREADY exist`);const T=this._handlePool++,N=this;this._logService.trace(`NotebookController[${T}], CREATED by ${n.identifier.value}, ${s}`);const V=()=>console.warn(`NO execute handler from notebook controller '${R.id}' of extension: '${n.identifier}'`);let B=!1;const D=new _.DisposableStore,z=new M.Emitter,L=new M.Emitter,R={id:u(n.identifier,s),notebookType:a,extensionId:n.identifier,extensionLocation:n.extensionLocation,label:o||n.identifier.value,preloads:p?p.map(k.NotebookRendererScript.from):[]};let K=v??V,W;this._proxy.$addKernel(T,R).catch(oe=>{console.log(oe),B=!0});let $=0;const G=()=>{if(B)return;const oe=++$;Promise.resolve().then(()=>{oe===$&&this._proxy.$updateKernel(T,R)})},ne=new A.ResourceMap,ge={get id(){return s},get notebookType(){return R.notebookType},onDidChangeSelectedNotebooks:z.event,get label(){return R.label},set label(oe){R.label=oe??n.displayName??n.name,G()},get detail(){return R.detail??""},set detail(oe){R.detail=oe,G()},get description(){return R.description??""},set description(oe){R.description=oe,G()},get kind(){return(0,h.checkProposedApiEnabled)(n,"notebookControllerKind"),R.kind??""},set kind(oe){(0,h.checkProposedApiEnabled)(n,"notebookControllerKind"),R.kind=oe,G()},get supportedLanguages(){return R.supportedLanguages},set supportedLanguages(oe){R.supportedLanguages=oe,G()},get supportsExecutionOrder(){return R.supportsExecutionOrder??!1},set supportsExecutionOrder(oe){R.supportsExecutionOrder=oe,G()},get rendererScripts(){return R.preloads?R.preloads.map(k.NotebookRendererScript.to):[]},get executeHandler(){return K},set executeHandler(oe){K=oe??V},get interruptHandler(){return W},set interruptHandler(oe){W=oe,R.supportsInterrupt=Boolean(oe),G()},createNotebookCellExecution(oe){if(B)throw new Error("notebook controller is DISPOSED");if(!ne.has(oe.notebook.uri))throw N._logService.trace(`NotebookController[${T}] NOT associated to notebook, associated to THESE notebooks:`,Array.from(ne.keys()).map(Ee=>Ee.toString())),new Error(`notebook controller is NOT associated to notebook: ${oe.notebook.uri.toString()}`);return N._createNotebookCellExecution(oe,u(n.identifier,this.id))},dispose:()=>{B||(this._logService.trace(`NotebookController[${T}], DISPOSED`),B=!0,this._kernelData.delete(T),D.dispose(),z.dispose(),L.dispose(),this._proxy.$removeKernel(T))},updateNotebookAffinity(oe,Ee){Ee===f.NotebookControllerAffinity2.Hidden&&(0,h.checkProposedApiEnabled)(n,"notebookControllerAffinityHidden"),N._proxy.$updateNotebookPriority(T,oe.uri,Ee)},onDidReceiveMessage:L.event,postMessage(oe,Ee){return(0,h.checkProposedApiEnabled)(n,"notebookMessaging"),N._proxy.$postMessage(T,Ee&&N._extHostNotebook.getIdByEditor(Ee),oe)},asWebviewUri(oe){return(0,h.checkProposedApiEnabled)(n,"notebookMessaging"),(0,c.asWebviewUri)(oe,N._initData.remote)}};return this._kernelData.set(T,{extensionId:n.identifier,controller:ge,onDidReceiveMessage:L,onDidChangeSelection:z,associatedNotebooks:ne}),ge}getIdByController(n){for(const[s,a]of this._kernelData)if(a.controller===n)return u(a.extensionId,n.id);return null}$acceptNotebookAssociation(n,s,a){const o=this._kernelData.get(n);if(o){const v=this._extHostNotebook.getNotebookDocument(b.URI.revive(s));a?o.associatedNotebooks.set(v.uri,!0):o.associatedNotebooks.delete(v.uri),this._logService.trace(`NotebookController[${n}] ASSOCIATE notebook`,v.uri.toString(),a),o.onDidChangeSelection.fire({selected:a,notebook:v.apiNotebook})}}async $executeCells(n,s,a){const o=this._kernelData.get(n);if(!o)return;const v=this._extHostNotebook.getNotebookDocument(b.URI.revive(s)),p=[];for(const T of a){const N=v.getCell(T);N&&p.push(N.apiCell)}try{this._logService.trace(`NotebookController[${n}] EXECUTE cells`,v.uri.toString(),p.length),await o.controller.executeHandler.call(o.controller,p,v.apiNotebook,o.controller)}catch(T){this._logService.error(`NotebookController[${n}] execute cells FAILED`,T),console.error(T)}}async $cancelCells(n,s,a){const o=this._kernelData.get(n);if(!o)return;const v=this._extHostNotebook.getNotebookDocument(b.URI.revive(s));if(o.controller.interruptHandler)await o.controller.interruptHandler.call(o.controller,v.apiNotebook);else for(const p of a){const T=v.getCell(p);T&&this._activeExecutions.get(T.uri)?.cancel()}}$acceptKernelMessageFromRenderer(n,s,a){const o=this._kernelData.get(n);if(!o)return;const v=this._extHostNotebook.getEditorById(s);o.onDidReceiveMessage.fire(Object.freeze({editor:v.apiEditor,message:a}))}$cellExecutionChanged(n,s,a){const v=this._extHostNotebook.getNotebookDocument(b.URI.revive(n)).getCell(s);if(v){const p=a?k.NotebookCellExecutionState.to(a):f.NotebookCellExecutionState.Idle;p!==void 0&&this._onDidChangeCellExecutionState.fire({cell:v.apiCell,state:p})}}_createNotebookCellExecution(n,s){if(n.index<0)throw new Error("CANNOT execute cell that has been REMOVED from notebook");const o=this._extHostNotebook.getNotebookDocument(n.notebook.uri).getCellFromApiCell(n);if(!o)throw new Error("invalid cell");if(this._activeExecutions.has(o.uri))throw new Error(`duplicate execution for ${o.uri}`);const v=new w(s,o,this._proxy);this._activeExecutions.set(o.uri,v);const p=v.onDidChangeState(()=>{v.state===l.Resolved&&(v.dispose(),p.dispose(),this._activeExecutions.delete(o.uri))});return v.asApiObject()}};C=ze([$e(4,O.ILogService)],C),e.ExtHostNotebookKernels=C;var l;(function(i){i[i.Init=0]="Init",i[i.Started=1]="Started",i[i.Resolved=2]="Resolved"})(l||(l={}));class w extends _.Disposable{get state(){return this._state}constructor(n,s,a){super(),this._cell=s,this._proxy=a,this._handle=w.HANDLE++,this._onDidChangeState=new M.Emitter,this.onDidChangeState=this._onDidChangeState.event,this._state=l.Init,this._tokenSource=this._register(new S.CancellationTokenSource),this._collector=new t(10,o=>this.update(o)),this._executionOrder=s.internalMetadata.executionOrder,this._proxy.$createExecution(this._handle,n,this._cell.notebook.uri,this._cell.handle)}cancel(){this._tokenSource.cancel()}async updateSoon(n){await this._collector.addItem(n)}async update(n){const s=Array.isArray(n)?n:[n];return this._proxy.$updateExecution(this._handle,new g.SerializableObjectWithBuffers(s))}verifyStateForOutput(){if(this._state===l.Init)throw new Error("Must call start before modifying cell output");if(this._state===l.Resolved)throw new Error("Cannot modify cell output after calling resolve")}cellIndexToHandle(n){let s=this._cell;if(n&&(s=this._cell.notebook.getCellFromApiCell(n)),!s)throw new Error("INVALID cell");return s.handle}validateAndConvertOutputs(n){return n.map(s=>{const a=f.NotebookCellOutput.ensureUniqueMimeTypes(s.items,!0);return a===s.items?k.NotebookCellOutput.from(s):k.NotebookCellOutput.from({items:a,id:s.id,metadata:s.metadata})})}async updateOutputs(n,s,a){const o=this.cellIndexToHandle(s),v=this.validateAndConvertOutputs((0,r.asArray)(n));return this.updateSoon({editType:d.CellExecutionUpdateType.Output,cellHandle:o,append:a,outputs:v})}async updateOutputItems(n,s,a){return n=f.NotebookCellOutput.ensureUniqueMimeTypes((0,r.asArray)(n),!0),this.updateSoon({editType:d.CellExecutionUpdateType.OutputItems,items:n.map(k.NotebookCellOutputItem.from),outputId:s.id,append:a})}asApiObject(){const n=this;return Object.freeze({get token(){return n._tokenSource.token},get cell(){return n._cell.apiCell},get executionOrder(){return n._executionOrder},set executionOrder(a){n._executionOrder=a,n.update([{editType:d.CellExecutionUpdateType.ExecutionState,executionOrder:n._executionOrder}])},start(a){if(n._state===l.Resolved||n._state===l.Started)throw new Error("Cannot call start again");n._state=l.Started,n._onDidChangeState.fire(),n.update({editType:d.CellExecutionUpdateType.ExecutionState,runStartTime:a})},end(a,o){if(n._state===l.Resolved)throw new Error("Cannot call resolve twice");n._state=l.Resolved,n._onDidChangeState.fire(),n._collector.flush(),n._proxy.$completeExecution(n._handle,new g.SerializableObjectWithBuffers({runEndTime:o,lastRunSuccess:a}))},clearOutput(a){return n.verifyStateForOutput(),n.updateOutputs([],a,!1)},appendOutput(a,o){return n.verifyStateForOutput(),n.updateOutputs(a,o,!0)},replaceOutput(a,o){return n.verifyStateForOutput(),n.updateOutputs(a,o,!1)},appendOutputItems(a,o){return n.verifyStateForOutput(),n.updateOutputItems(a,o,!0)},replaceOutputItems(a,o){return n.verifyStateForOutput(),n.updateOutputItems(a,o,!1)}})}}w.HANDLE=0;class t{constructor(n,s){this.delay=n,this.callback=s,this.batch=[],this.startedTimer=Date.now()}addItem(n){return this.batch.push(n),this.currentDeferred||(this.currentDeferred=new y.DeferredPromise,this.startedTimer=Date.now(),(0,y.timeout)(this.delay).then(()=>this.flush())),Date.now()-this.startedTimer>this.delay?this.flush():this.currentDeferred.p}flush(){if(this.batch.length===0||!this.currentDeferred)return Promise.resolve();const n=this.currentDeferred;this.currentDeferred=void 0;const s=this.batch;return this.batch=[],this.callback(s).finally(()=>n.complete())}}function u(i,n){return`${i.value}/${n}`}e.createKernelId=u}),define(Ce[209],Ie([1,0,5,4,94]),function(ie,e,r,y,S){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtHostNotebookRenderers=void 0;class M{constructor(A,b){this._extHostNotebook=b,this._rendererMessageEmitters=new Map,this.proxy=A.getProxy(y.MainContext.MainThreadNotebookRenderers)}$postRendererMessage(A,b,P){const O=this._extHostNotebook.getEditorById(A);this._rendererMessageEmitters.get(b)?.fire({editor:O.apiEditor,message:P})}createRendererMessaging(A,b){if(!A.contributes?.notebookRenderer?.some(O=>O.id===b))throw new Error(`Extensions may only call createRendererMessaging() for renderers they contribute (got ${b})`);return{onDidReceiveMessage:(O,E,m)=>this.getOrCreateEmitterFor(b).event(O,E,m),postMessage:(O,E)=>{S.ExtHostNotebookEditor.apiEditorsToExtHost.has(O)&&([O,E]=[E,O]);const m=E&&S.ExtHostNotebookEditor.apiEditorsToExtHost.get(E);return this.proxy.$postMessage(m?.id,b,O)}}}getOrCreateEmitterFor(A){let b=this._rendererMessageEmitters.get(A);return b||(b=new r.Emitter({onLastListenerRemove:()=>{b?.dispose(),this._rendererMessageEmitters.delete(A)}}),this._rendererMessageEmitters.set(A,b),b)}}e.ExtHostNotebookRenderers=M}),define(Ce[210],Ie([1,0,20,5,7,4,2,6,12,18,29,60]),function(ie,e,r,y,S,M,_,A,b,P,O,E){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.createExtHostQuickOpen=void 0;function m(k,f,c){const d=k.getProxy(M.MainContext.MainThreadQuickOpen);class h{constructor(s,a){this._sessions=new Map,this._instances=0,this._workspace=s,this._commands=a}showQuickPick(s,a,o=r.CancellationToken.None){this._onDidSelectItem=void 0;const v=Promise.resolve(s),p=++this._instances,T=d.$show(p,{title:a?.title,placeHolder:a?.placeHolder,matchOnDescription:a?.matchOnDescription,matchOnDetail:a?.matchOnDetail,ignoreFocusLost:a?.ignoreFocusOut,canPickMany:a?.canPickMany},o),N={},V=T.then(()=>N);return Promise.race([V,v]).then(B=>{if(B!==N)return v.then(D=>{const z=[];for(let L=0;L<D.length;L++){const R=D[L];typeof R=="string"?z.push({label:R,handle:L}):R.kind===A.QuickPickItemKind.Separator?z.push({type:"separator",label:R.label}):z.push({label:R.label,description:R.description,detail:R.detail,picked:R.picked,alwaysShow:R.alwaysShow,handle:L})}return a&&typeof a.onDidSelectItem=="function"&&(this._onDidSelectItem=L=>{a.onDidSelectItem(D[L])}),d.$setItems(p,z),T.then(L=>{if(typeof L=="number")return D[L];if(Array.isArray(L))return L.map(R=>D[R])})})}).then(void 0,B=>{if(!(0,b.isCancellationError)(B))return d.$setError(p,B),Promise.reject(B)})}$onItemSelected(s){this._onDidSelectItem?.(s)}showInput(s,a=r.CancellationToken.None){return this._validateInput=s?.validateInput,d.$input(s,typeof this._validateInput=="function",a).then(void 0,o=>{if(!(0,b.isCancellationError)(o))return Promise.reject(o)})}async $validateInput(s){if(!this._validateInput)return;const a=await this._validateInput(s);if(!a||typeof a=="string")return a;let o;switch(a.severity){case A.InputBoxValidationSeverity.Info:o=O.default.Info;break;case A.InputBoxValidationSeverity.Warning:o=O.default.Warning;break;case A.InputBoxValidationSeverity.Error:o=O.default.Error;break;default:o=a.message?O.default.Error:O.default.Ignore;break}return{content:a.message,severity:o}}async showWorkspaceFolderPick(s,a=r.CancellationToken.None){const o=await this._commands.executeCommand("_workbench.pickWorkspaceFolder",[s]);if(!o)return;const v=await this._workspace.getWorkspaceFolders2();if(!!v)return v.find(p=>p.uri.toString()===o.uri.toString())}createQuickPick(s){const a=new u(s,()=>this._sessions.delete(a._id));return this._sessions.set(a._id,a),a}createInputBox(s){const a=new i(s,()=>this._sessions.delete(a._id));return this._sessions.set(a._id,a),a}$onDidChangeValue(s,a){this._sessions.get(s)?._fireDidChangeValue(a)}$onDidAccept(s){this._sessions.get(s)?._fireDidAccept()}$onDidChangeActive(s,a){const o=this._sessions.get(s);o instanceof u&&o._fireDidChangeActive(a)}$onDidChangeSelection(s,a){const o=this._sessions.get(s);o instanceof u&&o._fireDidChangeSelection(a)}$onDidTriggerButton(s,a){this._sessions.get(s)?._fireDidTriggerButton(a)}$onDidTriggerItemButton(s,a,o){const v=this._sessions.get(s);v instanceof u&&v._fireDidTriggerItemButton(a,o)}$onDidHide(s){this._sessions.get(s)?._fireDidHide()}}class g{constructor(s,a){this._extensionId=s,this._onDidDispose=a,this._id=u._nextId++,this._visible=!1,this._expectingHide=!1,this._enabled=!0,this._busy=!1,this._ignoreFocusOut=!0,this._value="",this._buttons=[],this._handlesToButtons=new Map,this._onDidAcceptEmitter=new y.Emitter,this._onDidChangeValueEmitter=new y.Emitter,this._onDidTriggerButtonEmitter=new y.Emitter,this._onDidHideEmitter=new y.Emitter,this._pendingUpdate={id:this._id},this._disposed=!1,this._disposables=[this._onDidTriggerButtonEmitter,this._onDidHideEmitter,this._onDidAcceptEmitter,this._onDidChangeValueEmitter],this.onDidChangeValue=this._onDidChangeValueEmitter.event,this.onDidAccept=this._onDidAcceptEmitter.event,this.onDidTriggerButton=this._onDidTriggerButtonEmitter.event,this.onDidHide=this._onDidHideEmitter.event}get title(){return this._title}set title(s){this._title=s,this.update({title:s})}get step(){return this._steps}set step(s){this._steps=s,this.update({step:s})}get totalSteps(){return this._totalSteps}set totalSteps(s){this._totalSteps=s,this.update({totalSteps:s})}get enabled(){return this._enabled}set enabled(s){this._enabled=s,this.update({enabled:s})}get busy(){return this._busy}set busy(s){this._busy=s,this.update({busy:s})}get ignoreFocusOut(){return this._ignoreFocusOut}set ignoreFocusOut(s){this._ignoreFocusOut=s,this.update({ignoreFocusOut:s})}get value(){return this._value}set value(s){this._value=s,this.update({value:s})}get placeholder(){return this._placeholder}set placeholder(s){this._placeholder=s,this.update({placeholder:s})}get buttons(){return this._buttons}set buttons(s){this._buttons=s.slice(),this._handlesToButtons.clear(),s.forEach((a,o)=>{const v=a===A.QuickInputButtons.Back?-1:o;this._handlesToButtons.set(v,a)}),this.update({buttons:s.map((a,o)=>({...t(a),tooltip:a.tooltip,handle:a===A.QuickInputButtons.Back?-1:o}))})}show(){this._visible=!0,this._expectingHide=!0,this.update({visible:!0})}hide(){this._visible=!1,this.update({visible:!1})}_fireDidAccept(){this._onDidAcceptEmitter.fire()}_fireDidChangeValue(s){this._value=s,this._onDidChangeValueEmitter.fire(s)}_fireDidTriggerButton(s){const a=this._handlesToButtons.get(s);a&&this._onDidTriggerButtonEmitter.fire(a)}_fireDidHide(){this._expectingHide&&(this._expectingHide=this._visible,this._onDidHideEmitter.fire())}dispose(){this._disposed||(this._disposed=!0,this._fireDidHide(),this._disposables=(0,S.dispose)(this._disposables),this._updateTimeout&&(clearTimeout(this._updateTimeout),this._updateTimeout=void 0),this._onDidDispose(),d.$dispose(this._id))}update(s){if(!this._disposed){for(const a of Object.keys(s)){const o=s[a];this._pendingUpdate[a]=o===void 0?null:o}"visible"in this._pendingUpdate?(this._updateTimeout&&(clearTimeout(this._updateTimeout),this._updateTimeout=void 0),this.dispatchUpdate()):this._visible&&!this._updateTimeout&&(this._updateTimeout=setTimeout(()=>{this._updateTimeout=void 0,this.dispatchUpdate()},0))}}dispatchUpdate(){d.$createOrUpdate(this._pendingUpdate),this._pendingUpdate={id:this._id}}}g._nextId=1;function C(n){if(n instanceof A.ThemeIcon)return{id:n.id};const s=w(n),a=l(n);return{dark:typeof s=="string"?_.URI.file(s):s,light:typeof a=="string"?_.URI.file(a):a}}function l(n){return typeof n=="object"&&"light"in n?n.light:n}function w(n){return typeof n=="object"&&"dark"in n?n.dark:n}function t(n){const s=C(n.iconPath);let a,o;return"id"in s?o=E.ThemeIcon.asClassName(s):a=s,{iconPath:a,iconClass:o}}class u extends g{constructor(s,a){super(s.identifier,a),this._items=[],this._handlesToItems=new Map,this._itemsToHandles=new Map,this._canSelectMany=!1,this._matchOnDescription=!0,this._matchOnDetail=!0,this._sortByLabel=!0,this._keepScrollPosition=!1,this._activeItems=[],this._onDidChangeActiveEmitter=new y.Emitter,this._selectedItems=[],this._onDidChangeSelectionEmitter=new y.Emitter,this._onDidTriggerItemButtonEmitter=new y.Emitter,this.onDidChangeActive=this._onDidChangeActiveEmitter.event,this.onDidChangeSelection=this._onDidChangeSelectionEmitter.event,this.onDidTriggerItemButton=this._onDidTriggerItemButtonEmitter.event,this._disposables.push(this._onDidChangeActiveEmitter,this._onDidChangeSelectionEmitter,this._onDidTriggerItemButtonEmitter),this.update({type:"quickPick"})}get items(){return this._items}set items(s){this._items=s.slice(),this._handlesToItems.clear(),this._itemsToHandles.clear(),s.forEach((o,v)=>{this._handlesToItems.set(v,o),this._itemsToHandles.set(o,v)});const a=[];for(let o=0;o<s.length;o++){const v=s[o];v.kind===A.QuickPickItemKind.Separator?a.push({type:"separator",label:v.label}):a.push({handle:o,label:v.label,description:v.description,detail:v.detail,picked:v.picked,alwaysShow:v.alwaysShow,buttons:v.buttons?.map((p,T)=>({...t(p),tooltip:p.tooltip,handle:T}))})}this.update({items:a})}get canSelectMany(){return this._canSelectMany}set canSelectMany(s){this._canSelectMany=s,this.update({canSelectMany:s})}get matchOnDescription(){return this._matchOnDescription}set matchOnDescription(s){this._matchOnDescription=s,this.update({matchOnDescription:s})}get matchOnDetail(){return this._matchOnDetail}set matchOnDetail(s){this._matchOnDetail=s,this.update({matchOnDetail:s})}get sortByLabel(){return this._sortByLabel}set sortByLabel(s){this._sortByLabel=s,this.update({sortByLabel:s})}get keepScrollPosition(){return this._keepScrollPosition}set keepScrollPosition(s){this._keepScrollPosition=s,this.update({keepScrollPosition:s})}get activeItems(){return this._activeItems}set activeItems(s){this._activeItems=s.filter(a=>this._itemsToHandles.has(a)),this.update({activeItems:this._activeItems.map(a=>this._itemsToHandles.get(a))})}get selectedItems(){return this._selectedItems}set selectedItems(s){this._selectedItems=s.filter(a=>this._itemsToHandles.has(a)),this.update({selectedItems:this._selectedItems.map(a=>this._itemsToHandles.get(a))})}_fireDidChangeActive(s){const a=(0,P.coalesce)(s.map(o=>this._handlesToItems.get(o)));this._activeItems=a,this._onDidChangeActiveEmitter.fire(a)}_fireDidChangeSelection(s){const a=(0,P.coalesce)(s.map(o=>this._handlesToItems.get(o)));this._selectedItems=a,this._onDidChangeSelectionEmitter.fire(a)}_fireDidTriggerItemButton(s,a){const o=this._handlesToItems.get(s);if(!o||!o.buttons||!o.buttons.length)return;const v=o.buttons[a];v&&this._onDidTriggerItemButtonEmitter.fire({button:v,item:o})}}class i extends g{constructor(s,a){super(s.identifier,a),this._password=!1,this.update({type:"inputBox"})}get password(){return this._password}set password(s){this._password=s,this.update({password:s})}get prompt(){return this._prompt}set prompt(s){this._prompt=s,this.update({prompt:s})}get validationMessage(){return this._validationMessage}set validationMessage(s){this._validationMessage=s,s?typeof s=="string"?this.update({validationMessage:s,severity:O.default.Error}):this.update({validationMessage:s.message,severity:s.severity??O.default.Error}):this.update({validationMessage:void 0,severity:O.default.Ignore})}}return new h(f,c)}e.createExtHostQuickOpen=m});var Oe=this&&this.__classPrivateFieldGet||function(ie,e,r,y){if(r==="a"&&!y)throw new TypeError("Private accessor was defined without a getter");if(typeof e=="function"?ie!==e||!y:!e.has(ie))throw new TypeError("Cannot read private member from an object whose class did not declare it");return r==="m"?y:r==="a"?y.call(ie):y?y.value:e.get(ie)},Je=this&&this.__classPrivateFieldSet||function(ie,e,r,y,S){if(y==="m")throw new TypeError("Private method is not writable");if(y==="a"&&!S)throw new TypeError("Private accessor was defined without a setter");if(typeof e=="function"?ie!==e||!S:!e.has(ie))throw new TypeError("Cannot write private member to an object whose class did not declare it");return y==="a"?S.call(ie,r):S?S.value=r:e.set(ie,r),r};define(Ce[211],Ie([1,0,2,5,55,7,15,4,18,118,14,27,60,8,25]),function(ie,e,r,y,S,M,_,A,b,P,O,E,m,k,f){"use strict";var c,d;Object.defineProperty(e,"__esModule",{value:!0}),e.ExtHostSCM=e.ExtHostSCMInputBox=void 0;function h(v){if(v)return typeof v.iconPath=="string"?r.URI.file(v.iconPath):r.URI.isUri(v.iconPath)||m.ThemeIcon.isThemeIcon(v.iconPath)?v.iconPath:void 0}function g(v,p){if(!v.iconPath&&!p.iconPath)return 0;if(v.iconPath){if(!p.iconPath)return 1}else return-1;const T=typeof v.iconPath=="string"?v.iconPath:r.URI.isUri(v.iconPath)?v.iconPath.fsPath:v.iconPath.id,N=typeof p.iconPath=="string"?p.iconPath:r.URI.isUri(p.iconPath)?p.iconPath.fsPath:p.iconPath.id;return(0,P.comparePaths)(T,N)}function C(v,p){let T=0;if(v.strikeThrough!==p.strikeThrough)return v.strikeThrough?1:-1;if(v.faded!==p.faded)return v.faded?1:-1;if(v.tooltip!==p.tooltip)return(v.tooltip||"").localeCompare(p.tooltip||"");if(T=g(v,p),T!==0)return T;if(v.light&&p.light)T=g(v.light,p.light);else{if(v.light)return 1;if(p.light)return-1}if(T!==0)return T;if(v.dark&&p.dark)T=g(v.dark,p.dark);else{if(v.dark)return 1;if(p.dark)return-1}return T}function l(v,p){if(v.command!==p.command)return v.command<p.command?-1:1;if(v.title!==p.title)return v.title<p.title?-1:1;if(v.tooltip!==p.tooltip){if(v.tooltip!==void 0&&p.tooltip!==void 0)return v.tooltip<p.tooltip?-1:1;if(v.tooltip!==void 0)return 1;if(p.tooltip!==void 0)return-1}if(v.arguments===p.arguments)return 0;if(v.arguments)if(p.arguments){if(v.arguments.length!==p.arguments.length)return v.arguments.length-p.arguments.length}else return 1;else return-1;for(let T=0;T<v.arguments.length;T++){const N=v.arguments[T],V=p.arguments[T];if(N!==V)return N<V?-1:1}return 0}function w(v,p){let T=(0,P.comparePaths)(v.resourceUri.fsPath,p.resourceUri.fsPath,!0);if(T!==0)return T;if(v.command&&p.command)T=l(v.command,p.command);else{if(v.command)return 1;if(p.command)return-1}if(T!==0)return T;if(v.decorations&&p.decorations)T=C(v.decorations,p.decorations);else{if(v.decorations)return 1;if(p.decorations)return-1}return T}function t(v,p){for(let T=0;T<v.length;T++)if(v[T]!==p[T])return!1;return!0}function u(v,p){return v.command===p.command&&v.title===p.title&&v.tooltip===p.tooltip&&(v.arguments&&p.arguments?t(v.arguments,p.arguments):v.arguments===p.arguments)}function i(v,p){return(0,b.equals)(v,p,u)}class n{get value(){return this._value}set value(p){p=p??"",Oe(this,c,"f").$setInputBoxValue(this._sourceControlHandle,p),this.updateValue(p)}get onDidChange(){return this._onDidChange.event}get placeholder(){return this._placeholder}set placeholder(p){Oe(this,c,"f").$setInputBoxPlaceholder(this._sourceControlHandle,p),this._placeholder=p}get validateInput(){return(0,f.checkProposedApiEnabled)(this._extension,"scmValidation"),this._validateInput}set validateInput(p){if((0,f.checkProposedApiEnabled)(this._extension,"scmValidation"),p&&typeof p!="function")throw new Error(`[${this._extension.identifier.value}]: Invalid SCM input box validation function`);this._validateInput=p,Oe(this,c,"f").$setValidationProviderIsEnabled(this._sourceControlHandle,!!p)}get enabled(){return this._enabled}set enabled(p){p=!!p,this._enabled!==p&&(this._enabled=p,Oe(this,c,"f").$setInputBoxEnablement(this._sourceControlHandle,p))}get visible(){return this._visible}set visible(p){p=!!p,this._visible!==p&&(this._visible=p,Oe(this,c,"f").$setInputBoxVisibility(this._sourceControlHandle,p))}constructor(p,T,N){this._extension=p,this._sourceControlHandle=N,c.set(this,void 0),this._value="",this._onDidChange=new y.Emitter,this._placeholder="",this._enabled=!0,this._visible=!0,Je(this,c,T,"f")}showValidationMessage(p,T){(0,f.checkProposedApiEnabled)(this._extension,"scmValidation"),Oe(this,c,"f").$showValidationMessage(this._sourceControlHandle,p,T)}$onInputBoxValueChange(p){this.updateValue(p)}updateValue(p){this._value=p,this._onDidChange.fire(p)}}e.ExtHostSCMInputBox=n,c=new WeakMap;class s{get disposed(){return this._disposed}get id(){return this._id}get label(){return this._label}set label(p){this._label=p,this._proxy.$updateGroupLabel(this._sourceControlHandle,this.handle,p)}get hideWhenEmpty(){return this._hideWhenEmpty}set hideWhenEmpty(p){this._hideWhenEmpty=p,this._proxy.$updateGroup(this._sourceControlHandle,this.handle,this.features)}get features(){return{hideWhenEmpty:this.hideWhenEmpty}}get resourceStates(){return[...this._resourceStates]}set resourceStates(p){this._resourceStates=[...p],this._onDidUpdateResourceStates.fire()}constructor(p,T,N,V,B){this._proxy=p,this._commands=T,this._sourceControlHandle=N,this._id=V,this._label=B,this._resourceHandlePool=0,this._resourceStates=[],this._resourceStatesMap=new Map,this._resourceStatesCommandsMap=new Map,this._resourceStatesDisposablesMap=new Map,this._onDidUpdateResourceStates=new y.Emitter,this.onDidUpdateResourceStates=this._onDidUpdateResourceStates.event,this._disposed=!1,this._onDidDispose=new y.Emitter,this.onDidDispose=this._onDidDispose.event,this._handlesSnapshot=[],this._resourceSnapshot=[],this._hideWhenEmpty=void 0,this.handle=s._handlePool++}getResourceState(p){return this._resourceStatesMap.get(p)}$executeResourceCommand(p,T){const N=this._resourceStatesCommandsMap.get(p);return N?(0,_.asPromise)(()=>this._commands.executeCommand(N.command,...N.arguments||[],T)):Promise.resolve(void 0)}_takeResourceStateSnapshot(){const p=[...this._resourceStates].sort(w),N=(0,b.sortedDiff)(this._resourceSnapshot,p,w).map(D=>{const z=D.toInsert.map(L=>{const R=this._resourceHandlePool++;this._resourceStatesMap.set(R,L);const K=L.resourceUri;let W;if(L.command)if(L.command.command==="vscode.open"||L.command.command==="vscode.diff"){const be=new M.DisposableStore;W=this._commands.converter.toInternal(L.command,be),this._resourceStatesDisposablesMap.set(R,be)}else this._resourceStatesCommandsMap.set(R,L.command);const $=h(L.decorations),G=L.decorations&&h(L.decorations.light)||$,ne=L.decorations&&h(L.decorations.dark)||$,ge=[G,ne],oe=L.decorations&&L.decorations.tooltip||"",Ee=L.decorations&&!!L.decorations.strikeThrough,ce=L.decorations&&!!L.decorations.faded,me=L.contextValue||"";return{rawResource:[R,K,ge,oe,Ee,ce,me,W],handle:R}});return{start:D.start,deleteCount:D.deleteCount,toInsert:z}}),V=N.map(({start:D,deleteCount:z,toInsert:L})=>[D,z,L.map(R=>R.rawResource)]),B=N.reverse();for(const{start:D,deleteCount:z,toInsert:L}of B){const R=L.map(W=>W.handle),K=this._handlesSnapshot.splice(D,z,...R);for(const W of K)this._resourceStatesMap.delete(W),this._resourceStatesCommandsMap.delete(W),this._resourceStatesDisposablesMap.get(W)?.dispose(),this._resourceStatesDisposablesMap.delete(W)}return this._resourceSnapshot=p,V}dispose(){this._disposed=!0,this._onDidDispose.fire()}}s._handlePool=0;class a{get id(){return this._id}get label(){return this._label}get rootUri(){return this._rootUri}get inputBox(){return this._inputBox}get count(){return this._count}set count(p){this._count!==p&&(this._count=p,Oe(this,d,"f").$updateSourceControl(this.handle,{count:p}))}get quickDiffProvider(){return this._quickDiffProvider}set quickDiffProvider(p){this._quickDiffProvider=p,Oe(this,d,"f").$updateSourceControl(this.handle,{hasQuickDiffProvider:!!p})}get commitTemplate(){return this._commitTemplate}set commitTemplate(p){p!==this._commitTemplate&&(this._commitTemplate=p,Oe(this,d,"f").$updateSourceControl(this.handle,{commitTemplate:p}))}get acceptInputCommand(){return this._acceptInputCommand}set acceptInputCommand(p){this._acceptInputDisposables.value=new M.DisposableStore,this._acceptInputCommand=p;const T=this._commands.converter.toInternal(p,this._acceptInputDisposables.value);Oe(this,d,"f").$updateSourceControl(this.handle,{acceptInputCommand:T})}get actionButton(){return(0,f.checkProposedApiEnabled)(this._extension,"scmActionButton"),this._actionButton}set actionButton(p){(0,f.checkProposedApiEnabled)(this._extension,"scmActionButton"),this._actionButtonDisposables.value=new M.DisposableStore,this._actionButton=p;const T=p!==void 0?{command:this._commands.converter.toInternal(p.command,this._actionButtonDisposables.value),secondaryCommands:p.secondaryCommands?.map(N=>N.map(V=>this._commands.converter.toInternal(V,this._actionButtonDisposables.value))),description:p.description,enabled:p.enabled}:void 0;Oe(this,d,"f").$updateSourceControl(this.handle,{actionButton:T??null})}get statusBarCommands(){return this._statusBarCommands}set statusBarCommands(p){if(this._statusBarCommands&&p&&i(this._statusBarCommands,p))return;this._statusBarDisposables.value=new M.DisposableStore,this._statusBarCommands=p;const T=(p||[]).map(N=>this._commands.converter.toInternal(N,this._statusBarDisposables.value));Oe(this,d,"f").$updateSourceControl(this.handle,{statusBarCommands:T})}get selected(){return this._selected}constructor(p,T,N,V,B,D){this._extension=p,this._commands=N,this._id=V,this._label=B,this._rootUri=D,d.set(this,void 0),this._groups=new Map,this._count=void 0,this._quickDiffProvider=void 0,this._commitTemplate=void 0,this._acceptInputDisposables=new M.MutableDisposable,this._acceptInputCommand=void 0,this._actionButtonDisposables=new M.MutableDisposable,this._statusBarDisposables=new M.MutableDisposable,this._statusBarCommands=void 0,this._selected=!1,this._onDidChangeSelection=new y.Emitter,this.onDidChangeSelection=this._onDidChangeSelection.event,this.handle=a._handlePool++,this.createdResourceGroups=new Map,this.updatedResourceGroups=new Set,Je(this,d,T,"f"),this._inputBox=new n(p,Oe(this,d,"f"),this.handle),Oe(this,d,"f").$registerSourceControl(this.handle,V,B,D)}createResourceGroup(p,T){const N=new s(Oe(this,d,"f"),this._commands,this.handle,p,T),V=y.Event.once(N.onDidDispose)(()=>this.createdResourceGroups.delete(N));return this.createdResourceGroups.set(N,V),this.eventuallyAddResourceGroups(),N}eventuallyAddResourceGroups(){const p=[],T=[];for(const[N,V]of this.createdResourceGroups){V.dispose();const B=N.onDidUpdateResourceStates(()=>{this.updatedResourceGroups.add(N),this.eventuallyUpdateResourceStates()});y.Event.once(N.onDidDispose)(()=>{this.updatedResourceGroups.delete(N),B.dispose(),this._groups.delete(N.handle),Oe(this,d,"f").$unregisterGroup(this.handle,N.handle)}),p.push([N.handle,N.id,N.label,N.features]);const D=N._takeResourceStateSnapshot();D.length>0&&T.push([N.handle,D]),this._groups.set(N.handle,N)}Oe(this,d,"f").$registerGroups(this.handle,p,T),this.createdResourceGroups.clear()}eventuallyUpdateResourceStates(){const p=[];this.updatedResourceGroups.forEach(T=>{const N=T._takeResourceStateSnapshot();N.length!==0&&p.push([T.handle,N])}),p.length>0&&Oe(this,d,"f").$spliceResourceStates(this.handle,p),this.updatedResourceGroups.clear()}getResourceGroup(p){return this._groups.get(p)}setSelectionState(p){this._selected=p,this._onDidChangeSelection.fire(p)}dispose(){this._acceptInputDisposables.dispose(),this._actionButtonDisposables.dispose(),this._statusBarDisposables.dispose(),this._groups.forEach(p=>p.dispose()),Oe(this,d,"f").$unregisterSourceControl(this.handle)}}d=new WeakMap,a._handlePool=0,ze([(0,S.debounce)(100)],a.prototype,"eventuallyAddResourceGroups",null),ze([(0,S.debounce)(100)],a.prototype,"eventuallyUpdateResourceStates",null);let o=class en{get onDidChangeActiveProvider(){return this._onDidChangeActiveProvider.event}constructor(p,T,N){this._commands=T,this.logService=N,this._sourceControls=new Map,this._sourceControlsByExtension=new Map,this._onDidChangeActiveProvider=new y.Emitter,this._proxy=p.getProxy(A.MainContext.MainThreadSCM),this._telemetry=p.getProxy(A.MainContext.MainThreadTelemetry),T.registerArgumentProcessor({processArgument:V=>{if(V&&V.$mid===3){const B=this._sourceControls.get(V.sourceControlHandle);if(!B)return V;const D=B.getResourceGroup(V.groupHandle);return D?D.getResourceState(V.handle):V}else if(V&&V.$mid===4){const B=this._sourceControls.get(V.sourceControlHandle);return B?B.getResourceGroup(V.groupHandle):V}else if(V&&V.$mid===5){const B=this._sourceControls.get(V.handle);return B||V}return V}})}createSourceControl(p,T,N,V){this.logService.trace("ExtHostSCM#createSourceControl",p.identifier.value,T,N,V),this._telemetry.$publicLog2("api/scm/createSourceControl",{extensionId:p.identifier.value});const B=en._handlePool++,D=new a(p,this._proxy,this._commands,T,N,V);this._sourceControls.set(B,D);const z=this._sourceControlsByExtension.get(E.ExtensionIdentifier.toKey(p.identifier))||[];return z.push(D),this._sourceControlsByExtension.set(E.ExtensionIdentifier.toKey(p.identifier),z),D}getLastInputBox(p){this.logService.trace("ExtHostSCM#getLastInputBox",p.identifier.value);const T=this._sourceControlsByExtension.get(E.ExtensionIdentifier.toKey(p.identifier)),N=T&&T[T.length-1];return N&&N.inputBox}$provideOriginalResource(p,T,N){const V=r.URI.revive(T);this.logService.trace("ExtHostSCM#$provideOriginalResource",p,V.toString());const B=this._sourceControls.get(p);return!B||!B.quickDiffProvider||!B.quickDiffProvider.provideOriginalResource?Promise.resolve(null):(0,_.asPromise)(()=>B.quickDiffProvider.provideOriginalResource(V,N)).then(D=>D||null)}$onInputBoxValueChange(p,T){this.logService.trace("ExtHostSCM#$onInputBoxValueChange",p);const N=this._sourceControls.get(p);return N&&N.inputBox.$onInputBoxValueChange(T),Promise.resolve(void 0)}$executeResourceCommand(p,T,N,V){this.logService.trace("ExtHostSCM#$executeResourceCommand",p,T,N);const B=this._sourceControls.get(p);if(!B)return Promise.resolve(void 0);const D=B.getResourceGroup(T);return D?D.$executeResourceCommand(N,V):Promise.resolve(void 0)}$validateInput(p,T,N){this.logService.trace("ExtHostSCM#$validateInput",p);const V=this._sourceControls.get(p);return!V||!V.inputBox.validateInput?Promise.resolve(void 0):(0,_.asPromise)(()=>V.inputBox.validateInput(T,N)).then(B=>{if(!B)return Promise.resolve(void 0);const D=k.MarkdownString.fromStrict(B.message);return D?Promise.resolve([D,B.type]):Promise.resolve(void 0)})}$setSelectedSourceControl(p){return this.logService.trace("ExtHostSCM#$setSelectedSourceControl",p),p!==void 0&&this._sourceControls.get(p)?.setSelectionState(!0),this._selectedSourceControlHandle!==void 0&&this._sourceControls.get(this._selectedSourceControlHandle)?.setSelectionState(!1),this._selectedSourceControlHandle=p,Promise.resolve(void 0)}};o._handlePool=0,o=ze([$e(2,O.ILogService)],o),e.ExtHostSCM=o}),define(Ce[69],Ie([1,0,4,5,3]),function(ie,e,r,y,S){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.IExtHostSecretState=e.ExtHostSecretState=void 0;class M{constructor(A){this._onDidChangePassword=new y.Emitter,this.onDidChangePassword=this._onDidChangePassword.event,this._proxy=A.getProxy(r.MainContext.MainThreadSecretState)}async $onDidChangePassword(A){this._onDidChangePassword.fire(A)}get(A,b){return this._proxy.$getPassword(A,b)}store(A,b,P){return this._proxy.$setPassword(A,b,P)}delete(A,b){return this._proxy.$deletePassword(A,b)}}e.ExtHostSecretState=M,e.IExtHostSecretState=(0,S.createDecorator)("IExtHostSecretState")});var Je=this&&this.__classPrivateFieldSet||function(ie,e,r,y,S){if(y==="m")throw new TypeError("Private method is not writable");if(y==="a"&&!S)throw new TypeError("Private accessor was defined without a setter");if(typeof e=="function"?ie!==e||!S:!e.has(ie))throw new TypeError("Cannot write private member to an object whose class did not declare it");return y==="a"?S.call(ie,r):S?S.value=r:e.set(ie,r),r},Oe=this&&this.__classPrivateFieldGet||function(ie,e,r,y){if(r==="a"&&!y)throw new TypeError("Private accessor was defined without a getter");if(typeof e=="function"?ie!==e||!y:!e.has(ie))throw new TypeError("Cannot read private member from an object whose class did not declare it");return r==="m"?y:r==="a"?y.call(ie):y?y.value:e.get(ie)};define(Ce[212],Ie([1,0,6,4,133,7,8,10]),function(ie,e,r,y,S,M,_,A){"use strict";var b,P;Object.defineProperty(e,"__esModule",{value:!0}),e.ExtHostStatusBar=e.ExtHostStatusBarEntry=void 0;class O{constructor(f,c,d,h,g=r.StatusBarAlignment.Left,C){b.set(this,void 0),P.set(this,void 0),this._disposed=!1,this._visible=!1,this._text="",this._internalCommandRegistration=new M.DisposableStore,Je(this,b,f,"f"),Je(this,P,c,"f"),this._entryId=O.ID_GEN++,this._extension=d,this._id=h,this._alignment=g,this._priority=this.validatePriority(C)}validatePriority(f){if(!!(0,A.isNumber)(f))return f===Number.POSITIVE_INFINITY?Number.MAX_VALUE:f===Number.NEGATIVE_INFINITY?-Number.MAX_VALUE:f}get id(){return this._id??this._extension.identifier.value}get alignment(){return this._alignment}get priority(){return this._priority}get text(){return this._text}get name(){return this._name}get tooltip(){return this._tooltip}get color(){return this._color}get backgroundColor(){return this._backgroundColor}get command(){return this._command?.fromApi}get accessibilityInformation(){return this._accessibilityInformation}set text(f){this._text=f,this.update()}set name(f){this._name=f,this.update()}set tooltip(f){this._tooltip=f,this.update()}set color(f){this._color=f,this.update()}set backgroundColor(f){f&&!O.ALLOWED_BACKGROUND_COLORS.has(f.id)&&(f=void 0),this._backgroundColor=f,this.update()}set command(f){this._command?.fromApi!==f&&(this._internalCommandRegistration.clear(),typeof f=="string"?this._command={fromApi:f,internal:Oe(this,P,"f").toInternal({title:"",command:f},this._internalCommandRegistration)}:f?this._command={fromApi:f,internal:Oe(this,P,"f").toInternal(f,this._internalCommandRegistration)}:this._command=void 0,this.update())}set accessibilityInformation(f){this._accessibilityInformation=f,this.update()}show(){this._visible=!0,this.update()}hide(){clearTimeout(this._timeoutHandle),this._visible=!1,Oe(this,b,"f").$dispose(this._entryId)}update(){this._disposed||!this._visible||(clearTimeout(this._timeoutHandle),this._timeoutHandle=setTimeout(()=>{this._timeoutHandle=void 0;let f;this._extension?this._id?f=`${this._extension.identifier.value}.${this._id}`:f=this._extension.identifier.value:f=this._id;let c;this._name?c=this._name:c=(0,S.localize)(0,null,this._extension.displayName||this._extension.name);let d=this._color;this._backgroundColor&&(d=O.ALLOWED_BACKGROUND_COLORS.get(this._backgroundColor.id));const h=_.MarkdownString.fromStrict(this._tooltip);Oe(this,b,"f").$setEntry(this._entryId,f,c,this._text,h,this._command?.internal,d,this._backgroundColor,this._alignment===r.StatusBarAlignment.Left,this._priority,this._accessibilityInformation)},0))}dispose(){this.hide(),this._disposed=!0}}e.ExtHostStatusBarEntry=O,b=new WeakMap,P=new WeakMap,O.ID_GEN=0,O.ALLOWED_BACKGROUND_COLORS=new Map([["statusBarItem.errorBackground",new r.ThemeColor("statusBarItem.errorForeground")],["statusBarItem.warningBackground",new r.ThemeColor("statusBarItem.warningForeground")]]);class E{constructor(f){this._messages=[],this._item=f.createStatusBarEntry(void 0,"status.extensionMessage",r.StatusBarAlignment.Left,Number.MIN_VALUE),this._item.name=(0,S.localize)(1,null)}dispose(){this._messages.length=0,this._item.dispose()}setMessage(f){const c={message:f};return this._messages.unshift(c),this._update(),new r.Disposable(()=>{const d=this._messages.indexOf(c);d>=0&&(this._messages.splice(d,1),this._update())})}_update(){this._messages.length>0?(this._item.text=this._messages[0].message,this._item.show()):this._item.hide()}}class m{constructor(f,c){this._proxy=f.getProxy(y.MainContext.MainThreadStatusBar),this._commands=c,this._statusMessage=new E(this)}createStatusBarEntry(f,c,d,h){return new O(this._proxy,this._commands,f,c,d,h)}setStatusBarMessage(f,c){const d=this._statusMessage.setMessage(f);let h;return typeof c=="number"?h=setTimeout(()=>d.dispose(),c):typeof c<"u"&&c.then(()=>d.dispose(),()=>d.dispose()),new r.Disposable(()=>{d.dispose(),clearTimeout(h)})}}e.ExtHostStatusBar=m}),define(Ce[70],Ie([1,0,4,5,3]),function(ie,e,r,y,S){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.IExtHostStorage=e.ExtHostStorage=void 0;class M{constructor(A){this._onDidChangeStorage=new y.Emitter,this.onDidChangeStorage=this._onDidChangeStorage.event,this._proxy=A.getProxy(r.MainContext.MainThreadStorage)}registerExtensionStorageKeysToSync(A,b){this._proxy.$registerExtensionStorageKeysToSync(A,b)}initializeExtensionStorage(A,b,P){return this._proxy.$initializeExtensionStorage(A,b).then(O=>O||P)}setValue(A,b,P){return this._proxy.$setValue(A,b,P)}$acceptValue(A,b,P){this._onDidChangeStorage.fire({shared:A,key:b,value:P})}}e.ExtHostStorage=M,e.IExtHostStorage=(0,S.createDecorator)("IExtHostStorage")}),define(Ce[71],Ie([1,0,3,28,14,52,2]),function(ie,e,r,y,S,M,_){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtensionStoragePaths=e.IExtensionStoragePaths=void 0,e.IExtensionStoragePaths=(0,r.createDecorator)("IExtensionStoragePaths");let A=class{constructor(P,O,E){this._logService=O,this._extHostFileSystem=E,this._workspace=P.workspace??void 0,this._environment=P.environment,this.whenReady=this._getOrCreateWorkspaceStoragePath().then(m=>this._value=m)}async _getWorkspaceStorageURI(P){return _.URI.joinPath(this._environment.workspaceStorageHome,P)}async _getOrCreateWorkspaceStoragePath(){if(!this._workspace)return Promise.resolve(void 0);const P=this._workspace.id,O=await this._getWorkspaceStorageURI(P);try{return await this._extHostFileSystem.value.stat(O),this._logService.trace("[ExtHostStorage] storage dir already exists",O),O}catch{}try{return this._logService.trace("[ExtHostStorage] creating dir and metadata-file",O),await this._extHostFileSystem.value.createDirectory(O),await this._extHostFileSystem.value.writeFile(_.URI.joinPath(O,"meta.json"),new TextEncoder().encode(JSON.stringify({id:this._workspace.id,configuration:_.URI.revive(this._workspace.configuration)?.toString(),name:this._workspace.name},void 0,2))),O}catch(E){this._logService.error("[ExtHostStorage]",E);return}}workspaceValue(P){if(this._value)return _.URI.joinPath(this._value,P.identifier.value)}globalValue(P){return _.URI.joinPath(this._environment.globalStorageHome,P.identifier.value.toLowerCase())}onWillDeactivateAll(){}};A=ze([$e(0,y.IExtHostInitDataService),$e(1,S.ILogService),$e(2,M.IExtHostConsumerFileSystem)],A),e.ExtensionStoragePaths=A}),define(Ce[98],Ie([1,0,3,4,11]),function(ie,e,r,y,S){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtHostTelemetryLogService=e.IExtHostTelemetryLogService=void 0,e.IExtHostTelemetryLogService=(0,r.createDecorator)("IExtHostTelemetryLogService");let M=class{constructor(A){this._telemetryShape=A.getProxy(y.MainContext.MainThreadTelemetry)}logToTelemetryOutputChannel(A,b,P){this._telemetryShape.$logTelemetryToOutputChannel(`${A.identifier.value}/${b}`,P)}};M=ze([$e(0,S.IExtHostRpcService)],M),e.ExtHostTelemetryLogService=M}),define(Ce[53],Ie([1,0,5,4,3,2,11,7,6,134,12,168,20,42,154,60,10,15,8]),function(ie,e,r,y,S,M,_,A,b,P,O,E,m,k,f,c,d,h,g){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.WorkerExtHostTerminalService=e.EnvironmentVariableCollection=e.BaseExtHostTerminalService=e.ExtHostPseudoterminal=e.ExtHostTerminal=e.IExtHostTerminalService=void 0,e.IExtHostTerminalService=(0,S.createDecorator)("IExtHostTerminalService");class C{constructor(o,v,p,T){this._proxy=o,this._id=v,this._creationOptions=p,this._name=T,this._disposed=!1,this._state={isInteractedWith:!1},this.isOpen=!1,this._creationOptions=Object.freeze(this._creationOptions),this._pidPromise=new Promise(V=>this._pidPromiseComplete=V);const N=this;this.value={get name(){return N._name||""},get processId(){return N._pidPromise},get creationOptions(){return N._creationOptions},get exitStatus(){return N._exitStatus},get state(){return N._state},sendText(V,B=!0){N._checkDisposed(),N._proxy.$sendText(N._id,V,B)},show(V){N._checkDisposed(),N._proxy.$show(N._id,V)},hide(){N._checkDisposed(),N._proxy.$hide(N._id)},dispose(){N._disposed||(N._disposed=!0,N._proxy.$dispose(N._id))},get dimensions(){if(!(N._cols===void 0||N._rows===void 0))return{columns:N._cols,rows:N._rows}}}}async create(o,v){if(typeof this._id!="string")throw new Error("Terminal has already been created");await this._proxy.$createTerminal(this._id,{name:o.name,shellPath:(0,d.withNullAsUndefined)(o.shellPath),shellArgs:(0,d.withNullAsUndefined)(o.shellArgs),cwd:(0,d.withNullAsUndefined)(o.cwd),env:(0,d.withNullAsUndefined)(o.env),icon:(0,d.withNullAsUndefined)(n(o.iconPath)),color:c.ThemeColor.isThemeColor(o.color)?o.color.id:void 0,initialText:(0,d.withNullAsUndefined)(o.message),strictEnv:(0,d.withNullAsUndefined)(o.strictEnv),hideFromUser:(0,d.withNullAsUndefined)(o.hideFromUser),isFeatureTerminal:(0,d.withNullAsUndefined)(v?.isFeatureTerminal),isExtensionOwnedTerminal:!0,useShellEnvironment:(0,d.withNullAsUndefined)(v?.useShellEnvironment),location:v?.location||this._serializeParentTerminal(o.location,v?.resolvedExtHostIdentifier),isTransient:(0,d.withNullAsUndefined)(o.isTransient)})}async createExtensionTerminal(o,v,p,T){if(typeof this._id!="string")throw new Error("Terminal has already been created");if(await this._proxy.$createTerminal(this._id,{name:this._name,isExtensionCustomPtyTerminal:!0,icon:p,color:c.ThemeColor.isThemeColor(T)?T.id:void 0,location:this._serializeParentTerminal(o,v),isTransient:!0}),typeof this._id=="string")throw new Error("Terminal creation failed");return this._id}_serializeParentTerminal(o,v){return typeof o=="object"?"parentTerminal"in o&&o.parentTerminal&&v?{parentTerminal:v}:"viewColumn"in o?{viewColumn:g.ViewColumn.from(o.viewColumn),preserveFocus:o.preserveFocus}:void 0:o}_checkDisposed(){if(this._disposed)throw new Error("Terminal has already been disposed")}set name(o){this._name=o}setExitStatus(o,v){this._exitStatus=Object.freeze({code:o,reason:v})}setDimensions(o,v){return o===this._cols&&v===this._rows||o===0||v===0?!1:(this._cols=o,this._rows=v,!0)}setInteractedWith(){return this._state.isInteractedWith?!1:(this._state={isInteractedWith:!0},!0)}_setProcessId(o){this._pidPromiseComplete?(this._pidPromiseComplete(o),this._pidPromiseComplete=void 0):this._pidPromise.then(v=>{v!==o&&(this._pidPromise=Promise.resolve(o))})}}e.ExtHostTerminal=C;class l{get onProcessReady(){return this._onProcessReady.event}constructor(o){this._pty=o,this.id=0,this.shouldPersist=!1,this._onProcessData=new r.Emitter,this.onProcessData=this._onProcessData.event,this._onProcessReady=new r.Emitter,this._onDidChangeProperty=new r.Emitter,this.onDidChangeProperty=this._onDidChangeProperty.event,this._onProcessExit=new r.Emitter,this.onProcessExit=this._onProcessExit.event}refreshProperty(o){throw new Error(`refreshProperty is not suppported in extension owned terminals. property: ${o}`)}updateProperty(o,v){throw new Error(`updateProperty is not suppported in extension owned terminals. property: ${o}, value: ${v}`)}async start(){}shutdown(){this._pty.close()}input(o){this._pty.handleInput?.(o)}resize(o,v){this._pty.setDimensions?.({columns:o,rows:v})}async processBinary(o){}acknowledgeDataEvent(o){}async setUnicodeVersion(o){}getInitialCwd(){return Promise.resolve("")}getCwd(){return Promise.resolve("")}getLatency(){return Promise.resolve(0)}startSendingEvents(o){this._pty.onDidWrite(v=>this._onProcessData.fire(v)),this._pty.onDidClose?.((v=void 0)=>{this._onProcessExit.fire(v===void 0?void 0:v)}),this._pty.onDidOverrideDimensions?.(v=>{v&&this._onDidChangeProperty.fire({type:"overrideDimensions",value:{cols:v.columns,rows:v.rows}})}),this._pty.onDidChangeName?.(v=>{this._onDidChangeProperty.fire({type:"title",value:v})}),this._pty.open(o||void 0),o&&this._pty.setDimensions?.(o),this._onProcessReady.fire({pid:-1,cwd:""})}}e.ExtHostPseudoterminal=l;let w=1,t=class extends A.Disposable{get activeTerminal(){return this._activeTerminal?.value}get terminals(){return this._terminals.map(o=>o.value)}get onDidWriteTerminalData(){return this._onDidWriteTerminalData.event}constructor(o,v){super(),this._terminals=[],this._terminalProcesses=new Map,this._terminalProcessDisposables={},this._extensionTerminalAwaitingStart={},this._getTerminalPromises={},this._environmentVariableCollections=new Map,this._linkProviders=new Set,this._profileProviders=new Map,this._terminalLinkCache=new Map,this._terminalLinkCancellationSource=new Map,this._onDidCloseTerminal=new r.Emitter,this.onDidCloseTerminal=this._onDidCloseTerminal.event,this._onDidOpenTerminal=new r.Emitter,this.onDidOpenTerminal=this._onDidOpenTerminal.event,this._onDidChangeActiveTerminal=new r.Emitter,this.onDidChangeActiveTerminal=this._onDidChangeActiveTerminal.event,this._onDidChangeTerminalDimensions=new r.Emitter,this.onDidChangeTerminalDimensions=this._onDidChangeTerminalDimensions.event,this._onDidChangeTerminalState=new r.Emitter,this.onDidChangeTerminalState=this._onDidChangeTerminalState.event,this._onDidChangeShell=new r.Emitter,this.onDidChangeShell=this._onDidChangeShell.event,this._proxy=v.getProxy(y.MainContext.MainThreadTerminalService),this._bufferer=new f.TerminalDataBufferer(this._proxy.$sendProcessData),this._onDidWriteTerminalData=new r.Emitter({onFirstListenerAdd:()=>this._proxy.$startSendingDataEvents(),onLastListenerRemove:()=>this._proxy.$stopSendingDataEvents()}),this._proxy.$registerProcessSupport(o),this._register({dispose:()=>{for(const[p,T]of this._terminalProcesses)T.shutdown(!0)}})}getDefaultShell(o){return(o?this._defaultAutomationProfile:this._defaultProfile)?.path||""}getDefaultShellArgs(o){return(o?this._defaultAutomationProfile:this._defaultProfile)?.args||[]}createExtensionTerminal(o,v){const p=new C(this._proxy,(0,k.generateUuid)(),o,o.name),T=new l(o.pty);return p.createExtensionTerminal(o.location,this._serializeParentTerminal(o,v).resolvedExtHostIdentifier,n(o.iconPath),s(o.color)).then(N=>{const V=this._setupExtHostProcessListeners(N,T);this._terminalProcessDisposables[N]=V}),this._terminals.push(p),p.value}_serializeParentTerminal(o,v){if(v=v||{},o.location&&typeof o.location=="object"&&"parentTerminal"in o.location){const p=o.location.parentTerminal;if(p){const T=this._terminals.find(N=>N.value===p);T&&(v.resolvedExtHostIdentifier=T._id)}}else o.location&&typeof o.location!="object"?v.location=o.location:v.location&&typeof v.location=="object"&&"splitActiveTerminal"in v.location&&(v.location={splitActiveTerminal:!0});return v}attachPtyToTerminal(o,v){if(!this._getTerminalById(o))throw new Error(`Cannot resolve terminal with id ${o} for virtual process`);const T=new l(v),N=this._setupExtHostProcessListeners(o,T);this._terminalProcessDisposables[o]=N}async $acceptActiveTerminalChanged(o){const v=this._activeTerminal;if(o===null){this._activeTerminal=void 0,v!==this._activeTerminal&&this._onDidChangeActiveTerminal.fire(this._activeTerminal);return}const p=this._getTerminalById(o);p&&(this._activeTerminal=p,v!==this._activeTerminal&&this._onDidChangeActiveTerminal.fire(this._activeTerminal.value))}async $acceptTerminalProcessData(o,v){const p=this._getTerminalById(o);p&&this._onDidWriteTerminalData.fire({terminal:p.value,data:v})}async $acceptTerminalDimensions(o,v,p){const T=this._getTerminalById(o);T&&T.setDimensions(v,p)&&this._onDidChangeTerminalDimensions.fire({terminal:T.value,dimensions:T.value.dimensions})}async $acceptTerminalMaximumDimensions(o,v,p){this._terminalProcesses.get(o)?.resize(v,p)}async $acceptTerminalTitleChange(o,v){const p=this._getTerminalById(o);p&&(p.name=v)}async $acceptTerminalClosed(o,v,p){const T=this._getTerminalObjectIndexById(this._terminals,o);if(T!==null){const N=this._terminals.splice(T,1)[0];N.setExitStatus(v,p),this._onDidCloseTerminal.fire(N.value)}}$acceptTerminalOpened(o,v,p,T){if(v){const B=this._getTerminalObjectIndexById(this._terminals,v);if(B!==null){this._terminals[B]._id=o,this._onDidOpenTerminal.fire(this.terminals[B]),this._terminals[B].isOpen=!0;return}}const N={name:T.name,shellPath:T.executable,shellArgs:T.args,cwd:typeof T.cwd=="string"?T.cwd:M.URI.revive(T.cwd),env:T.env,hideFromUser:T.hideFromUser},V=new C(this._proxy,o,N,p);this._terminals.push(V),this._onDidOpenTerminal.fire(V.value),V.isOpen=!0}async $acceptTerminalProcessId(o,v){this._getTerminalById(o)?._setProcessId(v)}async $startExtensionTerminal(o,v){const p=this._getTerminalById(o);if(!p)return{message:(0,P.localize)(0,null,o)};p.isOpen||await new Promise(N=>{const V=this.onDidOpenTerminal(async B=>{B===p.value&&(V.dispose(),N())})});const T=this._terminalProcesses.get(o);T?T.startSendingEvents(v):this._extensionTerminalAwaitingStart[o]={initialDimensions:v}}_setupExtHostProcessListeners(o,v){const p=new A.DisposableStore;p.add(v.onProcessReady(N=>this._proxy.$sendProcessReady(o,N.pid,N.cwd))),p.add(v.onDidChangeProperty(N=>this._proxy.$sendProcessProperty(o,N))),this._bufferer.startBuffering(o,v.onProcessData),p.add(v.onProcessExit(N=>this._onProcessExit(o,N))),this._terminalProcesses.set(o,v);const T=this._extensionTerminalAwaitingStart[o];return T&&v instanceof l&&(v.startSendingEvents(T.initialDimensions),delete this._extensionTerminalAwaitingStart[o]),p}$acceptProcessAckDataEvent(o,v){this._terminalProcesses.get(o)?.acknowledgeDataEvent(v)}$acceptProcessInput(o,v){this._terminalProcesses.get(o)?.input(v)}$acceptTerminalInteraction(o){const v=this._getTerminalById(o);v?.setInteractedWith()&&this._onDidChangeTerminalState.fire(v.value)}$acceptProcessResize(o,v,p){try{this._terminalProcesses.get(o)?.resize(v,p)}catch(T){if(T.code!=="EPIPE"&&T.code!=="ERR_IPC_CHANNEL_CLOSED")throw T}}$acceptProcessShutdown(o,v){this._terminalProcesses.get(o)?.shutdown(v)}$acceptProcessRequestInitialCwd(o){this._terminalProcesses.get(o)?.getInitialCwd().then(v=>this._proxy.$sendProcessProperty(o,{type:"initialCwd",value:v}))}$acceptProcessRequestCwd(o){this._terminalProcesses.get(o)?.getCwd().then(v=>this._proxy.$sendProcessProperty(o,{type:"cwd",value:v}))}$acceptProcessRequestLatency(o){return Promise.resolve(o)}registerLinkProvider(o){return this._linkProviders.add(o),this._linkProviders.size===1&&this._proxy.$startLinkProvider(),new b.Disposable(()=>{this._linkProviders.delete(o),this._linkProviders.size===0&&this._proxy.$stopLinkProvider()})}registerProfileProvider(o,v,p){if(this._profileProviders.has(v))throw new Error(`Terminal profile provider "${v}" already registered`);return this._profileProviders.set(v,p),this._proxy.$registerProfileProvider(v,o.identifier.value),new b.Disposable(()=>{this._profileProviders.delete(v),this._proxy.$unregisterProfileProvider(v)})}async $createContributedProfileTerminal(o,v){const p=new m.CancellationTokenSource().token;let T=await this._profileProviders.get(o)?.provideTerminalProfile(p);if(!p.isCancellationRequested){if(T&&!("options"in T)&&(T={options:T}),!T||!("options"in T))throw new Error(`No terminal profile options provided for id "${o}"`);if("pty"in T.options){this.createExtensionTerminal(T.options,v);return}this.createTerminalFromOptions(T.options,v)}}async $provideLinks(o,v){const p=this._getTerminalById(o);if(!p)return[];this._terminalLinkCache.delete(o),this._terminalLinkCancellationSource.get(o)?.dispose(!0);const N=new m.CancellationTokenSource;this._terminalLinkCancellationSource.set(o,N);const V=[],B={terminal:p.value,line:v},D=[];for(const R of this._linkProviders)D.push(h.Promises.withAsyncBody(async K=>{N.token.onCancellationRequested(()=>K({provider:R,links:[]}));const W=await R.provideTerminalLinks(B,N.token)||[];N.token.isCancellationRequested||K({provider:R,links:W})}));const z=await Promise.all(D);if(N.token.isCancellationRequested)return[];const L=new Map;for(const R of z)R&&R.links.length>0&&V.push(...R.links.map(K=>{const W={id:w++,startIndex:K.startIndex,length:K.length,label:K.tooltip};return L.set(W.id,{provider:R.provider,link:K}),W}));return this._terminalLinkCache.set(o,L),V}$activateLink(o,v){const p=this._terminalLinkCache.get(o)?.get(v);!p||p.provider.handleTerminalLink(p.link)}_onProcessExit(o,v){this._bufferer.stopBuffering(o),this._terminalProcesses.delete(o),delete this._extensionTerminalAwaitingStart[o];const p=this._terminalProcessDisposables[o];p&&(p.dispose(),delete this._terminalProcessDisposables[o]),this._proxy.$sendProcessExit(o,v)}_getTerminalById(o){return this._getTerminalObjectById(this._terminals,o)}_getTerminalObjectById(o,v){const p=this._getTerminalObjectIndexById(o,v);return p!==null?o[p]:null}_getTerminalObjectIndexById(o,v){let p=null;return o.some((T,N)=>T._id===v?(p=N,!0):!1),p}getEnvironmentVariableCollection(o){let v=this._environmentVariableCollections.get(o.identifier.value);return v||(v=new u,this._setEnvironmentVariableCollection(o.identifier.value,v)),v}_syncEnvironmentVariableCollection(o,v){const p=(0,E.serializeEnvironmentVariableCollection)(v.map);this._proxy.$setEnvironmentVariableCollection(o,v.persistent,p.length===0?void 0:p)}$initEnvironmentVariableCollections(o){o.forEach(v=>{const p=v[0],T=new u(v[1]);this._setEnvironmentVariableCollection(p,T)})}$acceptDefaultProfile(o,v){const p=this._defaultProfile;this._defaultProfile=o,this._defaultAutomationProfile=v,p?.path!==o.path&&this._onDidChangeShell.fire(o.path)}_setEnvironmentVariableCollection(o,v){this._environmentVariableCollections.set(o,v),v.onDidChangeCollection(()=>{this._syncEnvironmentVariableCollection(o,v)})}};t=ze([$e(1,_.IExtHostRpcService)],t),e.BaseExtHostTerminalService=t;class u{get persistent(){return this._persistent}set persistent(o){this._persistent=o,this._onDidChangeCollection.fire()}get onDidChangeCollection(){return this._onDidChangeCollection&&this._onDidChangeCollection.event}constructor(o){this.map=new Map,this._persistent=!0,this._onDidChangeCollection=new r.Emitter,this.map=new Map(o)}get size(){return this.map.size}replace(o,v){this._setIfDiffers(o,{value:v,type:b.EnvironmentVariableMutatorType.Replace})}append(o,v){this._setIfDiffers(o,{value:v,type:b.EnvironmentVariableMutatorType.Append})}prepend(o,v){this._setIfDiffers(o,{value:v,type:b.EnvironmentVariableMutatorType.Prepend})}_setIfDiffers(o,v){const p=this.map.get(o);(!p||p.value!==v.value||p.type!==v.type)&&(this.map.set(o,v),this._onDidChangeCollection.fire())}get(o){return this.map.get(o)}forEach(o,v){this.map.forEach((p,T)=>o.call(v,T,p,this))}[Symbol.iterator](){return this.map.entries()}delete(o){this.map.delete(o),this._onDidChangeCollection.fire()}clear(){this.map.clear(),this._onDidChangeCollection.fire()}}e.EnvironmentVariableCollection=u;let i=class extends t{constructor(o){super(!1,o)}createTerminal(o,v,p){throw new O.NotSupportedError}createTerminalFromOptions(o,v){throw new O.NotSupportedError}};i=ze([$e(0,_.IExtHostRpcService)],i),e.WorkerExtHostTerminalService=i;function n(a){if(!(!a||typeof a=="string"))return"id"in a?{id:a.id,color:a.color}:a}function s(a){return c.ThemeColor.isThemeColor(a)?a:void 0}});var Oe=this&&this.__classPrivateFieldGet||function(ie,e,r,y){if(r==="a"&&!y)throw new TypeError("Private accessor was defined without a getter");if(typeof e=="function"?ie!==e||!y:!e.has(ie))throw new TypeError("Cannot read private member from an object whose class did not declare it");return r==="m"?y:r==="a"?y.call(ie):y?y.value:e.get(ie)},Je=this&&this.__classPrivateFieldSet||function(ie,e,r,y,S){if(y==="m")throw new TypeError("Private method is not writable");if(y==="a"&&!S)throw new TypeError("Private accessor was defined without a setter");if(typeof e=="function"?ie!==e||!S:!e.has(ie))throw new TypeError("Cannot write private member to an object whose class did not declare it");return y==="a"?S.call(ie,r):S?S.value=r:e.set(ie,r),r};define(Ce[213],Ie([1,0,18,23,20,5,177,214,7,26,10,42,4,11,95,8,6,47,65,48]),function(ie,e,r,y,S,M,_,A,b,P,O,E,m,k,f,c,d,h,g,C){"use strict";var l,w;Object.defineProperty(e,"__esModule",{value:!0}),e.TestRunProfileImpl=e.MirroredTestCollection=e.TestRunDto=e.TestRunCoordinator=e.ExtHostTesting=void 0;let t=class{constructor(B,D,z){this.editors=z,this.resultsChangedEmitter=new M.Emitter,this.controllers=new Map,this.onResultsChanged=this.resultsChangedEmitter.event,this.results=[],this.proxy=B.getProxy(m.MainContext.MainThreadTesting),this.observer=new p(this.proxy),this.runTracker=new i(this.proxy),D.registerArgumentProcessor({processArgument:L=>L?.$mid===13?(0,f.toItemFromContext)(L):L})}createTestController(B,D,z){if(this.controllers.has(B))throw new Error(`Attempt to insert a duplicate controller with ID "${B}"`);const L=new b.DisposableStore,R=L.add(new f.ExtHostTestItemCollection(B,D,this.editors));R.root.label=D;const K=new Map,W=this.proxy,$={items:R.root.children,get label(){return D},set label(ne){D=ne,R.root.label=ne,W.$updateController(B,{label:D})},get refreshHandler(){return z},set refreshHandler(ne){z=ne,W.$updateController(B,{canRefresh:!!ne})},get id(){return B},createRunProfile:(ne,ge,oe,Ee,ce)=>{let me=(0,A.hash)(ne);for(;K.has(me);)me++;return new T(this.proxy,K,B,me,ne,ge,oe,Ee,ce)},createTestItem(ne,ge,oe){return new f.TestItemImpl(B,ne,ge,oe)},createTestRun:(ne,ge,oe=!0)=>this.runTracker.createTestRun(B,R,ne,ge,oe),set resolveHandler(ne){R.resolveHandler=ne},get resolveHandler(){return R.resolveHandler},dispose:()=>{L.dispose()}};W.$registerTestController(B,D,!!z),L.add((0,b.toDisposable)(()=>W.$unregisterTestController(B)));const G={controller:$,collection:R,profiles:K};return this.controllers.set(B,G),L.add((0,b.toDisposable)(()=>this.controllers.delete(B))),L.add(R.onDidGenerateDiff(ne=>W.$publishDiff(B,ne.map(C.TestsDiffOp.serialize)))),$}createTestObserver(){return this.observer.checkout()}async runTests(B,D=S.CancellationToken.None){const z=n(B);if(!z)throw new Error("The request passed to `vscode.test.runTests` must include a profile");const L=this.controllers.get(z.controllerId);if(!L)throw new Error("Controller not found");await this.proxy.$runTests({isUiTriggered:!1,targets:[{testIds:B.include?.map(R=>h.TestId.fromExtHostTestItem(R,L.collection.root.id).toString())??[L.collection.root.id],profileGroup:N[z.kind],profileId:z.profileId,controllerId:z.controllerId}],exclude:B.exclude?.map(R=>R.id)},D)}$provideFileCoverage(B,D,z){return(0,r.mapFind)(this.runTracker.trackers,R=>R.id===B?R.getCoverage(D):void 0)?.provideFileCoverage(z)??Promise.resolve([])}$resolveFileCoverage(B,D,z,L){return(0,r.mapFind)(this.runTracker.trackers,K=>K.id===B?K.getCoverage(D):void 0)?.resolveFileCoverage(z,L)??Promise.resolve([])}$configureRunProfile(B,D){this.controllers.get(B)?.profiles.get(D)?.configureHandler?.()}async $refreshTests(B,D){await this.controllers.get(B)?.controller.refreshHandler?.(D)}$publishTestResults(B){this.results=Object.freeze(B.map(D=>(0,P.deepFreeze)(c.TestResults.to(D))).concat(this.results).sort((D,z)=>z.completedAt-D.completedAt).slice(0,32)),this.resultsChangedEmitter.fire()}async $expandTest(B,D){const z=this.controllers.get(h.TestId.fromString(B).controllerId)?.collection;z&&(await z.expand(B,D<0?1/0:D),z.flushDiff())}$acceptDiff(B){this.observer.applyDiff(B.map(C.TestsDiffOp.deserialize))}async $runControllerTests(B,D){return Promise.all(B.map(z=>this.runControllerTestRequest(z,D)))}async runControllerTestRequest(B,D){const z=this.controllers.get(B.controllerId);if(!z)return{};const{collection:L,profiles:R}=z,K=R.get(B.profileId);if(!K)return{};const W=B.testIds.map(ge=>L.tree.get(ge)).filter(O.isDefined),$=B.excludeExtIds.map(ge=>z.collection.tree.get(ge)).filter(O.isDefined).filter(ge=>W.some(oe=>oe.fullId.compare(ge.fullId)===2));if(!W.length)return{};const G=new d.TestRunRequest(W.some(ge=>ge.actual instanceof f.TestItemRootImpl)?void 0:W.map(ge=>ge.actual),$.map(ge=>ge.actual),K),ne=this.runTracker.prepareForMainThreadTestRun(G,s.fromInternal(B,z.collection),D);try{return await K.runHandler(G,D),{}}catch(ge){return{error:String(ge)}}finally{ne.isRunning&&!D.isCancellationRequested&&await M.Event.toPromise(ne.onEnd),ne.dispose()}}$cancelExtensionTestRun(B){B===void 0?this.runTracker.cancelAllRuns():this.runTracker.cancelRunById(B)}};t=ze([$e(0,k.IExtHostRpcService)],t),e.ExtHostTesting=t;class u extends b.Disposable{get isRunning(){return this.tasks.size>0}get id(){return this.dto.id}constructor(B,D,z){super(),this.dto=B,this.proxy=D,this.tasks=new Map,this.sharedTestIds=new Set,this.endEmitter=this._register(new M.Emitter),this.disposed=!1,this.onEnd=this.endEmitter.event,this.cts=this._register(new S.CancellationTokenSource(z)),this._register(this.cts.token.onCancellationRequested(()=>{for(const{run:L}of this.tasks.values())L.end()}))}getCoverage(B){return this.tasks.get(B)?.coverage}createRun(B){const D=this.dto.id,z=this.dto.controllerId,L=(0,E.generateUuid)(),R=new a(this.proxy,D,L),K=ne=>(ge,...oe)=>{if($){console.warn(`Setting the state of test "${ge.id}" is a no-op after the run ends.`);return}!this.dto.isIncluded(ge)||(this.ensureTestIsKnown(ge),ne(ge,...oe))},W=(ne,ge)=>{const oe=ge instanceof Array?ge.map(c.TestMessage.from):[c.TestMessage.from(ge)];if(ne.uri&&ne.range){const Ee={range:c.Range.from(ne.range),uri:ne.uri};for(const ce of oe)ce.location=ce.location||Ee}this.proxy.$appendTestMessagesInRun(D,L,h.TestId.fromExtHostTestItem(ne,z).toString(),oe)};let $=!1;const G={isPersisted:this.dto.isPersisted,token:this.cts.token,name:B,get coverageProvider(){return R.coverageProvider},set coverageProvider(ne){R.coverageProvider=ne},enqueued:K(ne=>{this.proxy.$updateTestStateInRun(D,L,h.TestId.fromExtHostTestItem(ne,z).toString(),1)}),skipped:K(ne=>{this.proxy.$updateTestStateInRun(D,L,h.TestId.fromExtHostTestItem(ne,z).toString(),5)}),started:K(ne=>{this.proxy.$updateTestStateInRun(D,L,h.TestId.fromExtHostTestItem(ne,z).toString(),2)}),errored:K((ne,ge,oe)=>{W(ne,ge),this.proxy.$updateTestStateInRun(D,L,h.TestId.fromExtHostTestItem(ne,z).toString(),6,oe)}),failed:K((ne,ge,oe)=>{W(ne,ge),this.proxy.$updateTestStateInRun(D,L,h.TestId.fromExtHostTestItem(ne,z).toString(),4,oe)}),passed:K((ne,ge)=>{this.proxy.$updateTestStateInRun(D,L,h.TestId.fromExtHostTestItem(ne,this.dto.controllerId).toString(),3,ge)}),appendOutput:(ne,ge,oe)=>{$||(oe&&(this.dto.isIncluded(oe)?this.ensureTestIsKnown(oe):oe=void 0),this.proxy.$appendOutputToRun(D,L,y.VSBuffer.fromString(ne),ge&&c.location.from(ge),oe&&h.TestId.fromExtHostTestItem(oe,z).toString()))},end:()=>{$||($=!0,this.proxy.$finishedTestRunTask(D,L),this.tasks.delete(L),this.isRunning||this.dispose())}};return this.tasks.set(L,{run:G,coverage:R}),this.proxy.$startedTestRunTask(D,{id:L,name:B,running:!0}),G}dispose(){this.disposed||(this.disposed=!0,this.endEmitter.fire(),this.cts.cancel(),super.dispose())}ensureTestIsKnown(B){if(!(B instanceof f.TestItemImpl))throw new g.InvalidTestItemError(B.id);if(this.sharedTestIds.has(h.TestId.fromExtHostTestItem(B,this.dto.controllerId).toString()))return;const D=[],z=this.dto.colllection.root;for(;;){const L=c.TestItem.from(B);if(D.unshift(L),this.sharedTestIds.has(L.extId)||(this.sharedTestIds.add(L.extId),B===z))break;B=B.parent||z}this.proxy.$addTestsToRun(this.dto.controllerId,this.dto.id,D)}}class i{get trackers(){return this.tracked.values()}constructor(B){this.proxy=B,this.tracked=new Map}prepareForMainThreadTestRun(B,D,z){return this.getTracker(B,D,z)}cancelRunById(B){for(const D of this.tracked.values())if(D.id===B){D.dispose();return}}cancelAllRuns(){for(const B of this.tracked.values())B.dispose()}createTestRun(B,D,z,L,R){const K=this.tracked.get(z);if(K)return K.createRun(L);const W=s.fromPublic(B,D,z,R),$=n(z);this.proxy.$startedExtensionTestRun({controllerId:B,profile:$&&{group:N[$.kind],id:$.profileId},exclude:z.exclude?.map(ne=>h.TestId.fromExtHostTestItem(ne,D.root.id).toString())??[],id:W.id,include:z.include?.map(ne=>h.TestId.fromExtHostTestItem(ne,D.root.id).toString())??[D.root.id],persist:R});const G=this.getTracker(z,W);return G.onEnd(()=>this.proxy.$finishedExtensionTestRun(W.id)),G.createRun(L)}getTracker(B,D,z){const L=new u(D,this.proxy,z);return this.tracked.set(B,L),L.onEnd(()=>this.tracked.delete(B)),L}}e.TestRunCoordinator=i;const n=V=>{if(!!V.profile){if(!(V.profile instanceof T))throw new Error("TestRunRequest.profile is not an instance created from TestController.createRunProfile");return V.profile}};class s{static fromPublic(B,D,z,L){return new s(B,(0,E.generateUuid)(),z.include?.map(R=>h.TestId.fromExtHostTestItem(R,B).toString())??[B],z.exclude?.map(R=>h.TestId.fromExtHostTestItem(R,B).toString())??[],L,D)}static fromInternal(B,D){return new s(B.controllerId,B.runId,B.testIds,B.excludeExtIds,!0,D)}constructor(B,D,z,L,R,K){this.controllerId=B,this.id=D,this.isPersisted=R,this.colllection=K,this.includePrefix=z.map(W=>W+"\0"),this.excludePrefix=L.map(W=>W+"\0")}isIncluded(B){const D=h.TestId.fromExtHostTestItem(B,this.controllerId).toString()+"\0";for(const z of this.excludePrefix)if(D===z||D.startsWith(z))return!1;for(const z of this.includePrefix)if(D===z||D.startsWith(z))return!0;return!1}}e.TestRunDto=s;class a{set coverageProvider(B){if(this._coverageProvider)throw new Error("The TestCoverageProvider cannot be replaced after being provided");!B||(this._coverageProvider=B,this.proxy.$signalCoverageAvailable(this.runId,this.taskId))}get coverageProvider(){return this._coverageProvider}constructor(B,D,z){this.proxy=B,this.runId=D,this.taskId=z}async provideFileCoverage(B){if(!this._coverageProvider)return[];this.fileCoverage||(this.fileCoverage=(async()=>this._coverageProvider.provideFileCoverage(B))());try{return(await this.fileCoverage)?.map(c.TestCoverage.fromFile)??[]}catch(D){throw this.fileCoverage=void 0,D}}async resolveFileCoverage(B,D){const z=await this.fileCoverage;let L=z?.[B];return!this._coverageProvider||!z||!L?[]:(L.detailedCoverage||(L=z[B]=await this._coverageProvider.resolveFileCoverage?.(L,D)??L),L.detailedCoverage?.map(c.TestCoverage.fromDetailed)??[])}}class o extends C.IncrementalChangeCollector{get isEmpty(){return this.added.size===0&&this.removed.size===0&&this.updated.size===0}constructor(B){super(),this.emitter=B,this.added=new Set,this.updated=new Set,this.removed=new Set,this.alreadyRemoved=new Set}add(B){this.added.add(B)}update(B){Object.assign(B.revived,c.TestItem.toPlain(B.item)),this.added.has(B)||this.updated.add(B)}remove(B){if(this.added.has(B)){this.added.delete(B);return}if(this.updated.delete(B),B.parent&&this.alreadyRemoved.has(B.parent)){this.alreadyRemoved.add(B.item.extId);return}this.removed.add(B)}getChangeEvent(){const{added:B,updated:D,removed:z}=this;return{get added(){return[...B].map(L=>L.revived)},get updated(){return[...D].map(L=>L.revived)},get removed(){return[...z].map(L=>L.revived)}}}complete(){this.isEmpty||this.emitter.fire(this.getChangeEvent())}}class v extends C.AbstractIncrementalTestCollection{constructor(){super(...arguments),this.changeEmitter=new M.Emitter,this.onDidChangeTests=this.changeEmitter.event}get rootTests(){return super.roots}getMirroredTestDataById(B){return this.items.get(B)}getMirroredTestDataByReference(B){return this.items.get(B.id)}createItem(B,D){return{...B,revived:c.TestItem.toPlain(B.item),depth:D?D.depth+1:0,children:new Set}}createChangeCollector(){return new o(this.changeEmitter)}}e.MirroredTestCollection=v;class p{constructor(B){this.proxy=B}checkout(){this.current||(this.current=this.createObserverData());const B=this.current;return B.observers++,{onDidChangeTest:B.tests.onDidChangeTests,get tests(){return[...B.tests.rootTests].map(D=>D.revived)},dispose:(0,_.once)(()=>{--B.observers===0&&(this.proxy.$unsubscribeFromDiffs(),this.current=void 0)})}}getMirroredTestDataByReference(B){return this.current?.tests.getMirroredTestDataByReference(B)}applyDiff(B){this.current?.tests.apply(B)}createObserverData(){const B=new v;return this.proxy.$subscribeToDiffs(),{observers:0,tests:B}}}class T{get label(){return this._label}set label(B){B!==this._label&&(this._label=B,Oe(this,l,"f").$updateTestRunConfig(this.controllerId,this.profileId,{label:B}))}get isDefault(){return this._isDefault}set isDefault(B){B!==this._isDefault&&(this._isDefault=B,Oe(this,l,"f").$updateTestRunConfig(this.controllerId,this.profileId,{isDefault:B}))}get tag(){return this._tag}set tag(B){B?.id!==this._tag?.id&&(this._tag=B,Oe(this,l,"f").$updateTestRunConfig(this.controllerId,this.profileId,{tag:B?c.TestTag.namespace(this.controllerId,B.id):null}))}get configureHandler(){return this._configureHandler}set configureHandler(B){B!==this._configureHandler&&(this._configureHandler=B,Oe(this,l,"f").$updateTestRunConfig(this.controllerId,this.profileId,{hasConfigurationHandler:!!B}))}constructor(B,D,z,L,R,K,W,$=!1,G=void 0){this.controllerId=z,this.profileId=L,this._label=R,this.kind=K,this.runHandler=W,this._isDefault=$,this._tag=G,l.set(this,void 0),w.set(this,void 0),Je(this,l,B,"f"),Je(this,w,D,"f"),D.set(L,this);const ne=N[K];if(typeof ne!="number")throw new Error(`Unknown TestRunProfile.group ${K}`);Oe(this,l,"f").$publishTestRunProfile({profileId:L,controllerId:z,tag:G?c.TestTag.namespace(this.controllerId,G.id):null,label:R,group:ne,isDefault:$,hasConfigurationHandler:!1})}dispose(){Oe(this,w,"f")?.delete(this.profileId)&&(Je(this,w,void 0,"f"),Oe(this,l,"f").$removeTestProfile(this.controllerId,this.profileId))}}e.TestRunProfileImpl=T,l=new WeakMap,w=new WeakMap;const N={[d.TestRunProfileKind.Coverage]:8,[d.TestRunProfileKind.Debug]:4,[d.TestRunProfileKind.Run]:2}}),define(Ce[215],Ie([1,0,18,5,4,96,8,6]),function(ie,e,r,y,S,M,_,A){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtHostEditors=void 0;class b{constructor(O,E){this._extHostDocumentsAndEditors=E,this._onDidChangeTextEditorSelection=new y.Emitter,this._onDidChangeTextEditorOptions=new y.Emitter,this._onDidChangeTextEditorVisibleRanges=new y.Emitter,this._onDidChangeTextEditorViewColumn=new y.Emitter,this._onDidChangeActiveTextEditor=new y.Emitter,this._onDidChangeVisibleTextEditors=new y.Emitter,this.onDidChangeTextEditorSelection=this._onDidChangeTextEditorSelection.event,this.onDidChangeTextEditorOptions=this._onDidChangeTextEditorOptions.event,this.onDidChangeTextEditorVisibleRanges=this._onDidChangeTextEditorVisibleRanges.event,this.onDidChangeTextEditorViewColumn=this._onDidChangeTextEditorViewColumn.event,this.onDidChangeActiveTextEditor=this._onDidChangeActiveTextEditor.event,this.onDidChangeVisibleTextEditors=this._onDidChangeVisibleTextEditors.event,this._proxy=O.getProxy(S.MainContext.MainThreadTextEditors),this._extHostDocumentsAndEditors.onDidChangeVisibleTextEditors(m=>this._onDidChangeVisibleTextEditors.fire(m)),this._extHostDocumentsAndEditors.onDidChangeActiveTextEditor(m=>this._onDidChangeActiveTextEditor.fire(m))}getActiveTextEditor(){return this._extHostDocumentsAndEditors.activeEditor()}getVisibleTextEditors(O){const E=this._extHostDocumentsAndEditors.allEditors();return O?E:E.map(m=>m.value)}async showTextDocument(O,E,m){let k;typeof E=="number"?k={position:_.ViewColumn.from(E),preserveFocus:m}:typeof E=="object"?k={position:_.ViewColumn.from(E.viewColumn),preserveFocus:E.preserveFocus,selection:typeof E.selection=="object"?_.Range.from(E.selection):void 0,pinned:typeof E.preview=="boolean"?!E.preview:void 0}:k={preserveFocus:!1};const f=await this._proxy.$tryShowTextDocument(O.uri,k),c=f&&this._extHostDocumentsAndEditors.getEditor(f);if(c)return c.value;throw f?new Error(`Could NOT open editor for "${O.uri.toString()}" because another editor opened in the meantime.`):new Error(`Could NOT open editor for "${O.uri.toString()}".`)}createTextEditorDecorationType(O,E){return new M.TextEditorDecorationType(this._proxy,O,E).value}$acceptEditorPropertiesChanged(O,E){const m=this._extHostDocumentsAndEditors.getEditor(O);if(!m)throw new Error("unknown text editor");if(E.options&&m._acceptOptions(E.options),E.selections){const k=E.selections.selections.map(_.Selection.to);m._acceptSelections(k)}if(E.visibleRanges){const k=r.coalesce(E.visibleRanges.map(_.Range.to));m._acceptVisibleRanges(k)}if(E.options&&this._onDidChangeTextEditorOptions.fire({textEditor:m.value,options:{...E.options,lineNumbers:_.TextEditorLineNumbersStyle.to(E.options.lineNumbers)}}),E.selections){const k=A.TextEditorSelectionChangeKind.fromValue(E.selections.source),f=E.selections.selections.map(_.Selection.to);this._onDidChangeTextEditorSelection.fire({textEditor:m.value,selections:f,kind:k})}if(E.visibleRanges){const k=r.coalesce(E.visibleRanges.map(_.Range.to));this._onDidChangeTextEditorVisibleRanges.fire({textEditor:m.value,visibleRanges:k})}}$acceptEditorPositionData(O){for(const E in O){const m=this._extHostDocumentsAndEditors.getEditor(E);if(!m)throw new Error("Unknown text editor");const k=_.ViewColumn.to(O[E]);m.value.viewColumn!==k&&(m._acceptViewColumn(k),this._onDidChangeTextEditorViewColumn.fire({textEditor:m.value,viewColumn:k}))}}getDiffInformation(O){return Promise.resolve(this._proxy.$getDiffInformation(O))}}e.ExtHostEditors=b}),define(Ce[216],Ie([1,0,2,3,4,7,6,8,10]),function(ie,e,r,y,S,M,_,A,b){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtHostTimeline=e.IExtHostTimeline=void 0,e.IExtHostTimeline=(0,y.createDecorator)("IExtHostTimeline");class P{constructor(m,k){this._providers=new Map,this._itemsBySourceAndUriMap=new Map,this._proxy=m.getProxy(S.MainContext.MainThreadTimeline),k.registerArgumentProcessor({processArgument:f=>{if(f&&f.$mid===11){const c=f.uri===void 0?void 0:r.URI.revive(f.uri);return this._itemsBySourceAndUriMap.get(f.source)?.get(O(c))?.get(f.handle)}return f}})}async $getTimeline(m,k,f,c){return this._providers.get(m)?.provideTimeline(r.URI.revive(k),f,c)}registerTimelineProvider(m,k,f,c){const d=new M.DisposableStore,h=this.convertTimelineItem(k.id,c,d).bind(this);let g;k.onDidChange&&(g=k.onDidChange(l=>this._proxy.$emitTimelineChangeEvent({uri:void 0,reset:!0,...l,id:k.id}),this));const C=this._itemsBySourceAndUriMap;return this.registerTimelineProviderCore({...k,scheme:m,onDidChange:void 0,async provideTimeline(l,w,t){w?.resetCache&&(d.clear(),C.get(k.id)?.clear());const u=await k.provideTimeline(l,w,t);if(u==null)return;const i=h(l,w);return{...u,source:k.id,items:u.items.map(i)}},dispose(){for(const l of C.values())l.get(k.id)?.clear();g?.dispose(),d.dispose()}})}convertTimelineItem(m,k,f){return(c,d)=>{let h;if(d?.cacheResults){let g=this._itemsBySourceAndUriMap.get(m);g===void 0&&(g=new Map,this._itemsBySourceAndUriMap.set(m,g));const C=O(c);h=g.get(C),h===void 0&&(h=new Map,g.set(C,h))}return g=>{const{iconPath:C,...l}=g,w=`${m}|${g.id??g.timestamp}`;h?.set(w,g);let t,u,i;g.iconPath&&(C instanceof _.ThemeIcon?i={id:C.id,color:C.color}:r.URI.isUri(C)?(t=C,u=C):{light:t,dark:u}=C);let n;return _.MarkdownString.isMarkdownString(l.tooltip)?n=A.MarkdownString.from(l.tooltip):(0,b.isString)(l.tooltip)?n=l.tooltip:_.MarkdownString.isMarkdownString(l.detail)?(console.warn("Using deprecated TimelineItem.detail, migrate to TimelineItem.tooltip"),n=A.MarkdownString.from(l.detail)):(0,b.isString)(l.detail)&&(console.warn("Using deprecated TimelineItem.detail, migrate to TimelineItem.tooltip"),n=l.detail),{...l,id:l.id??void 0,handle:w,source:m,command:g.command?k.toInternal(g.command,f):void 0,icon:t,iconDark:u,themeIcon:i,tooltip:n,accessibilityInformation:g.accessibilityInformation}}}}registerTimelineProviderCore(m){if(this._providers.get(m.id))throw new Error(`Timeline Provider ${m.id} already exists.`);return this._proxy.$registerTimelineProvider({id:m.id,label:m.label,scheme:m.scheme}),this._providers.set(m.id,m),(0,M.toDisposable)(()=>{for(const f of this._itemsBySourceAndUriMap.values())f.get(m.id)?.clear();this._providers.delete(m.id),this._proxy.$unregisterTimelineProvider(m.id),m.dispose()})}}e.ExtHostTimeline=P;function O(E){return E?.toString()}}),define(Ce[217],Ie([1,0,7,13,2,4]),function(ie,e,r,y,S,M){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtHostUriOpeners=void 0;class _{constructor(b){this._openers=new Map,this._proxy=b.getProxy(M.MainContext.MainThreadUriOpeners)}registerExternalUriOpener(b,P,O,E){if(this._openers.has(P))throw new Error(`Opener with id '${P}' already registered`);const m=E.schemes.find(k=>!_.supportedSchemes.has(k));if(m)throw new Error(`Scheme '${m}' is not supported. Only http and https are currently supported.`);return this._openers.set(P,O),this._proxy.$registerUriOpener(P,E.schemes,b,E.label),(0,r.toDisposable)(()=>{this._openers.delete(P),this._proxy.$unregisterUriOpener(P)})}async $canOpenUri(b,P,O){const E=this._openers.get(b);if(!E)throw new Error(`Unknown opener with id: ${b}`);const m=S.URI.revive(P);return E.canOpenExternalUri(m,O)}async $openUri(b,P,O){const E=this._openers.get(b);if(!E)throw new Error(`Unknown opener id: '${b}'`);return E.openExternalUri(S.URI.revive(P.resolvedUri),{sourceUri:S.URI.revive(P.sourceUri)},O)}}e.ExtHostUriOpeners=_,_.supportedSchemes=new Set([y.Schemas.http,y.Schemas.https])}),define(Ce[218],Ie([1,0,4,2,7,12,27]),function(ie,e,r,y,S,M,_){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtHostUrls=void 0;class A{constructor(P){this.handles=new Set,this.handlers=new Map,this._proxy=P.getProxy(r.MainContext.MainThreadUrls)}registerUriHandler(P,O){if(this.handles.has(_.ExtensionIdentifier.toKey(P)))throw new Error(`Protocol handler already registered for extension ${P}`);const E=A.HandlePool++;return this.handles.add(_.ExtensionIdentifier.toKey(P)),this.handlers.set(E,O),this._proxy.$registerUriHandler(E,P),(0,S.toDisposable)(()=>{this.handles.delete(_.ExtensionIdentifier.toKey(P)),this.handlers.delete(E),this._proxy.$unregisterUriHandler(E)})}$handleExternalUri(P,O){const E=this.handlers.get(P);if(!E)return Promise.resolve(void 0);try{E.handleUri(y.URI.revive(O))}catch(m){(0,M.onUnexpectedError)(m)}return Promise.resolve(void 0)}async createAppUri(P){return y.URI.revive(await this._proxy.$createAppUri(P))}}e.ExtHostUrls=A,A.HandlePool=0});var Je=this&&this.__classPrivateFieldSet||function(ie,e,r,y,S){if(y==="m")throw new TypeError("Private method is not writable");if(y==="a"&&!S)throw new TypeError("Private accessor was defined without a setter");if(typeof e=="function"?ie!==e||!S:!e.has(ie))throw new TypeError("Cannot write private member to an object whose class did not declare it");return y==="a"?S.call(ie,r):S?S.value=r:e.set(ie,r),r},Oe=this&&this.__classPrivateFieldGet||function(ie,e,r,y){if(r==="a"&&!y)throw new TypeError("Private accessor was defined without a getter");if(typeof e=="function"?ie!==e||!y:!e.has(ie))throw new TypeError("Cannot read private member from an object whose class did not declare it");return r==="m"?y:r==="a"?y.call(ie):y?y.value:e.get(ie)};define(Ce[54],Ie([1,0,5,13,2,145,161,63,4]),function(ie,e,r,y,S,M,_,A,b){"use strict";var P,O,E,m,k,f,c,d,h,g,C,l;Object.defineProperty(e,"__esModule",{value:!0}),e.reviveOptions=e.serializeWebviewOptions=e.toExtensionData=e.ExtHostWebviews=e.shouldSerializeBuffersForPostMessage=e.ExtHostWebview=void 0;class w{constructor(v,p,T,N,V,B,D){P.set(this,void 0),O.set(this,void 0),E.set(this,void 0),m.set(this,void 0),k.set(this,void 0),f.set(this,void 0),c.set(this,""),d.set(this,void 0),h.set(this,!1),g.set(this,!1),C.set(this,!1),this._onMessageEmitter=new r.Emitter,this.onDidReceiveMessage=this._onMessageEmitter.event,l.set(this,new r.Emitter),this._onDidDispose=Oe(this,l,"f").event,Je(this,P,v,"f"),Je(this,O,p,"f"),Je(this,d,T,"f"),Je(this,m,N,"f"),Je(this,k,V,"f"),Je(this,f,B,"f"),Je(this,C,t(B),"f"),Je(this,E,D,"f")}dispose(){Je(this,h,!0,"f"),Oe(this,l,"f").fire(),Oe(this,l,"f").dispose(),this._onMessageEmitter.dispose()}asWebviewUri(v){return Je(this,g,!0,"f"),(0,A.asWebviewUri)(v,Oe(this,m,"f"))}get cspSource(){const v=Oe(this,f,"f").extensionLocation;if(v.scheme===y.Schemas.https||v.scheme===y.Schemas.http){let p=v.toString();return p.endsWith("/")||(p+="/"),p+" "+A.webviewGenericCspSource}return A.webviewGenericCspSource}get html(){return this.assertNotDisposed(),Oe(this,c,"f")}set html(v){this.assertNotDisposed(),Oe(this,c,"f")!==v&&(Je(this,c,v,"f"),!Oe(this,g,"f")&&/(["'])vscode-resource:([^\s'"]+?)(["'])/i.test(v)&&(Je(this,g,!0,"f"),Oe(this,E,"f").report("Webview vscode-resource: uris",Oe(this,f,"f"),"Please migrate to use the 'webview.asWebviewUri' api instead: https://aka.ms/vscode-webview-use-aswebviewuri")),Oe(this,O,"f").$setHtml(Oe(this,P,"f"),v))}get options(){return this.assertNotDisposed(),Oe(this,d,"f")}set options(v){this.assertNotDisposed(),Oe(this,O,"f").$setOptions(Oe(this,P,"f"),n(Oe(this,f,"f"),Oe(this,k,"f"),v)),Je(this,d,v,"f")}async postMessage(v){if(Oe(this,h,"f"))return!1;const p=(0,_.serializeWebviewMessage)(v,{serializeBuffersForPostMessage:Oe(this,C,"f")});return Oe(this,O,"f").$postMessage(Oe(this,P,"f"),p.message,...p.buffers)}assertNotDisposed(){if(Oe(this,h,"f"))throw new Error("Webview is disposed")}}e.ExtHostWebview=w,P=new WeakMap,O=new WeakMap,E=new WeakMap,m=new WeakMap,k=new WeakMap,f=new WeakMap,c=new WeakMap,d=new WeakMap,h=new WeakMap,g=new WeakMap,C=new WeakMap,l=new WeakMap;function t(o){try{const v=(0,M.normalizeVersion)((0,M.parseVersion)(o.engines.vscode));return!!v&&v.majorBase>=1&&v.minorBase>=57}catch{return!1}}e.shouldSerializeBuffersForPostMessage=t;class u{constructor(v,p,T,N,V){this.remoteInfo=p,this.workspace=T,this._logService=N,this._deprecationService=V,this._webviews=new Map,this._webviewProxy=v.getProxy(b.MainContext.MainThreadWebviews)}$onMessage(v,p,T){const N=this.getWebview(v);if(N){const{message:V}=(0,_.deserializeWebviewMessage)(p,T.value);N._onMessageEmitter.fire(V)}}$onMissingCsp(v,p){this._logService.warn(`${p} created a webview without a content security policy: https://aka.ms/vscode-webview-missing-csp`)}createNewWebview(v,p,T){const N=new w(v,this._webviewProxy,s(p),this.remoteInfo,this.workspace,T,this._deprecationService);return this._webviews.set(v,N),N._onDidDispose(()=>{this._webviews.delete(v)}),N}deleteWebview(v){this._webviews.delete(v)}getWebview(v){return this._webviews.get(v)}}e.ExtHostWebviews=u;function i(o){return{id:o.identifier,location:o.extensionLocation}}e.toExtensionData=i;function n(o,v,p){return{enableCommandUris:p.enableCommandUris,enableScripts:p.enableScripts,enableForms:p.enableForms,portMapping:p.portMapping,localResourceRoots:p.localResourceRoots||a(o,v)}}e.serializeWebviewOptions=n;function s(o){return{enableCommandUris:o.enableCommandUris,enableScripts:o.enableScripts,enableForms:o.enableForms,portMapping:o.portMapping,localResourceRoots:o.localResourceRoots?.map(v=>S.URI.from(v))}}e.reviveOptions=s;function a(o,v){return[...(v?.getWorkspaceFolders()||[]).map(p=>p.uri),o.extensionLocation]}}),define(Ce[219],Ie([1,0,20,214,7,13,22,2,8,54,61,4,6]),function(ie,e,r,y,S,M,_,A,b,P,O,E,m){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtHostCustomEditors=void 0;class k{constructor(t,u){this.document=t,this._storagePath=u,this._backupCounter=1,this._edits=new O.Cache("custom documents")}addEdit(t){return this._edits.add([t])}async undo(t,u){await this.getEdit(t).undo(),u||this.disposeBackup()}async redo(t,u){await this.getEdit(t).redo(),u||this.disposeBackup()}disposeEdits(t){for(const u of t)this._edits.delete(u)}getNewBackupUri(){if(!this._storagePath)throw new Error("Backup requires a valid storage path");const t=l(this.document.uri)+this._backupCounter++;return(0,_.joinPath)(this._storagePath,t)}updateBackup(t){this._backup?.delete(),this._backup=t}disposeBackup(){this._backup?.delete(),this._backup=void 0}getEdit(t){const u=this._edits.get(t,0);if(!u)throw new Error("No edit found");return u}}class f{constructor(){this._documents=new Map}get(t,u){return this._documents.get(this.key(t,u))}add(t,u,i){const n=this.key(t,u.uri);if(this._documents.has(n))throw new Error(`Document already exists for viewType:${t} resource:${u.uri}`);const s=new k(u,i);return this._documents.set(n,s),s}delete(t,u){const i=this.key(t,u.uri);this._documents.delete(i)}key(t,u){return`${t}@@@${u}`}}var c;(function(w){w[w.Text=0]="Text",w[w.Custom=1]="Custom"})(c||(c={}));class d{constructor(){this._providers=new Map}addTextProvider(t,u,i){return this.add(0,t,u,i)}addCustomProvider(t,u,i){return this.add(1,t,u,i)}get(t){return this._providers.get(t)}add(t,u,i,n){if(this._providers.has(u))throw new Error(`Provider for viewType:${u} already registered`);return this._providers.set(u,{type:t,extension:i,provider:n}),new m.Disposable(()=>this._providers.delete(u))}}class h{constructor(t,u,i,n,s){this._extHostDocuments=u,this._extensionStoragePaths=i,this._extHostWebview=n,this._extHostWebviewPanels=s,this._editorProviders=new d,this._documents=new f,this._proxy=t.getProxy(E.MainContext.MainThreadCustomEditors)}registerCustomEditorProvider(t,u,i,n){const s=new S.DisposableStore;return g(i)?(s.add(this._editorProviders.addTextProvider(u,t,i)),this._proxy.$registerTextEditorProvider((0,P.toExtensionData)(t),u,n.webviewOptions||{},{supportsMove:!!i.moveCustomTextEditor},(0,P.shouldSerializeBuffersForPostMessage)(t))):(s.add(this._editorProviders.addCustomProvider(u,t,i)),this.supportEditing(i)&&s.add(i.onDidChangeCustomDocument(a=>{const o=this.getCustomDocumentEntry(u,a.document.uri);if(C(a)){const v=o.addEdit(a);this._proxy.$onDidEdit(a.document.uri,u,v,a.label)}else this._proxy.$onContentChange(a.document.uri,u)})),this._proxy.$registerCustomEditorProvider((0,P.toExtensionData)(t),u,n.webviewOptions||{},!!n.supportsMultipleEditorsPerDocument,(0,P.shouldSerializeBuffersForPostMessage)(t))),m.Disposable.from(s,new m.Disposable(()=>{this._proxy.$unregisterEditorProvider(u)}))}async $createCustomDocument(t,u,i,n,s){const a=this._editorProviders.get(u);if(!a)throw new Error(`No provider found for '${u}'`);if(a.type!==1)throw new Error(`Invalid provide type for '${u}'`);const o=A.URI.revive(t),v=await a.provider.openCustomDocument(o,{backupId:i,untitledDocumentData:n?.buffer},s);let p;return this.supportEditing(a.provider)&&this._extensionStoragePaths&&(p=this._extensionStoragePaths.workspaceValue(a.extension)??this._extensionStoragePaths.globalValue(a.extension)),this._documents.add(u,v,p),{editable:this.supportEditing(a.provider)}}async $disposeCustomDocument(t,u){const i=this._editorProviders.get(u);if(!i)throw new Error(`No provider found for '${u}'`);if(i.type!==1)throw new Error(`Invalid provider type for '${u}'`);const n=A.URI.revive(t),{document:s}=this.getCustomDocumentEntry(u,n);this._documents.delete(u,s),s.dispose()}async $resolveWebviewEditor(t,u,i,n,s,a){const o=this._editorProviders.get(i);if(!o)throw new Error(`No provider found for '${i}'`);const v=b.ViewColumn.to(s),p=this._extHostWebview.createNewWebview(u,n.webviewOptions,o.extension),T=this._extHostWebviewPanels.createNewWebviewPanel(u,i,n.title,v,n.panelOptions,p,!0),N=A.URI.revive(t);switch(o.type){case 1:{const{document:V}=this.getCustomDocumentEntry(i,N);return o.provider.resolveCustomEditor(V,T,a)}case 0:{const V=this._extHostDocuments.getDocument(N);return o.provider.resolveCustomTextEditor(V,T,a)}default:throw new Error("Unknown webview provider type")}}$disposeEdits(t,u,i){this.getCustomDocumentEntry(u,t).disposeEdits(i)}async $onMoveCustomEditor(t,u,i){const n=this._editorProviders.get(i);if(!n)throw new Error(`No provider found for '${i}'`);if(!n.provider.moveCustomTextEditor)throw new Error(`Provider does not implement move '${i}'`);const s=this._extHostWebviewPanels.getWebviewPanel(t);if(!s)throw new Error("No webview found");const a=A.URI.revive(u),o=this._extHostDocuments.getDocument(a);await n.provider.moveCustomTextEditor(o,s,r.CancellationToken.None)}async $undo(t,u,i,n){return this.getCustomDocumentEntry(u,t).undo(i,n)}async $redo(t,u,i,n){return this.getCustomDocumentEntry(u,t).redo(i,n)}async $revert(t,u,i){const n=this.getCustomDocumentEntry(u,t);await this.getCustomEditorProvider(u).revertCustomDocument(n.document,i),n.disposeBackup()}async $onSave(t,u,i){const n=this.getCustomDocumentEntry(u,t);await this.getCustomEditorProvider(u).saveCustomDocument(n.document,i),n.disposeBackup()}async $onSaveAs(t,u,i,n){const s=this.getCustomDocumentEntry(u,t);return this.getCustomEditorProvider(u).saveCustomDocumentAs(s.document,A.URI.revive(i),n)}async $backup(t,u,i){const n=this.getCustomDocumentEntry(u,t),a=await this.getCustomEditorProvider(u).backupCustomDocument(n.document,{destination:n.getNewBackupUri()},i);return n.updateBackup(a),a.id}getCustomDocumentEntry(t,u){const i=this._documents.get(t,A.URI.revive(u));if(!i)throw new Error("No custom document found");return i}getCustomEditorProvider(t){const i=this._editorProviders.get(t)?.provider;if(!i||!this.supportEditing(i))throw new Error("Custom document is not editable");return i}supportEditing(t){return!!t.onDidChangeCustomDocument}}e.ExtHostCustomEditors=h;function g(w){return typeof w.resolveCustomTextEditor=="function"}function C(w){return typeof w.undo=="function"&&typeof w.redo=="function"}function l(w){const t=w.scheme===M.Schemas.file||w.scheme===M.Schemas.untitled?w.fsPath:w.toString();return(0,y.hash)(t)+""}});var Je=this&&this.__classPrivateFieldSet||function(ie,e,r,y,S){if(y==="m")throw new TypeError("Private method is not writable");if(y==="a"&&!S)throw new TypeError("Private accessor was defined without a setter");if(typeof e=="function"?ie!==e||!S:!e.has(ie))throw new TypeError("Cannot write private member to an object whose class did not declare it");return y==="a"?S.call(ie,r):S?S.value=r:e.set(ie,r),r},Oe=this&&this.__classPrivateFieldGet||function(ie,e,r,y){if(r==="a"&&!y)throw new TypeError("Private accessor was defined without a getter");if(typeof e=="function"?ie!==e||!y:!e.has(ie))throw new TypeError("Cannot read private member from an object whose class did not declare it");return r==="m"?y:r==="a"?y.call(ie):y?y.value:e.get(ie)};define(Ce[220],Ie([1,0,5,7,2,42,8,54,4,6]),function(ie,e,r,y,S,M,_,A,b,P){"use strict";var O,E,m,k,f,c,d,h,g,C,l,w,t;Object.defineProperty(e,"__esModule",{value:!0}),e.ExtHostWebviewPanels=void 0;class u extends y.Disposable{constructor(a,o,v,p){super(),O.set(this,void 0),E.set(this,void 0),m.set(this,void 0),k.set(this,void 0),f.set(this,void 0),c.set(this,void 0),d.set(this,void 0),h.set(this,void 0),g.set(this,!0),C.set(this,void 0),l.set(this,!1),w.set(this,this._register(new r.Emitter)),this.onDidDispose=Oe(this,w,"f").event,t.set(this,this._register(new r.Emitter)),this.onDidChangeViewState=Oe(this,t,"f").event,Je(this,O,a,"f"),Je(this,E,o,"f"),Je(this,k,v,"f"),Je(this,m,p.viewType,"f"),Je(this,f,p.panelOptions,"f"),Je(this,h,p.viewColumn,"f"),Je(this,c,p.title,"f"),Je(this,C,p.active,"f")}dispose(){Oe(this,l,"f")||(Je(this,l,!0,"f"),Oe(this,w,"f").fire(),Oe(this,E,"f").$disposeWebview(Oe(this,O,"f")),Oe(this,k,"f").dispose(),super.dispose())}get webview(){return this.assertNotDisposed(),Oe(this,k,"f")}get viewType(){return this.assertNotDisposed(),Oe(this,m,"f")}get title(){return this.assertNotDisposed(),Oe(this,c,"f")}set title(a){this.assertNotDisposed(),Oe(this,c,"f")!==a&&(Je(this,c,a,"f"),Oe(this,E,"f").$setTitle(Oe(this,O,"f"),a))}get iconPath(){return this.assertNotDisposed(),Oe(this,d,"f")}set iconPath(a){this.assertNotDisposed(),Oe(this,d,"f")!==a&&(Je(this,d,a,"f"),Oe(this,E,"f").$setIconPath(Oe(this,O,"f"),S.URI.isUri(a)?{light:a,dark:a}:a))}get options(){return Oe(this,f,"f")}get viewColumn(){if(this.assertNotDisposed(),!(typeof Oe(this,h,"f")=="number"&&Oe(this,h,"f")<0))return Oe(this,h,"f")}get active(){return this.assertNotDisposed(),Oe(this,C,"f")}get visible(){return this.assertNotDisposed(),Oe(this,g,"f")}_updateViewState(a){Oe(this,l,"f")||(this.active!==a.active||this.visible!==a.visible||this.viewColumn!==a.viewColumn)&&(Je(this,C,a.active,"f"),Je(this,g,a.visible,"f"),Je(this,h,a.viewColumn,"f"),Oe(this,t,"f").fire({webviewPanel:this}))}reveal(a,o){this.assertNotDisposed(),Oe(this,E,"f").$reveal(Oe(this,O,"f"),{viewColumn:typeof a>"u"?void 0:_.ViewColumn.from(a),preserveFocus:!!o})}assertNotDisposed(){if(Oe(this,l,"f"))throw new Error("Webview is disposed")}}O=new WeakMap,E=new WeakMap,m=new WeakMap,k=new WeakMap,f=new WeakMap,c=new WeakMap,d=new WeakMap,h=new WeakMap,g=new WeakMap,C=new WeakMap,l=new WeakMap,w=new WeakMap,t=new WeakMap;class i{static newHandle(){return(0,M.generateUuid)()}constructor(a,o,v){this.webviews=o,this.workspace=v,this._webviewPanels=new Map,this._serializers=new Map,this._proxy=a.getProxy(b.MainContext.MainThreadWebviewPanels)}createWebviewPanel(a,o,v,p,T={}){const N=typeof p=="object"?p.viewColumn:p,V={viewColumn:_.ViewColumn.from(N),preserveFocus:typeof p=="object"&&!!p.preserveFocus},B=(0,A.shouldSerializeBuffersForPostMessage)(a),D=i.newHandle();this._proxy.$createWebviewPanel((0,A.toExtensionData)(a),D,o,{title:v,panelOptions:n(T),webviewOptions:(0,A.serializeWebviewOptions)(a,this.workspace,T),serializeBuffersForPostMessage:B},V);const z=this.webviews.createNewWebview(D,T,a);return this.createNewWebviewPanel(D,o,v,N,T,z,!0)}$onDidChangeWebviewPanelViewStates(a){const o=Object.keys(a);o.sort((v,p)=>{const T=a[v],N=a[p];return T.active?1:N.active?-1:+T.visible-+N.visible});for(const v of o){const p=this.getWebviewPanel(v);if(!p)continue;const T=a[v];p._updateViewState({active:T.active,visible:T.visible,viewColumn:_.ViewColumn.to(T.position)})}}async $onDidDisposeWebviewPanel(a){this.getWebviewPanel(a)?.dispose(),this._webviewPanels.delete(a),this.webviews.deleteWebview(a)}registerWebviewPanelSerializer(a,o,v){if(this._serializers.has(o))throw new Error(`Serializer for '${o}' already registered`);return this._serializers.set(o,{serializer:v,extension:a}),this._proxy.$registerSerializer(o,{serializeBuffersForPostMessage:(0,A.shouldSerializeBuffersForPostMessage)(a)}),new P.Disposable(()=>{this._serializers.delete(o),this._proxy.$unregisterSerializer(o)})}async $deserializeWebviewPanel(a,o,v,p){const T=this._serializers.get(o);if(!T)throw new Error(`No serializer found for '${o}'`);const{serializer:N,extension:V}=T,B=this.webviews.createNewWebview(a,v.webviewOptions,V),D=this.createNewWebviewPanel(a,o,v.title,p,v.panelOptions,B,v.active);await N.deserializeWebviewPanel(D,v.state)}createNewWebviewPanel(a,o,v,p,T,N,V){const B=new u(a,this._proxy,N,{viewType:o,title:v,viewColumn:p,panelOptions:T,active:V});return this._webviewPanels.set(a,B),B}getWebviewPanel(a){return this._webviewPanels.get(a)}}e.ExtHostWebviewPanels=i;function n(s){return{enableFindWidget:s.enableFindWidget,retainContextWhenHidden:s.retainContextWhenHidden}}});var Je=this&&this.__classPrivateFieldSet||function(ie,e,r,y,S){if(y==="m")throw new TypeError("Private method is not writable");if(y==="a"&&!S)throw new TypeError("Private accessor was defined without a setter");if(typeof e=="function"?ie!==e||!S:!e.has(ie))throw new TypeError("Cannot write private member to an object whose class did not declare it");return y==="a"?S.call(ie,r):S?S.value=r:e.set(ie,r),r},Oe=this&&this.__classPrivateFieldGet||function(ie,e,r,y){if(r==="a"&&!y)throw new TypeError("Private accessor was defined without a getter");if(typeof e=="function"?ie!==e||!y:!e.has(ie))throw new TypeError("Cannot read private member from an object whose class did not declare it");return r==="m"?y:r==="a"?y.call(ie):y?y.value:e.get(ie)};define(Ce[221],Ie([1,0,5,7,54,8,4,6]),function(ie,e,r,y,S,M,_,A){"use strict";var b,P,O,E,m,k,f,c,d,h,g;Object.defineProperty(e,"__esModule",{value:!0}),e.ExtHostWebviewViews=void 0;class C extends y.Disposable{constructor(t,u,i,n,s,a,o){super(),b.set(this,void 0),P.set(this,void 0),O.set(this,void 0),E.set(this,void 0),m.set(this,!1),k.set(this,void 0),f.set(this,void 0),c.set(this,void 0),d.set(this,void 0),h.set(this,this._register(new r.Emitter)),this.onDidChangeVisibility=Oe(this,h,"f").event,g.set(this,this._register(new r.Emitter)),this.onDidDispose=Oe(this,g,"f").event,Je(this,O,i,"f"),Je(this,f,n,"f"),Je(this,b,t,"f"),Je(this,P,u,"f"),Je(this,E,s,"f"),Je(this,k,o,"f")}dispose(){Oe(this,m,"f")||(Je(this,m,!0,"f"),Oe(this,g,"f").fire(),Oe(this,E,"f").dispose(),super.dispose())}get title(){return this.assertNotDisposed(),Oe(this,f,"f")}set title(t){this.assertNotDisposed(),Oe(this,f,"f")!==t&&(Je(this,f,t,"f"),Oe(this,P,"f").$setWebviewViewTitle(Oe(this,b,"f"),t))}get description(){return this.assertNotDisposed(),Oe(this,c,"f")}set description(t){this.assertNotDisposed(),Oe(this,c,"f")!==t&&(Je(this,c,t,"f"),Oe(this,P,"f").$setWebviewViewDescription(Oe(this,b,"f"),t))}get visible(){return Oe(this,k,"f")}get webview(){return Oe(this,E,"f")}get viewType(){return Oe(this,O,"f")}_setVisible(t){t===Oe(this,k,"f")||Oe(this,m,"f")||(Je(this,k,t,"f"),Oe(this,h,"f").fire())}get badge(){return this.assertNotDisposed(),Oe(this,d,"f")}set badge(t){this.assertNotDisposed(),!(t?.value===Oe(this,d,"f")?.value&&t?.tooltip===Oe(this,d,"f")?.tooltip)&&(Je(this,d,M.ViewBadge.from(t),"f"),Oe(this,P,"f").$setWebviewViewBadge(Oe(this,b,"f"),t))}show(t){this.assertNotDisposed(),Oe(this,P,"f").$show(Oe(this,b,"f"),!!t)}assertNotDisposed(){if(Oe(this,m,"f"))throw new Error("Webview is disposed")}}b=new WeakMap,P=new WeakMap,O=new WeakMap,E=new WeakMap,m=new WeakMap,k=new WeakMap,f=new WeakMap,c=new WeakMap,d=new WeakMap,h=new WeakMap,g=new WeakMap;class l{constructor(t,u){this._extHostWebview=u,this._viewProviders=new Map,this._webviewViews=new Map,this._proxy=t.getProxy(_.MainContext.MainThreadWebviewViews)}registerWebviewViewProvider(t,u,i,n){if(this._viewProviders.has(u))throw new Error(`View provider for '${u}' already registered`);return this._viewProviders.set(u,{provider:i,extension:t}),this._proxy.$registerWebviewViewProvider((0,S.toExtensionData)(t),u,{retainContextWhenHidden:n?.retainContextWhenHidden,serializeBuffersForPostMessage:(0,S.shouldSerializeBuffersForPostMessage)(t)}),new A.Disposable(()=>{this._viewProviders.delete(u),this._proxy.$unregisterWebviewViewProvider(u)})}async $resolveWebviewView(t,u,i,n,s){const a=this._viewProviders.get(u);if(!a)throw new Error(`No view provider found for '${u}'`);const{provider:o,extension:v}=a,p=this._extHostWebview.createNewWebview(t,{},v),T=new C(t,this._proxy,u,i,p,v,!0);this._webviewViews.set(t,T),await o.resolveWebviewView(T,{state:n},s)}async $onDidChangeWebviewViewVisibility(t,u){this.getWebviewView(t)._setVisible(u)}async $disposeWebviewView(t){const u=this.getWebviewView(t);this._webviewViews.delete(t),u.dispose(),this._extHostWebview.deleteWebview(t)}getWebviewView(t){const u=this._webviewViews.get(t);if(!u)throw new Error("No webview found");return u}}e.ExtHostWebviewViews=l}),define(Ce[99],Ie([1,0,5,4,2,13,9,3,11]),function(ie,e,r,y,S,M,_,A,b){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.IExtHostWindow=e.ExtHostWindow=void 0;let P=class tn{get state(){return this._state}constructor(E){this._onDidChangeWindowState=new r.Emitter,this.onDidChangeWindowState=this._onDidChangeWindowState.event,this._state=tn.InitialState,this._proxy=E.getProxy(y.MainContext.MainThreadWindow),this._proxy.$getWindowVisibility().then(m=>this.$onDidChangeWindowFocus(m))}$onDidChangeWindowFocus(E){E!==this._state.focused&&(this._state={...this._state,focused:E},this._onDidChangeWindowState.fire(this._state))}openUri(E,m){let k;if(typeof E=="string"){k=E;try{E=S.URI.parse(E)}catch{return Promise.reject(`Invalid uri - '${E}'`)}}return(0,_.isFalsyOrWhitespace)(E.scheme)?Promise.reject("Invalid scheme - cannot be empty"):E.scheme===M.Schemas.command?Promise.reject(`Invalid scheme '${E.scheme}'`):this._proxy.$openUri(E,k,m)}async asExternalUri(E,m){if((0,_.isFalsyOrWhitespace)(E.scheme))return Promise.reject("Invalid scheme - cannot be empty");const k=await this._proxy.$asExternalUri(E,m);return S.URI.from(k)}};P.InitialState={focused:!0},P=ze([$e(0,b.IExtHostRpcService)],P),e.ExtHostWindow=P,e.IExtHostWindow=(0,A.createDecorator)("IExtHostWindow")}),define(Ce[222],Ie([1,0,192,28,11]),function(ie,e,r,y,S){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtHostConsoleForwarder=void 0;let M=class extends r.AbstractExtHostConsoleForwarder{constructor(A,b){super(A,b)}_nativeConsoleLogMessage(A,b,P){b.apply(console,P)}};M=ze([$e(0,S.IExtHostRpcService),$e(1,y.IExtHostInitDataService)],M),e.ExtHostConsoleForwarder=M}),define(Ce[223],Ie([1,0,15,23,20,12,5,7,119,186,40]),function(ie,e,r,y,S,M,_,A,b,P,O){"use strict";var E;Object.defineProperty(e,"__esModule",{value:!0}),e.RPCProtocol=e.ResponsiveState=e.RequestInitiator=e.parseJsonAndRestoreBufferRefs=e.stringifyJsonWithBufferRefs=void 0;function m(T,N){try{return JSON.stringify(T,N)}catch{return"null"}}const k="$$ref$$",f={[k]:-1};class c{constructor(N,V){this.jsonString=N,this.referencedBuffers=V}}function d(T,N=null,V=!1){const B=[];return{jsonString:(V?m:JSON.stringify)(T,(z,L)=>{if(typeof L>"u")return f;if(typeof L=="object"){if(L instanceof y.VSBuffer){const R=B.push(L)-1;return{[k]:R}}if(N)return N(z,L)}return L}),referencedBuffers:B}}e.stringifyJsonWithBufferRefs=d;function h(T,N,V){return JSON.parse(T,(B,D)=>{if(D){const z=D[k];if(typeof z=="number")return N[z];if(V&&D.$mid===1)return V.transformIncoming(D)}return D})}e.parseJsonAndRestoreBufferRefs=h;function g(T,N){return JSON.stringify(T,N)}function C(T){return T?(N,V)=>V&&V.$mid===1?T.transformOutgoing(V):V:null}var l;(function(T){T[T.LocalSide=0]="LocalSide",T[T.OtherSide=1]="OtherSide"})(l=e.RequestInitiator||(e.RequestInitiator={}));var w;(function(T){T[T.Responsive=0]="Responsive",T[T.Unresponsive=1]="Unresponsive"})(w=e.ResponsiveState||(e.ResponsiveState={}));const t=()=>{},u=Symbol.for("rpcProtocol"),i=Symbol.for("rpcProxy");class n extends A.Disposable{constructor(N,V=null,B=null){super(),this[E]=!0,this._onDidChangeResponsiveState=this._register(new _.Emitter),this.onDidChangeResponsiveState=this._onDidChangeResponsiveState.event,this._protocol=N,this._logger=V,this._uriTransformer=B,this._uriReplacer=C(this._uriTransformer),this._isDisposed=!1,this._locals=[],this._proxies=[];for(let D=0,z=O.ProxyIdentifier.count;D<z;D++)this._locals[D]=null,this._proxies[D]=null;this._lastMessageId=0,this._cancelInvokedHandlers=Object.create(null),this._pendingRPCReplies={},this._responsiveState=0,this._unacknowledgedCount=0,this._unresponsiveTime=0,this._asyncCheckUresponsive=this._register(new r.RunOnceScheduler(()=>this._checkUnresponsive(),1e3)),this._protocol.onMessage(D=>this._receiveOneMessage(D))}dispose(){this._isDisposed=!0,Object.keys(this._pendingRPCReplies).forEach(N=>{this._pendingRPCReplies[N].resolveErr(M.canceled())})}drain(){return typeof this._protocol.drain=="function"?this._protocol.drain():Promise.resolve()}_onWillSendRequest(N){this._unacknowledgedCount===0&&(this._unresponsiveTime=Date.now()+n.UNRESPONSIVE_TIME),this._unacknowledgedCount++,this._asyncCheckUresponsive.isScheduled()||this._asyncCheckUresponsive.schedule()}_onDidReceiveAcknowledge(N){this._unresponsiveTime=Date.now()+n.UNRESPONSIVE_TIME,this._unacknowledgedCount--,this._unacknowledgedCount===0&&this._asyncCheckUresponsive.cancel(),this._setResponsiveState(0)}_checkUnresponsive(){this._unacknowledgedCount!==0&&(Date.now()>this._unresponsiveTime?this._setResponsiveState(1):this._asyncCheckUresponsive.schedule())}_setResponsiveState(N){this._responsiveState!==N&&(this._responsiveState=N,this._onDidChangeResponsiveState.fire(this._responsiveState))}get responsiveState(){return this._responsiveState}transformIncomingURIs(N){return this._uriTransformer?(0,b.transformIncomingURIs)(N,this._uriTransformer):N}getProxy(N){const{nid:V,sid:B}=N;return this._proxies[V]||(this._proxies[V]=this._createProxy(V,B)),this._proxies[V]}_createProxy(N,V){const B={get:(D,z)=>(typeof z=="string"&&!D[z]&&z.charCodeAt(0)===36&&(D[z]=(...L)=>this._remoteCall(N,z,L)),z===i?V:D[z])};return new Proxy(Object.create(null),B)}set(N,V){return this._locals[N.nid]=V,V}assertRegistered(N){for(let V=0,B=N.length;V<B;V++){const D=N[V];if(!this._locals[D.nid])throw new Error(`Missing proxy instance ${D.sid}`)}}_receiveOneMessage(N){if(this._isDisposed)return;const V=N.byteLength,B=s.read(N,0),D=B.readUInt8(),z=B.readUInt32();switch(D){case 1:case 2:{let{rpcId:L,method:R,args:K}=o.deserializeRequestJSONArgs(B);this._uriTransformer&&(K=(0,b.transformIncomingURIs)(K,this._uriTransformer)),this._receiveRequest(V,z,L,R,K,D===2);break}case 3:case 4:{let{rpcId:L,method:R,args:K}=o.deserializeRequestMixedArgs(B);this._uriTransformer&&(K=(0,b.transformIncomingURIs)(K,this._uriTransformer)),this._receiveRequest(V,z,L,R,K,D===4);break}case 5:{this._logger?.logIncoming(V,z,0,"ack"),this._onDidReceiveAcknowledge(z);break}case 6:{this._receiveCancel(V,z);break}case 7:{this._receiveReply(V,z,void 0);break}case 9:{let L=o.deserializeReplyOKJSON(B);this._uriTransformer&&(L=(0,b.transformIncomingURIs)(L,this._uriTransformer)),this._receiveReply(V,z,L);break}case 10:{const L=o.deserializeReplyOKJSONWithBuffers(B,this._uriTransformer);this._receiveReply(V,z,L);break}case 8:{const L=o.deserializeReplyOKVSBuffer(B);this._receiveReply(V,z,L);break}case 11:{let L=o.deserializeReplyErrError(B);this._uriTransformer&&(L=(0,b.transformIncomingURIs)(L,this._uriTransformer)),this._receiveReplyErr(V,z,L);break}case 12:{this._receiveReplyErr(V,z,void 0);break}default:console.error("received unexpected message"),console.error(N)}}_receiveRequest(N,V,B,D,z,L){this._logger?.logIncoming(N,V,1,`receiveRequest ${(0,O.getStringIdentifierForProxy)(B)}.${D}(`,z);const R=String(V);let K,W;if(L){const G=new S.CancellationTokenSource;z.push(G.token),K=this._invokeHandler(B,D,z),W=()=>G.cancel()}else K=this._invokeHandler(B,D,z),W=t;this._cancelInvokedHandlers[R]=W;const $=o.serializeAcknowledged(V);this._logger?.logOutgoing($.byteLength,V,1,"ack"),this._protocol.send($),K.then(G=>{delete this._cancelInvokedHandlers[R];const ne=o.serializeReplyOK(V,G,this._uriReplacer);this._logger?.logOutgoing(ne.byteLength,V,1,"reply:",G),this._protocol.send(ne)},G=>{delete this._cancelInvokedHandlers[R];const ne=o.serializeReplyErr(V,G);this._logger?.logOutgoing(ne.byteLength,V,1,"replyErr:",G),this._protocol.send(ne)})}_receiveCancel(N,V){this._logger?.logIncoming(N,V,1,"receiveCancel");const B=String(V);this._cancelInvokedHandlers[B]?.()}_receiveReply(N,V,B){this._logger?.logIncoming(N,V,0,"receiveReply:",B);const D=String(V);if(!this._pendingRPCReplies.hasOwnProperty(D))return;const z=this._pendingRPCReplies[D];delete this._pendingRPCReplies[D],z.resolveOk(B)}_receiveReplyErr(N,V,B){this._logger?.logIncoming(N,V,0,"receiveReplyErr:",B);const D=String(V);if(!this._pendingRPCReplies.hasOwnProperty(D))return;const z=this._pendingRPCReplies[D];delete this._pendingRPCReplies[D];let L;B&&(B.$isError?(L=new Error,L.name=B.name,L.message=B.message,L.stack=B.stack):L=B),z.resolveErr(L)}_invokeHandler(N,V,B){try{return Promise.resolve(this._doInvokeHandler(N,V,B))}catch(D){return Promise.reject(D)}}_doInvokeHandler(N,V,B){const D=this._locals[N];if(!D)throw new Error("Unknown actor "+(0,O.getStringIdentifierForProxy)(N));const z=D[V];if(typeof z!="function")throw new Error("Unknown method "+V+" on actor "+(0,O.getStringIdentifierForProxy)(N));return z.apply(D,B)}_remoteCall(N,V,B){if(this._isDisposed)return new P.CanceledLazyPromise;let D=null;if(B.length>0&&S.CancellationToken.isCancellationToken(B[B.length-1])&&(D=B.pop()),D&&D.isCancellationRequested)return Promise.reject(M.canceled());const z=o.serializeRequestArguments(B,this._uriReplacer),L=++this._lastMessageId,R=String(L),K=new P.LazyPromise;D&&D.onCancellationRequested(()=>{const $=o.serializeCancel(L);this._logger?.logOutgoing($.byteLength,L,0,"cancel"),this._protocol.send(o.serializeCancel(L))}),this._pendingRPCReplies[R]=K,this._onWillSendRequest(L);const W=o.serializeRequest(L,N,V,z,!!D);return this._logger?.logOutgoing(W.byteLength,L,0,`request: ${(0,O.getStringIdentifierForProxy)(N)}.${V}(`,B),this._protocol.send(W),K}}e.RPCProtocol=n,E=u,n.UNRESPONSIVE_TIME=3*1e3;class s{static alloc(N,V,B){const D=new s(y.VSBuffer.alloc(B+1+4),0);return D.writeUInt8(N),D.writeUInt32(V),D}static read(N,V){return new s(N,V)}get buffer(){return this._buff}constructor(N,V){this._buff=N,this._offset=V}static sizeUInt8(){return 1}writeUInt8(N){this._buff.writeUInt8(N,this._offset),this._offset+=1}readUInt8(){const N=this._buff.readUInt8(this._offset);return this._offset+=1,N}writeUInt32(N){this._buff.writeUInt32BE(N,this._offset),this._offset+=4}readUInt32(){const N=this._buff.readUInt32BE(this._offset);return this._offset+=4,N}static sizeShortString(N){return 1+N.byteLength}writeShortString(N){this._buff.writeUInt8(N.byteLength,this._offset),this._offset+=1,this._buff.set(N,this._offset),this._offset+=N.byteLength}readShortString(){const N=this._buff.readUInt8(this._offset);this._offset+=1;const B=this._buff.slice(this._offset,this._offset+N).toString();return this._offset+=N,B}static sizeLongString(N){return 4+N.byteLength}writeLongString(N){this._buff.writeUInt32BE(N.byteLength,this._offset),this._offset+=4,this._buff.set(N,this._offset),this._offset+=N.byteLength}readLongString(){const N=this._buff.readUInt32BE(this._offset);this._offset+=4;const B=this._buff.slice(this._offset,this._offset+N).toString();return this._offset+=N,B}writeBuffer(N){this._buff.writeUInt32BE(N.byteLength,this._offset),this._offset+=4,this._buff.set(N,this._offset),this._offset+=N.byteLength}static sizeVSBuffer(N){return 4+N.byteLength}writeVSBuffer(N){this._buff.writeUInt32BE(N.byteLength,this._offset),this._offset+=4,this._buff.set(N,this._offset),this._offset+=N.byteLength}readVSBuffer(){const N=this._buff.readUInt32BE(this._offset);this._offset+=4;const V=this._buff.slice(this._offset,this._offset+N);return this._offset+=N,V}static sizeMixedArray(N){let V=0;V+=1;for(let B=0,D=N.length;B<D;B++){const z=N[B];switch(V+=1,z.type){case 1:V+=this.sizeLongString(z.value);break;case 2:V+=this.sizeVSBuffer(z.value);break;case 3:V+=this.sizeUInt32,V+=this.sizeLongString(z.value);for(let L=0;L<z.buffers.length;++L)V+=this.sizeVSBuffer(z.buffers[L]);break;case 4:break}}return V}writeMixedArray(N){this._buff.writeUInt8(N.length,this._offset),this._offset+=1;for(let V=0,B=N.length;V<B;V++){const D=N[V];switch(D.type){case 1:this.writeUInt8(1),this.writeLongString(D.value);break;case 2:this.writeUInt8(2),this.writeVSBuffer(D.value);break;case 3:this.writeUInt8(3),this.writeUInt32(D.buffers.length),this.writeLongString(D.value);for(let z=0;z<D.buffers.length;++z)this.writeBuffer(D.buffers[z]);break;case 4:this.writeUInt8(4);break}}}readMixedArray(){const N=this._buff.readUInt8(this._offset);this._offset+=1;const V=new Array(N);for(let B=0;B<N;B++)switch(this.readUInt8()){case 1:V[B]=this.readLongString();break;case 2:V[B]=this.readVSBuffer();break;case 3:{const z=this.readUInt32(),L=this.readLongString(),R=[];for(let K=0;K<z;++K)R.push(this.readVSBuffer());V[B]=new O.SerializableObjectWithBuffers(h(L,R,null));break}case 4:V[B]=void 0;break}return V}}s.sizeUInt32=4;var a;(function(T){T[T.Simple=0]="Simple",T[T.Mixed=1]="Mixed"})(a||(a={}));class o{static _useMixedArgSerialization(N){for(let V=0,B=N.length;V<B;V++)if(N[V]instanceof y.VSBuffer||N[V]instanceof O.SerializableObjectWithBuffers||typeof N[V]>"u")return!0;return!1}static serializeRequestArguments(N,V){if(this._useMixedArgSerialization(N)){const B=[];for(let D=0,z=N.length;D<z;D++){const L=N[D];if(L instanceof y.VSBuffer)B[D]={type:2,value:L};else if(typeof L>"u")B[D]={type:4};else if(L instanceof O.SerializableObjectWithBuffers){const{jsonString:R,referencedBuffers:K}=d(L.value,V);B[D]={type:3,value:y.VSBuffer.fromString(R),buffers:K}}else B[D]={type:1,value:y.VSBuffer.fromString(g(L,V))}}return{type:1,args:B}}return{type:0,args:g(N,V)}}static serializeRequest(N,V,B,D,z){switch(D.type){case 0:return this._requestJSONArgs(N,V,B,D.args,z);case 1:return this._requestMixedArgs(N,V,B,D.args,z)}}static _requestJSONArgs(N,V,B,D,z){const L=y.VSBuffer.fromString(B),R=y.VSBuffer.fromString(D);let K=0;K+=s.sizeUInt8(),K+=s.sizeShortString(L),K+=s.sizeLongString(R);const W=s.alloc(z?2:1,N,K);return W.writeUInt8(V),W.writeShortString(L),W.writeLongString(R),W.buffer}static deserializeRequestJSONArgs(N){const V=N.readUInt8(),B=N.readShortString(),D=N.readLongString();return{rpcId:V,method:B,args:JSON.parse(D)}}static _requestMixedArgs(N,V,B,D,z){const L=y.VSBuffer.fromString(B);let R=0;R+=s.sizeUInt8(),R+=s.sizeShortString(L),R+=s.sizeMixedArray(D);const K=s.alloc(z?4:3,N,R);return K.writeUInt8(V),K.writeShortString(L),K.writeMixedArray(D),K.buffer}static deserializeRequestMixedArgs(N){const V=N.readUInt8(),B=N.readShortString(),D=N.readMixedArray(),z=new Array(D.length);for(let L=0,R=D.length;L<R;L++){const K=D[L];typeof K=="string"?z[L]=JSON.parse(K):z[L]=K}return{rpcId:V,method:B,args:z}}static serializeAcknowledged(N){return s.alloc(5,N,0).buffer}static serializeCancel(N){return s.alloc(6,N,0).buffer}static serializeReplyOK(N,V,B){if(typeof V>"u")return this._serializeReplyOKEmpty(N);if(V instanceof y.VSBuffer)return this._serializeReplyOKVSBuffer(N,V);if(V instanceof O.SerializableObjectWithBuffers){const{jsonString:D,referencedBuffers:z}=d(V.value,B,!0);return this._serializeReplyOKJSONWithBuffers(N,D,z)}else return this._serializeReplyOKJSON(N,m(V,B))}static _serializeReplyOKEmpty(N){return s.alloc(7,N,0).buffer}static _serializeReplyOKVSBuffer(N,V){let B=0;B+=s.sizeVSBuffer(V);const D=s.alloc(8,N,B);return D.writeVSBuffer(V),D.buffer}static deserializeReplyOKVSBuffer(N){return N.readVSBuffer()}static _serializeReplyOKJSON(N,V){const B=y.VSBuffer.fromString(V);let D=0;D+=s.sizeLongString(B);const z=s.alloc(9,N,D);return z.writeLongString(B),z.buffer}static _serializeReplyOKJSONWithBuffers(N,V,B){const D=y.VSBuffer.fromString(V);let z=0;z+=s.sizeUInt32,z+=s.sizeLongString(D);for(const R of B)z+=s.sizeVSBuffer(R);const L=s.alloc(10,N,z);L.writeUInt32(B.length),L.writeLongString(D);for(const R of B)L.writeBuffer(R);return L.buffer}static deserializeReplyOKJSON(N){const V=N.readLongString();return JSON.parse(V)}static deserializeReplyOKJSONWithBuffers(N,V){const B=N.readUInt32(),D=N.readLongString(),z=[];for(let L=0;L<B;++L)z.push(N.readVSBuffer());return new O.SerializableObjectWithBuffers(h(D,z,V))}static serializeReplyErr(N,V){const B=V?m(M.transformErrorForSerialization(V),null):void 0;if(typeof B!="string")return this._serializeReplyErrEmpty(N);const D=y.VSBuffer.fromString(B);let z=0;z+=s.sizeLongString(D);const L=s.alloc(11,N,z);return L.writeLongString(D),L.buffer}static deserializeReplyErrError(N){const V=N.readLongString();return JSON.parse(V)}static _serializeReplyErrEmpty(N){return s.alloc(12,N,0).buffer}}var v;(function(T){T[T.RequestJSONArgs=1]="RequestJSONArgs",T[T.RequestJSONArgsWithCancellation=2]="RequestJSONArgsWithCancellation",T[T.RequestMixedArgs=3]="RequestMixedArgs",T[T.RequestMixedArgsWithCancellation=4]="RequestMixedArgsWithCancellation",T[T.Acknowledged=5]="Acknowledged",T[T.Cancel=6]="Cancel",T[T.ReplyOKEmpty=7]="ReplyOKEmpty",T[T.ReplyOKVSBuffer=8]="ReplyOKVSBuffer",T[T.ReplyOKJSON=9]="ReplyOKJSON",T[T.ReplyOKJSONWithBuffers=10]="ReplyOKJSONWithBuffers",T[T.ReplyErrError=11]="ReplyErrError",T[T.ReplyErrEmpty=12]="ReplyErrEmpty"})(v||(v={}));var p;(function(T){T[T.String=1]="String",T[T.VSBuffer=2]="VSBuffer",T[T.SerializedObjectWithBuffers=3]="SerializedObjectWithBuffers",T[T.Undefined=4]="Undefined"})(p||(p={}))}),define(Ce[224],Ie([1,0]),function(ie,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.NestedWorker=void 0;const r=function(M){const _=A=>{self.removeEventListener("message",_);const b=A.data;Object.defineProperties(self,{postMessage:{value(P,O){b.postMessage(P,O)}},onmessage:{get(){return b.onmessage},set(P){b.onmessage=P}}}),b.addEventListener("message",P=>{self.dispatchEvent(new MessageEvent("message",{data:P.data}))}),b.start(),self.Worker=class{constructor(){throw new TypeError("Nested workers from within nested worker are NOT supported.")}},importScripts(M)};self.addEventListener("message",_)}.toString();class y extends EventTarget{constructor(M,_,A){super(),this.onmessage=null,this.onmessageerror=null,this.onerror=null;const b=`((${r})('${_}'))`,P=new Blob([b],{type:"application/javascript"}),O=URL.createObjectURL(P),E=new MessageChannel,m=O,k={type:"_newWorker",id:m,port:E.port2,url:O,options:A};M(k,[E.port2]),this.postMessage=E.port1.postMessage.bind(E.port1),this.terminate=()=>{M({type:"_terminateWorker",id:m}),URL.revokeObjectURL(O),E.port1.close(),E.port2.close()},Object.defineProperties(this,{onmessage:{get(){return E.port1.onmessage},set(f){E.port1.onmessage=f}},onmessageerror:{get(){return E.port1.onmessageerror},set(f){E.port1.onmessageerror=f}}}),E.port1.addEventListener("messageerror",f=>{const c=new MessageEvent("messageerror",{data:f.data});this.dispatchEvent(c)}),E.port1.addEventListener("message",f=>{const c=new MessageEvent("message",{data:f.data});this.dispatchEvent(c)}),E.port1.start()}}e.NestedWorker=y}),define(Ce[225],Ie([1,0,5,30,39,3,35,12,15]),function(ie,e,r,y,S,M,_,A,b){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.registerLogChannel=e.Extensions=e.OutputChannelUpdateMode=e.IOutputService=e.CONTEXT_OUTPUT_SCROLL_LOCK=e.CONTEXT_ACTIVE_LOG_OUTPUT=e.CONTEXT_IN_OUTPUT=e.MAX_OUTPUT_LENGTH=e.OUTPUT_SERVICE_ID=e.OUTPUT_VIEW_ID=e.LOG_MODE_ID=e.LOG_SCHEME=e.LOG_MIME=e.OUTPUT_MODE_ID=e.OUTPUT_SCHEME=e.OUTPUT_MIME=void 0,e.OUTPUT_MIME="text/x-code-output",e.OUTPUT_SCHEME="output",e.OUTPUT_MODE_ID="Log",e.LOG_MIME="text/x-code-log-output",e.LOG_SCHEME="log",e.LOG_MODE_ID="log",e.OUTPUT_VIEW_ID="workbench.panel.output",e.OUTPUT_SERVICE_ID="outputService",e.MAX_OUTPUT_LENGTH=1e4*100,e.CONTEXT_IN_OUTPUT=new S.RawContextKey("inOutput",!1),e.CONTEXT_ACTIVE_LOG_OUTPUT=new S.RawContextKey("activeLogOutput",!1),e.CONTEXT_OUTPUT_SCROLL_LOCK=new S.RawContextKey("outputView.scrollLock",!1),e.IOutputService=(0,M.createDecorator)(e.OUTPUT_SERVICE_ID);var P;(function(k){k[k.Append=1]="Append",k[k.Replace=2]="Replace",k[k.Clear=3]="Clear"})(P=e.OutputChannelUpdateMode||(e.OutputChannelUpdateMode={})),e.Extensions={OutputChannels:"workbench.contributions.outputChannels"};class O{constructor(){this.channels=new Map,this._onDidRegisterChannel=new r.Emitter,this.onDidRegisterChannel=this._onDidRegisterChannel.event,this._onDidRemoveChannel=new r.Emitter,this.onDidRemoveChannel=this._onDidRemoveChannel.event}registerChannel(f){this.channels.has(f.id)||(this.channels.set(f.id,f),this._onDidRegisterChannel.fire(f.id))}getChannels(){const f=[];return this.channels.forEach(c=>f.push(c)),f}getChannel(f){return this.channels.get(f)}removeChannel(f){this.channels.delete(f),this._onDidRemoveChannel.fire(f)}}y.Registry.add(e.Extensions.OutputChannels,new O);function E(k,f,c,d,h){return(0,b.createCancelablePromise)(async g=>{await(0,_.whenProviderRegistered)(c,d);const C=y.Registry.as(e.Extensions.OutputChannels);try{await m(c,1,d,h,g),C.registerChannel({id:k,label:f,file:c,log:!0})}catch(l){(0,A.isCancellationError)(l)||h.error("Error while registering log channel",c.toString(),(0,A.getErrorMessage)(l))}})}e.registerLogChannel=E;async function m(k,f,c,d,h){if(!await c.exists(k)){if(h.isCancellationRequested)throw new A.CancellationError;if(f>10)throw new Error("Timed out while waiting for file to be created");d.debug("[Registering Log Channel] File does not exist. Waiting for 1s to retry.",k.toString()),await(0,b.timeout)(1e3,h),await m(k,f+1,c,d,h)}}}),define(Ce[100],Ie([1,0,4,3,11,14,225,52,28,36,113,23,10,35]),function(ie,e,r,y,S,M,_,A,b,P,O,E,m,k){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.IExtHostOutputService=e.ExtHostOutputService=void 0;class f extends M.AbstractMessageLogger{get disposed(){return this._disposed}constructor(g,C,l,w,t){super(),this.id=g,this.name=C,this.logger=l,this.proxy=w,this.extension=t,this.offset=0,this._disposed=!1,this.visible=!1}appendLine(g){this.append(g+`
`)}append(g){this.info(g),this.visible&&(this.logger.flush(),this.proxy.$update(this.id,_.OutputChannelUpdateMode.Append))}clear(){const g=this.offset;this.logger.flush(),this.proxy.$update(this.id,_.OutputChannelUpdateMode.Clear,g)}replace(g){const C=this.offset;this.info(g),this.proxy.$update(this.id,_.OutputChannelUpdateMode.Replace,C),this.visible&&this.logger.flush()}show(g,C){this.logger.flush(),this.proxy.$reveal(this.id,!!(typeof g=="boolean"?g:C))}hide(){this.proxy.$close(this.id)}log(g,C){this.offset+=E.VSBuffer.fromString(C).byteLength,(0,M.log)(this.logger,g,C)}dispose(){super.dispose(),this._disposed||(this.proxy.$dispose(this.id),this._disposed=!0)}}class c extends f{appendLine(g){this.append(g)}}let d=class{constructor(g,C,l,w,t){this.initData=C,this.extHostFileSystem=l,this.extHostFileSystemInfo=w,this.loggerService=t,this.extensionLogDirectoryPromise=new Map,this.namePool=1,this.channels=new Map,this.visibleChannelId=null,this.proxy=g.getProxy(r.MainContext.MainThreadOutputService),this.outputsLocation=this.extHostFileSystemInfo.extUri.joinPath(C.logsLocation,`output_logging_${(0,O.toLocalISOString)(new Date).replace(/-|:|\.\d+Z$/g,"")}`)}$setVisibleChannel(g){this.visibleChannelId=g;for(const[C,l]of this.channels)l.visible=C===this.visibleChannelId}createOutputChannel(g,C,l){if(g=g.trim(),!g)throw new Error("illegal argument `name`. must not be falsy");const w=typeof C=="object"&&C.log,t=(0,m.isString)(C)?C:void 0;if((0,m.isString)(t)&&!t.trim())throw new Error("illegal argument `languageId`. must not be empty");const u=w?this.doCreateLogOutputChannel(g,l):this.doCreateOutputChannel(g,t,l);return u.then(i=>{this.channels.set(i.id,i),i.visible=i.id===this.visibleChannelId}),w?this.createExtHostLogOutputChannel(g,u):this.createExtHostOutputChannel(g,u)}async doCreateOutputChannel(g,C,l){this.outputDirectoryPromise||(this.outputDirectoryPromise=this.extHostFileSystem.value.createDirectory(this.outputsLocation).then(()=>this.outputsLocation));const w=await this.outputDirectoryPromise,t=this.extHostFileSystemInfo.extUri.joinPath(w,`${this.namePool++}-${g.replace(/[\\/:\*\?"<>\|]/g,"")}.log`),u=this.loggerService.createLogger(t,{always:!0,donotRotate:!0,donotUseFormatters:!0}),i=await this.proxy.$register(g,t,!1,C,l.identifier.value);return new f(i,g,u,this.proxy,l)}async doCreateLogOutputChannel(g,C){const l=await this.createExtensionLogDirectory(C),w=this.extHostFileSystemInfo.extUri.joinPath(l,`${g.replace(/[\\/:\*\?"<>\|]/g,"")}.log`),t=this.loggerService.createLogger(w,{name:g}),u=await this.proxy.$register(g,w,!0,void 0,C.identifier.value);return new c(u,g,t,this.proxy,C)}createExtensionLogDirectory(g){let C=this.extensionLogDirectoryPromise.get(g.identifier.value);if(!C){const l=this.extHostFileSystemInfo.extUri.joinPath(this.initData.logsLocation,g.identifier.value);this.extensionLogDirectoryPromise.set(g.identifier.value,C=(async()=>{try{await this.extHostFileSystem.value.createDirectory(l)}catch(w){if((0,k.toFileSystemProviderErrorCode)(w)!==k.FileSystemProviderErrorCode.FileExists)throw w}return l})())}return C}createExtHostOutputChannel(g,C){let l=!1;const w=()=>{if(l)throw new Error("Channel has been closed")};return{get name(){return g},append(t){w(),C.then(u=>u.append(t))},appendLine(t){w(),C.then(u=>u.appendLine(t))},clear(){w(),C.then(t=>t.clear())},replace(t){w(),C.then(u=>u.replace(t))},show(t,u){w(),C.then(i=>i.show(t,u))},hide(){w(),C.then(t=>t.hide())},dispose(){l=!0,C.then(t=>t.dispose())}}}createExtHostLogOutputChannel(g,C){let l=!1;const w=()=>{if(l)throw new Error("Channel has been closed")};return{...this.createExtHostOutputChannel(g,C),trace(t,...u){w(),C.then(i=>i.info(t,...u))},debug(t,...u){w(),C.then(i=>i.debug(t,...u))},info(t,...u){w(),C.then(i=>i.info(t,...u))},warn(t,...u){w(),C.then(i=>i.warn(t,...u))},error(t,...u){w(),C.then(i=>i.error(t,...u))},dispose(){l=!0,C.then(t=>t.dispose())}}}};d=ze([$e(0,S.IExtHostRpcService),$e(1,b.IExtHostInitDataService),$e(2,A.IExtHostConsumerFileSystem),$e(3,P.IExtHostFileSystemInfo),$e(4,M.ILoggerService)],d),e.ExtHostOutputService=d,e.IExtHostOutputService=(0,y.createDecorator)("IExtHostOutputService")}),define(Ce[226],Ie([1,0,3]),function(ie,e,r){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.IRemoteAgentService=e.RemoteExtensionLogFileName=void 0,e.RemoteExtensionLogFileName="remoteagent",e.IRemoteAgentService=(0,r.createDecorator)("remoteAgentService")}),define(Ce[227],Ie([1,0,38,13,19,21,22,2,3,157,45,172,226]),function(ie,e,r,y,S,M,_,A,b,P,O,E,m){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.AbstractPathService=e.IPathService=void 0,e.IPathService=(0,b.createDecorator)("pathService");let k=class nn{constructor(c,d,h,g){this.localUserHome=c,this.remoteAgentService=d,this.environmentService=h,this.contextService=g,this.resolveOS=(async()=>(await this.remoteAgentService.getEnvironment())?.os||M.OS)(),this.resolveUserHome=(async()=>{const C=await this.remoteAgentService.getEnvironment();return this.maybeUnresolvedUserHome=C?.userHome??c})()}hasValidBasename(c,d,h){return typeof d=="string"||typeof d>"u"?this.resolveOS.then(g=>this.doHasValidBasename(c,g,d)):this.doHasValidBasename(c,d,h)}doHasValidBasename(c,d,h){return c.scheme===y.Schemas.file||c.scheme===y.Schemas.vscodeRemote?(0,r.isValidBasename)(h??(0,_.basename)(c),d===1):!0}get defaultUriScheme(){return nn.findDefaultUriScheme(this.environmentService,this.contextService)}static findDefaultUriScheme(c,d){if(c.remoteAuthority)return y.Schemas.vscodeRemote;const h=(0,P.getVirtualWorkspaceScheme)(d.getWorkspace());if(h)return h;const g=d.getWorkspace().folders[0];if(g)return g.uri.scheme;const C=d.getWorkspace().configuration;return C?C.scheme:y.Schemas.file}userHome(c){return c?.preferLocal?this.localUserHome:this.resolveUserHome}get resolvedUserHome(){return this.maybeUnresolvedUserHome}get path(){return this.resolveOS.then(c=>c===1?S.win32:S.posix)}async fileURI(c){let d="";if(await this.resolveOS===1&&(c=c.replace(/\\/g,"/")),c[0]==="/"&&c[1]==="/"){const g=c.indexOf("/",2);g===-1?(d=c.substring(2),c="/"):(d=c.substring(2,g),c=c.substring(g)||"/")}return A.URI.from({scheme:y.Schemas.file,authority:d,path:c,query:"",fragment:""})}};k=ze([$e(1,m.IRemoteAgentService),$e(2,E.IWorkbenchEnvironmentService),$e(3,O.IWorkspaceContextService)],k),e.AbstractPathService=k}),define(Ce[101],Ie([1,0]),function(ie,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.TextSearchCompleteMessageType=e.Range=e.Position=void 0;class r{constructor(_,A){this.line=_,this.character=A}isBefore(_){return!1}isBeforeOrEqual(_){return!1}isAfter(_){return!1}isAfterOrEqual(_){return!1}isEqual(_){return!1}compareTo(_){return 0}translate(_,A){return new r(0,0)}with(_){return new r(0,0)}}e.Position=r;class y{constructor(_,A,b,P){this.isEmpty=!1,this.isSingleLine=!1,this.start=new r(_,A),this.end=new r(b,P)}contains(_){return!1}isEqual(_){return!1}intersection(_){}union(_){return new y(0,0,0,0)}with(_){return new y(0,0,0,0)}}e.Range=y;var S;(function(M){M[M.Information=1]="Information",M[M.Warning=2]="Warning"})(S=e.TextSearchCompleteMessageType||(e.TextSearchCompleteMessageType={}))}),define(Ce[41],Ie([1,0,18,34,26,38,9,3,19,12,101,15]),function(ie,e,r,y,S,M,_,A,b,P,O,E){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.hasSiblingFn=e.hasSiblingPromiseFn=e.QueryGlobTester=e.resolvePatternsForProvider=e.SerializableFileMatch=e.isFilePatternMatch=e.isSerializedFileMatch=e.isSerializedSearchSuccess=e.isSerializedSearchComplete=e.serializeSearchError=e.deserializeSearchError=e.SearchError=e.SearchErrorCode=e.pathIncludedInQuery=e.getExcludes=e.SearchSortOrder=e.ViewMode=e.OneLineRange=e.SearchRange=e.TextSearchMatch=e.FileMatch=e.SearchCompletionExitCode=e.isProgressMessage=e.isFileMatch=e.resultIsMatch=e.QueryType=e.SearchProviderType=e.ISearchService=e.SEARCH_EXCLUDE_CONFIG=e.VIEW_ID=e.PANEL_ID=e.VIEWLET_ID=e.TextSearchCompleteMessageType=void 0,Object.defineProperty(e,"TextSearchCompleteMessageType",{enumerable:!0,get:function(){return O.TextSearchCompleteMessageType}}),e.VIEWLET_ID="workbench.view.search",e.PANEL_ID="workbench.panel.search",e.VIEW_ID="workbench.view.search",e.SEARCH_EXCLUDE_CONFIG="search.exclude";const m="\u27EA ",k=" characters skipped \u27EB",f=(m.length+k.length+5)*2;e.ISearchService=(0,A.createDecorator)("searchService");var c;(function(oe){oe[oe.file=0]="file",oe[oe.text=1]="text"})(c=e.SearchProviderType||(e.SearchProviderType={}));var d;(function(oe){oe[oe.File=1]="File",oe[oe.Text=2]="Text"})(d=e.QueryType||(e.QueryType={}));function h(oe){return!!oe.preview}e.resultIsMatch=h;function g(oe){return!!oe.resource}e.isFileMatch=g;function C(oe){return!!oe.message}e.isProgressMessage=C;var l;(function(oe){oe[oe.Normal=0]="Normal",oe[oe.NewSearchStarted=1]="NewSearchStarted"})(l=e.SearchCompletionExitCode||(e.SearchCompletionExitCode={}));class w{constructor(Ee){this.resource=Ee,this.results=[]}}e.FileMatch=w;class t{constructor(Ee,ce,me){this.ranges=ce;const ee=Array.isArray(ce)?ce:[ce];if(me&&me.matchLines===1&&u(ee)){Ee=(0,_.getNLines)(Ee,me.matchLines);let be="",_e=0,Fe=0;const Be=Math.floor(me.charsPerLine/5),Xe=[];for(const ke of ee){const ye=Math.max(ke.startColumn-Be,0),De=ke.startColumn+me.charsPerLine;if(ye>Fe+Be+f){const ae=m+(ye-Fe)+k;be+=ae+Ee.slice(ye,De),_e+=ye-(Fe+ae.length)}else be+=Ee.slice(Fe,De);Xe.push(new n(0,ke.startColumn-_e,ke.endColumn-_e)),Fe=De}this.preview={text:be,matches:Array.isArray(this.ranges)?Xe:Xe[0]}}else{const be=Array.isArray(ce)?ce[0].startLineNumber:ce.startLineNumber;this.preview={text:Ee,matches:(0,r.mapArrayOrNot)(ce,_e=>new i(_e.startLineNumber-be,_e.startColumn,_e.endLineNumber-be,_e.endColumn))}}}}e.TextSearchMatch=t;function u(oe){const Ee=oe[0].startLineNumber;for(const ce of oe)if(ce.startLineNumber!==Ee||ce.endLineNumber!==Ee)return!1;return!0}class i{constructor(Ee,ce,me,ee){this.startLineNumber=Ee,this.startColumn=ce,this.endLineNumber=me,this.endColumn=ee}}e.SearchRange=i;class n extends i{constructor(Ee,ce,me){super(Ee,ce,Ee,me)}}e.OneLineRange=n;var s;(function(oe){oe.List="list",oe.Tree="tree"})(s=e.ViewMode||(e.ViewMode={}));var a;(function(oe){oe.Default="default",oe.FileNames="fileNames",oe.Type="type",oe.Modified="modified",oe.CountDescending="countDescending",oe.CountAscending="countAscending"})(a=e.SearchSortOrder||(e.SearchSortOrder={}));function o(oe,Ee=!0){const ce=oe&&oe.files&&oe.files.exclude,me=Ee&&oe&&oe.search&&oe.search.exclude;if(!ce&&!me)return;if(!ce||!me)return ce||me;let ee=Object.create(null);return ee=S.mixin(ee,S.deepClone(ce)),ee=S.mixin(ee,S.deepClone(me),!0),ee}e.getExcludes=o;function v(oe,Ee){return oe.excludePattern&&y.match(oe.excludePattern,Ee)?!1:oe.includePattern||oe.usingSearchPaths?oe.includePattern&&y.match(oe.includePattern,Ee)?!0:oe.usingSearchPaths?!!oe.folderQueries&&oe.folderQueries.some(ce=>{const me=ce.folder.fsPath;if(M.isEqualOrParent(Ee,me)){const ee=b.relative(me,Ee);return!ce.includePattern||!!y.match(ce.includePattern,ee)}else return!1}):!1:!0}e.pathIncludedInQuery=v;var p;(function(oe){oe[oe.unknownEncoding=1]="unknownEncoding",oe[oe.regexParseError=2]="regexParseError",oe[oe.globParseError=3]="globParseError",oe[oe.invalidLiteral=4]="invalidLiteral",oe[oe.rgProcessError=5]="rgProcessError",oe[oe.other=6]="other",oe[oe.canceled=7]="canceled"})(p=e.SearchErrorCode||(e.SearchErrorCode={}));class T extends Error{constructor(Ee,ce){super(Ee),this.code=ce}}e.SearchError=T;function N(oe){const Ee=oe.message;if((0,P.isCancellationError)(oe))return new T(Ee,p.canceled);try{const ce=JSON.parse(Ee);return new T(ce.message,ce.code)}catch{return new T(Ee,p.other)}}e.deserializeSearchError=N;function V(oe){const Ee={message:oe.message,code:oe.code};return new Error(JSON.stringify(Ee))}e.serializeSearchError=V;function B(oe){return oe.type==="error"?!0:oe.type==="success"}e.isSerializedSearchComplete=B;function D(oe){return oe.type==="success"}e.isSerializedSearchSuccess=D;function z(oe){return!!oe.path}e.isSerializedFileMatch=z;function L(oe,Ee){const ce=oe.searchPath?oe.searchPath:oe.relativePath;return(0,_.fuzzyContains)(ce,Ee)}e.isFilePatternMatch=L;class R{constructor(Ee){this.path=Ee,this.results=[]}addMatch(Ee){this.results.push(Ee)}serialize(){return{path:this.path,results:this.results,numMatches:this.results.length}}}e.SerializableFileMatch=R;function K(oe,Ee){const ce={...oe||{},...Ee||{}};return Object.keys(ce).filter(me=>{const ee=ce[me];return typeof ee=="boolean"&&ee})}e.resolvePatternsForProvider=K;class W{constructor(Ee,ce){this._parsedIncludeExpression=null,this._excludeExpression={...Ee.excludePattern||{},...ce.excludePattern||{}},this._parsedExcludeExpression=y.parse(this._excludeExpression);let me=Ee.includePattern;ce.includePattern&&(me?me={...me,...ce.includePattern}:me=ce.includePattern),me&&(this._parsedIncludeExpression=y.parse(me))}matchesExcludesSync(Ee,ce,me){return!!(this._parsedExcludeExpression&&this._parsedExcludeExpression(Ee,ce,me))}includedInQuerySync(Ee,ce,me){return!(this._parsedExcludeExpression&&this._parsedExcludeExpression(Ee,ce,me)||this._parsedIncludeExpression&&!this._parsedIncludeExpression(Ee,ce,me))}includedInQuery(Ee,ce,me){const ee=this._parsedExcludeExpression(Ee,ce,me),be=()=>this._parsedIncludeExpression?!!this._parsedIncludeExpression(Ee,ce,me):!0;return(0,E.isThenable)(ee)?ee.then(_e=>_e?!1:be()):be()}hasSiblingExcludeClauses(){return $(this._excludeExpression)}}e.QueryGlobTester=W;function $(oe){for(const Ee in oe)if(typeof oe[Ee]!="boolean")return!0;return!1}function G(oe){if(!oe)return;let Ee;return ce=>(Ee||(Ee=(oe()||Promise.resolve([])).then(me=>me?ge(me):{})),Ee.then(me=>!!me[ce]))}e.hasSiblingPromiseFn=G;function ne(oe){if(!oe)return;let Ee;return ce=>{if(!Ee){const me=oe();Ee=me?ge(me):{}}return!!Ee[ce]}}e.hasSiblingFn=ne;function ge(oe){const Ee={};for(const ce of oe)Ee[ce]=!0;return Ee}}),define(Ce[31],Ie([1,0,18,15,20,5,7,24,13,108,22,9,10,2,136,3,14,149,45,36,28,11,8,6,46,41,4]),function(ie,e,r,y,S,M,_,A,b,P,O,E,m,k,f,c,d,h,g,C,l,w,t,u,i,n,s){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.IExtHostWorkspace=e.ExtHostWorkspace=void 0;function a(D,z,L){return new O.ExtUri(R=>T(R,L)).isEqual(D,z)}function o(D,z,L){return a(D.uri,z.uri,L)?0:(0,E.compare)(D.uri.toString(),z.uri.toString())}function v(D,z,L){return D.index!==z.index?D.index<z.index?-1:1:a(D.uri,z.uri,L)?(0,E.compare)(D.name,z.name):(0,E.compare)(D.uri.toString(),z.uri.toString())}function p(D,z,L,R){const K=D.slice(0).sort(($,G)=>L($,G,R)),W=z.slice(0).sort(($,G)=>L($,G,R));return(0,r.delta)(K,W,($,G)=>L($,G,R))}function T(D,z){const L=z.getCapabilities(D.scheme);return!(L&&L&1024)}class N extends g.Workspace{static toExtHostWorkspace(z,L,R,K){if(!z)return{workspace:null,added:[],removed:[]};const{id:W,name:$,folders:G,configuration:ne,transient:ge,isUntitled:oe}=z,Ee=[],ce=L;L?G.forEach((_e,Fe)=>{const Be=k.URI.revive(_e.uri),Xe=N._findFolder(R||L,Be,K);Xe?(Xe.name=_e.name,Xe.index=_e.index,Ee.push(Xe)):Ee.push({uri:Be,name:_e.name,index:Fe})}):Ee.push(...G.map(({uri:_e,name:Fe,index:Be})=>({uri:k.URI.revive(_e),name:Fe,index:Be}))),Ee.sort((_e,Fe)=>_e.index<Fe.index?-1:1);const me=new N(W,$,Ee,!!ge,ne?k.URI.revive(ne):null,!!oe,_e=>T(_e,K)),{added:ee,removed:be}=p(ce?ce.workspaceFolders:[],me.workspaceFolders,o,K);return{workspace:me,added:ee,removed:be}}static _findFolder(z,L,R){for(let K=0;K<z.folders.length;K++){const W=z.workspaceFolders[K];if(a(W.uri,L,R))return W}}constructor(z,L,R,K,W,$,G){super(z,R.map(ne=>new g.WorkspaceFolder(ne)),K,W,G),this._name=L,this._isUntitled=$,this._workspaceFolders=[],this._structure=A.TernarySearchTree.forUris(G),R.forEach(ne=>{this._workspaceFolders.push(ne),this._structure.set(ne.uri,ne)})}get name(){return this._name}get isUntitled(){return this._isUntitled}get workspaceFolders(){return this._workspaceFolders.slice(0)}getWorkspaceFolder(z,L){return L&&this._structure.get(z)&&(z=(0,O.dirname)(z)),this._structure.findSubstr(z)}resolveWorkspaceFolder(z){return this._structure.get(z)}}let V=class{constructor(z,L,R,K,W){this._onDidChangeWorkspace=new M.Emitter,this.onDidChangeWorkspace=this._onDidChangeWorkspace.event,this._onDidGrantWorkspaceTrust=new M.Emitter,this.onDidGrantWorkspaceTrust=this._onDidGrantWorkspaceTrust.event,this._activeSearchCallbacks=[],this._trusted=!1,this._editSessionIdentityProviders=new Map,this._providerHandlePool=0,this._logService=K,this._extHostFileSystemInfo=R,this._uriTransformerService=W,this._requestIdProvider=new P.Counter,this._barrier=new y.Barrier,this._proxy=z.getProxy(s.MainContext.MainThreadWorkspace),this._messageService=z.getProxy(s.MainContext.MainThreadMessageService);const $=L.workspace;this._confirmedWorkspace=$?new N($.id,$.name,[],!!$.transient,$.configuration?k.URI.revive($.configuration):null,!!$.isUntitled,G=>T(G,R)):void 0}$initializeWorkspace(z,L){this._trusted=L,this.$acceptWorkspaceData(z),this._barrier.open()}waitForInitializeCall(){return this._barrier.wait()}get workspace(){return this._actualWorkspace}get name(){return this._actualWorkspace?this._actualWorkspace.name:void 0}get workspaceFile(){if(this._actualWorkspace&&this._actualWorkspace.configuration)return this._actualWorkspace.isUntitled?k.URI.from({scheme:b.Schemas.untitled,path:(0,O.basename)((0,O.dirname)(this._actualWorkspace.configuration))}):this._actualWorkspace.configuration}get _actualWorkspace(){return this._unconfirmedWorkspace||this._confirmedWorkspace}getWorkspaceFolders(){if(!!this._actualWorkspace)return this._actualWorkspace.workspaceFolders.slice(0)}async getWorkspaceFolders2(){if(await this._barrier.wait(),!!this._actualWorkspace)return this._actualWorkspace.workspaceFolders.slice(0)}updateWorkspaceFolders(z,L,R,...K){const W=[];if(Array.isArray(K)&&K.forEach(oe=>{k.URI.isUri(oe.uri)&&!W.some(Ee=>a(Ee.uri,oe.uri,this._extHostFileSystemInfo))&&W.push({uri:oe.uri,name:oe.name||(0,O.basenameOrAuthority)(oe.uri)})}),this._unconfirmedWorkspace||[L,R].some(oe=>typeof oe!="number"||oe<0)||R===0&&W.length===0)return!1;const $=this._actualWorkspace?this._actualWorkspace.workspaceFolders:[];if(L+R>$.length)return!1;const G=$.slice(0);G.splice(L,R,...W.map(oe=>({uri:oe.uri,name:oe.name||(0,O.basenameOrAuthority)(oe.uri),index:void 0})));for(let oe=0;oe<G.length;oe++){const Ee=G[oe];if(G.some((ce,me)=>me!==oe&&a(Ee.uri,ce.uri,this._extHostFileSystemInfo)))return!1}G.forEach((oe,Ee)=>oe.index=Ee);const{added:ne,removed:ge}=p($,G,v,this._extHostFileSystemInfo);if(ne.length===0&&ge.length===0)return!1;if(this._proxy){const oe=z.displayName||z.name;this._proxy.$updateWorkspaceFolders(oe,L,R,W).then(void 0,Ee=>{this._unconfirmedWorkspace=void 0;const ce={source:{identifier:z.identifier,label:z.displayName||z.name}};this._messageService.$showMessage(h.Severity.Error,(0,f.localize)(0,null,oe,Ee.toString()),ce,[])})}return this.trySetWorkspaceFolders(G),!0}getWorkspaceFolder(z,L){if(!!this._actualWorkspace)return this._actualWorkspace.getWorkspaceFolder(z,L)}async getWorkspaceFolder2(z,L){if(await this._barrier.wait(),!!this._actualWorkspace)return this._actualWorkspace.getWorkspaceFolder(z,L)}async resolveWorkspaceFolder(z){if(await this._barrier.wait(),!!this._actualWorkspace)return this._actualWorkspace.resolveWorkspaceFolder(z)}getPath(){if(!this._actualWorkspace)return;const{folders:z}=this._actualWorkspace;if(z.length!==0)return z[0].uri.fsPath}getRelativePath(z,L){let R,K="";if(typeof z=="string"?(R=k.URI.file(z),K=z):typeof z<"u"&&(R=z,K=z.fsPath),!R)return K;const W=this.getWorkspaceFolder(R,!0);if(!W)return K;typeof L>"u"&&this._actualWorkspace&&(L=this._actualWorkspace.folders.length>1);let $=(0,O.relativePath)(W.uri,R);return L&&W.name&&($=`${W.name}/${$}`),$}trySetWorkspaceFolders(z){this._actualWorkspace&&(this._unconfirmedWorkspace=N.toExtHostWorkspace({id:this._actualWorkspace.id,name:this._actualWorkspace.name,configuration:this._actualWorkspace.configuration,folders:z,isUntitled:this._actualWorkspace.isUntitled},this._actualWorkspace,void 0,this._extHostFileSystemInfo).workspace||void 0)}$acceptWorkspaceData(z){const{workspace:L,added:R,removed:K}=N.toExtHostWorkspace(z,this._confirmedWorkspace,this._unconfirmedWorkspace,this._extHostFileSystemInfo);this._confirmedWorkspace=L||void 0,this._unconfirmedWorkspace=void 0,this._onDidChangeWorkspace.fire(Object.freeze({added:R,removed:K}))}findFiles(z,L,R,K,W=S.CancellationToken.None){this._logService.trace(`extHostWorkspace#findFiles: fileSearch, extension: ${K.value}, entryPoint: findFiles`);let $;if(L===null?$=!1:L&&(typeof L=="string"?$=L:$=L.pattern),W&&W.isCancellationRequested)return Promise.resolve([]);const{includePattern:G,folder:ne}=B(t.GlobPattern.from(z));return this._proxy.$startFileSearch((0,m.withUndefinedAsNull)(G),(0,m.withUndefinedAsNull)(ne),(0,m.withUndefinedAsNull)($),(0,m.withUndefinedAsNull)(R),W).then(ge=>Array.isArray(ge)?ge.map(oe=>k.URI.revive(oe)):[])}async findTextInFiles(z,L,R,K,W=S.CancellationToken.None){this._logService.trace(`extHostWorkspace#findTextInFiles: textSearch, extension: ${K.value}, entryPoint: findTextInFiles`);const $=this._requestIdProvider.getNext(),G=typeof L.previewOptions>"u"?{matchLines:100,charsPerLine:1e4}:L.previewOptions,{includePattern:ne,folder:ge}=B(t.GlobPattern.from(L.include)),oe=typeof L.exclude=="string"?L.exclude:L.exclude?L.exclude.pattern:void 0,Ee={ignoreSymlinks:typeof L.followSymlinks=="boolean"?!L.followSymlinks:void 0,disregardIgnoreFiles:typeof L.useIgnoreFiles=="boolean"?!L.useIgnoreFiles:void 0,disregardGlobalIgnoreFiles:typeof L.useGlobalIgnoreFiles=="boolean"?!L.useGlobalIgnoreFiles:void 0,disregardParentIgnoreFiles:typeof L.useParentIgnoreFiles=="boolean"?!L.useParentIgnoreFiles:void 0,disregardExcludeSettings:typeof L.useDefaultExcludes=="boolean"?!L.useDefaultExcludes:!0,fileEncoding:L.encoding,maxResults:L.maxResults,previewOptions:G,afterContext:L.afterContext,beforeContext:L.beforeContext,includePattern:ne,excludePattern:oe},ce=!1;if(this._activeSearchCallbacks[$]=me=>{if(ce)return;const ee=k.URI.revive(me.resource);me.results.forEach(be=>{(0,n.resultIsMatch)(be)?R({uri:ee,preview:{text:be.preview.text,matches:(0,r.mapArrayOrNot)(be.preview.matches,_e=>new u.Range(_e.startLineNumber,_e.startColumn,_e.endLineNumber,_e.endColumn))},ranges:(0,r.mapArrayOrNot)(be.ranges,_e=>new u.Range(_e.startLineNumber,_e.startColumn,_e.endLineNumber,_e.endColumn))}):R({uri:ee,text:be.text,lineNumber:be.lineNumber})})},W.isCancellationRequested)return{};try{const me=await this._proxy.$startTextSearch(z,(0,m.withUndefinedAsNull)(ge),Ee,$,W);return delete this._activeSearchCallbacks[$],me||{}}catch(me){throw delete this._activeSearchCallbacks[$],me}}$handleTextSearchResult(z,L){this._activeSearchCallbacks[L]?.(z)}saveAll(z){return this._proxy.$saveAll(z)}resolveProxy(z){return this._proxy.$resolveProxy(z)}get trusted(){return this._trusted}requestWorkspaceTrust(z){return this._proxy.$requestWorkspaceTrust(z)}$onDidGrantWorkspaceTrust(){this._trusted||(this._trusted=!0,this._onDidGrantWorkspaceTrust.fire())}registerEditSessionIdentityProvider(z,L){if(this._editSessionIdentityProviders.has(z))throw new Error(`A provider has already been registered for scheme ${z}`);this._editSessionIdentityProviders.set(z,L);const R=this._uriTransformerService.transformOutgoingScheme(z),K=this._providerHandlePool++;return this._proxy.$registerEditSessionIdentityProvider(K,R),(0,_.toDisposable)(()=>{this._editSessionIdentityProviders.delete(z),this._proxy.$unregisterEditSessionIdentityProvider(K)})}async $getEditSessionIdentifier(z,L){this._logService.info("Getting edit session identifier for workspaceFolder",z);const R=await this.resolveWorkspaceFolder(k.URI.revive(z));if(!R){this._logService.warn("Unable to resolve workspace folder");return}this._logService.info("Invoking #provideEditSessionIdentity for workspaceFolder",R);const K=this._editSessionIdentityProviders.get(R.uri.scheme);if(this._logService.info(`Provider for scheme ${R.uri.scheme} is defined: `,!!K),!K)return;const W=await K.provideEditSessionIdentity(R,L);if(this._logService.info("Provider returned edit session identifier: ",W),!!W)return W}};V=ze([$e(0,w.IExtHostRpcService),$e(1,l.IExtHostInitDataService),$e(2,C.IExtHostFileSystemInfo),$e(3,d.ILogService),$e(4,i.IURITransformerService)],V),e.ExtHostWorkspace=V,e.IExtHostWorkspace=(0,c.createDecorator)("IExtHostWorkspace");function B(D){let z,L;return D&&(typeof D=="string"?z=D:(z=D.pattern,L=k.URI.revive(D.baseUri))),{includePattern:z,folder:L}}}),define(Ce[32],Ie([1,0,26,5,31,4,6,152,85,10,15,3,11,14,2]),function(ie,e,r,y,S,M,_,A,b,P,O,E,m,k,f){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.IExtHostConfiguration=e.ExtHostConfigProvider=e.ExtHostConfiguration=void 0;function c(u,i){if(i){const n=i.split(".");let s=u;for(let a=0;s&&a<n.length;a++)s=s[n[a]];return s}}function d(u){return u instanceof f.URI}function h(u){return u&&u.uri instanceof f.URI&&u.languageId&&typeof u.languageId=="string"}function g(u){return u&&!u.uri&&u.languageId&&typeof u.languageId=="string"}function C(u){return u&&u.uri instanceof f.URI&&(!u.name||typeof u.name=="string")&&(!u.index||typeof u.index=="number")}function l(u){if(d(u))return{resource:u};if(h(u))return{resource:u.uri,overrideIdentifier:u.languageId};if(g(u))return{overrideIdentifier:u.languageId};if(C(u))return{resource:u.uri};if(u===null)return{resource:null}}let w=class{constructor(i,n,s){this._proxy=i.getProxy(M.MainContext.MainThreadConfiguration),this._extHostWorkspace=n,this._logService=s,this._barrier=new O.Barrier,this._actual=null}getConfigProvider(){return this._barrier.wait().then(i=>this._actual)}$initializeConfiguration(i){this._actual=new t(this._proxy,this._extHostWorkspace,i,this._logService),this._barrier.open()}$acceptConfigurationChanged(i,n){this.getConfigProvider().then(s=>s.$acceptConfigurationChanged(i,n))}};w=ze([$e(0,m.IExtHostRpcService),$e(1,S.IExtHostWorkspace),$e(2,k.ILogService)],w),e.ExtHostConfiguration=w;class t{constructor(i,n,s,a){this._onDidChangeConfiguration=new y.Emitter,this._proxy=i,this._logService=a,this._extHostWorkspace=n,this._configuration=A.Configuration.parse(s),this._configurationScopes=this._toMap(s.configurationScopes)}get onDidChangeConfiguration(){return this._onDidChangeConfiguration&&this._onDidChangeConfiguration.event}$acceptConfigurationChanged(i,n){const s={data:this._configuration.toData(),workspace:this._extHostWorkspace.workspace};this._configuration=A.Configuration.parse(i),this._configurationScopes=this._toMap(i.configurationScopes),this._onDidChangeConfiguration.fire(this._toConfigurationChangeEvent(n,s))}getConfiguration(i,n,s){const a=l(n)||{},o=this._toReadonlyValue(i?c(this._configuration.getValue(void 0,a,this._extHostWorkspace.workspace),i):this._configuration.getValue(void 0,a,this._extHostWorkspace.workspace));i&&this._validateConfigurationAccess(i,a,s?.identifier);function v(T){if(T==null)return null;if(typeof T=="boolean")return T?2:5;switch(T){case _.ConfigurationTarget.Global:return 2;case _.ConfigurationTarget.Workspace:return 5;case _.ConfigurationTarget.WorkspaceFolder:return 6}}const p={has(T){return typeof c(o,T)<"u"},get:(T,N)=>{this._validateConfigurationAccess(i?`${i}.${T}`:T,a,s?.identifier);let V=c(o,T);if(typeof V>"u")V=N;else{let B;const D=(z,L)=>{let R;const K=()=>{B=B||(0,r.deepClone)(o),R=R||c(B,L)};return(0,P.isObject)(z)?new Proxy(z,{get:(W,$)=>{if(typeof $=="string"&&$.toLowerCase()==="tojson")return K(),()=>R;if(B)return R=R||c(B,L),R[$];const G=W[$];return typeof $=="string"?D(G,`${L}.${$}`):G},set:(W,$,G)=>(K(),R&&(R[$]=G),!0),deleteProperty:(W,$)=>(K(),R&&delete R[$],!0),defineProperty:(W,$,G)=>(K(),R&&Object.defineProperty(R,$,G),!0)}):z};V=D(V,T)}return V},update:(T,N,V,B)=>{T=i?`${i}.${T}`:T;const D=v(V);return N!==void 0?this._proxy.$updateConfigurationOption(D,T,N,a,B):this._proxy.$removeConfigurationOption(D,T,a,B)},inspect:T=>{T=i?`${i}.${T}`:T;const N=(0,r.deepClone)(this._configuration.inspect(T,a,this._extHostWorkspace.workspace));if(N)return{key:T,defaultValue:N.policy?.value??N.default?.value,globalValue:N.user?.value??N.application?.value,workspaceValue:N.workspace?.value,workspaceFolderValue:N.workspaceFolder?.value,defaultLanguageValue:N.default?.override,globalLanguageValue:N.user?.override??N.application?.override,workspaceLanguageValue:N.workspace?.override,workspaceFolderLanguageValue:N.workspaceFolder?.override,languageIds:N.overrideIdentifiers}}};return typeof o=="object"&&(0,r.mixin)(p,o,!1),Object.freeze(p)}_toReadonlyValue(i){const n=s=>(0,P.isObject)(s)?new Proxy(s,{get:(a,o)=>n(a[o]),set:(a,o,v)=>{throw new Error(`TypeError: Cannot assign to read only property '${String(o)}' of object`)},deleteProperty:(a,o)=>{throw new Error(`TypeError: Cannot delete read only property '${String(o)}' of object`)},defineProperty:(a,o)=>{throw new Error(`TypeError: Cannot define property '${String(o)}' for a readonly object`)},setPrototypeOf:a=>{throw new Error("TypeError: Cannot set prototype for a readonly object")},isExtensible:()=>!1,preventExtensions:()=>!0}):s;return n(i)}_validateConfigurationAccess(i,n,s){const a=b.OVERRIDE_PROPERTY_REGEX.test(i)?4:this._configurationScopes.get(i),o=s?`[${s.value}] `:"";if(a===4){typeof n?.resource>"u"&&this._logService.warn(`${o}Accessing a resource scoped configuration without providing a resource is not expected. To get the effective value for '${i}', provide the URI of a resource or 'null' for any resource.`);return}if(a===3){n?.resource&&this._logService.warn(`${o}Accessing a window scoped configuration for a resource is not expected. To associate '${i}' to a resource, define its scope to 'resource' in configuration contributions in 'package.json'.`);return}}_toConfigurationChangeEvent(i,n){const s=new A.ConfigurationChangeEvent(i,n,this._configuration,this._extHostWorkspace.workspace);return Object.freeze({affectsConfiguration:(a,o)=>s.affectsConfiguration(a,l(o))})}_toMap(i){return i.reduce((n,s)=>(n.set(s[0],s[1]),n),new Map)}}e.ExtHostConfigProvider=t,e.IExtHostConfiguration=(0,E.createDecorator)("IExtHostConfiguration")});var Je=this&&this.__classPrivateFieldSet||function(ie,e,r,y,S){if(y==="m")throw new TypeError("Private method is not writable");if(y==="a"&&!S)throw new TypeError("Private accessor was defined without a setter");if(typeof e=="function"?ie!==e||!S:!e.has(ie))throw new TypeError("Cannot write private member to an object whose class did not declare it");return y==="a"?S.call(ie,r):S?S.value=r:e.set(ie,r),r},Oe=this&&this.__classPrivateFieldGet||function(ie,e,r,y){if(r==="a"&&!y)throw new TypeError("Private accessor was defined without a getter");if(typeof e=="function"?ie!==e||!y:!e.has(ie))throw new TypeError("Cannot read private member from an object whose class did not declare it");return r==="m"?y:r==="a"?y.call(ie):y?y.value:e.get(ie)};define(Ce[102],Ie([1,0,2,15,5,4,6,31,50,32,20,53,11,28,3,13,21,14,67,185,12]),function(ie,e,r,y,S,M,_,A,b,P,O,E,m,k,f,c,d,h,g,C,l){"use strict";var w;Object.defineProperty(e,"__esModule",{value:!0}),e.IExtHostTask=e.WorkerExtHostTask=e.ExtHostTaskBase=e.TaskExecutionDTO=e.TaskFilterDTO=e.TaskDTO=e.TaskGroupDTO=e.TaskHandleDTO=e.CustomExecutionDTO=e.ShellExecutionDTO=e.ShellExecutionOptionsDTO=e.ProcessExecutionDTO=e.ProcessExecutionOptionsDTO=e.TaskPresentationOptionsDTO=e.TaskDefinitionDTO=void 0;var t;(function(L){function R(W){if(W!=null)return W}L.from=R;function K(W){if(W!=null)return W}L.to=K})(t=e.TaskDefinitionDTO||(e.TaskDefinitionDTO={}));var u;(function(L){function R(W){if(W!=null)return W}L.from=R;function K(W){if(W!=null)return W}L.to=K})(u=e.TaskPresentationOptionsDTO||(e.TaskPresentationOptionsDTO={}));var i;(function(L){function R(W){if(W!=null)return W}L.from=R;function K(W){if(W!=null)return W}L.to=K})(i=e.ProcessExecutionOptionsDTO||(e.ProcessExecutionOptionsDTO={}));var n;(function(L){function R($){if($){const G=$;return G&&!!G.process}else return!1}L.is=R;function K($){if($==null)return;const G={process:$.process,args:$.args};return $.options&&(G.options=i.from($.options)),G}L.from=K;function W($){if($!=null)return new _.ProcessExecution($.process,$.args,$.options)}L.to=W})(n=e.ProcessExecutionDTO||(e.ProcessExecutionDTO={}));var s;(function(L){function R(W){if(W!=null)return W}L.from=R;function K(W){if(W!=null)return W}L.to=K})(s=e.ShellExecutionOptionsDTO||(e.ShellExecutionOptionsDTO={}));var a;(function(L){function R($){if($){const G=$;return G&&(!!G.commandLine||!!G.command)}else return!1}L.is=R;function K($){if($==null)return;const G={};return $.commandLine!==void 0?G.commandLine=$.commandLine:(G.command=$.command,G.args=$.args),$.options&&(G.options=s.from($.options)),G}L.from=K;function W($){if(!($==null||$.command===void 0&&$.commandLine===void 0))return $.commandLine?new _.ShellExecution($.commandLine,$.options):new _.ShellExecution($.command,$.args?$.args:[],$.options)}L.to=W})(a=e.ShellExecutionDTO||(e.ShellExecutionDTO={}));var o;(function(L){function R($){if($){const G=$;return G&&G.customExecution==="customExecution"}else return!1}L.is=R;function K($){return{customExecution:"customExecution"}}L.from=K;function W($,G){return G.get($)}L.to=W})(o=e.CustomExecutionDTO||(e.CustomExecutionDTO={}));var v;(function(L){function R(K,W){let $;return K.scope!==void 0&&typeof K.scope!="number"?$=K.scope.uri:K.scope!==void 0&&typeof K.scope=="number"&&(K.scope===_.TaskScope.Workspace&&W&&W.workspaceFile?$=W.workspaceFile:$=C.USER_TASKS_GROUP_KEY),{id:K._id,workspaceFolder:$}}L.from=R})(v=e.TaskHandleDTO||(e.TaskHandleDTO={}));var p;(function(L){function R(K){if(K!=null)return{_id:K.id,isDefault:K.isDefault}}L.from=R})(p=e.TaskGroupDTO||(e.TaskGroupDTO={}));var T;(function(L){function R($,G){if($==null)return[];const ne=[];for(const ge of $){const oe=K(ge,G);oe&&ne.push(oe)}return ne}L.fromMany=R;function K($,G){if($==null)return;let ne;$.execution instanceof _.ProcessExecution?ne=n.from($.execution):$.execution instanceof _.ShellExecution?ne=a.from($.execution):$.execution&&$.execution instanceof _.CustomExecution&&(ne=o.from($.execution));const ge=t.from($.definition);let oe;return $.scope?typeof $.scope=="number"?oe=$.scope:oe=$.scope.uri:oe=_.TaskScope.Workspace,!ge||!oe?void 0:{_id:$._id,definition:ge,name:$.name,source:{extensionId:G.identifier.value,label:$.source,scope:oe},execution:ne,isBackground:$.isBackground,group:p.from($.group),presentationOptions:u.from($.presentationOptions),problemMatchers:$.problemMatchers,hasDefinedMatchers:$.hasDefinedMatchers,runOptions:$.runOptions?$.runOptions:{reevaluateOnRerun:!0},detail:$.detail}}L.from=K;async function W($,G,ne){if($==null)return;let ge;n.is($.execution)?ge=n.to($.execution):a.is($.execution)?ge=a.to($.execution):o.is($.execution)&&(ge=o.to($._id,ne));const oe=t.to($.definition);let Ee;if($.source&&($.source.scope!==void 0?typeof $.source.scope=="number"?Ee=$.source.scope:Ee=await G.resolveWorkspaceFolder(r.URI.revive($.source.scope)):Ee=_.TaskScope.Workspace),!oe||!Ee)return;const ce=new _.Task(oe,Ee,$.name,$.source.label,ge,$.problemMatchers);return $.isBackground!==void 0&&(ce.isBackground=$.isBackground),$.group!==void 0&&(ce.group=_.TaskGroup.from($.group._id),ce.group&&$.group.isDefault&&(ce.group=new _.TaskGroup(ce.group.id,ce.group.label),$.group.isDefault===!0&&(ce.group.isDefault=$.group.isDefault))),$.presentationOptions&&(ce.presentationOptions=u.to($.presentationOptions)),$._id&&(ce._id=$._id),$.detail&&(ce.detail=$.detail),ce}L.to=W})(T=e.TaskDTO||(e.TaskDTO={}));var N;(function(L){function R(W){return W}L.from=R;function K(W){if(!!W)return Object.assign(Object.create(null),W)}L.to=K})(N=e.TaskFilterDTO||(e.TaskFilterDTO={}));class V{constructor(R,K,W){this._id=K,this._task=W,w.set(this,void 0),Je(this,w,R,"f")}get task(){return this._task}terminate(){Oe(this,w,"f").terminateTask(this)}fireDidStartProcess(R){}fireDidEndProcess(R){}}w=new WeakMap;var B;(function(L){function R(K){return{id:K._id,task:void 0}}L.from=R})(B=e.TaskExecutionDTO||(e.TaskExecutionDTO={}));let D=class{constructor(R,K,W,$,G,ne,ge,oe){this._onDidExecuteTask=new S.Emitter,this._onDidTerminateTask=new S.Emitter,this._onDidTaskProcessStarted=new S.Emitter,this._onDidTaskProcessEnded=new S.Emitter,this._proxy=R.getProxy(M.MainContext.MainThreadTask),this._workspaceProvider=W,this._editorService=$,this._configurationService=G,this._terminalService=ne,this._handleCounter=0,this._handlers=new Map,this._taskExecutions=new Map,this._taskExecutionPromises=new Map,this._providedCustomExecutions2=new Map,this._notProvidedCustomExecutions=new Set,this._activeCustomExecutions2=new Map,this._logService=ge,this._deprecationService=oe,this._proxy.$registerSupportedExecutions(!0)}registerTaskProvider(R,K,W){if(!W)return new _.Disposable(()=>{});const $=this.nextHandle();return this._handlers.set($,{type:K,provider:W,extension:R}),this._proxy.$registerTaskProvider($,K),new _.Disposable(()=>{this._handlers.delete($),this._proxy.$unregisterTaskProvider($)})}registerTaskSystem(R,K){this._proxy.$registerTaskSystem(R,K)}fetchTasks(R){return this._proxy.$fetchTasks(N.from(R)).then(async K=>{const W=[];for(const $ of K){const G=await T.to($,this._workspaceProvider,this._providedCustomExecutions2);G&&W.push(G)}return W})}get taskExecutions(){const R=[];return this._taskExecutions.forEach(K=>R.push(K)),R}terminateTask(R){if(!(R instanceof V))throw new Error("No valid task execution provided");return this._proxy.$terminateTask(R._id)}get onDidStartTask(){return this._onDidExecuteTask.event}async $onDidStartTask(R,K,W){const $=this._providedCustomExecutions2.get(R.id);$&&(this._activeCustomExecutions2.set(R.id,$),this._terminalService.attachPtyToTerminal(K,await $.callback(W))),this._lastStartedTask=R.id,this._onDidExecuteTask.fire({execution:await this.getTaskExecution(R)})}get onDidEndTask(){return this._onDidTerminateTask.event}async $OnDidEndTask(R){const K=await this.getTaskExecution(R);this._taskExecutionPromises.delete(R.id),this._taskExecutions.delete(R.id),this.customExecutionComplete(R),this._onDidTerminateTask.fire({execution:K})}get onDidStartTaskProcess(){return this._onDidTaskProcessStarted.event}async $onDidStartTaskProcess(R){const K=await this.getTaskExecution(R.id);this._onDidTaskProcessStarted.fire({execution:K,processId:R.processId})}get onDidEndTaskProcess(){return this._onDidTaskProcessEnded.event}async $onDidEndTaskProcess(R){const K=await this.getTaskExecution(R.id);this._onDidTaskProcessEnded.fire({execution:K,exitCode:R.exitCode})}$provideTasks(R,K){const W=this._handlers.get(R);if(!W)return Promise.reject(new Error("no handler found"));const $=[],G=(0,y.asPromise)(()=>W.provider.provideTasks(O.CancellationToken.None)).then(ne=>this.provideTasksInternal(K,$,W,ne));return new Promise(ne=>{G.then(ge=>{Promise.all($).then(()=>{ne(ge)})})})}async $resolveTask(R,K){const W=this._handlers.get(R);if(!W)return Promise.reject(new Error("no handler found"));if(K.definition.type!==W.type)throw new Error(`Unexpected: Task of type [${K.definition.type}] cannot be resolved by provider of type [${W.type}].`);const $=await T.to(K,this._workspaceProvider,this._providedCustomExecutions2);if(!$)throw new Error("Unexpected: Task cannot be resolved.");const G=await W.provider.resolveTask($,O.CancellationToken.None);if(!G)return;this.checkDeprecation(G,W);const ne=T.from(G,W.extension);if(!ne)throw new Error("Unexpected: Task cannot be resolved.");if(G.definition!==$.definition)throw new Error("Unexpected: The resolved task definition must be the same object as the original task definition. The task definition cannot be changed.");return o.is(ne.execution)&&await this.addCustomExecution(ne,G,!0),await this.resolveTaskInternal(ne)}nextHandle(){return this._handleCounter++}async addCustomExecution(R,K,W){const $=await this._proxy.$createTaskId(R);!W&&!this._providedCustomExecutions2.has($)&&(this._notProvidedCustomExecutions.add($),this._activeCustomExecutions2.set($,K.execution)),this._providedCustomExecutions2.set($,K.execution)}async getTaskExecution(R,K){if(typeof R=="string"){const G=this._taskExecutionPromises.get(R);if(!G)throw new Error("Unexpected: The specified task is missing an execution");return G}const W=this._taskExecutionPromises.get(R.id);if(W)return W;const $=new Promise((G,ne)=>{function ge(oe,Ee,ce){ce?G(new V(oe,Ee.id,ce)):ne("Unexpected: Task does not exist.")}K?ge(this,R,K):T.to(R.task,this._workspaceProvider,this._providedCustomExecutions2).then(oe=>ge(this,R,oe))});return this._taskExecutionPromises.set(R.id,$),$.then(G=>(this._taskExecutions.set(R.id,G),G),G=>Promise.reject(G))}checkDeprecation(R,K){R._deprecated&&this._deprecationService.report("Task.constructor",K.extension,"Use the Task constructor that takes a `scope` instead.")}customExecutionComplete(R){this._activeCustomExecutions2.get(R.id)&&this._activeCustomExecutions2.delete(R.id),this._notProvidedCustomExecutions.has(R.id)&&this._lastStartedTask!==R.id&&(this._providedCustomExecutions2.delete(R.id),this._notProvidedCustomExecutions.delete(R.id));const W=this._notProvidedCustomExecutions.values();let $=W.next();for(;!$.done;)!this._activeCustomExecutions2.has($.value)&&this._lastStartedTask!==$.value&&(this._providedCustomExecutions2.delete($.value),this._notProvidedCustomExecutions.delete($.value)),$=W.next()}};D=ze([$e(0,m.IExtHostRpcService),$e(1,k.IExtHostInitDataService),$e(2,A.IExtHostWorkspace),$e(3,b.IExtHostDocumentsAndEditors),$e(4,P.IExtHostConfiguration),$e(5,E.IExtHostTerminalService),$e(6,h.ILogService),$e(7,g.IExtHostApiDeprecationService)],D),e.ExtHostTaskBase=D;let z=class extends D{constructor(R,K,W,$,G,ne,ge,oe){super(R,K,W,$,G,ne,ge,oe),this.registerTaskSystem(c.Schemas.vscodeRemote,{scheme:c.Schemas.vscodeRemote,authority:"",platform:d.PlatformToString(0)})}async executeTask(R,K){if(!K.execution)throw new Error("Tasks to execute must include an execution");const W=T.from(K,R);if(W===void 0)throw new Error("Task is not valid");if(o.is(W.execution))await this.addCustomExecution(W,K,!1);else throw new l.NotSupportedError;const $=await this.getTaskExecution(await this._proxy.$getTaskExecution(W),K);return this._proxy.$executeTask(W).catch(G=>{throw new Error(G)}),$}provideTasksInternal(R,K,W,$){const G=[];if($)for(const ne of $){this.checkDeprecation(ne,W),(!ne.definition||!R[ne.definition.type])&&this._logService.warn(`The task [${ne.source}, ${ne.name}] uses an undefined task type. The task will be ignored in the future.`);const ge=T.from(ne,W.extension);ge&&o.is(ge.execution)?(G.push(ge),K.push(this.addCustomExecution(ge,ne,!0))):this._logService.warn("Only custom execution tasks supported.")}return{tasks:G,extension:W.extension}}async resolveTaskInternal(R){if(o.is(R.execution))return R;this._logService.warn("Only custom execution tasks supported.")}async $resolveVariables(R,K){return{process:void 0,variables:Object.create(null)}}async $jsonTasksSupported(){return!1}async $findExecutable(R,K,W){}};z=ze([$e(0,m.IExtHostRpcService),$e(1,k.IExtHostInitDataService),$e(2,A.IExtHostWorkspace),$e(3,b.IExtHostDocumentsAndEditors),$e(4,P.IExtHostConfiguration),$e(5,E.IExtHostTerminalService),$e(6,h.ILogService),$e(7,g.IExtHostApiDeprecationService)],z),e.WorkerExtHostTask=z,e.IExtHostTask=(0,f.createDecorator)("IExtHostTask")}),define(Ce[228],Ie([1,0,19,20,43,34,22,203,41]),function(ie,e,r,y,S,M,_,A,b){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.FileSearchManager=void 0;class P{constructor(m,k,f){this.config=m,this.provider=k,this.sessionToken=f,this.isLimitHit=!1,this.resultCount=0,this.isCanceled=!1,this.filePattern=m.filePattern,this.includePattern=m.includePattern&&M.parse(m.includePattern),this.maxResults=m.maxResults||void 0,this.exists=m.exists,this.activeCancellationTokens=new Set,this.globalExcludePattern=m.excludePattern&&M.parse(m.excludePattern)}cancel(){this.isCanceled=!0,this.activeCancellationTokens.forEach(m=>m.cancel()),this.activeCancellationTokens=new Set}search(m){const k=this.config.folderQueries||[];return new Promise((f,c)=>{const d=h=>{this.resultCount++,m(h)};if(this.isCanceled)return f({limitHit:this.isLimitHit});this.config.extraFileResources&&this.config.extraFileResources.forEach(h=>{const g=h.toString(),C=r.basename(g);this.globalExcludePattern&&this.globalExcludePattern(g,C)||this.matchFile(d,{base:h,basename:C})}),Promise.all(k.map(h=>this.searchInFolder(h,d))).then(h=>{f({limitHit:this.isLimitHit,stats:h[0]||void 0})},h=>{c(new Error((0,S.toErrorMessage)(h)))})})}async searchInFolder(m,k){const f=new y.CancellationTokenSource,c=this.getSearchOptionsForFolder(m),d=this.initDirectoryTree(),h=new b.QueryGlobTester(this.config,m),g=!h.hasSiblingExcludeClauses();let C;try{this.activeCancellationTokens.add(f),C=A.StopWatch.create();const l=await this.provider.provideFileSearchResults({pattern:this.config.filePattern||""},c,f.token),w=C.elapsed(),t=A.StopWatch.create();return this.isCanceled&&!this.isLimitHit||(l&&l.forEach(u=>{const i=r.posix.relative(m.folder.path,u.path);if(g){const n=r.basename(u.path);this.matchFile(k,{base:m.folder,relativePath:i,basename:n});return}this.addDirectoryEntries(d,m.folder,i,k)}),this.isCanceled&&!this.isLimitHit)?null:(this.matchDirectoryTree(d,h,k),{providerTime:w,postProcessTime:t.elapsed()})}finally{f.dispose(),this.activeCancellationTokens.delete(f)}}getSearchOptionsForFolder(m){const k=(0,b.resolvePatternsForProvider)(this.config.includePattern,m.includePattern),f=(0,b.resolvePatternsForProvider)(this.config.excludePattern,m.excludePattern);return{folder:m.folder,excludes:f,includes:k,useIgnoreFiles:!m.disregardIgnoreFiles,useGlobalIgnoreFiles:!m.disregardGlobalIgnoreFiles,useParentIgnoreFiles:!m.disregardParentIgnoreFiles,followSymlinks:!m.ignoreSymlinks,maxResults:this.config.maxResults,session:this.sessionToken}}initDirectoryTree(){const m={rootEntries:[],pathToEntries:Object.create(null)};return m.pathToEntries["."]=m.rootEntries,m}addDirectoryEntries({pathToEntries:m},k,f,c){if(f===this.filePattern){const h=r.basename(this.filePattern);this.matchFile(c,{base:k,relativePath:this.filePattern,basename:h})}function d(h){const g=r.basename(h),C=r.dirname(h);let l=m[C];l||(l=m[C]=[],d(C)),l.push({base:k,relativePath:h,basename:g})}d(f)}matchDirectoryTree({rootEntries:m,pathToEntries:k},f,c){const d=this,h=this.filePattern;function g(C){const l=(0,b.hasSiblingFn)(()=>C.map(w=>w.basename));for(let w=0,t=C.length;w<t;w++){const u=C[w],{relativePath:i,basename:n}=u;if(f.matchesExcludesSync(i,n,h!==n?l:void 0))continue;const s=k[i];if(s)g(s);else{if(i===h)continue;d.matchFile(c,u)}if(d.isLimitHit)break}}g(m)}matchFile(m,k){(!this.includePattern||k.relativePath&&this.includePattern(k.relativePath,k.basename))&&((this.exists||this.maxResults&&this.resultCount>=this.maxResults)&&(this.isLimitHit=!0,this.cancel()),this.isLimitHit||m(k))}}class O{constructor(){this.sessions=new Map}fileSearch(m,k,f,c){const d=this.getSessionTokenSource(m.cacheKey),h=new P(m,k,d&&d.token);let g=0;const C=l=>{g+=l.length,f(l.map(w=>this.rawMatchToSearchItem(w)))};return this.doSearch(h,O.BATCH_SIZE,C,c).then(l=>({limitHit:l.limitHit,stats:{fromCache:!1,type:"fileSearchProvider",resultCount:g,detailStats:l.stats}}))}clearCache(m){this.getSessionTokenSource(m)?.cancel()}getSessionTokenSource(m){if(!!m)return this.sessions.has(m)||this.sessions.set(m,new y.CancellationTokenSource),this.sessions.get(m)}rawMatchToSearchItem(m){return m.relativePath?{resource:_.joinPath(m.base,m.relativePath)}:{resource:m.base}}doSearch(m,k,f,c){c.onCancellationRequested(()=>{m.cancel()});const d=g=>{g&&(h.push(g),k>0&&h.length>=k&&(f(h),h=[]))};let h=[];return m.search(d).then(g=>(h.length&&f(h),g),g=>(h.length&&f(h),Promise.reject(g)))}}e.FileSearchManager=O,O.BATCH_SIZE=512}),define(Ce[229],Ie([1,0,18,73,34,78,24,13,19,22,9,10,2,246,144,57,14,45,91,227,41]),function(ie,e,r,y,S,M,_,A,b,P,O,E,m,k,f,c,d,h,g,C,l){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.resolveResourcesForSearchIncludes=e.QueryBuilder=void 0;let w=class{constructor(p,T,N,V,B){this.configurationService=p,this.workspaceContextService=T,this.editorGroupsService=N,this.logService=V,this.pathService=B}text(p,T,N={}){p=this.getContentPattern(p,N);const V=this.configurationService.getValue(),B=T&&T.some(z=>!this.configurationService.getValue({resource:z}).search.useRipgrep);return{...this.commonQuery(T?.map(h.toWorkspaceFolder),N),type:2,contentPattern:p,previewOptions:N.previewOptions,maxFileSize:N.maxFileSize,usePCRE2:V.search.usePCRE2||B||!1,beforeContext:N.beforeContext,afterContext:N.afterContext,userDisabledExcludesAndIgnoreFiles:N.disregardExcludeSettings&&N.disregardIgnoreFiles}}getContentPattern(p,T){const N=this.configurationService.getValue();p.isRegExp&&(p.pattern=p.pattern.replace(/\r?\n/g,"\\n"));const V={...p,wordSeparators:N.editor.wordSeparators};return this.isCaseSensitive(p,T)&&(V.isCaseSensitive=!0),this.isMultiline(p)&&(V.isMultiline=!0),V}file(p,T={}){return{...this.commonQuery(p,T),type:1,filePattern:T.filePattern?T.filePattern.trim():T.filePattern,exists:T.exists,sortByScore:T.sortByScore,cacheKey:T.cacheKey}}handleIncludeExclude(p,T){return p?(p=Array.isArray(p)?p.map(s):s(p),T?this.parseSearchPaths(p):{pattern:u(...Array.isArray(p)?p:[p])}):{}}commonQuery(p=[],T={}){const N=this.handleIncludeExclude(T.includePattern,T.expandPatterns),V=this.handleIncludeExclude(T.excludePattern,T.expandPatterns),B=p.length>1,D=(N.searchPaths&&N.searchPaths.length?N.searchPaths.map(R=>this.getFolderQueryForSearchPath(R,T,V)):p.map(R=>this.getFolderQueryForRoot(R,T,V,B))).filter(R=>!!R),z={_reason:T._reason,folderQueries:D,usingSearchPaths:!!(N.searchPaths&&N.searchPaths.length),extraFileResources:T.extraFileResources,excludePattern:V.pattern,includePattern:N.pattern,onlyOpenEditors:T.onlyOpenEditors,maxResults:T.maxResults};if(T.onlyOpenEditors){const R=r.coalesce(r.flatten(this.editorGroupsService.groups.map($=>$.editors.map(G=>G.resource))));this.logService.trace("QueryBuilder#commonQuery - openEditor URIs",JSON.stringify(R));const K=R.filter($=>(0,l.pathIncludedInQuery)(z,$.fsPath)),W=this.commonQueryFromFileList(K);return this.logService.trace("QueryBuilder#commonQuery - openEditor Query",JSON.stringify(W)),{...z,...W}}const L=T.extraFileResources&&T.extraFileResources.filter(R=>(0,l.pathIncludedInQuery)(z,R.fsPath));return z.extraFileResources=L&&L.length?L:void 0,z}commonQueryFromFileList(p){const T=[],N=new _.ResourceMap,V={};let B=!1;return p.forEach(D=>{if(D.scheme===A.Schemas.walkThrough)return;if((0,P.isAbsolutePath)(D)){const L=this.workspaceContextService.getWorkspaceFolder(D)?.uri??D.with({path:b.dirname(D.fsPath)});let R=N.get(L);R||(B=!0,R={folder:L,includePattern:{}},T.push(R),N.set(L,R));const K=b.relative(L.fsPath,D.fsPath);(0,E.assertIsDefined)(R.includePattern)[K.replace(/\\/g,"/")]=!0}else D.fsPath&&(B=!0,V[D.fsPath]=!0)}),{folderQueries:T,includePattern:V,usingSearchPaths:!0,excludePattern:B?void 0:{"**/*":!0}}}isCaseSensitive(p,T){if(T.isSmartCase){if(p.isRegExp){if(O.containsUppercaseCharacter(p.pattern,!0))return!0}else if(O.containsUppercaseCharacter(p.pattern))return!0}return!!p.isCaseSensitive}isMultiline(p){return p.isMultiline||p.isRegExp&&(0,k.isMultilineRegexSource)(p.pattern)||p.pattern.indexOf(`
`)>=0?!0:!!p.isMultiline}parseSearchPaths(p){const T=W=>b.isAbsolute(W)||/^\.\.?([\/\\]|$)/.test(W),V=(Array.isArray(p)?p:i(p)).map(W=>{const $=this.pathService.resolvedUserHome;return $?(0,M.untildify)(W,$.scheme===A.Schemas.file?$.fsPath:$.path):W}),B=y.groupBy(V,W=>T(W)?"searchPaths":"exprSegments"),D=(B.exprSegments||[]).map(W=>O.rtrim(W,"/")).map(W=>O.rtrim(W,"\\")).map(W=>(W[0]==="."&&(W="*"+W),n(W))),z={},L=this.expandSearchPathPatterns(B.searchPaths||[]);L&&L.length&&(z.searchPaths=L);const R=r.flatten(D),K=u(...R);return K&&(z.pattern=K),z}getExcludesForFolder(p,T){return T.disregardExcludeSettings?void 0:(0,l.getExcludes)(p,!T.disregardSearchExcludeSettings)}expandSearchPathPatterns(p){if(!p||!p.length)return[];const T=r.flatten(p.map(V=>{let{pathPortion:B,globPortion:D}=t(V);D&&(D=a(D));const z=this.expandOneSearchPath(B);return r.flatten(z.map(L=>this.resolveOneSearchPathPattern(L,D)))})),N=new Map;return T.forEach(V=>{const B=V.searchPath.toString(),D=N.get(B);D?V.pattern&&(D.pattern=D.pattern||{},D.pattern[V.pattern]=!0):N.set(B,{searchPath:V.searchPath,pattern:V.pattern?u(V.pattern):void 0})}),Array.from(N.values())}expandOneSearchPath(p){if(b.isAbsolute(p)){const T=this.workspaceContextService.getWorkspace().folders;return T[0]&&T[0].uri.scheme!==A.Schemas.file?[{searchPath:T[0].uri.with({path:p})}]:[{searchPath:m.URI.file(b.normalize(p))}]}if(this.workspaceContextService.getWorkbenchState()===2){const T=this.workspaceContextService.getWorkspace().folders[0].uri;if(p=s(p),p.startsWith("../")||p===".."){const V=b.posix.resolve(T.path,p);return[{searchPath:T.with({path:V})}]}const N=a(p);return[{searchPath:T,pattern:N}]}else{if(p==="./"||p===".\\")return[];{const T=p.replace(/^\.[\/\\]/,""),V=this.workspaceContextService.getWorkspace().folders.map(B=>{const D=T.match(new RegExp(`^${O.escapeRegExpCharacters(B.name)}(?:/(.*)|$)`));return D?{match:D,folder:B}:null}).filter(E.isDefined);if(V.length)return V.map(B=>{const D=B.match[1];return{searchPath:B.folder.uri,pattern:D&&a(D)}});{const B=p.match(/\.[\/\\](.+)[\/\\]?/),D=B?B[1]:p,z=f.localize(0,null,D);throw new Error(z)}}}}resolveOneSearchPathPattern(p,T){const N=p.pattern&&T?`${p.pattern}/${T}`:p.pattern||T,V=[{searchPath:p.searchPath,pattern:N}];return N&&!N.endsWith("**")&&V.push({searchPath:p.searchPath,pattern:N+"/**"}),V}getFolderQueryForSearchPath(p,T,N){const V=this.getFolderQueryForRoot((0,h.toWorkspaceFolder)(p.searchPath),T,N,!1);return V?{...V,includePattern:p.pattern}:null}getFolderQueryForRoot(p,T,N,V){let B;const D=m.URI.isUri(p)?p:p.uri;if(N.searchPaths){const W=N.searchPaths.filter($=>(0,P.isEqual)($.searchPath,D))[0];if(W&&!W.pattern)return null;W&&(B=W.pattern)}const z=this.configurationService.getValue({resource:D}),R={...this.getExcludesForFolder(z,T)||{},...B||{}},K=m.URI.isUri(p)?(0,P.basename)(p):p.name;return{folder:D,folderName:V?K:void 0,excludePattern:Object.keys(R).length>0?R:void 0,fileEncoding:z.files&&z.files.encoding,disregardIgnoreFiles:typeof T.disregardIgnoreFiles=="boolean"?T.disregardIgnoreFiles:!z.search.useIgnoreFiles,disregardGlobalIgnoreFiles:typeof T.disregardGlobalIgnoreFiles=="boolean"?T.disregardGlobalIgnoreFiles:!z.search.useGlobalIgnoreFiles,disregardParentIgnoreFiles:typeof T.disregardParentIgnoreFiles=="boolean"?T.disregardParentIgnoreFiles:!z.search.useParentIgnoreFiles,ignoreSymlinks:typeof T.ignoreSymlinks=="boolean"?T.ignoreSymlinks:!z.search.followSymlinks}}};w=ze([$e(0,c.IConfigurationService),$e(1,h.IWorkspaceContextService),$e(2,g.IEditorGroupsService),$e(3,d.ILogService),$e(4,C.IPathService)],w),e.QueryBuilder=w;function t(v){const p=v.match(/[\*\{\}\(\)\[\]\?]/);if(p){const T=p.index,N=v.substr(0,T).match(/[/|\\][^/\\]*$/);if(N){let V=v.substr(0,N.index);return V.match(/[/\\]/)||(V+="/"),{pathPortion:V,globPortion:v.substr((N.index||0)+1)}}}return{pathPortion:v}}function u(...v){return v.length?v.reduce((p,T)=>(p[T]=!0,p),Object.create(null)):void 0}function i(v){return S.splitGlobAware(v,",").map(p=>p.trim()).filter(p=>!!p.length)}function n(v){return[`**/${v}/**`,`**/${v}`].map(T=>T.replace(/\*\*\/\*\*/g,"**"))}function s(v){return v.replace(/\\/g,"/")}function a(v){return s(v).replace(/^\.\//,"").replace(/\/+$/g,"")}function o(v,p){v=r.distinct(v,V=>V.toString());const T=[],N=p.getWorkspace();return v&&v.forEach(V=>{let B;if(p.getWorkbenchState()===2)B=(0,P.relativePath)(N.folders[0].uri,V),B&&B!=="."&&(B="./"+B);else{const D=p.getWorkspaceFolder(V);if(D){const z=D.name;if(N.folders.filter(R=>R.name===z).length===1){const R=(0,P.relativePath)(D.uri,V);R===""?B=`./${D.name}`:B=`./${D.name}/${R}`}else B=V.fsPath}}B&&T.push(B)}),T}e.resolveResourcesForSearchIncludes=o}),define(Ce[230],Ie([1,0,22,2,20,12,3,229,41,45]),function(ie,e,r,y,S,M,_,A,b,P){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.checkGlobFileExists=e.checkActivateWorkspaceContainsExtension=void 0;const O=7e3;function E(c,d){const h=d.activationEvents;if(!h)return Promise.resolve(void 0);const g=[],C=[];for(const n of h)if(/^workspaceContains:/.test(n)){const s=n.substr(18);s.indexOf("*")>=0||s.indexOf("?")>=0||c.forceUsingSearch?C.push(s):g.push(s)}if(g.length===0&&C.length===0)return Promise.resolve(void 0);let l;const w=new Promise((n,s)=>{l=n}),t=n=>l({activationEvent:n}),u=Promise.all(g.map(n=>m(c,n,t))).then(()=>{}),i=k(c,d.identifier,C,t);return Promise.all([u,i]).then(()=>{l(void 0)}),w}e.checkActivateWorkspaceContainsExtension=E;async function m(c,d,h){for(const g of c.folders)if(await c.exists(r.joinPath(y.URI.revive(g),d))){h(`workspaceContains:${d}`);return}}async function k(c,d,h,g){if(h.length===0)return Promise.resolve(void 0);const C=new S.CancellationTokenSource,l=c.checkExists(c.folders,h,C.token),w=setTimeout(async()=>{C.cancel(),c.logService.info(`Not activating extension '${d.value}': Timed out while searching for 'workspaceContains' pattern ${h.join(",")}`)},O);let t=!1;try{t=await l}catch(u){M.isCancellationError(u)||M.onUnexpectedError(u)}C.dispose(),clearTimeout(w),t&&g(`workspaceContains:${h.join(",")}`)}function f(c,d,h,g){const C=c.get(_.IInstantiationService),l=c.get(b.ISearchService),t=C.createInstance(A.QueryBuilder).file(d.map(u=>(0,P.toWorkspaceFolder)(y.URI.revive(u))),{_reason:"checkExists",includePattern:h,exists:!0});return l.fileSearch(t,g).then(u=>!!u.limitHit,u=>M.isCancellationError(u)?!1:Promise.reject(u))}e.checkGlobFileExists=f});var Je=this&&this.__classPrivateFieldSet||function(ie,e,r,y,S){if(y==="m")throw new TypeError("Private method is not writable");if(y==="a"&&!S)throw new TypeError("Private accessor was defined without a setter");if(typeof e=="function"?ie!==e||!S:!e.has(ie))throw new TypeError("Cannot write private member to an object whose class did not declare it");return y==="a"?S.call(ie,r):S?S.value=r:e.set(ie,r),r},Oe=this&&this.__classPrivateFieldGet||function(ie,e,r,y){if(r==="a"&&!y)throw new TypeError("Private accessor was defined without a getter");if(typeof e=="function"?ie!==e||!y:!e.has(ie))throw new TypeError("Cannot read private member from an object whose class did not declare it");return r==="m"?y:r==="a"?y.call(ie):y?y.value:e.get(ie)};define(Ce[33],Ie([1,0,131,19,72,22,15,7,24,2,14,4,32,174,70,31,25,173,12,27,23,158,6,86,3,28,71,11,58,62,53,5,230,69,160,13,68]),function(ie,e,r,y,S,M,_,A,b,P,O,E,m,k,f,c,d,h,g,C,l,w,t,u,i,n,s,a,o,v,p,T,N,V,B,D,z){"use strict";var L,R,K;Object.defineProperty(e,"__esModule",{value:!0}),e.ExtensionPaths=e.Extension=e.IExtHostExtensionService=e.AbstractExtHostExtensionService=e.IHostUtils=void 0,e.IHostUtils=(0,i.createDecorator)("IHostUtils");let W=class Ri extends A.Disposable{constructor(ce,me,ee,be,_e,Fe,Be,Xe,ke,ye,De){super(),this._onDidChangeRemoteConnectionData=this._register(new T.Emitter),this.onDidChangeRemoteConnectionData=this._onDidChangeRemoteConnectionData.event,this._isTerminating=!1,this._hostUtils=me,this._extHostContext=ee,this._initData=Be,this._extHostWorkspace=be,this._extHostConfiguration=_e,this._logService=Fe,this._extHostTunnelService=ke,this._extHostTerminalService=ye,this._extHostLocalizationService=De,this._mainThreadWorkspaceProxy=this._extHostContext.getProxy(E.MainContext.MainThreadWorkspace),this._mainThreadTelemetryProxy=this._extHostContext.getProxy(E.MainContext.MainThreadTelemetry),this._mainThreadExtensionsProxy=this._extHostContext.getProxy(E.MainContext.MainThreadExtensionService),this._almostReadyToRunExtensions=new _.Barrier,this._readyToStartExtensionHost=new _.Barrier,this._readyToRunExtensions=new _.Barrier,this._eagerExtensionsActivated=new _.Barrier,this._globalRegistry=new h.ExtensionDescriptionRegistry(this._initData.allExtensions);const ae=(0,d.extensionIdentifiersArrayToSet)(this._initData.myExtensions);this._myRegistry=new h.ExtensionDescriptionRegistry(ne(this._globalRegistry,ae)),this._storage=new f.ExtHostStorage(this._extHostContext),this._secretState=new V.ExtHostSecretState(this._extHostContext),this._storagePath=Xe,this._instaService=ce.createChild(new o.ServiceCollection([f.IExtHostStorage,this._storage],[V.IExtHostSecretState,this._secretState]));let ue=[],Z=[];this._initData.remote.isRemote&&(ue=this._initData.allExtensions.filter(I=>!I.main&&!I.browser).map(I=>I.identifier),Z=this._initData.allExtensions.filter(I=>!ae.has(C.ExtensionIdentifier.toKey(I.identifier.value))).filter(I=>(I.main||I.browser)&&I.api==="none").map(I=>I.identifier));const J=(0,d.extensionIdentifiersArrayToSet)(Z);this._activator=this._register(new k.ExtensionsActivator(this._myRegistry,ue,Z,{onExtensionActivationError:(I,U,H)=>{this._mainThreadExtensionsProxy.$onExtensionActivationError(I,g.transformErrorForSerialization(U),H)},actualActivateExtension:async(I,U)=>{if(J.has(C.ExtensionIdentifier.toKey(I)))return await this._mainThreadExtensionsProxy.$activateExtension(I,U),new k.HostExtension;const H=this._myRegistry.getExtensionDescription(I);return this._activateExtension(H,U)}},this._logService)),this._extensionPathIndex=null,this._resolvers=Object.create(null),this._started=!1,this._remoteConnectionData=this._initData.remote.connectionData}getRemoteConnectionData(){return this._remoteConnectionData}async initialize(){try{await this._beforeAlmostReadyToRunExtensions(),this._almostReadyToRunExtensions.open(),await this._extHostWorkspace.waitForInitializeCall(),S.mark("code/extHost/ready"),this._readyToStartExtensionHost.open(),this._initData.autoStart&&this._startExtensionHost()}catch(ce){g.onUnexpectedError(ce)}}async _deactivateAll(){this._storagePath.onWillDeactivateAll();let ce=[];try{ce=this._myRegistry.getAllExtensionDescriptions().map(_e=>_e.identifier).filter(_e=>this.isActivated(_e)).map(_e=>this._deactivate(_e))}catch{}await Promise.all(ce)}terminate(ce,me=0){if(this._isTerminating)return;this._isTerminating=!0,this._logService.info(`Extension host terminating: ${ce}`),this._logService.flush(),this._extHostTerminalService.dispose(),this._activator.dispose(),g.setUnexpectedErrorHandler(be=>{this._logService.error(be)}),this._extHostContext.dispose();const ee=this._deactivateAll();Promise.race([(0,_.timeout)(5e3),ee]).finally(()=>{this._hostUtils.pid?this._logService.info(`Extension host with pid ${this._hostUtils.pid} exiting with code ${me}`):this._logService.info(`Extension host exiting with code ${me}`),this._logService.flush(),this._logService.dispose(),this._hostUtils.exit(me)})}isActivated(ce){return this._readyToRunExtensions.isOpen()?this._activator.isActivated(ce):!1}async getExtension(ce){const me=await this._mainThreadExtensionsProxy.$getExtension(ce);let ee;if(me?.browserNlsBundleUris){ee={};for(const be of Object.keys(me.browserNlsBundleUris))ee[be]=P.URI.revive(me.browserNlsBundleUris[be])}return me&&{...me,identifier:new C.ExtensionIdentifier(me.identifier.value),extensionLocation:P.URI.revive(me.extensionLocation),browserNlsBundleUris:ee}}_activateByEvent(ce,me){return this._activator.activateByEvent(ce,me)}_activateById(ce,me){return this._activator.activateById(ce,me)}activateByIdWithErrors(ce,me){return this._activateById(ce,me).then(()=>{const ee=this._activator.getActivatedExtension(ce);if(ee.activationFailed)return Promise.reject(ee.activationFailedError)})}getExtensionRegistry(){return this._readyToRunExtensions.wait().then(ce=>this._myRegistry)}getExtensionExports(ce){return this._readyToRunExtensions.isOpen()?this._activator.getActivatedExtension(ce).exports:null}async _realPathExtensionUri(ce){if(ce.scheme!==D.Schemas.file)return ce;const me=await this._hostUtils.realpath(ce.fsPath);return P.URI.file(me)}async getExtensionPathIndex(){return this._extensionPathIndex||(this._extensionPathIndex=this._createExtensionPathIndex(this._myRegistry.getAllExtensionDescriptions()).then(ce=>new oe(ce))),this._extensionPathIndex}async _createExtensionPathIndex(ce){const me=b.TernarySearchTree.forUris(ee=>M.extUriBiasedIgnorePathCase.ignorePathCasing(ee));return await Promise.all(ce.map(async ee=>{if(this._getEntryPoint(ee)){const be=await this._realPathExtensionUri(ee.extensionLocation);me.set(be,ee)}})),me}_deactivate(ce){let me=Promise.resolve(void 0);if(!this._readyToRunExtensions.isOpen()||!this._activator.isActivated(ce))return me;const ee=this._activator.getActivatedExtension(ce);if(!ee)return me;try{typeof ee.module.deactivate=="function"&&(me=Promise.resolve(ee.module.deactivate()).then(void 0,be=>(this._logService.error(be),Promise.resolve(void 0))))}catch(be){this._logService.error(`An error occurred when deactivating the extension '${ce.value}':`),this._logService.error(be)}try{(0,A.dispose)(ee.subscriptions)}catch(be){this._logService.error(`An error occurred when deactivating the subscriptions for extension '${ce.value}':`),this._logService.error(be)}return me}async _activateExtension(ce,me){return this._initData.remote.isRemote?this._mainThreadExtensionsProxy.$onWillActivateExtension(ce.identifier):await this._mainThreadExtensionsProxy.$onWillActivateExtension(ce.identifier),this._doActivateExtension(ce,me).then(ee=>{const be=ee.activationTimes;return this._mainThreadExtensionsProxy.$onDidActivateExtension(ce.identifier,be.codeLoadingTime,be.activateCallTime,be.activateResolvedTime,me),this._logExtensionActivationTimes(ce,me,"success",be),ee},ee=>{throw this._logExtensionActivationTimes(ce,me,"failure"),ee})}_logExtensionActivationTimes(ce,me,ee,be){const _e=$(ce,me);this._mainThreadTelemetryProxy.$publicLog2("extensionActivationTimes",{..._e,...be||{},outcome:ee})}_doActivateExtension(ce,me){const ee=$(ce,me);this._mainThreadTelemetryProxy.$publicLog2("activatePlugin",ee);const be=this._getEntryPoint(ce);if(!be)return Promise.resolve(new k.EmptyExtension(k.ExtensionActivationTimes.NONE));this._logService.info(`ExtensionService#_doActivateExtension ${ce.identifier.value}, startup: ${me.startup}, activationEvent: '${me.activationEvent}'${ce.identifier.value!==me.extensionId.value?`, root cause: ${me.extensionId.value}`:""}`),this._logService.flush();const _e=new k.ExtensionActivationTimesBuilder(me.startup);return Promise.all([this._loadCommonJSModule(ce,(0,M.joinPath)(ce.extensionLocation,be),_e),this._loadExtensionContext(ce)]).then(Fe=>(S.mark(`code/extHost/willActivateExtension/${ce.identifier.value}`),Ri._callActivate(this._logService,ce.identifier,Fe[0],Fe[1],_e))).then(Fe=>(S.mark(`code/extHost/didActivateExtension/${ce.identifier.value}`),Fe))}_loadExtensionContext(ce){const me=new w.ExtensionGlobalMemento(ce,this._storage),ee=new w.ExtensionMemento(ce.identifier.value,!1,this._storage),be=new B.ExtensionSecrets(ce,this._secretState),_e=ce.isUnderDevelopment?this._initData.environment.extensionTestsLocationURI?t.ExtensionMode.Test:t.ExtensionMode.Development:t.ExtensionMode.Production,Fe=this._initData.remote.isRemote?t.ExtensionKind.Workspace:t.ExtensionKind.UI;return this._logService.trace(`ExtensionService#loadExtensionContext ${ce.identifier.value}`),Promise.all([me.whenReady,ee.whenReady,this._storagePath.whenReady]).then(()=>{const Be=this;let Xe,ke;const ye=(0,d.isProposedApiEnabled)(ce,"ipc")?this._initData.messagePorts?.get(C.ExtensionIdentifier.toKey(ce.identifier)):void 0;return Object.freeze({globalState:me,workspaceState:ee,secrets:be,subscriptions:[],get extensionUri(){return ce.extensionLocation},get extensionPath(){return ce.extensionLocation.fsPath},asAbsolutePath(De){return y.join(ce.extensionLocation.fsPath,De)},get storagePath(){return Be._storagePath.workspaceValue(ce)?.fsPath},get globalStoragePath(){return Be._storagePath.globalValue(ce).fsPath},get logPath(){return y.join(Be._initData.logsLocation.fsPath,ce.identifier.value)},get logUri(){return P.URI.joinPath(Be._initData.logsLocation,ce.identifier.value)},get storageUri(){return Be._storagePath.workspaceValue(ce)},get globalStorageUri(){return Be._storagePath.globalValue(ce)},get extensionMode(){return _e},get extension(){return Xe===void 0&&(Xe=new G(Be,ce.identifier,ce,Fe,!1)),Xe},get extensionRuntime(){return(0,d.checkProposedApiEnabled)(ce,"extensionRuntime"),Be.extensionRuntime},get environmentVariableCollection(){return Be._extHostTerminalService.getEnvironmentVariableCollection(ce)},get messagePassingProtocol(){if(!ke){if(!ye)return;const De=T.Event.buffer(T.Event.fromDOMEventEmitter(ye,"message",ae=>ae.data));ye.start(),ke={onDidReceiveMessage:De,postMessage:ye.postMessage.bind(ye)}}return ke}})})}static _callActivate(ce,me,ee,be,_e){return ee=ee||{activate:void 0,deactivate:void 0},this._callActivateOptional(ce,me,ee,be,_e).then(Fe=>new k.ActivatedExtension(!1,null,_e.build(),ee,Fe,be.subscriptions))}static _callActivateOptional(ce,me,ee,be,_e){if(typeof ee.activate=="function")try{_e.activateCallStart(),ce.trace(`ExtensionService#_callActivateOptional ${me.value}`);const Fe=typeof global=="object"?global:self,Be=ee.activate.apply(Fe,[be]);return _e.activateCallStop(),_e.activateResolveStart(),Promise.resolve(Be).then(Xe=>(_e.activateResolveStop(),Xe))}catch(Fe){return Promise.reject(Fe)}else return Promise.resolve(ee)}_activateOneStartupFinished(ce,me){this._activateById(ce.identifier,{startup:!1,extensionId:ce.identifier,activationEvent:me}).then(void 0,ee=>{this._logService.error(ee)})}_activateAllStartupFinished(){this._mainThreadExtensionsProxy.$setPerformanceMarks(S.getMarks());for(const ce of this._myRegistry.getAllExtensionDescriptions())if(ce.activationEvents)for(const me of ce.activationEvents)me==="onStartupFinished"&&this._activateOneStartupFinished(ce,me)}_handleEagerExtensions(){const ce=this._activateByEvent("*",!0).then(void 0,_e=>{this._logService.error(_e)});this._register(this._extHostWorkspace.onDidChangeWorkspace(_e=>this._handleWorkspaceContainsEagerExtensions(_e.added)));const me=this._extHostWorkspace.workspace?this._extHostWorkspace.workspace.folders:[],ee=this._handleWorkspaceContainsEagerExtensions(me),be=Promise.all([ce,ee]).then(()=>{});return Promise.race([be,(0,_.timeout)(1e4)]).then(()=>{this._activateAllStartupFinished()}),be}_handleWorkspaceContainsEagerExtensions(ce){return ce.length===0?Promise.resolve(void 0):Promise.all(this._myRegistry.getAllExtensionDescriptions().map(me=>this._handleWorkspaceContainsEagerExtension(ce,me))).then(()=>{})}async _handleWorkspaceContainsEagerExtension(ce,me){if(this.isActivated(me.identifier))return;const ee=!this._initData.remote.isRemote&&!!this._initData.remote.authority,be={logService:this._logService,folders:ce.map(Fe=>Fe.uri),forceUsingSearch:ee,exists:Fe=>this._hostUtils.exists(Fe.fsPath),checkExists:(Fe,Be,Xe)=>this._mainThreadWorkspaceProxy.$checkExists(Fe,Be,Xe)},_e=await(0,N.checkActivateWorkspaceContainsExtension)(be,me);if(!!_e)return this._activateById(me.identifier,{startup:!0,extensionId:me.identifier,activationEvent:_e.activationEvent}).then(void 0,Fe=>this._logService.error(Fe))}async $extensionTestsExecute(){await this._eagerExtensionsActivated.wait();try{return await this._doHandleExtensionTests()}catch(ce){throw console.error(ce),ce}}async _doHandleExtensionTests(){const{extensionDevelopmentLocationURI:ce,extensionTestsLocationURI:me}=this._initData.environment;if(!ce||!me)throw new Error(r.localize(0,null));const ee=await this._loadCommonJSModule(null,me,new k.ExtensionActivationTimesBuilder(!1));if(!ee||typeof ee.run!="function")throw new Error(r.localize(1,null,me.toString()));return new Promise((be,_e)=>{const Fe=(ke,ye)=>{ke?_e(ke):be(typeof ye=="number"&&ye>0?1:0)},Be=(0,M.originalFSPath)(me),Xe=ee.run(Be,Fe);Xe&&Xe.then&&Xe.then(()=>{be(0)}).catch(ke=>{_e(ke instanceof Error&&ke.stack?ke.stack:String(ke))})})}_startExtensionHost(){if(this._started)throw new Error("Extension host is already started!");return this._started=!0,this._readyToStartExtensionHost.wait().then(()=>this._readyToRunExtensions.open()).then(()=>this._handleEagerExtensions()).then(()=>{this._eagerExtensionsActivated.open(),this._logService.info("Eager extensions activated")})}registerRemoteAuthorityResolver(ce,me){return this._resolvers[ce]=me,(0,A.toDisposable)(()=>{delete this._resolvers[ce]})}async _activateAndGetResolver(ce){const me=ce.indexOf("+");if(me===-1)throw new Error("Not an authority that can be resolved!");const ee=ce.substr(0,me);return await this._almostReadyToRunExtensions.wait(),await this._activateByEvent(`onResolveRemoteAuthority:${ee}`,!1),{authorityPrefix:ee,resolver:this._resolvers[ee]}}async $resolveAuthority(ce,me){this._logService.info(`$resolveAuthority invoked for authority (${ge(ce)})`);const{authorityPrefix:ee,resolver:be}=await this._activateAndGetResolver(ce);if(!be)return{type:"error",error:{code:u.RemoteAuthorityResolverErrorCode.NoResolverFound,message:`No remote extension installed to resolve ${ee}.`,detail:void 0}};try{this._register(await this._extHostTunnelService.setTunnelFactory(be)),S.mark(`code/extHost/willResolveAuthority/${ee}`);const _e=await be.resolve(ce,{resolveAttempt:me});S.mark(`code/extHost/didResolveAuthorityOK/${ee}`);const Fe={authority:ce,host:_e.host,port:_e.port,connectionToken:_e.connectionToken},Be={extensionHostEnv:_e.extensionHostEnv,isTrusted:_e.isTrusted,authenticationSession:_e.authenticationSessionForInitializingExtensions?{id:_e.authenticationSessionForInitializingExtensions.id,providerId:_e.authenticationSessionForInitializingExtensions.providerId}:void 0};return{type:"ok",value:{authority:Fe,options:Be,tunnelInformation:{environmentTunnels:_e.environmentTunnels,features:_e.tunnelFeatures}}}}catch(_e){if(S.mark(`code/extHost/didResolveAuthorityError/${ee}`),_e instanceof t.RemoteAuthorityResolverError)return{type:"error",error:{code:_e._code,message:_e._message,detail:_e._detail}};throw _e}}async $getCanonicalURI(ce,me){this._logService.info(`$getCanonicalURI invoked for authority (${ge(ce)})`);const{resolver:ee}=await this._activateAndGetResolver(ce);if(!ee)return null;const be=P.URI.revive(me);if(typeof ee.getCanonicalURI>"u")return be;const _e=await(0,_.asPromise)(()=>ee.getCanonicalURI(be));return _e||be}static _applyExtensionsDelta(ce,me,ee){const be=new h.ExtensionDescriptionRegistry(ce.getAllExtensionDescriptions());be.deltaExtensions(ee.toAdd,ee.toRemove);const _e=(0,d.extensionIdentifiersArrayToSet)(me.getAllExtensionDescriptions().map(Be=>Be.identifier));for(const Be of ee.myToRemove)_e.delete(C.ExtensionIdentifier.toKey(Be));for(const Be of ee.myToAdd)_e.add(C.ExtensionIdentifier.toKey(Be));const Fe=ne(be,_e);return{globalRegistry:be,myExtensions:Fe}}$startExtensionHost(ce){ce.toAdd.forEach(be=>be.extensionLocation=P.URI.revive(be.extensionLocation));const{globalRegistry:me,myExtensions:ee}=Ri._applyExtensionsDelta(this._globalRegistry,this._myRegistry,ce);return this._globalRegistry.set(me.getAllExtensionDescriptions()),this._myRegistry.set(ee),this._startExtensionHost()}$activateByEvent(ce,me){return me===1?this._activateByEvent(ce,!1):this._readyToRunExtensions.wait().then(ee=>this._activateByEvent(ce,!1))}async $activate(ce,me){return await this._readyToRunExtensions.wait(),this._myRegistry.getExtensionDescription(ce)?(await this._activateById(ce,me),!0):!1}async $deltaExtensions(ce){ce.toAdd.forEach(Fe=>Fe.extensionLocation=P.URI.revive(Fe.extensionLocation));const{globalRegistry:me,myExtensions:ee}=Ri._applyExtensionsDelta(this._globalRegistry,this._myRegistry,ce),be=await this._createExtensionPathIndex(ee);return(await this.getExtensionPathIndex()).setSearchTree(be),this._globalRegistry.set(me.getAllExtensionDescriptions()),this._myRegistry.set(ee),Promise.resolve(void 0)}async $test_latency(ce){return ce}async $test_up(ce){return ce.byteLength}async $test_down(ce){const me=l.VSBuffer.alloc(ce),ee=Math.random()%256;for(let be=0;be<ce;be++)me.writeUInt8(ee,be);return me}async $updateRemoteConnectionData(ce){this._remoteConnectionData=ce,this._onDidChangeRemoteConnectionData.fire()}};W=ze([$e(0,i.IInstantiationService),$e(1,e.IHostUtils),$e(2,a.IExtHostRpcService),$e(3,c.IExtHostWorkspace),$e(4,m.IExtHostConfiguration),$e(5,O.ILogService),$e(6,n.IExtHostInitDataService),$e(7,s.IExtensionStoragePaths),$e(8,v.IExtHostTunnelService),$e(9,p.IExtHostTerminalService),$e(10,z.IExtHostLocalizationService)],W),e.AbstractExtHostExtensionService=W;function $(Ee,ce){return{id:Ee.identifier.value,name:Ee.name,extensionVersion:Ee.version,publisherDisplayName:Ee.publisher,activationEvents:Ee.activationEvents?Ee.activationEvents.join(","):null,isBuiltin:Ee.isBuiltin,reason:ce.activationEvent,reasonId:ce.extensionId.value}}e.IExtHostExtensionService=(0,i.createDecorator)("IExtHostExtensionService");class G{constructor(ce,me,ee,be,_e){L.set(this,void 0),R.set(this,void 0),K.set(this,void 0),Je(this,L,ce,"f"),Je(this,R,me,"f"),Je(this,K,ee.identifier,"f"),this.id=ee.identifier.value,this.extensionUri=ee.extensionLocation,this.extensionPath=y.normalize((0,M.originalFSPath)(ee.extensionLocation)),this.packageJSON=ee,this.extensionKind=be,this.isFromDifferentExtensionHost=_e}get isActive(){return Oe(this,L,"f").isActivated(Oe(this,K,"f"))}get exports(){if(!(this.packageJSON.api==="none"||this.isFromDifferentExtensionHost))return Oe(this,L,"f").getExtensionExports(Oe(this,K,"f"))}async activate(){if(this.isFromDifferentExtensionHost)throw new Error("Cannot activate foreign extension");return await Oe(this,L,"f").activateByIdWithErrors(Oe(this,K,"f"),{startup:!1,extensionId:Oe(this,R,"f"),activationEvent:"api"}),this.exports}}e.Extension=G,L=new WeakMap,R=new WeakMap,K=new WeakMap;function ne(Ee,ce){return Ee.getAllExtensionDescriptions().filter(me=>ce.has(C.ExtensionIdentifier.toKey(me.identifier)))}function ge(Ee){const ce=Ee.indexOf("+");return ce===-1?Ee:Ee.substring(0,ce)}class oe{constructor(ce){this._searchTree=ce}setSearchTree(ce){this._searchTree=ce}findSubstr(ce){return this._searchTree.findSubstr(ce)}forEach(ce){return this._searchTree.forEach(ce)}}e.ExtensionPaths=oe}),define(Ce[231],Ie([1,0,72,2,4,32,25,27,11,28,3,33,59,14,9]),function(ie,e,r,y,S,M,_,A,b,P,O,E,m,k,f){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.RequireInterceptor=void 0;let c=class{constructor(w,t,u,i,n,s,a){this._apiFactory=w,this._extensionRegistry=t,this._instaService=u,this._extHostConfiguration=i,this._extHostExtensionService=n,this._initData=s,this._logService=a,this._factories=new Map,this._alternatives=[]}async install(){this._installInterceptor(),r.mark("code/extHost/willWaitForConfig");const w=await this._extHostConfiguration.getConfigProvider();r.mark("code/extHost/didWaitForConfig");const t=await this._extHostExtensionService.getExtensionPathIndex();this.register(new h(this._apiFactory,t,this._extensionRegistry,w,this._logService)),this.register(this._instaService.createInstance(g,t)),this.register(this._instaService.createInstance(d)),this._initData.remote.isRemote&&this.register(this._instaService.createInstance(C,t,this._initData.environment.appUriScheme))}register(w){if("nodeModuleName"in w)if(Array.isArray(w.nodeModuleName))for(const t of w.nodeModuleName)this._factories.set(t,w);else this._factories.set(w.nodeModuleName,w);typeof w.alternativeModuleName=="function"&&this._alternatives.push(t=>w.alternativeModuleName(t))}};c=ze([$e(2,O.IInstantiationService),$e(3,M.IExtHostConfiguration),$e(4,E.IExtHostExtensionService),$e(5,P.IExtHostInitDataService),$e(6,k.ILogService)],c),e.RequireInterceptor=c;let d=class Ji{constructor(w){if(w.environment.appRoot&&Ji.aliased.size){const t=(0,f.escapeRegExpCharacters)(this.forceForwardSlashes(w.environment.appRoot.fsPath)),u="[a-z0-9_.-]",i=`@${u}+\\/${u}+|${u}+`,n="node_modules|node_modules\\.asar(?:\\.unpacked)?";this.re=new RegExp(`^(${t}/${n}\\/)(${i})(.*)$`,"i")}}alternativeModuleName(w){if(!this.re)return;const t=this.re.exec(this.forceForwardSlashes(w));if(!t)return;const[,u,i,n]=t,s=Ji.aliased.get(i);if(s!==void 0)return console.warn(`${i} as been renamed to ${s}, please update your imports`),u+s+n}forceForwardSlashes(w){return w.replace(/\\/g,"/")}};d.aliased=new Map([["vscode-ripgrep","@vscode/ripgrep"],["vscode-windows-registry","@vscode/windows-registry"]]),d=ze([$e(0,P.IExtHostInitDataService)],d);class h{constructor(w,t,u,i,n){this._apiFactory=w,this._extensionPaths=t,this._extensionRegistry=u,this._configProvider=i,this._logService=n,this.nodeModuleName="vscode",this._extApiImpl=new Map}load(w,t){const u=this._extensionPaths.findSubstr(t);if(u){let i=this._extApiImpl.get(A.ExtensionIdentifier.toKey(u.identifier));return i||(i=this._apiFactory(u,this._extensionRegistry,this._configProvider),this._extApiImpl.set(A.ExtensionIdentifier.toKey(u.identifier),i)),i}if(!this._defaultApiImpl){let i="";this._extensionPaths.forEach((n,s)=>i+=`	${s} -> ${n.identifier.value}
`),this._logService.warn(`Could not identify extension for 'vscode' require call from ${t}. These are the extension path mappings: 
${i}`),this._defaultApiImpl=this._apiFactory(_.nullExtensionDescription,this._extensionRegistry,this._configProvider)}return this._defaultApiImpl}}let g=class{constructor(w,t,u){this._extensionPaths=w,this.nodeModuleName="keytar",this._mainThreadTelemetry=t.getProxy(S.MainContext.MainThreadTelemetry);const{environment:i}=u,n=t.getProxy(S.MainContext.MainThreadKeytar);if(i.appRoot){let s=i.appRoot.fsPath;m.platform==="win32"&&(s=s.replace(/\\/g,"/")),s[s.length-1]==="/"&&(s=s.substr(0,s.length-1)),this.alternativeNames=new Set,this.alternativeNames.add(`${s}/node_modules.asar/keytar`),this.alternativeNames.add(`${s}/node_modules/keytar`)}this._impl={getPassword:(s,a)=>n.$getPassword(s,a),setPassword:(s,a,o)=>n.$setPassword(s,a,o),deletePassword:(s,a)=>n.$deletePassword(s,a),findPassword:s=>n.$findPassword(s),findCredentials(s){return n.$findCredentials(s)}}}load(w,t){const u=this._extensionPaths.findSubstr(t);return this._mainThreadTelemetry.$publicLog2("shimming.keytar",{extension:u?.identifier.value??"unknown_extension"}),this._impl}alternativeModuleName(w){const t=w.length;if(t<=7||!this.alternativeNames)return;const u=t-7;if((w.charAt(u)==="/"||w.charAt(u)==="\\")&&w.endsWith("keytar")&&(w=w.replace(/\\/g,"/"),this.alternativeNames.has(w)))return"keytar"}};g=ze([$e(1,b.IExtHostRpcService),$e(2,P.IExtHostInitDataService)],g);let C=class{constructor(w,t,u){this._extensionPaths=w,this._appUriScheme=t,this.nodeModuleName=["open","opn"],this._mainThreadTelemetry=u.getProxy(S.MainContext.MainThreadTelemetry);const i=u.getProxy(S.MainContext.MainThreadWindow);this._impl=(n,s)=>{const a=y.URI.parse(n);return s?this.callOriginal(n,s):a.scheme==="http"||a.scheme==="https"?i.$openUri(a,n,{allowTunneling:!0}):a.scheme==="mailto"||a.scheme===this._appUriScheme?i.$openUri(a,n,{}):this.callOriginal(n,s)}}load(w,t,u){const i=this._extensionPaths.findSubstr(t);return i&&(this._extensionId=i.identifier.value,this.sendShimmingTelemetry()),this._original=u(w),this._impl}callOriginal(w,t){return this.sendNoForwardTelemetry(),this._original(w,t)}sendShimmingTelemetry(){!this._extensionId||this._mainThreadTelemetry.$publicLog2("shimming.open",{extension:this._extensionId})}sendNoForwardTelemetry(){!this._extensionId||this._mainThreadTelemetry.$publicLog2("shimming.open.call.noForward",{extension:this._extensionId})}};C=ze([$e(2,b.IExtHostRpcService)],C)}),define(Ce[103],Ie([1,0,197,7,19,59,3,50,51,33,6,31,170,32]),function(ie,e,r,y,S,M,_,A,b,P,O,E,m,k){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtHostVariableResolverProviderService=e.IExtHostVariableResolverProvider=void 0,e.IExtHostVariableResolverProvider=(0,_.createDecorator)("IExtHostVariableResolverProvider");class f extends m.AbstractVariableResolverService{constructor(h,g,C,l,w,t,u){function i(){if(C){const n=C.activeEditor();if(n)return n.document.uri;const s=l.tabGroups.all.find(a=>a.isActive)?.activeTab;if(s!==void 0){if(s.input instanceof O.TextDiffTabInput||s.input instanceof O.NotebookDiffEditorTabInput)return s.input.modified;if(s.input instanceof O.TextTabInput||s.input instanceof O.NotebookEditorTabInput||s.input instanceof O.CustomEditorTabInput)return s.input.uri}}}super({getFolderUri:n=>{const s=t.folders.filter(a=>a.name===n);if(s&&s.length>0)return s[0].uri},getWorkspaceFolderCount:()=>t.folders.length,getConfigurationValue:(n,s)=>w.getConfiguration(void 0,n).get(s),getAppRoot:()=>M.cwd(),getExecPath:()=>M.env.VSCODE_EXEC_PATH,getFilePath:()=>{const n=i();if(n)return S.normalize(n.fsPath)},getWorkspaceFolderPathForFile:()=>{if(g){const n=i();if(n){const s=g.getWorkspaceFolder(n);if(s)return S.normalize(s.uri.fsPath)}}},getSelectedText:()=>{if(C){const n=C.activeEditor();if(n&&!n.selection.isEmpty)return n.document.getText(n.selection)}},getLineNumber:()=>{if(C){const n=C.activeEditor();if(n)return String(n.selection.end.line+1)}},getExtension:n=>h.getExtension(n)},void 0,u?Promise.resolve(u):void 0,Promise.resolve(M.env))}}let c=class extends y.Disposable{constructor(h,g,C,l,w){super(),this.extensionService=h,this.workspaceService=g,this.editorService=C,this.configurationService=l,this.editorTabs=w,this._resolver=new r.Lazy(async()=>{const t=await this.configurationService.getConfigProvider(),i={folders:await this.workspaceService.getWorkspaceFolders2()||[]};return this._register(this.workspaceService.onDidChangeWorkspace(async n=>{i.folders=await this.workspaceService.getWorkspaceFolders2()||[]})),new f(this.extensionService,this.workspaceService,this.editorService,this.editorTabs,t,i,this.homeDir())})}getResolver(){return this._resolver.getValue()}homeDir(){}};c=ze([$e(0,P.IExtHostExtensionService),$e(1,E.IExtHostWorkspace),$e(2,A.IExtHostDocumentsAndEditors),$e(3,k.IExtHostConfiguration),$e(4,b.IExtHostEditorTabs)],c),e.ExtHostVariableResolverProviderService=c}),define(Ce[104],Ie([1,0,15,5,10,2,3,4,51,33,11,6,31,163,165,32,103]),function(ie,e,r,y,S,M,_,A,b,P,O,E,m,k,f,c,d){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.WorkerExtHostDebugService=e.ExtHostDebugConsole=e.ExtHostDebugSession=e.ExtHostDebugServiceBase=e.IExtHostDebugService=void 0,e.IExtHostDebugService=(0,_.createDecorator)("IExtHostDebugService");let h=class{get onDidStartDebugSession(){return this._onDidStartDebugSession.event}get onDidTerminateDebugSession(){return this._onDidTerminateDebugSession.event}get onDidChangeActiveDebugSession(){return this._onDidChangeActiveDebugSession.event}get activeDebugSession(){return this._activeDebugSession}get onDidReceiveDebugSessionCustomEvent(){return this._onDidReceiveDebugSessionCustomEvent.event}get activeDebugConsole(){return this._activeDebugConsole.value}constructor(i,n,s,a,o,v){this._workspaceService=n,this._extensionService=s,this._configurationService=a,this._editorTabs=o,this._variableResolver=v,this._debugSessions=new Map,this._configProviderHandleCounter=0,this._configProviders=[],this._adapterFactoryHandleCounter=0,this._adapterFactories=[],this._trackerFactoryHandleCounter=0,this._trackerFactories=[],this._debugAdapters=new Map,this._debugAdaptersTrackers=new Map,this._onDidStartDebugSession=new y.Emitter,this._onDidTerminateDebugSession=new y.Emitter,this._onDidChangeActiveDebugSession=new y.Emitter,this._onDidReceiveDebugSessionCustomEvent=new y.Emitter,this._debugServiceProxy=i.getProxy(A.MainContext.MainThreadDebugService),this._onDidChangeBreakpoints=new y.Emitter({onFirstListenerAdd:()=>{this.startBreakpoints()}}),this._activeDebugConsole=new C(this._debugServiceProxy),this._breakpoints=new Map,this._breakpointEventsActive=!1,this._extensionService.getExtensionRegistry().then(p=>{p.onDidChange(T=>{this.registerAllDebugTypes(p)}),this.registerAllDebugTypes(p)})}asDebugSourceUri(i,n){const s=i;if(typeof s.sourceReference=="number"&&s.sourceReference>0){let a=`debug:${encodeURIComponent(s.path||"")}`,o="?";return n&&(a+=`${o}session=${encodeURIComponent(n.id)}`,o="&"),a+=`${o}ref=${s.sourceReference}`,M.URI.parse(a)}else{if(s.path)return M.URI.file(s.path);throw new Error("cannot create uri from DAP 'source' object; properties 'path' and 'sourceReference' are both missing.")}}registerAllDebugTypes(i){const n=[];for(const s of i.getAllExtensionDescriptions())if(s.contributes){const a=s.contributes.debuggers;if(a&&a.length>0)for(const o of a)(0,f.isDebuggerMainContribution)(o)&&n.push(o.type)}this._debugServiceProxy.$registerDebugTypes(n)}get onDidChangeBreakpoints(){return this._onDidChangeBreakpoints.event}get breakpoints(){this.startBreakpoints();const i=[];return this._breakpoints.forEach(n=>i.push(n)),i}addBreakpoints(i){this.startBreakpoints();const n=i.filter(o=>{const v=o.id;return this._breakpoints.has(v)?!1:(this._breakpoints.set(v,o),!0)});this.fireBreakpointChanges(n,[],[]);const s=[],a=new Map;for(const o of n)if(o instanceof E.SourceBreakpoint){let v=a.get(o.location.uri.toString());v||(v={type:"sourceMulti",uri:o.location.uri,lines:[]},a.set(o.location.uri.toString(),v),s.push(v)),v.lines.push({id:o.id,enabled:o.enabled,condition:o.condition,hitCondition:o.hitCondition,logMessage:o.logMessage,line:o.location.range.start.line,character:o.location.range.start.character})}else o instanceof E.FunctionBreakpoint&&s.push({type:"function",id:o.id,enabled:o.enabled,hitCondition:o.hitCondition,logMessage:o.logMessage,condition:o.condition,functionName:o.functionName});return this._debugServiceProxy.$registerBreakpoints(s)}removeBreakpoints(i){this.startBreakpoints();const n=i.filter(v=>this._breakpoints.delete(v.id));this.fireBreakpointChanges([],n,[]);const s=n.filter(v=>v instanceof E.SourceBreakpoint).map(v=>v.id),a=n.filter(v=>v instanceof E.FunctionBreakpoint).map(v=>v.id),o=n.filter(v=>v instanceof E.DataBreakpoint).map(v=>v.id);return this._debugServiceProxy.$unregisterBreakpoints(s,a,o)}startDebugging(i,n,s){return this._debugServiceProxy.$startDebugging(i?i.uri:void 0,n,{parentSessionID:s.parentSession?s.parentSession.id:void 0,lifecycleManagedByParent:s.lifecycleManagedByParent,repl:s.consoleMode===E.DebugConsoleMode.MergeWithParent?"mergeWithParent":"separate",noDebug:s.noDebug,compact:s.compact,debugUI:s.debugUI,suppressSaveBeforeStart:s.suppressSaveBeforeStart})}stopDebugging(i){return this._debugServiceProxy.$stopDebugging(i?i.id:void 0)}registerDebugConfigurationProvider(i,n,s){if(!n)return new E.Disposable(()=>{});const a=this._configProviderHandleCounter++;return this._configProviders.push({type:i,handle:a,provider:n}),this._debugServiceProxy.$registerDebugConfigurationProvider(i,s,!!n.provideDebugConfigurations,!!n.resolveDebugConfiguration,!!n.resolveDebugConfigurationWithSubstitutedVariables,a),new E.Disposable(()=>{this._configProviders=this._configProviders.filter(o=>o.provider!==n),this._debugServiceProxy.$unregisterDebugConfigurationProvider(a)})}registerDebugAdapterDescriptorFactory(i,n,s){if(!s)return new E.Disposable(()=>{});if(!this.definesDebugType(i,n))throw new Error(`a DebugAdapterDescriptorFactory can only be registered from the extension that defines the '${n}' debugger.`);if(this.getAdapterDescriptorFactoryByType(n))throw new Error("a DebugAdapterDescriptorFactory can only be registered once per a type.");const a=this._adapterFactoryHandleCounter++;return this._adapterFactories.push({type:n,handle:a,factory:s}),this._debugServiceProxy.$registerDebugAdapterDescriptorFactory(n,a),new E.Disposable(()=>{this._adapterFactories=this._adapterFactories.filter(o=>o.factory!==s),this._debugServiceProxy.$unregisterDebugAdapterDescriptorFactory(a)})}registerDebugAdapterTrackerFactory(i,n){if(!n)return new E.Disposable(()=>{});const s=this._trackerFactoryHandleCounter++;return this._trackerFactories.push({type:i,handle:s,factory:n}),new E.Disposable(()=>{this._trackerFactories=this._trackerFactories.filter(a=>a.factory!==n)})}async $runInTerminal(i,n){return Promise.resolve(void 0)}async $substituteVariables(i,n){let s;const a=await this.getFolder(i);return a&&(s={uri:a.uri,name:a.name,index:a.index,toResource:()=>{throw new Error("Not implemented")}}),(await this._variableResolver.getResolver()).resolveAnyAsync(s,n)}createDebugAdapter(i,n){if(i.type==="implementation")return new w(i.implementation)}createSignService(){}async $startDASession(i,n){const s=this,a=await this.getSession(n);return this.getAdapterDescriptor(this.getAdapterDescriptorFactoryByType(a.type),a).then(o=>{if(!o)throw new Error(`Couldn't find a debug adapter descriptor for debug type '${a.type}' (extension might have failed to activate)`);const v=this.convertToDto(o),p=this.createDebugAdapter(v,a);if(!p)throw new Error(`Couldn't create a debug adapter for type '${a.type}'.`);const T=p;return this._debugAdapters.set(i,T),this.getDebugAdapterTrackers(a).then(N=>(N&&this._debugAdaptersTrackers.set(i,N),T.onMessage(async V=>{if(V.type==="request"&&V.command==="handshake"){const B=V,D={type:"response",seq:0,command:B.command,request_seq:B.seq,success:!0};this._signService||(this._signService=this.createSignService());try{if(this._signService){const z=await this._signService.sign(B.arguments.value);D.body={signature:z},T.sendResponse(D)}else throw new Error("no signer")}catch(z){D.success=!1,D.message=z.message,T.sendResponse(D)}}else N&&N.onDidSendMessage&&N.onDidSendMessage(V),V=(0,f.convertToVSCPaths)(V,!0),s._debugServiceProxy.$acceptDAMessage(i,V)}),T.onError(V=>{N&&N.onError&&N.onError(V),this._debugServiceProxy.$acceptDAError(i,V.name,V.message,V.stack)}),T.onExit(V=>{N&&N.onExit&&N.onExit((0,S.withNullAsUndefined)(V),void 0),this._debugServiceProxy.$acceptDAExit(i,(0,S.withNullAsUndefined)(V),void 0)}),N&&N.onWillStartSession&&N.onWillStartSession(),T.startSession()))})}$sendDAMessage(i,n){n=(0,f.convertToDAPaths)(n,!1);const s=this._debugAdaptersTrackers.get(i);s&&s.onWillReceiveMessage&&s.onWillReceiveMessage(n),this._debugAdapters.get(i)?.sendMessage(n)}$stopDASession(i){const n=this._debugAdaptersTrackers.get(i);this._debugAdaptersTrackers.delete(i),n&&n.onWillStopSession&&n.onWillStopSession();const s=this._debugAdapters.get(i);return this._debugAdapters.delete(i),s?s.stopSession():Promise.resolve(void 0)}$acceptBreakpointsDelta(i){const n=[],s=[],a=[];if(i.added)for(const o of i.added){const v=o.id;if(v&&!this._breakpoints.has(v)){let p;if(o.type==="function")p=new E.FunctionBreakpoint(o.functionName,o.enabled,o.condition,o.hitCondition,o.logMessage);else if(o.type==="data")p=new E.DataBreakpoint(o.label,o.dataId,o.canPersist,o.enabled,o.hitCondition,o.condition,o.logMessage);else{const T=M.URI.revive(o.uri);p=new E.SourceBreakpoint(new E.Location(T,new E.Position(o.line,o.character)),o.enabled,o.condition,o.hitCondition,o.logMessage)}p._id=v,this._breakpoints.set(v,p),n.push(p)}}if(i.removed)for(const o of i.removed){const v=this._breakpoints.get(o);v&&(this._breakpoints.delete(o),s.push(v))}if(i.changed){for(const o of i.changed)if(o.id){const v=this._breakpoints.get(o.id);if(v){if(v instanceof E.FunctionBreakpoint&&o.type==="function"){const p=v;p.enabled=o.enabled,p.condition=o.condition,p.hitCondition=o.hitCondition,p.logMessage=o.logMessage,p.functionName=o.functionName}else if(v instanceof E.SourceBreakpoint&&o.type==="source"){const p=v;p.enabled=o.enabled,p.condition=o.condition,p.hitCondition=o.hitCondition,p.logMessage=o.logMessage,p.location=new E.Location(M.URI.revive(o.uri),new E.Position(o.line,o.character))}a.push(v)}}}this.fireBreakpointChanges(n,s,a)}$provideDebugConfigurations(i,n,s){return(0,r.asPromise)(async()=>{const a=this.getConfigProviderByHandle(i);if(!a)throw new Error("no DebugConfigurationProvider found");if(!a.provideDebugConfigurations)throw new Error("DebugConfigurationProvider has no method provideDebugConfigurations");const o=await this.getFolder(n);return a.provideDebugConfigurations(o,s)}).then(a=>{if(!a)throw new Error("nothing returned from DebugConfigurationProvider.provideDebugConfigurations");return a})}$resolveDebugConfiguration(i,n,s,a){return(0,r.asPromise)(async()=>{const o=this.getConfigProviderByHandle(i);if(!o)throw new Error("no DebugConfigurationProvider found");if(!o.resolveDebugConfiguration)throw new Error("DebugConfigurationProvider has no method resolveDebugConfiguration");const v=await this.getFolder(n);return o.resolveDebugConfiguration(v,s,a)})}$resolveDebugConfigurationWithSubstitutedVariables(i,n,s,a){return(0,r.asPromise)(async()=>{const o=this.getConfigProviderByHandle(i);if(!o)throw new Error("no DebugConfigurationProvider found");if(!o.resolveDebugConfigurationWithSubstitutedVariables)throw new Error("DebugConfigurationProvider has no method resolveDebugConfigurationWithSubstitutedVariables");const v=await this.getFolder(n);return o.resolveDebugConfigurationWithSubstitutedVariables(v,s,a)})}async $provideDebugAdapter(i,n){const s=this.getAdapterDescriptorFactoryByHandle(i);if(!s)return Promise.reject(new Error("no adapter descriptor factory found for handle"));const a=await this.getSession(n);return this.getAdapterDescriptor(s,a).then(o=>{if(!o)throw new Error(`Couldn't find a debug adapter descriptor for debug type '${a.type}'`);return this.convertToDto(o)})}async $acceptDebugSessionStarted(i){const n=await this.getSession(i);this._onDidStartDebugSession.fire(n)}async $acceptDebugSessionTerminated(i){const n=await this.getSession(i);n&&(this._onDidTerminateDebugSession.fire(n),this._debugSessions.delete(n.id))}async $acceptDebugSessionActiveChanged(i){this._activeDebugSession=i?await this.getSession(i):void 0,this._onDidChangeActiveDebugSession.fire(this._activeDebugSession)}async $acceptDebugSessionNameChanged(i,n){(await this.getSession(i))?._acceptNameChanged(n)}async $acceptDebugSessionCustomEvent(i,n){const a={session:await this.getSession(i),event:n.event,body:n.body};this._onDidReceiveDebugSessionCustomEvent.fire(a)}convertToDto(i){if(i instanceof E.DebugAdapterExecutable)return{type:"executable",command:i.command,args:i.args,options:i.options};if(i instanceof E.DebugAdapterServer)return{type:"server",port:i.port,host:i.host};if(i instanceof E.DebugAdapterNamedPipeServer)return{type:"pipeServer",path:i.path};if(i instanceof E.DebugAdapterInlineImplementation)return{type:"implementation",implementation:i.implementation};throw new Error("convertToDto unexpected type")}getAdapterDescriptorFactoryByType(i){const n=this._adapterFactories.filter(s=>s.type===i);if(n.length>0)return n[0].factory}getAdapterDescriptorFactoryByHandle(i){const n=this._adapterFactories.filter(s=>s.handle===i);if(n.length>0)return n[0].factory}getConfigProviderByHandle(i){const n=this._configProviders.filter(s=>s.handle===i);if(n.length>0)return n[0].provider}definesDebugType(i,n){if(i.contributes){const s=i.contributes.debuggers;if(s&&s.length>0){for(const a of s)if(a.label&&a.type&&a.type===n)return!0}}return!1}getDebugAdapterTrackers(i){const s=i.configuration.type,a=this._trackerFactories.filter(o=>o.type===s||o.type==="*").map(o=>(0,r.asPromise)(()=>o.factory.createDebugAdapterTracker(i)).then(v=>v,v=>null));return Promise.race([Promise.all(a).then(o=>{const v=o.filter(p=>!!p);if(v.length>0)return new l(v)}),new Promise((o,v)=>{const p=setTimeout(()=>{clearTimeout(p),v(new Error("timeout"))},1e3)})]).catch(o=>{})}async getAdapterDescriptor(i,n){const s=n.configuration.debugServer;if(typeof s=="number")return Promise.resolve(new E.DebugAdapterServer(s));if(i){const o=await this._extensionService.getExtensionRegistry();return(0,r.asPromise)(()=>i.createDebugAdapterDescriptor(n,this.daExecutableFromPackage(n,o))).then(v=>{if(v)return v})}const a=await this._extensionService.getExtensionRegistry();return Promise.resolve(this.daExecutableFromPackage(n,a))}daExecutableFromPackage(i,n){}startBreakpoints(){this._breakpointEventsActive||(this._breakpointEventsActive=!0,this._debugServiceProxy.$startBreakpointEvents())}fireBreakpointChanges(i,n,s){(i.length>0||n.length>0||s.length>0)&&this._onDidChangeBreakpoints.fire(Object.freeze({added:i,removed:n,changed:s}))}async getSession(i){if(i)if(typeof i=="string"){const n=this._debugSessions.get(i);if(n)return n}else{let n=this._debugSessions.get(i.id);if(!n){const s=await this.getFolder(i.folderUri),a=i.parent?this._debugSessions.get(i.parent):void 0;n=new g(this._debugServiceProxy,i.id,i.type,i.name,s,i.configuration,a),this._debugSessions.set(n.id,n),this._debugServiceProxy.$sessionCached(n.id)}return n}throw new Error("cannot find session")}getFolder(i){if(i){const n=M.URI.revive(i);return this._workspaceService.resolveWorkspaceFolder(n)}return Promise.resolve(void 0)}};h=ze([$e(0,O.IExtHostRpcService),$e(1,m.IExtHostWorkspace),$e(2,P.IExtHostExtensionService),$e(3,c.IExtHostConfiguration),$e(4,b.IExtHostEditorTabs),$e(5,d.IExtHostVariableResolverProvider)],h),e.ExtHostDebugServiceBase=h;class g{constructor(i,n,s,a,o,v,p){this._debugServiceProxy=i,this._id=n,this._type=s,this._name=a,this._workspaceFolder=o,this._configuration=v,this._parentSession=p}get id(){return this._id}get type(){return this._type}get name(){return this._name}set name(i){this._name=i,this._debugServiceProxy.$setDebugSessionName(this._id,i)}get parentSession(){return this._parentSession}_acceptNameChanged(i){this._name=i}get workspaceFolder(){return this._workspaceFolder}get configuration(){return this._configuration}customRequest(i,n){return this._debugServiceProxy.$customDebugAdapterRequest(this._id,i,n)}getDebugProtocolBreakpoint(i){return this._debugServiceProxy.$getDebugProtocolBreakpoint(this._id,i.id)}}e.ExtHostDebugSession=g;class C{constructor(i){this.value=Object.freeze({append(n){i.$appendDebugConsole(n)},appendLine(n){this.append(n+`
`)}})}}e.ExtHostDebugConsole=C;class l{constructor(i){this.trackers=i}onWillStartSession(){this.trackers.forEach(i=>i.onWillStartSession?i.onWillStartSession():void 0)}onWillReceiveMessage(i){this.trackers.forEach(n=>n.onWillReceiveMessage?n.onWillReceiveMessage(i):void 0)}onDidSendMessage(i){this.trackers.forEach(n=>n.onDidSendMessage?n.onDidSendMessage(i):void 0)}onWillStopSession(){this.trackers.forEach(i=>i.onWillStopSession?i.onWillStopSession():void 0)}onError(i){this.trackers.forEach(n=>n.onError?n.onError(i):void 0)}onExit(i,n){this.trackers.forEach(s=>s.onExit?s.onExit(i,n):void 0)}}class w extends k.AbstractDebugAdapter{constructor(i){super(),this.implementation=i,i.onDidSendMessage(n=>{this.acceptMessage(n)})}startSession(){return Promise.resolve(void 0)}sendMessage(i){this.implementation.handleMessage(i)}stopSession(){return this.implementation.dispose(),Promise.resolve(void 0)}}let t=class extends h{constructor(i,n,s,a,o,v){super(i,n,s,a,o,v)}};t=ze([$e(0,O.IExtHostRpcService),$e(1,m.IExtHostWorkspace),$e(2,P.IExtHostExtensionService),$e(3,c.IExtHostConfiguration),$e(4,b.IExtHostEditorTabs),$e(5,d.IExtHostVariableResolverProvider)],t),e.WorkerExtHostDebugService=t}),define(Ce[232],Ie([1,0,12,72,2,4,223,14,56,58,28,148,11,46,33]),function(ie,e,r,y,S,M,_,A,b,P,O,E,m,k,f){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtensionHostMain=void 0;class c{constructor(h,g,C,l,w){this._hostUtils=C,this._rpcProtocol=new _.RPCProtocol(h,null,l),g=c._transform(g,this._rpcProtocol);const t=new P.ServiceCollection(...(0,b.getSingletonServiceDescriptors)());t.set(O.IExtHostInitDataService,{_serviceBrand:void 0,...g,messagePorts:w}),t.set(m.IExtHostRpcService,new m.ExtHostRpcService(this._rpcProtocol)),t.set(k.IURITransformerService,new k.URITransformerService(l)),t.set(f.IHostUtils,C);const u=new E.InstantiationService(t,!0);this._logService=u.invokeFunction(a=>a.get(A.ILogService)),y.mark("code/extHost/didCreateServices"),this._hostUtils.pid?this._logService.info(`Extension host with pid ${this._hostUtils.pid} started`):this._logService.info("Extension host started"),this._logService.trace("initData",g),this._extensionService=u.invokeFunction(a=>a.get(f.IExtHostExtensionService)),this._extensionService.initialize(),Error.stackTraceLimit=100;const i=new WeakMap;this._extensionService.getExtensionPathIndex().then(a=>{Error.prepareStackTrace=(o,v)=>{let p="",T,N;for(const V of v)p+=`
	at ${V.toString()}`,N=V.getFileName(),!T&&N&&(T=a.findSubstr(S.URI.file(N)));return i.set(o,T),`${o.name||"Error"}: ${o.message||""}${p}`}});const n=this._rpcProtocol.getProxy(M.MainContext.MainThreadExtensionService),s=this._rpcProtocol.getProxy(M.MainContext.MainThreadErrors);r.setUnexpectedErrorHandler(a=>{const o=r.transformErrorForSerialization(a),v=i.get(a);v?n.$onExtensionRuntimeError(v.identifier,o):s.$onUnexpectedError(o)})}async asBrowserUri(h){const g=this._rpcProtocol.getProxy(M.MainContext.MainThreadExtensionService);return S.URI.revive(await g.$asBrowserUri(h))}terminate(h){this._extensionService.terminate(h)}static _transform(h,g){h.allExtensions.forEach(l=>{l.extensionLocation=S.URI.revive(g.transformIncomingURIs(l.extensionLocation));const w={};l.browserNlsBundleUris&&(Object.keys(l.browserNlsBundleUris).forEach(t=>w[t]=S.URI.revive(g.transformIncomingURIs(l.browserNlsBundleUris[t]))),l.browserNlsBundleUris=w)}),h.environment.appRoot=S.URI.revive(g.transformIncomingURIs(h.environment.appRoot));const C=h.environment.extensionDevelopmentLocationURI;return C&&(h.environment.extensionDevelopmentLocationURI=C.map(l=>S.URI.revive(g.transformIncomingURIs(l)))),h.environment.extensionTestsLocationURI=S.URI.revive(g.transformIncomingURIs(h.environment.extensionTestsLocationURI)),h.environment.globalStorageHome=S.URI.revive(g.transformIncomingURIs(h.environment.globalStorageHome)),h.environment.workspaceStorageHome=S.URI.revive(g.transformIncomingURIs(h.environment.workspaceStorageHome)),h.nlsBaseUrl=S.URI.revive(g.transformIncomingURIs(h.nlsBaseUrl)),h.logsLocation=S.URI.revive(g.transformIncomingURIs(h.logsLocation)),h.logFile=S.URI.revive(g.transformIncomingURIs(h.logFile)),h.workspace=g.transformIncomingURIs(h.workspace),h}}e.ExtensionHostMain=c}),define(Ce[233],Ie([1,0,18,15,20,43,13,19,22,2,41]),function(ie,e,r,y,S,M,_,A,b,P,O){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.BatchedCollector=e.extensionResultIsMatch=e.TextSearchResultsCollector=e.TextSearchManager=void 0;class E{constructor(g,C,l,w){this.query=g,this.provider=C,this.fileUtils=l,this.processType=w,this.collector=null,this.isLimitHit=!1,this.resultCount=0}search(g,C){const l=this.query.folderQueries||[],w=new S.CancellationTokenSource;return C.onCancellationRequested(()=>w.cancel()),new Promise((t,u)=>{this.collector=new k(g);let i=!1;const n=(s,a)=>{if(!i&&!this.isLimitHit){const o=this.resultSize(s);c(s)&&typeof this.query.maxResults=="number"&&this.resultCount+o>this.query.maxResults&&(this.isLimitHit=!0,i=!0,w.cancel(),s=this.trimResultToSize(s,this.query.maxResults-this.resultCount));const v=this.resultSize(s);this.resultCount+=v,(v>0||!c(s))&&this.collector.add(s,a)}};Promise.all(l.map((s,a)=>this.searchInFolder(s,o=>n(o,a),w.token))).then(s=>{w.dispose(),this.collector.flush();const a=s.some(o=>!!o&&!!o.limitHit);t({limitHit:this.isLimitHit||a,messages:(0,r.flatten)(s.map(o=>o?.message?Array.isArray(o.message)?o.message:[o.message]:[])),stats:{type:this.processType}})},s=>{w.dispose();const a=(0,M.toErrorMessage)(s);u(new Error(a))})})}resultSize(g){return c(g)?Array.isArray(g.ranges)?g.ranges.length:1:0}trimResultToSize(g,C){const l=Array.isArray(g.ranges)?g.ranges:[g.ranges],w=Array.isArray(g.preview.matches)?g.preview.matches:[g.preview.matches];return{ranges:l.slice(0,C),preview:{matches:w.slice(0,C),text:g.preview.text},uri:g.uri}}async searchInFolder(g,C,l){const w=new O.QueryGlobTester(this.query,g),t=[],u={report:s=>{if(!this.validateProviderResult(s))return;const a=g.folder.scheme===_.Schemas.file?(0,O.hasSiblingPromiseFn)(()=>this.fileUtils.readdir(b.dirname(s.uri))):void 0,o=b.relativePath(g.folder,s.uri);if(o){const v=w.includedInQuery(o,A.basename(o),a);(0,y.isThenable)(v)?t.push(v.then(p=>{p&&C(s)})):v&&C(s)}}},i=this.getSearchOptionsForFolder(g),n=await this.provider.provideTextSearchResults(m(this.query.contentPattern),i,u,l);return t.length&&await Promise.all(t),n}validateProviderResult(g){if(c(g)){if(Array.isArray(g.ranges)){if(!Array.isArray(g.preview.matches))return console.warn("INVALID - A text search provider match's`ranges` and`matches` properties must have the same type."),!1;if(g.preview.matches.length!==g.ranges.length)return console.warn("INVALID - A text search provider match's`ranges` and`matches` properties must have the same length."),!1}else if(Array.isArray(g.preview.matches))return console.warn("INVALID - A text search provider match's`ranges` and`matches` properties must have the same length."),!1}return!0}getSearchOptionsForFolder(g){const C=(0,O.resolvePatternsForProvider)(this.query.includePattern,g.includePattern),l=(0,O.resolvePatternsForProvider)(this.query.excludePattern,g.excludePattern),w={folder:P.URI.from(g.folder),excludes:l,includes:C,useIgnoreFiles:!g.disregardIgnoreFiles,useGlobalIgnoreFiles:!g.disregardGlobalIgnoreFiles,useParentIgnoreFiles:!g.disregardParentIgnoreFiles,followSymlinks:!g.ignoreSymlinks,encoding:g.fileEncoding&&this.fileUtils.toCanonicalName(g.fileEncoding),maxFileSize:this.query.maxFileSize,maxResults:this.query.maxResults,previewOptions:this.query.previewOptions,afterContext:this.query.afterContext,beforeContext:this.query.beforeContext};return w.usePCRE2=this.query.usePCRE2,w}}e.TextSearchManager=E;function m(h){return{isCaseSensitive:h.isCaseSensitive||!1,isRegExp:h.isRegExp||!1,isWordMatch:h.isWordMatch||!1,isMultiline:h.isMultiline||!1,pattern:h.pattern}}class k{constructor(g){this._onResult=g,this._currentFolderIdx=-1,this._currentFileMatch=null,this._batchedCollector=new d(512,C=>this.sendItems(C))}add(g,C){this._currentFileMatch&&(this._currentFolderIdx!==C||!b.isEqual(this._currentUri,g.uri))&&(this.pushToCollector(),this._currentFileMatch=null),this._currentFileMatch||(this._currentFolderIdx=C,this._currentFileMatch={resource:g.uri,results:[]}),this._currentFileMatch.results.push(f(g))}pushToCollector(){const g=this._currentFileMatch&&this._currentFileMatch.results?this._currentFileMatch.results.length:0;this._batchedCollector.addItem(this._currentFileMatch,g)}flush(){this.pushToCollector(),this._batchedCollector.flush()}sendItems(g){this._onResult(g)}}e.TextSearchResultsCollector=k;function f(h){return c(h)?{preview:{matches:(0,r.mapArrayOrNot)(h.preview.matches,g=>({startLineNumber:g.start.line,startColumn:g.start.character,endLineNumber:g.end.line,endColumn:g.end.character})),text:h.preview.text},ranges:(0,r.mapArrayOrNot)(h.ranges,g=>({startLineNumber:g.start.line,startColumn:g.start.character,endLineNumber:g.end.line,endColumn:g.end.character}))}:{text:h.text,lineNumber:h.lineNumber}}function c(h){return!!h.preview}e.extensionResultIsMatch=c;class d{constructor(g,C){this.maxBatchSize=g,this.cb=C,this.totalNumberCompleted=0,this.batch=[],this.batchSize=0}addItem(g,C){!g||this.addItemToBatch(g,C)}addItems(g,C){!g||this.addItemsToBatch(g,C)}addItemToBatch(g,C){this.batch.push(g),this.batchSize+=C,this.onUpdate()}addItemsToBatch(g,C){this.batch=this.batch.concat(g),this.batchSize+=C,this.onUpdate()}onUpdate(){this.totalNumberCompleted<d.START_BATCH_AFTER_COUNT?this.flush():this.batchSize>=this.maxBatchSize?this.flush():this.timeoutHandle||(this.timeoutHandle=setTimeout(()=>{this.flush()},d.TIMEOUT))}flush(){this.batchSize&&(this.totalNumberCompleted+=this.batchSize,this.cb(this.batch),this.batch=[],this.batchSize=0,this.timeoutHandle&&(clearTimeout(this.timeoutHandle),this.timeoutHandle=0))}}e.BatchedCollector=d,d.TIMEOUT=4e3,d.START_BATCH_AFTER_COUNT=50}),define(Ce[105],Ie([1,0,7,4,3,228,11,46,14,2,233]),function(ie,e,r,y,S,M,_,A,b,P,O){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.reviveQuery=e.ExtHostSearch=e.IExtHostSearch=void 0,e.IExtHostSearch=(0,S.createDecorator)("IExtHostSearch");let E=class{constructor(c,d,h){this.extHostRpc=c,this._uriTransformer=d,this._logService=h,this._proxy=this.extHostRpc.getProxy(y.MainContext.MainThreadSearch),this._handlePool=0,this._textSearchProvider=new Map,this._textSearchUsedSchemes=new Set,this._fileSearchProvider=new Map,this._fileSearchUsedSchemes=new Set,this._fileSearchManager=new M.FileSearchManager}_transformScheme(c){return this._uriTransformer.transformOutgoingScheme(c)}registerTextSearchProvider(c,d){if(this._textSearchUsedSchemes.has(c))throw new Error(`a text search provider for the scheme '${c}' is already registered`);this._textSearchUsedSchemes.add(c);const h=this._handlePool++;return this._textSearchProvider.set(h,d),this._proxy.$registerTextSearchProvider(h,this._transformScheme(c)),(0,r.toDisposable)(()=>{this._textSearchUsedSchemes.delete(c),this._textSearchProvider.delete(h),this._proxy.$unregisterProvider(h)})}registerFileSearchProvider(c,d){if(this._fileSearchUsedSchemes.has(c))throw new Error(`a file search provider for the scheme '${c}' is already registered`);this._fileSearchUsedSchemes.add(c);const h=this._handlePool++;return this._fileSearchProvider.set(h,d),this._proxy.$registerFileSearchProvider(h,this._transformScheme(c)),(0,r.toDisposable)(()=>{this._fileSearchUsedSchemes.delete(c),this._fileSearchProvider.delete(h),this._proxy.$unregisterProvider(h)})}$provideFileSearchResults(c,d,h,g){const C=m(h),l=this._fileSearchProvider.get(c);if(l)return this._fileSearchManager.fileSearch(C,l,w=>{this._proxy.$handleFileMatch(c,d,w.map(t=>t.resource))},g);throw new Error("unknown provider: "+c)}$clearCache(c){return this._fileSearchManager.clearCache(c),Promise.resolve(void 0)}$provideTextSearchResults(c,d,h,g){const C=this._textSearchProvider.get(c);if(!C||!C.provideTextSearchResults)throw new Error(`Unknown provider ${c}`);const l=m(h);return this.createTextSearchManager(l,C).search(t=>this._proxy.$handleTextMatch(c,d,t),g)}$enableExtensionHostSearch(){}createTextSearchManager(c,d){return new O.TextSearchManager(c,d,{readdir:h=>Promise.resolve([]),toCanonicalName:h=>h},"textSearchProvider")}};E=ze([$e(0,_.IExtHostRpcService),$e(1,A.IURITransformerService),$e(2,b.ILogService)],E),e.ExtHostSearch=E;function m(f){return{...f,folderQueries:f.folderQueries&&f.folderQueries.map(k),extraFileResources:f.extraFileResources&&f.extraFileResources.map(c=>P.URI.revive(c))}}e.reviveQuery=m;function k(f){return{...f,folder:P.URI.revive(f.folder)}}}),define(Ce[234],Ie([1,0,56,100,31,97,32,37,50,53,102,104,105,70,62,67,99,52,36,69,88,51,205,14,175,103,98,68]),function(ie,e,r,y,S,M,_,A,b,P,O,E,m,k,f,c,d,h,g,C,l,w,t,u,i,n,s,a){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),(0,r.registerSingleton)(a.IExtHostLocalizationService,a.ExtHostLocalizationService,!0),(0,r.registerSingleton)(u.ILoggerService,t.ExtHostLoggerService,!0),(0,r.registerSingleton)(u.ILogService,i.ExtHostLogService,!0),(0,r.registerSingleton)(c.IExtHostApiDeprecationService,c.ExtHostApiDeprecationService,!1),(0,r.registerSingleton)(A.IExtHostCommands,A.ExtHostCommands,!1),(0,r.registerSingleton)(_.IExtHostConfiguration,_.ExtHostConfiguration,!1),(0,r.registerSingleton)(h.IExtHostConsumerFileSystem,h.ExtHostConsumerFileSystem,!1),(0,r.registerSingleton)(E.IExtHostDebugService,E.WorkerExtHostDebugService,!1),(0,r.registerSingleton)(M.IExtHostDecorations,M.ExtHostDecorations,!1),(0,r.registerSingleton)(b.IExtHostDocumentsAndEditors,b.ExtHostDocumentsAndEditors,!1),(0,r.registerSingleton)(g.IExtHostFileSystemInfo,g.ExtHostFileSystemInfo,!1),(0,r.registerSingleton)(y.IExtHostOutputService,y.ExtHostOutputService,!0),(0,r.registerSingleton)(m.IExtHostSearch,m.ExtHostSearch,!1),(0,r.registerSingleton)(k.IExtHostStorage,k.ExtHostStorage,!1),(0,r.registerSingleton)(O.IExtHostTask,O.WorkerExtHostTask,!1),(0,r.registerSingleton)(P.IExtHostTerminalService,P.WorkerExtHostTerminalService,!1),(0,r.registerSingleton)(f.IExtHostTunnelService,f.ExtHostTunnelService,!1),(0,r.registerSingleton)(d.IExtHostWindow,d.ExtHostWindow,!1),(0,r.registerSingleton)(S.IExtHostWorkspace,S.ExtHostWorkspace,!1),(0,r.registerSingleton)(C.IExtHostSecretState,C.ExtHostSecretState,!1),(0,r.registerSingleton)(l.IExtHostTelemetry,l.ExtHostTelemetry,!1),(0,r.registerSingleton)(s.IExtHostTelemetryLogService,s.ExtHostTelemetryLogService,!1),(0,r.registerSingleton)(w.IExtHostEditorTabs,w.ExtHostEditorTabs,!1),(0,r.registerSingleton)(n.IExtHostVariableResolverProvider,n.ExtHostVariableResolverProviderService,!1)}),define(Ce[235],Ie([1,0]),function(ie,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.TreeviewsService=void 0;class r{constructor(){this._dragOperations=new Map,this._renderedElements=new Map}removeDragOperationTransfer(S){if(S&&this._dragOperations.has(S)){const M=this._dragOperations.get(S);return this._dragOperations.delete(S),M}}addDragOperationTransfer(S,M){this._dragOperations.set(S,M)}getRenderedTreeElement(S){if(this._renderedElements.has(S))return this._renderedElements.get(S)}addRenderedTreeItemElement(S,M){this._renderedElements.set(S,M)}removeRenderedTreeItemElement(S){this._renderedElements.has(S)&&this._renderedElements.delete(S)}}e.TreeviewsService=r}),define(Ce[236],Ie([1,0,135,6,22,2,5,7,15,6,10,18,8,20,235,25]),function(ie,e,r,y,S,M,_,A,b,P,O,E,m,k,f,c){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtHostTreeViews=void 0;function d(C,l){if((0,O.isString)(C))return{label:C};if(C&&typeof C=="object"&&typeof C.label=="string"){let w;return Array.isArray(C.highlights)&&(w=C.highlights.filter(t=>t.length===2&&typeof t[0]=="number"&&typeof t[1]=="number"),w=w.length?w:void 0),{label:C.label,highlights:w}}}class h{constructor(l,w,t){this._proxy=l,this.commands=w,this.logService=t,this.treeViews=new Map,this.treeDragAndDropService=new f.TreeviewsService;function u(i){return i&&i.$treeViewId&&(i.$treeItemHandle||i.$selectedTreeItems||i.$focusedTreeItem)}w.registerArgumentProcessor({processArgument:i=>u(i)?this.convertArgument(i):Array.isArray(i)&&i.length>0?i.map(n=>u(n)?this.convertArgument(n):n):i})}registerTreeDataProvider(l,w,t){const u=this.createTreeView(l,{treeDataProvider:w},t);return{dispose:()=>u.dispose()}}createTreeView(l,w,t){if(!w||!w.treeDataProvider)throw new Error("Options with treeDataProvider is mandatory");const u=w.dragAndDropController?.dropMimeTypes??[],i=w.dragAndDropController?.dragMimeTypes??[],n=!!w.dragAndDropController?.handleDrag,s=!!w.dragAndDropController?.handleDrop,a=this.createExtHostTreeView(l,w,t),o=this._proxy.$registerTreeViewDataProvider(l,{showCollapseAll:!!w.showCollapseAll,canSelectMany:!!w.canSelectMany,dropMimeTypes:u,dragMimeTypes:i,hasHandleDrag:n,hasHandleDrop:s});return{get onDidCollapseElement(){return a.onDidCollapseElement},get onDidExpandElement(){return a.onDidExpandElement},get selection(){return a.selectedElements},get onDidChangeSelection(){return a.onDidChangeSelection},get visible(){return a.visible},get onDidChangeVisibility(){return a.onDidChangeVisibility},get onDidChangeCheckboxState(){return(0,c.checkProposedApiEnabled)(t,"treeItemCheckbox"),a.onDidChangeCheckboxState},get message(){return a.message},set message(v){a.message=v},get title(){return a.title},set title(v){a.title=v},get description(){return a.description},set description(v){a.description=v},get badge(){return a.badge},set badge(v){a.badge=v},reveal:(v,p)=>a.reveal(v,p),dispose:async()=>{await o,this.treeViews.delete(l),a.dispose()}}}$getChildren(l,w){const t=this.treeViews.get(l);return t?t.getChildren(w):Promise.reject(new Error((0,r.localize)(0,null,l)))}async $handleDrop(l,w,t,u,i,n,s,a){const o=this.treeViews.get(l);if(!o)return Promise.reject(new Error((0,r.localize)(1,null,l)));const v=m.DataTransfer.toDataTransfer(t,async p=>(await this._proxy.$resolveDropFileData(l,w,p)).buffer);return s===l&&a&&await this.addAdditionalTransferItems(v,o,a,i,n),o.onDrop(v,u,i)}async addAdditionalTransferItems(l,w,t,u,i){const n=this.treeDragAndDropService.removeDragOperationTransfer(i);if(n)(await n)?.forEach((s,a)=>{s&&l.set(a,s)});else if(i&&w.handleDrag){const s=w.handleDrag(t,l,u);this.treeDragAndDropService.addDragOperationTransfer(i,s),await s}return l}async $handleDrag(l,w,t,u){const i=this.treeViews.get(l);if(!i)return Promise.reject(new Error((0,r.localize)(2,null,l)));const n=await this.addAdditionalTransferItems(new y.DataTransfer,i,w,u,t);if(!!n)return m.DataTransfer.toDataTransferDTO(n)}async $hasResolve(l){const w=this.treeViews.get(l);if(!w)throw new Error((0,r.localize)(3,null,l));return w.hasResolve}$resolve(l,w,t){const u=this.treeViews.get(l);if(!u)throw new Error((0,r.localize)(4,null,l));return u.resolveTreeItem(w,t)}$setExpanded(l,w,t){const u=this.treeViews.get(l);if(!u)throw new Error((0,r.localize)(5,null,l));u.setExpanded(w,t)}$setSelection(l,w){const t=this.treeViews.get(l);if(!t)throw new Error((0,r.localize)(6,null,l));t.setSelection(w)}$setFocus(l,w){const t=this.treeViews.get(l);if(!t)throw new Error((0,r.localize)(7,null,l));t.setFocus(w)}$setVisible(l,w){const t=this.treeViews.get(l);if(!t)throw new Error((0,r.localize)(8,null,l));t.setVisible(w)}$changeCheckboxState(l,w){const t=this.treeViews.get(l);if(!t)throw new Error((0,r.localize)(9,null,l));t.setCheckboxState(w)}createExtHostTreeView(l,w,t){const u=new g(l,w,this._proxy,this.commands.converter,this.logService,t);return this.treeViews.set(l,u),u}convertArgument(l){const w=this.treeViews.get(l.$treeViewId);return w&&"$treeItemHandle"in l?w.getExtensionElement(l.$treeItemHandle):w&&"$focusedTreeItem"in l&&l.$focusedTreeItem?w.focusedElement:null}}e.ExtHostTreeViews=h;class g extends A.Disposable{get visible(){return this._visible}get selectedElements(){return this._selectedHandles.map(l=>this.getExtensionElement(l)).filter(l=>!(0,O.isUndefinedOrNull)(l))}get focusedElement(){return this._focusedHandle?this.getExtensionElement(this._focusedHandle):void 0}constructor(l,w,t,u,i,n){if(super(),this.viewId=l,this.proxy=t,this.commands=u,this.logService=i,this.extension=n,this.roots=void 0,this.elements=new Map,this.nodes=new Map,this._visible=!1,this._selectedHandles=[],this._focusedHandle=void 0,this._onDidExpandElement=this._register(new _.Emitter),this.onDidExpandElement=this._onDidExpandElement.event,this._onDidCollapseElement=this._register(new _.Emitter),this.onDidCollapseElement=this._onDidCollapseElement.event,this._onDidChangeSelection=this._register(new _.Emitter),this.onDidChangeSelection=this._onDidChangeSelection.event,this._onDidChangeVisibility=this._register(new _.Emitter),this.onDidChangeVisibility=this._onDidChangeVisibility.event,this._onDidChangeCheckboxState=this._register(new _.Emitter),this.onDidChangeCheckboxState=this._onDidChangeCheckboxState.event,this._onDidChangeData=this._register(new _.Emitter),this.refreshPromise=Promise.resolve(),this.refreshQueue=Promise.resolve(),this._message="",this._title="",this._refreshCancellationSource=new k.CancellationTokenSource,n.contributes&&n.contributes.views)for(const o in n.contributes.views)for(const v of n.contributes.views[o])v.id===l&&(this._title=v.name);this.dataProvider=w.treeDataProvider,this.dndController=w.dragAndDropController,this.dataProvider.onDidChangeTreeData&&this._register(this.dataProvider.onDidChangeTreeData(o=>this._onDidChangeData.fire({message:!1,element:o})));let s,a;this._register(_.Event.debounce(this._onDidChangeData.event,(o,v)=>(o||(o={message:!1,elements:[]}),v.element!==!1&&(s||(s=new Promise(p=>a=p),this.refreshPromise=this.refreshPromise.then(()=>s)),Array.isArray(v.element)?o.elements.push(...v.element):o.elements.push(v.element)),v.message&&(o.message=!0),o),200,!0)(({message:o,elements:v})=>{v.length&&(this.refreshQueue=this.refreshQueue.then(()=>{const p=a;return s=null,this.refresh(v).then(()=>p())})),o&&this.proxy.$setMessage(this.viewId,this._message)}))}async getChildren(l){const w=l?this.getExtensionElement(l):void 0;if(l&&!w)return this.logService.error(`No tree item with id '${l}' found.`),Promise.resolve([]);let t=this.getChildrenNodes(l);return t||(t=await this.fetchChildrenNodes(w)),t?t.map(u=>u.item):void 0}getExtensionElement(l){return this.elements.get(l)}reveal(l,w){w=w||{select:!0,focus:!1};const t=(0,O.isUndefinedOrNull)(w.select)?!0:w.select,u=(0,O.isUndefinedOrNull)(w.focus)?!1:w.focus,i=(0,O.isUndefinedOrNull)(w.expand)?!1:w.expand;return typeof this.dataProvider.getParent!="function"?Promise.reject(new Error("Required registered TreeDataProvider to implement 'getParent' method to access 'reveal' method")):l?this.refreshPromise.then(()=>this.resolveUnknownParentChain(l)).then(n=>this.resolveTreeNode(l,n[n.length-1]).then(s=>this.proxy.$reveal(this.viewId,{item:s.item,parentChain:n.map(a=>a.item)},{select:t,focus:u,expand:i})),n=>this.logService.error(n)):this.proxy.$reveal(this.viewId,void 0,{select:t,focus:u,expand:i})}get message(){return this._message}set message(l){this._message=l,this._onDidChangeData.fire({message:!0,element:!1})}get title(){return this._title}set title(l){this._title=l,this.proxy.$setTitle(this.viewId,l,this._description)}get description(){return this._description}set description(l){this._description=l,this.proxy.$setTitle(this.viewId,this._title,l)}get badge(){return this._badge}set badge(l){this._badge?.value===l?.value&&this._badge?.tooltip===l?.tooltip||(this._badge=m.ViewBadge.from(l),this.proxy.$setBadge(this.viewId,l))}setExpanded(l,w){const t=this.getExtensionElement(l);t&&(w?this._onDidExpandElement.fire(Object.freeze({element:t})):this._onDidCollapseElement.fire(Object.freeze({element:t})))}setSelection(l){(0,E.equals)(this._selectedHandles,l)||(this._selectedHandles=l,this._onDidChangeSelection.fire(Object.freeze({selection:this.selectedElements})))}setFocus(l){this._focusedHandle=l}setVisible(l){l!==this._visible&&(this._visible=l,this._onDidChangeVisibility.fire(Object.freeze({visible:this._visible})))}async setCheckboxState(l){const w=(await Promise.all(l.map(async t=>{const u=this.getExtensionElement(t.treeItemHandle);return u?{extensionItem:u,treeItem:await this.dataProvider.getTreeItem(u),newState:t.newState?P.TreeItemCheckboxState.Checked:P.TreeItemCheckboxState.Unchecked}:Promise.resolve(void 0)}))).filter(t=>t!==void 0);w.forEach(t=>{t.treeItem.checkboxState=t.newState?P.TreeItemCheckboxState.Checked:P.TreeItemCheckboxState.Unchecked}),this._onDidChangeCheckboxState.fire({items:w.map(t=>[t.extensionItem,t.newState])})}async handleDrag(l,w,t){const u=[];for(const i of l){const n=this.getExtensionElement(i);n&&u.push(n)}if(!(!this.dndController?.handleDrag||u.length===0))return await this.dndController.handleDrag(u,w,t),w}get hasHandleDrag(){return!!this.dndController?.handleDrag}async onDrop(l,w,t){const u=w?this.getExtensionElement(w):void 0;if(!(!u&&w||!this.dndController?.handleDrop))return(0,b.asPromise)(()=>this.dndController?.handleDrop?this.dndController.handleDrop(u,l,t):void 0)}get hasResolve(){return!!this.dataProvider.resolveTreeItem}async resolveTreeItem(l,w){if(!this.dataProvider.resolveTreeItem)return;const t=this.elements.get(l);if(t){const u=this.nodes.get(t);if(u){const i=await this.dataProvider.resolveTreeItem(u.extensionItem,t,w)??u.extensionItem;return this.validateTreeItem(i),u.item.tooltip=this.getTooltip(i.tooltip),u.item.command=this.getCommand(u.disposableStore,i.command),u.item}}}resolveUnknownParentChain(l){return this.resolveParent(l).then(w=>w?this.resolveUnknownParentChain(w).then(t=>this.resolveTreeNode(w,t[t.length-1]).then(u=>(t.push(u),t))):Promise.resolve([]))}resolveParent(l){const w=this.nodes.get(l);return w?Promise.resolve(w.parent?this.elements.get(w.parent.item.handle):void 0):(0,b.asPromise)(()=>this.dataProvider.getParent(l))}resolveTreeNode(l,w){const t=this.nodes.get(l);return t?Promise.resolve(t):(0,b.asPromise)(()=>this.dataProvider.getTreeItem(l)).then(u=>this.createHandle(l,u,w,!0)).then(u=>this.getChildren(w?w.item.handle:void 0).then(()=>{const i=this.getExtensionElement(u);if(i){const n=this.nodes.get(i);if(n)return Promise.resolve(n)}throw new Error(`Cannot resolve tree item for element ${u}`)}))}getChildrenNodes(l){if(l){let w;if(typeof l=="string"){const t=this.getExtensionElement(l);w=t?this.nodes.get(t):void 0}else w=l;return w&&w.children||void 0}return this.roots}async fetchChildrenNodes(l){this.clearChildren(l);const w=new k.CancellationTokenSource(this._refreshCancellationSource.token);try{const t=l?this.nodes.get(l):void 0,u=await this.dataProvider.getChildren(l);if(w.token.isCancellationRequested)return;const i=await Promise.all((0,E.coalesce)(u||[]).map(async n=>{const s=await this.dataProvider.getTreeItem(n);return s&&!w.token.isCancellationRequested?this.createAndRegisterTreeNode(n,s,t):null}));return w.token.isCancellationRequested?void 0:(0,E.coalesce)(i)}finally{w.dispose()}}refresh(l){if(l.some(t=>!t))return this._refreshCancellationSource.dispose(!0),this._refreshCancellationSource=new k.CancellationTokenSource,this.clearAll(),this.proxy.$refresh(this.viewId);{const t=this.getHandlesToRefresh(l);if(t.length)return this.refreshHandles(t)}return Promise.resolve(void 0)}getHandlesToRefresh(l){const w=new Set,t=l.map(i=>this.nodes.get(i));for(const i of t)if(i&&!w.has(i.item.handle)){let n=i;for(;n&&n.parent&&t.findIndex(s=>n&&n.parent&&s&&s.item.handle===n.parent.item.handle)===-1;){const s=this.elements.get(n.parent.item.handle);n=s?this.nodes.get(s):void 0}n&&!n.parent&&w.add(i.item.handle)}const u=[];return w.forEach(i=>{const n=this.elements.get(i);if(n){const s=this.nodes.get(n);s&&(!s.parent||!w.has(s.parent.item.handle))&&u.push(i)}}),u}refreshHandles(l){const w={};return Promise.all(l.map(t=>this.refreshNode(t).then(u=>{u&&(w[t]=u.item)}))).then(()=>Object.keys(w).length?this.proxy.$refresh(this.viewId,w):void 0)}refreshNode(l){const w=this.getExtensionElement(l);if(w){const t=this.nodes.get(w);if(t)return this.clearChildren(w),(0,b.asPromise)(()=>this.dataProvider.getTreeItem(w)).then(u=>{if(u){const i=this.createTreeNode(w,u,t.parent);return this.updateNodeCache(w,i,t,t.parent),t.dispose(),i}return null})}return Promise.resolve(null)}createAndRegisterTreeNode(l,w,t){const u=this.createTreeNode(l,w,t);if(w.id&&this.elements.has(u.item.handle))throw new Error((0,r.localize)(10,null,w.id));return this.addNodeToCache(l,u),this.addNodeToParentCache(u,t),u}getTooltip(l){return P.MarkdownString.isMarkdownString(l)?m.MarkdownString.from(l):l}getCommand(l,w){return w?{...this.commands.toInternal(w,l),originalId:w.command}:void 0}getCheckbox(l){if(!l.checkboxState)return;let w,t;return typeof l.checkboxState=="number"?w=l.checkboxState:(w=l.checkboxState.state,t=l.checkboxState.tooltip),{isChecked:w===P.TreeItemCheckboxState.Checked,tooltip:t}}validateTreeItem(l){if(!P.TreeItem.isTreeItem(l,this.extension))throw new Error(`Extension ${this.extension.identifier.value} has provided an invalid tree item.`)}createTreeNode(l,w,t){this.validateTreeItem(w);const u=new A.DisposableStore,i=this.createHandle(l,w,t),n=this.getLightIconPath(w);return{item:{handle:i,parentHandle:t?t.item.handle:void 0,label:d(w.label,this.extension),description:w.description,resourceUri:w.resourceUri,tooltip:this.getTooltip(w.tooltip),command:this.getCommand(u,w.command),contextValue:w.contextValue,icon:n,iconDark:this.getDarkIconPath(w)||n,themeIcon:this.getThemeIcon(w),collapsibleState:(0,O.isUndefinedOrNull)(w.collapsibleState)?P.TreeItemCollapsibleState.None:w.collapsibleState,accessibilityInformation:w.accessibilityInformation,checkbox:this.getCheckbox(w)},extensionItem:w,parent:t,children:void 0,disposableStore:u,dispose(){u.dispose()}}}getThemeIcon(l){return l.iconPath instanceof P.ThemeIcon?l.iconPath:void 0}createHandle(l,{id:w,label:t,resourceUri:u},i,n){if(w)return`${g.ID_HANDLE_PREFIX}/${w}`;const s=d(t,this.extension),a=i?i.item.handle:g.LABEL_HANDLE_PREFIX;let o=s?s.label:u?(0,S.basename)(u):"";o=o.indexOf("/")!==-1?o.replace("/","//"):o;const v=this.nodes.has(l)?this.nodes.get(l).item.handle:void 0,p=this.getChildrenNodes(i)||[];let T,N=0;do{if(T=`${a}/${N}:${o}`,n||!this.elements.has(T)||v===T)break;N++}while(N<=p.length);return T}getLightIconPath(l){if(l.iconPath&&!(l.iconPath instanceof P.ThemeIcon))return typeof l.iconPath=="string"||M.URI.isUri(l.iconPath)?this.getIconPath(l.iconPath):this.getIconPath(l.iconPath.light)}getDarkIconPath(l){if(l.iconPath&&!(l.iconPath instanceof P.ThemeIcon)&&l.iconPath.dark)return this.getIconPath(l.iconPath.dark)}getIconPath(l){return M.URI.isUri(l)?l:M.URI.file(l)}addNodeToCache(l,w){this.elements.set(w.item.handle,l),this.nodes.set(l,w)}updateNodeCache(l,w,t,u){this.elements.delete(w.item.handle),this.nodes.delete(l),w.item.handle!==t.item.handle&&this.elements.delete(t.item.handle),this.addNodeToCache(l,w);const i=this.getChildrenNodes(u)||[],n=i.filter(s=>s.item.handle===t.item.handle)[0];n&&i.splice(i.indexOf(n),1,w)}addNodeToParentCache(l,w){w?(w.children||(w.children=[]),w.children.push(l)):(this.roots||(this.roots=[]),this.roots.push(l))}clearChildren(l){if(l){const w=this.nodes.get(l);if(w){if(w.children)for(const t of w.children){const u=this.elements.get(t.item.handle);u&&this.clear(u)}w.children=void 0}}else this.clearAll()}clear(l){const w=this.nodes.get(l);if(w){if(w.children)for(const t of w.children){const u=this.elements.get(t.item.handle);u&&this.clear(u)}this.nodes.delete(l),this.elements.delete(w.item.handle),w.dispose()}}clearAll(){this.roots=void 0,this.elements.clear(),this.nodes.forEach(l=>l.dispose()),this.nodes.clear()}dispose(){this._refreshCancellationSource.dispose(),this.clearAll()}}g.LABEL_HANDLE_PREFIX="0",g.ID_HANDLE_PREFIX="1"}),define(Ce[237],Ie([1,0,20,12,5,29,2,122,247,111,120,35,4,92,190,189,37,191,32,193,194,195,178,196,50,33,198,199,202,204,206,100,181,210,211,212,70,53,215,236,8,6,218,54,99,31,162,201,87,97,102,104,105,14,46,11,28,207,176,62,67,187,216,71,52,221,219,220,188,36,213,217,69,51,88,208,101,209,13,83,180,159,200,7,25,164,98,68]),function(ie,e,r,y,S,M,_,A,b,P,O,E,m,k,f,c,d,h,g,C,l,w,t,u,i,n,s,a,o,v,p,T,N,V,B,D,z,L,R,K,W,$,G,ne,ge,oe,Ee,ce,me,ee,be,_e,Fe,Be,Xe,ke,ye,De,ae,ue,Z,J,I,U,H,j,se,le,Y,ve,pe,Me,xe,Ye,Ge,Te,rt,X,Q,he,Ue,je,Ze,Ke,Ve,it,st,dt){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.createApiFactoryAndRegisterActors=void 0;function yt(et){const ut=et.get(ye.IExtHostInitDataService),Ot=et.get(ve.IExtHostFileSystemInfo),Vt=et.get(H.IExtHostConsumerFileSystem),At=et.get(n.IExtHostExtensionService),ft=et.get(oe.IExtHostWorkspace),It=et.get(Ge.IExtHostTelemetry),Lt=et.get(g.IExtHostConfiguration),xt=et.get(Xe.IURITransformerService),qe=et.get(ke.IExtHostRpcService),Ft=et.get(z.IExtHostStorage),kt=et.get(U.IExtensionStoragePaths),Nt=et.get(Be.ILoggerService),gt=et.get(Be.ILogService),Se=et.get(ue.IExtHostTunnelService),Pe=et.get(st.IExtHostTelemetryLogService),fe=et.get(Z.IExtHostApiDeprecationService),q=et.get(ge.IExtHostWindow),Ae=et.get(xe.IExtHostSecretState),Le=et.get(Ye.IExtHostEditorTabs);qe.set(m.ExtHostContext.ExtHostFileSystemInfo,Ot),qe.set(m.ExtHostContext.ExtHostLogLevelServiceShape,Nt),qe.set(m.ExtHostContext.ExtHostWorkspace,ft),qe.set(m.ExtHostContext.ExtHostConfiguration,Lt),qe.set(m.ExtHostContext.ExtHostExtensionService,At),qe.set(m.ExtHostContext.ExtHostStorage,Ft),qe.set(m.ExtHostContext.ExtHostTunnelService,Se),qe.set(m.ExtHostContext.ExtHostWindow,q),qe.set(m.ExtHostContext.ExtHostSecretState,Ae),qe.set(m.ExtHostContext.ExtHostTelemetry,It),qe.set(m.ExtHostContext.ExtHostEditorTabs,Le);const nt=qe.set(m.ExtHostContext.ExtHostDecorations,et.get(ee.IExtHostDecorations)),We=qe.set(m.ExtHostContext.ExtHostDocumentsAndEditors,et.get(i.IExtHostDocumentsAndEditors)),tt=qe.set(m.ExtHostContext.ExtHostCommands,et.get(d.IExtHostCommands)),ct=qe.set(m.ExtHostContext.ExtHostTerminalService,et.get(L.IExtHostTerminalService)),mt=qe.set(m.ExtHostContext.ExtHostDebugService,et.get(_e.IExtHostDebugService)),Dt=qe.set(m.ExtHostContext.ExtHostSearch,et.get(Fe.IExtHostSearch)),Et=qe.set(m.ExtHostContext.ExtHostTask,et.get(be.IExtHostTask)),wt=qe.set(m.ExtHostContext.ExtHostOutputService,et.get(T.IExtHostOutputService)),Tt=qe.set(m.ExtHostContext.ExtHostLocalization,et.get(dt.IExtHostLocalizationService)),bt=qe.set(m.ExtHostContext.ExtHostUrls,new G.ExtHostUrls(qe)),Ct=qe.set(m.ExtHostContext.ExtHostDocuments,new u.ExtHostDocuments(qe,We)),Yt=qe.set(m.ExtHostContext.ExtHostDocumentContentProviders,new w.ExtHostDocumentContentProvider(qe,We,gt)),qt=qe.set(m.ExtHostContext.ExtHostDocumentSaveParticipant,new t.ExtHostDocumentSaveParticipant(gt,Ct,qe.getProxy(m.MainContext.MainThreadBulkEdits))),vt=qe.set(m.ExtHostContext.ExtHostNotebook,new De.ExtHostNotebookController(qe,tt,We,Ct)),ti=qe.set(m.ExtHostContext.ExtHostNotebookDocuments,new je.ExtHostNotebookDocuments(vt)),ii=qe.set(m.ExtHostContext.ExtHostNotebookEditors,new Ue.ExtHostNotebookEditors(gt,vt)),ni=qe.set(m.ExtHostContext.ExtHostNotebookKernels,new Te.ExtHostNotebookKernels(qe,ut,vt,tt,gt)),mi=qe.set(m.ExtHostContext.ExtHostNotebookRenderers,new X.ExtHostNotebookRenderers(qe,vt)),_t=qe.set(m.ExtHostContext.ExtHostEditors,new R.ExtHostEditors(qe,We)),ri=qe.set(m.ExtHostContext.ExtHostTreeViews,new K.ExtHostTreeViews(qe.getProxy(m.MainContext.MainThreadTreeViews),tt,gt)),Oi=qe.set(m.ExtHostContext.ExtHostEditorInsets,new Ee.ExtHostEditorInsets(qe.getProxy(m.MainContext.MainThreadEditorInsets),_t,ut.remote)),Jt=qe.set(m.ExtHostContext.ExtHostDiagnostics,new C.ExtHostDiagnostics(qe,gt,Ot)),zt=qe.set(m.ExtHostContext.ExtHostLanguages,new v.ExtHostLanguages(qe,Ct,tt.converter,xt)),lt=qe.set(m.ExtHostContext.ExtHostLanguageFeatures,new o.ExtHostLanguageFeatures(qe,xt,Ct,tt,Jt,gt,fe)),gi=qe.set(m.ExtHostContext.ExtHostFileSystem,new s.ExtHostFileSystem(qe,lt)),$t=qe.set(m.ExtHostContext.ExtHostFileSystemEventService,new a.ExtHostFileSystemEventService(qe,gt,We)),Kt=qe.set(m.ExtHostContext.ExtHostQuickOpen,(0,V.createExtHostQuickOpen)(qe,ft,tt)),si=qe.set(m.ExtHostContext.ExtHostSCM,new B.ExtHostSCM(qe,tt,gt)),pi=qe.set(m.ExtHostContext.ExtHostComments,(0,h.createExtHostComments)(qe,tt,Ct)),oi=qe.set(m.ExtHostContext.ExtHostProgress,new N.ExtHostProgress(qe.getProxy(m.MainContext.MainThreadProgress))),vi=qe.set(m.ExtHostContext.ExtHosLabelService,new ce.ExtHostLabelService(qe)),Ci=qe.set(m.ExtHostContext.ExtHostTheming,new ae.ExtHostTheming(qe)),ai=qe.set(m.ExtHostContext.ExtHostAuthentication,new J.ExtHostAuthentication(qe)),Ei=qe.set(m.ExtHostContext.ExtHostTimeline,new I.ExtHostTimeline(qe,tt)),Zt=qe.set(m.ExtHostContext.ExtHostWebviews,new ne.ExtHostWebviews(qe,ut.remote,ft,gt,fe)),ei=qe.set(m.ExtHostContext.ExtHostWebviewPanels,new le.ExtHostWebviewPanels(qe,Zt,ft)),bi=qe.set(m.ExtHostContext.ExtHostCustomEditors,new se.ExtHostCustomEditors(qe,Ct,kt,Zt,ei)),Fi=qe.set(m.ExtHostContext.ExtHostWebviewViews,new j.ExtHostWebviewViews(qe,Zt)),Gt=qe.set(m.ExtHostContext.ExtHostTesting,new pe.ExtHostTesting(qe,tt,We)),wi=qe.set(m.ExtHostContext.ExtHostUriOpeners,new Me.ExtHostUriOpeners(qe));qe.set(m.ExtHostContext.ExtHostInteractive,new Ze.ExtHostInteractive(qe,vt,We,tt,gt));const Ni=Object.values(m.ExtHostContext);qe.assertRegistered(Ni);const Mi=new Y.ExtHostBulkEdits(qe,We),Li=new c.ExtHostClipboard(qe),Si=new p.ExtHostMessageService(qe,gt),Ii=new l.ExtHostDialogs(qe),ki=new D.ExtHostStatusBar(qe,tt.converter);return f.ExtHostApiCommands.register(tt),function(Ne,Ut,Ti){const pt=function(){let re=!Ne.isUnderDevelopment;function de(){re||(gt.info(`Extension '${Ne.identifier.value}' uses a document selector without scheme. Learn more about this: https://go.microsoft.com/fwlink/?linkid=872305`),re=!0)}return function Re(ot){if(Array.isArray(ot))ot.forEach(Re);else if(typeof ot=="string")de();else{const St=ot;typeof St.scheme>"u"&&de(),typeof St.exclusive=="boolean"&&(0,Ve.checkProposedApiEnabled)(Ne,"documentFiltersExclusive")}return ot}}(),Ui={getSession(re,de,Re){return ai.getSession(Ne,re,de,Re)},async hasSession(re,de){return(0,Ve.checkProposedApiEnabled)(Ne,"authSession"),!!await ai.getSession(Ne,re,de,{silent:!0})},get onDidChangeSessions(){return ai.onDidChangeSessions},registerAuthenticationProvider(re,de,Re,ot){return ai.registerAuthenticationProvider(re,de,Re,ot)}},ci={registerCommand(re,de,Re){return tt.registerCommand(!0,re,de,Re,void 0,Ne)},registerTextEditorCommand(re,de,Re){return tt.registerCommand(!0,re,(...ot)=>{const St=_t.getActiveTextEditor();if(!St){gt.warn("Cannot execute "+re+" because there is no active text editor.");return}return St.edit(Pt=>{de.apply(Re,[St,Pt,...ot])}).then(Pt=>{Pt||gt.warn("Edits from command "+re+" were not applied.")},Pt=>{gt.warn("An error occurred while running command "+re,Pt)})},void 0,void 0,Ne)},registerDiffInformationCommand:(re,de,Re)=>((0,Ve.checkProposedApiEnabled)(Ne,"diffCommand"),tt.registerCommand(!0,re,async(...ot)=>{const St=We.activeEditor(!0);if(!St){gt.warn("Cannot execute "+re+" because there is no active text editor.");return}const Pt=await _t.getDiffInformation(St.id);de.apply(Re,[Pt,...ot])},void 0,void 0,Ne)),executeCommand(re,...de){return tt.executeCommand(re,...de)},getCommands(re=!1){return tt.getCommands(re)}},Pi={get machineId(){return ut.telemetryInfo.machineId},get sessionId(){return ut.telemetryInfo.sessionId},get language(){return ut.environment.appLanguage},get appName(){return ut.environment.appName},get appRoot(){return ut.environment.appRoot?.fsPath??""},get appHost(){return ut.environment.appHost},get uriScheme(){return ut.environment.appUriScheme},get clipboard(){return Li.value},get shell(){return ct.getDefaultShell(!1)},get onDidChangeShell(){return(0,Ve.checkProposedApiEnabled)(Ne,"envShellEvent"),ct.onDidChangeShell},get isTelemetryEnabled(){return It.getTelemetryConfiguration()},get onDidChangeTelemetryEnabled(){return It.onDidChangeTelemetryEnabled},get telemetryConfiguration(){return(0,Ve.checkProposedApiEnabled)(Ne,"telemetry"),It.getTelemetryDetails()},get onDidChangeTelemetryConfiguration(){return(0,Ve.checkProposedApiEnabled)(Ne,"telemetry"),It.onDidChangeTelemetryConfiguration},get isNewAppInstall(){const re=Date.now()-new Date(ut.telemetryInfo.firstSessionDate).getTime();return isNaN(re)?!1:re<1e3*60*60*24},openExternal(re,de){return q.openUri(re,{allowTunneling:!!ut.remote.authority,allowContributedOpeners:de?.allowContributedOpeners})},async asExternalUri(re){if(re.scheme===ut.environment.appUriScheme)return bt.createAppUri(re);try{return await q.asExternalUri(re,{allowTunneling:!!ut.remote.authority})}catch(de){if((0,he.matchesScheme)(re,Q.Schemas.http)||(0,he.matchesScheme)(re,Q.Schemas.https))return re;throw de}},get remoteName(){return(0,me.getRemoteName)(ut.remote.authority)},get remoteAuthority(){return(0,Ve.checkProposedApiEnabled)(Ne,"resolvers"),ut.remote.authority},get uiKind(){return ut.uiKind}};ut.environment.extensionTestsLocationURI||Object.freeze(Pi);const Bi={createTestController(re,de,Re){return Gt.createTestController(re,de,Re)},createTestObserver(){return(0,Ve.checkProposedApiEnabled)(Ne,"testObserver"),Gt.createTestObserver()},runTests(re){return(0,Ve.checkProposedApiEnabled)(Ne,"testObserver"),Gt.runTests(re)},get onDidChangeTestResults(){return(0,Ve.checkProposedApiEnabled)(Ne,"testObserver"),Gt.onResultsChanged},get testResults(){return(0,Ve.checkProposedApiEnabled)(Ne,"testObserver"),Gt.results}},li=ut.remote.isRemote?$.ExtensionKind.Workspace:$.ExtensionKind.UI,xi={getExtension(re,de){(0,Ve.isProposedApiEnabled)(Ne,"extensionsAny")||(de=!1);const Re=Ut.mine.getExtensionDescription(re);if(Re)return new n.Extension(At,Ne.identifier,Re,li,!1);if(de){const ot=Ut.all.getExtensionDescription(re);if(ot)return new n.Extension(At,Ne.identifier,ot,li,!0)}},get all(){const re=[];for(const de of Ut.mine.getAllExtensionDescriptions())re.push(new n.Extension(At,Ne.identifier,de,li,!1));return re},get allAcrossExtensionHosts(){(0,Ve.checkProposedApiEnabled)(Ne,"extensionsAny");const re=new Ve.ExtensionIdentifierSet(Ut.mine.getAllExtensionDescriptions().map(Re=>Re.identifier)),de=[];for(const Re of Ut.all.getAllExtensionDescriptions()){const ot=!re.has(Re.identifier);de.push(new n.Extension(At,Ne.identifier,Re,li,ot))}return de},get onDidChange(){return(0,Ve.isProposedApiEnabled)(Ne,"extensionsAny")?S.Event.any(Ut.mine.onDidChange,Ut.all.onDidChange):Ut.mine.onDidChange}},_i={createDiagnosticCollection(re){return Jt.createDiagnosticCollection(Ne.identifier,re)},get onDidChangeDiagnostics(){return Jt.onDidChangeDiagnostics},getDiagnostics:re=>Jt.getDiagnostics(re),getLanguages(){return zt.getLanguages()},setTextDocumentLanguage(re,de){return zt.changeLanguage(re.uri,de)},match(re,de){const Re=Ct.getDocumentData(de.uri)?.notebook;return(0,O.score)(W.LanguageSelector.from(re),de.uri,de.languageId,!0,Re?.uri,Re?.notebookType)},registerCodeActionsProvider(re,de,Re){return lt.registerCodeActionProvider(Ne,pt(re),de,Re)},registerDocumentPasteEditProvider(re,de,Re){return(0,Ve.checkProposedApiEnabled)(Ne,"documentPaste"),lt.registerDocumentPasteEditProvider(Ne,pt(re),de,Re)},registerCodeLensProvider(re,de){return lt.registerCodeLensProvider(Ne,pt(re),de)},registerDefinitionProvider(re,de){return lt.registerDefinitionProvider(Ne,pt(re),de)},registerDeclarationProvider(re,de){return lt.registerDeclarationProvider(Ne,pt(re),de)},registerImplementationProvider(re,de){return lt.registerImplementationProvider(Ne,pt(re),de)},registerTypeDefinitionProvider(re,de){return lt.registerTypeDefinitionProvider(Ne,pt(re),de)},registerHoverProvider(re,de){return lt.registerHoverProvider(Ne,pt(re),de,Ne.identifier)},registerEvaluatableExpressionProvider(re,de){return lt.registerEvaluatableExpressionProvider(Ne,pt(re),de,Ne.identifier)},registerInlineValuesProvider(re,de){return lt.registerInlineValuesProvider(Ne,pt(re),de,Ne.identifier)},registerDocumentHighlightProvider(re,de){return lt.registerDocumentHighlightProvider(Ne,pt(re),de)},registerLinkedEditingRangeProvider(re,de){return lt.registerLinkedEditingRangeProvider(Ne,pt(re),de)},registerReferenceProvider(re,de){return lt.registerReferenceProvider(Ne,pt(re),de)},registerRenameProvider(re,de){return lt.registerRenameProvider(Ne,pt(re),de)},registerDocumentSymbolProvider(re,de,Re){return lt.registerDocumentSymbolProvider(Ne,pt(re),de,Re)},registerWorkspaceSymbolProvider(re){return lt.registerWorkspaceSymbolProvider(Ne,re)},registerDocumentFormattingEditProvider(re,de){return lt.registerDocumentFormattingEditProvider(Ne,pt(re),de)},registerDocumentRangeFormattingEditProvider(re,de){return lt.registerDocumentRangeFormattingEditProvider(Ne,pt(re),de)},registerOnTypeFormattingEditProvider(re,de,Re,...ot){return lt.registerOnTypeFormattingEditProvider(Ne,pt(re),de,[Re].concat(ot))},registerDocumentSemanticTokensProvider(re,de,Re){return lt.registerDocumentSemanticTokensProvider(Ne,pt(re),de,Re)},registerDocumentRangeSemanticTokensProvider(re,de,Re){return lt.registerDocumentRangeSemanticTokensProvider(Ne,pt(re),de,Re)},registerSignatureHelpProvider(re,de,Re,...ot){return typeof Re=="object"?lt.registerSignatureHelpProvider(Ne,pt(re),de,Re):lt.registerSignatureHelpProvider(Ne,pt(re),de,typeof Re>"u"?[]:[Re,...ot])},registerCompletionItemProvider(re,de,...Re){return lt.registerCompletionItemProvider(Ne,pt(re),de,Re)},registerInlineCompletionItemProvider(re,de){return de.handleDidShowCompletionItem&&(0,Ve.checkProposedApiEnabled)(Ne,"inlineCompletionsAdditions"),lt.registerInlineCompletionsProvider(Ne,pt(re),de)},registerInlineCompletionItemProviderNew(re,de){if((0,Ve.checkProposedApiEnabled)(Ne,"inlineCompletionsNew"),de.handleDidShowCompletionItem&&!(0,Ve.isProposedApiEnabled)(Ne,"inlineCompletionsAdditions"))throw new Error(`When the method "handleDidShowCompletionItem" is implemented on a provider, the usage of the proposed api 'inlineCompletionsAdditions' must be declared!`);return lt.registerInlineCompletionsProviderNew(Ne,pt(re),de)},registerDocumentLinkProvider(re,de){return lt.registerDocumentLinkProvider(Ne,pt(re),de)},registerColorProvider(re,de){return lt.registerColorProvider(Ne,pt(re),de)},registerFoldingRangeProvider(re,de){return lt.registerFoldingRangeProvider(Ne,pt(re),de)},registerSelectionRangeProvider(re,de){return lt.registerSelectionRangeProvider(Ne,re,de)},registerCallHierarchyProvider(re,de){return lt.registerCallHierarchyProvider(Ne,re,de)},registerTypeHierarchyProvider(re,de){return lt.registerTypeHierarchyProvider(Ne,re,de)},setLanguageConfiguration:(re,de)=>lt.setLanguageConfiguration(Ne,re,de),getTokenInformationAtPosition(re,de){return(0,Ve.checkProposedApiEnabled)(Ne,"tokenInformation"),zt.tokenAtPosition(re,de)},registerInlayHintsProvider(re,de){return lt.registerInlayHintsProvider(Ne,re,de)},createLanguageStatusItem(re,de){return zt.createLanguageStatusItem(Ne,re,de)},registerDocumentDropEditProvider(re,de){return lt.registerDocumentOnDropEditProvider(Ne,re,de)}},zi={get activeTextEditor(){return _t.getActiveTextEditor()},get visibleTextEditors(){return _t.getVisibleTextEditors()},get activeTerminal(){return ct.activeTerminal},get terminals(){return ct.terminals},async showTextDocument(re,de,Re){const ot=await(_.URI.isUri(re)?Promise.resolve(Wt.openTextDocument(re)):Promise.resolve(re));return _t.showTextDocument(ot,de,Re)},createTextEditorDecorationType(re){return _t.createTextEditorDecorationType(Ne,re)},onDidChangeActiveTextEditor(re,de,Re){return _t.onDidChangeActiveTextEditor(re,de,Re)},onDidChangeVisibleTextEditors(re,de,Re){return _t.onDidChangeVisibleTextEditors(re,de,Re)},onDidChangeTextEditorSelection(re,de,Re){return _t.onDidChangeTextEditorSelection(re,de,Re)},onDidChangeTextEditorOptions(re,de,Re){return _t.onDidChangeTextEditorOptions(re,de,Re)},onDidChangeTextEditorVisibleRanges(re,de,Re){return _t.onDidChangeTextEditorVisibleRanges(re,de,Re)},onDidChangeTextEditorViewColumn(re,de,Re){return _t.onDidChangeTextEditorViewColumn(re,de,Re)},onDidCloseTerminal(re,de,Re){return ct.onDidCloseTerminal(re,de,Re)},onDidOpenTerminal(re,de,Re){return ct.onDidOpenTerminal(re,de,Re)},onDidChangeActiveTerminal(re,de,Re){return ct.onDidChangeActiveTerminal(re,de,Re)},onDidChangeTerminalDimensions(re,de,Re){return(0,Ve.checkProposedApiEnabled)(Ne,"terminalDimensions"),ct.onDidChangeTerminalDimensions(re,de,Re)},onDidChangeTerminalState(re,de,Re){return ct.onDidChangeTerminalState(re,de,Re)},onDidWriteTerminalData(re,de,Re){return(0,Ve.checkProposedApiEnabled)(Ne,"terminalDataWriteEvent"),ct.onDidWriteTerminalData(re,de,Re)},get state(){return q.state},onDidChangeWindowState(re,de,Re){return q.onDidChangeWindowState(re,de,Re)},showInformationMessage(re,...de){return Si.showMessage(Ne,M.default.Info,re,de[0],de.slice(1))},showWarningMessage(re,...de){return Si.showMessage(Ne,M.default.Warning,re,de[0],de.slice(1))},showErrorMessage(re,...de){return Si.showMessage(Ne,M.default.Error,re,de[0],de.slice(1))},showQuickPick(re,de,Re){return Kt.showQuickPick(re,de,Re)},showWorkspaceFolderPick(re){return Kt.showWorkspaceFolderPick(re)},showInputBox(re,de){return Kt.showInput(re,de)},showOpenDialog(re){return Ii.showOpenDialog(re)},showSaveDialog(re){return Ii.showSaveDialog(re)},createStatusBarItem(re,de,Re){let ot,St,Pt;return typeof re=="string"?(ot=re,St=de,Pt=Re):(St=re,Pt=de),ki.createStatusBarEntry(Ne,ot,St,Pt)},setStatusBarMessage(re,de){return ki.setStatusBarMessage(re,de)},withScmProgress(re){return fe.report("window.withScmProgress",Ne,"Use 'withProgress' instead."),oi.withProgress(Ne,{location:$.ProgressLocation.SourceControl},(de,Re)=>re({report(ot){}}))},withProgress(re,de){return oi.withProgress(Ne,re,de)},createOutputChannel(re,de){return wt.createOutputChannel(re,de,Ne)},createWebviewPanel(re,de,Re,ot){return ei.createWebviewPanel(Ne,re,de,Re,ot)},createWebviewTextEditorInset(re,de,Re,ot){return(0,Ve.checkProposedApiEnabled)(Ne,"editorInsets"),Oi.createWebviewEditorInset(re,de,Re,ot,Ne)},createTerminal(re,de,Re){return typeof re=="object"?"pty"in re?ct.createExtensionTerminal(re):ct.createTerminalFromOptions(re):ct.createTerminal(re,de,Re)},registerTerminalLinkProvider(re){return ct.registerLinkProvider(re)},registerTerminalProfileProvider(re,de){return ct.registerProfileProvider(Ne,re,de)},registerTreeDataProvider(re,de){return ri.registerTreeDataProvider(re,de,Ne)},createTreeView(re,de){return ri.createTreeView(re,de,Ne)},registerWebviewPanelSerializer:(re,de)=>ei.registerWebviewPanelSerializer(Ne,re,de),registerCustomEditorProvider:(re,de,Re={})=>bi.registerCustomEditorProvider(Ne,re,de,Re),registerFileDecorationProvider(re){return nt.registerFileDecorationProvider(re,Ne.identifier)},registerUriHandler(re){return bt.registerUriHandler(Ne.identifier,re)},createQuickPick(){return Kt.createQuickPick(Ne)},createInputBox(){return Kt.createInputBox(Ne)},get activeColorTheme(){return Ci.activeColorTheme},onDidChangeActiveColorTheme(re,de,Re){return Ci.onDidChangeActiveColorTheme(re,de,Re)},registerWebviewViewProvider(re,de,Re){return Fi.registerWebviewViewProvider(Ne,re,de,Re?.webviewOptions)},get activeNotebookEditor(){return vt.activeNotebookEditor},onDidChangeActiveNotebookEditor(re,de,Re){return vt.onDidChangeActiveNotebookEditor(re,de,Re)},get visibleNotebookEditors(){return vt.visibleNotebookEditors},get onDidChangeVisibleNotebookEditors(){return vt.onDidChangeVisibleNotebookEditors},onDidChangeNotebookEditorSelection(re,de,Re){return ii.onDidChangeNotebookEditorSelection(re,de,Re)},onDidChangeNotebookEditorVisibleRanges(re,de,Re){return ii.onDidChangeNotebookEditorVisibleRanges(re,de,Re)},showNotebookDocument(re,de){return _.URI.isUri(re)&&fe.report("window.showNotebookDocument(uri)",Ne,"Please use 'workspace.openNotebookDocument' and 'window.showNotebookDocument'"),vt.showNotebookDocument(re,de)},registerExternalUriOpener(re,de,Re){return(0,Ve.checkProposedApiEnabled)(Ne,"externalUriOpener"),wi.registerExternalUriOpener(Ne.identifier,re,de,Re)},get tabGroups(){return Le.tabGroups},logTelemetryToOutputChannel(re,de){(0,Ve.checkProposedApiEnabled)(Ne,"telemetryLog"),Pe.logToTelemetryOutputChannel(Ne,re,de)}},Wt={get rootPath(){return fe.report("workspace.rootPath",Ne,"Please use 'workspace.workspaceFolders' instead. More details: https://aka.ms/vscode-eliminating-rootpath"),ft.getPath()},set rootPath(re){throw y.readonly()},getWorkspaceFolder(re){return ft.getWorkspaceFolder(re)},get workspaceFolders(){return ft.getWorkspaceFolders()},get name(){return ft.name},set name(re){throw y.readonly()},get workspaceFile(){return ft.workspaceFile},set workspaceFile(re){throw y.readonly()},updateWorkspaceFolders:(re,de,...Re)=>ft.updateWorkspaceFolders(Ne,re,de||0,...Re),onDidChangeWorkspaceFolders:function(re,de,Re){return ft.onDidChangeWorkspace(re,de,Re)},asRelativePath:(re,de)=>ft.getRelativePath(re,de),findFiles:(re,de,Re,ot)=>ft.findFiles(re,de,Re,Ne.identifier,ot),findTextInFiles:(re,de,Re,ot)=>{(0,Ve.checkProposedApiEnabled)(Ne,"findTextInFiles");let St,Pt;return typeof de=="object"?(St=de,Pt=Re):(St={},Pt=de,ot=Re),ft.findTextInFiles(re,St||{},Pt,Ne.identifier,ot)},saveAll:re=>ft.saveAll(re),applyEdit(re,de){return Mi.applyWorkspaceEdit(re,Ne,de)},createFileSystemWatcher:(re,de,Re,ot)=>$t.createFileSystemWatcher(ft,Ne,re,de,Re,ot),get textDocuments(){return Ct.getAllDocumentData().map(re=>re.document)},set textDocuments(re){throw y.readonly()},openTextDocument(re){let de;const Re=re;if(typeof re=="string")de=Promise.resolve(_.URI.file(re));else if(_.URI.isUri(re))de=Promise.resolve(re);else if(!Re||typeof Re=="object")de=Ct.createDocumentData(Re);else throw new Error("illegal argument - uriOrFileNameOrOptions");return de.then(ot=>Ct.ensureDocumentData(ot).then(St=>St.document))},onDidOpenTextDocument:(re,de,Re)=>Ct.onDidAddDocument(re,de,Re),onDidCloseTextDocument:(re,de,Re)=>Ct.onDidRemoveDocument(re,de,Re),onDidChangeTextDocument:(re,de,Re)=>Ct.onDidChangeDocument(re,de,Re),onDidSaveTextDocument:(re,de,Re)=>Ct.onDidSaveDocument(re,de,Re),onWillSaveTextDocument:(re,de,Re)=>qt.getOnWillSaveTextDocumentEvent(Ne)(re,de,Re),get notebookDocuments(){return vt.notebookDocuments.map(re=>re.apiNotebook)},async openNotebookDocument(re,de){let Re;if(_.URI.isUri(re))Re=re,await vt.openNotebookDocument(re);else if(typeof re=="string")Re=_.URI.revive(await vt.createNotebookDocument({viewType:re,content:de}));else throw new Error("Invalid arguments");return vt.getNotebookDocument(Re).apiNotebook},onDidSaveNotebookDocument(re,de,Re){return ti.onDidSaveNotebookDocument(re,de,Re)},onDidChangeNotebookDocument(re,de,Re){return ti.onDidChangeNotebookDocument(re,de,Re)},get onDidOpenNotebookDocument(){return vt.onDidOpenNotebookDocument},get onDidCloseNotebookDocument(){return vt.onDidCloseNotebookDocument},registerNotebookSerializer(re,de,Re,ot){return vt.registerNotebookSerializer(Ne,re,de,Re,(0,Ve.isProposedApiEnabled)(Ne,"notebookLiveShare")?ot:void 0)},registerNotebookContentProvider:(re,de,Re,ot)=>((0,Ve.checkProposedApiEnabled)(Ne,"notebookContentProvider"),fe.report("workspace.registerNotebookContentProvider",Ne,"The notebookContentProvider API is not on track for finalization and will be removed."),vt.registerNotebookContentProvider(Ne,re,de,Re,(0,Ve.isProposedApiEnabled)(Ne,"notebookLiveShare")?ot:void 0)),onDidChangeConfiguration:(re,de,Re)=>Ti.onDidChangeConfiguration(re,de,Re),getConfiguration(re,de){return de=arguments.length===1?void 0:de,Ti.getConfiguration(re,de,Ne)},registerTextDocumentContentProvider(re,de){return Yt.registerTextDocumentContentProvider(re,de)},registerTaskProvider:(re,de)=>(fe.report("window.registerTaskProvider",Ne,"Use the corresponding function on the 'tasks' namespace instead"),Et.registerTaskProvider(Ne,re,de)),registerFileSystemProvider(re,de,Re){return(0,Ke.combinedDisposable)(gi.registerFileSystemProvider(Ne,re,de,Re),Vt.addFileSystemProvider(re,de))},get fs(){return Vt.value},registerFileSearchProvider:(re,de)=>((0,Ve.checkProposedApiEnabled)(Ne,"fileSearchProvider"),Dt.registerFileSearchProvider(re,de)),registerTextSearchProvider:(re,de)=>((0,Ve.checkProposedApiEnabled)(Ne,"textSearchProvider"),Dt.registerTextSearchProvider(re,de)),registerRemoteAuthorityResolver:(re,de)=>((0,Ve.checkProposedApiEnabled)(Ne,"resolvers"),At.registerRemoteAuthorityResolver(re,de)),registerResourceLabelFormatter:re=>((0,Ve.checkProposedApiEnabled)(Ne,"resolvers"),vi.$registerResourceLabelFormatter(re)),onDidCreateFiles:(re,de,Re)=>$t.onDidCreateFile(re,de,Re),onDidDeleteFiles:(re,de,Re)=>$t.onDidDeleteFile(re,de,Re),onDidRenameFiles:(re,de,Re)=>$t.onDidRenameFile(re,de,Re),onWillCreateFiles:(re,de,Re)=>$t.getOnWillCreateFileEvent(Ne)(re,de,Re),onWillDeleteFiles:(re,de,Re)=>$t.getOnWillDeleteFileEvent(Ne)(re,de,Re),onWillRenameFiles:(re,de,Re)=>$t.getOnWillRenameFileEvent(Ne)(re,de,Re),openTunnel:re=>((0,Ve.checkProposedApiEnabled)(Ne,"resolvers"),Se.openTunnel(Ne,re).then(de=>{if(!de)throw new Error("cannot open tunnel");return de})),get tunnels(){return(0,Ve.checkProposedApiEnabled)(Ne,"resolvers"),Se.getTunnels()},onDidChangeTunnels:(re,de,Re)=>((0,Ve.checkProposedApiEnabled)(Ne,"resolvers"),Se.onDidChangeTunnels(re,de,Re)),registerPortAttributesProvider:(re,de)=>((0,Ve.checkProposedApiEnabled)(Ne,"portsAttributes"),Se.registerPortsAttributesProvider(re,de)),registerTimelineProvider:(re,de)=>((0,Ve.checkProposedApiEnabled)(Ne,"timeline"),Ei.registerTimelineProvider(re,de,Ne.identifier,tt.converter)),get isTrusted(){return ft.trusted},requestWorkspaceTrust:re=>((0,Ve.checkProposedApiEnabled)(Ne,"workspaceTrust"),ft.requestWorkspaceTrust(re)),onDidGrantWorkspaceTrust:(re,de,Re)=>ft.onDidGrantWorkspaceTrust(re,de,Re),registerEditSessionIdentityProvider:(re,de)=>((0,Ve.checkProposedApiEnabled)(Ne,"editSessionIdentityProvider"),ft.registerEditSessionIdentityProvider(re,de))},ui={get inputBox(){return fe.report("scm.inputBox",Ne,"Use 'SourceControl.inputBox' instead"),si.getLastInputBox(Ne)},createSourceControl(re,de,Re){return si.createSourceControl(Ne,re,de,Re)}},$i={createCommentController(re,de){return pi.createCommentController(Ne,re,de)}},Mt={get activeDebugSession(){return mt.activeDebugSession},get activeDebugConsole(){return mt.activeDebugConsole},get breakpoints(){return mt.breakpoints},onDidStartDebugSession(re,de,Re){return mt.onDidStartDebugSession(re,de,Re)},onDidTerminateDebugSession(re,de,Re){return mt.onDidTerminateDebugSession(re,de,Re)},onDidChangeActiveDebugSession(re,de,Re){return mt.onDidChangeActiveDebugSession(re,de,Re)},onDidReceiveDebugSessionCustomEvent(re,de,Re){return mt.onDidReceiveDebugSessionCustomEvent(re,de,Re)},onDidChangeBreakpoints(re,de,Re){return mt.onDidChangeBreakpoints(re,de,Re)},registerDebugConfigurationProvider(re,de,Re){return mt.registerDebugConfigurationProvider(re,de,Re||it.DebugConfigurationProviderTriggerKind.Initial)},registerDebugAdapterDescriptorFactory(re,de){return mt.registerDebugAdapterDescriptorFactory(Ne,re,de)},registerDebugAdapterTrackerFactory(re,de){return mt.registerDebugAdapterTrackerFactory(re,de)},startDebugging(re,de,Re){return!Re||typeof Re=="object"&&"configuration"in Re?mt.startDebugging(re,de,{parentSession:Re}):mt.startDebugging(re,de,Re||{})},stopDebugging(re){return mt.stopDebugging(re)},addBreakpoints(re){return mt.addBreakpoints(re)},removeBreakpoints(re){return mt.removeBreakpoints(re)},asDebugSourceUri(re,de){return mt.asDebugSourceUri(re,de)}},di={registerTaskProvider:(re,de)=>Et.registerTaskProvider(Ne,re,de),fetchTasks:re=>Et.fetchTasks(re),executeTask:re=>Et.executeTask(Ne,re),get taskExecutions(){return Et.taskExecutions},onDidStartTask:(re,de,Re)=>Et.onDidStartTask(re,de,Re),onDidEndTask:(re,de,Re)=>Et.onDidEndTask(re,de,Re),onDidStartTaskProcess:(re,de,Re)=>Et.onDidStartTaskProcess(re,de,Re),onDidEndTaskProcess:(re,de,Re)=>Et.onDidEndTaskProcess(re,de,Re)},Wi={createNotebookController(re,de,Re,ot,St){return ni.createNotebookController(Ne,re,de,Re,ot,(0,Ve.isProposedApiEnabled)(Ne,"notebookMessaging")?St:void 0)},registerNotebookCellStatusBarItemProvider:(re,de)=>vt.registerNotebookCellStatusBarItemProvider(Ne,re,de),createRendererMessaging(re){return mi.createRendererMessaging(Ne,re)},onDidChangeNotebookCellExecutionState(re,de,Re){return(0,Ve.checkProposedApiEnabled)(Ne,"notebookCellExecutionState"),ni.onDidChangeNotebookCellExecutionState(re,de,Re)}},Hi={t(...re){if((0,Ve.checkProposedApiEnabled)(Ne,"localization"),typeof re[0]=="string"){const de=re.shift();return Tt.getMessage(Ne.identifier.value,{message:de,args:re})}return Tt.getMessage(Ne.identifier.value,re[0])},get bundle(){return(0,Ve.checkProposedApiEnabled)(Ne,"localization"),Tt.getBundle(Ne.identifier.value)},get uri(){return(0,Ve.checkProposedApiEnabled)(Ne,"localization"),Tt.getBundleUri(Ne.identifier.value)}};return{version:ut.version,authentication:Ui,commands:ci,comments:$i,debug:Mt,env:Pi,extensions:xi,l10n:Hi,languages:_i,notebooks:Wi,scm:ui,tasks:di,tests:Bi,window:zi,workspace:Wt,Breakpoint:$.Breakpoint,CallHierarchyIncomingCall:$.CallHierarchyIncomingCall,CallHierarchyItem:$.CallHierarchyItem,CallHierarchyOutgoingCall:$.CallHierarchyOutgoingCall,CancellationError:y.CancellationError,CancellationTokenSource:r.CancellationTokenSource,CandidatePortSource:m.CandidatePortSource,CodeAction:$.CodeAction,CodeActionKind:$.CodeActionKind,CodeActionTriggerKind:$.CodeActionTriggerKind,CodeLens:$.CodeLens,Color:$.Color,ColorInformation:$.ColorInformation,ColorPresentation:$.ColorPresentation,ColorThemeKind:$.ColorThemeKind,CommentMode:$.CommentMode,CommentThreadCollapsibleState:$.CommentThreadCollapsibleState,CommentThreadState:$.CommentThreadState,CompletionItem:$.CompletionItem,CompletionItemKind:$.CompletionItemKind,CompletionItemTag:$.CompletionItemTag,CompletionList:$.CompletionList,CompletionTriggerKind:$.CompletionTriggerKind,ConfigurationTarget:$.ConfigurationTarget,CustomExecution:$.CustomExecution,DebugAdapterExecutable:$.DebugAdapterExecutable,DebugAdapterInlineImplementation:$.DebugAdapterInlineImplementation,DebugAdapterNamedPipeServer:$.DebugAdapterNamedPipeServer,DebugAdapterServer:$.DebugAdapterServer,DebugConfigurationProviderTriggerKind:it.DebugConfigurationProviderTriggerKind,DebugConsoleMode:$.DebugConsoleMode,DecorationRangeBehavior:$.DecorationRangeBehavior,Diagnostic:$.Diagnostic,DiagnosticRelatedInformation:$.DiagnosticRelatedInformation,DiagnosticSeverity:$.DiagnosticSeverity,DiagnosticTag:$.DiagnosticTag,Disposable:$.Disposable,DocumentHighlight:$.DocumentHighlight,DocumentHighlightKind:$.DocumentHighlightKind,DocumentLink:$.DocumentLink,DocumentSymbol:$.DocumentSymbol,EndOfLine:$.EndOfLine,EnvironmentVariableMutatorType:$.EnvironmentVariableMutatorType,EvaluatableExpression:$.EvaluatableExpression,InlineValueText:$.InlineValueText,InlineValueVariableLookup:$.InlineValueVariableLookup,InlineValueEvaluatableExpression:$.InlineValueEvaluatableExpression,InlineCompletionTriggerKind:$.InlineCompletionTriggerKind,InlineCompletionTriggerKindNew:$.InlineCompletionTriggerKindNew,EventEmitter:S.Emitter,ExtensionKind:$.ExtensionKind,ExtensionMode:$.ExtensionMode,ExternalUriOpenerPriority:$.ExternalUriOpenerPriority,FileChangeType:$.FileChangeType,FileDecoration:$.FileDecoration,FileSystemError:$.FileSystemError,FileType:E.FileType,FilePermission:E.FilePermission,FoldingRange:$.FoldingRange,FoldingRangeKind:$.FoldingRangeKind,FunctionBreakpoint:$.FunctionBreakpoint,InlineCompletionItem:$.InlineSuggestion,InlineCompletionItemNew:$.InlineSuggestionNew,InlineCompletionList:$.InlineSuggestionList,InlineCompletionListNew:$.InlineSuggestionsNew,Hover:$.Hover,IndentAction:P.IndentAction,Location:$.Location,MarkdownString:$.MarkdownString,OverviewRulerLane:b.OverviewRulerLane,ParameterInformation:$.ParameterInformation,PortAutoForwardAction:$.PortAutoForwardAction,Position:$.Position,ProcessExecution:$.ProcessExecution,ProgressLocation:$.ProgressLocation,QuickInputButtons:$.QuickInputButtons,Range:$.Range,RelativePattern:$.RelativePattern,Selection:$.Selection,SelectionRange:$.SelectionRange,SemanticTokens:$.SemanticTokens,SemanticTokensBuilder:$.SemanticTokensBuilder,SemanticTokensEdit:$.SemanticTokensEdit,SemanticTokensEdits:$.SemanticTokensEdits,SemanticTokensLegend:$.SemanticTokensLegend,ShellExecution:$.ShellExecution,ShellQuoting:$.ShellQuoting,SignatureHelp:$.SignatureHelp,SignatureHelpTriggerKind:$.SignatureHelpTriggerKind,SignatureInformation:$.SignatureInformation,SnippetString:$.SnippetString,SourceBreakpoint:$.SourceBreakpoint,StandardTokenType:$.StandardTokenType,StatusBarAlignment:$.StatusBarAlignment,SymbolInformation:$.SymbolInformation,SymbolKind:$.SymbolKind,SymbolTag:$.SymbolTag,Task:$.Task,TaskGroup:$.TaskGroup,TaskPanelKind:$.TaskPanelKind,TaskRevealKind:$.TaskRevealKind,TaskScope:$.TaskScope,TerminalLink:$.TerminalLink,TerminalLocation:$.TerminalLocation,TerminalProfile:$.TerminalProfile,TextDocumentSaveReason:$.TextDocumentSaveReason,TextEdit:$.TextEdit,SnippetTextEdit:$.SnippetTextEdit,TextEditorCursorStyle:A.TextEditorCursorStyle,TextEditorLineNumbersStyle:$.TextEditorLineNumbersStyle,TextEditorRevealType:$.TextEditorRevealType,TextEditorSelectionChangeKind:$.TextEditorSelectionChangeKind,TextDocumentChangeReason:$.TextDocumentChangeReason,ThemeColor:$.ThemeColor,ThemeIcon:$.ThemeIcon,TreeItem:$.TreeItem,TreeItem2:$.TreeItem,TreeItemCheckboxState:$.TreeItemCheckboxState,TreeItemCollapsibleState:$.TreeItemCollapsibleState,TypeHierarchyItem:$.TypeHierarchyItem,UIKind:k.UIKind,Uri:_.URI,ViewColumn:$.ViewColumn,WorkspaceEdit:$.WorkspaceEdit,DocumentDropEdit:$.DocumentDropEdit,DocumentPasteEdit:$.DocumentPasteEdit,InlayHint:$.InlayHint,InlayHintLabelPart:$.InlayHintLabelPart,InlayHintKind:$.InlayHintKind,RemoteAuthorityResolverError:$.RemoteAuthorityResolverError,ResolvedAuthority:$.ResolvedAuthority,SourceControlInputBoxValidationType:$.SourceControlInputBoxValidationType,ExtensionRuntime:$.ExtensionRuntime,TimelineItem:$.TimelineItem,NotebookRange:$.NotebookRange,NotebookCellKind:$.NotebookCellKind,NotebookCellExecutionState:$.NotebookCellExecutionState,NotebookCellData:$.NotebookCellData,NotebookData:$.NotebookData,NotebookRendererScript:$.NotebookRendererScript,NotebookCellStatusBarAlignment:$.NotebookCellStatusBarAlignment,NotebookEditorRevealType:$.NotebookEditorRevealType,NotebookCellOutput:$.NotebookCellOutput,NotebookCellOutputItem:$.NotebookCellOutputItem,NotebookCellStatusBarItem:$.NotebookCellStatusBarItem,NotebookControllerAffinity:$.NotebookControllerAffinity,NotebookControllerAffinity2:$.NotebookControllerAffinity2,NotebookEdit:$.NotebookEdit,PortAttributes:$.PortAttributes,LinkedEditingRanges:$.LinkedEditingRanges,TestResultState:$.TestResultState,TestRunRequest:$.TestRunRequest,TestMessage:$.TestMessage,TestTag:$.TestTag,TestRunProfileKind:$.TestRunProfileKind,TextSearchCompleteMessageType:rt.TextSearchCompleteMessageType,DataTransfer:$.DataTransfer,DataTransferItem:$.DataTransferItem,CoveredCount:$.CoveredCount,FileCoverage:$.FileCoverage,StatementCoverage:$.StatementCoverage,BranchCoverage:$.BranchCoverage,FunctionCoverage:$.FunctionCoverage,WorkspaceTrustState:$.WorkspaceTrustState,LanguageStatusSeverity:$.LanguageStatusSeverity,QuickPickItemKind:$.QuickPickItemKind,InputBoxValidationSeverity:$.InputBoxValidationSeverity,TabInputText:$.TextTabInput,TabInputTextDiff:$.TextDiffTabInput,TabInputTextMerge:$.TextMergeTabInput,TabInputCustom:$.CustomEditorTabInput,TabInputNotebook:$.NotebookEditorTabInput,TabInputNotebookDiff:$.NotebookDiffEditorTabInput,TabInputWebview:$.WebviewEditorTabInput,TabInputTerminal:$.TerminalEditorTabInput,TabInputInteractiveWindow:$.InteractiveWindowInput,TerminalExitReason:$.TerminalExitReason}}}e.createApiFactoryAndRegisterActors=yt}),define(Ce[238],Ie([1,0,237,33,2,231,6,15,222]),function(ie,e,r,y,S,M,_,A,b){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtHostExtensionService=void 0;class P extends M.RequireInterceptor{_installInterceptor(){}getModule(k,f){for(const c of this._alternatives){const d=c(k);if(d){k=d;break}}if(this._factories.has(k))return this._factories.get(k).load(k,f,()=>{throw new Error("CANNOT LOAD MODULE from here.")})}}class O extends y.AbstractExtHostExtensionService{constructor(){super(...arguments),this.extensionRuntime=_.ExtensionRuntime.Webworker}async _beforeAlmostReadyToRunExtensions(){this._instaService.createInstance(b.ExtHostConsoleForwarder);const k=this._instaService.invokeFunction(r.createApiFactoryAndRegisterActors);this._fakeModules=this._instaService.createInstance(P,k,{mine:this._myRegistry,all:this._globalRegistry}),await this._fakeModules.install(),performance.mark("code/extHost/didInitAPI"),await this._waitForDebuggerAttachment()}_getEntryPoint(k){return k.browser}async _loadCommonJSModule(k,f,c){f=f.with({path:E(f.path,".js")});const d=k?.identifier.value;d&&performance.mark(`code/extHost/willFetchExtensionCode/${d}`);const h=S.URI.revive(await this._mainThreadExtensionsProxy.$asBrowserUri(f)),g=await fetch(h.toString(!0));if(d&&performance.mark(`code/extHost/didFetchExtensionCode/${d}`),g.status!==200)throw new Error(g.statusText);const C=await g.text(),l=`${f.toString(!0)}#vscode-extension`,w=`${C}
//# sourceURL=${l}`;let t;try{t=new Function("module","exports","require",w)}catch(s){throw console.error(d?`Loading code for extension ${d} failed: ${s.message}`:`Loading code failed: ${s.message}`),console.error(`${f.toString(!0)}${typeof s.line=="number"?` line ${s.line}`:""}${typeof s.column=="number"?` column ${s.column}`:""}`),console.error(s),s}k&&await this._extHostLocalizationService.initializeLocalizedMessages(k);const u={},i={exports:u},n=s=>{const a=this._fakeModules.getModule(s,f);if(a===void 0)throw new Error(`Cannot load module '${s}'`);return a};try{return c.codeLoadingStart(),d&&performance.mark(`code/extHost/willLoadExtensionCode/${d}`),t(i,u,n),i.exports!==u?i.exports:u}finally{d&&performance.mark(`code/extHost/didLoadExtensionCode/${d}`),c.codeLoadingStop()}}async $setRemoteEnvironment(k){}async _waitForDebuggerAttachment(k=5e3){if(!this._initData.environment.isExtensionDevelopmentDebug)return;const f=Date.now()+k;for(;Date.now()<f&&!("__jsDebugIsReady"in globalThis);)await(0,A.timeout)(10)}}e.ExtHostExtensionService=O;function E(m,k){return m.endsWith(k)?m:m+k}}),define(Ce[239],Ie([1,0,56,33,71,238]),function(ie,e,r,y,S,M){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),(0,r.registerSingleton)(y.IExtHostExtensionService,M.ExtHostExtensionService,!1),(0,r.registerSingleton)(S.IExtensionStoragePaths,S.ExtensionStoragePaths,!1)}),define(Ce[248],Ie([1,0,23,5,92,232,224,19,72,13,2,234,239]),function(ie,e,r,y,S,M,_,A,b,P,O){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.create=void 0;const E=self.close.bind(self);self.close=()=>console.trace("'close' has been blocked");const m=postMessage.bind(self);self.postMessage=()=>console.trace("'postMessage' has been blocked");function k(t){return/^(file|vscode-remote):/i.test(t)}const f=fetch.bind(self);function c(t){self.fetch=async function(u,i){return u instanceof Request||k(String(u))&&(u=(await t(O.URI.parse(String(u)))).toString(!0)),f(u,i)},self.XMLHttpRequest=class extends XMLHttpRequest{open(u,i,n,s,a){(async()=>(k(i.toString())&&(i=(await t(O.URI.parse(i.toString()))).toString(!0)),super.open(u,i,n??!0,s,a)))()}}}if(self.importScripts=()=>{throw new Error("'importScripts' has been blocked")},self.addEventListener=()=>console.trace("'addEventListener' has been blocked"),self.AMDLoader=void 0,self.NLSLoaderPlugin=void 0,self.define=void 0,self.require=void 0,self.webkitRequestFileSystem=void 0,self.webkitRequestFileSystemSync=void 0,self.webkitResolveLocalFileSystemSyncURL=void 0,self.webkitResolveLocalFileSystemURL=void 0,self.Worker){const t=self.Worker;Worker=function(u,i){if(/^file:/i.test(u.toString()))u=P.FileAccess.asBrowserUri(O.URI.parse(u.toString())).toString(!0);else if(/^vscode-remote:/i.test(u.toString()))throw new Error("Creating workers from remote extensions is currently not supported.");const s=`(${function(p){function T(B){return typeof B=="string"||B instanceof URL?String(B).replace(/^file:\/\//i,"vscode-file://vscode-app"):B}const N=fetch.bind(self);self.fetch=function(B,D){return B instanceof Request?N(B,D):N(T(B),D)},self.XMLHttpRequest=class extends XMLHttpRequest{open(B,D,z,L,R){return super.open(B,T(D),z??!0,L,R)}};const V=importScripts.bind(self);self.importScripts=(...B)=>{V(...B.map(T))},V(p)}.toString()}('${u}'))`;i=i||{},i.name=i.name||A.basename(u.toString());const a=new Blob([s],{type:"application/javascript"}),o=URL.createObjectURL(a);return new t(o,i)}}else self.Worker=class extends _.NestedWorker{constructor(t,u){super(m,t,{name:A.basename(t.toString()),...u})}};const d=new class{constructor(){this.pid=void 0}exit(t){E()}async exists(t){return!0}async realpath(t){return t}};class h{constructor(){const u=new MessageChannel,i=new y.Emitter;let n=!1;m(u.port2,[u.port2]),u.port1.onmessage=s=>{const{data:a}=s;if(!(a instanceof ArrayBuffer)){console.warn("UNKNOWN data received",a);return}const o=r.VSBuffer.wrap(new Uint8Array(a,0,a.byteLength));if((0,S.isMessageOfType)(o,2)){n=!0,C("received terminate message from renderer");return}i.fire(o)},this.protocol={onMessage:i.event,send:s=>{if(!n){const a=s.buffer.buffer.slice(s.buffer.byteOffset,s.buffer.byteOffset+s.buffer.byteLength);u.port1.postMessage(a,[a])}}}}}function g(t){return new Promise(u=>{const i=t.onMessage(n=>{i.dispose();const s=JSON.parse(n.toString());t.send((0,S.createMessageOfType)(0)),u({protocol:t,initData:s})});t.send((0,S.createMessageOfType)(1))})}let C=t=>E();function l(t){return!!t&&typeof t=="object"&&t.type==="vscode.init"&&t.data instanceof Map}function w(){b.mark("code/extHost/willConnectToRenderer");const t=new h;return{onmessage(u){!l(u)||g(t.protocol).then(i=>{b.mark("code/extHost/didWaitForInitData");const n=new M.ExtensionHostMain(i.protocol,i.initData,d,null,u.data);c(s=>n.asBrowserUri(s)),C=s=>n.terminate(s)})}}}e.create=w})}).call(this);

//# sourceMappingURL=https://ticino.blob.core.windows.net/sourcemaps/b9f7f85e90b4d51b38fcbf4232801ab04bd659cb/core/vs/workbench/api/worker/extensionHostWorker.js.map
